/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/map","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,t=Q.length;D<t;D++)e[D]=ne[Q[D]];return e};define(ne[53],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=D;class t{constructor(P,I,E){this.id=P,this.definition=I,this.description=E,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(T,P){const I=["codicon","codicon-"+T];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=R;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function I(b){if(b instanceof t)return["codicon","codicon-"+b.id];const S=P.exec(b.id);if(!S)return I(t.error);const[,p,f]=S,v=["codicon","codicon-"+p];return f&&v.push("codicon-modifier-"+f.substr(1)),v}T.asClassNameArray=I;function E(b){return I(b).join(" ")}T.asClassName=E;function C(b){return"."+I(b).join(".")}T.asCSSSelector=C})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[64],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(P,I,E)=>{let C=null,b=null;if(typeof E.value=="function"?(C="value",b=E.value):typeof E.get=="function"&&(C="get",b=E.get),!b)throw new Error("not supported");E[C]=T(b,I)}}e.createDecorator=D;function t(T,P,I){let E=null,C=null;if(typeof I.value=="function"?(E="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(E="get",C=I.get),!C)throw new Error("not supported");const b=`$memoize$${P}`;I[E]=function(...S){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,S)}),this[b]}}e.memoize=t;function R(T,P,I){return D((E,C)=>{const b=`$debounce$${C}`,S=`$debounce$result$${C}`;return function(...p){this[S]||(this[S]=I?I():void 0),clearTimeout(this[b]),P&&(this[S]=P(this[S],...p),p=[this[S]]),this[b]=setTimeout(()=>{E.apply(this,p),this[S]=I?I():void 0},T)}})}e.debounce=R;function L(T,P,I){return D((E,C)=>{const b=`$throttle$timer$${C}`,S=`$throttle$result$${C}`,p=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...v){if(this[S]||(this[S]=I?I():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[S]=P(this[S],...v)),this[f])return;const y=this[p]+T;y<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[S]]),this[S]=I?I():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),E.apply(this,[this[S]]),this[S]=I?I():void 0},y-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?c.isErrorNoTelemetry(n)?new c(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(r=>{r(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=D,e.errorHandler=new D;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function R(l){I(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function L(l){I(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function T(l){if(l instanceof Error){const{name:n,message:r}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:c.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=T;const P="Canceled";function I(l){return l instanceof E?!0:l instanceof Error&&l.name===P&&l.message===P}e.isCancellationError=I;class E extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=E;function C(){const l=new Error(P);return l.name=l.message,l}e.canceled=C;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function S(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=S;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function f(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=f;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class y extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=y;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class c extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof c)return n;const r=new c;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class d extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(ne[18],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(Z,ie=0){return Z[Z.length-(1+ie)]}e.tail=t;function R(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=R;function L(Z,ie,se=(ue,de)=>ue===de){if(Z===ie)return!0;if(!Z||!ie||Z.length!==ie.length)return!1;for(let ue=0,de=Z.length;ue<de;ue++)if(!se(Z[ue],ie[ue]))return!1;return!0}e.equals=L;function T(Z,ie){const se=Z.length-1;ie<se&&(Z[ie]=Z[se]),Z.pop()}e.removeFastWithoutKeepingOrder=T;function P(Z,ie,se){return I(Z.length,ue=>se(Z[ue],ie))}e.binarySearch=P;function I(Z,ie){let se=0,ue=Z-1;for(;se<=ue;){const de=(se+ue)/2|0,ve=ie(de);if(ve<0)se=de+1;else if(ve>0)ue=de-1;else return de}return-(se+1)}e.binarySearch2=I;function E(Z,ie){let se=0,ue=Z.length;if(ue===0)return 0;for(;se<ue;){const de=Math.floor((se+ue)/2);ie(Z[de])?ue=de:se=de+1}return se}e.findFirstInSorted=E;function C(Z,ie,se){if(Z=Z|0,Z>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],de=[],ve=[],we=[];for(const Ee of ie){const Pe=se(Ee,ue);Pe<0?de.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return Z<de.length?C(Z,de,se):Z<de.length+we.length?we[0]:C(Z-(de.length+we.length),ve,se)}e.quickSelect=C;function b(Z,ie){const se=[];let ue;for(const de of Z.slice(0).sort(ie))!ue||ie(ue[0],de)!==0?(ue=[de],se.push(ue)):ue.push(de);return se}e.groupBy=b;function S(Z,ie,se){const ue=[];function de(Ee,Pe,Oe){if(Pe===0&&Oe.length===0)return;const $e=ue[ue.length-1];$e&&$e.start+$e.deleteCount===Ee?($e.deleteCount+=Pe,$e.toInsert.push(...Oe)):ue.push({start:Ee,deleteCount:Pe,toInsert:Oe})}let ve=0,we=0;for(;;){if(ve===Z.length){de(ve,0,ie.slice(we));break}if(we===ie.length){de(ve,Z.length-ve,[]);break}const Ee=Z[ve],Pe=ie[we],Oe=se(Ee,Pe);Oe===0?(ve+=1,we+=1):Oe<0?(de(ve,1,[]),ve+=1):Oe>0&&(de(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=S;function p(Z,ie,se){const ue=S(Z,ie,se),de=[],ve=[];for(const we of ue)de.push(...Z.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:de,added:ve}}e.delta=p;function f(Z,ie,se){if(se===0)return[];const ue=Z.slice(0,se).sort(ie);return y(Z,ie,ue,se,Z.length),ue}e.top=f;function v(Z,ie,se,ue,de){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=Z.length,Pe=Z.slice(0,se).sort(ie);for(let Oe=se,$e=Math.min(se+ue,Ee);Oe<Ee;Oe=$e,$e=Math.min($e+ue,Ee)){if(Oe>se&&await new Promise(Ve=>setTimeout(Ve)),de&&de.isCancellationRequested)throw new D.CancellationError;y(Z,ie,Pe,Oe,$e)}return Pe})().then(ve,we)})}e.topAsync=v;function y(Z,ie,se,ue,de){for(const ve=se.length;ue<de;ue++){const we=Z[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=E(se,Pe=>ie(we,Pe)<0);se.splice(Ee,0,we)}}}function u(Z){return Z.filter(ie=>!!ie)}e.coalesce=u;function m(Z){let ie=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[ie]=Z[se],ie+=1);Z.length=ie}e.coalesceInPlace=m;function c(Z,ie,se){Z.splice(se,0,Z.splice(ie,1)[0])}e.move=c;function d(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=d;function l(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=l;function n(Z,ie=se=>se){const se=new Set;return Z.filter(ue=>{const de=ie(ue);return se.has(de)?!1:(se.add(de),!0)})}e.distinct=n;function r(Z){const ie=new Set;return se=>{const ue=Z(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=r;function i(Z,ie){const se=o(Z,ie);if(se!==-1)return Z[se]}e.findLast=i;function o(Z,ie){for(let se=Z.length-1;se>=0;se--){const ue=Z[se];if(ie(ue))return se}return-1}e.lastIndex=o;function s(Z,ie){return Z.length>0?Z[0]:ie}e.firstOrDefault=s;function h(Z,ie){return Z.length>0?Z[Z.length-1]:ie}e.lastOrDefault=h;function a(Z,ie,se=(ue,de)=>ue===de){let ue=0;for(let de=0,ve=Math.min(Z.length,ie.length);de<ve&&se(Z[de],ie[de]);de++)ue++;return ue}e.commonPrefixLength=a;function g(Z){return[].concat(...Z)}e.flatten=g;function w(Z,ie){let se=typeof ie=="number"?Z:0;typeof ie=="number"?se=Z:(se=0,ie=Z);const ue=[];if(se<=ie)for(let de=se;de<ie;de++)ue.push(de);else for(let de=se;de>ie;de--)ue.push(de);return ue}e.range=w;function A(Z,ie,se){return Z.reduce((ue,de)=>(ue[ie(de)]=se?se(de):de,ue),Object.create(null))}e.index=A;function F(Z,ie){return Z.push(ie),()=>_(Z,ie)}e.insert=F;function _(Z,ie){const se=Z.indexOf(ie);if(se>-1)return Z.splice(se,1),ie}e.remove=_;function N(Z,ie,se){const ue=Z.slice(0,ie),de=Z.slice(ie);return ue.concat(se,de)}e.arrayInsert=N;function W(Z,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const de=Math.sin(ue++)*179426549;return de-Math.floor(de)}}else se=Math.random;for(let ue=Z.length-1;ue>0;ue-=1){const de=Math.floor(se()*(ue+1)),ve=Z[ue];Z[ue]=Z[de],Z[de]=ve}}e.shuffle=W;function k(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.unshift(ie))}e.pushToStart=k;function U(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.push(ie))}e.pushToEnd=U;function $(Z,ie){for(const se of ie)Z.push(se)}e.pushMany=$;function Y(Z,ie){return Array.isArray(Z)?Z.map(ie):ie(Z)}e.mapArrayOrNot=Y;function q(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=q;function V(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=V;function z(Z,ie){for(const se of Z){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=z;function j(Z,ie,se){const ue=X(Z,ie),de=Z.length,ve=se.length;Z.length=de+ve;for(let we=de-1;we>=ue;we--)Z[we+ve]=Z[we];for(let we=0;we<ve;we++)Z[we+ue]=se[we]}e.insertInto=j;function K(Z,ie,se,ue){const de=X(Z,ie),ve=Z.splice(de,se);return j(Z,de,ue),ve}e.splice=K;function X(Z,ie){return ie<0?Math.max(ie+Z.length,0):Math.min(ie,Z.length)}var ce;(function(Z){function ie(de){return de<0}Z.isLessThan=ie;function se(de){return de>0}Z.isGreaterThan=se;function ue(de){return de===0}Z.isNeitherLessOrGreaterThan=ue,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function B(Z,ie){return(se,ue)=>ie(Z(se),Z(ue))}e.compareBy=B;function H(...Z){return(ie,se)=>{for(const ue of Z){const de=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(de))return de}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=H;const O=(Z,ie)=>Z-ie;e.numberComparator=O;function M(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>0&&(se=de)}return se}e.findMaxBy=M;function x(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>=0&&(se=de)}return se}e.findLastMaxBy=x;function G(Z,ie){return M(Z,(se,ue)=>-ie(se,ue))}e.findMinBy=G;class ee{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=ee;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(de=>((ue||ce.isGreaterThan(ie(de,se)))&&(ue=!1,se=de),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(Z=>{})}),define(ne[120],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(I,E){if(!I)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=t;function R(I,E="Unreachable"){throw new Error(E)}e.assertNever=R;function L(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=L;function T(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(I,E){let C=0;for(;C<I.length-1;){const b=I[C],S=I[C+1];if(!E(b,S))return!1;C++}return!0}e.checkAdjacentItems=P}),define(ne[80],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(t){const R=this;let L=!1,T;return function(){return L||(L=!0,T=t.apply(R,arguments)),T}}e.once=D}),define(ne[54],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(t){function R(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=R;const L=Object.freeze([]);function T(){return L}t.empty=T;function*P(d){yield d}t.single=P;function I(d){return R(d)?d:P(d)}t.wrap=I;function E(d){return d||L}t.from=E;function C(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=C;function b(d){return d[Symbol.iterator]().next().value}t.first=b;function S(d,l){for(const n of d)if(l(n))return!0;return!1}t.some=S;function p(d,l){for(const n of d)if(l(n))return n}t.find=p;function*f(d,l){for(const n of d)l(n)&&(yield n)}t.filter=f;function*v(d,l){let n=0;for(const r of d)yield l(r,n++)}t.map=v;function*y(...d){for(const l of d)for(const n of l)yield n}t.concat=y;function u(d,l,n){let r=n;for(const i of d)r=l(r,i);return r}t.reduce=u;function*m(d,l,n=d.length){for(l<0&&(l+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);l<n;l++)yield d[l]}t.slice=m;function c(d,l=Number.POSITIVE_INFINITY){const n=[];if(l===0)return[n,d];const r=d[Symbol.iterator]();for(let i=0;i<l;i++){const o=r.next();if(o.done)return[n,t.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return r}}]}t.consume=c})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(n,r=!1){let i=0;const o=n.length;let s="",h=0,a=16,g=0;function w(U){let $=0,Y=0;for(;$<U;){const q=n.charCodeAt(i);if(q>=48&&q<=57)Y=Y*16+q-48;else if(q>=65&&q<=70)Y=Y*16+q-65+10;else if(q>=97&&q<=102)Y=Y*16+q-97+10;else break;i++,$++}return $<U&&(Y=-1),Y}function A(U){i=U,s="",h=0,a=16,g=0}function F(){const U=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&E(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&E(n.charCodeAt(i)))for(i++;i<n.length&&E(n.charCodeAt(i));)i++;else return g=3,n.substring(U,i);let $=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&E(n.charCodeAt(i))){for(i++;i<n.length&&E(n.charCodeAt(i));)i++;$=i}else g=3;return n.substring(U,$)}function _(){let U="",$=i;for(;;){if(i>=o){U+=n.substring($,i),g=2;break}const Y=n.charCodeAt(i);if(Y===34){U+=n.substring($,i),i++;break}if(Y===92){if(U+=n.substring($,i),i++,i>=o){g=2;break}switch(n.charCodeAt(i++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=w(4);V>=0?U+=String.fromCharCode(V):g=4;break}default:g=5}$=i;continue}if(Y>=0&&Y<=31)if(I(Y)){U+=n.substring($,i),g=2;break}else g=6;i++}return U}function N(){if(s="",g=0,h=i,i>=o)return h=o,a=17;let U=n.charCodeAt(i);if(P(U)){do i++,s+=String.fromCharCode(U),U=n.charCodeAt(i);while(P(U));return a=15}if(I(U))return i++,s+=String.fromCharCode(U),U===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch(U){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=_(),a=10;case 47:{const $=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!I(n.charCodeAt(i));)i++;return s=n.substring($,i),a=12}if(n.charCodeAt(i+1)===42){i+=2;const Y=o-1;let q=!1;for(;i<Y;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,q=!0;break}i++}return q||(i++,g=1),s=n.substring($,i),a=13}return s+=String.fromCharCode(U),i++,a=16}case 45:if(s+=String.fromCharCode(U),i++,i===o||!E(n.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),a=11;default:for(;i<o&&W(U);)i++,U=n.charCodeAt(i);if(h!==i){switch(s=n.substring(h,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(U),i++,a=16}}function W(U){if(P(U)||I(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:A,getPosition:()=>i,scan:r?k:N,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>h,getTokenLength:()=>i-h,getTokenError:()=>g}}e.createScanner=T;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function E(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function b(n,r){const i=[],o=new Object;let s;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(w,A,F,_){h.value=w,h.offset=A,h.length=F,h.type=_,h.colonOffset=void 0,s=h}try{c(n,{onObjectBegin:(w,A)=>{if(r<=w)throw o;s=void 0,a=r>w,i.push("")},onObjectProperty:(w,A,F)=>{if(r<A||(g(w,A,F,"property"),i[i.length-1]=w,r<=A+F))throw o},onObjectEnd:(w,A)=>{if(r<=w)throw o;s=void 0,i.pop()},onArrayBegin:(w,A)=>{if(r<=w)throw o;s=void 0,i.push(0)},onArrayEnd:(w,A)=>{if(r<=w)throw o;s=void 0,i.pop()},onLiteralValue:(w,A,F)=>{if(r<A||(g(w,A,F,l(w)),r<=A+F))throw o},onSeparator:(w,A,F)=>{if(r<=A)throw o;if(w===":"&&s&&s.type==="property")s.colonOffset=A,a=!1,s=void 0;else if(w===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(w){if(w!==o)throw w}return{path:i,previousNode:s,isAtPropertyKey:a,matches:w=>{let A=0;for(let F=0;A<w.length&&F<i.length;F++)if(w[A]===i[F]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}e.getLocation=b;function S(n,r=[],i=L.DEFAULT){let o=null,s=[];const h=[];function a(w){Array.isArray(s)?s.push(w):o!==null&&(s[o]=w)}return c(n,{onObjectBegin:()=>{const w={};a(w),h.push(s),s=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const w=[];a(w),h.push(s),s=w,o=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:a,onError:(w,A,F)=>{r.push({error:w,offset:A,length:F})}},i),s[0]}e.parse=S;function p(n,r=[],i=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function h(w){return o.children.push(w),w}c(n,{onObjectBegin:w=>{o=h({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,A,F)=>{o=h({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:A,length:F,parent:o})},onObjectEnd:(w,A)=>{o.length=w+A-o.offset,o=o.parent,s(w+A)},onArrayBegin:(w,A)=>{o=h({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,A)=>{o.length=w+A-o.offset,o=o.parent,s(w+A)},onLiteralValue:(w,A,F)=>{h({type:l(w),offset:A,length:F,parent:o,value:w}),s(A+F)},onSeparator:(w,A,F)=>{o.type==="property"&&(w===":"?o.colonOffset=A:w===","&&s(A))},onError:(w,A,F)=>{r.push({error:w,offset:A,length:F})}},i);const g=o.children[0];return g&&delete g.parent,g}e.parseTree=p;function f(n,r){if(!n)return;let i=n;for(const o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const h of i.children)if(Array.isArray(h.children)&&h.children[0].value===o){i=h.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=f;function v(n){if(!n.parent||!n.parent.children)return[];const r=v(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=v;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":{const r=Object.create(null);for(const i of n.children){const o=i.children[1];o&&(r[i.children[0].value]=y(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function u(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=u;function m(n,r,i=!1){if(u(n,r,i)){const o=n.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=r;s++){const h=m(o[s],r,i);if(h)return h}return n}}e.findNodeAtOffset=m;function c(n,r,i=L.DEFAULT){const o=T(n,!1);function s(B){return B?()=>B(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(B){return B?H=>B(H,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=s(r.onObjectBegin),g=h(r.onObjectProperty),w=s(r.onObjectEnd),A=s(r.onArrayBegin),F=s(r.onArrayEnd),_=h(r.onLiteralValue),N=h(r.onSeparator),W=s(r.onComment),k=h(r.onError),U=i&&i.disallowComments,$=i&&i.allowTrailingComma;function Y(){for(;;){const B=o.scan();switch(o.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:U||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(B){case 12:case 13:U?q(10):W();break;case 16:q(1);break;case 15:case 14:break;default:return B}}}function q(B,H=[],O=[]){if(k(B),H.length+O.length>0){let M=o.getToken();for(;M!==17;){if(H.indexOf(M)!==-1){Y();break}else if(O.indexOf(M)!==-1)break;M=Y()}}}function V(B){const H=o.getTokenValue();return B?_(H):g(H),Y(),!0}function z(){switch(o.getToken()){case 11:{let B=0;try{B=JSON.parse(o.getTokenValue()),typeof B!="number"&&(q(2),B=0)}catch{q(2)}_(B);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return Y(),!0}function j(){return o.getToken()!==10?(q(3,[],[2,5]),!1):(V(!1),o.getToken()===6?(N(":"),Y(),ce()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function K(){a(),Y();let B=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(B||q(4,[],[]),N(","),Y(),o.getToken()===2&&$)break}else B&&q(6,[],[]);j()||q(4,[],[2,5]),B=!0}return w(),o.getToken()!==2?q(7,[2],[]):Y(),!0}function X(){A(),Y();let B=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(B||q(4,[],[]),N(","),Y(),o.getToken()===4&&$)break}else B&&q(6,[],[]);ce()||q(4,[],[4,5]),B=!0}return F(),o.getToken()!==4?q(8,[4],[]):Y(),!0}function ce(){switch(o.getToken()){case 3:return X();case 1:return K();case 10:return V(!0);default:return z()}}return Y(),o.getToken()===17?i.allowEmptyContent?!0:(q(4,[],[]),!1):ce()?(o.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function d(n,r){const i=T(n),o=[];let s,h=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:h!==a&&o.push(n.substring(h,a)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),h=i.getPosition();break}while(s!==17);return o.join("")}e.stripComments=d;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[46],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(E,C,b){let S,p,f,v,y;if(C){for(v=C.offset,y=v+C.length,f=v;f>0&&!I(E,f-1);)f--;let a=y;for(;a<E.length&&!I(E,a);)a++;p=E.substring(f,a),S=T(p,b)}else p=E,S=0,f=0,v=0,y=E.length;const u=P(b,E);let m=!1,c=0,d;b.insertSpaces?d=L(" ",b.tabSize||4):d="	";const l=(0,D.createScanner)(p,!1);let n=!1;function r(){return u+L(d,S+c)}function i(){let a=l.scan();for(m=!1;a===15||a===14;)m=m||a===14,a=l.scan();return n=a===16||l.getTokenError()!==0,a}const o=[];function s(a,g,w){!n&&g<y&&w>v&&E.substring(g,w)!==a&&o.push({offset:g,length:w-g,content:a})}let h=i();if(h!==17){const a=l.getTokenOffset()+f,g=L(d,S);s(g,f,a)}for(;h!==17;){let a=l.getTokenOffset()+l.getTokenLength()+f,g=i(),w="";for(;!m&&(g===12||g===13);){const F=l.getTokenOffset()+f;s(" ",a,F),a=l.getTokenOffset()+l.getTokenLength()+f,w=g===12?r():"",g=i()}if(g===2)h!==1&&(c--,w=r());else if(g===4)h!==3&&(c--,w=r());else{switch(h){case 3:case 1:c++,w=r();break;case 5:case 12:w=r();break;case 13:m?w=r():w=" ";break;case 6:w=" ";break;case 10:if(g===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?w=" ":g!==5&&g!==17&&(n=!0);break;case 16:n=!0;break}m&&(g===12||g===13)&&(w=r())}const A=l.getTokenOffset()+f;s(w,a,A),h=g}return o}e.format=t;function R(E,C){const b=JSON.stringify(E,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?b.replace(/\r\n|\r|\n/g,C.eol):b}e.toFormattedString=R;function L(E,C){let b="";for(let S=0;S<C;S++)b+=E;return b}function T(E,C){let b=0,S=0;const p=C.tabSize||4;for(;b<E.length;){const f=E.charAt(b);if(f===" ")S++;else if(f==="	")S+=p;else break;b++}return Math.floor(S/p)}function P(E,C){for(let b=0;b<C.length;b++){const S=C.charAt(b);if(S==="\r")return b+1<C.length&&C.charAt(b+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function I(E,C){return`\r
`.indexOf(E.charAt(C))!==-1}e.isEOL=I}),define(ne[81],re([0,1,35,46]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,C,b){return L(E,C,void 0,b)}e.removeProperty=R;function L(E,C,b,S,p){const f=C.slice(),v=[],y=(0,D.parseTree)(E,v);let u,m;for(;f.length>0&&(m=f.pop(),u=(0,D.findNodeAtLocation)(y,f),u===void 0&&b!==void 0);)typeof m=="string"?b={[m]:b}:b=[b];if(u)if(u.type==="object"&&typeof m=="string"&&Array.isArray(u.children)){const c=(0,D.findNodeAtLocation)(u,[m]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const d=u.children.indexOf(c.parent);let l,n=c.parent.offset+c.parent.length;if(d>0){const r=u.children[d-1];l=r.offset+r.length}else l=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return T(E,{offset:l,length:n-l,content:""},S)}else return T(E,{offset:c.offset,length:c.length,content:JSON.stringify(b)},S);else{if(b===void 0)return[];const d=`${JSON.stringify(m)}: ${JSON.stringify(b)}`,l=p?p(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(l>0){const r=u.children[l-1];n={offset:r.offset+r.length,length:0,content:","+d}}else u.children.length===0?n={offset:u.offset+1,length:0,content:d}:n={offset:u.offset+1,length:0,content:d+","};return T(E,n,S)}}else if(u.type==="array"&&typeof m=="number"&&Array.isArray(u.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let d;if(u.children.length===0||m===0)d={offset:u.offset+1,length:0,content:u.children.length===0?c:c+","};else{const l=m===-1||m>u.children.length?u.children.length:m,n=u.children[l-1];d={offset:n.offset+n.length,length:0,content:","+c}}return T(E,d,S)}else{const c=m,d=u.children[c];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===c){const n=u.children[c-1],r=n.offset+n.length,i=u.offset+u.length;l={offset:r,length:i-2-r,content:""}}else l={offset:d.offset,length:u.children[c+1].offset-d.offset,content:""};return T(E,l,S)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(b)},S)}}e.setProperty=L;function T(E,C,b){let S=P(E,C),p=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;p>0&&!(0,t.isEOL)(S,p-1);)p--;for(;f<S.length&&!(0,t.isEOL)(S,f);)f++}const v=(0,t.format)(S,{offset:p,length:f-p},b);for(let u=v.length-1;u>=0;u--){const m=v[u];S=P(S,m),p=Math.min(p,m.offset),f=Math.max(f,m.offset+m.length),f+=m.content.length-m.length}const y=E.length-(S.length-f)-p;return[{offset:p,length:y,content:S.substring(p,f)}]}e.withFormatting=T;function P(E,C){return E.substring(0,C.offset)+C.content+E.substring(C.offset+C.length)}e.applyEdit=P;function I(E,C){const b=C.slice(0).sort((p,f)=>{const v=p.offset-f.offset;return v===0?p.length-f.length:v});let S=E.length;for(let p=b.length-1;p>=0;p--){const f=b[p];if(f.offset+f.length<=S)E=P(E,f);else throw new Error("Overlapping edit");S=f.offset}return E}e.applyEdits=I}),define(ne[121],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(ne[2],re([0,1,80,54]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function T(h){L=h}if(e.setDisposableTracker=T,R){const h="__is_disposable_tracked__";T(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[h]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==m.None)try{a[h]=!0}catch{}}markAsDisposed(a){if(a&&a!==m.None)try{a[h]=!0}catch{}}markAsSingleton(a){}})}function P(h){return L?.trackDisposable(h),h}function I(h){L?.markAsDisposed(h)}function E(h,a){L?.setParent(h,a)}function C(h,a){if(!!L)for(const g of h)L.setParent(g,a)}function b(h){return L?.markAsSingleton(h),h}e.markAsSingleton=b;function S(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=S;function p(h){if(t.Iterable.is(h)){const a=[];for(const g of h)if(g)try{g.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.dispose=p;function f(h){for(const a of h)S(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function v(...h){const a=y(()=>p(h));return C(h,a),a}e.combinedDisposable=v;function y(h){const a=P({dispose:(0,D.once)(()=>{I(a),h()})});return a}e.toDisposable=y;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new u,P(this),E(this._store,this)}dispose(){I(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=c;class d{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let g=a;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,I(this))},this}}e.SafeDisposable=l;class n{constructor(){this.references=new Map}acquire(a,...g){let w=this.references.get(a);w||(w={counter:0,object:this.createReferencedObject(a,...g)},this.references.set(a,w));const{object:A}=w,F=(0,D.once)(()=>{--w.counter===0&&(this.destroyReferencedObject(a,w.object),this.references.delete(a))});return w.counter++,{object:A,dispose:F}}}e.ReferenceCollection=n;class r{constructor(a){this.referenceCollection=a}async acquire(a,...g){const w=this.referenceCollection.acquire(a,...g);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(A){throw w.dispose(),A}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(h){const a=new u;try{h(a)}finally{a.dispose()}}e.disposeOnReturn=o;class s{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){I(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,g,w=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this._store.get(a)?.dispose(),this._store.set(a,g)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(ne[82],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class t{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const T=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(T){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),define(ne[40],re([0,1]),function(Q,e){"use strict";var D,t,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,v,y){let u=f.get(v);return u===void 0&&(u=y,f.set(v,u)),u}e.getOrSet=L;function T(f){const v=[];return f.forEach((y,u)=>{v.push(`${u} => ${y}`)}),`Map(${f.size}) {${v.join(", ")}}`}e.mapToString=T;function P(f){const v=[];return f.forEach(y=>{v.push(y)}),`Set(${f.size}) {${v.join(", ")}}`}e.setToString=P;class I{constructor(v,y){this.uri=v,this.value=y}}class E{constructor(v,y){this[D]="ResourceMap",v instanceof E?(this.map=new Map(v.map),this.toKey=y??E.defaultToKey):(this.map=new Map,this.toKey=v??E.defaultToKey)}set(v,y){return this.map.set(this.toKey(v),new I(v,y)),this}get(v){return this.map.get(this.toKey(v))?.value}has(v){return this.map.has(this.toKey(v))}get size(){return this.map.size}clear(){this.map.clear()}delete(v){return this.map.delete(this.toKey(v))}forEach(v,y){typeof y<"u"&&(v=v.bind(y));for(const[u,m]of this.map)v(m.value,m.uri,this)}*values(){for(const v of this.map.values())yield v.value}*keys(){for(const v of this.map.values())yield v.uri}*entries(){for(const v of this.map.values())yield[v.uri,v.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.map)yield[v.uri,v.value]}}e.ResourceMap=E,E.defaultToKey=f=>f.toString();class C{constructor(v,y){this[t]="ResourceSet",!v||typeof v=="function"?this._map=new E(v):(this._map=new E(y),v.forEach(this.add,this))}get size(){return this._map.size}add(v){return this._map.set(v,v),this}clear(){this._map.clear()}delete(v){return this._map.delete(v)}forEach(v,y){this._map.forEach((u,m)=>v.call(y,m,m,this))}has(v){return this._map.has(v)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class S{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(v){return this._map.has(v)}get(v,y=0){const u=this._map.get(v);if(!!u)return y!==0&&this.touch(u,y),u.value}set(v,y,u=0){let m=this._map.get(v);if(m)m.value=y,u!==0&&this.touch(m,u);else{switch(m={key:v,value:y,next:void 0,previous:void 0},u){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(v,m),this._size++}return this}delete(v){return!!this.remove(v)}remove(v){const y=this._map.get(v);if(!!y)return this._map.delete(v),this.removeItem(y),this._size--,y.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const v=this._head;return this._map.delete(v.key),this.removeItem(v),this._size--,v.value}forEach(v,y){const u=this._state;let m=this._head;for(;m;){if(y?v.bind(y)(m.value,m.key,this):v(m.value,m.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const v=this,y=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}values(){const v=this,y=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}entries(){const v=this,y=this._state;let u=this._head;const m={[Symbol.iterator](){return m},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return m}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(v){if(v>=this.size)return;if(v===0){this.clear();return}let y=this._head,u=this.size;for(;y&&u>v;)this._map.delete(y.key),y=y.next,u--;this._head=y,this._size=u,y&&(y.previous=void 0),this._state++}addItemFirst(v){if(!this._head&&!this._tail)this._tail=v;else if(this._head)v.next=this._head,this._head.previous=v;else throw new Error("Invalid list");this._head=v,this._state++}addItemLast(v){if(!this._head&&!this._tail)this._head=v;else if(this._tail)v.previous=this._tail,this._tail.next=v;else throw new Error("Invalid list");this._tail=v,this._state++}removeItem(v){if(v===this._head&&v===this._tail)this._head=void 0,this._tail=void 0;else if(v===this._head){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this._head=v.next}else if(v===this._tail){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this._tail=v.previous}else{const y=v.next,u=v.previous;if(!y||!u)throw new Error("Invalid list");y.previous=u,u.next=y}v.next=void 0,v.previous=void 0,this._state++}touch(v,y){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(v===this._head)return;const u=v.next,m=v.previous;v===this._tail?(m.next=void 0,this._tail=m):(u.previous=m,m.next=u),v.previous=void 0,v.next=this._head,this._head.previous=v,this._head=v,this._state++}else if(y===2){if(v===this._tail)return;const u=v.next,m=v.previous;v===this._head?(u.previous=void 0,this._head=u):(u.previous=m,m.next=u),v.next=void 0,v.previous=this._tail,this._tail.next=v,this._tail=v,this._state++}}}toJSON(){const v=[];return this.forEach((y,u)=>{v.push([u,y])}),v}fromJSON(v){this.clear();for(const[y,u]of v)this.set(y,u)}}e.LinkedMap=S;class p extends S{constructor(v,y=1){super(),this._limit=v,this._ratio=Math.min(Math.max(0,y),1)}get limit(){return this._limit}set limit(v){this._limit=v,this.checkTrim()}get ratio(){return this._ratio}set ratio(v){this._ratio=Math.min(Math.max(0,v),1),this.checkTrim()}get(v,y=2){return super.get(v,y)}peek(v){return super.get(v,0)}set(v,y){return super.set(v,y,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p}),define(ne[83],re([0,1,40]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new D.LRUCache(1e4);function R(E){return I(E,"NFC",t)}e.normalizeNFC=R;const L=new D.LRUCache(1e4);function T(E){return I(E,"NFD",L)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function I(E,C,b){if(!E)return E;const S=b.get(E);if(S)return S;let p;return P.test(E)?p=E.normalize(C):p=E,b.set(E,p),p}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(C){return T(C).replace(E,"")}}()}),function(){function Q(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function T(I){L.push(I,Date.now())}function P(){const I=[];for(let E=0;E<L.length;E+=2)I.push({name:L[E],startTime:L[E+1]});return I}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(R+T.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=D(t))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var t in D)(typeof exports=="object"?exports:Q)[t]=D[t]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(t){if(e[t])return e[t].exports;var R=e[t]={i:t,l:!1,exports:{}};return Q[t].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(t,R,L){D.o(t,R)||Object.defineProperty(t,R,{enumerable:!0,get:L})},D.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},D.t=function(t,R){if(1&R&&(t=D(t)),8&R||4&R&&typeof t=="object"&&t&&t.__esModule)return t;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:t}),2&R&&typeof t!="string")for(var T in t)D.d(L,T,function(P){return t[P]}.bind(null,T));return L},D.n=function(t){var R=t&&t.__esModule?function(){return t.default}:function(){return t};return D.d(R,"a",R),R},D.o=function(t,R){return Object.prototype.hasOwnProperty.call(t,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(t){var R;e=Q.exports=O,R=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],E=0,C=E++;I[C]="0|[1-9]\\d*";var b=E++;I[b]="[0-9]+";var S=E++;I[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=E++;I[p]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var f=E++;I[f]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var v=E++;I[v]="(?:"+I[C]+"|"+I[S]+")";var y=E++;I[y]="(?:"+I[b]+"|"+I[S]+")";var u=E++;I[u]="(?:-("+I[v]+"(?:\\."+I[v]+")*))";var m=E++;I[m]="(?:-?("+I[y]+"(?:\\."+I[y]+")*))";var c=E++;I[c]="[0-9A-Za-z-]+";var d=E++;I[d]="(?:\\+("+I[c]+"(?:\\."+I[c]+")*))";var l=E++,n="v?"+I[p]+I[u]+"?"+I[d]+"?";I[l]="^"+n+"$";var r="[v=\\s]*"+I[f]+I[m]+"?"+I[d]+"?",i=E++;I[i]="^"+r+"$";var o=E++;I[o]="((?:<|>)?=?)";var s=E++;I[s]=I[b]+"|x|X|\\*";var h=E++;I[h]=I[C]+"|x|X|\\*";var a=E++;I[a]="[v=\\s]*("+I[h]+")(?:\\.("+I[h]+")(?:\\.("+I[h]+")(?:"+I[u]+")?"+I[d]+"?)?)?";var g=E++;I[g]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[m]+")?"+I[d]+"?)?)?";var w=E++;I[w]="^"+I[o]+"\\s*"+I[a]+"$";var A=E++;I[A]="^"+I[o]+"\\s*"+I[g]+"$";var F=E++;I[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=E++;I[_]="(?:~>?)";var N=E++;I[N]="(\\s*)"+I[_]+"\\s+",P[N]=new RegExp(I[N],"g");var W=E++;I[W]="^"+I[_]+I[a]+"$";var k=E++;I[k]="^"+I[_]+I[g]+"$";var U=E++;I[U]="(?:\\^)";var $=E++;I[$]="(\\s*)"+I[U]+"\\s+",P[$]=new RegExp(I[$],"g");var Y=E++;I[Y]="^"+I[U]+I[a]+"$";var q=E++;I[q]="^"+I[U]+I[g]+"$";var V=E++;I[V]="^"+I[o]+"\\s*("+r+")$|^$";var z=E++;I[z]="^"+I[o]+"\\s*("+n+")$|^$";var j=E++;I[j]="(\\s*)"+I[o]+"\\s*("+r+"|"+I[a]+")",P[j]=new RegExp(I[j],"g");var K=E++;I[K]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var X=E++;I[X]="^\\s*("+I[g]+")\\s+-\\s+("+I[g]+")\\s*$";var ce=E++;I[ce]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)R(B,I[B]),P[B]||(P[B]=new RegExp(I[B]));function H(ae,fe){if(ae instanceof O)return ae;if(typeof ae!="string"||ae.length>L||!(fe?P[i]:P[l]).test(ae))return null;try{return new O(ae,fe)}catch{return null}}function O(ae,fe){if(ae instanceof O){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof O))return new O(ae,fe);R("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?P[i]:P[l]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=H,e.valid=function(ae,fe){var ge=H(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=H(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof O||(ae=new O(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},O.prototype.compareMain=function(ae){return ae instanceof O||(ae=new O(ae,this.loose)),x(this.major,ae.major)||x(this.minor,ae.minor)||x(this.patch,ae.patch)},O.prototype.comparePre=function(ae){if(ae instanceof O||(ae=new O(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return x(ge,be)}while(++fe)},O.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new O(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(Z(ae,fe))return null;var ge=H(ae),be=H(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=x;var M=/^[0-9]+$/;function x(ae,fe){var ge=M.test(ae),be=M.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function G(ae,fe,ge){return new O(ae,ge).compare(new O(fe,ge))}function ee(ae,fe,ge){return G(ae,fe,ge)>0}function oe(ae,fe,ge){return G(ae,fe,ge)<0}function Z(ae,fe,ge){return G(ae,fe,ge)===0}function ie(ae,fe,ge){return G(ae,fe,ge)!==0}function se(ae,fe,ge){return G(ae,fe,ge)>=0}function ue(ae,fe,ge){return G(ae,fe,ge)<=0}function de(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=Z(ae,ge,be);break;case"!=":Ie=ie(ae,ge,be);break;case">":Ie=ee(ae,ge,be);break;case">=":Ie=se(ae,ge,be);break;case"<":Ie=oe(ae,ge,be);break;case"<=":Ie=ue(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function ve(ae,fe){if(ae instanceof ve){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,fe);R("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,fe){return x(fe,ae)},e.major=function(ae,fe){return new O(ae,fe).major},e.minor=function(ae,fe){return new O(ae,fe).minor},e.patch=function(ae,fe){return new O(ae,fe).patch},e.compare=G,e.compareLoose=function(ae,fe){return G(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return G(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=ee,e.lt=oe,e.eq=Z,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=de,e.Comparator=ve;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof ve)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Oe(ae,fe,ge,be,Ie,Le,Re,Ne,_e,Me,We,ke,Ae){return((fe=Pe(ge)?"":Pe(be)?">="+ge+".0.0":Pe(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Ne=Pe(_e)?"":Pe(Me)?"<"+(+_e+1)+".0.0":Pe(We)?"<"+_e+"."+(+Me+1)+".0":ke?"<="+_e+"."+Me+"."+We+"-"+ke:"<="+Ne)).trim()}function $e(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(R(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function Ve(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function Je(ae,fe,ge,be){var Ie,Le,Re,Ne,_e;switch(ae=new O(ae,be),fe=new Ee(fe,be),ge){case">":Ie=ee,Le=ue,Re=oe,Ne=">",_e=">=";break;case"<":Ie=oe,Le=se,Re=ee,Ne="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var We=fe.set[Me],ke=null,Ae=null;if(We.forEach(function(te){te.semver===we&&(te=new ve(">=0.0.0")),ke=ke||te,Ae=Ae||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,Ae.semver,be)&&(Ae=te)}),ke.operator===Ne||ke.operator===_e||(!Ae.operator||Ae.operator===Ne)&&Le(ae,Ae.semver)||Ae.operator===_e&&Re(ae,Ae.semver))return!1}return!0}ve.prototype.parse=function(ae){var fe=this.loose?P[V]:P[z],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new O(ae,this.loose)),de(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,fe){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),Ve(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),Ve(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Le=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=de(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),_e=de(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Le&&Re||Ne||_e},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),R("range",ae,fe);var ge=fe?P[X]:P[K];ae=ae.replace(ge,Oe),R("hyphen replace",ae),ae=ae.replace(P[j],"$1$2$3"),R("comparator trim",ae,P[j]),ae=(ae=(ae=ae.replace(P[N],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var be=fe?P[V]:P[z],Ie=ae.split(" ").map(function(Le){return function(Re,Ne){return R("comp",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(We){return function(ke,Ae){R("caret",ke,Ae);var te=Ae?P[q]:P[Y];return ke.replace(te,function(le,he,me,Se,Ce){var De;return R("caret",ke,le,he,me,Se,Ce),Pe(he)?De="":Pe(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Pe(Se)?De=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Ce?(R("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Ce+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Ce+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Ce+" <"+(+he+1)+".0.0"):(R("no pr"),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),R("caret return",De),De})}(We,Me)}).join(" ")}(Re,Ne),R("caret",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(We){return function(ke,Ae){var te=Ae?P[k]:P[W];return ke.replace(te,function(le,he,me,Se,Ce){var De;return R("tilde",ke,le,he,me,Se,Ce),Pe(he)?De="":Pe(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Pe(Se)?De=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Ce?(R("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),De=">="+he+"."+me+"."+Se+Ce+" <"+he+"."+(+me+1)+".0"):De=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",R("tilde return",De),De})}(We,Me)}).join(" ")}(Re,Ne),R("tildes",Re),Re=function(_e,Me){return R("replaceXRanges",_e,Me),_e.split(/\s+/).map(function(We){return function(ke,Ae){ke=ke.trim();var te=Ae?P[A]:P[w];return ke.replace(te,function(le,he,me,Se,Ce,De){R("xRange",ke,le,he,me,Se,Ce,De);var ze=Pe(me),Fe=ze||Pe(Se),Te=Fe||Pe(Ce);return he==="="&&Te&&(he=""),ze?le=he===">"||he==="<"?"<0.0.0":"*":he&&Te?(Fe&&(Se=0),Te&&(Ce=0),he===">"?(he=">=",Fe?(me=+me+1,Se=0,Ce=0):Te&&(Se=+Se+1,Ce=0)):he==="<="&&(he="<",Fe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Ce):Fe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Te&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",le),le})}(We,Me)}).join(" ")}(Re,Ne),R("xrange",Re),Re=function(_e,Me){return R("replaceStars",_e,Me),_e.trim().replace(P[ce],"")}(Re,Ne),R("stars",Re),Re}(Le,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Le){return!!Le.match(be)})),Ie=Ie.map(function(Le){return new ve(Le,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Le){return be.intersects(Le,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new O(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if($e(this.set[fe],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new O(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new O(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return Je(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return Je(ae,fe,">",ge)},e.outside=Je,e.prerelease=function(ae,fe){var ge=H(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof O)return ae;if(typeof ae!="string")return null;var fe=ae.match(P[F]);return fe==null?null:H((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,t,R=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(y){if(D===setTimeout)return setTimeout(y,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{t=typeof clearTimeout=="function"?clearTimeout:T}catch{t=T}})();var I,E=[],C=!1,b=-1;function S(){C&&I&&(C=!1,I.length?E=I.concat(E):b=-1,E.length&&p())}function p(){if(!C){var y=P(S);C=!0;for(var u=E.length;u;){for(I=E,E=[];++b<u;)I&&I[b].run();b=-1,u=E.length}I=null,C=!1,function(m){if(t===clearTimeout)return clearTimeout(m);if((t===T||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(m);try{t(m)}catch{try{return t.call(null,m)}catch{return t.call(this,m)}}}(y)}}function f(y,u){this.fun=y,this.array=u}function v(){}R.nextTick=function(y){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];E.push(new f(y,u)),E.length!==1||C||P(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function(y){return[]},R.binding=function(y){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(y){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[122],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,I,E){this.level=P,this.key=I,this.value=E,this.forward=[]}}const R=void 0;class L{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new t(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,R,R)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,I){return L._insert(this,P,I,this.comparator)&&(this._size+=1),this}delete(P){const I=L._delete(this,P,this.comparator);return I&&(this._size-=1),I}forEach(P,I){let E=this._header.forward[0];for(;E;)P.call(I,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this._header.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static _search(P,I,E){let C=P._header;for(let b=P._level-1;b>=0;b--)for(;C.forward[b]&&E(C.forward[b].key,I)<0;)C=C.forward[b];if(C=C.forward[0],C&&E(C.key,I)===0)return C}static _insert(P,I,E,C){const b=[];let S=P._header;for(let p=P._level-1;p>=0;p--){for(;S.forward[p]&&C(S.forward[p].key,I)<0;)S=S.forward[p];b[p]=S}if(S=S.forward[0],S&&C(S.key,I)===0)return S.value=E,!1;{const p=L._randomLevel(P);if(p>P._level){for(let f=P._level;f<p;f++)b[f]=P._header;P._level=p}S=new t(p,I,E);for(let f=0;f<p;f++)S.forward[f]=b[f].forward[f],b[f].forward[f]=S;return!0}}static _randomLevel(P,I=.5){let E=1;for(;Math.random()<I&&E<P._maxLevel;)E+=1;return E}static _delete(P,I,E){const C=[];let b=P._header;for(let S=P._level-1;S>=0;S--){for(;b.forward[S]&&E(b.forward[S].key,I)<0;)b=b.forward[S];C[S]=b}if(b=b.forward[0],!b||E(b.key,I)!==0)return!1;for(let S=0;S<P._level&&C[S].forward[S]===b;S++)C[S].forward[S]=b.forward[S];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(d){const l=d;return l?typeof l.read=="function":!1}e.isReadable=R;function L(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function T(d){const l=d;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(d,l){return new I(d,l)}e.newWriteableStream=P;class I{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,D.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(d,l){const n=[];let r;for(;(r=d.read())!==null;)n.push(r);return l(n)}e.consumeReadable=E;function C(d,l,n){const r=[];let i;for(;(i=d.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return d.read()}}}e.peekReadable=C;function b(d,l){return new Promise((n,r)=>{const i=[];S(d,{onData:o=>{l&&i.push(o)},onError:o=>{l?r(o):n(void 0)},onEnd:()=>{n(l?l(i):void 0)}})})}e.consumeStream=b;function S(d,l){let n=!1;return d.on("error",r=>{n||l.onError(r)}),d.on("end",()=>{n||l.onEnd()}),d.on("data",r=>{n||l.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=S;function p(d,l){return new Promise((n,r)=>{const i=new t.DisposableStore,o=[],s=g=>{if(o.push(g),o.length>l)return i.dispose(),d.pause(),n({stream:d,buffer:o,ended:!1})},h=g=>r(g),a=()=>n({stream:d,buffer:o,ended:!0});i.add((0,t.toDisposable)(()=>d.removeListener("error",h))),d.on("error",h),i.add((0,t.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),i.add((0,t.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=p;function f(d,l){const n=P(l);return n.end(d),n}e.toStream=f;function v(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=v;function y(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=y;function u(d,l,n){const r=P(n);return S(d,{onData:i=>r.write(l.data(i)),onError:i=>r.error(l.error?l.error(i):i),onEnd:()=>r.end()}),r}e.transform=u;function m(d,l,n){let r=!1;return{read:()=>{const i=l.read();return r?i:(r=!0,i!==null?n([d,i]):d)}}}e.prefixedReadable=m;function c(d,l,n){let r=!1;const i=P(n);return S(l,{onData:o=>r?i.write(o):(r=!0,i.write(n([d,o]))),onError:o=>i.error(o),onEnd:()=>{r||(r=!0,i.write(d)),i.end()}}),i}e.prefixedStream=c}),define(ne[17],re([0,1,42]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let R,L;class T{static alloc(g){return t?new T(Buffer.allocUnsafe(g)):new T(new Uint8Array(g))}static wrap(g){return t&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new T(g)}static fromString(g,w){return!(w?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(g)):(R||(R=new TextEncoder),new T(R.encode(g)))}static fromByteArray(g){const w=T.alloc(g.length);for(let A=0,F=g.length;A<F;A++)w.buffer[A]=g[A];return w}static concat(g,w){if(typeof w>"u"){w=0;for(let _=0,N=g.length;_<N;_++)w+=g[_].byteLength}const A=T.alloc(w);let F=0;for(let _=0,N=g.length;_<N;_++){const W=g[_];A.set(W,F),F+=W.byteLength}return A}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=T.alloc(this.byteLength);return g.set(this),g}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(g,w){return new T(this.buffer.subarray(g,w))}set(g,w){if(g instanceof T)this.buffer.set(g.buffer,w);else if(g instanceof Uint8Array)this.buffer.set(g,w);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),w);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return E(this.buffer,g)}writeUInt32BE(g,w){C(this.buffer,g,w)}readUInt32LE(g){return b(this.buffer,g)}writeUInt32LE(g,w){S(this.buffer,g,w)}readUInt8(g){return p(this.buffer,g)}writeUInt8(g,w){f(this.buffer,g,w)}}e.VSBuffer=T;function P(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=P;function I(a,g,w){a[w+0]=g&255,g=g>>>8,a[w+1]=g&255}e.writeUInt16LE=I;function E(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=E;function C(a,g,w){a[w+3]=g,g=g>>>8,a[w+2]=g,g=g>>>8,a[w+1]=g,g=g>>>8,a[w]=g}e.writeUInt32BE=C;function b(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=b;function S(a,g,w){a[w+0]=g&255,g=g>>>8,a[w+1]=g&255,g=g>>>8,a[w+2]=g&255,g=g>>>8,a[w+3]=g&255}e.writeUInt32LE=S;function p(a,g){return a[g]}e.readUInt8=p;function f(a,g,w){a[w]=g}e.writeUInt8=f;function v(a){return D.consumeReadable(a,g=>T.concat(g))}e.readableToBuffer=v;function y(a){return D.toReadable(a)}e.bufferToReadable=y;function u(a){return D.consumeStream(a,g=>T.concat(g))}e.streamToBuffer=u;async function m(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=m;function c(a){return D.toStream(a,g=>T.concat(g))}e.bufferToStream=c;function d(a){return D.transform(a,{data:g=>typeof g=="string"?T.fromString(g):T.wrap(g)},g=>T.concat(g))}e.streamToBufferReadableStream=d;function l(a){return D.newWriteableStream(g=>T.concat(g),a)}e.newWriteableBufferStream=l;function n(a,g){return D.prefixedReadable(a,g,w=>T.concat(w))}e.prefixedBufferReadable=n;function r(a,g){return D.prefixedStream(a,g,w=>T.concat(w))}e.prefixedBufferStream=r;function i(a){let g=0,w=0,A=0;const F=new Uint8Array(Math.floor(a.length/4*3)),_=W=>{switch(w){case 3:F[A++]=g|W,w=0;break;case 2:F[A++]=g|W>>>2,g=W<<6,w=3;break;case 1:F[A++]=g|W>>>4,g=W<<4,w=2;break;default:g=W<<2,w=1}};for(let W=0;W<a.length;W++){const k=a.charCodeAt(W);if(k>=65&&k<=90)_(k-65);else if(k>=97&&k<=122)_(k-97+26);else if(k>=48&&k<=57)_(k-48+52);else if(k===43||k===45)_(62);else if(k===47||k===95)_(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${a[W]}`)}}const N=A;for(;w>0;)_(0);return T.wrap(F).slice(0,N)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:a},g=!0,w=!1){const A=w?s:o;let F="";const _=a.byteLength%3;let N=0;for(;N<a.byteLength-_;N+=3){const W=a[N+0],k=a[N+1],U=a[N+2];F+=A[W>>>2],F+=A[(W<<4|k>>>4)&63],F+=A[(k<<2|U>>>6)&63],F+=A[U&63]}if(_===1){const W=a[N+0];F+=A[W>>>2],F+=A[W<<4&63],g&&(F+="==")}else if(_===2){const W=a[N+0],k=a[N+1];F+=A[W>>>2],F+=A[(W<<4|k>>>4)&63],F+=A[k<<2&63],g&&(F+="=")}return F}e.encodeBase64=h}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(r){return typeof r=="string"}e.isString=D;function t(r){return Array.isArray(r)&&r.every(i=>D(i))}e.isStringArray=t;function R(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=R;function L(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=L;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function I(r){return r===!0||r===!1}e.isBoolean=I;function E(r){return typeof r>"u"}e.isUndefined=E;function C(r){return!b(r)}e.isDefined=C;function b(r){return E(r)||r===null}e.isUndefinedOrNull=b;function S(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=S;function p(r){if(b(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=p;function f(...r){const i=[];for(let o=0;o<r.length;o++){const s=r[o];if(b(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(s)}return i}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function y(r){if(!R(r))return!1;for(const i in r)if(v.call(r,i))return!1;return!0}e.isEmptyObject=y;function u(r){return typeof r=="function"}e.isFunction=u;function m(...r){return r.length>0&&r.every(u)}e.areFunctions=m;function c(r,i){const o=Math.min(r.length,i.length);for(let s=0;s<o;s++)d(r[s],i[s])}e.validateConstraints=c;function d(r,i){if(D(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(r instanceof i)return}catch{}if(!b(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function l(r){return r===null?void 0:r}e.withNullAsUndefined=l;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(ne[32],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([c,d])=>{m[c]=d&&typeof d=="object"?t(d):d}),m}e.deepClone=t;function R(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const c=m.shift();Object.freeze(c);for(const d in c)if(L.call(c,d)){const l=c[d];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.isTypedArray)(l)&&m.push(l)}}return u}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function T(u,m){return P(u,m,new Set)}e.cloneAndChange=T;function P(u,m,c){if((0,D.isUndefinedOrNull)(u))return u;const d=m(u);if(typeof d<"u")return d;if(Array.isArray(u)){const l=[];for(const n of u)l.push(P(n,m,c));return l}if((0,D.isObject)(u)){if(c.has(u))throw new Error("Cannot clone recursive data-structure");c.add(u);const l={};for(const n in u)L.call(u,n)&&(l[n]=P(u[n],m,c));return c.delete(u),l}return u}function I(u,m,c=!0){return(0,D.isObject)(u)?((0,D.isObject)(m)&&Object.keys(m).forEach(d=>{d in u?c&&((0,D.isObject)(u[d])&&(0,D.isObject)(m[d])?I(u[d],m[d],c):u[d]=m[d]):u[d]=m[d]}),u):m}e.mixin=I;function E(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let c,d;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(c=0;c<u.length;c++)if(!E(u[c],m[c]))return!1}else{const l=[];for(d in u)l.push(d);l.sort();const n=[];for(d in m)n.push(d);if(n.sort(),!E(l,n))return!1;for(c=0;c<l.length;c++)if(!E(u[l[c]],m[l[c]]))return!1}return!0}e.equals=E;function C(u){const m=new Set;return JSON.stringify(u,(c,d)=>{if((0,D.isObject)(d)||Array.isArray(d)){if(m.has(d))return"[Circular]";m.add(d)}return d})}e.safeStringify=C;function b(u,m){const c=Object.create(null);return!u||!m||Object.keys(m).forEach(l=>{const n=u[l],r=m[l];E(n,r)||(c[l]=r)}),c}e.distinct=b;function S(u,m){const c=m.toLowerCase(),d=Object.keys(u).find(l=>l.toLowerCase()===c);return d?u[d]:u[m]}e.getCaseInsensitive=S;function p(u,m){const c=Object.create(null);for(const[d,l]of Object.entries(u))m(d,l)&&(c[d]=l);return c}e.filter=p;function f(u){let m=[],c=Object.getPrototypeOf(u);for(;Object.prototype!==c;)m=m.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return m}e.getAllPropertyNames=f;function v(u){const m=[];for(const c of f(u))typeof u[c]=="function"&&m.push(c);return m}e.getAllMethodNames=v;function y(u,m){const c=l=>function(){const n=Array.prototype.slice.call(arguments,0);return m(l,n)},d={};for(const l of u)d[l]=c(l);return d}e.createProxyObject=y}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(R){return D.test(R)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let I=0,E="";return E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+="-",E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E+=T[L[I++]],E}}()}),define(ne[123],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(T){const P=T.replace(/\-/g,":").toLowerCase();return!t.has(P)}function L(){const T=(0,D.networkInterfaces)();for(const P in T){const I=T[P];if(I){for(const{mac:E}of I)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[124],re([0,1,84]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,I,E,C=1){let b=!1;return new Promise(S=>{const p=setTimeout(()=>{if(!b)return b=!0,S(0)},E);R(P,I,C,f=>{if(!b)return b=!0,clearTimeout(p),S(f)})})}e.findFreePort=t;function R(P,I,E,C){if(I===0)return C(0);const b=new D.Socket;b.once("connect",()=>(T(b),R(P+E,I-1,E,C))),b.once("data",()=>{}),b.once("error",S=>(T(b),S.code!=="ECONNREFUSED"?R(P+E,I-1,E,C):C(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,I,E){let C=!1,b,S=1;const p=D.createServer({pauseOnConnect:!0});function f(v,y){C||(C=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),y(v))}return new Promise(v=>{b=setTimeout(()=>{f(0,v)},E),p.on("listening",()=>{f(P,v)}),p.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&S<I?(P++,S++,p.listen(P,"127.0.0.1")):f(0,v)}),p.on("close",()=>{f(0,v)}),p.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function T(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(ne[125],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function t(L){return L instanceof R?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=t;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(ne[126],re([0,1,17,9,125]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(I,E){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((b,S)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),T(C,I),C.responseType="arraybuffer",C.onerror=p=>S(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=p=>{b({res:{statusCode:C.status,headers:P(C)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=p=>S(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),E.onCancellationRequested(()=>{C.abort(),S((0,t.canceled)())})})}e.request=L;function T(I,E){if(E.headers){e:for(const C in E.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,E.headers[C])}}}function P(I){const E=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const b=C.indexOf(":");E[C.substr(0,b).trim().toLowerCase()]=C.substr(b+1).trim()}return E}}),define(ne[127],re([11,12]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[65],re([0,1,127]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,R=t*60,L=R*24,T=L*7,P=L*30,I=L*365;function E(b,S,p){typeof b!="number"&&(b=b.getTime());const f=Math.round((new Date().getTime()-b)/1e3);if(f<-30)return(0,D.localize)(0,null,E(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let v;return f<t?(v=f,S?v===1?p?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):p?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?p?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):p?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):f<R?(v=Math.floor(f/t),S?v===1?p?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):p?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?p?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):p?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):f<L?(v=Math.floor(f/R),S?v===1?p?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):p?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?p?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):p?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):f<T?(v=Math.floor(f/L),S?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):f<P?(v=Math.floor(f/T),S?v===1?p?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):p?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?p?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):p?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):f<I?(v=Math.floor(f/P),S?v===1?p?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):p?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?p?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):p?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(f/I),S?v===1?p?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):p?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?p?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):p?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=E;function C(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(ne[128],re([11,12]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[37],re([0,1,18,15,128]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(b,S){return S&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),T(b.stack)||T(b.stacktrace)):P(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function I(b=null,S=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const p=D.coalesce(b),f=I(p[0],S);return p.length>1?R.localize(4,null,f,p.length):f}if(t.isString(b))return b;if(b.detail){const p=b.detail;if(p.error)return L(p.error,S);if(p.exception)return L(p.exception,S)}return b.stack?L(b,S):b.message?b.message:R.localize(5,null)}e.toErrorMessage=I;function E(b){const S=b;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=E;function C(b,S){let p;return typeof b=="string"?p=new Error(b):p=b,p.actions=S,p}e.createErrorWithActions=C}),define(ne[129],re([11,12]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[130],re([0,1,129]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ne[131],re([11,12]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,131]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,R=!1,L=!1,T=!1,P=!1,I=!1,E=!1,C=!1,b=!1,S=!1,p,f=e.LANGUAGE_DEFAULT,v,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",c=m&&u?.type==="renderer";if(typeof navigator=="object"&&!c)y=navigator.userAgent,t=y.indexOf("Windows")>=0,R=y.indexOf("Macintosh")>=0,C=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=y.indexOf("Linux")>=0,S=y?.indexOf("Mobi")>=0,I=!0,p=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,f=p;else if(typeof u=="object"){t=u.platform==="win32",R=u.platform==="darwin",L=u.platform==="linux",T=L&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,E=m,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const g=JSON.parse(a),w=g.availableLanguages["*"];p=g.locale,f=w||e.LANGUAGE_DEFAULT,v=g._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var d;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let n=0;R?n=1:t?n=3:L&&(n=2),e.isWindows=t,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=T,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=S,e.isCI=b,e.platform=n,e.userAgent=y,e.language=f;var r;(function(a){function g(){return e.language}a.value=g;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=w;function A(){return e.language==="en"}a.isDefault=A})(r=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let A=0,F=a.length;A<F;A++){const _=a[A];if(_.id===w.data.vscodeScheduleAsyncWork){a.splice(A,1),_.callback();return}}});let g=0;return w=>{const A=++g;a.push({id:A,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:t?1:3;let o=!0,s=!1;function h(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=h,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ne[10],re([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,R=97,L=90,T=122,P=46,I=47,E=92,C=58,b=63;class S extends Error{constructor(d,l,n){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const i=d.indexOf(".")!==-1?"property":"argument";let o=`The "${d}" ${i} ${r} of type ${l}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,d){if(typeof c!="string")throw new S(d,"string",c)}function f(c){return c===I||c===E}function v(c){return c===I}function y(c){return c>=t&&c<=L||c>=R&&c<=T}function u(c,d,l,n){let r="",i=0,o=-1,s=0,h=0;for(let a=0;a<=c.length;++a){if(a<c.length)h=c.charCodeAt(a);else{if(n(h))break;h=I}if(n(h)){if(!(o===a-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const g=r.lastIndexOf(l);g===-1?(r="",i=0):(r=r.slice(0,g),i=r.length-1-r.lastIndexOf(l)),o=a,s=0;continue}else if(r.length!==0){r="",i=0,o=a,s=0;continue}}d&&(r+=r.length>0?`${l}..`:"..",i=2)}else r.length>0?r+=`${l}${c.slice(o+1,a)}`:r=c.slice(o+1,a),i=a-o-1;o=a,s=0}else h===P&&s!==-1?++s:s=-1}return r}function m(c,d){if(d===null||typeof d!="object")throw new S("pathObject","Object",d);const l=d.dir||d.root,n=d.base||`${d.name||""}${d.ext||""}`;return l?l===d.root?`${l}${n}`:`${l}${c}${n}`:n}e.win32={resolve(...c){let d="",l="",n=!1;for(let r=c.length-1;r>=-1;r--){let i;if(r>=0){if(i=c[r],p(i,"path"),i.length===0)continue}else d.length===0?i=D.cwd():(i=D.env[`=${d}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==d.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${d}\\`));const o=i.length;let s=0,h="",a=!1;const g=i.charCodeAt(0);if(o===1)f(g)&&(s=1,a=!0);else if(f(g))if(a=!0,f(i.charCodeAt(1))){let w=2,A=w;for(;w<o&&!f(i.charCodeAt(w));)w++;if(w<o&&w!==A){const F=i.slice(A,w);for(A=w;w<o&&f(i.charCodeAt(w));)w++;if(w<o&&w!==A){for(A=w;w<o&&!f(i.charCodeAt(w));)w++;(w===o||w!==A)&&(h=`\\\\${F}\\${i.slice(A,w)}`,s=w)}}}else s=1;else y(g)&&i.charCodeAt(1)===C&&(h=i.slice(0,2),s=2,o>2&&f(i.charCodeAt(2))&&(a=!0,s=3));if(h.length>0)if(d.length>0){if(h.toLowerCase()!==d.toLowerCase())continue}else d=h;if(n){if(d.length>0)break}else if(l=`${i.slice(s)}\\${l}`,n=a,a&&d.length>0)break}return l=u(l,!n,"\\",f),n?`${d}\\${l}`:`${d}${l}`||"."},normalize(c){p(c,"path");const d=c.length;if(d===0)return".";let l=0,n,r=!1;const i=c.charCodeAt(0);if(d===1)return v(i)?"\\":c;if(f(i))if(r=!0,f(c.charCodeAt(1))){let s=2,h=s;for(;s<d&&!f(c.charCodeAt(s));)s++;if(s<d&&s!==h){const a=c.slice(h,s);for(h=s;s<d&&f(c.charCodeAt(s));)s++;if(s<d&&s!==h){for(h=s;s<d&&!f(c.charCodeAt(s));)s++;if(s===d)return`\\\\${a}\\${c.slice(h)}\\`;s!==h&&(n=`\\\\${a}\\${c.slice(h,s)}`,l=s)}}}else l=1;else y(i)&&c.charCodeAt(1)===C&&(n=c.slice(0,2),l=2,d>2&&f(c.charCodeAt(2))&&(r=!0,l=3));let o=l<d?u(c.slice(l),!r,"\\",f):"";return o.length===0&&!r&&(o="."),o.length>0&&f(c.charCodeAt(d-1))&&(o+="\\"),n===void 0?r?`\\${o}`:o:r?`${n}\\${o}`:`${n}${o}`},isAbsolute(c){p(c,"path");const d=c.length;if(d===0)return!1;const l=c.charCodeAt(0);return f(l)||d>2&&y(l)&&c.charCodeAt(1)===C&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let d,l;for(let i=0;i<c.length;++i){const o=c[i];p(o,"path"),o.length>0&&(d===void 0?d=l=o:d+=`\\${o}`)}if(d===void 0)return".";let n=!0,r=0;if(typeof l=="string"&&f(l.charCodeAt(0))){++r;const i=l.length;i>1&&f(l.charCodeAt(1))&&(++r,i>2&&(f(l.charCodeAt(2))?++r:n=!1))}if(n){for(;r<d.length&&f(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.win32.normalize(d)},relative(c,d){if(p(c,"from"),p(d,"to"),c===d)return"";const l=e.win32.resolve(c),n=e.win32.resolve(d);if(l===n||(c=l.toLowerCase(),d=n.toLowerCase(),c===d))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===E;)r++;let i=c.length;for(;i-1>r&&c.charCodeAt(i-1)===E;)i--;const o=i-r;let s=0;for(;s<d.length&&d.charCodeAt(s)===E;)s++;let h=d.length;for(;h-1>s&&d.charCodeAt(h-1)===E;)h--;const a=h-s,g=o<a?o:a;let w=-1,A=0;for(;A<g;A++){const _=c.charCodeAt(r+A);if(_!==d.charCodeAt(s+A))break;_===E&&(w=A)}if(A!==g){if(w===-1)return n}else{if(a>g){if(d.charCodeAt(s+A)===E)return n.slice(s+A+1);if(A===2)return n.slice(s+A)}o>g&&(c.charCodeAt(r+A)===E?w=A:A===2&&(w=3)),w===-1&&(w=0)}let F="";for(A=r+w+1;A<=i;++A)(A===i||c.charCodeAt(A)===E)&&(F+=F.length===0?"..":"\\..");return s+=w,F.length>0?`${F}${n.slice(s,h)}`:(n.charCodeAt(s)===E&&++s,n.slice(s,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const d=e.win32.resolve(c);if(d.length<=2)return c;if(d.charCodeAt(0)===E){if(d.charCodeAt(1)===E){const l=d.charCodeAt(2);if(l!==b&&l!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(y(d.charCodeAt(0))&&d.charCodeAt(1)===C&&d.charCodeAt(2)===E)return`\\\\?\\${d}`;return c},dirname(c){p(c,"path");const d=c.length;if(d===0)return".";let l=-1,n=0;const r=c.charCodeAt(0);if(d===1)return f(r)?c:".";if(f(r)){if(l=n=1,f(c.charCodeAt(1))){let s=2,h=s;for(;s<d&&!f(c.charCodeAt(s));)s++;if(s<d&&s!==h){for(h=s;s<d&&f(c.charCodeAt(s));)s++;if(s<d&&s!==h){for(h=s;s<d&&!f(c.charCodeAt(s));)s++;if(s===d)return c;s!==h&&(l=n=s+1)}}}}else y(r)&&c.charCodeAt(1)===C&&(l=d>2&&f(c.charCodeAt(2))?3:2,n=l);let i=-1,o=!0;for(let s=d-1;s>=n;--s)if(f(c.charCodeAt(s))){if(!o){i=s;break}}else o=!1;if(i===-1){if(l===-1)return".";i=l}return c.slice(0,i)},basename(c,d){d!==void 0&&p(d,"ext"),p(c,"path");let l=0,n=-1,r=!0,i;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===C&&(l=2),d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let o=d.length-1,s=-1;for(i=c.length-1;i>=l;--i){const h=c.charCodeAt(i);if(f(h)){if(!r){l=i+1;break}}else s===-1&&(r=!1,s=i+1),o>=0&&(h===d.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=s))}return l===n?n=s:n===-1&&(n=c.length),c.slice(l,n)}for(i=c.length-1;i>=l;--i)if(f(c.charCodeAt(i))){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":c.slice(l,n)},extname(c){p(c,"path");let d=0,l=-1,n=0,r=-1,i=!0,o=0;c.length>=2&&c.charCodeAt(1)===C&&y(c.charCodeAt(0))&&(d=n=2);for(let s=c.length-1;s>=d;--s){const h=c.charCodeAt(s);if(f(h)){if(!i){n=s+1;break}continue}r===-1&&(i=!1,r=s+1),h===P?l===-1?l=s:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||r===-1||o===0||o===1&&l===r-1&&l===n+1?"":c.slice(l,r)},format:m.bind(null,"\\"),parse(c){p(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const l=c.length;let n=0,r=c.charCodeAt(0);if(l===1)return f(r)?(d.root=d.dir=c,d):(d.base=d.name=c,d);if(f(r)){if(n=1,f(c.charCodeAt(1))){let w=2,A=w;for(;w<l&&!f(c.charCodeAt(w));)w++;if(w<l&&w!==A){for(A=w;w<l&&f(c.charCodeAt(w));)w++;if(w<l&&w!==A){for(A=w;w<l&&!f(c.charCodeAt(w));)w++;w===l?n=w:w!==A&&(n=w+1)}}}}else if(y(r)&&c.charCodeAt(1)===C){if(l<=2)return d.root=d.dir=c,d;if(n=2,f(c.charCodeAt(2))){if(l===3)return d.root=d.dir=c,d;n=3}}n>0&&(d.root=c.slice(0,n));let i=-1,o=n,s=-1,h=!0,a=c.length-1,g=0;for(;a>=n;--a){if(r=c.charCodeAt(a),f(r)){if(!h){o=a+1;break}continue}s===-1&&(h=!1,s=a+1),r===P?i===-1?i=a:g!==1&&(g=1):i!==-1&&(g=-1)}return s!==-1&&(i===-1||g===0||g===1&&i===s-1&&i===o+1?d.base=d.name=c.slice(o,s):(d.name=c.slice(o,i),d.base=c.slice(o,s),d.ext=c.slice(i,s))),o>0&&o!==n?d.dir=c.slice(0,o-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let d="",l=!1;for(let n=c.length-1;n>=-1&&!l;n--){const r=n>=0?c[n]:D.cwd();p(r,"path"),r.length!==0&&(d=`${r}/${d}`,l=r.charCodeAt(0)===I)}return d=u(d,!l,"/",v),l?`/${d}`:d.length>0?d:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===I,l=c.charCodeAt(c.length-1)===I;return c=u(c,!d,"/",v),c.length===0?d?"/":l?"./":".":(l&&(c+="/"),d?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===I},join(...c){if(c.length===0)return".";let d;for(let l=0;l<c.length;++l){const n=c[l];p(n,"path"),n.length>0&&(d===void 0?d=n:d+=`/${n}`)}return d===void 0?".":e.posix.normalize(d)},relative(c,d){if(p(c,"from"),p(d,"to"),c===d||(c=e.posix.resolve(c),d=e.posix.resolve(d),c===d))return"";const l=1,n=c.length,r=n-l,i=1,o=d.length-i,s=r<o?r:o;let h=-1,a=0;for(;a<s;a++){const w=c.charCodeAt(l+a);if(w!==d.charCodeAt(i+a))break;w===I&&(h=a)}if(a===s)if(o>s){if(d.charCodeAt(i+a)===I)return d.slice(i+a+1);if(a===0)return d.slice(i+a)}else r>s&&(c.charCodeAt(l+a)===I?h=a:a===0&&(h=0));let g="";for(a=l+h+1;a<=n;++a)(a===n||c.charCodeAt(a)===I)&&(g+=g.length===0?"..":"/..");return`${g}${d.slice(i+h)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===I;let l=-1,n=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===I){if(!n){l=r;break}}else n=!1;return l===-1?d?"/":".":d&&l===1?"//":c.slice(0,l)},basename(c,d){d!==void 0&&p(d,"ext"),p(c,"path");let l=0,n=-1,r=!0,i;if(d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let o=d.length-1,s=-1;for(i=c.length-1;i>=0;--i){const h=c.charCodeAt(i);if(h===I){if(!r){l=i+1;break}}else s===-1&&(r=!1,s=i+1),o>=0&&(h===d.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=s))}return l===n?n=s:n===-1&&(n=c.length),c.slice(l,n)}for(i=c.length-1;i>=0;--i)if(c.charCodeAt(i)===I){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":c.slice(l,n)},extname(c){p(c,"path");let d=-1,l=0,n=-1,r=!0,i=0;for(let o=c.length-1;o>=0;--o){const s=c.charCodeAt(o);if(s===I){if(!r){l=o+1;break}continue}n===-1&&(r=!1,n=o+1),s===P?d===-1?d=o:i!==1&&(i=1):d!==-1&&(i=-1)}return d===-1||n===-1||i===0||i===1&&d===n-1&&d===l+1?"":c.slice(d,n)},format:m.bind(null,"/"),parse(c){p(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const l=c.charCodeAt(0)===I;let n;l?(d.root="/",n=1):n=0;let r=-1,i=0,o=-1,s=!0,h=c.length-1,a=0;for(;h>=n;--h){const g=c.charCodeAt(h);if(g===I){if(!s){i=h+1;break}continue}o===-1&&(s=!1,o=h+1),g===P?r===-1?r=h:a!==1&&(a=1):r!==-1&&(a=-1)}if(o!==-1){const g=i===0&&l?1:i;r===-1||a===0||a===1&&r===o-1&&r===i+1?d.base=d.name=c.slice(g,o):(d.name=c.slice(g,r),d.base=c.slice(g,o),d.ext=c.slice(r,o))}return i>0?d.dir=c.slice(0,i-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[132],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(C){const b=(0,D.extname)(C),S=t[b.toLowerCase()];return S!==void 0?S:T(C)}e.getMediaOrTextMime=L;function T(C){const b=(0,D.extname)(C);return R[b.toLowerCase()]}e.getMediaMime=T;function P(C){for(const b in R)if(R[b]===C)return b}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function E(C,b){const S=I.exec(C);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:b?void 0:C}e.normalizeMimeType=E}),define(ne[85],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...I){const E=I.reduce((S,p)=>(S[p]=!0,S),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(S=>!E[S]).forEach(S=>{for(let p=0;p<C.length;p++)if(S.search(C[p])!==-1){delete P[S];break}})}e.sanitizeProcessEnvironment=L;function T(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[133],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(T=!0){return new R(T)}constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ne[3],re([0,1,9,80,2,82,133]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var E;(function(h){h.None=()=>R.Disposable.None;function a(M){if(I){const{onListenerDidAdd:x}=M,G=f.create();let ee=0;M.onListenerDidAdd=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),x?.()}}}function g(M){return(x,G=null,ee)=>{let oe=!1,Z;return Z=M(ie=>{if(!oe)return Z?Z.dispose():oe=!0,x.call(G,ie)},null,ee),oe&&Z.dispose(),Z}}h.once=g;function w(M,x,G){return k((ee,oe=null,Z)=>M(ie=>ee.call(oe,x(ie)),null,Z),G)}h.map=w;function A(M,x,G){return k((ee,oe=null,Z)=>M(ie=>{x(ie),ee.call(oe,ie)},null,Z),G)}h.forEach=A;function F(M,x,G){return k((ee,oe=null,Z)=>M(ie=>x(ie)&&ee.call(oe,ie),null,Z),G)}h.filter=F;function _(M){return M}h.signal=_;function N(...M){return(x,G=null,ee)=>(0,R.combinedDisposable)(...M.map(oe=>oe(Z=>x.call(G,Z),null,ee)))}h.any=N;function W(M,x,G,ee){let oe=G;return w(M,Z=>(oe=x(oe,Z),oe),ee)}h.reduce=W;function k(M,x){let G;const ee={onFirstListenerAdd(){G=M(oe.fire,oe)},onLastListenerRemove(){G?.dispose()}};x||a(ee);const oe=new y(ee);return x?.add(oe),oe.event}function U(M,x,G=100,ee=!1,oe,Z){let ie,se,ue,de=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=M(Ee=>{de++,se=x(se,Ee),ee&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=se;se=void 0,ue=void 0,(!ee||de>1)&&we.fire(Pe),de=0},G)})},onLastListenerRemove(){ie.dispose()}};Z||a(ve);const we=new y(ve);return Z?.add(we),we.event}h.debounce=U;function $(M,x=(ee,oe)=>ee===oe,G){let ee=!0,oe;return F(M,Z=>{const ie=ee||!x(Z,oe);return ee=!1,oe=Z,ie},G)}h.latch=$;function Y(M,x,G){return[h.filter(M,x,G),h.filter(M,ee=>!x(ee),G)]}h.split=Y;function q(M,x=!1,G=[]){let ee=G.slice(),oe=M(se=>{ee?ee.push(se):ie.fire(se)});const Z=()=>{ee?.forEach(se=>ie.fire(se)),ee=null},ie=new y({onFirstListenerAdd(){oe||(oe=M(se=>ie.fire(se)))},onFirstListenerDidAdd(){ee&&(x?setTimeout(Z):Z())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}h.buffer=q;class V{constructor(x){this.event=x,this.disposables=new R.DisposableStore}map(x){return new V(w(this.event,x,this.disposables))}forEach(x){return new V(A(this.event,x,this.disposables))}filter(x){return new V(F(this.event,x,this.disposables))}reduce(x,G){return new V(W(this.event,x,G,this.disposables))}latch(){return new V($(this.event,void 0,this.disposables))}debounce(x,G=100,ee=!1,oe){return new V(U(this.event,x,G,ee,oe,this.disposables))}on(x,G,ee){return this.event(x,G,ee)}once(x,G,ee){return g(this.event)(x,G,ee)}dispose(){this.disposables.dispose()}}function z(M){return new V(M)}h.chain=z;function j(M,x,G=ee=>ee){const ee=(...se)=>ie.fire(G(...se)),oe=()=>M.on(x,ee),Z=()=>M.removeListener(x,ee),ie=new y({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}h.fromNodeEventEmitter=j;function K(M,x,G=ee=>ee){const ee=(...se)=>ie.fire(G(...se)),oe=()=>M.addEventListener(x,ee),Z=()=>M.removeEventListener(x,ee),ie=new y({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}h.fromDOMEventEmitter=K;function X(M){return new Promise(x=>g(M)(x))}h.toPromise=X;function ce(M,x){return x(void 0),M(G=>x(G))}h.runAndSubscribe=ce;function B(M,x){let G=null;function ee(Z){G?.dispose(),G=new R.DisposableStore,x(Z,G)}ee(void 0);const oe=M(Z=>ee(Z));return(0,R.toDisposable)(()=>{oe.dispose(),G?.dispose()})}h.runAndSubscribeWithStore=B;class H{constructor(x,G){this.obs=x,this._counter=0,this._hasChanged=!1;const ee={onFirstListenerAdd:()=>{x.addObserver(this)},onLastListenerRemove:()=>{x.removeObserver(this)}};G||a(ee),this.emitter=new y(ee),G&&G.add(this.emitter)}beginUpdate(x){this._counter++}handleChange(x,G){this._hasChanged=!0}endUpdate(x){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(M,x){return new H(M,x).emitter.event}h.fromObservable=O})(E=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C._idPool++}`,C.all.add(this)}start(a){this._stopWatch=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=C,C.all=new Set,C._idPool=0;let b=-1;function S(h){const a=b;return b=h,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=S;class p{constructor(a,g=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,g){let w=b;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||g<w)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let F,_=0;for(const[N,W]of this._stacks)(!F||_<W)&&(F=N,_=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${_}):`),console.warn(F)}return()=>{const F=this._stacks.get(a.value)||0;this._stacks.set(a.value,F-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(a,g,w){this.callback=a,this.callbackThis=g,this.stack=w,this.subscription=new R.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class y{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const g of a)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,g,w)=>{this._listeners||(this._listeners=new L.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let F,_;this._leakageMon&&this._listeners.size>=30&&(_=f.create(),F=this._leakageMon.check(_,this._listeners.size+1)),P&&(_=_??f.create());const N=new v(a,g,_),W=this._listeners.push(N);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,g);const k=N.subscription.set(()=>{F?.(),this._disposed||(W(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return w instanceof R.DisposableStore?w.add(k):Array.isArray(w)&&w.push(k),k}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new m);for(const g of this._listeners)this._deliveryQueue.push(this,g,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class u{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(a,g,w){this._queue.push(new c(a,g,w))}clear(a){const g=new L.LinkedList;for(const w of this._queue)w.emitter!==a&&g.push(w);this._queue=g}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(g){(0,D.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=u;class m extends u{clear(a){this._queue.clear()}}class c{constructor(a,g,w){this.emitter=a,this.listener=g,this.event=w}}class d extends y{async fireAsync(a,g,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,a]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[A,F]=this._asyncDeliveryQueue.shift(),_=[],N={...F,token:g,waitUntil:W=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");w&&(W=w(W,A.callback)),_.push(W)}};try{A.invoke(N)}catch(W){(0,D.onUnexpectedError)(W);continue}Object.freeze(_),await Promise.allSettled(_).then(W=>{for(const k of W)k.status==="rejected"&&(0,D.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=d;class l extends y{constructor(a){super(a),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class n extends l{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class r extends y{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const g={event:a,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const w=()=>{this.hasListeners&&this.unhook(g);const A=this.events.indexOf(g);this.events.splice(A,1)};return(0,R.toDisposable)((0,t.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(g=>this.emitter.fire(g))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(a){return(g,w,A)=>a(F=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>g.call(w,F)):g.call(w,F)},void 0,A)}bufferEvents(a){const g=[];this.buffers.push(g);const w=a();return this.buffers.pop(),g.forEach(A=>A()),w}}e.EventBufferer=o;class s{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ne[24],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,I){const E=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function I(E){return E===P.None||E===P.Cancelled||E instanceof L?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=T}),define(ne[134],re([0,1,24]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,I=this.task(P.token);return this.result={promise:I,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class R{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const I=JSON.stringify(P);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=R;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const I=this.fn(P);return this._map.set(P,I),I}}e.CachedFunction=L}),define(ne[86],re([0,1,3,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=R;class L extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(ne[27],re([0,1,134,121]),function(Q,e,D,t){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function P(te,...le){return le.length===0?te:te.replace(T,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const I=/{([^}]+)}/g;function E(te,le){return te.replace(I,(he,me)=>le[me]??he)}e.format2=E;function C(te){return te.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=C;function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function S(te,le){let he=0;const me=le.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&he++;return he}e.count=S;function p(te,le,he="\u2026"){return te.length<=le?te:`${te.substr(0,le)}${he}`}e.truncate=p;function f(te,le=" "){const he=v(te,le);return y(he,le)}e.trim=f;function v(te,le){if(!te||!le)return te;const he=le.length;if(he===0||te.length===0)return te;let me=0;for(;te.indexOf(le,me)===me;)me=me+he;return te.substring(me)}e.ltrim=v;function y(te,le){if(!te||!le)return te;const he=le.length,me=te.length;if(he===0||me===0)return te;let Se=me,Ce=-1;for(;Ce=te.lastIndexOf(le,Se-1),!(Ce===-1||Ce+he!==Se);){if(Ce===0)return"";Se=Ce}return te.substring(0,Se)}e.rtrim=y;function u(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(te){return te.replace(/\*/g,"")}e.stripWildcards=m;function c(te,le,he={}){if(!te)throw new Error("Cannot create regex from empty string");le||(te=b(te)),he.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=c;function d(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function l(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function r(te){return te.split(/\r\n|\r|\n/)}e.splitLines=r;function i(te){for(let le=0,he=te.length;le<he;le++){const me=te.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function o(te,le=0,he=te.length){for(let me=le;me<he;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(le,me)}return te.substring(le,he)}e.getLeadingWhitespace=o;function s(te,le=te.length-1){for(let he=le;he>=0;he--){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function h(te,le,he){const me=[];let Se=0;for(const Ce of te.matchAll(le)){if(me.push(te.slice(Se,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Se=Ce.index+Ce[0].length,me.push(he(Ce[0],...Ce.slice(1),Ce.index,te,Ce.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Ce=>Ce.join(""))}e.replaceAsync=h;function a(te,le){return te<le?-1:te>le?1:0}e.compare=a;function g(te,le,he=0,me=te.length,Se=0,Ce=le.length){for(;he<me&&Se<Ce;he++,Se++){const Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe<Te)return-1;if(Fe>Te)return 1}const De=me-he,ze=Ce-Se;return De<ze?-1:De>ze?1:0}e.compareSubstring=g;function w(te,le){return A(te,le,0,te.length,0,le.length)}e.compareIgnoreCase=w;function A(te,le,he=0,me=te.length,Se=0,Ce=le.length){for(;he<me&&Se<Ce;he++,Se++){let Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe===Te)continue;if(Fe>=128||Te>=128)return g(te.toLowerCase(),le.toLowerCase(),he,me,Se,Ce);_(Fe)&&(Fe-=32),_(Te)&&(Te-=32);const qe=Fe-Te;if(qe!==0)return qe}const De=me-he,ze=Ce-Se;return De<ze?-1:De>ze?1:0}e.compareSubstringIgnoreCase=A;function F(te){return te>=48&&te<=57}e.isAsciiDigit=F;function _(te){return te>=97&&te<=122}e.isLowerAsciiLetter=_;function N(te){return te>=65&&te<=90}e.isUpperAsciiLetter=N;function W(te,le){return te.length===le.length&&A(te,le)===0}e.equalsIgnoreCase=W;function k(te,le){const he=le.length;return le.length>te.length?!1:A(te,le,0,he)===0}e.startsWithIgnoreCase=k;function U(te,le){const he=Math.min(te.length,le.length);let me;for(me=0;me<he;me++)if(te.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=U;function $(te,le){const he=Math.min(te.length,le.length);let me;const Se=te.length-1,Ce=le.length-1;for(me=0;me<he;me++)if(te.charCodeAt(Se-me)!==le.charCodeAt(Ce-me))return me;return he}e.commonSuffixLength=$;function Y(te){return 55296<=te&&te<=56319}e.isHighSurrogate=Y;function q(te){return 56320<=te&&te<=57343}e.isLowSurrogate=q;function V(te,le){return(te-55296<<10)+(le-56320)+65536}e.computeCodePoint=V;function z(te,le,he){const me=te.charCodeAt(he);if(Y(me)&&he+1<le){const Se=te.charCodeAt(he+1);if(q(Se))return V(me,Se)}return me}e.getNextCodePoint=z;function j(te,le){const he=te.charCodeAt(le-1);if(q(he)&&le>1){const me=te.charCodeAt(le-2);if(Y(me))return V(me,he)}return he}class K{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=j(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=z(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class X{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new K(le,he)}nextGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ce=he.offset,De=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,De)){he.setOffset(Ce);break}Se=De}return he.offset-me}prevGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ce=he.offset,De=le.getGraphemeBreakType(he.prevCodePoint());if(be(De,Se)){he.setOffset(Ce);break}Se=De}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function ce(te,le){return new X(te,le).nextGraphemeLength()}e.nextCharLength=ce;function B(te,le){return new X(te,le).prevGraphemeLength()}e.prevCharLength=B;function H(te,le){le>0&&q(te.charCodeAt(le))&&le--;const he=le+ce(te,le);return[he-B(te,he),he]}e.getCharContainingOffset=H;function O(te){const le=new X(te);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=O;let M;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function G(te){return M||(M=x()),M.test(te)}e.containsRTL=G;const ee=/^[\t\n\r\x20-\x7E]*$/;function oe(te){return ee.test(te)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=Z;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function se(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=se;function ue(te,le){if(te.length<le)return te;const he=/\b/g;let me=0;for(;he.test(te)&&!(te.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ue;const de=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(de,""),te=te.replace(ve,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Oe(te){return Pe(te)?te.substr(1):te}e.stripUTF8BOM=Oe;function $e(te,le){if(!te||!le||te.length<le.length)return!1;const he=le.length,me=te.toLowerCase();let Se=0,Ce=-1;for(;Se<he;){const De=me.indexOf(le[Se],Ce+1);if(De<0)return!1;Ce=De,Se++}return!0}e.fuzzyContains=$e;function Ve(te,le=!1){return te?(le&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ve;function Je(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Je;function ae(te,le=1){if(le===0)return"";let he=-1;do he=te.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?te:(te[he-1]==="\r"&&he--,te.substr(0,he))}e.getNLines=ae;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Le.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,le){return te===0?le!==5&&le!==7:te===2&&le===3?!1:te===4||te===2||te===3||le===4||le===2||le===3?!0:!(te===8&&(le===8||le===9||le===11||le===12)||(te===11||te===9)&&(le===9||le===10)||(te===12||te===10)&&le===10||le===5||le===13||le===7||te===1||te===13&&le===14||te===6&&le===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}Le._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(te,le){if(te===0)return 0;const he=_e(te,le);if(he!==void 0)return he;const me=new K(le,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ne;function _e(te,le){const he=new K(le,te);let me=he.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!se(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function Me(te){return 127995<=te&&te<=127999}var We;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(le){return ke.cache.get(Array.from(le))}static getLocales(){return ke._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function le(Te){const qe=new Map;for(let Be=0;Be<Te.length;Be+=2)qe.set(Te[Be],Te[Be+1]);return qe}function he(Te,qe){const Be=new Map(Te);for(const[Ze,et]of qe)Be.set(Ze,et);return Be}function me(Te,qe){if(!Te)return qe;const Be=new Map;for(const[Ze,et]of Te)qe.has(Ze)&&Be.set(Ze,et);return Be}const Se=R.ambiguousCharacterData.getValue();let Ce=te.filter(Te=>!Te.startsWith("_")&&Te in Se);Ce.length===0&&(Ce=["_default"]);let De;for(const Te of Ce){const qe=le(Se[Te]);De=me(De,qe)}const ze=le(Se._common),Fe=he(ze,De);return new ke(Fe)}),ke._locales=new t.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(le){return Ae.getData().has(le)}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae,Ae._data=void 0}),define(ne[47],re([0,1,10,4,27,15]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function E(s,h=D.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(T(g)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let A=3;const F=A;for(;A<a&&!T(s.charCodeAt(A));A++);if(F!==A&&!T(s.charCodeAt(A+1))){for(A+=1;A<a;A++)if(T(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,h)}}return h}else if(u(g)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+h:s.slice(0,2);let w=s.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(T(s.charCodeAt(w)))return s.slice(0,w+1)}return""}e.getRoot=E;function C(s){if(!t.isWindows||!s||s.length<5)return!1;let h=s.charCodeAt(0);if(h!==92||(h=s.charCodeAt(1),h!==92))return!1;let a=2;const g=a;for(;a<s.length&&(h=s.charCodeAt(a),h!==92);a++);return!(g===a||(h=s.charCodeAt(a+1),isNaN(h)||h===92))}e.isUNC=C;const b=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,h=t.isWindows){const a=h?b:S;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||h&&p.test(s)||s==="."||s===".."||h&&s[s.length-1]==="."||h&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function v(s,h,a){const g=s===h;return!a||g?g:!s||!h?!1:(0,R.equalsIgnoreCase)(s,h)}e.isEqual=v;function y(s,h,a,g=D.sep){if(s===h)return!0;if(!s||!h||h.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,h))return!1;if(h.length===s.length)return!0;let A=h.length;return h.charAt(h.length-1)===g&&A--,s.charAt(A)===g}return h.charAt(h.length-1)!==g&&(h+=g),s.indexOf(h)===0}e.isEqualOrParent=y;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function m(s,h){return t.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(h,s)),s=(0,D.normalize)(s),t.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=m;function c(s){const h=(0,D.normalize)(s);return t.isWindows?s.length>3?!1:d(h)&&(s.length===2||h.charCodeAt(2)===92):h===D.posix.sep}e.isRootOrDriveLetter=c;function d(s,h=t.isWindows){return h?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(s){return d(s)?s[0]:void 0}e.getDriveLetter=l;function n(s,h,a){return h.length>s.length?-1:s===h?0:(a&&(s=s.toLowerCase(),h=h.toLowerCase()),s.indexOf(h))}e.indexOfPath=n;function r(s){const h=s.split(":");let a,g,w;for(const A of h){const F=Number(A);(0,L.isNumber)(F)?g===void 0?g=F:w===void 0&&(w=F):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:w!==void 0?w:g!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(s,h,a=8){let g="";for(let A=0;A<a;A++)g+=i.charAt(Math.floor(Math.random()*i.length));let w;return h?w=`${h}-${g}`:w=g,s?(0,D.join)(s,w):w}e.randomPath=o}),define(ne[66],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return R(u,0)}e.hash=t;function R(u,m){switch(typeof u){case"object":return u===null?L(349,m):Array.isArray(u)?I(u,m):E(u,m);case"string":return P(u,m);case"boolean":return T(u,m);case"number":return L(u,m);case"undefined":return L(937,m);default:return L(617,m)}}e.doHash=R;function L(u,m){return(m<<5)-m+u|0}e.numberHash=L;function T(u,m){return L(u?433:863,m)}function P(u,m){m=L(149417,m);for(let c=0,d=u.length;c<d;c++)m=L(u.charCodeAt(c),m);return m}e.stringHash=P;function I(u,m){return m=L(104579,m),u.reduce((c,d)=>R(d,c),m)}function E(u,m){return m=L(181387,m),Object.keys(u).sort().reduce((c,d)=>(c=P(d,c),R(u[d],c)),m)}class C{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=R(m,this._value),this._value}}e.Hasher=C;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function S(u,m,c=32){const d=c-m,l=~((1<<d)-1);return(u<<m|(l&u)>>>d)>>>0}function p(u,m=0,c=u.byteLength,d=0){for(let l=0;l<c;l++)u[m+l]=d}function f(u,m,c="0"){for(;u.length<m;)u=c+u;return u}function v(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),m/4)}e.toHexString=v;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const c=m.length;if(c===0)return;const d=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=m.charCodeAt(0),i=0);;){let o=r;if(D.isHighSurrogate(r))if(i+1<c){const s=m.charCodeAt(i+1);D.isLowSurrogate(s)?(i++,o=D.computeCodePoint(r,s)):o=65533}else{n=r;break}else D.isLowSurrogate(r)&&(o=65533);if(l=this._push(d,l,o),i++,i<c)r=m.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(m,c,d){return d<128?m[c++]=d:d<2048?(m[c++]=192|(d&1984)>>>6,m[c++]=128|(d&63)>>>0):d<65536?(m[c++]=224|(d&61440)>>>12,m[c++]=128|(d&4032)>>>6,m[c++]=128|(d&63)>>>0):(m[c++]=240|(d&1835008)>>>18,m[c++]=128|(d&258048)>>>12,m[c++]=128|(d&4032)>>>6,m[c++]=128|(d&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=y._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)m.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)m.setUint32(a,S(m.getUint32(a-12,!1)^m.getUint32(a-32,!1)^m.getUint32(a-56,!1)^m.getUint32(a-64,!1),1),!1);let d=this._h0,l=this._h1,n=this._h2,r=this._h3,i=this._h4,o,s,h;for(let a=0;a<80;a++)a<20?(o=l&n|~l&r,s=1518500249):a<40?(o=l^n^r,s=1859775393):a<60?(o=l&n|l&r|n&r,s=2400959708):(o=l^n^r,s=3395469782),h=S(d,5)+o+i+s+m.getUint32(a*4,!1)&4294967295,i=r,r=n,n=S(l,30),l=d,d=h;this._h0=this._h0+d&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[87],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(t||(t={})),function(R){const L="error",T="warning",P="warn",I="info",E="ignore";function C(S){return S?D.equalsIgnoreCase(L,S)?R.Error:D.equalsIgnoreCase(T,S)||D.equalsIgnoreCase(P,S)?R.Warning:D.equalsIgnoreCase(I,S)?R.Info:R.Ignore:R.Ignore}R.fromValue=C;function b(S){switch(S){case R.Error:return L;case R.Warning:return T;case R.Info:return I;default:return E}}R.toString=b}(t||(t={})),e.default=t}),define(ne[48],re([0,1,18,27]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(p){return this._value=p,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(p){const f=p.charCodeAt(0),v=this._value.charCodeAt(this._pos);return f-v}value(){return this._value[this._pos]}}e.StringIterator=R;class L{constructor(p=!0){this._caseSensitive=p}reset(p){return this._value=p,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let p=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(p)this._from++;else break;else p=!1;return this}cmp(p){return this._caseSensitive?(0,t.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class T{constructor(p=!0,f=!0){this._splitOnBackslash=p,this._caseSensitive=f}reset(p){this._from=0,this._to=0,this._value=p,this._valueLen=p.length;for(let f=p.length-1;f>=0;f--,this._valueLen--){const v=this._value.charCodeAt(f);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let p=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(p)this._from++;else break;else p=!1}return this}cmp(p){return this._caseSensitive?(0,t.compareSubstring)(p,this._value,0,p.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(p,this._value,0,p.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var P;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(p,f){this._ignorePathCasing=p,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(p){return this._value=p,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(p)),this._pathIterator.reset(p.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(p)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(p){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(p,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(p,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(p);if(this._states[this._stateIdx]===4)return(0,t.compare)(p,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(p,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(C||(C={}));class b{static forUris(p=()=>!1,f=()=>!1){return new b(new I(p,f))}static forPaths(p=!1){return new b(new T(void 0,!p))}static forStrings(){return new b(new R)}static forConfigKeys(){return new b(new L)}constructor(p){this._iter=p}clear(){this._root=void 0}fill(p,f){if(f){const v=f.slice(0);(0,D.shuffle)(v);for(const y of v)this.set(y,p)}else{const v=p.slice(0);(0,D.shuffle)(v);for(const y of v)this.set(y[0],y[1])}}set(p,f){const v=this._iter.reset(p);let y;this._root||(this._root=new E,this._root.segment=v.value());const u=[];for(y=this._root;;){const c=v.cmp(y.segment);if(c>0)y.left||(y.left=new E,y.left.segment=v.value()),u.push([-1,y]),y=y.left;else if(c<0)y.right||(y.right=new E,y.right.segment=v.value()),u.push([1,y]),y=y.right;else if(v.hasNext())v.next(),y.mid||(y.mid=new E,y.mid.segment=v.value()),u.push([0,y]),y=y.mid;else break}const m=y.value;y.value=f,y.key=p;for(let c=u.length-1;c>=0;c--){const d=u[c][1];d.updateHeight();const l=d.balanceFactor();if(l<-1||l>1){const n=u[c][0],r=u[c+1][0];if(n===1&&r===1)u[c][1]=d.rotateLeft();else if(n===-1&&r===-1)u[c][1]=d.rotateRight();else if(n===1&&r===-1)d.right=u[c+1][1]=u[c+1][1].rotateRight(),u[c][1]=d.rotateLeft();else if(n===-1&&r===1)d.left=u[c+1][1]=u[c+1][1].rotateLeft(),u[c][1]=d.rotateRight();else throw new Error;if(c>0)switch(u[c-1][0]){case-1:u[c-1][1].left=u[c][1];break;case 1:u[c-1][1].right=u[c][1];break;case 0:u[c-1][1].mid=u[c][1];break}else this._root=u[0][1]}}return m}get(p){return this._getNode(p)?.value}_getNode(p){const f=this._iter.reset(p);let v=this._root;for(;v;){const y=f.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else break}return v}has(p){const f=this._getNode(p);return!(f?.value===void 0&&f?.mid===void 0)}delete(p){return this._delete(p,!1)}deleteSuperstr(p){return this._delete(p,!0)}_delete(p,f){const v=this._iter.reset(p),y=[];let u=this._root;for(;u;){const m=v.cmp(u.segment);if(m>0)y.push([-1,u]),u=u.left;else if(m<0)y.push([1,u]),u=u.right;else if(v.hasNext())v.next(),y.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this._min(u.right);if(m.key){const{key:c,value:d,segment:l}=m;this._delete(m.key,!1),u.key=c,u.value=d,u.segment=l}}else{const m=u.left??u.right;if(y.length>0){const[c,d]=y[y.length-1];switch(c){case-1:d.left=m;break;case 0:d.mid=m;break;case 1:d.right=m;break}}else this._root=m}for(let m=y.length-1;m>=0;m--){const c=y[m][1];c.updateHeight();const d=c.balanceFactor();if(d>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),y[m][1]=c.rotateLeft()):d<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),y[m][1]=c.rotateRight()),m>0)switch(y[m-1][0]){case-1:y[m-1][1].left=y[m][1];break;case 1:y[m-1][1].right=y[m][1];break;case 0:y[m-1][1].mid=y[m][1];break}else this._root=y[0][1]}}}_min(p){for(;p.left;)p=p.left;return p}findSubstr(p){const f=this._iter.reset(p);let v=this._root,y;for(;v;){const u=f.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(f.hasNext())f.next(),y=v.value||y,v=v.mid;else break}return v&&v.value||y}findSuperstr(p){const f=this._iter.reset(p);let v=this._root;for(;v;){const y=f.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else return v.mid?this._entries(v.mid):void 0}}forEach(p){for(const[f,v]of this)p(v,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(p){const f=[];return this._dfsEntries(p,f),f[Symbol.iterator]()}_dfsEntries(p,f){!p||(p.left&&this._dfsEntries(p.left,f),p.value&&f.push([p.key,p.value]),p.mid&&this._dfsEntries(p.mid,f),p.right&&this._dfsEntries(p.right,f))}_isBalanced(){const p=f=>{if(!f)return!0;const v=f.balanceFactor();return v<-1||v>1?!1:p(f.left)&&p(f.right)};return p(this._root)}}e.TernarySearchTree=b}),define(ne[7],re([0,1,10,4]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!R.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,o){return!i&&!o?"file":i}function E(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const C="",b="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(o){return o instanceof p?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,s,h,a,g,w=!1){typeof o=="object"?(this.scheme=o.scheme||C,this.authority=o.authority||C,this.path=o.path||C,this.query=o.query||C,this.fragment=o.fragment||C):(this.scheme=I(o,w),this.authority=s||C,this.path=E(this.scheme,h||C),this.query=a||C,this.fragment=g||C,P(this,w))}get fsPath(){return c(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:h,path:a,query:g,fragment:w}=o;return s===void 0?s=this.scheme:s===null&&(s=C),h===void 0?h=this.authority:h===null&&(h=C),a===void 0?a=this.path:a===null&&(a=C),g===void 0?g=this.query:g===null&&(g=C),w===void 0?w=this.fragment:w===null&&(w=C),s===this.scheme&&h===this.authority&&a===this.path&&g===this.query&&w===this.fragment?this:new v(s,h,a,g,w)}static parse(o,s=!1){const h=S.exec(o);return h?new v(h[2]||C,r(h[4]||C),r(h[5]||C),r(h[7]||C),r(h[9]||C),s):new v(C,C,C,C,C)}static file(o){let s=C;if(t.isWindows&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const h=o.indexOf(b,2);h===-1?(s=o.substring(2),o=b):(s=o.substring(2,h),o=o.substring(h)||b)}return new v("file",s,o,C,C)}static from(o){const s=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return P(s,!0),s}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return t.isWindows&&o.scheme==="file"?h=p.file(D.win32.join(c(o,!0),...s)).path:h=D.posix.join(o.path,...s),o.with({path:h})}toString(o=!1){return d(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof p)return o;{const s=new v(o);return s._formatted=o.external,s._fsPath=o._sep===f?o.fsPath:null,s}}else return o}}e.URI=p;const f=t.isWindows?1:void 0;class v extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(o=!1){return o?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=f),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,o){let s,h=-1;for(let a=0;a<i.length;a++){const g=i.charCodeAt(a);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||o&&g===47)h!==-1&&(s+=encodeURIComponent(i.substring(h,a)),h=-1),s!==void 0&&(s+=i.charAt(a));else{s===void 0&&(s=i.substr(0,a));const w=y[g];w!==void 0?(h!==-1&&(s+=encodeURIComponent(i.substring(h,a)),h=-1),s+=w):h===-1&&(h=a)}}return h!==-1&&(s+=encodeURIComponent(i.substring(h))),s!==void 0?s:i}function m(i){let o;for(let s=0;s<i.length;s++){const h=i.charCodeAt(s);h===35||h===63?(o===void 0&&(o=i.substr(0,s)),o+=y[h]):o!==void 0&&(o+=i[s])}return o!==void 0?o:i}function c(i,o){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function d(i,o){const s=o?m:u;let h="",{scheme:a,authority:g,path:w,query:A,fragment:F}=i;if(a&&(h+=a,h+=":"),(g||a==="file")&&(h+=b,h+=b),g){let _=g.indexOf("@");if(_!==-1){const N=g.substr(0,_);g=g.substr(_+1),_=N.indexOf(":"),_===-1?h+=s(N,!1):(h+=s(N.substr(0,_),!1),h+=":",h+=s(N.substr(_+1),!1)),h+="@"}g=g.toLowerCase(),_=g.indexOf(":"),_===-1?h+=s(g,!1):(h+=s(g.substr(0,_),!1),h+=g.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}h+=s(w,!0)}return A&&(h+="?",h+=s(A,!1)),F&&(h+="#",h+=o?F:u(F,!1)),h}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,o=>l(o)):i}}),define(ne[135],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const C=E;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function R(E){const C=[];let b;try{const S=JSON.parse(E.arguments),p=S[S.length-1];p&&p.__$stack&&(S.pop(),b=p.__$stack),C.push(...S)}catch{C.push("Unable to log remote console arguments",E.arguments)}return{args:C,stack:b}}e.parse=R;function L(E){if(typeof E!="string")return L(R(E).stack);const C=E;if(C){const b=T(C),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(S&&S.length===4)return{uri:D.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=L;function T(E){if(!E)return E;const C=E.indexOf(`
`);return C===-1?E:E.substring(0,C)}function P(E,C){const{args:b,stack:S}=R(E),p=typeof b[0]=="string"&&b.length===1;let f=T(S);f&&(f=`(${f.trim()})`);let v=[];if(typeof b[0]=="string"?f&&p?v=[`%c[${C}] %c${b[0]} %c${f}`,I("blue"),I(""),I("grey")]:v=[`%c[${C}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:v=[`%c[${C}]%`,I("blue"),...b],f&&!p&&v.push(f),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,v)}e.log=P;function I(E){return`color: ${E}`}}),define(ne[67],re([0,1,17,27,7]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(E){return JSON.stringify(E,P)}e.stringify=L;function T(E){let C=JSON.parse(E);return C=I(C),C}e.parse=T;function P(E,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function I(E,C=0){if(!E||C>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 15:return new Date(E.source)}if(E instanceof D.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let b=0;b<E.length;++b)E[b]=I(E[b],C+1);else for(const b in E)Object.hasOwnProperty.call(E,b)&&(E[b]=I(E[b],C+1))}return E}e.revive=I}),define(ne[22],re([0,1,4,7]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${R.vscodeRemoteResource}`}set(E,C,b){this._hosts[E]=C,this._ports[E]=b}setConnectionToken(E,C){this._connectionTokens[E]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const C=E.authority;let b=this._hosts[C];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const S=this._ports[C],p=this._connectionTokens[C];let f=`path=${encodeURIComponent(E.path)}`;return typeof p=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),t.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${S}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new L;class T{asBrowserUri(E,C){const b=this.toUri(E,C);return b.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(E,C){const b=this.toUri(E,C);return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==T.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(E,C){return t.URI.isUri(E)?E:t.URI.parse(C.toUrl(E))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var P;(function(I){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(E.get("3"));const C="vscode-coi";function b(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:t.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const v=f?.get(C);if(!!v)return E.get(v)}I.getHeadersFromQuery=b;function S(p,f,v){if(!globalThis.crossOriginIsolated)return;const y=f&&v?"3":v?"2":"1";p instanceof URLSearchParams?p.set(C,y):p[C]=y}I.addSearchParam=S})(P=e.COI||(e.COI={}))}),define(ne[19],re([0,1,47,22,10,4,27,7]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=I;class E{constructor(f){this._ignorePathCasing=f}compare(f,v,y=!1){return f===v?0:(0,T.compare)(this.getComparisonKey(f,y),this.getComparisonKey(v,y))}isEqual(f,v,y=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,y)===this.getComparisonKey(v,y)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,y=!1){if(f.scheme===v.scheme){if(f.scheme===t.Schemas.file)return D.isEqualOrParent(I(f),I(v),this._ignorePathCasing(f))&&f.query===v.query&&(y||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return D.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(y||f.fragment===v.fragment)}return!1}joinPath(f,...v){return P.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===t.Schemas.file?v=P.URI.file(R.dirname(I(f))).path:(v=R.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===t.Schemas.file?v=P.URI.file(R.normalize(I(f))).path:v=R.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===t.Schemas.file){const m=R.relative(I(f),I(v));return L.isWindows?D.toSlashes(m):m}let y=f.path||"/";const u=v.path||"/";if(this._ignorePathCasing(f)){let m=0;for(const c=Math.min(y.length,u.length);m<c&&!(y.charCodeAt(m)!==u.charCodeAt(m)&&y.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);y=u.substr(0,m)+y.substr(m)}return R.posix.relative(y,u)}resolvePath(f,v){if(f.scheme===t.Schemas.file){const y=P.URI.file(R.resolve(I(f),v));return f.with({authority:y.authority,path:y.path})}return v=D.toPosixPath(v),f.with({path:R.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,T.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=R.sep){if(f.scheme===t.Schemas.file){const y=I(f);return y.length>D.getRoot(y).length&&y[y.length-1]===v}else{const y=f.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=R.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=R.sep){let y=!1;if(f.scheme===t.Schemas.file){const u=I(f);y=u!==void 0&&u.length===D.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=f.path;y=u.length===1&&u.charCodeAt(u.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(p=>p.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new E(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(p,f){const v=[];for(let y=0;y<p.length;y++){const u=f(p[y]);p.some((m,c)=>c===y?!1:(0,e.isEqualOrParent)(u,f(m)))||v.push(p[y])}return v}e.distinctParents=C;var b;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(v){const y=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[d,l]=c.split(":");d&&l&&y.set(d,l)});const m=v.path.substring(0,v.path.indexOf(";"));return m&&y.set(p.META_DATA_MIME,m),y}p.parseMetaData=f})(b=e.DataUri||(e.DataUri={}));function S(p,f,v){if(f){let y=p.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),p.with({scheme:v,authority:f,path:y})}return p.with({scheme:v})}e.toLocalResource=S}),define(ne[6],re([0,1,24,9,3,2,19,4]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(H){return!!H&&typeof H.then=="function"}e.isThenable=I;function E(H){const O=new D.CancellationTokenSource,M=H(O.token),x=new Promise((G,ee)=>{const oe=O.token.onCancellationRequested(()=>{oe.dispose(),O.dispose(),ee(new t.CancellationError)});Promise.resolve(M).then(Z=>{oe.dispose(),O.dispose(),G(Z)},Z=>{oe.dispose(),O.dispose(),ee(Z)})});return new class{cancel(){O.cancel()}then(G,ee){return x.then(G,ee)}catch(G){return this.then(void 0,G)}finally(G){return x.finally(G)}}}e.createCancelablePromise=E;function C(H,O,M){return new Promise((x,G)=>{const ee=O.onCancellationRequested(()=>{ee.dispose(),x(M)});H.then(x,G).finally(()=>ee.dispose())})}e.raceCancellation=C;function b(H,O){return new Promise((M,x)=>{const G=O.onCancellationRequested(()=>{G.dispose(),x(new t.CancellationError)});H.then(M,x).finally(()=>G.dispose())})}e.raceCancellationError=b;async function S(H){let O=-1;const M=H.map((G,ee)=>G.then(oe=>(O=ee,oe))),x=await Promise.race(M);return H.forEach((G,ee)=>{ee!==O&&G.cancel()}),x}e.raceCancellablePromises=S;function p(H,O,M){let x;const G=setTimeout(()=>{x?.(void 0),M?.()},O);return Promise.race([H.finally(()=>clearTimeout(G)),new Promise(ee=>x=ee)])}e.raceTimeout=p;function f(H){return new Promise((O,M)=>{const x=H();I(x)?x.then(O,M):O(x)})}e.asPromise=f;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(M,M).then(x)})}return new Promise((M,x)=>{this.queuedPromise.then(M,x)})}return this.activePromise=O(),new Promise((M,x)=>{this.activePromise.then(G=>{this.activePromise=null,M(G)},G=>{this.activePromise=null,x(G)})})}}e.Throttler=v;class y{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=y;class u{constructor(){this.promiseMap=new Map}queue(O,M){const G=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(O)===G&&this.promiseMap.delete(O)});return this.promiseMap.set(O,G),G}}e.SequencerByKey=u;const m=(H,O)=>{let M=!0;const x=setTimeout(()=>{M=!1,O()},H);return{isTriggered:()=>M,dispose:()=>{clearTimeout(x),M=!1}}},c=H=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,H())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,M=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ee)=>{this.doResolve=G,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?c(x):m(M,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class l{constructor(O){this.delayer=new d(O),this.throttler=new v}trigger(O,M){return this.delayer.trigger(()=>this.throttler.queue(O),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class n{constructor(){this._isOpen=!1,this._promise=new Promise((O,M)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(H,O){return O?new Promise((M,x)=>{const G=setTimeout(()=>{ee.dispose(),M()},H),ee=O.onCancellationRequested(()=>{clearTimeout(G),ee.dispose(),x(new t.CancellationError)})}):E(M=>i(H,M))}e.timeout=i;function o(H,O=0){const M=setTimeout(H,O);return(0,L.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=o;function s(H){const O=[];let M=0;const x=H.length;function G(){return M<x?H[M++]():null}function ee(oe){oe!=null&&O.push(oe);const Z=G();return Z?Z.then(ee):Promise.resolve(O)}return Promise.resolve(null).then(ee)}e.sequence=s;function h(H,O=x=>!!x,M=null){let x=0;const G=H.length,ee=()=>{if(x>=G)return Promise.resolve(M);const oe=H[x++];return Promise.resolve(oe()).then(ie=>O(ie)?Promise.resolve(ie):ee())};return ee()}e.first=h;function a(H,O=x=>!!x,M=null){if(H.length===0)return Promise.resolve(M);let x=H.length;const G=()=>{x=-1;for(const ee of H)ee.cancel?.()};return new Promise((ee,oe)=>{for(const Z of H)Z.then(ie=>{--x>=0&&O(ie)?(G(),ee(ie)):x===0&&ee(M)}).catch(ie=>{--x>=0&&(G(),oe(ie))})})}e.firstParallel=a;class g{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((M,x)=>{this.outstandingPromises.push({factory:O,c:M,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class w extends g{constructor(){super(1)}}e.Queue=w;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new z;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,M=T.extUri){const x=M.getComparisonKey(O);let G=this.queues.get(x);return G||(G=new w,R.Event.once(G.onDrained)(()=>{G?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,G)),G}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class F{constructor(O,M){this._token=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},M)}setIfNotSet(O,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},M))}}e.TimeoutTimer=F;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setInterval(()=>{O()},M)}}e.IntervalTimer=_;class N{constructor(O,M){this.timeoutToken=-1,this.runner=O,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class W{constructor(O,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=W;class k extends N{constructor(O,M){super(O,M),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class U extends L.Disposable{constructor(O,M){super(),this.options=O,this.handler=M,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{(0,P.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(H,O)=>{const M=requestIdleCallback(H,typeof O=="number"?{timeout:O}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(M))}}}}();class ${constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function Y(H,O,M){let x;for(let G=0;G<M;G++)try{return await H()}catch(ee){x=ee,await i(O)}throw x}e.retry=Y;class q{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(O,M,x){return this._pending={taskId:O,cancel:()=>x?.(),promise:M},M.then(()=>this.donePending(O),()=>this.donePending(O)),M}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let M,x;const G=new Promise((ee,oe)=>{M=ee,x=oe});this._next={run:O,promise:G,promiseResolve:M,promiseReject:x}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=q;class V{constructor(O,M=()=>Date.now()){this.interval=O,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,M)=>{this.completeCallback=O,this.errorCallback=M})}complete(O){return new Promise(M=>{this.completeCallback(O),this.resolved=!0,M()})}error(O){return new Promise(M=>{this.errorCallback(O),this.rejected=!0,M()})}cancel(){new Promise(O=>{this.errorCallback(new t.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=z;var j;(function(H){async function O(x){let G;const ee=await Promise.all(x.map(oe=>oe.then(Z=>Z,Z=>{G||(G=Z)})));if(typeof G<"u")throw G;return ee}H.settled=O;function M(x){return new Promise(async(G,ee)=>{try{await x(G,ee)}catch(oe){ee(oe)}})}H.withAsyncBody=M})(j=e.Promises||(e.Promises={}));var K;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(K||(K={}));class X{static fromArray(O){return new X(M=>{M.emitMany(O)})}static fromPromise(O){return new X(async M=>{M.emitMany(await O)})}static fromPromises(O){return new X(async M=>{await Promise.all(O.map(async x=>M.emitOne(await x)))})}static merge(O){return new X(async M=>{await Promise.all(O.map(async x=>{for await(const G of x)M.emitOne(G)}))})}constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(O(M)),this.resolve()}catch(x){this.reject(x)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,M){return new X(async x=>{for await(const G of O)x.emitOne(M(G))})}map(O){return X.map(this,O)}static filter(O,M){return new X(async x=>{for await(const G of O)M(G)&&x.emitOne(G)})}filter(O){return X.filter(this,O)}static coalesce(O){return X.filter(O,M=>!!M)}coalesce(){return X.coalesce(this)}static async toPromise(O){const M=[];for await(const x of O)M.push(x);return M}toPromise(){return X.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ce extends X{constructor(O,M){super(M),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function B(H){const O=new D.CancellationTokenSource,M=H(O.token);return new ce(O,async x=>{const G=O.token.onCancellationRequested(()=>{G.dispose(),O.dispose(),x.reject(new t.CancellationError)});try{for await(const ee of M){if(O.token.isCancellationRequested)return;x.emitOne(ee)}G.dispose(),O.dispose()}catch(ee){G.dispose(),O.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=B}),define(ne[88],re([0,1,18,6,47,40,10,4,27]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",b="[^/\\\\]",S=/\//g;function p(z,j){switch(z){case 0:return"";case 1:return`${b}*?`;default:return`(?:${C}|${b}+${C}${j?`|${C}${b}+`:""})*?`}}function f(z,j){if(!z)return[];const K=[];let X=!1,ce=!1,B="";for(const H of z){switch(H){case j:if(!X&&!ce){K.push(B),B="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}B+=H}return B&&K.push(B),K}e.splitGlobAware=f;function v(z){if(!z)return"";let j="";const K=f(z,e.GLOB_SPLIT);if(K.every(X=>X===e.GLOBSTAR))j=".*";else{let X=!1;K.forEach((ce,B)=>{if(ce===e.GLOBSTAR){if(X)return;j+=p(2,B===K.length-1)}else{let H=!1,O="",M=!1,x="";for(const G of ce){if(G!=="}"&&H){O+=G;continue}if(M&&(G!=="]"||!x)){let ee;G==="-"?ee=G:(G==="^"||G==="!")&&!x?ee="^":G===e.GLOB_SPLIT?ee="":ee=(0,I.escapeRegExpCharacters)(G),x+=ee;continue}switch(G){case"{":H=!0;continue;case"[":M=!0;continue;case"}":{j+=`(?:${f(O,",").map(Z=>v(Z)).join("|")})`,H=!1,O="";break}case"]":{j+="["+x+"]",M=!1,x="";break}case"?":j+=b;continue;case"*":j+=p(1);continue;default:j+=(0,I.escapeRegExpCharacters)(G)}}B<K.length-1&&(K[B+1]!==e.GLOBSTAR||B+2<K.length)&&(j+=C)}X=ce===e.GLOBSTAR})}return j}const y=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(z,j){if(!z)return i;let K;typeof z!="string"?K=z.pattern:K=z,K=K.trim();const X=`${K}_${!!j.trimForExclusions}`;let ce=n.get(X);if(ce)return s(ce,z);let B;return y.test(K)?ce=a(K.substr(4),K):(B=u.exec(h(K,j)))?ce=g(B[1],K):(j.trimForExclusions?c:m).test(K)?ce=w(K,j):(B=d.exec(h(K,j)))?ce=A(B[1].substr(1),K,!0):(B=l.exec(h(K,j)))?ce=A(B[1],K,!1):ce=F(K),n.set(X,ce),s(ce,z)}function s(z,j){if(typeof j=="string")return z;const K=function(X,ce){return(0,R.isEqualOrParent)(X,j.base,!P.isLinux)?z(X.substr(j.base.length+1),ce):null};return K.allBasenames=z.allBasenames,K.allPaths=z.allPaths,K.basenames=z.basenames,K.patterns=z.patterns,K}function h(z,j){return j.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function a(z,j){return function(K,X){return typeof K=="string"&&K.endsWith(z)?j:null}}function g(z,j){const K=`/${z}`,X=`\\${z}`,ce=function(H,O){return typeof H!="string"?null:O?O===z?j:null:H===z||H.endsWith(K)||H.endsWith(X)?j:null},B=[z];return ce.basenames=B,ce.patterns=[j],ce.allBasenames=B,ce}function w(z,j){const K=q(z.slice(1,-1).split(",").map(O=>o(O,j)).filter(O=>O!==i),z),X=K.length;if(!X)return i;if(X===1)return K[0];const ce=function(O,M){for(let x=0,G=K.length;x<G;x++)if(K[x](O,M))return z;return null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const H=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return H.length&&(ce.allPaths=H),ce}function A(z,j,K){const X=T.sep===T.posix.sep,ce=X?z:z.replace(S,T.sep),B=T.sep+ce,H=T.posix.sep+z;let O;return K?O=function(M,x){return typeof M=="string"&&(M===ce||M.endsWith(B)||!X&&(M===z||M.endsWith(H)))?j:null}:O=function(M,x){return typeof M=="string"&&(M===ce||!X&&M===z)?j:null},O.allPaths=[(K?"*/":"./")+z],O}function F(z){try{const j=new RegExp(`^${v(z)}$`);return function(K){return j.lastIndex=0,typeof K=="string"&&j.test(K)?z:null}}catch{return i}}function _(z,j,K){return!z||typeof j!="string"?!1:N(z)(j,void 0,K)}e.match=_;function N(z,j={}){if(!z)return r;if(typeof z=="string"||W(z)){const K=o(z,j);if(K===i)return r;const X=function(ce,B){return!!K(ce,B)};return K.allBasenames&&(X.allBasenames=K.allBasenames),K.allPaths&&(X.allPaths=K.allPaths),X}return $(z,j)}e.parse=N;function W(z){const j=z;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=W;function k(z){return z.allBasenames||[]}e.getBasenameTerms=k;function U(z){return z.allPaths||[]}e.getPathTerms=U;function $(z,j){const K=q(Object.getOwnPropertyNames(z).map(O=>Y(O,z[O],j)).filter(O=>O!==i)),X=K.length;if(!X)return i;if(!K.some(O=>!!O.requiresSiblings)){if(X===1)return K[0];const O=function(G,ee){let oe;for(let Z=0,ie=K.length;Z<ie;Z++){const se=K[Z](G,ee);if(typeof se=="string")return se;(0,t.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const Z of oe){const ie=await Z;if(typeof ie=="string")return ie}return null})():null},M=K.find(G=>!!G.allBasenames);M&&(O.allBasenames=M.allBasenames);const x=K.reduce((G,ee)=>ee.allPaths?G.concat(ee.allPaths):G,[]);return x.length&&(O.allPaths=x),O}const ce=function(O,M,x){let G,ee;for(let oe=0,Z=K.length;oe<Z;oe++){const ie=K[oe];ie.requiresSiblings&&x&&(M||(M=(0,T.basename)(O)),G||(G=M.substr(0,M.length-(0,T.extname)(O).length)));const se=ie(O,M,G,x);if(typeof se=="string")return se;(0,t.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const oe of ee){const Z=await oe;if(typeof Z=="string")return Z}return null})():null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const H=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return H.length&&(ce.allPaths=H),ce}function Y(z,j,K){if(j===!1)return i;const X=o(z,K);if(X===i)return i;if(typeof j=="boolean")return X;if(j){const ce=j.when;if(typeof ce=="string"){const B=(H,O,M,x)=>{if(!x||!X(H,O))return null;const G=ce.replace("$(basename)",M),ee=x(G);return(0,t.isThenable)(ee)?ee.then(oe=>oe?z:null):ee?z:null};return B.requiresSiblings=!0,B}}return X}function q(z,j){const K=z.filter(O=>!!O.basenames);if(K.length<2)return z;const X=K.reduce((O,M)=>{const x=M.basenames;return x?O.concat(x):O},[]);let ce;if(j){ce=[];for(let O=0,M=X.length;O<M;O++)ce.push(j)}else ce=K.reduce((O,M)=>{const x=M.patterns;return x?O.concat(x):O},[]);const B=function(O,M){if(typeof O!="string")return null;if(!M){let G;for(G=O.length;G>0;G--){const ee=O.charCodeAt(G-1);if(ee===47||ee===92)break}M=O.substr(G)}const x=X.indexOf(M);return x!==-1?ce[x]:null};B.basenames=X,B.patterns=ce,B.allBasenames=X;const H=z.filter(O=>!O.basenames);return H.push(B),H}function V(z,j){return(0,D.equals)(z,j,(K,X)=>typeof K=="string"&&typeof X=="string"?K===X:typeof K!="string"&&typeof X!="string"?K.base===X.base&&K.pattern===X.pattern:!1)}e.patternsEquals=V}),define(ne[136],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class R{constructor(b){this._uriTransformer=b}transformIncoming(b){const S=this._uriTransformer.transformIncoming(b);return S===b?b:t(D.URI.from(S))}transformOutgoing(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:t(D.URI.from(S))}transformOutgoingURI(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:D.URI.from(S)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function L(C,b,S){if(!C||S>200)return null;if(typeof C=="object"){if(C instanceof D.URI)return b.transformOutgoing(C);for(const p in C)if(Object.hasOwnProperty.call(C,p)){const f=L(C[p],b,S+1);f!==null&&(C[p]=f)}}return null}function T(C,b){const S=L(C,b,0);return S===null?C:S}e.transformOutgoingURIs=T;function P(C,b,S,p){if(!C||p>200)return null;if(typeof C=="object"){if(C.$mid===1)return S?D.URI.revive(b.transformIncoming(C)):b.transformIncoming(C);for(const f in C)if(Object.hasOwnProperty.call(C,f)){const v=P(C[f],b,S,p+1);v!==null&&(C[f]=v)}}return null}function I(C,b){const S=P(C,b,!1,0);return S===null?C:S}e.transformIncomingURIs=I;function E(C,b){const S=P(C,b,!0,0);return S===null?C:S}e.transformAndReviveIncomingURIs=E}),define(ne[137],re([0,1,34,9,48,30,123]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,b=0;const S=(0,D.networkInterfaces)();for(const p in S){const f=S[p];if(f)for(const{mac:v,internal:y}of f)y||(b+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(C+=1))}this._value=b>0?C/b:0}return this._value}};let P;async function I(){return P||(P=(async()=>await E()||L.generateUuid())()),P}e.getMachineId=I;async function E(){try{const C=await new Promise((S,p)=>{Q(["crypto"],S,p)}),b=(0,T.getMac)();return C.createHash("sha256").update(b,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(ne[28],re([0,1,55,34,279,6,47,83,10,4,19,7]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function p($,Y=S.UNLINK){if((0,T.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return Y===S.UNLINK?v($):f($)}async function f($){try{const Y=(0,T.randomPath)((0,t.tmpdir)());try{await D.promises.rename($,Y)}catch(q){return q.code==="ENOENT"?void 0:v($)}v(Y).catch(q=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function v($){return(0,R.promisify)(D.rm)($,{recursive:!0,force:!0,maxRetries:3})}function y($){if((0,T.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function u($,Y){return d(await(Y?m($):(0,R.promisify)(D.readdir)($)))}async function m($){try{return await(0,R.promisify)(D.readdir)($,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const Y=[],q=await u($);for(const V of q){let z=!1,j=!1,K=!1;try{const X=await e.Promises.lstat((0,I.join)($,V));z=X.isFile(),j=X.isDirectory(),K=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}Y.push({name:V,isFile:()=>z,isDirectory:()=>j,isSymbolicLink:()=>K})}return Y}function c($){return d(D.readdirSync($))}e.readdirSync=c;function d($){return $.map(Y=>typeof Y=="string"?E.isMacintosh?(0,P.normalizeNFC)(Y):Y:(Y.name=E.isMacintosh?(0,P.normalizeNFC)(Y.name):Y.name,Y))}async function l($){const Y=await u($),q=[];for(const V of Y)await r.existsDirectory((0,I.join)($,V))&&q.push(V);return q}function n($,Y=1e3){return new Promise(q=>{let V=!1;const z=setInterval(()=>{V||(V=!0,D.access($,j=>{V=!1,j&&(clearInterval(z),q(void 0))}))},Y)})}e.whenDeleted=n;var r;(function($){async function Y(z){let j;try{if(j=await e.Promises.lstat(z),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(E.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw X}throw K}}$.stat=Y;async function q(z){try{const{stat:j,symbolicLink:K}=await $.stat(z);return j.isFile()&&K?.dangling!==!0}catch{}return!1}$.existsFile=q;async function V(z){try{const{stat:j,symbolicLink:K}=await $.stat(z);return j.isDirectory()&&K?.dangling!==!0}catch{}return!1}$.existsDirectory=V})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function o($,Y,q){return i.queueFor(b.URI.file($),C.extUriBiasedIgnorePathCase).queue(()=>{const V=w(q);return new Promise((z,j)=>a($,Y,V,K=>K?j(K):z()))})}let s=!0;function h($){s=$}e.configureFlushOnWrite=h;function a($,Y,q,V){if(!s)return D.writeFile($,Y,{mode:q.mode,flag:q.flag},V);D.open($,q.flag,q.mode,(z,j)=>{if(z)return V(z);D.writeFile(j,Y,K=>{if(K)return D.close(j,()=>V(K));D.fdatasync(j,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),h(!1)),D.close(j,ce=>V(ce))))})})}function g($,Y,q){const V=w(q);if(!s)return D.writeFileSync($,Y,{mode:V.mode,flag:V.flag});const z=D.openSync($,V.flag,V.mode);try{D.writeFileSync(z,Y);try{D.fdatasyncSync(z)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),h(!1)}}finally{D.closeSync(z)}}e.writeFileSync=g;function w($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function A($,Y){if($!==Y)try{await e.Promises.rename($,Y)}catch(q){if($.toLowerCase()!==Y.toLowerCase()&&q.code==="EXDEV"||$.endsWith("."))await F($,Y,{preserveSymlinks:!1}),await p($,S.MOVE);else throw q}}async function F($,Y,q){return N($,Y,{root:{source:$,target:Y},options:q,handledSourcePaths:new Set})}const _=511;async function N($,Y,q){if(q.handledSourcePaths.has($))return;q.handledSourcePaths.add($);const{stat:V,symbolicLink:z}=await r.stat($);if(z){if(q.options.preserveSymlinks)try{return await U($,Y,q)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(z.dangling)return}return V.isDirectory()?W($,Y,V.mode&_,q):k($,Y,V.mode&_)}async function W($,Y,q,V){await e.Promises.mkdir(Y,{recursive:!0,mode:q});const z=await u($);for(const j of z)await N((0,I.join)($,j),(0,I.join)(Y,j),V)}async function k($,Y,q){await e.Promises.copyFile($,Y),await e.Promises.chmod(Y,q)}async function U($,Y,q){let V=await e.Promises.readlink($);(0,T.isEqualOrParent)(V,q.root.source,!E.isLinux)&&(V=(0,I.join)(q.root.target,V.substr(q.root.source.length+1))),await e.Promises.symlink(V,Y)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return($,Y,q,V,z)=>new Promise((j,K)=>{D.read($,Y,q,V,z,(X,ce,B)=>X?K(X):j({bytesRead:ce,buffer:B}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return($,Y,q,V,z)=>new Promise((j,K)=>{D.write($,Y,q,V,z,(X,ce,B)=>X?K(X):j({bytesWritten:ce,buffer:B}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return o}get rm(){return p}get move(){return A}get copy(){return F}}}),define(ne[138],re([0,1,55,10,4,27,28]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(S){if(R.isLinux)return S;const p=(0,t.dirname)(S);if(S===p)return S;const f=((0,t.basename)(S)||S).toLowerCase();try{const y=(0,T.readdirSync)(p).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=P(p);if(u)return(0,t.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const m=P(p);if(m)return(0,t.join)(m,y[u])}}}catch{}return null}e.realcaseSync=P;async function I(S){if(R.isLinux)return S;const p=(0,t.dirname)(S);if(S===p)return S;const f=((0,t.basename)(S)||S).toLowerCase();try{const y=(await T.Promises.readdir(p)).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=await I(p);if(u)return(0,t.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const m=await I(p);if(m)return(0,t.join)(m,y[u])}}}catch{}return null}e.realcase=I;async function E(S){try{return await T.Promises.realpath(S)}catch{const f=b(S);return await T.Promises.access(f,D.constants.R_OK),f}}e.realpath=E;function C(S){try{return D.realpathSync(S)}catch{const f=b(S);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=C;function b(S){return(0,L.rtrim)((0,t.normalize)(S),t.sep)}}),define(ne[89],re([0,1,34,10,28]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(I||(I={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class b{constructor(l,n,r){this.exePath=l,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:d=!1}={}){return d?E===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:d=!1,findPreview:l=!1}={}){const n=S({useAlternateBitness:d});if(!n)return null;const r=t.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const a of await R.Promises.readdir(r)){let g=-1;if(l){const A=a.indexOf("-");if(A<0)continue;const F=a.substring(0,A);if(!L.test(F)||a.substring(A+1)!=="preview")continue;g=parseInt(F,10)}else{if(!L.test(a))continue;g=parseInt(a,10)}if(g<=i)continue;const w=t.join(r,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(w)||(o=w,i=g)}if(!o)return null;const s=n.includes("x86")?" (x86)":"",h=l?" Preview":"";return new b(o,`PowerShell${h}${s}`,!0)}async function f({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=d?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(l))if(n.test(i)){const o=t.join(l,i,"pwsh.exe");return new b(o,r)}return null}function v(){const d=t.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(d,".NET Core PowerShell Global Tool")}function y(){const d=t.join(process.env.windir,E===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(d,"Windows PowerShell",!0)}async function*u(){let d=await p();d&&(yield d),d=await p({useAlternateBitness:!0}),d&&(yield d),d=await f(),d&&(yield d),d=v(),d&&(yield d),d=await p({findPreview:!0}),d&&(yield d),d=await f({findPreview:!0}),d&&(yield d),d=await p({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=y(),d&&(yield d)}async function*m(){for await(const d of u())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=m;async function c(){for await(const d of m())return d;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ne[90],re([0,1,10,4,36,85,15,28]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function I(b=R.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function E(b){let S=[],p=!1;const f=function(v){if(p){S.push(v);return}(!b.send(v,u=>{if(u&&console.error(u),p=!1,S.length>0){const m=S.slice(0);S=[],m.forEach(c=>f(c))}})||t.isWindows)&&(p=!0)};return{send:f}}e.createQueuedSender=E;var C;(function(b){async function S(p,f,v){if(D.isAbsolute(p))return p;if(f===void 0&&(f=R.cwd()),D.dirname(p)!=="."||(v===void 0&&T.isString(R.env.PATH)&&(v=R.env.PATH.split(D.delimiter)),v===void 0||v.length===0))return D.join(f,p);async function u(m){if(await P.Promises.exists(m)){let c;try{c=await P.Promises.stat(m)}catch(d){d.message.startsWith("EACCES")&&(c=await P.Promises.lstat(m))}return c?!c.isDirectory():!1}return!1}for(const m of v){let c;if(D.isAbsolute(m)?c=D.join(m,p):c=D.join(f,m,p),await u(c))return c;let d=c+".com";if(await u(d)||(d=c+".exe",await u(d)))return d}return D.join(f,p)}b.findExecutable=S})(C=e.win32||(e.win32={}))}),define(ne[139],re([0,1,49,22]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(T){return new Promise((P,I)=>{let E;const C=new Map;function b(p,f,v,y,u){const m=C.get(f);if(p===T||m){const c={name:S(v),cmd:v,pid:p,ppid:f,load:y,mem:u};C.set(p,c),p===T&&(E=c),m&&(m.children||(m.children=[]),m.children.push(c),m.children.length>1&&(m.children=m.children.sort((d,l)=>d.pid-l.pid)))}}function S(p){const f=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,d=/\\pipe\\winpty-control/,l=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(c.exec(p))return"electron-crash-reporter";if(d.exec(p))return"winpty-process";if(l.exec(p))return"console-window-host (Windows internal process)";let r=n.exec(p);if(r&&r.length===2){if(r[1]==="renderer")return f.exec(p)?"shared-process":v.exec(p)?"issue-reporter":y.exec(p)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(p))return"utility-network-service";if(m.exec(p))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let o="";do r=i.exec(p),r&&(o+=r+" ");while(r);return o&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${o}`:p}if(process.platform==="win32"){const p=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,v)=>{Q(["windows-process-tree"],f,v)}).then(f=>{f.getProcessList(T,v=>{if(!v){I(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(v,y=>{const u=new Map;y.forEach(m=>{const c=p(m.commandLine||"");u.set(m.pid,{name:S(c),cmd:c,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),E=u.get(T),E?(u.forEach(m=>{const c=u.get(m.ppid);c&&(c.children||(c.children=[]),c.children.push(m))}),u.forEach(m=>{m.children&&(m.children=m.children.sort((c,d)=>c.pid-d.pid))}),P(E)):I(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let p=function(){let f=[E];const v=[];for(;f.length;){const u=f.shift();u&&(v.push(u.pid),u.children&&(f=f.concat(u.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);y+=" "+v.join(" "),(0,D.exec)(y,{},(u,m,c)=>{if(u||c)I(u||new Error(c.toString()));else{const d=m.toString().split(`
`);for(let l=0;l<v.length;l++){const n=C.get(v[l]);n.load=parseFloat(d[l])}if(!E){I(new Error(`Root process ${T} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(f,v,y)=>{if(f||y)if(process.platform!=="linux")I(f||new Error(y.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(u,{},(m,c,d)=>{m||d?I(m||new Error(d.toString())):(L(c,b),p())})}else{const u=v.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,d,l)=>{c||l&&!l.includes("screen size is bogus")?I(c||new Error(l.toString())):(L(d,b),process.platform==="linux"?p():E?P(E):I(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=R;function L(T,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const C of E){const b=I.exec(C.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ne[140],re([0,1,34,4,89,90]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(p,f){return p===1?t.isWindows?b():L.getWindowsShell(f):E(p,f)}e.getSystemShell=T;function P(p,f){return p===1?t.isWindows?S(f):L.getWindowsShell(f):E(p,f)}e.getSystemShellSync=P;let I=null;function E(p,f){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!I){let v;if(t.isWindows)v="/bin/bash";else{if(v=f.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}I=v}return I}let C=null;async function b(){return C||(C=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),C}function S(p){if(C)return C;const f=t.isWindows&&parseFloat((0,D.release)())>=10,v=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${p.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:L.getWindowsShell(p)}});var pe=this&&this.__decorate||function(Q,e,D,t){var R=arguments.length,L=R<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,D):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,D,t);else for(var P=Q.length-1;P>=0;P--)(T=Q[P])&&(L=(R<3?T(L):R>3?T(e,D,L):T(e,D))||L);return R>3&&L&&Object.defineProperty(e,D,L),L};define(ne[38],re([0,1,18,6,17,24,64,9,3,2,67,27,15]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function f(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function y(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(u||(u={}));class m{constructor(j){this.buffer=j,this.pos=0}read(j){const K=this.buffer.slice(this.pos,this.pos+j);return this.pos+=K.byteLength,K}}class c{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var d;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(d||(d={}));function l(z){const j=R.VSBuffer.alloc(4);return j.writeUInt32BE(z,0),j}function n(z){return z.read(4).readUInt32BE(0)}function r(z){const j=R.VSBuffer.alloc(1);return j.writeUInt8(z,0),j}const i={Undefined:r(d.Undefined),String:r(d.String),Buffer:r(d.Buffer),VSBuffer:r(d.VSBuffer),Array:r(d.Array),Object:r(d.Object)},o=typeof Buffer<"u";function s(z,j){if(typeof j>"u")z.write(i.Undefined);else if(typeof j=="string"){const K=R.VSBuffer.fromString(j);z.write(i.String),z.write(l(K.byteLength)),z.write(K)}else if(o&&Buffer.isBuffer(j)){const K=R.VSBuffer.wrap(j);z.write(i.Buffer),z.write(l(K.byteLength)),z.write(K)}else if(j instanceof R.VSBuffer)z.write(i.VSBuffer),z.write(l(j.byteLength)),z.write(j);else if(Array.isArray(j)){z.write(i.Array),z.write(l(j.length));for(const K of j)s(z,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(j));z.write(i.Object),z.write(l(K.byteLength)),z.write(K)}}function h(z){switch(z.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return z.read(n(z)).toString();case d.Buffer:return z.read(n(z)).buffer;case d.VSBuffer:return z.read(n(z));case d.Array:{const K=n(z),X=[];for(let ce=0;ce<K;ce++)X.push(h(z));return X}case d.Object:return JSON.parse(z.read(n(z)).toString())}}class a{constructor(j,K,X=null,ce=1e3){this.protocol=j,this.ctx=K,this.logger=X,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(j,K){this.channels.set(j,K),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const K=this.send([j.type]);this.logger?.logOutgoing(K,0,1,y(j.type));return}case 201:case 202:case 204:case 203:{const K=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(K,j.id,1,y(j.type),j.data);return}}}send(j,K=void 0){const X=new c;return s(X,j),s(X,K),this.sendBuffer(X.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const K=new m(j),X=h(K),ce=h(K),B=X[0];switch(B){case 100:return this.logger?.logIncoming(j.byteLength,X[1],1,`${f(B)}: ${X[2]}.${X[3]}`,ce),this.onPromise({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 102:return this.logger?.logIncoming(j.byteLength,X[1],1,`${f(B)}: ${X[2]}.${X[3]}`,ce),this.onEventListen({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 101:return this.logger?.logIncoming(j.byteLength,X[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:X[1]});case 103:return this.logger?.logIncoming(j.byteLength,X[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:X[1]})}}onPromise(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const X=new L.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,j.name,j.arg,X.token)}catch(O){ce=Promise.reject(O)}const B=j.id;ce.then(O=>{this.sendResponse({id:B,data:O,type:201}),this.activeRequests.delete(j.id)},O=>{O instanceof Error?this.sendResponse({id:B,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:B,data:O,type:203}),this.activeRequests.delete(j.id)});const H=(0,E.toDisposable)(()=>X.cancel());this.activeRequests.set(j.id,H)}onEventListen(j){const K=this.channels.get(j.channelName);if(!K){this.collectPendingRequest(j);return}const X=j.id,B=K.listen(this.ctx,j.name,j.arg)(H=>this.sendResponse({id:X,data:H,type:204}));this.activeRequests.set(j.id,B)}disposeActiveRequest(j){const K=this.activeRequests.get(j.id);K&&(K.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let K=this.pendingRequests.get(j.channelName);K||(K=[],this.pendingRequests.set(j.channelName,K));const X=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:j,timeoutTimer:X})}flushPendingRequests(j){const K=this.pendingRequests.get(j);if(K){for(const X of K)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(j,K=null){this.protocol=j,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=K}getChannel(j){const K=this;return{call(X,ce,B){return K.isDisposed?Promise.reject(new P.CancellationError):K.requestPromise(j,X,ce,B)},listen(X,ce){return K.isDisposed?I.Event.None:K.requestEvent(j,X,ce)}}}requestPromise(j,K,X,ce=L.CancellationToken.None){const B=this.lastRequestId++,O={id:B,type:100,channelName:j,name:K,arg:X};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((G,ee)=>{if(ce.isCancellationRequested)return ee(new P.CancellationError);const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(B),G(de.data);break;case 202:{this.handlers.delete(B);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ee(ve);break}case 203:this.handlers.delete(B),ee(de.data);break}};this.handlers.set(B,ue),this.sendRequest(O)};let Z=null;this.state===u.Idle?oe():(Z=(0,t.createCancelablePromise)(ue=>this.whenInitialized()),Z.then(()=>{Z=null,oe()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:B,type:101}),ee(new P.CancellationError)},se=ce.onCancellationRequested(ie);M=(0,E.combinedDisposable)((0,E.toDisposable)(ie),se),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(j,K,X){const ce=this.lastRequestId++,H={id:ce,type:102,channelName:j,name:K,arg:X};let O=null;const M=new I.Emitter({onFirstListenerAdd:()=>{O=(0,t.createCancelablePromise)(G=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(M),this.sendRequest(H)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(M),this.sendRequest({id:ce,type:103}))}}),x=G=>M.fire(G.data);return this.handlers.set(ce,x),M.event}sendRequest(j){switch(j.type){case 100:case 102:{const K=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger?.logOutgoing(K,j.id,0,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const K=this.send([j.type,j.id]);this.logger?.logOutgoing(K,j.id,0,f(j.type));return}}}send(j,K=void 0){const X=new c;return s(X,j),s(X,K),this.sendBuffer(X.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const K=new m(j),X=h(K),ce=h(K),B=X[0];switch(B){case 200:return this.logger?.logIncoming(j.byteLength,0,0,y(B)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(j.byteLength,X[1],0,y(B),ce),this.onResponse({type:X[0],id:X[1],data:ce})}}onResponse(j){if(j.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(j.id)?.(j)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class A{get connections(){const j=[];return this._connections.forEach(K=>j.push(K)),j}constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:K,onDidClientDisconnect:X})=>{I.Event.once(K.onMessage)(B=>{const H=new m(B),O=h(H),M=new a(K,O),x=new w(K);this.channels.forEach((ee,oe)=>M.registerChannel(oe,ee));const G={channelServer:M,channelClient:x,ctx:O};this._connections.add(G),this._onDidAddConnection.fire(G),X(()=>{M.dispose(),x.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)})})})}getChannel(j,K){const X=this;return{call(ce,B,H){let O;if((0,S.isFunction)(K)){const x=(0,D.getRandomElement)(X.connections.filter(K));O=x?Promise.resolve(x):I.Event.toPromise(I.Event.filter(X.onDidAddConnection,K))}else O=K.routeCall(X,ce,B);const M=O.then(x=>x.channelClient.getChannel(j));return _(M).call(ce,B,H)},listen(ce,B){if((0,S.isFunction)(K))return X.getMulticastEvent(j,K,ce,B);const H=K.routeEvent(X,ce,B).then(O=>O.channelClient.getChannel(j));return _(H).listen(ce,B)}}}getMulticastEvent(j,K,X,ce){const B=this;let H=new E.DisposableStore;const O=new I.Emitter({onFirstListenerAdd:()=>{H=new E.DisposableStore;const M=new I.EventMultiplexer,x=new Map,G=oe=>{const ie=oe.channelClient.getChannel(j).listen(X,ce),se=M.add(ie);x.set(oe,se)},ee=oe=>{const Z=x.get(oe);!Z||(Z.dispose(),x.delete(oe))};B.connections.filter(K).forEach(G),I.Event.filter(B.onDidAddConnection,K)(G,void 0,H),B.onDidRemoveConnection(ee,void 0,H),M.event(O.fire,O,H),H.add(M)},onLastListenerRemove:()=>{H.dispose()}});return O.event}registerChannel(j,K){this.channels.set(j,K),this._connections.forEach(X=>{X.channelServer.registerChannel(j,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class F{constructor(j,K,X=null){const ce=new c;s(ce,K),j.send(ce.buffer),this.channelClient=new w(j,X),this.channelServer=new a(j,K,X)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,K){this.channelServer.registerChannel(j,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function _(z){return{call(j,K,X){return z.then(ce=>ce.call(j,K,X))},listen(j,K){const X=new I.Relay;return z.then(ce=>X.input=ce.listen(j,K)),X.event}}}e.getDelayedChannel=_;function N(z){let j=!1;return{call(K,X,ce){return j?z.call(K,X,ce):(0,t.timeout)(0).then(()=>j=!0).then(()=>z.call(K,X,ce))},listen(K,X){if(j)return z.listen(K,X);const ce=new I.Relay;return(0,t.timeout)(0).then(()=>j=!0).then(()=>ce.input=z.listen(K,X)),ce.event}}}e.getNextTickChannel=N;class W{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const K of j.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await I.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=W;var k;(function(z){function j(B,H){const O=B,M=H&&H.disableMarshalling,x=new Map;for(const G in O)X(G)&&x.set(G,I.Event.buffer(O[G],!0));return new class{listen(G,ee,oe){const Z=x.get(ee);if(Z)return Z;if(ce(ee)){const ie=O[ee];if(typeof ie=="function")return ie.call(O,oe)}throw new Error(`Event not found: ${ee}`)}call(G,ee,oe){const Z=O[ee];if(typeof Z=="function"){if(!M&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,C.revive)(oe[ie]);return Z.apply(O,oe)}throw new Error(`Method not found: ${ee}`)}}}z.fromService=j;function K(B,H){const O=H&&H.disableMarshalling;return new Proxy({},{get(M,x){if(typeof x=="string")return H?.properties?.has(x)?H.properties.get(x):ce(x)?function(G){return B.listen(x,G)}:X(x)?B.listen(x):async function(...G){let ee;H&&!(0,S.isUndefinedOrNull)(H.context)?ee=[H.context,...G]:ee=G;const oe=await B.call(x,ee);return O?oe:(0,C.revive)(oe)};throw new Error(`Property not found: ${String(x)}`)}})}z.toService=K;function X(B){return B[0]==="o"&&B[1]==="n"&&b.isUpperAsciiLetter(B.charCodeAt(2))}function ce(B){return/^onDynamic/.test(B)&&b.isUpperAsciiLetter(B.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const j=z.toString();if(j!=="[object Object]")return j}return z}function Y(z){return Array.isArray(z)?z.map($):$(z)}function q(z,j,K,X,ce,B,H){H=Y(H);const O=U[ce],M=O[X%O.length];let x=[`%c[${z}]%c[${String(j).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(B)?(x=x.concat(H),x.push(")")):x.push(H),console.log.apply(console,x)}e.logWithColors=q;class V{constructor(j,K){this._outgoingPrefix=j,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,K,X,ce,B){this._totalOutgoing+=j,q(this._outgoingPrefix,this._totalOutgoing,j,K,X,ce,B)}logIncoming(j,K,X,ce,B){this._totalIncoming+=j,q(this._incomingPrefix,this._totalIncoming,j,K,X,ce,B)}}e.IPCLogger=V}),define(ne[141],re([0,1,17,3,38]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(I){this.port=I,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),I.start()}send(I){this.port.postMessage(I.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends R.IPCClient{constructor(I,E){const C=new L(I);super(C,E),this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[91],re([0,1,17,3,2,38]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(o){o.enableDiagnostics=!1,o.records=[];const s=new WeakMap;let h=0;function a(w,A){if(!s.has(w)){const F=String(++h);s.set(w,F)}return s.get(w)}function g(w,A,F,_){if(!o.enableDiagnostics)return;const N=a(w,A);if(_ instanceof D.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const W=D.VSBuffer.alloc(_.byteLength);W.set(_),o.records.push({timestamp:Date.now(),id:N,label:A,type:F,buff:W})}else o.records.push({timestamp:Date.now(),id:N,label:A,type:F,data:_})}o.traceSocketEvent=g})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function C(){return E||(E=D.VSBuffer.alloc(0)),E}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,h){if(s===0)return C();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return h&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const a=D.VSBuffer.alloc(s);let g=0,w=0;for(;s>0;){const A=this._chunks[w];if(A.byteLength>s){const F=A.slice(0,s);a.set(F,g),g+=s,h&&(this._chunks[w]=A.slice(s),this._totalLength-=s),s-=s}else a.set(A,g),g+=A.byteLength,h?(this._chunks.shift(),this._totalLength-=A.byteLength):w++,s-=A.byteLength}return a}}e.ChunkStream=b;var S;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(S||(S={}));function p(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(s,h,a,g){this.type=s,this.id=h,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends R.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,g=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new v(a,g,w,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.VSBuffer.alloc(13);h.writeUInt8(s.type,0),h.writeUInt32BE(s.id,1),h.writeUInt32BE(s.ack,5),h.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(h,s.data)}_bufferAdd(s,h){const a=this._totalLength===0;return this._data.push(s,h),this._totalLength+=s.byteLength+h.byteLength,a}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,h){this._bufferAdd(s,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class m extends R.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new v(1,0,0,s))}}e.Protocol=m;class c extends L.IPCClient{static fromSocket(s,h){return new c(new m(s),h)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,h,a=null){super(s,h,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class l{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,h=this._first;for(;h;)h=h.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let h=0,a=this._first;for(;a;)s[h++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const h=new l(s);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let h=0;h<r._HISTORY_LENGTH;h++)this.lastRuns[h]=s-1e3*h;setInterval(()=>{for(let h=r._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),h=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let g=0;g<r._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=h&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,h=null,a=r.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),h&&this._socketReader.acceptChunk(h),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new v(5,0,0,C());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new v(7,0,0,C());this._socketWriter.write(s)}sendResume(){const s=new v(8,0,0,C());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,h){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,C());this._socketWriter.write(s);const h=this._outgoingUnackMsg.toArray();for(let a=0,g=h.length;a<g;a++)this._socketWriter.write(h[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new v(6,0,0,C())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let a=0,g=h.length;a<g;a++)this._socketWriter.write(h[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new v(1,h,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const h=new v(2,0,0,s);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),h=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&a>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-h,2e4-a,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,C());this._socketWriter.write(s)}_sendKeepAlive(){const s=new v(9,0,0,C());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ne[142],re([0,1,92,3,38,141]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends R.IPCServer{static getOnDidClientConnect(){const I=t.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,C)=>C);return t.Event.map(I,E=>{const{port1:C,port2:b}=new MessageChannel,p={protocol:new L.Protocol(C),onDidClientDisconnect:t.Event.fromDOMEventEmitter(C,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),p})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[68],re([0,1,49,6,17,24,135,9,3,2,32,90,85,38]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends p.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class v{constructor(u,m){this.modulePath=u,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new t.Delayer(c),this.child=null,this._client=null}getChannel(u){const m=this;return{call(c,d,l){return m.requestPromise(u,c,d,l)},listen(c,d){return m.requestEvent(u,c,d)}}}requestPromise(u,m,c,d=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(u),n=(0,t.createCancelablePromise)(o=>l.call(m,c,o)),r=d.onCancellationRequested(()=>n.cancel()),i=(0,E.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(u,m,c){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let d;const l=new I.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(u).listen(m,c)(l.fire,l),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,S.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,u,m);const c=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}c.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const l=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&l.send(s.buffer.toString("base64")),r=c.event,i={send:n,onMessage:r};this._client=new p.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,h)=>{process.removeListener("exit",o),this.activeRequests.forEach(a=>(0,E.dispose)(a)),this.activeRequests.clear(),s!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+h),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:h})})}return this._client}getCachedChannel(u){let m=this.channels.get(u);return m||(m=this.client.getChannel(u),this.channels.set(u,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(ne[143],re([0,1,17,9,3,2,10,4,30,38,91]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class S{traceSocketEvent(a,g){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,g)}constructor(a,g=""){this._canWrite=!0,this.debugLabel=g,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,t.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener),this._closeListener=w=>{this.traceSocketEvent("close",{hadError:w}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const g=w=>{this.traceSocketEvent("read",w),a(D.VSBuffer.wrap(w))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(a){const g=w=>{a({type:0,hadError:w,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(a){const g=()=>{a()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,t.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,t.onUnexpectedError)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=S;var p;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var f;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(f||(f={}));class v extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,g){this.socket.traceSocketEvent(a,g)}constructor(a,g,w,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:w?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new y(this,g,w,A,this._onData,(F,_)=>this._write(F,_))),this._register(this._flowManager.onError(F=>{console.error(F),(0,t.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,g){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let w=2;a.byteLength<126?w+=0:a.byteLength<2**16?w+=2:w+=8;const A=D.VSBuffer.alloc(w);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),a.byteLength<126)A.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){A.writeUInt8(126,1);let F=1;A.writeUInt8(a.byteLength>>>8&255,++F),A.writeUInt8(a.byteLength>>>0&255,++F)}else{A.writeUInt8(127,1);let F=1;A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(0,++F),A.writeUInt8(a.byteLength>>>24&255,++F),A.writeUInt8(a.byteLength>>>16&255,++F),A.writeUInt8(a.byteLength>>>8&255,++F),A.writeUInt8(a.byteLength>>>0&255,++F)}this.socket.write(D.VSBuffer.concat([A,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),w=g.readUInt8(0),A=(w&128)>>>7,F=(w&64)>>>6,_=g.readUInt8(1),N=(_&128)>>>7,W=_&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),w=g.readUInt8(1),A=(w&128)>>>7;let F=w&127,_=1;F===126?F=g.readUInt8(++_)*2**8+g.readUInt8(++_):F===127&&(F=g.readUInt8(++_)*0+g.readUInt8(++_)*0+g.readUInt8(++_)*0+g.readUInt8(++_)*0+g.readUInt8(++_)*2**24+g.readUInt8(++_)*2**16+g.readUInt8(++_)*2**8+g.readUInt8(++_));let N=0;A&&(N=g.readUInt8(++_)*2**24+g.readUInt8(++_)*2**16+g.readUInt8(++_)*2**8+g.readUInt8(++_)),this._state.state=3,this._state.readLen=F,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),c(g,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(g,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class y extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,g,w,A,F,_){super(),this._tracer=a,this._onData=F,this._writeFn=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,g?(this._zlibInflateStream=this._register(new u(this._tracer,A,w,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const g=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(g,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,g){return new Promise((w,A)=>{a.write(g),a.flush(F=>w(F))})}acceptFrame(a,g,w){this._readQueue.push({data:a,isCompressed:g,isLastFrameOfMessage:w}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const g=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(g)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,g,w){return new Promise((A,F)=>{a.write(g),w&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(_=>A(_))})}}class u extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,g,w,A){super(),this._tracer=a,this._recordInflateBytes=g,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(A),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(D.VSBuffer.wrap(F))}),w&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this._zlibInflate.write(w.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const g=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(g)})}}class m extends L.Disposable{constructor(a,g){super(),this._tracer=a,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",w=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this._onError.fire(w)}),this._zlibDeflate.on("data",w=>{this._tracer.traceSocketEvent("zlibDeflateData",w),this._pendingDeflateData.push(D.VSBuffer.wrap(w))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let g=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.byteLength-4),a(g)})}}function c(h,a){if(a===0)return;const g=h.byteLength>>>2;for(let W=0;W<g;W++){const k=h.readUInt32BE(W*4);h.writeUInt32BE(k^a,W*4)}const w=g*4,A=h.byteLength-w,F=a>>>24&255,_=a>>>16&255,N=a>>>8&255;A>=1&&h.writeUInt8(h.readUInt8(w)^F,w),A>=2&&h.writeUInt8(h.readUInt8(w+1)^_,w+1),A>=3&&h.writeUInt8(h.readUInt8(w+2)^N,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function l(){const h=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):a=(0,T.join)(b().os.tmpdir(),`vscode-ipc-${h}.sock`),r(a),a}e.createRandomIPCHandle=l;function n(h,a,g){const w=b().crypto.createHash("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${g}-${a}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${g}-${a}.sock`):A=(0,T.join)(h,`${g}-${a}.sock`),r(A),A}e.createStaticIPCHandle=n;function r(h){const a=d[P.platform];typeof a=="number"&&h.length>=a&&console.warn(`WARNING: IPC handle "${h}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends E.IPCServer{static toClientConnectionEvent(a){const g=R.Event.fromNodeEventEmitter(a,"connection");return R.Event.map(g,w=>({protocol:new C.Protocol(new S(w,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(w,"close"))}))}constructor(a){super(i.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function o(h){return new Promise((a,g)=>{const w=b().net.createServer();w.on("error",g),w.listen(h,()=>{w.removeListener("error",g),a(new i(w))})})}e.serve=o;function s(h,a){return new Promise((g,w)=>{const A=b().net.createConnection(h,()=>{A.removeListener("error",w),g(C.Client.fromSocket(new S(A,`ipc-client${a}`),a))});A.once("error",w)})}e.connect=s}),define(ne[69],re([0,1,6,3,2,15]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function P(b){const S=b;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(S,p=Object.create(null)){super(),this.database=S,this.options=p,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=I.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((p,f)=>this.accept(f,p)),S.deleted?.forEach(p=>this.accept(p,void 0))}accept(S,p){if(this.state===I.Closed)return;let f=!1;(0,L.isUndefinedOrNull)(p)?f=this.cache.delete(S):this.cache.get(S)!==p&&(this.cache.set(S,p),f=!0),f&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===I.None&&(this.state=I.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,p){const f=this.cache.get(S);return(0,L.isUndefinedOrNull)(f)?p:f}getBoolean(S,p){const f=this.get(S);return(0,L.isUndefinedOrNull)(f)?p:f==="true"}getNumber(S,p){const f=this.get(S);return(0,L.isUndefinedOrNull)(f)?p:parseInt(f,10)}async set(S,p){if(this.state===I.Closed)return;if((0,L.isUndefinedOrNull)(p))return this.delete(S);const f=String(p);if(this.cache.get(S)!==f)return this.cache.set(S,f),this.pendingInserts.set(S,f),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===I.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=I.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((p,f)=>this.items.set(f,p)),S.delete?.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=C}),define(ne[144],re([11,12]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[145],re([11,12]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[146],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[147],re([11,12]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[148],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[149],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[150],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[151],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[152],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[153],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[154],re([11,12]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[155],re([11,12]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[156],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[157],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[158],re([11,12]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[159],re([11,12]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[160],re([11,12]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[161],re([11,12]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[162],re([11,12]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[163],re([11,12]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[164],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[165],re([11,12]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[166],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[167],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[168],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[169],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[170],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[171],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[172],re([11,12]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[173],re([11,12]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[93],re([0,1,65,64,22,10,36,19,7]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class E{get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=T.env.VSCODE_PORTABLE;return v?I.URI.file((0,L.join)(v,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,L.resolve)(v):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?I.URI.file((0,L.resolve)(v)):I.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,L.resolve)(v);const y=T.env.VSCODE_EXTENSIONS;if(y)return y;const u=T.env.VSCODE_PORTABLE;return u?(0,L.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(y=>/^[^:/?#]+?:\/\//.test(y)?I.URI.parse(y):I.URI.file((0,L.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,L.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const y of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);u&&u[1]&&u[2]&&v.push([u[1],u[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=T.env.VSCODE_PORTABLE;return v?I.URI.file((0,L.join)(v,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,y,u){this._args=v,this.paths=y,this.productService=u,this.editSessionId=this.args.editSessionId}}pe([t.memoize],E.prototype,"appRoot",null),pe([t.memoize],E.prototype,"userHome",null),pe([t.memoize],E.prototype,"userDataPath",null),pe([t.memoize],E.prototype,"appSettingsHome",null),pe([t.memoize],E.prototype,"tmpDir",null),pe([t.memoize],E.prototype,"cacheHome",null),pe([t.memoize],E.prototype,"stateResource",null),pe([t.memoize],E.prototype,"userRoamingDataHome",null),pe([t.memoize],E.prototype,"userDataSyncHome",null),pe([t.memoize],E.prototype,"userDataSyncLogResource",null),pe([t.memoize],E.prototype,"editSessionsLogResource",null),pe([t.memoize],E.prototype,"sync",null),pe([t.memoize],E.prototype,"machineSettingsResource",null),pe([t.memoize],E.prototype,"workspaceStorageHome",null),pe([t.memoize],E.prototype,"localHistoryHome",null),pe([t.memoize],E.prototype,"keyboardLayoutResource",null),pe([t.memoize],E.prototype,"argvResource",null),pe([t.memoize],E.prototype,"isExtensionDevelopment",null),pe([t.memoize],E.prototype,"untitledWorkspacesHome",null),pe([t.memoize],E.prototype,"installSourcePath",null),pe([t.memoize],E.prototype,"builtinExtensionsPath",null),pe([t.memoize],E.prototype,"extensionsPath",null),pe([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],E.prototype,"extensionDevelopmentKind",null),pe([t.memoize],E.prototype,"extensionTestsLocationURI",null),pe([t.memoize],E.prototype,"debugExtensionHost",null),pe([t.memoize],E.prototype,"logLevel",null),pe([t.memoize],E.prototype,"extensionLogLevel",null),pe([t.memoize],E.prototype,"serviceMachineIdResource",null),pe([t.memoize],E.prototype,"telemetryLogResource",null),pe([t.memoize],E.prototype,"disableWorkspaceTrust",null),pe([t.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function C(f,v){return p(f["inspect-extensions"],f["inspect-brk-extensions"],5870,v,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=C;function b(f,v){return p(f["inspect-search"],f["inspect-brk-search"],5876,v,f.extensionEnvironment)}e.parseSearchPort=b;function S(f,v){return p(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,v,f.extensionEnvironment)}e.parsePtyHostPort=S;function p(f,v,y,u,m,c){const l=Number(v||f)||(u?null:y),n=l?Boolean(!!v):!1;let r;if(c)try{r=JSON.parse(c)}catch{}return{port:l,break:n,debugId:m,env:r}}}),define(ne[174],re([0,1,280,4,146]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(v,y,u=T){const m=v.find(h=>h.length>0&&h[0]!=="-"),c={},d=["_"],l=[],n={};let r;for(const h in y){const a=y[h];a.type==="subcommand"?h===m&&(r=a):(a.alias&&(c[h]=a.alias),a.type==="string"||a.type==="string[]"?(d.push(h),a.deprecates&&d.push(...a.deprecates)):a.type==="boolean"&&(l.push(h),a.deprecates&&l.push(...a.deprecates)),a.global&&(n[h]=a))}if(r&&m){const h=n;for(const A in r.options)h[A]=r.options[A];const a=v.filter(A=>A!==m),g=u.getSubcommandReporter?u.getSubcommandReporter(m):void 0,w=P(a,h,g);return{[m]:w,_:[]}}const i=D(v,{string:d,boolean:l,alias:c}),o={},s=i;o._=i._.map(h=>String(h)).filter(h=>h.length>0),delete s._;for(const h in y){const a=y[h];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let g=s[h];if(a.deprecates)for(const w of a.deprecates)s.hasOwnProperty(w)&&(g||(g=s[w],g&&u.onDeprecatedOption(w,a.deprecationMessage||(0,R.localize)(36,null,h))),delete s[w]);if(typeof g<"u"){if(a.type==="string[]"){if(Array.isArray(g)||(g=[g]),!a.allowEmptyValue){const w=g.filter(A=>A.length>0);w.length!==g.length&&(u.onEmptyValue(h),g=w.length>0?w:void 0)}}else a.type==="string"&&(Array.isArray(g)?(g=g.pop(),u.onMultipleValues(h,g)):!g&&!a.allowEmptyValue&&(u.onEmptyValue(h),g=void 0));o[h]=g,a.deprecationMessage&&u.onDeprecatedOption(h,a.deprecationMessage)}delete s[h]}for(const h in s)u.onUnknownOption(h);return o}e.parseArgs=P;function I(v,y){let u="";return y.args&&(Array.isArray(y.args)?u=` <${y.args.join("> <")}>`:u=` <${y.args}>`),y.alias?`-${y.alias} --${v}${u}`:`--${v}${u}`}function E(v,y){const u=[];for(const m in v){const c=v[m],d=I(m,c);u.push([d,c.description])}return C(u,y)}e.formatOptions=E;function C(v,y){const m=v.reduce((l,n)=>Math.max(l,n[0].length),12)+2+1;if(y-m<25)return v.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const c=y-m-1,d=[];for(const l of v){const n=l[0],r=S(l[1],c),i=b(m-n.length-2);d.push("  "+n+i+r[0]);for(let o=1;o<r.length;o++)d.push(b(m)+r[o])}return d}function b(v){return" ".repeat(v)}function S(v,y){const u=[];for(;v.length;){const m=v.length<y?v.length:v.lastIndexOf(" ",y),c=v.slice(0,m).trim();v=v.slice(m),u.push(c)}return u}function p(v,y,u,m,c){const d=process.stdout.isTTY&&process.stdout.columns||80,l=c?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",n=[`${v} ${u}`];n.push(""),n.push(`${(0,R.localize)(38,null)}: ${y} [${(0,R.localize)(39,null)}]${l}`),n.push(""),c?.noPipe!==!0&&(t.isWindows?n.push((0,R.localize)(40,null,y)):n.push((0,R.localize)(41,null,y)),n.push(""));const r={},i=[];for(const o in m){const s=m[o];if(s.type==="subcommand")s.description&&i.push({command:o,description:s.description});else if(s.description&&s.cat){let h=r[s.cat];h||(r[s.cat]=h={}),h[o]=s}}for(const o in r){const s=o,h=r[s];h&&(n.push(L[s]),n.push(...E(h,d)),n.push(""))}return i.length&&(n.push((0,R.localize)(42,null)),n.push(...C(i.map(o=>[o.command,o.description]),d)),n.push("")),n.join(`
`)}e.buildHelpMessage=p;function f(v,y){return`${v||(0,R.localize)(43,null)}
${y||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ne[175],re([0,1,281,147,174]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(S,p){const f=(d,l)=>{console.warn((0,t.localize)(0,null,d,l))},v=d=>{console.warn((0,t.localize)(1,null,d))},y=(d,l)=>{console.warn((0,t.localize)(2,null,d,l))},u=d=>({onUnknownOption:l=>{d!=="tunnel"&&console.warn((0,t.localize)(3,null,l,d))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:d!=="tunnel"?u:void 0}),m={onUnknownOption:d=>{console.warn((0,t.localize)(4,null,d))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:u},c=(0,R.parseArgs)(S,R.OPTIONS,p?m:void 0);return c.goto&&c._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,t.localize)(5,null))),c["max-memory"]&&D(parseInt(c["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),c}function P(S){const p=S.findIndex(f=>!/^-/.test(f));if(p>-1)return[...S.slice(0,p),...S.slice(p+1)]}function I(S){let[,...p]=S;process.env.VSCODE_DEV&&(p=P(p)||[]);const f=!b(process.env);return T(p,f)}e.parseMainProcessArgv=I;function E(S){let[,,...p]=S;return process.env.VSCODE_DEV&&(p=P(p)||[]),T(p,!0)}e.parseCLIProcessArgv=E;function C(S,...p){const f=S.indexOf("--");return f===-1?S.push(...p):S.splice(f,0,...p),S}e.addArg=C;function b(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function Q(e,D,t){function R(T,P){const I=L(T,P),E=[I];return e.isAbsolute(I)||E.unshift(t),e.resolve(...E)}function L(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,P);const C=T["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,P)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[176],re([282,34,36]),function(e,D,t){return Q(e,D,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[177],re([0,1,34,93,176]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=L}),define(ne[178],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(y){const u=y.match(T);return u?u[1]:null}function C(y){if(y.indexOf("://")===-1){const u=y.match(t);return u?E(u[2]):null}try{const u=D.URI.parse(y);if(u.authority)return E(u.authority)}catch{}return null}function b(y,u){const m=new Set;let c;for(;c=P.exec(y);){const l=C(c[1]);l&&m.add(l)}const d=new Set(u);return Array.from(m).map(l=>d.has(l)?l:l.replace(I,"a"))}e.getDomainsOfRemotes=b;function S(y){const u=y.match(L);return u?u[2]:null}function p(y,u,m){return y&&u?(m&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${y}${u}`:`${y}/${u}`):null}function f(y,u){if(y.indexOf("://")===-1){const m=y.match(R);if(m)return p(m[2],m[3],u)}try{const m=D.URI.parse(y);if(m.authority)return p(S(m.authority),m.path,u)}catch{}return null}function v(y,u=!1){const m=[];let c;for(;c=P.exec(y);){const d=f(c[1],u);d&&m.push(d)}return m}e.getRemotes=v}),define(ne[179],re([0,1,15,150]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(T,P,I){try{L(T,P,I)}catch{}return T}e.localizeManifest=R;function L(T,P,I){const E=(C,b,S)=>{const p=C[b];if((0,D.isString)(p)){const f=p,v=f.length;if(v>1&&f[0]==="%"&&f[v-1]==="%"){const y=f.substr(1,v-2);let u=P[y];u===void 0&&I&&(u=I[y]);const m=typeof u=="string"?u:u.message;if(m!==void 0){const c=I?.[y],d=typeof c=="string"?c:c?.message;if(S&&(b==="title"||b==="category")&&d&&d!==m){const l={value:m,original:d};C[b]=l}else C[b]=m}else console.warn(`[${T.name}]: ${(0,t.localize)(0,null,y)}`)}}else if((0,D.isObject)(p))for(const f in p)p.hasOwnProperty(f)&&(f==="commands"?E(p,f,!0):E(p,f,S));else if(Array.isArray(p))for(let f=0;f<p.length;f++)E(p,f,S)};for(const C in T)T.hasOwnProperty(C)&&E(T,C)}}),define(ne[180],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,P,I){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,P,I])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class t{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,P){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(ne[70],re([0,1,19,87,155,56]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||T.test(u)}e.isValidVersionStr=I;function E(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(T);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=E;function C(u){if(!u)return null;const m=u.majorBase,c=u.majorMustEqual,d=u.minorBase;let l=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(m===0||(l=!1),r=!1);let i=0;if(u.preRelease){const o=P.exec(u.preRelease);if(o){const[,s,h,a]=o;i=Date.UTC(Number(s),Number(h)-1,Number(a))}}return{majorBase:m,majorMustEqual:c,minorBase:d,minorMustEqual:l,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=C;function b(u,m,c){let d;typeof u=="string"?d=C(E(u)):d=u;let l;m instanceof Date?l=m.getTime():typeof m=="string"&&(l=new Date(m).getTime());let n;if(typeof c=="string"?n=C(E(c)):n=c,!d||!n)return!1;const r=d.majorBase,i=d.minorBase,o=d.patchBase;let s=n.majorBase,h=n.minorBase,a=n.patchBase;const g=n.notBefore;let w=n.majorMustEqual,A=n.minorMustEqual,F=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>h?!0:i<h||l&&l<g?!1:o>=a:(r===1&&s===0&&(!w||!A||!F)&&(s=1,h=0,a=0,w=!0,A=!1,F=!1),r<s?!1:r>s?!w:i<h?!1:i>h?!A:o<a?!1:o>a?!F:!(l&&l<g))}e.isValidVersion=b;function S(u,m,c,d,l){const n=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return n.push([t.default.Error,R.localize(0,null)]),n;if(typeof d.name!="string")return n.push([t.default.Error,R.localize(1,null,"name")]),n;if(typeof d.version!="string")return n.push([t.default.Error,R.localize(2,null,"version")]),n;if(!d.engines)return n.push([t.default.Error,R.localize(3,null,"engines")]),n;if(typeof d.engines.vscode!="string")return n.push([t.default.Error,R.localize(4,null,"engines.vscode")]),n;if(typeof d.extensionDependencies<"u"&&!y(d.extensionDependencies))return n.push([t.default.Error,R.localize(5,null,"extensionDependencies")]),n;if(typeof d.activationEvents<"u"){if(!y(d.activationEvents))return n.push([t.default.Error,R.localize(6,null,"activationEvents")]),n;if(typeof d.main>"u"&&typeof d.browser>"u")return n.push([t.default.Error,R.localize(7,null,"activationEvents","main")]),n}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&n.push([t.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return n.push([t.default.Error,R.localize(9,null,"main")]),n;{const o=(0,D.joinPath)(c,d.main);(0,D.isEqualOrParent)(o,c)||n.push([t.default.Warning,R.localize(10,null,o.path,c.path)])}if(typeof d.activationEvents>"u")return n.push([t.default.Error,R.localize(11,null,"activationEvents","main")]),n}if(typeof d.browser<"u"){if(typeof d.browser!="string")return n.push([t.default.Error,R.localize(12,null,"browser")]),n;{const o=(0,D.joinPath)(c,d.browser);(0,D.isEqualOrParent)(o,c)||n.push([t.default.Warning,R.localize(13,null,o.path,c.path)])}if(typeof d.activationEvents>"u")return n.push([t.default.Error,R.localize(14,null,"activationEvents","browser")]),n}if(!L.valid(d.version))return n.push([t.default.Error,R.localize(15,null)]),n;const r=[];if(!p(u,m,d,l,r))for(const o of r)n.push([t.default.Error,o]);return n}e.validateExtensionManifest=S;function p(u,m,c,d,l){return d||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(u,m,c.engines.vscode,l)}e.isValidExtensionVersion=p;function f(u,m,c){return u==="*"||v(m,c,u)}e.isEngineValid=f;function v(u,m,c,d=[]){const l=C(E(c));if(!l)return d.push(R.localize(16,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return d.push(R.localize(17,null,c)),!1}else if(!l.majorMustEqual)return d.push(R.localize(18,null,c)),!1;return b(u,m,l)?!0:(d.push(R.localize(19,null,u,c)),!1)}function y(u){if(!Array.isArray(u))return!1;for(let m=0,c=u.length;m<c;m++)if(typeof u[m]!="string")return!1;return!0}}),define(ne[50],re([0,1,17,30]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,T,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await T.readFile(L.serviceMachineIdResource)).value.toString();I=(0,t.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,t.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(ne[57],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,L=[],T=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[94],re([0,1,57]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function L(P,I,E){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(E))),t.push([P,I])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ne[181],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const P=this.lookupOrInsertNode(L),I=this.lookupOrInsertNode(T);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let P=this._nodes.get(T);return P||(P=new D(T,L),this._nodes.set(T,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,P]of this._nodes)L.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const P=new Set([L]),I=this._findCycle(T,P);if(I)return I}}_findCycle(L,T){for(const[P,I]of L.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const E=this._findCycle(I,T);if(E)return E;T.delete(P)}}}e.Graph=t}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function t(T,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:T,index:I}):(P[D.DI_DEPENDENCIES]=[{id:T,index:I}],P[D.DI_TARGET]=P)}function R(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const P=function(I,E,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,I,C)};return P.toString=()=>T,D.serviceIds.set(T,P),P}e.createDecorator=R;function L(T){return T}e.refineServiceDecorator=L}),define(ne[182],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[16],re([0,1,15,7,5]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=L;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(u,m){const c=Object.create(null);for(const d in u)C(c,d,u[d],m);return c}e.toValuesTree=E;function C(u,m,c,d){const l=m.split("."),n=l.pop();let r=u;for(let i=0;i<l.length;i++){const o=l[i];let s=r[o];switch(typeof s){case"undefined":s=r[o]=Object.create(null);break;case"object":break;default:d(`Ignoring ${m} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=c}catch{d(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function b(u,m){const c=m.split(".");S(u,c)}e.removeFromValueTree=b;function S(u,m){const c=m.shift();if(m.length===0){delete u[c];return}if(Object.keys(u).indexOf(c)!==-1){const d=u[c];typeof d=="object"&&!Array.isArray(d)&&(S(d,m),Object.keys(d).length===0&&delete u[c])}}function p(u,m,c){function d(r,i){let o=r;for(const s of i){if(typeof o!="object"||o===null)return;o=o[s]}return o}const l=m.split("."),n=d(u,l);return typeof n>"u"?c:n}e.getConfigurationValue=p;function f(u,m,c){Object.keys(m).forEach(d=>{d!=="__proto__"&&(d in u?D.isObject(u[d])&&D.isObject(m[d])?f(u[d],m[d],c):c&&(u[d]=m[d]):u[d]=m[d])})}e.merge=f;function v(u,m,c){const d=u.inspect(m),l=u.inspect(c);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:d.defaultValue}e.getMigratedSettingValue=v;function y(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(ne[183],re([0,1,4,27,5]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return b.INSTANCE}static true(){return S.INSTANCE}static has(k){return p.create(k)}static equals(k,U){return f.create(k,U)}static notEquals(k,U){return u.create(k,U)}static regex(k,U){return i.create(k,U)}static in(k,U){return v.create(k,U)}static notIn(k,U){return y.create(k,U)}static not(k){return m.create(k)}static and(...k){return h.create(k,null,!0)}static or(...k){return a.create(k,null,!0)}static greater(k,U){return d.create(k,U)}static greaterEquals(k,U){return l.create(k,U)}static smaller(k,U){return n.create(k,U)}static smallerEquals(k,U){return r.create(k,U)}static deserialize(k,U=!1){if(!!k)return this._deserializeOrExpression(k,U)}static _deserializeOrExpression(k,U){const $=k.split("||");return a.create($.map(Y=>this._deserializeAndExpression(Y,U)),null,!0)}static _deserializeAndExpression(k,U){const $=k.split("&&");return h.create($.map(Y=>this._deserializeOne(Y,U)),null,!0)}static _deserializeOne(k,U){if(k=k.trim(),k.indexOf("!=")>=0){const $=k.split("!=");return u.create($[0].trim(),this._deserializeValue($[1],U))}if(k.indexOf("==")>=0){const $=k.split("==");return f.create($[0].trim(),this._deserializeValue($[1],U))}if(k.indexOf("=~")>=0){const $=k.split("=~");return i.create($[0].trim(),this._deserializeRegexValue($[1],U))}if(k.indexOf(" not in ")>=0){const $=k.split(" not in ");return y.create($[0].trim(),this._deserializeValue($[1],U))}if(k.indexOf(" in ")>=0){const $=k.split(" in ");return v.create($[0].trim(),this._deserializeValue($[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return r.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?m.create(k.substr(1).trim()):p.create(k)}static _deserializeValue(k,U){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,U){if((0,t.isFalsyOrWhitespace)(k)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=k.indexOf("/"),Y=k.lastIndexOf("/");if($===Y||$<0){if(U)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const q=k.slice($+1,Y),V=k[Y+1]==="i"?"i":"";try{return new RegExp(q,V)}catch(z){if(U)throw new Error(`bad regexp-value '${k}', parse error: ${z}`);return console.warn(`bad regexp-value '${k}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function E(W,k){const U=W?W.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!U&&!$?!0:!U||!$?!1:U.equals($)}e.expressionsAreEqualWithConstantSubstitution=E;function C(W,k){return W.cmp(k)}class b{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class S{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class p{static create(k,U=null){const $=L.get(k);return typeof $=="boolean"?$?S.INSTANCE:b.INSTANCE:new p(k,U)}constructor(k,U){this.key=k,this.negated=U,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?S.INSTANCE:b.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class f{static create(k,U,$=null){if(typeof U=="boolean")return U?p.create(k,$):m.create(k,$);const Y=L.get(k);return typeof Y=="boolean"?U===(Y?"true":"false")?S.INSTANCE:b.INSTANCE:new f(k,U,$)}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?S.INSTANCE:b.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class v{static create(k,U){return new v(k,U)}constructor(k,U){this.key=k,this.valueKey=U,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(U)?U.includes($):typeof $=="string"&&typeof U=="object"&&U!==null?T.call(U,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=v;class y{static create(k,U){return new y(k,U)}constructor(k,U){this.key=k,this.valueKey=U,this.type=11,this._negated=v.create(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class u{static create(k,U,$=null){if(typeof U=="boolean")return U?m.create(k,$):p.create(k,$);const Y=L.get(k);return typeof Y=="boolean"?U===(Y?"true":"false")?b.INSTANCE:S.INSTANCE:new u(k,U,$)}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?b.INSTANCE:S.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class m{static create(k,U=null){const $=L.get(k);return typeof $=="boolean"?$?b.INSTANCE:S.INSTANCE:new m(k,U)}constructor(k,U){this.key=k,this.negated=U,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?b.INSTANCE:S.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function c(W,k){if(typeof W=="string"){const U=parseFloat(W);isNaN(U)||(W=U)}return typeof W=="string"||typeof W=="number"?k(W):b.INSTANCE}class d{static create(k,U,$=null){return c(U,Y=>new d(k,Y,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class l{static create(k,U,$=null){return c(U,Y=>new l(k,Y,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class n{static create(k,U,$=null){return c(U,Y=>new n(k,Y,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class r{static create(k,U,$=null){return c(U,Y=>new r(k,Y,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{static create(k,U){return new i(k,U)}constructor(k,U){this.key=k,this.regexp=U,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const U=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return U<$?-1:U>$?1:0}equals(k){if(k.type===this.type){const U=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&U===$}return!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class o{static create(k){return new o(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new o(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function s(W){let k=null;for(let U=0,$=W.length;U<$;U++){const Y=W[U].substituteConstants();if(W[U]!==Y&&k===null){k=[];for(let q=0;q<U;q++)k[q]=W[q]}k!==null&&(k[U]=Y)}return k===null?W:k}class h{static create(k,U,$){return h._normalizeArr(k,U,$)}constructor(k,U){this.expr=k,this.negated=U,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const Y=C(this.expr[U],k.expr[U]);if(Y!==0)return Y}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:h.create(k,this.negated,!1)}evaluate(k){for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static _normalizeArr(k,U,$){const Y=[];let q=!1;for(const V of k)if(!!V){if(V.type===1){q=!0;continue}if(V.type===0)return b.INSTANCE;if(V.type===6){Y.push(...V.expr);continue}Y.push(V)}if(Y.length===0&&q)return S.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(C);for(let V=1;V<Y.length;V++)Y[V-1].equals(Y[V])&&(Y.splice(V,1),V--);if(Y.length===1)return Y[0];for(;Y.length>1;){const V=Y[Y.length-1];if(V.type!==9)break;Y.pop();const z=Y.pop(),j=Y.length===0,K=a.create(V.expr.map(X=>h.create([X,z],null,$)),null,j);K&&(Y.push(K),Y.sort(C))}if(Y.length===1)return Y[0];if($){for(let V=0;V<Y.length;V++)for(let z=V+1;z<Y.length;z++)if(Y[V].negate().equals(Y[z]))return b.INSTANCE;if(Y.length===1)return Y[0]}return new h(Y,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new h(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(const U of this.expr)k.push(U.negate());this.negated=a.create(k,this,!0)}return this.negated}}class a{static create(k,U,$){return a._normalizeArr(k,U,$)}constructor(k,U){this.expr=k,this.negated=U,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const Y=C(this.expr[U],k.expr[U]);if(Y!==0)return Y}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:a.create(k,this.negated,!1)}evaluate(k){for(let U=0,$=this.expr.length;U<$;U++)if(this.expr[U].evaluate(k))return!0;return!1}static _normalizeArr(k,U,$){let Y=[],q=!1;if(k){for(let V=0,z=k.length;V<z;V++){const j=k[V];if(!!j){if(j.type===0){q=!0;continue}if(j.type===1)return S.INSTANCE;if(j.type===9){Y=Y.concat(j.expr);continue}Y.push(j)}}if(Y.length===0&&q)return b.INSTANCE;Y.sort(C)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let V=1;V<Y.length;V++)Y[V-1].equals(Y[V])&&(Y.splice(V,1),V--);if(Y.length===1)return Y[0];if($){for(let V=0;V<Y.length;V++)for(let z=V+1;z<Y.length;z++)if(Y[V].negate().equals(Y[z]))return S.INSTANCE;if(Y.length===1)return Y[0]}return new a(Y,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new a(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(const U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),$=k.shift(),Y=[];for(const q of N(U))for(const V of N($))Y.push(h.create([q,V],null,!1));k.unshift(a.create(Y,null,!1))}this.negated=a.create(k,this,!0)}return this.negated}}class g extends p{static all(){return g._info.values()}constructor(k,U,$){super(k,null),this._defaultValue=U,typeof $=="object"?g._info.push({...$,key:k}):$!==!0&&g._info.push({key:k,description:$,type:U!=null?typeof U:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return f.create(this.key,k)}notEqualsTo(k){return u.create(this.key,k)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(W,k){return W<k?-1:W>k?1:0}function A(W,k,U,$){return W<U?-1:W>U?1:k<$?-1:k>$?1:0}function F(W,k){if(W.type===0||k.type===1)return!0;if(W.type===9)return k.type===9?_(W.expr,k.expr):!1;if(k.type===9){for(const U of k.expr)if(F(W,U))return!0;return!1}if(W.type===6){if(k.type===6)return _(k.expr,W.expr);for(const U of W.expr)if(F(U,k))return!0;return!1}return W.equals(k)}e.implies=F;function _(W,k){let U=0,$=0;for(;U<W.length&&$<k.length;){const Y=W[U].cmp(k[$]);if(Y<0)return!1;Y===0&&U++,$++}return U===W.length}function N(W){return W.type===9?W.expr:[W]}}),define(ne[95],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class R{async getPerformanceInfo(T,P){return{}}async getSystemInfo(T,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,P){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=R}),define(ne[96],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[13],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,149,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(u,m,c){return P(m,c)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===c?!0:E(c).includes(u)}e.isTargetPlatformCompatible=I;function E(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=C;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var S;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(m,c){super(m),this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[184],re([0,1,3,2,67,32,7,136,29]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(y,u){return T.URI.revive(u?u.transformIncoming(y):y)}function C(y,u){return u?u.transformOutgoingURI(y):y}function b(y,u){u=u||P.DefaultURITransformer;const m=y.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...y,manifest:void 0},u),manifest:m}}function S(y,u){return u?(0,L.cloneAndChange)(y,m=>m instanceof T.URI?u.transformOutgoingURI(m):void 0):y}class p{constructor(u,m){this.service=u,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,m){const c=this.getUriTransformer(u);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(l=>({...l,local:l.local?S(l.local,c):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,m,c){const d=this.getUriTransformer(u);switch(m){case"zip":return this.service.zip(b(c[0],d)).then(l=>C(l,d));case"unzip":return this.service.unzip(E(c[0],d));case"install":return this.service.install(E(c[0],d),(0,R.revive)(c[1]));case"getManifest":return this.service.getManifest(E(c[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,R.revive)(c[1]));case"uninstall":return this.service.uninstall(b(c[0],d),(0,R.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(b(c[0],d));case"getInstalled":return this.service.getInstalled(c[0],T.URI.revive(c[1])).then(l=>l.map(n=>S(n,d)));case"getMetadata":return this.service.getMetadata(b(c[0],d));case"updateMetadata":return this.service.updateMetadata(b(c[0],d),c[1]).then(l=>S(l,d));case"updateExtensionScope":return this.service.updateExtensionScope(b(c[0],d),c[1]).then(l=>S(l,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class f extends t.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(c=>({...c,local:c.local?b(c.local,null):c.local,source:this.isUriComponents(c.source)?T.URI.revive(c.source):c.source,profileLocation:T.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire({identifier:m.identifier,profileLocation:T.URI.revive(m.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire({...m,profileLocation:T.URI.revive(m.profileLocation)})))}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const m=await this.getTargetPlatform();return u.allTargetPlatforms.some(c=>(0,I.isTargetPlatformCompatible)(c,u.allTargetPlatforms,m))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(m=>T.URI.revive(m)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,m){return Promise.resolve(this.channel.call("install",[u,m])).then(c=>b(c,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,m){return Promise.resolve(this.channel.call("installFromGallery",[u,m])).then(c=>b(c,null))}uninstall(u,m){return Promise.resolve(this.channel.call("uninstall",[u,m]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u]))}getInstalled(u=null,m){return Promise.resolve(this.channel.call("getInstalled",[u,m])).then(c=>c.map(d=>b(d,null)))}getMetadata(u){return Promise.resolve(this.channel.call("getMetadata",[u]))}updateMetadata(u,m){return Promise.resolve(this.channel.call("updateMetadata",[u,m])).then(c=>b(c,null))}updateExtensionScope(u,m){return Promise.resolve(this.channel.call("updateExtensionScope",[u,m])).then(c=>b(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,m){const c=await this.channel.call("download",[u,m]);return T.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class v{constructor(u){this.service=u}listen(u,m){throw new Error("Invalid listen")}call(u,m,c){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(ne[97],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class t{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((L,T)=>Q(["vsce-sign"],async P=>L(P),T))),this.moduleLoadingPromise}async verify(L,T){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(L,T)}}e.ExtensionSignatureVerificationService=t}),define(ne[98],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function R(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],re([0,1,48,10,27,15,7,157,5]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function E(q){return q.create===!0}e.isFileOpenForWriteOptions=E;var C;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var b;(function(q){q[q.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var S;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=p;function f(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=v;function y(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function u(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=u;function m(q){return p(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var c;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(V,z){super(V),this.code=z}}e.FileSystemProviderError=d;function l(q,V){const z=new d(q.toString(),V);return r(z,V),z}e.createFileSystemProviderError=l;function n(q){return q||l((0,P.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=n;function r(q,V){return q.name=V?`${V} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=r;function i(q){if(!q)return c.Unknown;if(q instanceof d)return q.code;const V=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!V)return c.Unknown;switch(V[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=i;function o(q){if(q instanceof A)return q.fileOperationResult;switch(i(q)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class h{constructor(V,z,j){this.resource=V,this.operation=z,this.target=j}isOperation(V){return this.operation===V}}e.FileOperationEvent=h;var a;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const j=new Map;for(const K of V){const X=j.get(K.type);switch(X?X.push([K.resource,K]):j.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,X]of j)switch(K){case 1:this.added=D.TernarySearchTree.forUris(()=>z),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>z),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>z),this.deleted.fill(X);break}}contains(V,...z){return this.doContains(V,{includeChildren:!1},...z)}affects(V,...z){return this.doContains(V,{includeChildren:!0},...z)}doContains(V,z,...j){if(!V)return!1;const K=j.length>0;return!!((!K||j.includes(1))&&(this.added?.get(V)||z.includeChildren&&this.added?.findSuperstr(V))||(!K||j.includes(0))&&(this.updated?.get(V)||z.includeChildren&&this.updated?.findSuperstr(V))||(!K||j.includes(2))&&(this.deleted?.findSubstr(V)||z.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function w(q,V,z){return!q||!V||q===V||V.length>q.length?!1:(V.charAt(V.length-1)!==t.sep&&(V+=t.sep),z?(0,R.startsWithIgnoreCase)(q,V):q.indexOf(V)===0)}e.isParent=w;class A extends Error{constructor(V,z,j){super(V),this.fileOperationResult=z,this.options=j}}e.FileOperationError=A;class F extends A{constructor(V,z,j){super(V,2,j),this.stat=z}}e.NotModifiedSinceFileOperationError=F;var _;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=W;async function k(q,V){if(!V.hasProvider(T.URI.from({scheme:q.scheme})))return new Promise(z=>{const j=V.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===q.scheme&&K.added&&(j.dispose(),z())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(V){return(0,L.isNumber)(V)||(V=0),V<U.KB?(0,P.localize)(1,null,V.toFixed(0)):V<U.MB?(0,P.localize)(2,null,(V/U.KB).toFixed(2)):V<U.GB?(0,P.localize)(3,null,(V/U.MB).toFixed(2)):V<U.TB?(0,P.localize)(4,null,(V/U.GB).toFixed(2)):(0,P.localize)(5,null,(V/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function Y(q){return{maxFileSize:q===0?300*U.MB:16*U.GB,maxHeapSize:q===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=Y});var J=this&&this.__param||function(Q,e){return function(D,t){e(D,t,Q)}};define(ne[185],re([0,1,99,42,14]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const I=(await this.fileService.readFileStream(P)).value;return new Promise((E,C)=>{const b=(0,D.createHash)("md5");(0,t.listenStream)(I,{onData:S=>b.update(S.buffer),onError:S=>C(S),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};L=pe([J(0,R.IFileService)],L),e.ChecksumService=L}),define(ne[186],re([0,1,17,37,9,3,2,42,7,30,14]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(p,f){super(),this.channel=p,this.extraCapabilities=f,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,f){const{buffer:v}=await this.channel.call("readFile",[p,f]);return v}readFileStream(p,f,v){const y=(0,P.newWriteableStream)(m=>D.VSBuffer.concat(m.map(c=>D.VSBuffer.wrap(c))).buffer),u=this.channel.listen("readFileStream",[p,f])(m=>{if(m instanceof D.VSBuffer)y.write(m.buffer);else{if(m==="end")y.end();else{let c=m;c instanceof Error||(c=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(c),C.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}u.dispose()}});return v.onCancellationRequested(()=>{y.error((0,R.canceled)()),y.end(),u.dispose()}),y}writeFile(p,f,v){return this.channel.call("writeFile",[p,D.VSBuffer.wrap(f),v])}open(p,f){return this.channel.call("open",[p,f])}close(p){return this.channel.call("close",[p])}async read(p,f,v,y,u){const[m,c]=await this.channel.call("read",[p,f,u]);return v.set(m.buffer.slice(0,c),y),c}write(p,f,v,y,u){return this.channel.call("write",[p,f,D.VSBuffer.wrap(v),y,u])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,f){return this.channel.call("delete",[p,f])}rename(p,f,v){return this.channel.call("rename",[p,f,v])}copy(p,f,v){return this.channel.call("copy",[p,f,v])}cloneFile(p,f){return this.channel.call("cloneFile",[p,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const f=p;this._onDidChange.fire(f.map(v=>({resource:I.URI.revive(v.resource),type:v.type})))}else{const f=p;this._onDidWatchError.fire(f)}}))}watch(p,f){const v=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,v,p,f]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=b}),define(ne[100],re([0,1,17,9,158,14]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(C,b,S,p,f,v){let y;try{await P(C,b,S,p,f,v)}catch(u){y=u}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&S.error(y),S.end()}}e.readFileIntoStream=T;async function P(C,b,S,p,f,v){I(v);const y=await C.open(b,{create:!1});try{I(v);let u=0,m=0,c=f&&typeof f.length=="number"?f.length:void 0,d=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),l=f&&typeof f.position=="number"?f.position:0,n=0;do m=await C.read(y,l,d.buffer,n,d.byteLength-n),l+=m,n+=m,u+=m,typeof c=="number"&&(c-=m),n===d.byteLength&&(await S.write(p(d)),d=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),n=0);while(m>0&&(typeof c!="number"||c>0)&&I(v)&&E(u,f));if(n>0){let r=n;typeof c=="number"&&(r=Math.min(n,c)),S.write(p(d.slice(0,r)))}}catch(u){throw(0,L.ensureFileSystemProviderError)(u)}finally{await C.close(y)}}function I(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function E(C,b){if(b?.limits){if(typeof b.limits.memory=="number"&&C>b.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&C>b.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[58],re([0,1,88,2,10,4,7,14]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class E extends t.Disposable{constructor(m,c,d,l){super(),this.onFileChanges=m,this.onLogMessage=c,this.verboseLogging=d,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new t.DisposableStore;this.watcherDisposables.value=m,this.watcher=this.createWatcher(m),this.watcher.setVerboseLogging(this.verboseLogging),m.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),m.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),m.add(this.watcher.onDidError(c=>this.onError(c)))}onError(m){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`):this.error(m)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.watcher?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.watcher?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${m}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class C extends E{constructor(m,c,d){super(m,c,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class b extends E{constructor(m,c,d){super(m,c,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function S(u){return u.map(m=>({type:m.type,resource:T.URI.file(m.path)}))}e.toFileChanges=S;function p(u){const m=new y;for(const c of u)m.processEvent(c);return m.coalesce()}e.coalesceEvents=p;function f(u,m){return typeof m=="string"&&!m.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(m)?{base:u,pattern:m}:m}e.normalizeWatcherPattern=f;function v(u,m){const c=[];for(const d of m)c.push((0,D.parse)(f(u,d)));return c}e.parseWatcherPatterns=v;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return L.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const c=this.mapPathToChange.get(this.toKey(m));let d=!1;if(c){const l=c.type,n=m.type;c.path!==m.path&&(m.type===2||m.type===1)?d=!0:l===1&&n===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(c)):l===2&&n===1?c.type=0:l===1&&n===0||(c.type=n)}else d=!0;d&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],c=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(m.push(d),!1):!0).sort((d,l)=>d.path.length-l.path.length).filter(d=>c.some(l=>(0,P.isParent)(d.path,l,!L.isLinux))?!1:(c.push(d.path),!0)).concat(m)}}}),define(ne[187],re([0,1,55,6,24,47,2,83,10,4,138,28,58]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends T.Disposable{constructor(y,u,m,c){super(),this.request=y,this.onDidFilesChange=u,this.onLogMessage=m,this.verboseLogging=c,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(p.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await b.Promises.stat(y);this._register(await this.doWatch(y,u.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let u=y.path;try{u=await b.Promises.realpath(y.path),y.path===u&&(u=await(0,C.realcase)(y.path)??y.path),y.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${u})`)}catch{}return u}async doWatch(y,u){if(E.isMacintosh&&(0,L.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const m=new R.CancellationTokenSource(this.cts.token),c=new T.DisposableStore;try{const d=(0,I.basename)(y),l=(0,D.watch)(y);c.add((0,T.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${y}'`);const n=new Set;if(u)try{for(const i of await b.Promises.readdir(y))n.add(i)}catch(i){this.error(i)}const r=new Map;c.add((0,T.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),l.on("error",(i,o)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),l.on("change",(i,o)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let s="";if(o&&(s=o.toString(),E.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){r.get(s)?.dispose();const h=setTimeout(async()=>{if(r.delete(s),s===d&&!await b.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,I.join)(y,s));if(m.token.isCancellationRequested)return;let g;a?n.has(s)?g=0:(g=1,n.add(s)):(n.delete(s),g=2),this.onFileChange({path:(0,I.join)(this.request.path,s),type:g})},p.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,T.toDisposable)(()=>clearTimeout(h)))}else{let h;n.has(s)?h=0:(h=1,n.add(s)),this.onFileChange({path:(0,I.join)(this.request.path,s),type:h})}else if(i==="rename"||s!==d){const h=setTimeout(async()=>{const a=await b.Promises.exists(y);m.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},p.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,T.toDisposable)(()=>clearTimeout(h)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await b.Promises.exists(y)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${d.toString()})`)}return(0,T.toDisposable)(()=>{m.dispose(!0),c.dispose()})}async onFileChange(y,u=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!u&&this.excludes.some(m=>m(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(m=>m(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,S.coalesceEvents)(m);if(c.length>0){if(this.verboseLogging)for(const l of c)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(E.isLinux)return b.Promises.exists(y);try{const u=(0,I.basename)(y);return(await b.Promises.readdir((0,I.dirname)(y))).some(c=>c===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.FILE_DELETE_HANDLER_DELAY=100,p.FILE_CHANGES_HANDLER_DELAY=50;async function f(v,y,u,m,c=512){const d=await b.Promises.open(v,"r"),l=Buffer.allocUnsafe(c),n=new R.CancellationTokenSource(m);let r,i=!1;const o={path:v,excludes:[],recursive:!1},s=new p(o,h=>{(async()=>{for(const{type:a}of h)if(a===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await b.Promises.read(d,l,0,c,null);if(!g||n.token.isCancellationRequested)break;y(l.slice(0,g))}}catch(g){r=new Error(g),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,u(),new Promise((h,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(d)}catch(g){r=new Error(g)}r?a(r):h()})})}e.watchFileContents=f}),define(ne[188],re([0,1,3,88,2,4,187]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const C=this.normalizeRequests(E),b=C.filter(p=>{const f=this.watchers.get(p.path);return f?!(0,t.patternsEquals)(f.request.excludes,p.excludes)||!(0,t.patternsEquals)(f.request.includes,p.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:p})=>!C.find(f=>f.path===p.path&&(0,t.patternsEquals)(f.excludes,p.excludes)&&(0,t.patternsEquals)(f.includes,p.includes))).map(({request:p})=>p.path);b.length&&this.trace(`Request to start watching: ${b.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const p of S)this.stopWatching(p);for(const p of b)this.startWatching(p)}startWatching(E){const C=new T.NodeJSFileWatcherLibrary(E,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),b={request:E,instance:C};this.watchers.set(E.path,b)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const C=this.watchers.get(E);C&&(this.watchers.delete(E),C.instance.dispose())}normalizeRequests(E){const C=new Map;for(const b of E){const S=L.isLinux?b.path:b.path.toLowerCase();C.set(S,b)}return Array.from(C.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,C]of this.watchers)C.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,C){return C?`[File Watcher (node.js)] ${E} (path: ${C.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(ne[189],re([0,1,58,188]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(T,P,I){super(T,P,I),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(ne[190],re([0,1,22,38,68,58]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(I,E,C){super(I,E,C),this.init()}createWatcher(I){const E=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(E.onDidProcessExit(({code:C,signal:b})=>this.onError(`terminated by itself with code ${C}, signal: ${b}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[71],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[L,T]of R)this.set(L,T)}set(R,L){const T=this._entries.get(R);return this._entries.set(R,L),T}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(ne[191],re([0,1,6,9,2,57,181,5,71,82]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class S{constructor(y=new I.ServiceCollection,u=!1,m,c=C){this._services=y,this._strict=u,this._parent=m,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=c?m?._globalGraph??new T.Graph(d=>d):void 0}createChild(y){return new S(y,this._strict,this,this._enableTracing)}invokeFunction(y,...u){const m=f.traceInvocation(this._enableTracing,y);let c=!1;try{return y({get:l=>{if(c)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(l,m);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...u)}finally{c=!0,m.stop()}}createInstance(y,...u){let m,c;return y instanceof L.SyncDescriptor?(m=f.traceCreation(this._enableTracing,y.ctor),c=this._createInstance(y.ctor,y.staticArguments.concat(u),m)):(m=f.traceCreation(this._enableTracing,y),c=this._createInstance(y,u,m)),m.stop(),c}_createInstance(y,u=[],m){const c=P._util.getServiceDependencies(y).sort((n,r)=>n.index-r.index),d=[];for(const n of c){const r=this._getOrCreateServiceInstance(n.id,m);r||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${n.id}.`,!1),d.push(r)}const l=c.length>0?c[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${y.name} at position ${l+1} conflicts with ${u.length} static arguments`);const n=l-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,l)}return Reflect.construct(y,u.concat(d))}_setServiceInstance(y,u){if(this._services.get(y)instanceof L.SyncDescriptor)this._services.set(y,u);else if(this._parent)this._parent._setServiceInstance(y,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const u=this._services.get(y);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):u}_getOrCreateServiceInstance(y,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const m=this._getServiceInstanceOrDescriptor(y);return m instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,m,u.branch(y,!0)):(u.branch(y,!1),m)}_safeCreateAndCacheServiceInstance(y,u,m){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,u,m)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,u,m){const c=new T.Graph(n=>n.id.toString());let d=0;const l=[{id:y,desc:u,_trace:m}];for(;l.length;){const n=l.pop();if(c.lookupOrInsertNode(n),d++>1e3)throw new b(c);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(r.id);if(i||this._throwIfStrict(`[createInstance] ${y} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof L.SyncDescriptor){const o={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};c.insertEdge(n,o),l.push(o)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new b(c);break}for(const{data:r}of n){if(this._getServiceInstanceOrDescriptor(r.id)instanceof L.SyncDescriptor){const o=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,o)}c.removeNode(r)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,u,m=[],c,d){if(this._services.get(y)instanceof L.SyncDescriptor)return this._createServiceInstance(y,u,m,c,d);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,u,m,c,d);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(y,u,m=[],c,d){if(c){const l=new S(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(y);const n=new Map,r=new D.IdleValue(()=>{const i=l._createInstance(u,m,d);for(const[o,s]of n){const h=i[o];if(typeof h=="function")for(const a of s)h.apply(i,a)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=n.get(o);return a||(a=new E.LinkedList,n.set(o,a)),(w,A,F)=>{const _=a.push([w,A,F]);return(0,R.toDisposable)(_)}}if(o in i)return i[o];const s=r.value;let h=s[o];return typeof h!="function"||(h=h.bind(s),i[o]=h),h},set(i,o,s){return r.value[o]=s,!0}})}else return this._createInstance(u,m,d)}_throwIfStrict(y,u){if(u&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=S;var p;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(p||(p={}));class f{static traceInvocation(y,u){return y?new f(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(y,u){return y?new f(0,u.name):f._None}constructor(y,u){this.type=y,this.name=u,this._start=Date.now(),this._dep=[]}branch(y,u){const m=new f(2,y.toString());return this._dep.push([y,u,m]),m}stop(){const y=Date.now()-this._start;f._totals+=y;let u=!1;function m(d,l){const n=[],r=new Array(d+1).join("	");for(const[i,o,s]of l._dep)if(o&&s){u=!0,n.push(`${r}CREATES -> ${i}`);const h=m(d+1,s);h&&n.push(h)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(y>2||u)&&f.all.add(c.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[192],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,L){this.server=R,this.router=L}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,L){this.server.registerChannel(R,L)}}e.MessagePortMainProcessService=D}),define(ne[59],re([0,1,38,57,94,5]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(p,f,v,y){const u=v.getChannel(p);return P(f)?y.createInstance(new t.SyncDescriptor(f.channelClientCtor,[u])):D.ProxyChannel.toService(u,f?.proxyOptions)}}function P(S){return!!S?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let I=class extends T{constructor(p,f,v,y){super(p,f,v,y)}};I=pe([J(2,e.IMainProcessService),J(3,L.IInstantiationService)],I);function E(S,p,f){(0,R.registerSingleton)(S,new t.SyncDescriptor(I,[p,f],!0))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let C=class extends T{constructor(p,f,v,y){super(p,f,v,y)}};C=pe([J(2,e.ISharedProcessService),J(3,L.IInstantiationService)],C);function b(S,p,f){(0,R.registerSingleton)(S,new t.SyncDescriptor(C,[p,f],!0))}e.registerSharedProcessRemoteService=b}),define(ne[72],re([0,1,24,2,4,160,29,5]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let I=class extends t.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new D.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const p=b.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(v=>v.startsWith("lp-"))).map(f=>{const v=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,v,f),extensionId:f.identifier.id,galleryExtension:f}});return p.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),p}getLocale(C){return C.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C,b,S){const p=b??C;let f;if(p!==C&&(f=`(${C})`),C.toLowerCase()===R.language.toLowerCase()&&(f??="",f+=(0,L.localize)(0,null)),S?.installCount){f??="";const v=S.installCount;let y;v>1e6?y=`${Math.floor(v/1e5)/10}M`:v>1e3?y=`${Math.floor(v/1e3)}K`:y=String(v),f+=` $(cloud-download) ${y}`}return{id:C,label:p,description:f}}};I=pe([J(0,T.IExtensionGalleryService)],I),e.LanguagePackBaseService=I}),define(ne[193],re([0,1,2,72]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=pe([J(0,t.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(ne[8],re([0,1,37,3,2,40,4,7,5]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function E(){return new Date().toISOString()}var C;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(h,a,g){switch(a){case C.Trace:h.trace(g);break;case C.Debug:h.debug(g);break;case C.Info:h.info(g);break;case C.Warning:h.warn(g);break;case C.Error:h.error(g);break;case C.Critical:h.critical(g);break;default:throw new Error("Invalid log level")}}e.log=b;function S(h){let a="";for(let g=0;g<h.length;g++){let w=h[g];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}a+=(g>0?" ":"")+w}return a}e.format=S;class p extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class f extends p{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...g){this.checkLogLevel(C.Trace)&&this.log(C.Trace,S([a,...g]))}debug(a,...g){this.checkLogLevel(C.Debug)&&this.log(C.Debug,S([a,...g]))}info(a,...g){this.checkLogLevel(C.Info)&&this.log(C.Info,S([a,...g]))}warn(a,...g){this.checkLogLevel(C.Warning)&&this.log(C.Warning,S([a,...g]))}error(a,...g){if(this.checkLogLevel(C.Error))if(a instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=a.stack,this.log(C.Error,S(w))}else this.log(C.Error,S([a,...g]))}critical(a,...g){this.checkLogLevel(C.Critical)&&this.log(C.Critical,S([a,...g]))}flush(){}}e.AbstractMessageLogger=f;class v extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!T.isWindows}trace(a,...g){this.getLevel()<=C.Trace&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...g):console.log(`[main ${E()}]`,a,...g))}debug(a,...g){this.getLevel()<=C.Debug&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...g):console.log(`[main ${E()}]`,a,...g))}info(a,...g){this.getLevel()<=C.Info&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,a,...g):console.log(`[main ${E()}]`,a,...g))}warn(a,...g){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,a,...g):console.warn(`[main ${E()}]`,a,...g))}error(a,...g){this.getLevel()<=C.Error&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,a,...g):console.error(`[main ${E()}]`,a,...g))}critical(a,...g){this.getLevel()<=C.Critical&&(this.useColors?console.error(`\x1B[90m[main ${E()}]\x1B[0m`,a,...g):console.error(`[main ${E()}]`,a,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class y extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...g){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",a,...g)}debug(a,...g){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...g)}info(a,...g){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",a,...g)}warn(a,...g){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",a,...g)}error(a,...g){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",a,...g)}critical(a,...g){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...g)}dispose(){}flush(){}}e.ConsoleLogger=y;class u extends p{constructor(a,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(g)}trace(a,...g){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(a),...g])}debug(a,...g){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(a),...g])}info(a,...g){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(a),...g])}warn(a,...g){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(a),...g])}error(a,...g){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(a),...g])}critical(a,...g){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(a),...g])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class m extends p{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const g of this.logServices)g.setLevel(a);super.setLevel(a)}trace(a,...g){for(const w of this.logServices)w.trace(a,...g)}debug(a,...g){for(const w of this.logServices)w.debug(a,...g)}info(a,...g){for(const w of this.logServices)w.info(a,...g)}warn(a,...g){for(const w of this.logServices)w.warn(a,...g)}error(a,...g){for(const w of this.logServices)w.error(a,...g)}critical(a,...g){for(const w of this.logServices)w.critical(a,...g)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=m;class c extends R.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...g){this.logger.trace(a,...g)}debug(a,...g){this.logger.debug(a,...g)}info(a,...g){this.logger.info(a,...g)}warn(a,...g){this.logger.warn(a,...g)}error(a,...g){this.logger.error(a,...g)}critical(a,...g){this.logger.critical(a,...g)}flush(){this.logger.flush()}}e.LogService=c;class d extends R.Disposable{constructor(a,g){super(),this.logLevel=a,this.loggerItems=new L.ResourceMap,this._register(g(w=>this.setLevel(w)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,g,w){let A=this.loggerItems.get(a)?.logger;return A||(w=g?.always?C.Trace:w,A=this.doCreateLogger(a,w??this.logLevel,g),this.loggerItems.set(a,{logger:A,logLevel:w})),A}setLevel(a,g){const w=P.URI.isUri(a)?a:void 0,A=w?g:a;if(w){const F=this.loggerItems.get(w);F&&F.logLevel!==A&&(F.logLevel=A,F.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:F,logger:_})=>{F===void 0&&_.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=d;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...g){}debug(a,...g){}info(a,...g){}warn(a,...g){}error(a,...g){}critical(a,...g){}dispose(){}flush(){}}e.NullLogger=l;class n extends l{}e.NullLogService=n;class r extends d{constructor(){super(C.Info,t.Event.None)}doCreateLogger(a,g,w){return new l}}e.NullLoggerService=r;function i(h){if(h.verbose)return C.Trace;if(typeof h.logLevel=="string"){const a=o(h.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function o(h){switch(h){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=o;function s(h){switch(h){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=s}),define(ne[194],re([0,1,6,9,2,10,28,13,8]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(b,S){super(),this.environmentService=b,this.logService=S,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,L.basename)(this.environmentService.logsPath),S=(0,L.dirname)(this.environmentService.logsPath),v=(await T.Promises.readdir(S)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==b),y=v.slice(0,Math.max(0,v.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(u=>T.Promises.rm((0,L.join)(S,u)))))}catch(b){(0,t.onUnexpectedError)(b)}}};E=pe([J(0,P.IEnvironmentService),J(1,I.ILogService)],E),e.LogsDataCleaner=E}),define(ne[195],re([0,1,18,6,9,3,2,10,58,8]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(S,p){super(),this.logService=S,this.options=p,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,p):this.watchNonRecursive(S,p)}watchUniversal(S,p){const f={path:this.toFilePath(S),excludes:p.excludes,includes:p.includes,recursive:p.recursive},v=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,I.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const p of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const p of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(p)&&S.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,p){const f={path:this.toFilePath(S),excludes:p.excludes,includes:p.includes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,I.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,P.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(ne[196],re([0,1,18,6,17,24,3,66,54,2,48,22,197,19,42,156,14,100,8]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends E.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,n){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${l}`);const r=new E.DisposableStore;return this.provider.set(l,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:n}),r.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new y.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:n}),this.provider.delete(l),(0,E.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){n.push(r)}}),!this.provider.has(l)&&await t.Promises.settled(n)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,n){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return I.Iterable.map(this.provider,([l,n])=>({scheme:l,capabilities:n.capabilities}))}async withProvider(l){if(!(0,p.isAbsolutePath)(l))throw new y.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const n=this.provider.get(l.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,v.localize)(1,null,l.toString()),r}return n}async withReadProvider(l){const n=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)||(0,y.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const n=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,n){try{return await this.doResolveFile(l,n)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(l,n){const r=await this.withProvider(l),i=this.isPathCaseSensitive(r),o=n?.resolveTo,s=n?.resolveSingleChildDescendants,h=n?.resolveMetadata,a=await r.stat(l);let g;return this.toFileStat(r,l,a,void 0,!!h,(w,A)=>(g||(g=C.TernarySearchTree.forUris(()=>!i),g.set(l,!0),o&&g.fill(!0,o)),g.get(w.resource)||g.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&s?A===1:!1))}async toFileStat(l,n,r,i,o,s){const{providerExtUri:h}=this.getExtUri(l),a={resource:n,name:h.basename(n),isFile:(r.type&y.FileType.File)!==0,isDirectory:(r.type&y.FileType.Directory)!==0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const g=await l.readdir(n),w=await t.Promises.settled(g.map(async([A,F])=>{try{const _=h.joinPath(n,A),N=o?await l.stat(_):{type:F};return await this.toFileStat(l,_,N,g.length,o,s)}catch(_){return this.logService.trace(_),null}}));a.children=(0,D.coalesce)(w)}catch(g){this.logService.trace(g),a.children=[]}return a}return a}async resolveAll(l){return t.Promises.settled(l.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const n=await this.withProvider(l),r=await n.stat(l);return this.toFileStat(n,l,r,void 0,!0,()=>!1)}async exists(l){const n=await this.withProvider(l);try{return!!await n.stat(l)}catch{return!1}}async canCreateFile(l,n){try{await this.doValidateCreateFile(l,n)}catch(r){return r}return!0}async doValidateCreateFile(l,n){if(!n?.overwrite&&await this.exists(l))throw new y.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,n)}async createFile(l,n=R.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const i=await this.writeFile(l,n);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,i)),i}async writeFile(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,l,r)||await this.mkdirp(i,o.dirname(l));let h;if((0,y.hasReadWriteCapability)(i)&&!(n instanceof R.VSBuffer))if((0,f.isReadableStream)(n)){const a=await(0,f.peekStream)(n,3);a.ended?h=R.VSBuffer.concat(a.buffer):h=a}else h=(0,f.peekReadable)(n,a=>R.VSBuffer.concat(a),3);else h=n;!(0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)&&h instanceof R.VSBuffer?await this.doWriteUnbuffered(i,l,r,h):await this.doWriteBuffered(i,l,r,h instanceof R.VSBuffer?(0,R.bufferToReadable)(h):h),this._onDidRunOperation.fire(new y.FileOperationEvent(l,4))}catch(s){throw new y.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,n,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(n)));let o;try{o=await l.stat(n)}catch{return}if((o.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,v.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:o.size}))throw new y.FileOperationError((0,v.localize)(7,null),3,r);return o}async readFile(l,n,r){const i=await this.withReadProvider(l);return n?.atomic?this.doReadFileAtomic(i,l,n,r):this.doReadFile(i,l,n,r)}async doReadFileAtomic(l,n,r,i){return new Promise((o,s)=>{this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{try{const h=await this.doReadFile(l,n,r,i);o(h)}catch(h){s(h)}})})}async doReadFile(l,n,r,i){const o=await this.doReadFileStream(l,n,{...r,preferUnbuffered:!0},i);return{...o,value:await(0,R.streamToBuffer)(o.value)}}async readFileStream(l,n,r){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,n,r)}async doReadFileStream(l,n,r,i){const o=new L.CancellationTokenSource(i),s=this.validateReadFile(n,r).then(a=>a,a=>{throw o.cancel(),a});let h;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await s,r?.atomic&&(0,y.hasFileAtomicReadCapability)(l)||!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&r?.preferUnbuffered?h=this.readFileUnbuffered(l,n,r):(0,y.hasFileReadStreamCapability)(l)?h=this.readFileStreamed(l,n,o.token,r):h=this.readFileBuffered(l,n,o.token,r),{...await s,value:h}}catch(a){h&&await(0,f.consumeStream)(h);const g=(0,v.localize)(8,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(g,a.stat,r):new y.FileOperationError(g,(0,y.toFileOperationResult)(a),r)}}readFileStreamed(l,n,r,i=Object.create(null)){const o=l.readFileStream(n,i,r);return(0,f.transform)(o,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,v.localize)(9,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),i)},s=>R.VSBuffer.concat(s))}readFileBuffered(l,n,r,i=Object.create(null)){const o=(0,R.newWriteableBufferStream)();return(0,u.readFileIntoStream)(l,n,o,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,v.localize)(10,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),i)},r),o}readFileUnbuffered(l,n,r){const i=(0,f.newWriteableStream)(o=>R.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,y.hasFileAtomicReadCapability)(l)?o=await l.readFile(n,{atomic:!0}):o=await l.readFile(n),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.validateReadFileLimits(n,o.byteLength,r),i.end(R.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(l,n){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&n.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,v.localize)(12,null),r,n);return this.validateReadFileLimits(l,r.size,n),r}validateReadFileLimits(l,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new y.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,n,r){return this.doCanMoveCopy(l,n,"move",r)}async canCopy(l,n,r){return this.doCanMoveCopy(l,n,"copy",r)}async doCanMoveCopy(l,n,r,i){if(l.toString()!==n.toString())try{const o=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,l,s,n,r,i)}catch(o){return o}return!0}async move(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,l,o,n,"move",!!r),h=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,s==="move"?2:3,h)),h}async copy(l,n,r){const i=await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,l,o,n,"copy",!!r),h=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,s==="copy"?3:2,h)),h}async doMoveCopy(l,n,r,i,o,s){if(n.toString()===i.toString())return o;const{exists:h,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,n,r,i,o,s);if(h&&!a&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),o==="copy"){if(l===r&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(n,i,{overwrite:s});else{const g=await this.resolve(n);g.isDirectory?await this.doCopyFolder(l,g,r,i):await this.doCopyFile(l,n,r,i)}return o}else return l===r?(await l.rename(n,i,{overwrite:s}),o):(await this.doMoveCopy(l,n,r,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(l,n,r,i){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,n,r,i);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,n,r,i);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,n,r,i);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,n,r,i)}async doCopyFolder(l,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async o=>{const s=this.getExtUri(r).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(l,await this.resolve(o.resource),r,s):this.doCopyFile(l,o.resource,r,s)}))}async doValidateMoveCopy(l,n,r,i,o,s){let h=!1;if(l===r){const{providerExtUri:g,isPathCaseSensitive:w}=this.getExtUri(l);if(w||(h=g.isEqual(n,i)),h&&o==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!h&&g.isEqualOrParent(i,n))throw new Error((0,v.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!h){if(!s)throw new y.FileOperationError((0,v.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(l===r){const{providerExtUri:g}=this.getExtUri(l);if(g.isEqualOrParent(n,i))throw new Error((0,v.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const n=this.isPathCaseSensitive(l);return{providerExtUri:n?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(n,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,r)),r}async mkdirp(l,n){const r=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(n,i.dirname(n));)try{if(((await l.stat(n)).type&y.FileType.Directory)===0)throw new Error((0,v.localize)(18,null,this.resourceForError(n)));break}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(i.basename(n)),n=i.dirname(n)}for(let o=r.length-1;o>=0;o--){n=i.joinPath(n,r[o]);try{await l.mkdir(n)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,n){try{await this.doValidateDelete(l,n)}catch(r){return r}return!0}async doValidateDelete(l,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));let o;try{o=await r.stat(l)}catch{}if(o)this.throwIfFileIsReadonly(l,o);else throw new y.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!n?.recursive){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return r}async del(l,n){const r=await this.doValidateDelete(l,n),i=!!n?.useTrash,o=!!n?.recursive;await r.delete(l,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}async cloneFile(l,n){const r=await this.withProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(l,n))return;if(r===i&&(0,y.hasFileCloneCapability)(r))return r.cloneFile(l,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const o=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===i&&(0,y.hasFileFolderCopyCapability)(r)?o.queue(()=>r.copy(l,n,{overwrite:!0})):o.queue(()=>this.doCopyFile(r,l,i,n))}watch(l,n={recursive:!1,excludes:[]}){const r=new E.DisposableStore;let i=!1,o=()=>{i=!0};return r.add((0,E.toDisposable)(()=>o())),(async()=>{try{const s=await this.doWatch(l,n);i?(0,E.dispose)(s):o=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(l,n){const r=await this.withProvider(l),i=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:r.watch(l,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,E.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,E.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{const o=await l.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,f.isReadableStream)(i)||(0,f.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,o,i):await this.doWriteReadableBufferedQueued(l,o,i)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await l.close(o)}})}async doWriteStreamBufferedQueued(l,n,r){let i=0,o;if((0,f.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=R.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,n,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((s,h)=>{(0,f.listenStream)(o,{onData:async a=>{o.pause();try{await this.doWriteBuffer(l,n,a,a.byteLength,i,0)}catch(g){return h(g)}i+=a.byteLength,setTimeout(()=>o.resume())},onError:a=>h(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,n,r){let i=0,o;for(;(o=r.read())!==null;)await this.doWriteBuffer(l,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(l,n,r,i,o,s){let h=0;for(;h<i;)h+=await l.write(n,o+h,r.buffer,s+h,i-h)}async doWriteUnbuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,n,r,i))}async doWriteUnbufferedQueued(l,n,r,i){let o;i instanceof R.VSBuffer?o=i:(0,f.isReadableStream)(i)?o=await(0,R.streamToBuffer)(i):(0,f.isReadableBufferedStream)(i)?o=await(0,R.bufferedStreamToBuffer)(i):o=(0,R.readableToBuffer)(i),await l.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,n,r,i))}async doPipeBufferedQueued(l,n,r,i){let o,s;try{o=await l.open(n,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const h=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,g=0,w=0;do w=await l.read(o,a,h.buffer,g,h.byteLength-g),await this.doWriteBuffer(r,s,h,w,a,g),a+=w,g+=w,g===h.byteLength&&(g=0);while(w>0)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await t.Promises.settled([typeof o=="number"?l.close(o):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,n,r,i))}async doPipeUnbufferedQueued(l,n,r,i){return r.writeFile(i,await l.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,n,r,i))}async doPipeUnbufferedToBufferedQueued(l,n,r,i){const o=await r.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(n);await this.doWriteBuffer(r,o,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await r.close(o)}}async doPipeBufferedToUnbuffered(l,n,r,i){const o=await(0,R.streamToBuffer)(this.readFileBuffered(l,n,L.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,o)}throwIfFileSystemIsReadonly(l,n){if(l.capabilities&2048)throw new y.FileOperationError((0,v.localize)(22,null,this.resourceForError(n)),6);return l}throwIfFileIsReadonly(l,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,v.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===b.Schemas.file?l.fsPath:l.toString(!0)}};c=pe([J(0,m.ILogService)],c),e.FileService=c}),define(ne[198],re([0,1,55,283,6,40,17,3,47,2,10,4,19,42,28,159,14,100,195,37,190,189]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(r)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,s),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await f.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(o.map(async h=>{try{let a;h.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(i,h.name))).type:a=this.toType(h),s.push([h.name,a])}catch(a){this.logService.trace(a)}})),s}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let s;return o?.dangling?s=y.FileType.Unknown:i.isFile()?s=y.FileType.File:i.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,o&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(i){const o=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let s;for(;s=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await s.wait();const h=new R.Barrier;return this.resourceLocks.set(i,h),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,E.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===h&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),h.open()})}async readFile(i,o){let s;try{o?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const h=this.toFilePath(i);return await f.Promises.readFile(h)}catch(h){throw this.toFileSystemProviderError(h)}finally{s?.dispose()}}traceLock(i){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,o,s){const h=(0,p.newWriteableStream)(a=>T.VSBuffer.concat(a.map(g=>T.VSBuffer.wrap(g))).buffer);return(0,u.readFileIntoStream)(this,i,h,a=>a.buffer,{...o,bufferSize:256*1024},s),h}async writeFile(i,o,s){let h;try{const a=this.toFilePath(i);if(!s.create||!s.overwrite){if(await f.Promises.exists(a)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,v.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,v.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof h=="number"&&await this.close(h)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,o){const s=this.toFilePath(i);let h;(0,y.isFileOpenForWriteOptions)(o)&&(h=await this.createResourceLock(i));let a;try{if((0,y.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:w}=await f.SymlinkSupport.stat(s);w.mode&128||await f.Promises.chmod(s,w.mode|128)}catch(w){this.logService.trace(w)}let g;if((0,y.isFileOpenForWriteOptions)(o)){if(b.isWindows)try{await f.Promises.truncate(s,0),g="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}g||(g="w")}else g="r";a=await f.Promises.open(s,g)}catch(g){throw h?.dispose(),(0,y.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(a,0),(0,y.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(a,i),h){const g=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,h),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),g.dispose())}return a}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await f.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,s,h,a){const g=this.normalizePos(i,o);let w=null;try{w=(await f.Promises.read(i,s,h,a,g)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(i,g,w)}return w}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,s){const h=this.mapHandleToPos.get(i);typeof h=="number"&&(typeof o=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,h+s):this.mapHandleToPos.delete(i)))}async write(i,o,s,h,a){return(0,R.retry)(()=>this.doWrite(i,o,s,h,a),100,3)}async doWrite(i,o,s,h,a){const g=this.normalizePos(i,o);let w=null;try{w=(await f.Promises.write(i,s,h,a,g)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),A)}finally{this.updatePos(i,g,w)}return w}async mkdir(i){try{await f.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const s=this.toFilePath(i);o.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,o,s){const h=this.toFilePath(i),a=this.toFilePath(o);if(h!==a)try{await this.validateTargetDeleted(i,o,"move",s.overwrite),await f.Promises.move(h,a)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(2,null,(0,C.basename)(h),(0,C.basename)((0,C.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,o,s){const h=this.toFilePath(i),a=this.toFilePath(o);if(h!==a)try{await this.validateTargetDeleted(i,o,"copy",s.overwrite),await f.Promises.copy(h,a,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(3,null,(0,C.basename)(h),(0,C.basename)((0,C.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,o,s,h){const a=this.toFilePath(i),g=this.toFilePath(o);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(a,g,!0)),w&&s==="copy")throw(0,y.createFileSystemProviderError)((0,v.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!w&&await f.Promises.exists(g)){if(!h)throw(0,y.createFileSystemProviderError)((0,v.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,s){const h=this.toFilePath(i),a=this.toFilePath(o),g=!!(this.capabilities&1024);if((0,I.isEqual)(h,a,!g))return;const w=new E.DisposableStore;try{const[A,F]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);w.add(A),w.add(F),s&&await f.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await f.Promises.copyFile(h,a)}catch(A){if(A.code==="ENOENT"&&!s)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(A)}finally{w.dispose()}}createUniversalWatcher(i,o,s){return new d.UniversalWatcherClient(h=>i(h),h=>o(h),s)}createNonRecursiveWatcher(i,o,s){return new l.NodeJSWatcherClient(h=>i(h),h=>o(h),s)}toFileSystemProviderError(i){if(i instanceof y.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=y.FileSystemProviderErrorCode.NoPermissions;break;default:o=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let s=this.toFileSystemProviderError(o);if(i&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await f.SymlinkSupport.stat(this.toFilePath(i));h.mode&128||(s=(0,y.createFileSystemProviderError)(o,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(ne[101],re([0,1,6,3,2,5,8]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,L.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(E){super(),this.logService=E,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new t.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(C){E.push(C)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(E)}catch(C){this.logService.error(C)}})(),this.pendingWillShutdownPromise}};P=pe([J(0,T.ILogService)],P),e.SharedProcessLifecycleService=P}),define(ne[102],re([0,1,3,7,8]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(S,p){this.logService=S,this.loggerService=p,this.onDidChangeLogLevel=D.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(S,p,f){switch(p){case"setLevel":return f[1]?this.loggerService.setLevel(t.URI.revive(f[1]),f[0]):this.logService.setLevel(f[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=L;class T{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S,p){T.setLevel(this.channel,S,p)}static setLevel(S,p,f){return S.call("setLevel",[p,f])}}e.LogLevelChannelClient=T;class P{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,p){throw new Error(`Event not found: ${p}`)}async call(S,p,f){switch(p){case"createLogger":this.createLogger(t.URI.revive(f[0]),f[1]);return;case"log":return this.log(t.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${p}`)}createLogger(S,p){this.loggers.set(S.toString(),this.loggerService.createLogger(S,p))}consoleLog(S,p){let f=console.log;switch(S){case R.LogLevel.Error:f=console.error;break;case R.LogLevel.Warning:f=console.warn;break;case R.LogLevel.Info:f=console.info;break}f.call(console,...p)}log(S,p){const f=this.loggers.get(S.toString());if(!f)throw new Error("Create the logger before logging");for(const[v,y]of p)(0,R.log)(f,v,y)}}e.LoggerChannel=P;class I extends R.AbstractLoggerService{constructor(S,p,f){super(S,p),this.channel=f}createConsoleMainLogger(){return new R.AdapterLogger({log:(S,p)=>{this.channel.call("consoleLog",[S,p])}})}doCreateLogger(S,p,f){return new E(this.channel,S,p,f)}}e.LoggerChannelClient=I;class E extends R.AbstractMessageLogger{constructor(S,p,f,v){super(v?.always),this.channel=S,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[p,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,p){const f=[[S,p]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(S){this.channel.call("log",[this.file,S])}}class C extends R.LogService{constructor(S,p){super(p),this.parent=S,this._register(S.onDidChangeLogLevel(f=>p.setLevel(f)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=C}),define(ne[60],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[61],re([0,1,3,54,2,5]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(E){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(E),t.Iterable.reduce(this.policies.entries(),(b,[S,p])=>({...b,[S]:p}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[C,b])=>({...E,[C]:{definition:b,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[199],re([0,1,3,2,61]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(I){this.service=I,this.disposables=new t.DisposableStore}listen(I,E){switch(E){case"onDidChange":return D.Event.map(this.service.onDidChange,C=>C.reduce((b,S)=>({...b,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(I,E,C){switch(E){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends R.AbstractPolicyService{constructor(I,E){super(),this.channel=E;for(const C in I){const{definition:b,value:S}=I[C];this.policyDefinitions[C]=b,S!==void 0&&this.policies.set(C,S)}this.channel.listen("onDidChange")(C=>{for(const b in C){const S=C[b];S===null?this.policies.delete(b):this.policies.set(b,S)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(I){const E=await this.channel.call("registerPolicyDefinitions",I);for(const C in E)this.policies.set(C,E[C])}}e.PolicyChannelClient=T}),define(ne[103],re([0,1,22,4,36,19]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",Q));if(T=Q.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=Q.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);Object.assign(T,{version:I.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[25],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[200],re([0,1,6,9,2,10,28,8,25]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(b,S,p){super(),this.productService=S,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),p=(0,L.dirname)(b),f=(0,L.basename)(b),v=await T.Promises.readdir(p);await Promise.all(v.map(async y=>{if(y===f)return;const u=(0,L.join)(p,y),m=await T.Promises.stat(u);if(m.isDirectory()&&S-m.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),T.Promises.rm(u)}))}catch(S){(0,t.onUnexpectedError)(S)}}};E=pe([J(1,I.IProductService),J(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[201],re([0,1,6,9,2,10,28,13,8,25]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends R.Disposable{constructor(S,p,f){super(),this.environmentService=S,this.logService=p,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),p=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(p)){const c=p[m];S[`${c.hash}.${m}`]=!0}const f=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(f))return;const y=await T.Promises.readdir(f);for(const m of y){if(S[m]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await T.Promises.rm((0,L.join)(f,m))}const u=Date.now();for(const m of Object.keys(S)){const c=(0,L.join)(f,m),d=await T.Promises.readdir(c);for(const l of d){if(l==="tcf.json")continue;const n=(0,L.join)(c,l),r=await T.Promises.stat(n);r.isDirectory()&&u-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(m,l)}`),await T.Promises.rm(n))}}}catch(S){(0,t.onUnexpectedError)(S)}}};C=pe([J(0,P.INativeEnvironmentService),J(1,I.ILogService),J(2,E.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(ne[202],re([0,1,10,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var R;(function(L){function T(I){return Boolean(I.samples&&I.timeDeltas)}L.isValidProfile=T;function P(I,E="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,D.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.join)(E,(0,D.basename)(C.callFrame.url)));return I}L.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(ne[203],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((E,C)=>{Q(["v8-inspect-profiler"],E,C)})).startProfiling({port:L.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this._sessions.set(I,P),I}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const P=await T.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=t}),define(ne[39],re([0,1,120,15]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(T,P){D.ok(t.isString(T)),D.ok(t.isObject(P)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new R}),define(ne[104],re([0,1,3,39]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,E){this.schemasById[R(I)]=E,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;t.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],re([0,1,18,3,15,145,16,104,39]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.doRegisterConfigurations(n,r);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=this.doDeregisterConfigurations(n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(n,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:o,source:s}of n)for(const h in o)if(r.push(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const a=this.configurationDefaultsOverrides.get(h),g=a?.valuesSources??new Map;if(s)for(const _ of Object.keys(o[h]))g.set(_,s);const w={...a?.value||{},...o[h]};this.configurationDefaultsOverrides.set(h,{source:s,value:w,valuesSources:g});const A=(0,T.getLanguageTagSettingPlainKey)(h),F={type:"object",default:w,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:R.isString(s)?void 0:s,defaultValueSource:s};i.push(...v(h)),this.configurationProperties[h]=F,this.defaultLanguageConfigurationOverridesNode.properties[h]=F}else{this.configurationDefaultsOverrides.set(h,{value:o[h],source:s});const a=this.configurationProperties[h];a&&(this.updatePropertyDefaultValue(h,a),this.updateSchema(h,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:o}of n)for(const s in i){const h=this.configurationDefaultsOverrides.get(s),a=R.isString(o)?o:o?.id,g=R.isString(h?.source)?h?.source:h?.source?.id;if(a===g)if(r.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const w=this.configurationProperties[s];w&&(this.updatePropertyDefaultValue(s,w),this.updateSchema(s,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,r,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const r=[],i=o=>{if(o.properties)for(const s in o.properties){r.push(s);const h=this.configurationProperties[s];h?.policy?.name&&this.policyConfigurations.delete(h.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s])}o.allOf?.forEach(s=>i(s))};for(const o of n){i(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}return r}validateAndRegisterProperties(n,r=!0,i,o,s=3){s=R.isUndefinedOrNull(n.scope)?s:n.scope;const h=[],a=n.properties;if(a)for(const w in a){const A=a[w];if(r&&c(w,A)){delete a[w];continue}if(A.source=i,A.defaultDefaultValue=a[w].default,this.updatePropertyDefaultValue(w,A),e.OVERRIDE_PROPERTY_REGEX.test(w)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!o?.includes(w):A.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.excludedConfigurationProperties[w]=a[w],delete a[w];continue}else this.configurationProperties[w]=a[w],a[w].policy?.name&&this.policyConfigurations.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),h.push(w)}const g=n.allOf;if(g)for(const w of g)h.push(...this.validateAndRegisterProperties(w,r,i,o,s));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const o=i.properties;if(o)for(const h in o)this.updateSchema(h,o[h]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,s=i?.source;R.isUndefined(o)&&(o=r.defaultDefaultValue,s=void 0),R.isUndefined(o)&&(o=u(r.type)),r.default=o,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(l){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=f.exec(l);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=f.exec(l)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=v;function y(l){return l.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new S;I.Registry.add(e.Extensions.Configuration,m);function c(l,n){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):m.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,l,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=c;function d(){const l=[],n=m.getConfigurationProperties();for(const r of Object.keys(n))l.push([r,n[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=d}),define(ne[73],re([0,1,18,3,35,2,40,32,15,7,16,43,39]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(r={},i=[],o=[],s){this._contents=r,this._keys=i,this._overrides=o,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof p)return i;const o=new f("");return o.parseRaw(i),o.configurationModel});this._rawConfiguration=r.reduce((i,o)=>o===i?o:i.merge(o),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const o=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,h=i?this.rawConfiguration.override(i).getValue(r):o;return{value:o,override:s,merged:h}}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,C.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return D.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return D.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),s=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const a of r)if(h.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(i,a.contents);for(const g of a.overrides){const[w]=o.filter(A=>D.equals(A.identifiers,g.identifiers));w?(this.mergeContents(w.contents,g.contents),w.keys.push(...g.keys),w.keys=D.distinct(w.keys)):o.push(P.deepClone(g))}for(const g of a.keys)s.indexOf(g)===-1&&s.push(g)}return new p(i,s,o,h.every(a=>a instanceof p)?void 0:h)}freeze(){return this.frozen=!0,this}clone(){return new p(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[s];const a=i[s];a&&(typeof h=="object"&&typeof a=="object"?(h=P.deepClone(h),this.mergeContents(h,a)):h=a),o[s]=h}return new p(o,this.keys,this.overrides)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&I.isObject(r[o])&&I.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=P.deepClone(i[o])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,o=null;const s=h=>{h&&(o?this.mergeContents(o,h):o=P.deepClone(h))};for(const h of this.overrides)D.equals(h.identifiers,[r])?i=h.contents:h.identifiers.includes(r)&&s(h.contents);return s(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,C.addToValueTree)(this.contents,r,i,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,C.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let o=0;o<i;o++)r.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class f{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!I.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:s,overrides:h,restricted:a,hasExcludedProperties:g}=this.doParseRaw(r,i);this._configurationModel=new p(o,s,h,g?[r]:void 0),this._restrictedConfigurations=a||[]}doParseContent(r){let i={},o=null,s=[];const h=[],a=[];function g(A){Array.isArray(s)?s.push(A):o!==null&&(s[o]=A)}const w={onObjectBegin:()=>{const A={};g(A),h.push(s),s=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const A=[];g(A),h.push(s),s=A,o=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:g,onError:(A,F,_)=>{a.push({error:A,offset:F,length:_})}};if(r)try{R.visit(r,w),i=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(r,i){const o=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,i);r=s.raw;const h=(0,C.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),a=Object.keys(r),g=this.toOverrides(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:h,keys:a,overrides:g,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(r,i,o,s){let h=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:h};const a={},g=[];for(const w in r)if(b.OVERRIDE_PROPERTY_REGEX.test(w)&&o){const A=this.filter(r[w],i,!1,s);a[w]=A.raw,h=h||A.hasExcludedProperties,g.push(...A.restricted)}else{const A=i[w],F=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&g.push(w),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&!(s.skipRestricted&&A?.restricted)?a[w]=r[w]:h=!0}return{raw:a,restricted:g,hasExcludedProperties:h}}toOverrides(r,i){const o=[];for(const s of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(s)){const h={};for(const a in r[s])h[a]=r[s][a];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(h),contents:(0,C.toValuesTree)(h,i)})}return o}}e.ConfigurationModelParser=f;class v extends L.Disposable{constructor(r,i,o,s){super(),this.userSettingsResource=r,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&o.isEqual(h.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class y{constructor(r,i,o,s,h,a,g,w,A,F,_,N,W){this.key=r,this.overrides=i,this.value=o,this.overrideIdentifiers=s,this.defaultConfiguration=h,this.policyConfiguration=a,this.applicationConfiguration=g,this.userConfiguration=w,this.localUserConfiguration=A,this.remoteUserConfiguration=F,this.workspaceConfiguration=_,this.folderConfigurationModel=N,this.memoryInspectValue=W}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(r,i,o,s,h=new p,a=new p,g=new T.ResourceMap,w=new p,A=new T.ResourceMap,F=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=s,this._remoteUserConfiguration=h,this._workspaceConfiguration=a,this._folderConfigurations=g,this._memoryConfiguration=w,this._memoryConfigurationByResource=A,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidatedConfigurationModel(r,i,o).getValue(r)}updateValue(r,i,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new p,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(r):s.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const s=this.getConsolidatedConfigurationModel(r,i,o),h=D.distinct(s.overrides.map(w=>w.identifiers).flat()).filter(w=>s.getOverrideValue(r,w)!==void 0),a=this.getFolderConfigurationModelForResource(i.resource,o),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration;return new y(r,i,s.getValue(r),h.length?h:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,g.inspect(r,i.overrideIdentifier))}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];if(!i){const{added:s,updated:h,removed:a}=d(this._defaultConfiguration,r);i=[...s,...h,...a]}for(const s of i)for(const h of(0,b.overrideIdentifiersFromKey)(s)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(h),g=r.getKeysForOverrideIdentifier(h),w=[...g.filter(A=>a.indexOf(A)===-1),...a.filter(A=>g.indexOf(A)===-1),...a.filter(A=>!P.equals(this._defaultConfiguration.override(h).getValue(A),r.override(h).getValue(A)))];o.push([h,w])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:o,removed:s}=d(this._policyConfiguration,r),h=[...i,...o,...s];return h.length&&this.updatePolicyConfiguration(r),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:o,removed:s,overrides:h}=d(this.applicationConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:h}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:s,overrides:h}=d(this.localUserConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:h}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:s,overrides:h}=d(this.remoteUserConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:h}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:s,overrides:h}=d(this.workspaceConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:h}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:s,updated:h,removed:a,overrides:g}=d(o,i),w=[...s,...h,...a];return(w.length||!o)&&this.updateFolderConfiguration(r,i),{keys:w,overrides:g}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:h,overrides:a}=d(i,void 0);return{keys:[...o,...s,...h],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,o){let s=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const s=i.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const h=this._memoryConfigurationByResource.get(r);h&&(o=o.merge(h))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(i=o.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:s,keys:h}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:s,keys:h}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.policy),s=this.parseConfigurationModel(r.application),h=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),g=r.folders.reduce((w,A)=>(w.set(E.URI.revive(A[0]),this.parseConfigurationModel(A[1])),w),new T.ResourceMap);return new u(i,o,s,h,new p,a,g,new p,new T.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function m(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const s of n)s.keys.forEach(h=>r.add(h)),s.overrides.forEach(([h,a])=>{const g=(0,T.getOrSet)(i,h,new Set);a.forEach(w=>g.add(w))});const o=[];return i.forEach((s,h)=>o.push([h,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=m;class c{constructor(r,i,o,s){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const h=new Set;r.keys.forEach(g=>h.add(g)),r.overrides.forEach(([,g])=>g.forEach(w=>h.add(w))),this.affectedKeys=[...h.values()];const a=new p;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let o=(0,C.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=c;function d(n,r){const{added:i,removed:o,updated:s}=l(r?.rawConfiguration,n?.rawConfiguration),h=[],a=n?.getAllOverrideIdentifiers()||[],g=r?.getAllOverrideIdentifiers()||[];if(r){const w=g.filter(A=>!a.includes(A));for(const A of w)h.push([A,r.getKeysForOverrideIdentifier(A)])}if(n){const w=a.filter(A=>!g.includes(A));for(const A of w)h.push([A,n.getKeysForOverrideIdentifier(A)])}if(r&&n){for(const w of a)if(g.includes(w)){const A=l({contents:n.getOverrideValue(void 0,w)||{},keys:n.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});h.push([w,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:o,updated:s,overrides:h}}function l(n,r){const i=n?r?n.keys.filter(h=>r.keys.indexOf(h)===-1):[...n.keys]:[],o=r?n?r.keys.filter(h=>n.keys.indexOf(h)===-1):[...r.keys]:[],s=[];if(n&&r){for(const h of r.keys)if(n.keys.indexOf(h)!==-1){const a=(0,C.getConfigurationValue)(r.contents,h),g=(0,C.getConfigurationValue)(n.contents,h);P.equals(a,g)||s.push(h)}}return{added:i,removed:o,updated:s}}}),define(ne[204],re([0,1,18,3,2,32,15,16,73,43,8,61,39]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.onDidUpdateConfiguration(m,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(m,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=p;class f extends I.ConfigurationModel{constructor(m={}){const c=S.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(c),l=Object.create(null),n=[];for(const r in c){const i=m[r],o=i!==void 0?i:c[r].default;(0,P.addToValueTree)(l,r,o,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(l))E.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,E.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,P.toValuesTree)(l[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,d,n)}}e.DefaultConfigurationModel=f;class v{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let y=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(m,c,d){super(),this.defaultConfiguration=m,this.policyService=c,this.logService=d,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.registerPolicyDefinitions(m),!0))),this._configurationModel}async registerPolicyDefinitions(m){const c={},d=[],l=S.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const n of m){const r=l[n];if(!r){d.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}d.push(n),c[r.policy.name]={type:r.type}}}return(0,T.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),d}onDidChangePolicies(m){const c=S.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),d=(0,D.coalesce)(m.map(l=>c.get(l)));this.update(d,!0)}update(m,c){const d=S.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),l=[],n=this._configurationModel.isEmpty();for(const r of m){const i=d[r]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(n?o!==void 0:!(0,L.equals)(this._configurationModel.getValue(r),o))&&l.push([r,o])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,o]of l)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=pe([J(1,b.IPolicyService),J(2,C.ILogService)],y),e.PolicyConfiguration=y}),define(ne[205],re([0,1,6,3,2,19,16,73,204,61]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends R.Disposable{constructor(S,p,f,v){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=f instanceof E.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,f,v)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:u})=>this.onDidDefaultConfigurationChange(y,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,p,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(S,p,new P.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(S,p){const f=typeof S=="string"?S:void 0,v=(0,T.isConfigurationOverrides)(S)?S:(0,T.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(f,v,void 0)}updateValue(S,p,f,v){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const p=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(f,p,2)}onDidDefaultConfigurationChange(S,p){const f=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(S,p);this.trigger(v,f,7)}onDidPolicyConfigurationChange(S){const p=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(f,p,7)}trigger(S,p,f){const v=new P.ConfigurationChangeEvent(S,{data:p},this.configuration);v.source=f,v.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(ne[206],re([0,1,9,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,I=R.Unknown,E){super(P),this._message=P,this._code=I,this._detail=E,this.isHandled=I===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ne[105],re([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=t;function R(E){if(!E)return;const C=E.indexOf("+");return C<0?E:E.substr(0,C)}e.getRemoteName=R;function L(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(E){const{host:C,port:b}=I(E);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:b}}e.parseAuthorityWithPort=T;function P(E,C){let{host:b,port:S}=I(E);return typeof S>"u"&&(S=C),{host:b,port:S}}e.parseAuthorityWithOptionalPort=P;function I(E){const C=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const b=E.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const S=E.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:E,port:void 0}}}),define(ne[44],re([0,1,27,5,105]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,y){if(typeof v>"u"||v===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof v=="string"||typeof y=="string"){const u=typeof v=="string"?v:v.value,m=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(u,m)}return v._lower===y._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=E;function C(f){return b(f)}e.isApplicationScopedExtension=C;function b(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function S(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function p(f,v){if(v){const y=`onResolveRemoteAuthority:${(0,R.getRemoteName)(v)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,36]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,D.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=E;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const o=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,o,s)}static parse(i){const o=C.exec(i);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,s="undefined"){this.version=o,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?E(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const i=S.exec(r);return i&&i[1]?[v(i[1]),i[2]]:[v(r),void 0]}e.getIdAndVersion=p;function f(r,i){return`${r}.${i}`}e.getExtensionId=f;function v(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function y(r,i){return v(f(r,i))}e.getGalleryExtensionId=y;function u(r,i){const o=[],s=h=>{for(const a of o)if(a.some(g=>E(i(g),i(h))))return a;return null};for(const h of r){const a=s(h);a?a.push(h):o.push([h])}return o}e.groupByExtension=u;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function c(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(r,i){const o=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const h=s.shift();if(h&&o.every(a=>!E(a.identifier,{id:h}))){const a=r.filter(g=>E(g.identifier,{id:h}));a.length===1&&(o.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=d;async function l(r,i){if(!L.isLinux)return!1;let o;try{o=(await r.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(h))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function n(r,i){const o=await l(r,i),s=(0,t.getTargetPlatform)(o?"alpine":L.platform,I.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(ne[51],re([0,1,6,17,2,40,7,33,14,5,8]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let b=class extends R.Disposable{constructor(p,f){super(),this.fileService=p,this.logService=f,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(p){return this.withProfileExtensions(p)}addExtensionsToProfile(p,f){return this.withProfileExtensions(f,v=>(v=v.filter(y=>p.some(([u])=>!(0,P.areSameExtensions)(y.identifier,u.identifier))),v.push(...p.map(([y,u])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:u}))),v))}removeExtensionFromProfile(p,f){return this.withProfileExtensions(f,v=>v.filter(y=>!(0,P.areSameExtensions)(y.identifier,p)))}async withProfileExtensions(p,f){return this.getResourceAccessQueue(p).queue(async()=>{let v=[];try{const y=await this.fileService.readFile(p),u=JSON.parse(y.value.toString());for(const m of u){if(!m.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",m);continue}if(!m.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",m);continue}if(!m.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",m);continue}v.push({identifier:m.identifier,location:T.URI.revive(m.location),version:m.version,metadata:m.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){v=f(v);const y=v.map(u=>({identifier:u.identifier,version:u.version,location:u.location.toJSON(),metadata:u.metadata}));await this.fileService.writeFile(p,t.VSBuffer.fromString(JSON.stringify(y)))}return v})}getResourceAccessQueue(p){let f=this.resourcesAccessQueueMap.get(p);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(p,f)),f}};b=pe([J(0,I.IFileService),J(1,C.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ne[207],re([0,1,24,33]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(L,T,P,I,E){try{const C=await L.getExtensionsControlManifest();if(!C.deprecated)return;const b=await L.getInstalled(1);for(const[S,p]of Object.entries(C.deprecated)){if(!p?.extension)continue;const{id:f,autoMigrate:v,preRelease:y}=p.extension;if(!v)continue;const u=b.find(c=>(0,t.areSameExtensions)(c.identifier,{id:S}));if(!u)continue;const m=(await T.getExtensions([{id:f,preRelease:y}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!m){E.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{E.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const c=!I.getDisabledExtensions().some(l=>(0,t.areSameExtensions)(l,u.identifier));await L.uninstall(u),E.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let d=b.find(l=>(0,t.areSameExtensions)(l.identifier,{id:f}));(!d||!d.isPreReleaseVersion&&c)&&(d=await L.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${d.identifier.id}'`),c||(await I.disableExtension(d.identifier),E.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),v.storage&&(P.addToMigrationList((0,t.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,t.getExtensionId)(d.manifest.publisher,d.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(c){E.error(c)}}}catch(C){E.error(C)}}e.migrateUnsupportedExtensions=R}),define(ne[208],re([0,1,6,9,2,22,4,19,56,30,28,16,13,29,33,97,14,8]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let m=class pt extends R.Disposable{constructor(d,l,n,r,i,o){super(),this.fileService=l,this.extensionGalleryService=n,this.configurationService=r,this.extensionSignatureVerificationService=i,this.logService=o,this.extensionsDownloadDir=d.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(d,l){await this.cleanUpPromise;const n=(0,P.joinPath)(this.extensionsDownloadDir,this.getName(d));try{await this.downloadFile(d,n,i=>this.extensionGalleryService.download(d,i,l))}catch(i){throw new p.ExtensionManagementError(i.message,p.ExtensionManagementErrorCode.Download)}let r=!1;if(d.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const i=await this.downloadSignatureArchive(d);try{r=await this.extensionSignatureVerificationService.verify(n.fsPath,i.fsPath)}catch(o){throw await this.delete(i),await this.delete(n),new p.ExtensionManagementError(o.code,p.ExtensionManagementErrorCode.Signature)}}return{location:n,verified:r}}async downloadSignatureArchive(d){await this.cleanUpPromise;const l=(0,P.joinPath)(this.extensionsDownloadDir,`${this.getName(d)}${pt.SignatureArchiveExtension}`);return await this.downloadFile(d,l,n=>this.extensionGalleryService.downloadSignatureArchive(d,n)),l}async downloadFile(d,l,n){if(await this.fileService.exists(l))return;if(l.scheme!==L.Schemas.file){await n(l);return}const r=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(r)||await n(r);try{await this.rename(r,l,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",d.identifier.id,l.path);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(i)}. Deleted the file from downloaded location`,r.path),i}}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,l,n){try{await C.Promises.rename(d.fsPath,l.fsPath)}catch(r){if(T.isWindows&&r&&r.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${d} to ${l} with 'EPERM' error. Trying again...`),this.rename(d,l,n);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const l=[],n=[],r=[];for(const s of d.children)if(s.name.endsWith(pt.SignatureArchiveExtension))r.push(s.resource);else{const h=f.ExtensionKey.parse(s.name);h&&n.push([h,s])}const i=(0,f.groupByExtension)(n,([s])=>s),o=[];for(const s of i)s.sort((h,a)=>I.rcompare(h[0].version,a[0].version)),l.push(...s.slice(1).map(h=>h[1].resource)),o.push(s[0][1]);o.sort((s,h)=>s.mtime-h.mtime),l.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(s=>s.resource)),l.push(...r),await D.Promises.settled(l.map(s=>(this.logService.trace("Deleting from cache",s.path),this.fileService.del(s))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?f.ExtensionKey.create(d).toString().toLowerCase():(0,E.generateUuid)()}};m.SignatureArchiveExtension=".sigzip",m=pe([J(0,S.INativeEnvironmentService),J(1,y.IFileService),J(2,p.IExtensionGalleryService),J(3,b.IConfigurationService),J(4,v.IExtensionSignatureVerificationService),J(5,u.ILogService)],m),e.ExtensionsDownloader=m}),define(ne[209],re([0,1,2,10,28,44]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(I,E){super(),this.environmentService=I,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(E.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(I){I.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[210],re([0,1,99,18,6,2,22,10,28,13,29,33,8,72,4,7]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends p.LanguagePackBaseService{constructor(d,l,n,r){super(n),this.extensionManagementService=d,this.logService=r,this.cache=this._register(new u(l,r)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getBuiltInExtensionTranslationsUri(d){const n=(await this.cache.getLanguagePacks())[f.Language.value()];if(!n){this.logService.warn(`No language pack found for ${f.Language.value()}`);return}const r=n.translations[d];return r?v.URI.file(r):void 0}async getInstalledLanguages(){const d=await this.cache.getLanguagePacks(),l=Object.keys(d).map(n=>{const r=d[n];return{...this.createQuickPickItem(n,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return l.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),l.sort((n,r)=>n.label.localeCompare(r.label)),l}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const l=await this.cache.getLanguagePacks();Object.keys(l).some(n=>l[n]&&l[n].extensions.some(r=>(0,b.areSameExtensions)(r.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),n=await this.cache.update(l);return!(0,t.equals)(Object.keys(d),Object.keys(n))}};y=pe([J(0,C.IExtensionManagementService),J(1,E.INativeEnvironmentService),J(2,C.IExtensionGalleryService),J(3,S.ILogService)],y),e.NativeLanguagePackService=y;let u=class extends L.Disposable{constructor(d,l){super(),this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(l=>{Object.keys(l).forEach(n=>delete l[n]),this.createLanguagePacksFromExtensions(l,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...l){for(const n of l)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,n);Object.keys(d).forEach(n=>this.updateHash(d[n]))}createLanguagePacksFromExtension(d,l){const n=l.identifier,r=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const i of r)if(l.location.scheme===T.Schemas.file&&m(i)){let o=d[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},d[i.languageId]=o);const s=o.extensions.filter(h=>(0,b.areSameExtensions)(h.extensionIdentifier,n))[0];s?s.version=l.manifest.version:o.extensions.push({extensionIdentifier:n,version:l.manifest.version});for(const h of i.translations)o.translations[h.id]=(0,P.join)(l.location.fsPath,h.path)}}updateHash(d){if(d){const l=(0,D.createHash)("md5");for(const n of d.extensions)l.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);d.hash=l.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(l=d(n),n)).then(n=>{for(const i of Object.keys(n))n[i]||delete n[i];this.languagePacks=n,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),I.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>l,n=>this.logService.error(n))})}};u=pe([J(0,E.INativeEnvironmentService),J(1,S.ILogService)],u);function m(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const d of c.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(ne[211],re([0,1,6,17,24,9,3,2,30,91,206,105]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var p;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function f(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function v(B){const H=new R.CancellationTokenSource;return setTimeout(()=>H.cancel(),B),H.token}function y(B,H){if(B.isCancellationRequested||H.isCancellationRequested)return R.CancellationToken.Cancelled;const O=new R.CancellationTokenSource;return B.onCancellationRequested(()=>O.cancel()),H.onCancellationRequested(()=>O.cancel()),O.token}class u{get didTimeout(){return this._state==="timedout"}constructor(H){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((O,M)=>{this._resolvePromise=O,this._rejectPromise=M}),H.isCancellationRequested?this._timeout():this._disposables.add(H.onCancellationRequested(()=>this._timeout()))}registerDisposable(H){this._state==="pending"?this._disposables.add(H):H.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(H))}reject(H){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(H))}}function m(B,H){const O=new u(H);return O.registerDisposable(B.onControlMessage(M=>{const x=JSON.parse(M.toString()),G=z(x);G?O.reject(G):O.resolve(x)})),O.promise}function c(B,H,O,M,x,G,ee,oe){const Z=new u(oe);return H.connect(O,M,x,G,ee,(ie,se)=>{Z.didTimeout?(ie&&B.error(ie),se?.dispose()):ie||!se?Z.reject(ie):Z.resolve(se)}),Z.promise}function d(B,H){const O=new u(H);return B.then(M=>{O.didTimeout||O.resolve(M)},M=>{O.didTimeout||O.reject(M)}),O.promise}async function l(B,H,O,M){const x=X(B,H);B.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let G;try{G=await c(B.logService,B.socketFactory,B.host,B.port,(0,b.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${f(H)}-${B.reconnectionToken}`,M)}catch(se){throw B.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),B.logService.error(se),se}B.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(G,null),ee=B.reconnectionProtocol,oe=!1):(ee=new E.PersistentProtocol(G,null),oe=!0),B.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await d(B.signService.createNewMessage((0,I.generateUuid)()),M),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(t.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await m(ee,y(M,v(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(B.logService.trace(`${x} 4/6. received SignRequest control message.`),!await d(B.signService.validate(Z,se.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const de=await d(B.signService.sign(se.data),M),ve={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:H};return O&&(ve.args=O),B.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(t.VSBuffer.fromString(JSON.stringify(ve))),{protocol:ee,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(B.logService.error(`${x} the handshake timed out. Error:`),B.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${x} received error control message when negotiating connection. Error:`),B.logService.error(se)),oe&&V(ee),se}}async function n(B,H,O,M){const x=Date.now(),G=X(B,H),{protocol:ee,ownsProtocol:oe}=await l(B,H,O,M),Z=new u(M);return Z.registerDisposable(ee.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=z(se);ue?(B.logService.error(`${G} received error control message when negotiating connection. Error:`),B.logService.error(ue),oe&&V(ee),Z.reject(ue)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${ce(x)}!`),Z.resolve({protocol:ee,firstMessage:se}))})),Z.promise}async function r(B,H){const{protocol:O}=await n(B,1,void 0,H);return{protocol:O}}async function i(B,H,O){const{protocol:M,firstMessage:x}=await n(B,2,H,O),G=x&&x.debugPort;return{protocol:M,debugPort:G}}async function o(B,H,O){const M=Date.now(),x=X(B,3),{protocol:G}=await l(B,3,H,O);return B.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ce(M)}!`),G}async function s(B,H,O){const{host:M,port:x,connectionToken:G}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:M,port:x,connectionToken:G,reconnectionToken:H,reconnectionProtocol:O,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function h(B,H,O){return g(B,async M=>{const{protocol:x}=await r(M,R.CancellationToken.None);return new Y(B,H,O,M.reconnectionToken,x)})}e.connectRemoteAgentManagement=h;async function a(B,H){return g(B,async O=>{const{protocol:M,debugPort:x}=await i(O,H,R.CancellationToken.None);return new q(B,H,O.reconnectionToken,M,x)})}e.connectRemoteAgentExtensionHost=a;async function g(B,H){for(let M=1;;M++)try{const x=(0,I.generateUuid)(),G=await s(B,x,null);return await H(G)}catch(x){if(M<5)B.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(x);else throw B.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(x),$.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(x)),x}}async function w(B,H,O){const M=await s(B,(0,I.generateUuid)(),null);return await o(M,{host:H,port:O},R.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function A(B){return(0,D.createCancelablePromise)(H=>new Promise((O,M)=>{const x=setTimeout(O,B*1e3);H.onCancellationRequested(()=>{clearTimeout(x),O()})}))}var F;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(H,O){this.reconnectionToken=H,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=_;class N{constructor(H,O,M,x){this.reconnectionToken=H,this.millisSinceLastIncomingData=O,this.durationSeconds=M,this.cancellableTimer=x,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=N;class W{constructor(H,O,M){this.reconnectionToken=H,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=W;class k{constructor(H,O,M){this.reconnectionToken=H,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=4}}e.ConnectionGainEvent=k;class U{constructor(H,O,M,x){this.reconnectionToken=H,this.millisSinceLastIncomingData=O,this.attempt=M,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class $ extends P.Disposable{static triggerPermanentFailure(H,O,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=H,this._permanentFailureAttempt=O,this._permanentFailureHandled=M,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(H=>H._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(H=>H._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||$._permanentFailure}constructor(H,O,M,x,G){super(),this._connectionType=H,this._options=O,this.reconnectionToken=M,this.protocol=x,this._reconnectionFailureIsFatal=G,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new k(this.reconnectionToken,0,0)),this._register(x.onSocketClose(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),$._instances.push(this),this._register((0,P.toDisposable)(()=>{const ee=$._instances.indexOf(this);ee>=0&&$._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure($._permanentFailureMillisSinceLastIncomingData,$._permanentFailureAttempt,$._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const H=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const x=M<O.length?O[M]:O[O.length-1];try{if(x>0){const ee=A(x);this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this._options.logService.info(`${H} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${H} resolving connection...`);const G=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${H} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,v(S)),this._options.logService.info(`${H} reconnected!`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,L.isCancellationError)(G)){this._options.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,C.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(H,O,M){this._reconnectionFailureIsFatal?$.triggerPermanentFailure(H,O,M):this._gotoPermanentFailure(H,O,M)}_gotoPermanentFailure(H,O,M){this._onDidStateChange.fire(new U(this.reconnectionToken,H,O,M)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=$,$._permanentFailure=!1,$._permanentFailureMillisSinceLastIncomingData=0,$._permanentFailureAttempt=0,$._permanentFailureHandled=!1,$._instances=[];class Y extends ${constructor(H,O,M,x,G){super(1,H,x,G,!0),this.client=this._register(new E.Client(G,{remoteAuthority:O,clientId:M},H.ipcLogger))}async _reconnect(H,O){await r(H,O)}}e.ManagementPersistentConnection=Y;class q extends ${constructor(H,O,M,x,G){super(2,H,M,x,!1),this._startArguments=O,this.debugPort=G}async _reconnect(H,O){await i(H,this._startArguments,O)}}e.ExtensionHostPersistentConnection=q;function V(B){try{B.acceptDisconnect();const H=B.getSocket();B.dispose(),H.dispose()}catch(H){(0,L.onUnexpectedError)(H)}}function z(B){if(B&&B.type==="error"){const H=new Error(`Connection error: ${B.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function j(B,H){for(;B.length<H;)B+=" ";return B}function K(B,H,O){return`[remote-connection][${j(f(B),13)}][${H.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function X(B,H){return`${K(H,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ce(B){return`${Date.now()-B} ms`}}),define(ne[212],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[213],re([0,1,84,143]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,T,P,I,E){const C=S=>E(S,void 0),b=D.createConnection({host:R,port:L},()=>{b.removeListener("error",C);const S=Buffer.alloc(16);for(let y=0;y<16;y++)S[y]=Math.round(Math.random()*256);const p=S.toString("base64"),f=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}${T}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];b.write(f.join(`\r
`)+`\r
\r
`);const v=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",v),E(void 0,new t.NodeSocket(b,I)))};b.on("data",v)});b.setNoDelay(!0),b.once("error",C)}}}),define(ne[106],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var t;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=L=>({type:"connected",link:L}),R.connecting=L=>({type:"connecting",progress:L})})(t=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride"}),define(ne[214],re([0,1,126,16,8]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,I){this.configurationService=P,this.logService=I}async request(P,I){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const E=await(0,D.request)(P,I);return this.logService.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.logService.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};L=pe([J(0,t.IConfigurationService),J(1,R.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,17,161,43,5,39]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=P;function I(v){return v.res.statusCode===204}async function E(v){return I(v)?null:(await(0,D.streamToBuffer)(v.stream)).toString()}e.asText=E;async function C(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);return E(v)}e.asTextOrError=C;async function b(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);if(I(v))return null;const u=(await(0,D.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(m){throw m.message+=`:
`+u,m}}e.asJson=b;function S(v){f(v)}e.updateProxyConfigurationsScope=S;let p;function f(v){const y=T.Registry.as(R.Extensions.Configuration),u=p;p={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[p],remove:u?[u]:[]})}f(2)}),define(ne[215],re([0,1,24,22,14,45]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(I,E){this.requestService=I,this.fileService=E}async download(I,E,C=D.CancellationToken.None){if(I.scheme===t.Schemas.file||I.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(I,E);return}const b={type:"GET",url:I.toString(!0)},S=await this.requestService.request(b,C);if(S.res.statusCode===200)await this.fileService.writeFile(E,S.stream);else{const p=await(0,L.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${p}`)}}};T=pe([J(0,L.IRequestService),J(1,R.IFileService)],T),e.DownloadService=T}),define(ne[216],re([0,1,18,24,2,19,178,14,8,25,45]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends R.Disposable{constructor(p,f,v,y){super(),this.fileService=p,this.productService=f,this.requestService=v,this.logService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,u])=>this.allConfigBasedTips.set(u.configPath,u))}getConfigBasedTips(p){return this.getValidConfigBasedTips(p)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(p){const f=[];for(const[v,y]of this.allConfigBasedTips)if(!(y.configScheme&&y.configScheme!==p.scheme))try{const u=await this.fileService.readFile((0,L.joinPath)(p,v)),m=new Map;Object.entries(y.recommendations).forEach(([d,l])=>{if((0,D.isNonEmptyArray)(l.remotes))for(const n of l.remotes)m.set(n,{extensionId:d,extensionName:l.name,configName:y.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else f.push({extensionId:d,extensionName:l.name,configName:y.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const c=(0,T.getDomainsOfRemotes)(u.value.toString(),[...m.keys()]);for(const d of c){const l=m.get(d);l&&f.push(l)}}catch{}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const p=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(p.res.statusCode!==200)return[];const f=await(0,C.asJson)(p);return f?f.workspaceRecommendations||[]:[]}catch(p){return this.logService.error(p),[]}}};b=pe([J(0,P.IFileService),J(1,E.IProductService),J(2,C.IRequestService),J(3,I.ILogService)],b),e.ExtensionTipsService=b}),define(ne[217],re([0,1,17,24]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.service=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,E,C=t.CancellationToken.None){switch(I){case"request":return this.service.request(E[0],C).then(async({res:b,stream:S})=>{const p=await(0,D.streamToBuffer)(S);return[{statusCode:b.statusCode,headers:b.headers},p]});case"resolveProxy":return this.service.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class L{constructor(P){this.channel=P}async request(P,I){const[E,C]=await this.channel.call("request",[P],I);return{res:E,stream:(0,D.bufferToStream)(C)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=L}),define(ne[218],re([0,1,214,217]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(T,P,I){this.configurationService=P,this.logService=I,this.browserRequestService=new D.RequestService(P,I),this.mainRequestService=new t.RequestChannelClient(T.getChannel("request"))}request(T,P){return this.getRequestService().request(T,P)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(ne[107],re([0,1,66,5]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[219],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[220],re([0,1,92,6,24,3,2,22,30,8,107,219]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let S=class{constructor(v){this.logService=v,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const y=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${y})`);const u=(0,C.hash)(v);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.doDisposeWorker(v));const m=new R.CancellationTokenSource;let c,d,l;this.processeDisposables.set(u,o=>{m.dispose(!0),c?.terminate(v,R.CancellationToken.None),d?.close(),l?.close(),this.processeDisposables.delete(u);const s=this.processResolvers.get(u);s&&(this.processResolvers.delete(u),s({reason:o}))}),c=await this.getOrCreateWebWorker(v);const n=new Promise(o=>{this.processResolvers.set(u,o)});if(m.token.isCancellationRequested)return n;const{port1:r,port2:i}=new MessageChannel;return d=r,l=i,await c.spawn(v,l,m.token),m.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${y})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[d])),n}getOrCreateWebWorker(v){let y=this.workers.get(v.process.moduleId);if(!y){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const u=new p(v.process.type,this.logService);y=u.init(),u.onDidProcessSelfTerminate(({configuration:m,reason:c})=>{this.doDisposeWorker(m,c)}),this.workers.set(v.process.moduleId,y)}return y}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,y){const u=this.processeDisposables.get((0,C.hash)(v));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),u(y))}};S=pe([J(0,E.ILogService)],S),e.SharedProcessWorkerService=S;class p extends T.Disposable{constructor(v,y){super(),this.type=v,this.logService=y,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const v=new t.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return y.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},y.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},y.onmessage=u=>{const{id:m,message:c,configuration:d,nonce:l}=u.data;switch(m){case b.SharedProcessWorkerMessages.Ready:v.complete(y);break;case b.SharedProcessWorkerMessages.Ack:if(l){const n=this.mapMessageNonceToPendingMessageResolve.get(l);n&&(this.mapMessageNonceToPendingMessageResolve.delete(l),n())}break;case b.SharedProcessWorkerMessages.SelfTerminated:d&&c&&this._onDidProcessSelfTerminate.fire({configuration:d,reason:JSON.parse(c)});break;case b.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case b.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case b.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case b.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async send(v,y,u){const m=await this.workerReady;if(!y.isCancellationRequested)return new Promise(c=>{const d=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,c);const l={...v,nonce:d};u?m.postMessage(l,[u]):m.postMessage(l),y.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&c()})})}spawn(v,y,u){const m={id:b.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(m,u,y)}terminate(v,y){const u={id:b.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(u,y)}}}),define(ne[221],re([0,1,64,22,177]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.vscodeUserData})}}pe([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[222],re([0,1,49,10,162,24,37,9,4,30,140,175,6]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let f;async function v(u,m,c){return m["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(c)&&!m["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(c)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=S.Promises.withAsyncBody(async(d,l)=>{const n=new L.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),l(new Error((0,R.localize)(0,null)))},p);try{d(await y(u,n.token))}catch(i){!(0,P.isCancellationError)(i)&&!n.token.isCancellationRequested?l(new Error((0,R.localize)(1,null,(0,T.toErrorMessage)(i)))):d({})}finally{clearTimeout(r),n.dispose()}})),f)}e.getResolvedShellEnv=v;async function y(u,m){const c=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",c);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",d);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await(0,C.getSystemShell)(I.OS,r);return u.trace("getUnixShellEnvironment#shell",i),new Promise((o,s)=>{if(m.isCancellationRequested)return s((0,P.canceled)());const h=(0,t.basename)(i);let a,g;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(a=`& '${process.execPath}' ${w} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,g=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,h==="tcsh"?g=["-ic"]:g=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),a);const A=(0,D.spawn)(i,[...g,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(A.kill(),s((0,P.canceled)()))),A.on("error",N=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(N)),s(N)});const F=[];A.stdout.on("data",N=>F.push(N));const _=[];A.stderr.on("data",N=>_.push(N)),A.on("close",(N,W)=>{const k=Buffer.concat(F).toString("utf8");u.trace("getUnixShellEnvironment#raw",k);const U=Buffer.concat(_).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),N||W)return s(new Error((0,R.localize)(2,null,N,W)));const $=n.exec(k),Y=$?$[1]:"{}";try{const q=JSON.parse(Y);c?q.ELECTRON_RUN_AS_NODE=c:delete q.ELECTRON_RUN_AS_NODE,d?q.ELECTRON_NO_ATTACH_CONSOLE=d:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",q),o(q)}catch(q){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(q)),s(q)}})})}}),define(ne[108],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[223],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>Q(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),T=new L.validator;if(T){const P=String(D._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const T=this.validators.get(R.id);if(!T)return!1;this.validators.delete(R.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(ne[74],re([0,1,3,2]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends t.Disposable{constructor(b,S,p){super(),this.channel=b,this.profile=S,this.workspace=p}async getItems(){const b={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",b);return new Map(S)}updateItems(b){const S={profile:this.profile,workspace:this.workspace};return b.insert&&(S.insert=Array.from(b.insert.entries())),b.delete&&(S.delete=Array.from(b.delete.values())),this.channel.call("updateItems",S)}}class L extends R{constructor(b,S){super(b,S,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class T extends L{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class P extends L{constructor(b,S){super(b,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(b,S){super(b,void 0,S),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class E{constructor(b){this.channel=b}isUsed(b){const S={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=E}),define(ne[109],re([0,1,4,36,7,30]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,C,b,S,p,f,v,y,u,m){const c=Object.create(null);c["common.machineId"]=v,c.sessionID=(0,L.generateUuid)()+Date.now(),c.commitHash=p,c.version=f,c["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=t.platform,c["common.nodeArch"]=S,c["common.product"]=m||"desktop",y&&(c["common.msftInternal"]=y);let d=0;const l=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const n=T(b);n&&(c["common.platformDetail"]=n);try{const r=await E.readFile(R.URI.file(u));c["common.source"]=r.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function I(E){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const b=C.toLowerCase();return E.some(S=>b===S)}e.verifyMicrosoftInternalDomain=I}),define(ne[23],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[224],re([0,1,34,54,6,35,22,10,4,7,137,28,139,95,14,25,23]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const u=new Map;async function m(r,i){const o=`${r}::${i.join(":")}`,s=u.get(o);if(s)return s;const h=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,g=new Map,w=2e4;function A(_,N,W,k){const U=N.substring(_.length+1);return R.Promises.withAsyncBody(async $=>{let Y;try{Y=await b.Promises.readdir(N,{withFileTypes:!0})}catch{$();return}if(k.count>=w){k.count+=Y.length,k.maxReached=!0,$();return}let q=Y.length;if(q===0){$();return}let V=Y;k.count+Y.length>w&&(k.maxReached=!0,q=w-k.count,V=Y.slice(0,q)),k.count+=Y.length;for(const z of V)if(z.isDirectory()){if(W.includes(z.name)||await A(_,(0,P.join)(N,z.name),W,k),--q===0){$();return}}else{const j=z.name.lastIndexOf(".");if(j>=0){const K=z.name.substring(j+1);K&&a.set(K,(a.get(K)??0)+1)}for(const K of h)K.relativePathPattern?.test(U)!==!1&&K.filePattern.test(z.name)&&g.set(K.tag,(g.get(K.tag)??0)+1);if(--q===0){$();return}}})}const F=R.Promises.withAsyncBody(async _=>{const N={count:0,maxReached:!1};await A(r,r,i,N);const W=await l(r);_({configFiles:c(g),fileTypes:c(a),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:W})});return u.set(o,F),F}e.collectWorkspaceStats=m;function c(r){return[...t.Iterable.map(r.entries(),([i,o])=>({name:i,count:o}))].sort((i,o)=>o.count-i.count)}function d(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},i=D.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=d;async function l(r){try{const i=new Map,o=(0,P.join)(r,".vscode","launch.json"),s=await b.Promises.readFile(o),h=[],a=(0,L.parse)(s.toString(),h);if(h.length)return console.log(`Unable to parse ${o}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const g of a.configurations){const w=g.type;w&&(i.has(w)?i.set(w,i.get(w)+1):i.set(w,1))}return c(i)}catch{return[]}}e.collectLaunchConfigs=l;let n=class{constructor(i,o){this.telemetryService=i,this.productService=o}formatMachineInfo(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}formatEnvironment(i){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&o.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),o.push(`Memory (System):  ${(D.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||o.push(`Load (avg):       ${D.loadavg().map(h=>Math.round(h)).join(", ")}`),o.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[h,a]=s,g=this.formatProcessList(i,h);return o.forEach(w=>{if((0,p.isRemoteDiagnosticError)(w))g+=`
${w.errorMessage}`,a+=`
${w.errorMessage}`;else if(g+=`

Remote: ${w.hostName}`,w.processes&&(g+=`
${this.formatProcessList(i,w.processes)}`),w.workspaceMetadata){a+=`
|  Remote: ${w.hostName}`;for(const A of Object.keys(w.workspaceMetadata)){const F=w.workspaceMetadata[A];let _=`${F.fileCount} files`;F.maxFilesReached&&(_=`more than ${_}`),a+=`|    Folder (${A}): ${_}`,a+=this.formatWorkspaceStats(F)}}}),{processInfo:g,workspaceInfo:a}})}async getSystemInfo(i,o){const{memory:s,vmHint:h,os:a,cpus:g}=d(),w={os:a,memory:s,cpus:g,vmHint:h,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return I.isWindows||(w.load=`${D.loadavg().map(A=>Math.round(A)).join(", ")}`),I.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(i,o){const s=[];return(0,S.listProcesses)(i.mainPID).then(async h=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,h)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),o.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.formatMachineInfo(a.machineInfo)),a.processes&&s.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const g of Object.keys(a.workspaceMetadata)){const w=a.workspaceMetadata[g];let A=`${w.fileCount} files`;w.maxFilesReached&&(A=`more than ${A}`),s.push(`Folder (${g}): ${A}`),s.push(this.formatWorkspaceStats(w))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const o=[];let h=0;const a=(F,_)=>{const N=` ${F}(${_})`;h+N.length>60?(o.push(g),g="|                 ",h=g.length):h+=N.length,g+=N};let g="|      File types:";const w=10,A=i.fileTypes.length>w?w:i.fileTypes.length;for(let F=0;F<A;F++){const _=i.fileTypes[F];a(_.name,_.count)}if(o.push(g),i.configFiles.length>=0&&(g="|      Conf files:",h=0,i.configFiles.forEach(F=>{a(F.name,F.count)}),o.push(g)),i.launchConfigFiles.length>0){let F="|      Launch Configs:";i.launchConfigFiles.forEach(_=>{F+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),o.push(F)}return o.join(`
`)}expandGPUFeatures(i){const o=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(o-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const o=[],s=[];return i.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(o.push(`|  Window (${h.title})`),h.folderURIs.forEach(a=>{const g=E.URI.revive(a);if(g.scheme===T.Schemas.file){const w=g.fsPath;s.push(m(w,["node_modules",".git"]).then(A=>{let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),o.push(`|    Folder (${(0,P.basename)(w)}): ${F}`),o.push(this.formatWorkspaceStats(A))}).catch(A=>{o.push(`|      Error: Unable to collect workspace stats for folder ${w} (${A.toString()})`)}))}else o.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(h=>o.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(i,o){const s=new Map;i.windows.forEach(a=>s.set(a.pid,a.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(i.mainPID,s,h,o,0),h.join(`
`)}formatProcessItem(i,o,s,h,a){const g=a===0;let w;g?w=h.pid===i?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(a)} ${h.name}`,h.name==="window"&&(w=`${w} (${o.get(h.pid)})`));const A=process.platform==="win32"?h.mem:D.totalmem()*(h.mem/100);s.push(`${h.load.toFixed(0).padStart(5," ")}	${(A/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(h.children)&&h.children.forEach(F=>this.formatProcessItem(i,o,s,F,a+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:s}of i.folders){const h=E.URI.revive(s);if(h.scheme!==T.Schemas.file)continue;const a=h.fsPath;try{(await m(a,["node_modules",".git"])).fileTypes.forEach(w=>o.add(w.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const s=E.URI.revive(o);if(s.scheme!==T.Schemas.file)continue;const h=s.fsPath;try{const a=await m(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),a.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),a.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};n=pe([J(0,y.ITelemetryService),J(1,v.IProductService)],n),e.DiagnosticsService=n}),define(ne[225],re([0,1,106,3,23,13,2,8,7,10,49,25,4,6,101,16,34]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let u=class extends T.Disposable{constructor(c,d,l,n,r,i){super(),this.telemetryService=c,this.productService=d,this.environmentService=l,this.configurationService=i,this._onDidTokenFailedEmitter=new t.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new t.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new t.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=D.TunnelStates.disconnected;const o=I.URI.file((0,E.join)((0,E.dirname)(l.logsPath),"remoteTunnel.log"));this._logger=this._register(n.createLogger(o,{name:"remoteTunnel"})),this._startTunnelProcessDelayer=new p.Delayer(100),this._register(r.onWillShutdown(s=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()})),this._register(i.onDidChangeConfiguration(s=>{s.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(c){if(c&&this._account?c.token!==this._account.token||c.authenticationProviderId!==this._account.authenticationProviderId:c!==this._account){this._account=c,this._onDidChangeAccountEmitter.fire(c),this._logger.info(`Account updated: ${c?c.authenticationProviderId:"undefined"}`),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!c});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(d){this._logger.error(d)}}}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(D.TunnelStates.disconnected);return}this.setTunnelStatus(D.TunnelStates.connecting());const c=this.runCodeTunneCommand("login",["user","login","--provider",this._account.authenticationProviderId,"--access-token",this._account.token]);this._tunnelProcess=c;try{if(await c,this._tunnelProcess!==c)return}catch(r){this._logger.error(r),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected);return}const d=["--parent-process-id",String(process.pid)];let l=this.getHostName();if(l){const r=this.runCodeTunneCommand("set name",["rename",l]);this._tunnelProcess=r;try{if(await r,this._tunnelProcess!==r)return}catch(i){this._logger.error(i),l=void 0}}l||d.push("--random-name");const n=this.runCodeTunneCommand("tunnel",d,r=>{const i=r.match(/^\s*Open this link in your browser (https:[^\s]*)+/);i&&i[1]&&this.setTunnelStatus(D.TunnelStates.connected(i[1]))});this._tunnelProcess=n,n.finally(()=>{n===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(c){c!==this._tunnelStatus&&(this._tunnelStatus=c,this._onDidChangeTunnelStatusEmitter.fire(c))}runCodeTunneCommand(c,d,l=()=>{}){return(0,p.createCancelablePromise)(n=>new Promise((r,i)=>{n.isCancellationRequested&&r();let o;if(n.onCancellationRequested(()=>{o&&(this._logger.info(`${c} terminating (${o.pid})`),o.kill())}),process.env.VSCODE_DEV)this._logger.info(`${c} Spawning: cargo run -- tunnel ${d.join(" ")}`),o=(0,C.spawn)("cargo",["run","--","tunnel",...d],{cwd:(0,E.join)(this.environmentService.appRoot,"cli")});else{const s=(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.tunnelApplicationName}${S.isWindows?".exe":""}`);this._logger.info(`${c} Spawning: ${s} ${d.join(" ")}`),o=(0,C.spawn)(s,d)}o.stdout.on("data",s=>{if(o){const h=s.toString();l(h,!1),this._logger.info(`${c} stdout (${o.pid}):  + ${h}`)}}),o.stderr.on("data",s=>{if(o){const h=s.toString();l(h,!0),this._logger.info(`${c} stderr (${o.pid}):  + ${h}`)}}),o.on("exit",s=>{o&&(this._logger.info(`${c} exit (${o.pid}):  + ${s}`),o=void 0,s===0?r():i())}),o.on("error",s=>{o&&(this._logger.info(`${c} error (${o.pid}):  + ${s}`),o=void 0,i())})}))}getHostName(){const c=this.configurationService.getValue(D.CONFIGURATION_KEY_HOST_NAME);if(c&&c.match(/^([\w-]+)$/)&&c.length<=20)return c;const d=(0,y.hostname)();if(d&&d.match(/^([\w-]+)$/))return d}};u=pe([J(0,R.ITelemetryService),J(1,b.IProductService),J(2,L.INativeEnvironmentService),J(3,P.ILoggerService),J(4,f.ISharedProcessLifecycleService),J(5,v.IConfigurationService)],u),e.RemoteTunnelService=u}),define(ne[110],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:P,data:I}){return this.appenders.forEach(E=>E.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class t{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ne[52],re([0,1,32,86,15,16,109,23]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(o,s){return Promise.resolve(void 0)}publicLog2(o,s){return this.publicLog(o,s)}publicLogError(o,s){return Promise.resolve(void 0)}publicLogError2(o,s){return this.publicLogError(o,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(o,s,h){}async publicLogError(o,s,h){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return o.onDidChangeConfiguration(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(s.source),configurationKeys:u(s.sourceConfig)})})}e.configurationTelemetry=C;function b(i,o){return!(o.disableTelemetry||!i.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=b;function S(i){const o=i.getValue(P.TELEMETRY_SETTING_ID),s=i.getValue("telemetry.enableCrashReporter");if(i.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function p(i){const o={},s={},h={};y(i,h);for(let a in h){a=a.length>150?a.substr(a.length-149):a;const g=h[a];typeof g=="number"?s[a]=g:typeof g=="boolean"?s[a]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${g.length}`),o[a]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(o[a]=g)}return{properties:o,measurements:s}}e.validateTelemetryData=p;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function v(i){if(!i)return"none";for(const o of f)if(i.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=v;function y(i,o,s=0,h){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const g=i[a],w=h?h+a:a;Array.isArray(g)?o[w]=(0,D.safeStringify)(g):g instanceof Date?o[w]=g.toISOString():(0,R.isObject)(g)?s<2?y(g,o,s+1,w+"."):o[w]=(0,D.safeStringify)(g):o[w]=g}}function u(i){if(!i)return[];const o=[];return m(o,"",i),o}function m(i,o,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(h=>m(i,o?`${o}.${h}`:h,s[h])):i.push(o)}function c(i,o){const s=i.msftInternalDomains||[],h=o.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(s)||h}e.isInternalTelemetry=c;function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=d;function l(i,o){let s=i;const h=[];for(const A of o)for(;;){const F=A.exec(i);if(!F)break;h.push([F.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(s="";;){const A=g.exec(i);if(!A)break;!a.test(A[0])&&h.every(([F,_])=>A.index<F||A.index>=_)&&(s+=i.substring(w,A.index)+"<REDACTED: user-file-path>",w=g.lastIndex)}return w<i.length&&(s+=i.substr(w)),s}function n(i){if(!i)return i;const o=i.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of s)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return i}function r(i,o){return(0,D.cloneAndChange)(i,s=>{if(typeof s=="string"){let h=s;h=l(h,o);for(const a of o)h=h.replace(a,"");return h=n(h),h}})}e.cleanData=r}),define(ne[226],re([0,1,50,52]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,T,P,I,E,C,b){const S={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,t.supportsTelemetry)(T,P)&&(0,t.getTelemetryLevel)(I)===3){const p=await(0,D.getServiceMachineId)(P,E,C),{sessionId:f}=await b.getTelemetryInfo();S["X-Market-User-Id"]=p,S["VSCode-SessionId"]=f}return S}e.resolveMarketplaceHeaders=R}),define(ne[227],re([0,1,9,32,52]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(I,E,C){const b=await new Promise((y,u)=>{Q(["@microsoft/1ds-core-js"],y,u)}),S=await new Promise((y,u)=>{Q(["@microsoft/1ds-post-js"],y,u)}),p=new b.AppInsightsCore,f=new S.PostChannel,v={instrumentationKey:I,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(C){v.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:C};v.extensionConfig[f.identifier]=y}return p.initialize(v,[]),p.addTelemetryInitializer(y=>{E&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),p}class P{constructor(E,C,b,S,p){this._isInternalTelemetry=E,this._eventPrefix=C,this._defaultData=b,this._xhrOverride=p,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(E){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{E(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(E,C){if(!this._aiCoreOrKey)return;C=(0,t.mixin)(C,this._defaultData),C=(0,R.validateTelemetryData)(C);const b=this._eventPrefix+"/"+E;try{this._withAIClient(S=>{S.pluginVersionString=C?.properties.version??"Unknown",S.track({name:b,baseData:{name:b,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ne[111],re([0,1,2,13,8,52]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(I,E,C=""){super(),this.prefix=C;const b=I.getLogger(E.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(I.createLogger(E.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,E){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,L.validateTelemetryData)(E))}};T=pe([J(0,R.ILoggerService),J(1,t.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[112],re([0,1,2,32,86,4,27,163,16,43,103,25,39,23,52]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(m,c,d){this._configurationService=c,this._productService=d,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,c){this._experimentProperties[m]=c}_updateTelemetryLevel(){let m=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const d=c.usage?3:c.error?2:0;m=Math.min(m,d)}this.telemetryLevel.value=m}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const m=await this._commonProperties,c=m.sessionID,d=m["common.machineId"],l=m["common.firstSessionDate"],n=m["common.msftInternal"];return{sessionId:c,machineId:d,firstSessionDate:l,msftInternal:n}}dispose(){this._disposables.dispose()}_log(m,c,d,l){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(n=>{d=(0,t.mixin)(d,this._experimentProperties),d=(0,f.cleanData)(d,this._cleanupPatterns),d=(0,t.mixin)(d,n),this._appenders.forEach(r=>r.log(m,d))},n=>{console.error(n)})}publicLog(m,c,d){return this._log(m,3,c,d)}publicLog2(m,c,d){return this.publicLog(m,c,d)}publicLogError(m,c){return this._sendErrorTelemetry?this._log(m,2,c,!0):Promise.resolve(void 0)}publicLogError2(m,c){return this.publicLogError(m,c)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=pe([J(1,I.IConfigurationService),J(2,b.IProductService)],v),e.TelemetryService=v;function y(){const u=(0,P.localize)(0,null,C.default.nameLong),m=C.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=L.isWeb?"":(0,P.localize)(3,null),d=(0,P.localize)(4,null),l=(0,P.localize)(5,null),n=(0,P.localize)(6,null),r=(0,P.localize)(7,null),i=`
|       | ${d} | ${l} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${u} ${m} ${c}

&nbsp;

${r}
${i}

&nbsp;

${o}
`}S.Registry.as(E.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(E.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,P.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,P.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[228],re([0,1,284,227]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends t.AbstractOneDataSystemAppender{constructor(T,P,I,E){const C={sendPOST:(b,S)=>{const p={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const f=D.request(b.urlString,p,v=>{v.on("data",function(y){S(v.statusCode??200,v.headers,y.toString())}),v.on("error",function(y){S(0,{})})});f.write(b.data),f.end()}catch{S(0,{})}}};super(T,P,I,E,C)}}e.OneDataSystemAppender=R}),define(ne[229],re([0,1,22,68,16,13,8,25,23,110,111,112]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(f,v,y,u,m){this.configurationService=f,this.telemetryService=v,this.loggerService=y,this.environmentService=u,this.productService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:v,sessionId:y}=await this.telemetryService.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=v,u["common.vscodesessionid"]=y;const m=[f.id,JSON.stringify(u),f.aiKey],d=new t.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new E.TelemetryAppenderClient(d),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new b.TelemetryService({appenders:l,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,v,y){await(await this.getCustomTelemetryService(f)).publicLog(v,y)}async publicLogError(f,v,y){await(await this.getCustomTelemetryService(f)).publicLogError(v,y)}};S=pe([J(0,R.IConfigurationService),J(1,I.ITelemetryService),J(2,T.ILoggerService),J(3,L.IEnvironmentService),J(4,P.IProductService)],S),e.CustomEndpointTelemetryService=S}),define(ne[230],re([0,1,6,24,3,2,8]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(E,C){super(),this._logService=C,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((C,b)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,C),this._onCreateRequest.fire({requestId:S,...E});const p=new t.CancellationTokenSource;(0,D.timeout)(this._timeout,p.token).then(()=>b(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,L.toDisposable)(()=>p.cancel())])})}acceptReply(E,C){const b=this._pendingRequests.get(E);b?(this._pendingRequests.delete(E),(0,L.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),b(C)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=pe([J(1,T.ILogService)],P),e.RequestStore=P}),define(ne[113],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(c){c.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var P;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var C;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(c){c.TerminalView="view",c.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var u;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[231],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[232],re([0,1,34,22,32,10,4,36,27,15,28]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let l=0;return d&&d.length===4&&(l=parseInt(d[3])),l}e.getWindowsBuildNumber=b;async function S(d,l,n,r=P.env,i=C.Promises.exists){if(L.isAbsolute(d))return await i(d)?d:void 0;if(l===void 0&&(l=P.cwd()),L.dirname(d)!=="."){const a=L.join(l,d);return await i(a)?a:void 0}const s=(0,R.getCaseInsensitive)(r,"PATH");if(n===void 0&&(0,E.isString)(s)&&(n=s.split(L.delimiter)),n===void 0||n.length===0){const a=L.join(l,d);return await i(a)?a:void 0}for(const a of n){let g;if(L.isAbsolute(a)?g=L.join(a,d):g=L.join(l,a,d),await i(g))return g;if(T.isWindows){let w=g+".com";if(await i(w)||(w=g+".exe",await i(w)))return w}}const h=L.join(l,d);return await i(h)?h:void 0}e.findExecutable=S;function p(d,l,n,r,i){if(!l.shellIntegration.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration||T.isWindows&&!l.windowsEnableConpty)return;const o=d.args,s=P.platform==="win32"?L.basename(d.executable).toLowerCase():L.basename(d.executable),h=L.dirname(t.FileAccess.asFileUri("",Q).fsPath);let a;const g={VSCODE_INJECTION:"1"};if(T.isWindows){if(s==="pwsh.exe")return!o||m(o)?a=e.shellIntegrationArgs.get(f.WindowsPwsh):u(o)&&(a=e.shellIntegrationArgs.get(f.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h,""),{newArgs:a,envMixin:g}):void 0;r.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(s){case"bash":return!o||o.length===0?a=e.shellIntegrationArgs.get(f.Bash):c(o)&&(g.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(f.Bash)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h),{newArgs:a,envMixin:g}):void 0;case"pwsh":return!o||m(o)?a=e.shellIntegrationArgs.get(f.Pwsh):u(o)&&(a=e.shellIntegrationArgs.get(f.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h,""),{newArgs:a,envMixin:g}):void 0;case"zsh":{if(!o||o.length===0?a=e.shellIntegrationArgs.get(f.Zsh):c(o)?a=e.shellIntegrationArgs.get(f.ZshLogin):(o===e.shellIntegrationArgs.get(f.Zsh)||o===e.shellIntegrationArgs.get(f.ZshLogin))&&(a=o),!a)return;a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],h);const w=L.join(D.tmpdir(),`${D.userInfo().username}-${i.applicationName}-zsh`);g.ZDOTDIR=w;const A=n?.ZDOTDIR??D.homedir()??"~";g.USER_ZDOTDIR=A;const F=[];return F.push({source:L.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(w,".zshrc")}),F.push({source:L.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(w,".zprofile")}),F.push({source:L.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(w,".zshenv")}),F.push({source:L.join(h,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(w,".zlogin")}),{newArgs:a,envMixin:g,filesToCopy:F}}}r.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=p;var f;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(f=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(f.Zsh,["-i"]),e.shellIntegrationArgs.set(f.ZshLogin,["-il"]),e.shellIntegrationArgs.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],y=["-nol","-nologo"];function u(d){return typeof d=="string"?v.includes(d.toLowerCase()):d.length===1&&v.includes(d[0].toLowerCase())||d.length===2&&(v.includes(d[0].toLowerCase())||v.includes(d[1].toLowerCase()))&&(y.includes(d[0].toLowerCase())||y.includes(d[1].toLowerCase()))}function m(d){return typeof d=="string"?y.includes(d.toLowerCase()):d.length===0||d?.length===1&&y.includes(d[0].toLowerCase())}function c(d){return d==="string"&&v.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&v.includes(d[0].toLowerCase())}}),define(ne[233],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function t(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function R(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(ne[114],re([0,1,53,3,2,5,39,233]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var I;(function(y){function u(m){return m&&typeof m=="object"&&typeof m.id=="string"}y.isThemeColor=u})(I=e.ThemeColor||(e.ThemeColor={}));function E(y){return{id:y}}e.themeColorFromId=E;var C;(function(y){function u(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||I.isThemeColor(o.color))}y.isThemeIcon=u;const m=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(o){const s=m.exec(o);if(!s)return;const[,h]=s;return{id:h}}y.fromString=c;function d(o){return{id:o}}y.fromId=d;function l(o,s){let h=o.id;const a=h.lastIndexOf("~");return a!==-1&&(h=h.substring(0,a)),s&&(h=`${h}~${s}`),{id:h}}y.modify=l;function n(o){const s=o.id.lastIndexOf("~");if(s!==-1)return o.id.substring(s+1)}y.getModifier=n;function r(o,s){return o.id===s.id&&o.color?.id===s.color?.id}y.isEqual=r;function i(o,s){return{id:o.id,color:s?E(s):void 0}}y.asThemeIcon=i,y.asClassNameArray=D.CSSIcon.asClassNameArray,y.asClassName=D.CSSIcon.asClassName,y.asCSSSelector=D.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,R.toDisposable)(()=>{const m=this.themingParticipants.indexOf(u);this.themingParticipants.splice(m,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const p=new S;T.Registry.add(e.Extensions.ThemingContribution,p);function f(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=f;class v extends R.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(m=>this.onThemeChange(m)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,m){let c=this.theme.getColor(u);return c&&m&&(c=m(c,this.theme)),c?c.toString():null}}e.Themable=v}),define(ne[234],re([0,1,53,7,165,114]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(S,p){const f=[{name:null,description:(0,R.localize)(0,null)}];return f.push(...S.map(v=>({name:v.profileName,description:P(v)}))),p&&f.push(...p.map(v=>({name:v.title,description:I(v)}))),{values:f.map(v=>v.name),markdownDescriptions:f.map(v=>v.description)}}e.createProfileSchemaEnums=T;function P(S){let p=`$(${L.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:D.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?p+=`
- args: "${S.args}"`:p+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(p+=`
- overrideName: ${S.overrideName}`),S.color&&(p+=`
- color: ${S.color}`),S.env&&(p+=`
- env: ${JSON.stringify(S.env)}`),p}function I(S){return`$(${L.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:D.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function E(S,p){if(!S&&!p)return!0;if(typeof S=="string"&&typeof p=="string")return S===p;if(Array.isArray(S)&&Array.isArray(p)){if(S.length!==p.length)return!1;for(let f=0;f<S.length;f++)if(S[f]!==p[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function C(S,p){if(!S&&!p)return!0;if(!S||!p)return!1;if(L.ThemeIcon.isThemeIcon(S)&&L.ThemeIcon.isThemeIcon(p))return S.id===p.id&&S.color===p.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof p=="object"&&"light"in p&&"dark"in p){const f=S,v=p;if((t.URI.isUri(f.light)||b(f.light))&&(t.URI.isUri(f.dark)||b(f.dark))&&(t.URI.isUri(v.light)||b(v.light))&&(t.URI.isUri(v.dark)||b(v.dark)))return f.light.path===v.light.path&&f.dark.path===v.dark.path}if(t.URI.isUri(S)&&t.URI.isUri(p)||b(S)||b(p)){const f=S,v=p;return f.path===v.path&&f.scheme===v.scheme}return!1}e.terminalIconsEqual=C;function b(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=b}),define(ne[235],re([0,1,53,164,43,39,234]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),d=>`$(${d.id})`)};const P={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){L.Registry.as(R.Extensions.Configuration).registerConfiguration(y),c()}e.registerTerminalPlatformConfiguration=u;let m;function c(d,l){const n=L.Registry.as(R.Extensions.Configuration);let r;d&&(r=(0,T.createProfileSchemaEnums)(d?.profiles,l));const i=m;m={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?r?.values:void 0,markdownEnumDescriptions:d?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?r?.values:void 0,markdownEnumDescriptions:d?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?r?.values:void 0,markdownEnumDescriptions:d?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[m],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(ne[236],re([0,1,49,53,10,4,28,89,232,114]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,b=!0;function S(r,i,o,s,h=process.env,a,g,w,A){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?p(o,a,h,g,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),A,w):d(a,g,o,r&&typeof r=="object"?{...r}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,w,h)}e.detectAvailableProfiles=S;async function p(r,i,o,s,h,a,g,w,A){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let N=!1;(0,I.getWindowsBuildNumber)()>=16299&&(N=!0),await y(w);const W=new Map;r&&(W.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),W.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),W.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),W.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),l(a,W);const k=await f(W.entries(),g,i,o,s,A);if(r||h)try{const U=await m(`${_}\\${N?"wsl":"bash"}.exe`,g);for(const $ of U)(!a||!($.profileName in a))&&k.push($)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return k}async function f(r,i,o,s=process.env,h,a){const g=[];for(const[w,A]of r){if(A===null)continue;let F,_,N;if("source"in A){const U=C?.get(A.source);if(!U)continue;F=U.paths,_=A.args||U.args,A.icon?N=v(A.icon):U.icon&&(N=U.icon)}else F=Array.isArray(A.path)?A.path:[A.path],_=L.isWindows||Array.isArray(A.args)?A.args:void 0,N=v(A.icon);const W=await a?.(F)||F.slice(),k=await n(w,i,W,o,s,_,A.env,A.overrideName,A.isAutoDetected,h);k?(k.isAutoDetected=A.isAutoDetected,k.icon=N,k.color=A.color,g.push(k)):h?.debug("Terminal profile not validated",w,F)}return h?.debug("Validated terminal profiles",g),g}function v(r){return typeof r=="string"?{id:r}:r}async function y(r){C&&!r||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),C.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function u(){const r=[];for await(const i of(0,P.enumeratePowerShellInstallations)())r.push(i.exePath);return r}async function m(r,i){const o=[],s=await new Promise((g,w)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,F)=>{if(A)return w("Problem occurred when getting wsl distros");g(F)})});if(!s)return[];const h=new RegExp(/[\r?\n]/),a=s.split(h).filter(g=>g.trim().length>0&&g!=="");for(const g of a){if(g===""||g.startsWith("docker-desktop"))continue;const w=`${g} (WSL)`,A={profileName:w,path:r,args:["-d",`${g}`],isDefault:w===i,icon:c(g),isAutoDetected:!1};o.push(A)}return o}function c(r){return r.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):r.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function d(r,i,o,s,h,a,g,w){const A=new Map;if(o){const F=(await r.readFile("/etc/shells")).toString(),_=a||F.split(`
`).filter(W=>W.trim().indexOf("#")!==0&&W.trim().length>0),N=new Map;for(const W of _){let k=(0,R.basename)(W),U=N.get(k)||0;U++,U>1&&(k=`${k} (${U})`),N.set(k,U),A.set(k,{path:W,isAutoDetected:!0})}}return l(s,A),await f(A.entries(),h,r,w,i,g)}function l(r,i){if(!!r)for(const[o,s]of Object.entries(r))s===null||!("path"in s)&&!("source"in s)?i.delete(o):(s.icon=s.icon||i.get(o)?.icon,i.set(o,s))}async function n(r,i,o,s,h,a,g,w,A,F){if(o.length===0)return Promise.resolve(void 0);const _=o.shift();if(_==="")return n(r,i,o,s,h,a,g,w,A);const N={profileName:r,path:_,args:a,env:g,overrideName:w,isAutoDetected:A,isDefault:r===i};if((0,R.basename)(_)===_){const k=h.PATH?h.PATH.split(R.delimiter):void 0,U=await(0,I.findExecutable)(_,void 0,k,void 0,s.existsFile);return U?(N.path=U,N.isFromPath=!0,N):n(r,i,o,s,h,a)}return await s.existsFile((0,R.normalize)(_))?N:n(r,i,o,s,h,a,g,w,A)}}),define(ne[237],re([0,1,3,2,22,4,38,68,16,13,93,222,8,102,230,113,235,236]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let c=0,d=class extends t.Disposable{constructor(n,r,i,o){super(),this._reconnectConstants=n,this._configurationService=r,this._environmentService=i,this._logService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,C.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const i=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,n);this._onPtyHostStart.fire(),T.ProxyChannel.toService(i.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=i.getChannel(v.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const h=T.ProxyChannel.toService(i.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(h.onProcessData(a=>this._onProcessData.fire(a))),this._register(h.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(h.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(h.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(h.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(h.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(h.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[i,h]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,r,i,o,s,h,a,g,w,A,F){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(n,r,i,o,s,h,a,g,w,A,F);return clearTimeout(_),c=Math.max(c,N),N}updateTitle(n,r,i){return this._proxy.updateTitle(n,r,i)}updateIcon(n,r,i,o){return this._proxy.updateIcon(n,r,i,o)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,r){return this._proxy.detachFromProcess(n,r)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,r){return this._proxy.shutdown(n,r)}input(n,r){return this._proxy.input(n,r)}processBinary(n,r){return this._proxy.processBinary(n,r)}resize(n,r,i){return this._proxy.resize(n,r,i)}acknowledgeDataEvent(n,r){return this._proxy.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this._proxy.setUnicodeVersion(n,r)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,r){return this._proxy.installAutoReply(n,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,r,i,o=!1){const s=await this._shellEnv;return(0,u.detectAvailableProfiles)(r,i,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this._proxy.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this._proxy.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this._proxy.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this._proxy.refreshProperty(n,r)}async updateProperty(n,r,i){return this._proxy.updateProperty(n,r,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this._resolveVariablesRequestStore.acceptReply(n,r)}};d=pe([J(1,I.IConfigurationService),J(2,E.IEnvironmentService),J(3,S.ILogService)],d),e.PtyHostService=d}),define(ne[75],re([0,1,3,4,5,8]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var T;(function(v){v.Http="http",v.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=b;function S(v,y){return y?y!==1&&v<1024:!t.isWindows&&v<1024}e.isPortPrivileged=S;class p{constructor(y,u,m){this.remoteAddress=y,this.localAddress=u,this._dispose=m,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=p;let f=class{constructor(y){this.logService=y,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],u=Array.from(this._tunnels.values());for(const m of u){const c=Array.from(m.values());for(const d of c){const l=await d.value;l&&y.push(l)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:u}of y.values())await u.then(m=>m?.dispose());y.clear()}this._tunnels.clear()}setEnvironmentTunnel(y,u,m,c,d){this.addTunnelToMap(y,u,Promise.resolve({tunnelRemoteHost:y,tunnelRemotePort:u,localAddress:m,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(y,u){(b(y)||C(y))&&(y=e.LOCALHOST_ADDRESSES[0]);const m=this.getTunnelFromMap(y,u);if(m)return++m.refcount,m.value}openTunnel(y,u,m,c,d=!1,l,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${c}.`),!y)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(m)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(y,u,m,c,d,l,n);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const u=this._tunnels.get(y.tunnelRemoteHost);if(u){const m=u.get(y.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,m))}}}}async tryDisposeTunnel(y,u,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${u}.`);const c=m.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(u),c}}async closeTunnel(y,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${u} `);const m=this._tunnels.get(y);if(m&&m.has(u)){const c=m.get(u);c.refcount=0,await this.tryDisposeTunnel(y,u,c)}}addTunnelToMap(y,u,m){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(u,{refcount:1,value:m})}async removeEmptyTunnelFromMap(y,u){const m=this._tunnels.get(y);m&&(await m.get(u)||m.delete(u),m.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,u){const m=[y];C(y)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):b(y)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const c=m.map(d=>this._tunnels.get(d));for(const d of c){const l=d?.get(u);if(l)return l}}canTunnel(y){return!!E(y)}doIsPortPrivileged(y,u,m,c){if(u)return!1;if(m){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(d?.length===4){const l=parseInt(d[1]),n=parseInt(d[2]);if(l>10||l===10&&n>=14)return!1}}return y<1024}createWithProvider(y,u,m,c,d,l,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${c}.`);const r=m;this._factoryInProgress.add(r);const i=c===void 0?m:c,o={elevationRequired:d?this.isPortPrivileged(i):!1},s={remoteAddress:{host:u,port:m},localAddressPort:c,privacy:l,public:l?l!==P.Private:void 0,protocol:n},h=y.forwardPort(s,o);return h?(this.addTunnelToMap(u,m,h),h.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),h}};f=pe([J(0,L.ILogService)],f),e.AbstractTunnelService=f}),define(ne[238],re([0,1,8,75,2,9,6]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(C){this._address=C,this._addressPromise&&(this._addressPromise.complete(C),this._addressPromise=null)}setTunnel(C){this._register(C)}}let I=class Tt extends R.Disposable{constructor(C,b){super(),this._tunnelService=C,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++Tt._lastId)}}async startTunnel(C,b,S,p,f,v){const y=new P,u=await Promise.resolve(this._tunnelService.openTunnel(C,y,S,p,f,v));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${S}:${p} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),y.dispose(),await u.dispose(),(0,L.canceled)();return y.setTunnel(u),this._tunnels.set(b,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${S}:${p} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(C,b){const S=this._tunnels.get(C);!S||S.setAddress(b)}async destroyTunnel(C){const b=this._tunnels.get(C);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this._tunnels.delete(C),await b.dispose();return}this._disposedTunnels.add(C)}};I._lastId=0,I=pe([J(0,t.ISharedTunnelsService),J(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(ne[239],re([0,1,84,34,124,213,6,2,16,8,25,211,75,108,4]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(d,l,n,r,i){let o;for(let s=3;s&&(o?.dispose(),o=await new y(d,l,n,r,i).waitForReady(),!(i&&R.BROWSER_RESTRICTED_PORTS[i]||!R.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));s--);return o}class y extends P.Disposable{constructor(l,n,r,i,o){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=o,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){let l=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),n=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(l){l.pause();const n=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,b.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),i.end()}),l.on("close",()=>i.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),i.destroy()}),i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),l.pipe(i),i.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),i.end()})}}let u=class extends S.AbstractTunnelService{constructor(l,n,r,i,o){super(n),this.socketFactory=l,this.signService=r,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(l){return this.doIsPortPrivileged(l,f.isWindows,f.isMacintosh,t.release())}retainOrCreateTunnel(l,n,r,i,o,s,h){const a=this.getTunnelFromMap(n,r);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,r,i,o,s,h);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const g={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},w=v(g,this.defaultTunnelHost,n,r,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,r,w),w}}};u=pe([J(1,E.ILogService),J(2,p.ISignService),J(3,C.IProductService),J(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let m=class extends u{constructor(l,n,r,i){super(L.nodeSocketFactory,l,n,r,i)}};m=pe([J(0,E.ILogService),J(1,p.ISignService),J(2,C.IProductService),J(3,I.IConfigurationService)],m),e.TunnelService=m;let c=class extends P.Disposable{constructor(l,n,r,i){super(),this.logService=l,this.productService=n,this.signService=r,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(l,n,r,i,o,s,h,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${o}.`),!this._tunnelServices.has(l)){const g=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(g),this._tunnelServices.set(l,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(n,r,i,o,s,h,a)}};c=pe([J(0,E.ILogService),J(1,C.IProductService),J(2,p.ISignService),J(3,I.IConfigurationService)],c),e.SharedTunnelsService=c}),define(ne[31],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[240],re([0,1,3,2,7,13,33,14,8,31]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let C=class extends t.Disposable{constructor(S,p,f,v,y){super(),this.extensionsManagementService=S,this.logService=v,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(m=>{this.installedExtensions=m.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(S.onInstallExtension(m=>this.onInstallExtension(m))),this._register(S.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(S.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const u=R.URI.file(f.extensionsPath);this._register(p.watch(u)),this._register(D.Event.filter(p.onDidFilesChange,m=>m.rawChanges.some(c=>this.doesChangeAffects(c,u)))(()=>this.onDidChange()))}doesChangeAffects(S,p){return S.type!==1&&S.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(S.resource),p)?!1:this.uriIdentityService.extUri.isEqual(S.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(S.resource).startsWith(".")}onInstallExtension(S){this.addInstallingExtension(S.identifier)}onDidInstallExtensions(S){for(const p of S)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(S){S.error||this.removeInstalledExtension(S.identifier)}addInstallingExtension(S){this.removeInstallingExtension(S),this.installingExtensions.push(S)}removeInstallingExtension(S){this.installingExtensions=this.installingExtensions.filter(p=>!(0,T.areSameExtensions)(p,S))}addInstalledExtension(S){this.installedExtensions&&(this.removeInstalledExtension(S),this.installedExtensions.push(S))}removeInstalledExtension(S){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,T.areSameExtensions)(p,S)))}async onDidChange(){if(this.installedExtensions){const S=await this.extensionsManagementService.getInstalled(),p=S.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,T.areSameExtensions)(y,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),f=this.installedExtensions.filter(v=>this.installingExtensions.some(y=>(0,T.areSameExtensions)(y,v))?!1:S.every(y=>!(0,T.areSameExtensions)(y.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=S.map(v=>v.identifier),(p.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:f})}}};C=pe([J(1,P.IFileService),J(2,L.INativeEnvironmentService),J(3,I.ILogService),J(4,E.IUriIdentityService)],C),e.ExtensionsWatcher=C}),define(ne[241],re([0,1,31,94,14,19,122,3,2]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(S){this.uri=S,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let C=class{constructor(S){this._fileService=S,this._dispooables=new I.DisposableStore,this._limit=2**16;const p=new Map,f=v=>{let y=p.get(v.scheme);return y===void 0&&(y=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),p.set(v.scheme,y)),y};this._dispooables.add(P.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{p.delete(v.scheme)})),this.extUri=new L.ExtUri(f),this._canonicalUris=new T.SkipList((v,y)=>this.extUri.compare(v,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,L.normalizePath)(S));const p=this._canonicalUris.get(S);return p?p.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new E(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((f,v)=>f[1].touch<v[1].touch?1:f[1].touch>v[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let f=0;f<p;f++)this._canonicalUris.set(S[f][0],S[f][1].touch())}};C=pe([J(0,R.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(D.IUriIdentityService,C,1)}),define(ne[242],re([0,1,3,2,14,42,48,17]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends t.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(C,b,S,p){super(),this.fileSystemScheme=C,this.fileSystemProvider=b,this.userDataScheme=S,this.logService=p,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(C,b){this.watchResources.set(C,C);const S=this.fileSystemProvider.watch(this.toFileSystemResource(C),b);return(0,t.toDisposable)(()=>{this.watchResources.delete(C),S.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,b,S){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(b),S)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,b,S){const p=(0,L.newWriteableStream)(f=>P.VSBuffer.concat(f.map(v=>P.VSBuffer.wrap(v))).buffer);return(async()=>{try{const f=await this.readFile(C);p.end(f)}catch(f){p.error(f),p.end()}})(),p}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,b,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),b,S)}delete(C,b){return this.fileSystemProvider.delete(this.toFileSystemResource(C),b)}copy(C,b,S){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(C),this.toFileSystemResource(b),S);throw new Error("copy not supported")}handleFileChanges(C){const b=[];for(const S of C){if(S.resource.scheme!==this.fileSystemScheme)continue;const p=this.toUserDataResource(S.resource);this.watchResources.findSubstr(p)&&b.push({resource:p,type:S.type})}b.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(b))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(ne[62],re([0,1,81]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(T,P,I,E){const C=(0,D.setProperty)(T,P,I,E)[0];return C&&(T=T.substring(0,C.offset)+C.content+T.substring(C.offset+C.length)),T}e.edit=t;function R(T,P,I){let E=I;for(;E>=0;){if(T.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&T.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function L(T,P,I){let E=I;for(;E>=0;)if(T.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&T.charAt(E)===P.charAt(1)))return E;return T.length-1}e.getLineEndOffset=L}),define(ne[243],re([0,1,32,56,15]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(p,f,v,y,u,m){const c=[],d=[],l=[];if(!f){const U=p.filter(({identifier:$})=>u.every(Y=>Y.toLowerCase()!==$.id.toLowerCase()));return{local:{added:c,removed:d,updated:l},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}p=p.map(b),f=f.map(b),v=v?v.map(b):null;const n=new Map,r=U=>{U.uuid&&n.set(U.id.toLowerCase(),U.uuid)};p.forEach(({identifier:U})=>r(U)),f.forEach(({identifier:U})=>r(U)),v?.forEach(({identifier:U})=>r(U));const i=U=>{const $=U.identifier.uuid||n.get(U.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${U.identifier.id.toLowerCase()}`},o=(U,$)=>(U.set(i($),$),U),s=p.reduce(o,new Map),h=f.reduce(o,new Map),a=f.reduce((U,$)=>o(U,(0,D.deepClone)($)),new Map),g=v?v.reduce(o,new Map):null,w=y.reduce(o,new Map),A=u.reduce((U,$)=>{const Y=n.get($.toLowerCase());return U.add(Y?`uuid:${Y}`:`id:${$.toLowerCase()}`)},new Set),F=m.reduce((U,{id:$,uuid:Y})=>(Y=Y??n.get($.toLowerCase()),U.add(Y?`uuid:${Y}`:`id:${$.toLowerCase()}`)),new Set),_=T(s,h,A,!1);if(_.added.size>0||_.removed.size>0||_.updated.size>0){const U=T(g,s,A,!1),$=T(g,h,A,!0),Y=(q,V,z,j)=>({...j,installed:V.installed||z.installed,version:z.version&&(!V.installed||t.gt(z.version,V.version))?z.version:V.version,state:I(V,z,g?.get(q)),preRelease:(V.installed?j.preRelease:z.preRelease)??V.preRelease});for(const q of $.removed.values()){const V=s.get(q);if(!V)continue;const z=(0,R.assertIsDefined)(g?.get(q)),j=!F.has(q)&&z.installed;V.installed&&j?d.push(V.identifier):a.set(q,V)}for(const q of $.added.values()){const V=(0,R.assertIsDefined)(h.get(q)),z=s.get(q);if(z){if(_.updated.has(q)){const j=Y(q,z,V,V);P(z,V,!1,!1)||l.push(S(j,q)),a.set(q,j)}}else V.installed&&c.push(S(V,q))}for(const q of $.updated.values()){const V=(0,R.assertIsDefined)(h.get(q)),z=(0,R.assertIsDefined)(g?.get(q)),j=s.get(q);if(j)if(!F.has(q)&&z.installed&&j.installed&&!V.installed)d.push(j.identifier);else{const X=Y(q,j,V,V);l.push(S(X,q)),a.set(q,X)}else V.installed&&c.push(S(V,q))}for(const q of U.added.values())$.added.has(q)||a.set(q,(0,R.assertIsDefined)(s.get(q)));for(const q of U.updated.values()){if($.removed.has(q)||$.updated.has(q))continue;const V=(0,R.assertIsDefined)(s.get(q)),z=(0,R.assertIsDefined)(h.get(q));a.set(q,Y(q,V,z,V))}for(const q of U.removed.values())$.updated.has(q)||$.removed.has(q)||w.has(q)||!(0,R.assertIsDefined)(h.get(q)).installed||F.has(q)||!(0,R.assertIsDefined)(g?.get(q)).installed||a.delete(q)}const N=[],W=T(h,a,new Set,!0),k=W.added.size>0||W.updated.size>0||W.removed.size>0;return k&&a.forEach((U,$)=>N.push(S(U,$))),{local:{added:c,removed:d,updated:l},remote:k?{added:[...W.added].map(U=>a.get(U)),updated:[...W.updated].map(U=>a.get(U)),removed:[...W.removed].map(U=>h.get(U)),all:N}:null}}e.merge=L;function T(p,f,v,y){const u=p?[...p.keys()].filter(n=>!v.has(n)):[],m=[...f.keys()].filter(n=>!v.has(n)),c=m.filter(n=>u.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),d=u.filter(n=>m.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),l=new Set;for(const n of u){if(d.has(n))continue;const r=p.get(n),i=f.get(n);(!i||!P(r,i,y,!0))&&l.add(n)}return{added:c,removed:d,updated:l}}function P(p,f,v,y){return!(p.disabled!==f.disabled||y&&p.installed!==f.installed||p.installed&&f.installed&&p.preRelease!==f.preRelease||!C(p.state,f.state)||v&&p.version!==f.version)}function I(p,f,v){const y=p.state,u=f.state,m=v?.state;if(!f.version||y&&t.gt(p.version,f.version))return y;if(u&&t.gt(f.version,p.version)||!y)return u;if(!u)return y;const c=(0,D.deepClone)(y),d=m?E(m,u):{added:Object.keys(u).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},l=m?E(m,y):{added:Object.keys(y).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...d.added.values(),...d.updated.values()])c[n]=u[n];for(const n of d.removed.values())l.updated.has(n)||delete c[n];return c}function E(p,f){const v=Object.keys(p),y=Object.keys(f),u=y.filter(d=>v.indexOf(d)===-1).reduce((d,l)=>(d.add(l),d),new Set),m=v.filter(d=>y.indexOf(d)===-1).reduce((d,l)=>(d.add(l),d),new Set),c=new Set;for(const d of v){if(m.has(d))continue;const l=p[d],n=f[d];(0,D.equals)(l,n)||c.add(d)}return{added:u,removed:m,updated:c}}function C(p={},f={}){const{added:v,removed:y,updated:u}=E(p,f);return v.size===0&&y.size===0&&u.size===0}function b(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function S(p,f){const v={identifier:{id:p.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(v.version=p.version),p.disabled&&(v.disabled=!0),p.installed&&(v.installed=!0),p.state&&(v.state=p.state),v}}),define(ne[115],re([0,1,18,16,5]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}updateSynchronizedExtensions(P,I){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return E=E.filter(C=>C!==P&&C!==`-${P}`),I&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}getIgnoredExtensions(P){const I=P.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),C=[],b=[];if(Array.isArray(E))for(const S of E)S.startsWith("-")?b.push(S.substring(1)):C.push(S);return(0,D.distinct)([...I,...C].filter(S=>b.indexOf(S)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};L=pe([J(0,t.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[244],re([0,1,18,35,32,183,62]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(d){return(0,t.parse)(d)||[]}e.parseKeybindings=P;async function I(d,l,n,r,i){const o=P(d),s=P(l),h=n?P(n):null,a=[...o,...s,...h||[]].map(Y=>Y.key),g=await i.resolveUserBindings(a),w=C(o,s,h,g);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const A=S(o),F=S(s),_=h?S(h):null,N=f(A,F,g),W=_?f(_,A,g):{added:[...A.keys()].reduce((Y,q)=>(Y.add(q),Y),new Set),removed:new Set,updated:new Set},k=_?f(_,F,g):{added:[...F.keys()].reduce((Y,q)=>(Y.add(q),Y),new Set),removed:new Set,updated:new Set},U=E(N,W,k);let $=d;for(const Y of U.removed.values())U.conflicts.has(Y)||($=m($,Y,r));for(const Y of U.added.values()){if(U.conflicts.has(Y))continue;const q=F.get(Y);if(q.some(V=>V.command!==`-${Y}`&&w.conflicts.has(g[V.key]))){U.conflicts.add(Y);continue}$=u($,q,r)}for(const Y of U.updated.values()){if(U.conflicts.has(Y))continue;const q=F.get(Y);if(q.some(V=>V.command!==`-${Y}`&&w.conflicts.has(g[V.key]))){U.conflicts.add(Y);continue}$=c($,Y,q,r)}return{mergeContent:$,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=I;function E(d,l,n){const r=new Set,i=new Set,o=new Set,s=new Set;for(const h of l.removed.values())n.updated.has(h)&&s.add(h);for(const h of n.removed.values())s.has(h)||(l.updated.has(h)?s.add(h):i.add(h));for(const h of l.added.values())s.has(h)||n.added.has(h)&&d.updated.has(h)&&s.add(h);for(const h of n.added.values())s.has(h)||(l.added.has(h)?d.updated.has(h)&&s.add(h):r.add(h));for(const h of l.updated.values())s.has(h)||n.updated.has(h)&&d.updated.has(h)&&s.add(h);for(const h of n.updated.values())s.has(h)||(l.updated.has(h)?d.updated.has(h)&&s.add(h):o.add(h));return{added:r,removed:i,updated:o,conflicts:s}}function C(d,l,n,r){const i=new Set,o=b(d,r),s=b(l,r),h=n?b(n,r):null,a=p(o,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const g=h?p(h,o):{added:[...o.keys()].reduce((W,k)=>(W.add(k),W),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=h?p(h,s):{added:[...s.keys()].reduce((W,k)=>(W.add(k),W),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:A,removed:F,updated:_,conflicts:N}=E(a,g,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:F,updated:_,conflicts:N}}function b(d,l){const n=new Map;for(const r of d){const i=l[r.key];let o=n.get(i);o||(o=[],n.set(i,o)),o.push(r)}return n}function S(d){const l=new Map;for(const n of d){const r=n.command[0]==="-"?n.command.substring(1):n.command;let i=l.get(r);i||(i=[],l.set(r,i)),i.push(n)}return l}function p(d,l){const n=[...d.keys()],r=[...l.keys()],i=r.filter(h=>n.indexOf(h)===-1).reduce((h,a)=>(h.add(a),h),new Set),o=n.filter(h=>r.indexOf(h)===-1).reduce((h,a)=>(h.add(a),h),new Set),s=new Set;for(const h of n){if(o.has(h))continue;const a=d.get(h).map(w=>({...w,key:h})),g=l.get(h).map(w=>({...w,key:h}));(0,D.equals)(a,g,(w,A)=>y(w,A))||s.add(h)}return{added:i,removed:o,updated:s}}function f(d,l,n){const r=[...d.keys()],i=[...l.keys()],o=i.filter(a=>r.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),s=r.filter(a=>i.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),h=new Set;for(const a of r){if(s.has(a))continue;const g=d.get(a).map(A=>({...A,key:n[A.key]})),w=l.get(a).map(A=>({...A,key:n[A.key]}));v(g,w)||h.add(a)}return{added:o,removed:s,updated:h}}function v(d,l){return!(!(0,D.equals)(d.filter(({command:n})=>n[0]!=="-"),l.filter(({command:n})=>n[0]!=="-"),(n,r)=>y(n,r))||!(0,D.equals)(d.filter(({command:n})=>n[0]==="-"),l.filter(({command:n})=>n[0]==="-"),(n,r)=>y(n,r)))}function y(d,l){if(d.command!==l.command||d.key!==l.key)return!1;const n=L.ContextKeyExpr.deserialize(d.when),r=L.ContextKeyExpr.deserialize(l.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!R.equals(d.args,l.args))}function u(d,l,n){for(const r of l)d=T.edit(d,[-1],r,n);return d}function m(d,l,n){const r=P(d);for(let i=r.length-1;i>=0;i--)(r[i].command===l||r[i].command===`-${l}`)&&(d=T.edit(d,[i],void 0,n));return d}function c(d,l,n,r){const i=P(d),o=i.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=i.length-1;s>=0;s--)(i[s].command===l||i[s].command===`-${l}`)&&(d=T.edit(d,[s],void 0,r));for(let s=n.length-1;s>=0;s--)d=T.edit(d,[o],n[s],r);return d}}),define(ne[245],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,T,P){const I={},E={},C=new Set;if(!T)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const b=t(L,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:E,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=t(P,L),p=t(P,T),f={},v={},y=new Set,u=new Set;for(const m of S.removed.values())p.updated.has(m)?I[m]=T[m]:y.add(m);for(const m of p.removed.values())u.has(m)||(S.updated.has(m)?u.add(m):C.add(m));for(const m of S.updated.values())u.has(m)||(p.updated.has(m)?b.updated.has(m)&&u.add(m):v[m]=L[m]);for(const m of p.updated.values())u.has(m)||(S.updated.has(m)?b.updated.has(m)&&u.add(m):L[m]!==void 0&&(E[m]=T[m]));for(const m of S.added.values())u.has(m)||(p.added.has(m)?b.updated.has(m)&&u.add(m):f[m]=L[m]);for(const m of p.added.values())u.has(m)||(S.added.has(m)?b.updated.has(m)&&u.add(m):I[m]=T[m]);return{local:{added:I,removed:[...C.values()],updated:E},remote:{added:f,removed:[...y.values()],updated:v},conflicts:[...u.values()]}}e.merge=D;function t(L,T){const P=L?Object.keys(L):[],I=T?Object.keys(T):[],E=I.filter(S=>P.indexOf(S)===-1).reduce((S,p)=>(S.add(p),S),new Set),C=P.filter(S=>I.indexOf(S)===-1).reduce((S,p)=>(S.add(p),S),new Set),b=new Set;for(const S of P){if(C.has(S))continue;const p=L[S],f=T[S];p!==f&&b.add(S)}return{added:E,removed:C,updated:b}}function R(L,T){const{added:P,removed:I,updated:E}=t(L,T);return P.size===0&&I.size===0&&E.size===0}e.areSame=R}),define(ne[246],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,L,T,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const C=R.filter(({id:b})=>!P.includes(b));return C.length?I.remote.added=C:I.remote=null,I}const E=t(R,L,P);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const C=t(T,R,P),b=t(T,L,P);for(const S of b.removed){const p=R.find(f=>f.id===S);p&&I.local.removed.push(p)}for(const S of b.added){const p=L.find(f=>f.id===S);C.added.includes(S)?E.updated.includes(S)&&I.local.updated.push(p):I.local.added.push(p)}for(const S of b.updated)I.local.updated.push(L.find(p=>p.id===S));for(const S of C.added)b.added.includes(S)||I.remote.added.push(R.find(p=>p.id===S));for(const S of C.updated)b.removed.includes(S)||b.updated.includes(S)||I.remote.updated.push(R.find(p=>p.id===S));for(const S of C.removed)I.remote.removed.push(L.find(p=>p.id===S))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=D;function t(R,L,T){R=R?R.filter(({id:S})=>!T.includes(S)):[],L=L.filter(({id:S})=>!T.includes(S));const P=R.map(({id:S})=>S),I=L.map(({id:S})=>S),E=I.filter(S=>P.indexOf(S)===-1),C=P.filter(S=>I.indexOf(S)===-1),b=[];for(const{id:S,name:p,shortName:f}of R){if(C.includes(S))continue;const v=L.find(y=>y.id===S);(!v||v.name!==p||v.shortName!==f)&&b.push(S)}return{added:E,removed:C,updated:b}}}),define(ne[26],re([0,1,18,15,171,43,29,5,104,39]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(h=>!!s[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function b(){const s=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(s).filter(w=>!!s[w].ignoreSync),a=Object.keys(s).filter(w=>s[w].scope===2||s[w].scope===6),g=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...a,...g])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const s="vscode://schemas/ignoredSettings",h=E.Registry.as(L.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=E.Registry.as(I.Extensions.JSONContribution),g=()=>{const w=C(),A=b().filter(W=>W!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(L.allSettings.properties).filter(W=>A.indexOf(W)===-1),_=A.filter(W=>w.indexOf(W)===-1),N={items:{type:"string",enum:[...F,..._.map(W=>`-${W}`)]}};a.registerSchema(s,N)};return h.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=S;function p(s){return s&&(0,t.isObject)(s)&&(0,t.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=p;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(s,...h){return s?[s,...h]:h}e.getPathSegments=v;function y(s,h,a,g){return g.joinPath(a.userDataSyncHome,...v(s,h,`lastSync${h}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const h={};return h[e.HEADER_EXECUTION_ID]=s,h}e.createSyncHeaders=u;var m;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(h,a,g,w){super(h),this.code=a,this.resource=g,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class d extends c{constructor(h,a,g,w,A){super(h,g,void 0,A),this.url=a,this.serverCode=w}}e.UserDataSyncStoreError=d;class l extends c{constructor(h,a){super(h,a)}}e.UserDataAutoSyncError=l,function(s){function h(a){if(a instanceof s)return a;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(g&&g[1]){const w=g[2]==="unknown"?void 0:g[2],A=g[3]==="unknown"?void 0:g[3];return new s(a.message,g[1],w,A)}return new s(a.message,"Unknown")}s.toUserDataSyncError=h}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(s){return`sync.enable.${s}`}e.getEnablementKey=o,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[247],re([0,1,32,26]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(T,P,I,E,C){if(!P)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const b=L(T,P);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=I?L(I,P):{added:Object.keys(P).reduce((m,c)=>(m.add(c),m),new Set),removed:new Set,updated:new Set},p=I?L(I,T):{added:Object.keys(T).reduce((m,c)=>(m.add(c),m),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},v=D.deepClone(P),y=!I;for(const m of p.added.values())m!==t.SYNC_SERVICE_URL_TYPE&&y&&S.added.has(m)||(v[m]=T[m]);for(const m of p.updated.values())v[m]=T[m];for(const m of p.removed.values())E.unregistered.includes(m)||delete v[m];for(const m of S.added.values()){const c=P[m];if(E.machine.includes(m)){C.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(I&&p.added.has(m))continue;const d=T[m];d&&d.value===c.value||m===t.SYNC_SERVICE_URL_TYPE&&y&&p.added.has(m)||(d?f.updated[m]=c:f.added[m]=c)}for(const m of S.updated.values()){const c=P[m];if(E.machine.includes(m)){C.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(m)||p.removed.has(m))continue;const d=T[m];d&&d.value===c.value||(f.updated[m]=c)}for(const m of S.removed.values()){if(E.machine.includes(m)){C.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}p.updated.has(m)||p.removed.has(m)||f.removed.push(m)}const u=L(P,v);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:v}}}e.merge=R;function L(T,P){const I=Object.keys(T),E=Object.keys(P),C=E.filter(p=>I.indexOf(p)===-1).reduce((p,f)=>(p.add(f),p),new Set),b=I.filter(p=>E.indexOf(p)===-1).reduce((p,f)=>(p.add(f),p),new Set),S=new Set;for(const p of I){if(b.has(p))continue;const f=T[p],v=P[p];D.equals(f,v)||S.add(p)}return{added:C,removed:b,updated:S}}}),define(ne[248],re([0,1,18,35,81,46,32,62,26]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(a,g,w){let A=[];w?A=b(w):A=C(g);const F=[],_=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const N of A)N.startsWith("-")?_.push(N.substring(1)):F.push(N);return(0,D.distinct)([...a,...F].filter(N=>_.indexOf(N)===-1))}e.getIgnoredSettings=E;function C(a){let g=a.inspect("settingsSync.ignoredSettings").userValue;return g!==void 0||(g=a.inspect("sync.ignoredSettings").userValue,g!==void 0)?g:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const g=(0,t.parse)(a);return g?g["settingsSync.ignoredSettings"]||g["sync.ignoredSettings"]||[]:[]}function S(a,g){const w=(0,t.parse)(a)||{};let A="{}";for(const F of Object.keys(w)){const _=(0,R.setProperty)(A,[F],w[F],g);A=(0,R.applyEdits)(A,_)}return A}e.removeComments=S;function p(a,g,w,A){if(w.length){const F=h(g),_=(0,t.parse)(g)||{},N=(0,t.parse)(a);if(!N)return a;const W=[];for(const k of w){const U=_[k],$=N[k];U===void 0?a=P.edit(a,[k],void 0,A):$!==void 0?a=P.edit(a,[k],U,A):W.push(n(k,F))}W.sort((k,U)=>k.startOffset-U.startOffset),W.forEach(k=>a=m(k.setting.key,g,a,A))}return a}e.updateIgnoredSettings=p;function f(a,g,w,A,F,_){const N=p(a,g,A,_),W=w!==N,k=w!==g;if(!W&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(W&&!k)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(k&&!W)return{conflictsSettings:[],localContent:p(g,a,A,_),remoteContent:null,hasConflicts:!1};if(w===null&&y(a)){const G=v(a,g,A)?null:p(g,a,A,_);return{conflictsSettings:[],localContent:G,remoteContent:null,hasConflicts:!1}}let U=a,$=g;const Y=(0,t.parse)(a),q=(0,t.parse)(g),V=w?(0,t.parse)(w):null,z=A.reduce((G,ee)=>(G.add(ee),G),new Set),j=u(Y,q,z),K=u(V,Y,z),X=u(V,q,z),ce=new Map,B=new Set,H=G=>{B.add(G);const ee=F.filter(({key:oe})=>oe===G)[0];ee?(U=P.edit(U,[G],ee.value,_),$=P.edit($,[G],ee.value,_)):ce.set(G,{key:G,localValue:Y[G],remoteValue:q[G]})};for(const G of K.removed.values())X.updated.has(G)?H(G):$=P.edit($,[G],void 0,_);for(const G of X.removed.values())B.has(G)||(K.updated.has(G)?H(G):U=P.edit(U,[G],void 0,_));for(const G of K.updated.values())B.has(G)||(X.updated.has(G)?j.updated.has(G)&&H(G):$=P.edit($,[G],Y[G],_));for(const G of X.updated.values())B.has(G)||(K.updated.has(G)?j.updated.has(G)&&H(G):U=P.edit(U,[G],q[G],_));for(const G of K.added.values())B.has(G)||(X.added.has(G)?j.updated.has(G)&&H(G):$=m(G,U,$,_));for(const G of X.added.values())B.has(G)||(K.added.has(G)?j.updated.has(G)&&H(G):U=m(G,$,U,_));const O=ce.size>0||!v(U,$,A),M=O||!v(U,a,[]),x=O||!v($,g,[]);return{localContent:M?U:null,remoteContent:x?$:null,conflictsSettings:[...ce.values()],hasConflicts:O}}e.merge=f;function v(a,g,w){if(a===g)return!0;const A=(0,t.parse)(a),F=(0,t.parse)(g),_=w.reduce((k,U)=>(k.add(U),k),new Set),N=h(a).filter(k=>!(k.setting&&_.has(k.setting.key))),W=h(g).filter(k=>!(k.setting&&_.has(k.setting.key)));if(N.length!==W.length)return!1;for(let k=0;k<N.length;k++){const U=N[k],$=W[k];if(U.setting&&$.setting){if(U.setting.key!==$.setting.key||!T.equals(A[U.setting.key],F[U.setting.key]))return!1}else if(!U.setting&&!$.setting){if(U.value!==$.value)return!1}else return!1}return!0}e.areSame=v;function y(a){return a?h(a).length===0:!0}e.isEmpty=y;function u(a,g,w){const A=a?Object.keys(a).filter(k=>!w.has(k)):[],F=Object.keys(g).filter(k=>!w.has(k)),_=F.filter(k=>A.indexOf(k)===-1).reduce((k,U)=>(k.add(U),k),new Set),N=A.filter(k=>F.indexOf(k)===-1).reduce((k,U)=>(k.add(U),k),new Set),W=new Set;if(a)for(const k of A){if(N.has(k))continue;const U=a[k],$=g[k];T.equals(U,$)||W.add(k)}return{added:_,removed:N,updated:W}}function m(a,g,w,A){const F=(0,t.parse)(g),_=h(g),N=h(w),W=c(a,_,N);return d(w,a,F[a],W,N,A)}e.addSetting=m;function c(a,g,w){const A=g.findIndex(_=>_.setting?.key===a),F=g[A-1];if(F){if(F.setting){const N=n(F.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!0}}else{const N=r(A,g);if(N){const W=n(N.setting.key,w);if(W){const k=i(w.indexOf(W),w),U=o(g,N,g[A]);if(k){const $=o(w,W,k),Y=s(U,$);return Y?{index:w.indexOf(Y),insertAfter:!0}:{index:w.indexOf(k),insertAfter:!1}}else{const $=o(w,W,w[w.length-1]),Y=s(U,$);return Y?{index:w.indexOf(Y),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const _=g[A+1];if(_)if(_.setting){const N=n(_.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!1}}else{const N=i(A,g);if(N){const W=n(N.setting.key,w);if(W){const k=r(w.indexOf(W),w),U=o(g,g[A],N);if(k){const $=o(w,k,W),Y=s(U.reverse(),$.reverse());return Y?{index:w.indexOf(Y),insertAfter:!1}:{index:w.indexOf(k),insertAfter:!0}}else{const $=o(w,w[0],W),Y=s(U.reverse(),$.reverse());return Y?{index:w.indexOf(Y),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(a,g,w,A,F,_){let N;return A.index===-1?N=(0,R.setProperty)(a,[g],w,_):N=l(a,g,w,A,F,_).map(W=>(0,R.withFormatting)(a,W,_)[0]),(0,R.applyEdits)(a,N)}function l(a,g,w,A,F,_){const N=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,W=(0,L.getEOL)(_,a),k=F[A.index];if(A.insertAfter){const U=[];if(k.setting)U.push({offset:k.endOffset,length:0,content:","+N});else{const $=i(A.index,F),Y=r(A.index,F),q=Y?.setting?.commaOffset;Y&&q===void 0&&U.push({offset:Y.endOffset,length:0,content:","});const V=q!==void 0&&q>k.endOffset;U.push({offset:V?q+1:k.endOffset,length:0,content:$?W+N+",":W+N})}return U}else{if(k.setting)return[{offset:k.startOffset,length:0,content:N+","}];const U=(F[A.index-1]&&!F[A.index-1].setting?W:"")+N+(i(A.index,F)?",":"")+W;return[{offset:k.startOffset,length:0,content:U}]}}function n(a,g){return g.filter(w=>w.setting?.key===a)[0]}function r(a,g){for(let w=a-1;w>=0;w--)if(g[w].setting)return g[w]}function i(a,g){for(let w=a+1;w<g.length;w++)if(g[w].setting)return g[w]}function o(a,g,w){const A=a.indexOf(g),F=a.indexOf(w);return a.filter((_,N)=>A<N&&N<F)}function s(a,g){if(a.length&&g.length){let w=0;for(;w<g.length&&w<a.length;w++)if(a[w].value!==g[w].value)return g[w-1];return g[w-1]}}function h(a){const g=[];let w=-1,A,F;const _={onObjectBegin:N=>{w++},onObjectProperty:(N,W,k)=>{w===0&&(A=W,F=N)},onObjectEnd:(N,W)=>{w--,w===0&&g.push({startOffset:A,endOffset:N+W,value:a.substring(A,N+W),setting:{key:F,commaOffset:void 0}})},onArrayBegin:(N,W)=>{w++},onArrayEnd:(N,W)=>{w--,w===0&&g.push({startOffset:A,endOffset:N+W,value:a.substring(A,N+W),setting:{key:F,commaOffset:void 0}})},onLiteralValue:(N,W,k)=>{w===0&&g.push({startOffset:A,endOffset:W+k,value:a.substring(A,W+k),setting:{key:F,commaOffset:void 0}})},onSeparator:(N,W,k)=>{if(w===0&&N===","){let U=g.length-1;for(;U>=0&&!g[U].setting;U--);const $=g[U];$&&g.splice(U,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:W}})}},onComment:(N,W)=>{w===0&&g.push({startOffset:N,endOffset:N+W,value:a.substring(N,N+W)})}};return(0,t.visit)(a,_),g}}),define(ne[76],re([0,1,3,2,5,26]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let T=class extends t.Disposable{get account(){return this._account}constructor(I,E){super(),this.userDataSyncStoreService=I,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};T=pe([J(0,L.IUserDataSyncStoreService),J(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[249],re([0,1,2,7]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(S){this.service=S}listen(S,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(S,p,f){switch(p){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class L{constructor(S){this.service=S}listen(S,p){throw new Error(`Event not found: ${p}`)}call(S,p,f){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(S){this.channel=S}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(S){return this.channel.call("resolveUserKeybindings",[S])}async resolveFormattingOptions(S){return this.channel.call("resolveFormattingOptions",[S])}}e.UserDataSyncUtilServiceClient=T;class P{constructor(S){this.service=S}listen(S,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(S,p,f){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(S){this.service=S}listen(S,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(S,p,f){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class E{constructor(S){this.service=S}listen(S,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(S,p,f){switch(p){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class C extends D.Disposable{constructor(S){super(),this.channel=S,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(S){return this.channel.call("switch",[S])}async getPreviousUserDataSyncStore(){const S=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(S)}revive(S){return{url:t.URI.revive(S.url),type:S.type,defaultUrl:t.URI.revive(S.defaultUrl),insidersUrl:t.URI.revive(S.insidersUrl),stableUrl:t.URI.revive(S.stableUrl),canSwitch:S.canSwitch,authenticationProviders:S.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(ne[250],re([0,1,13,8]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends t.AbstractLogger{constructor(T,P){super(),this.logger=this._register(T.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}critical(T,...P){this.logger.critical(T,...P)}flush(){this.logger.flush()}};R=pe([J(0,t.ILoggerService),J(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(ne[251],re([0,1,6,3,2]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:E}){super(),this.disposables=this._register(new R.DisposableStore),t.Event.latch(t.Event.any(P,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[116],re([0,1,173,10,48,19,7,5,22]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function E(r){const i=r;return typeof i?.id=="string"&&T.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=r;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=C;function b(r){const i=r;return typeof i?.id=="string"&&T.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function S(r){const i=r;if(i?.uri)return{id:i.id,uri:T.URI.revive(i.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=S;var p;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function v(r){const i=r;return!!(i&&typeof i=="object"&&T.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=v;class y{constructor(i,o,s,h,a){this._id=i,this._transient=s,this._configuration=h,this._ignorePathCasing=a,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function m(r){return new u({uri:r,index:0,name:(0,L.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(r,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function d(r){let i;return T.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=d;function l(r,i){return!c(r,i)&&!d(r)}e.isSavedWorkspace=l;function n(r){return(typeof r=="string"?(0,t.extname)(r):(0,L.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ne[20],re([0,1,66,3,2,19,15,7,166,13,14,5,8,116,40,31,6,30,27]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&P.URI.isUri(o.location)&&P.URI.isUri(o.globalStorageHome)&&P.URI.isUri(o.settingsResource)&&P.URI.isUri(o.keybindingsResource)&&P.URI.isUri(o.tasksResource)&&P.URI.isUri(o.snippetsHome)&&((0,T.isUndefined)(o.extensionsResource)||P.URI.isUri(o.extensionsResource)))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function d(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:P.URI.revive(i.location).with({scheme:o}),globalStorageHome:P.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:P.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:P.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:P.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:P.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:P.URI.revive(i.extensionsResource)?.with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(i,o,s,h){return{id:i,name:o,location:s,isDefault:!1,shortName:h?.shortName,globalStorageHome:(0,L.joinPath)(s,"globalStorage"),settingsResource:(0,L.joinPath)(s,"settings.json"),keybindingsResource:(0,L.joinPath)(s,"keybindings.json"),tasksResource:(0,L.joinPath)(s,"tasks.json"),snippetsHome:(0,L.joinPath)(s,"snippets"),extensionsResource:(0,L.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}e.toUserDataProfile=l;let n=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(o,s,h,a){super(),this.environmentService=o,this.fileService=s,this.uriIdentityService=h,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(o){this.enabled!==o&&(this._profilesObject=void 0,this.enabled=o)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const o=this.enabled?this.getStoredProfiles().map(g=>l((0,L.basename)(g.location),g.name,g.location,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags})):[];let s;const h=new f.ResourceMap,a=l((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(o.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||o.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),o.length){const g=this.getStoredProfileAssociations();if(g.workspaces)for(const[w,A]of Object.entries(g.workspaces)){const F=P.URI.parse(w),_=P.URI.parse(A),N=o.find(W=>this.uriIdentityService.extUri.isEqual(W.location,_));N&&h.set(F,N)}if(g.emptyWindow){const w=P.URI.parse(g.emptyWindow);s=o.find(A=>this.uriIdentityService.extUri.isEqual(A.location,w))}}this._profilesObject={profiles:o,workspaces:h,emptyWindow:s}}return this._profilesObject}async createTransientProfile(o){const s="Temp",h=new RegExp(`${(0,m.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const w of this.profiles){const A=h.exec(w.name),F=A?parseInt(A[1]):0;a=F>a?F:a}const g=`${s} ${a+1}`;return this.createProfile((0,D.hash)((0,u.generateUuid)()).toString(16),g,{transient:!0},o)}async createNamedProfile(o,s,h){return this.createProfile((0,D.hash)((0,u.generateUuid)()).toString(16),o,s,h)}async createProfile(o,s,h,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const g=await this.doCreateProfile(o,s,h);return a&&await this.setProfileForWorkspace(a,g),g}async doCreateProfile(o,s,h){let a=this.profileCreationPromises.get(s);return a||(a=(async()=>{try{const g=this.profiles.find(F=>F.name===s||F.id===o);if(g)return g;const w=l(o,s,(0,L.joinPath)(this.profilesHome,o),h);await this.fileService.createFolder(w.location);const A=[];return this._onWillCreateProfile.fire({profile:w,join(F){A.push(F)}}),await y.Promises.settled(A),this.updateProfiles([w],[],[]),w}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,a)),a}async updateProfile(o,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let h=this.profiles.find(a=>a.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);return h=l(h.id,s.name??h.name,h.location,{shortName:s.shortName??h.shortName,transient:s.transient??h.isTransient,useDefaultFlags:s.useDefaultFlags??h.useDefaultFlags}),this.updateProfiles([],[],[h]),h}async removeProfile(o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===o.id);if(!s)throw new Error(`Profile '${o.name}' does not exist`);const h=[];this._onWillRemoveProfile.fire({profile:s,join(a){h.push(a)}});try{await Promise.allSettled(h)}catch(a){this.logService.error(a)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(o,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let h=this.getProfileForWorkspace(o);return h||(h=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(o,h)),h}async setProfileForWorkspace(o,s){this.setProfileForWorkspaceSync(o,s)}setProfileForWorkspaceSync(o,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=this.profiles.find(a=>a.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(o,h)}unsetWorkspace(o,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(o,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const o=await this.fileService.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(s=>s.isDirectory&&this.profiles.every(h=>!this.uriIdentityService.extUri.isEqual(h.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const o=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(o.map(s=>this.removeProfile(s)))}getProfileForWorkspace(o){const s=this.getWorkspace(o);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(o){return(0,p.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,p.isWorkspaceIdentifier)(o)?o.configPath:"empty-window"}isProfileAssociatedToWorkspace(o){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,o.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,o.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,o.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,o.location)))}updateProfiles(o,s,h){const a=[...this.profiles,...o],g=[];this.transientProfilesObject.profiles=[];for(let w of a)w.isDefault||s.some(A=>w.id===A.id)||(w=h.find(A=>w.id===A.id)??w,w.isTransient?this.transientProfilesObject.profiles.push(w):g.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.saveStoredProfiles(g),this._profilesObject=void 0,this.triggerProfilesChanges(o,s,h)}triggerProfilesChanges(o,s,h){this._onDidChangeProfiles.fire({added:o,removed:s,updated:h,all:this.profiles})}updateWorkspaceAssociation(o,s,h){h=s?.isTransient?!0:h,h||this.updateWorkspaceAssociation(o,void 0,!0);const a=this.getWorkspace(o),g=h?this.transientProfilesObject:this.profilesObject;P.URI.isUri(a)?(g.workspaces.delete(a),s&&g.workspaces.set(a,s)):g.emptyWindow=s,h||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const o={};for(const[h,a]of this.profilesObject.workspaces.entries())o[h.toString()]=a.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:o,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(o){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(o){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=pe([J(0,E.IEnvironmentService),J(1,C.IFileService),J(2,v.IUriIdentityService),J(3,S.ILogService)],n),e.UserDataProfilesService=n;class r extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(o){this.storedProfiles=o}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(o){this.storedProfileAssociations=o}}e.InMemoryUserDataProfilesService=r}),define(ne[252],re([0,1,6,2,20]),function(Q,e,D,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends t.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};L=pe([J(0,R.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[253],re([0,1,18,6,24,9,3,2,4,7,148,29,33,44,8,25,23,20]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,o,s,h,a){super(),this.galleryService=i,this.telemetryService=o,this.logService=s,this.productService=h,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:g})=>g.cancel()),this.uninstallingExtensions.forEach(g=>g.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const o=await this.getTargetPlatform();return i.allTargetPlatforms.some(s=>(0,b.isTargetPlatformCompatible)(s,i.allTargetPlatforms,o))}async installFromGallery(i,o={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(C.localize(0,null),b.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(i,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,o)}catch(s){throw l(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(i),error:s}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(s),d(s)}}async uninstall(i,o={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,o)}async reinstallFromGallery(i){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",i.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const o=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...i.identifier,preRelease:i.preRelease}],{targetPlatform:o,compatible:!0},R.CancellationToken.None);if(!s)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(i,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,o,s){const h=_=>`${S.ExtensionKey.create(_).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!E.URI.isUri(o)){const _=this.installingExtensions.get(h(o));if(_){this.logService.info("Extensions is already requested to install",o.identifier.id);const{local:N}=await _.task.waitUntilTaskIsFinished();return N}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],g=[],w=[],A=this.createInstallExtensionTask(i,o,s);E.URI.isUri(o)||this.installingExtensions.set(h(o),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:o,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),a.push({task:A,manifest:i});let F=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const N=await this.getAllDepsAndPackExtensions(A.identifier,i,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),W=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:k,manifest:U}of N){F=F||!!U.extensionDependencies?.some(q=>(0,S.areSameExtensions)({id:q},A.identifier));const $=h(k),Y=this.installingExtensions.get($);if(Y){if(this.canWaitForTask(A,Y.task)){this.logService.info("Waiting for already requested installing extension",k.identifier.id,A.identifier.id),Y.waitingTasks.push(A);const q=Y.task.identifier;g.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,V=>V.some(z=>(0,S.areSameExtensions)(z.identifier,q)))).then(V=>{if(!V.find(j=>(0,S.areSameExtensions)(j.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!W.some(({identifier:q})=>(0,S.areSameExtensions)(q,k.identifier))){const q=this.createInstallExtensionTask(U,k,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set($,{task:q,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:q.identifier,source:k,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",q.identifier.id,A.identifier.id),a.push({task:q,manifest:U})}}}catch(N){if(E.URI.isUri(A.source))(0,D.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,N.message),(0,D.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),N}const _=a.reduce((N,{task:W,manifest:k})=>(N.set(W.identifier.id.toLowerCase(),{task:W,manifest:k}),N),new Map);for(;_.size;){let N;const W=[..._.values()].filter(({manifest:k})=>!k.extensionDependencies?.some(U=>_.has(U.toLowerCase())));W.length?N=_.size===1?W:W.filter(({task:k})=>!(k===A&&!F)):(this.logService.info("Found extensions with circular dependencies",W.map(({task:k})=>k.identifier.id)),N=[..._.values()]),await this.joinAllSettled(N.map(async({task:k})=>{const U=new Date().getTime();try{const{local:$}=await k.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall($,k.source,s,R.CancellationToken.None))),!E.URI.isUri(k.source)){const Y=k.operation===3,q=Y?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(l(this.telemetryService,Y?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(k.source),wasVerified:k.wasVerified,duration:new Date().getTime()-U,durationSinceUpdate:q}),I.isWeb&&k.operation!==3)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}w.push({local:$,identifier:k.identifier,operation:k.operation,source:k.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw E.URI.isUri(k.source)||l(this.telemetryService,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(k.source),wasVerified:k.wasVerified,duration:new Date().getTime()-U,error:$}),this.logService.error("Error while installing the extension:",k.identifier.id),$}finally{_.delete(k.identifier.id.toLowerCase())}}))}return g.length&&await this.joinAllSettled(g),w.forEach(({identifier:N})=>this.logService.info("Extension installed successfully:",N.id)),this._onDidInstallExtensions.fire(w),w.filter(({identifier:N})=>(0,S.areSameExtensions)(N,A.identifier))[0].local}catch(_){if(a.forEach(({task:N})=>N.cancel()),w.length)try{const N=await Promise.allSettled(w.map(({local:W})=>this.createUninstallExtensionTask(W,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let W=0;W<N.length;W++){const k=N[W],{identifier:U}=w[W];k.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,L.getErrorMessage)(k.reason))}}catch(N){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(N),w.map(({identifier:W})=>W.id))}throw this._onDidInstallExtensions.fire(a.map(({task:N})=>({identifier:N.identifier,operation:2,source:N.source,context:s.context,profileLocation:s.profileLocation}))),_}finally{for(const[_,{task:N,waitingTasks:W}]of this.installingExtensions.entries()){const k=W.indexOf(A);k!==-1&&W.splice(k,1),W.length===0&&(N===A||k!==-1)&&this.installingExtensions.delete(_)}}}canWaitForTask(i,o){for(const[,{task:s,waitingTasks:h}]of this.installingExtensions.entries())if(s===i&&(h.includes(o)||h.some(a=>this.canWaitForTask(a,o)))||s===o&&h[0]&&!this.canWaitForTask(i,h[0]))return!1;return!0}async joinAllSettled(i){const o=[],s=[],h=await Promise.allSettled(i);for(const a of h)a.status==="fulfilled"?o.push(a.value):s.push(a.reason);if(s.length)throw c(s);return o}async getAllDepsAndPackExtensions(i,o,s,h,a){if(!this.galleryService.isEnabled())return[];const g=await this.getInstalled(void 0,a),w=[i],A=[],F=async(_,N)=>{const W=N.extensionDependencies||[],k=[...W];if(N.extensionPack){const U=s?g.find($=>(0,S.areSameExtensions)($.identifier,_)):void 0;for(const $ of N.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(Y=>(0,S.areSameExtensions)({id:Y},{id:$}))||k.every(Y=>!(0,S.areSameExtensions)({id:Y},{id:$}))&&k.push($)}if(k.length){const U=[...w,...A.map(Y=>Y.gallery.identifier)],$=k.filter(Y=>U.every(q=>!(0,S.areSameExtensions)(q,{id:Y})));if($.length){const Y=await this.galleryService.getExtensions($.map(q=>({id:q,preRelease:h})),R.CancellationToken.None);for(const q of Y){if(U.find(j=>(0,S.areSameExtensions)(j,q.identifier)))continue;const V=W.some(j=>(0,S.areSameExtensions)({id:j},q.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(q,!1,h)}catch(j){if(j instanceof b.ExtensionManagementError&&j.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",q.identifier.id);continue}else throw j}A.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(i,o),A}async checkAndGetCompatibleVersion(i,o,s){if((await this.getExtensionsControlManifest()).malicious.some(w=>(0,S.areSameExtensions)(i.identifier,w)))throw new b.ExtensionManagementError(C.localize(3,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const w=await this.getTargetPlatform();throw new b.ExtensionManagementError(C.localize(4,null,i.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(w)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(i,o,s);if(a){if(s&&!o&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(C.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],R.CancellationToken.None))[0]?new b.ExtensionManagementError(C.localize(6,null,i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(C.localize(7,null,i.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const g=await this.galleryService.getManifest(a,R.CancellationToken.None);if(g===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(g.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:g}}async getCompatibleVersion(i,o,s){const h=await this.getTargetPlatform();let a=null;return!o&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==s&&(a=(await this.galleryService.getExtensions([{...i.identifier,preRelease:s}],{targetPlatform:h,compatible:!0},R.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(i,s,h)&&(a=i),a||(o?a=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:h,compatible:!0},R.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(i,s,h)),a}async uninstallExtension(i,o){const s=F=>`${F.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,h=this.uninstallingExtensions.get(s(i.identifier));if(h)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),h.waitUntilTaskIsFinished();const a=(F,_)=>{const N=this.createUninstallExtensionTask(F,_);return this.uninstallingExtensions.set(s(N.extension.identifier),N),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this._onUninstallExtension.fire({identifier:F.identifier,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped}),N},g=(F,_)=>{_?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString(),_.message):this.logService.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,_.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),l(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(F),error:_}),this._onDidUninstallExtension.fire({identifier:F.identifier,version:F.manifest.version,error:_?.code,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped})},w=[],A=[];try{w.push(a(i,o));const F=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const _=this.getAllPackExtensionsToUninstall(i,F);for(const N of _)this.uninstallingExtensions.has(s(N.identifier))?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):w.push(a(N,o))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(w.map(_=>_.extension),F,i),await this.joinAllSettled(w.map(async _=>{try{if(await _.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(_.extension,o,R.CancellationToken.None))),_.extension.identifier.uuid)try{await this.galleryService.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}g(_.extension)}catch(N){const W=N instanceof b.ExtensionManagementError?N:new b.ExtensionManagementError((0,L.getErrorMessage)(N),b.ExtensionManagementErrorCode.Internal);throw g(_.extension,W),W}finally{A.push(_)}}))}catch(F){const _=F instanceof b.ExtensionManagementError?F:new b.ExtensionManagementError((0,L.getErrorMessage)(F),b.ExtensionManagementErrorCode.Internal);for(const N of w){try{N.cancel()}catch{}A.includes(N)||g(N.extension,_)}throw _}finally{for(const F of w)this.uninstallingExtensions.delete(s(F.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}checkForDependents(i,o,s){for(const h of i){const a=this.getDependents(h,o);if(a.length){const g=a.filter(w=>!i.some(A=>(0,S.areSameExtensions)(A.identifier,w.identifier)));if(g.length)throw new Error(this.getDependentsErrorMessage(h,g,s))}}}getDependentsErrorMessage(i,o,s){return s===i?o.length===1?C.localize(8,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(9,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(10,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(11,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(12,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(13,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(i,o,s=[]){if(s.indexOf(i)!==-1)return[];s.push(i);const h=i.manifest.extensionPack?i.manifest.extensionPack:[];if(h.length){const a=o.filter(w=>!w.isBuiltin&&h.some(A=>(0,S.areSameExtensions)({id:A},w.identifier))),g=[];for(const w of a)g.push(...this.getAllPackExtensionsToUninstall(w,o,s));return[...a,...g]}return[]}getDependents(i,o){return o.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(h=>(0,S.areSameExtensions)({id:h},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(i,o,s){return s.profileLocation&&(0,p.isApplicationScopedExtension)(i)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(i,o,s)}createUninstallExtensionTask(i,o){return o.profileLocation&&i.isApplicationScoped&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(i,o)}};m=pe([J(0,b.IExtensionGalleryService),J(1,y.ITelemetryService),J(2,f.ILogService),J(3,v.IProductService),J(4,u.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function c(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((o,s)=>new Error(`${o.message}${o.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function d(r){if(r instanceof b.ExtensionManagementError)return r;const i=new b.ExtensionManagementError(r.message,b.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function l(r,i,{extensionData:o,wasVerified:s,duration:h,error:a,durationSinceUpdate:g}){let w,A;a&&(a instanceof b.ExtensionManagementError?(w=a.code,a.code===b.ExtensionManagementErrorCode.Signature&&(A=a.message)):w=b.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...o,wasVerified:s,success:!a,duration:h,errorcode:w,errorcodeDetail:A,durationSinceUpdate:g})}e.reportTelemetry=l;class n{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(i=>new Promise((o,s)=>{const h=i.onCancellationRequested(()=>{h.dispose(),s(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(ne[77],re([0,1,18,6,32,17,9,35,130,2,22,10,4,19,56,87,15,7,151,13,33,44,70,14,5,8,25,3,67,51,20,31,179]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n,r,i,o,s,h,a,g,w,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(q){function V(z,j){if(z===j)return!0;const K=Object.keys(z),X=new Set;for(const ce of Object.keys(j))X.add(ce);if(K.length!==X.size)return!1;for(const ce of K){if(z[ce]!==j[ce])return!1;X.delete(ce)}return X.size===0}q.equals=V})(_=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let N=class extends E.Disposable{constructor(V,z,j,K,X,ce,B,H,O,M,x){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=z,this.extensionsControlLocation=j,this.cacheLocation=K,this.userDataProfilesService=X,this.extensionsProfileScannerService=ce,this.fileService=B,this.logService=H,this.environmentService=O,this.productService=M,this.instantiationService=x,this._onDidChangeCache=this._register(new h.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,p.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,p.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(k,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,z,j){const[K,X]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(z)]),ce=j?await this.scanExtensionsUnderDevelopment(V,[...K,...X]):[];return this.dedupExtensions(K,X,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const z=[];z.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),z.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[j,K]=await Promise.all(z);return this.applyScanOptions([...j,...K],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let K=await(V.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return K=await this.applyScanOptions(K,1,V,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(V,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const j=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(K=>K.scheme===C.Schemas.file).map(async K=>{const X=await this.createExtensionScannerInput(K,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(X)).map(B=>(B.type=z.find(H=>(0,d.areSameExtensions)(H.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,X)))}))).flat();return this.applyScanOptions(j,"development",V,!0)}return[]}async scanExistingExtension(V,z,j){const K=await this.createExtensionScannerInput(V,!1,z,!0,j.language),X=await this.extensionsScanner.scanExtension(K);return!X||!j.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(V,z,j){const K=await this.createExtensionScannerInput(V,!1,z,!0,j.language),X=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(X,z,j,!0)}async scanMetadata(V){const z=(0,p.joinPath)(V,"package.json"),j=(await this.fileService.readFile(z)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(V,z){const j=(0,p.joinPath)(V,"package.json"),K=(await this.fileService.readFile(j)).value.toString(),X=JSON.parse(K);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,X.__metadata={...X.__metadata,...z},await this.fileService.writeFile((0,p.joinPath)(V,"package.json"),L.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async applyScanOptions(V,z,j,K){return j.includeAllVersions||(V=this.dedupExtensions(z===0?V:void 0,z===1?V:void 0,z==="development"?V:void 0,await this.getTargetPlatform(),K)),j.includeInvalid||(V=V.filter(X=>X.isValid)),V.sort((X,ce)=>{const B=b.basename(X.location.fsPath),H=b.basename(ce.location.fsPath);return B<H?-1:B>H?1:0})}dedupExtensions(V,z,j,K,X){const ce=(H,O,M)=>{if(H.isValid&&!O.isValid)return!1;if(H.isValid===O.isValid){if(X&&f.gt(H.manifest.version,O.manifest.version))return this.logService.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(f.eq(H.manifest.version,O.manifest.version)){if(H.type===0)return this.logService.debug(`Skipping extension ${O.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===K)return this.logService.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${H.location.path} with ${O.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${O.location.path}.`),!0},B=new Map;return V?.forEach(H=>{const O=l.ExtensionIdentifier.toKey(H.identifier.id),M=B.get(O);(!M||ce(M,H,!1))&&B.set(O,H)}),z?.forEach(H=>{const O=l.ExtensionIdentifier.toKey(H.identifier.id),M=B.get(O);if(!M&&V&&H.type===0){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!M||ce(M,H,!1))&&B.set(O,H)}),j?.forEach(H=>{const O=l.ExtensionIdentifier.toKey(H.identifier.id),M=B.get(O);(!M||ce(M,H,!0))&&B.set(O,H),B.set(O,H)}),[...B.values()]}async scanDefaultSystemExtensions(V,z){this.logService.trace("Started scanning system extensions");const j=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),X=await(V&&!j.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return this.logService.trace("Scanned system extensions:",X.length),X}async scanDevSystemExtensions(V,z){const j=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!j?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=z?await this.getBuiltInExtensionControl():{},X=[],ce=u.URI.file(b.normalize(b.join(C.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const H of j){const O=K[H.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":X.push((0,p.joinPath)(ce,H.name));break;default:X.push(u.URI.file(O));break}}const B=await Promise.all(X.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,D.coalesce)(B)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,z,j,K,X,ce=!0){const B=await this.getTranslations(X??S.language),H=await this.getMtime(V),O=z?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=O?await this.getMtime(O):void 0;return new W(V,H,O,M,z,j,K,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,X,B)}async getMtime(V){try{const z=await this.fileService.stat(V);if(typeof z.mtime=="number")return z.mtime}catch{}}};N=pe([J(4,w.IUserDataProfilesService),J(5,g.IExtensionsProfileScannerService),J(6,r.IFileService),J(7,o.ILogService),J(8,c.IEnvironmentService),J(9,s.IProductService),J(10,i.IInstantiationService)],N),e.AbstractExtensionsScannerService=N;class W{constructor(V,z,j,K,X,ce,B,H,O,M,x,G,ee,oe){this.location=V,this.mtime=z,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=K,this.profile=X,this.type=ce,this.excludeObsolete=B,this.validate=H,this.productVersion=O,this.productDate=M,this.productCommit=x,this.devMode=G,this.language=ee,this.translations=oe}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,z){return(0,p.isEqual)(V.location,z.location)&&V.mtime===z.mtime&&(0,p.isEqual)(V.applicationExtensionslocation,z.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&V.profile===z.profile&&V.type===z.type&&V.excludeObsolete===z.excludeObsolete&&V.validate===z.validate&&V.productVersion===z.productVersion&&V.productDate===z.productDate&&V.productCommit===z.productCommit&&V.devMode===z.devMode&&V.language===z.language&&_.equals(V.translations,z.translations)}}let k=class extends E.Disposable{constructor(V,z,j,K,X){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=z,this.uriIdentityService=j,this.fileService=K,this.logService=X}async scanExtensions(V){const z=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let j={};if(V.excludeObsolete&&V.type===1)try{const K=(await this.fileService.readFile(this.obsoleteFile)).value.toString();j=JSON.parse(K)}catch{}return(0,y.isEmptyObject)(j)?z:z.filter(K=>!j[d.ExtensionKey.create(K).toString()])}async scanExtensionsFromLocation(V){const z=await this.fileService.resolve(V.location);if(!z.children?.length)return[];const j=await Promise.all(z.children.map(async K=>{if(!K.isDirectory||V.type===1&&(0,p.basename)(K.resource).indexOf(".")===0)return null;const X=new W(K.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(X)}));return(0,D.coalesce)(j).sort((K,X)=>K.location.path<X.location.path?-1:1)}async scanExtensionsFromProfile(V){let z=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){z=z.filter(K=>!K.metadata?.isApplicationScoped);const j=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,V);z.push(...j)}return z}async scanExtensionsFromProfileResource(V,z,j){const K=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!K.length)return[];const X=await Promise.all(K.map(async ce=>{if(z(ce)){const B=new W(ce.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(B,ce.metadata)}return null}));return(0,D.coalesce)(X)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,p.joinPath)(V.location,"package.json"))){const z=await this.scanExtension(V);return z?[z]:[]}else return await this.scanExtensions(V)}catch(z){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,T.getErrorMessage)(z)),[]}}async scanExtension(V,z){try{let j=await this.scanExtensionManifest(V.location);if(j){j.publisher||(j.publisher=l.UNDEFINED_PUBLISHER),z=z??j.__metadata,delete j.__metadata;const K=(0,d.getGalleryExtensionId)(j.publisher,j.name),X=z?.id?{id:K,uuid:z.id}:{id:K},ce=z?.isSystem?0:V.type,B=ce===0||!!z?.isBuiltin;j=await this.translateManifest(V.location,j,W.createNlsConfiguration(V));const H={type:ce,identifier:X,manifest:j,location:V.location,isBuiltin:B,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return V.validate?this.validate(H,V):H}}catch(j){V.type!==0&&this.logService.error(j)}return null}validate(V,z){let j=!0;const K=(0,n.validateExtensionManifest)(z.productVersion,z.productDate,z.location,V.manifest,V.isBuiltin);for(const[X,ce]of K)X===v.default.Error&&(j=!1,this.logService.error(this.formatMessage(z.location,ce)));return V.isValid=j,V.validations=K,V}async scanExtensionManifest(V){const z=(0,p.joinPath)(V,"package.json");let j;try{j=(await this.fileService.readFile(z)).value.toString()}catch(X){return(0,r.toFileOperationResult)(X)!==1&&this.logService.error(this.formatMessage(V,(0,m.localize)(0,null,z.path,X.message))),null}let K;try{K=JSON.parse(j)}catch{const ce=[];(0,P.parse)(j,ce);for(const B of ce)this.logService.error(this.formatMessage(V,(0,m.localize)(1,null,z.path,B.offset,B.length,(0,I.getParseErrorMessage)(B.error))));return null}return(0,P.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(V,(0,m.localize)(2,null,z.path))),null):K}async translateManifest(V,z,j){const K=await this.getLocalizedMessages(V,z,j);if(K)try{const X=[],ce=await this.resolveOriginalMessageBundle(K.default,X);if(X.length>0)return X.forEach(H=>{this.logService.error(this.formatMessage(V,(0,m.localize)(3,null,K.default?.path,(0,I.getParseErrorMessage)(H.error))))}),z;if((0,P.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(V,(0,m.localize)(4,null,K.default?.path))),z;const B=K.values||Object.create(null);return(0,F.localizeManifest)(z,B,ce)}catch{}return z}async getLocalizedMessages(V,z,j){const K=(0,p.joinPath)(V,"package.nls.json"),X=(O,M)=>{M.forEach(x=>{this.logService.error(this.formatMessage(V,(0,m.localize)(5,null,O?.path,(0,I.getParseErrorMessage)(x.error))))})},ce=O=>{this.logService.error(this.formatMessage(V,(0,m.localize)(6,null,O?.path)))},B=`${z.publisher}.${z.name}`,H=j.translations[B];if(H)try{const O=u.URI.file(H),M=(await this.fileService.readFile(O)).value.toString(),x=[],G=(0,P.parse)(M,x);return x.length>0?(X(O,x),{values:void 0,default:K}):(0,P.getNodeType)(G)!=="object"?(ce(O),{values:void 0,default:K}):{values:G.contents?G.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let M;try{M=await this.findMessageBundles(V,j)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const x=(await this.fileService.readFile(M.localized)).value.toString(),G=[],ee=(0,P.parse)(x,G);return G.length>0?(X(M.localized,G),{values:void 0,default:M.original}):(0,P.getNodeType)(ee)!=="object"?(ce(M.localized),{values:void 0,default:M.original}):{values:ee,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(V,z){if(V)try{const j=(await this.fileService.readFile(V)).value.toString();return(0,P.parse)(j,z)}catch{}}findMessageBundles(V,z){return new Promise((j,K)=>{const X=ce=>{const B=(0,p.joinPath)(V,`package.nls.${ce}.json`);this.fileService.exists(B).then(H=>{H&&j({localized:B,original:(0,p.joinPath)(V,"package.nls.json")});const O=ce.lastIndexOf("-");O===-1?j({localized:(0,p.joinPath)(V,"package.nls.json"),original:null}):(ce=ce.substring(0,O),X(ce))})};if(z.devMode||z.pseudo||!z.language)return j({localized:(0,p.joinPath)(V,"package.nls.json"),original:null});X(z.language)})}formatMessage(V,z){return`[${V.path}]: ${z}`}};k=pe([J(1,g.IExtensionsProfileScannerService),J(2,A.IUriIdentityService),J(3,r.IFileService),J(4,o.ILogService)],k);let U=class extends k{constructor(V,z,j,K,X,ce){super(z,j,K,X,ce),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new h.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const z=await this.readExtensionCache();if(this.input=V,z&&z.input&&W.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(K=>(K.location=u.URI.revive(K.location),K));const j=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:j}),j}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),z=JSON.parse(V.value.toString());return{result:z.result,input:(0,a.revive)(z.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(V)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const z=V.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(j,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}};U=pe([J(2,g.IExtensionsProfileScannerService),J(3,A.IUriIdentityService),J(4,r.IFileService),J(5,o.ILogService)],U);function $(q,V){const z=(0,d.getExtensionId)(q.manifest.publisher,q.manifest.name);return{id:z,identifier:new l.ExtensionIdentifier(z),isBuiltin:q.type===0,isUserBuiltin:q.type===1&&q.isBuiltin,isUnderDevelopment:V,extensionLocation:q.location,uuid:q.identifier.uuid,targetPlatform:q.targetPlatform,...q.manifest}}e.toExtensionDescription=$;class Y extends N{constructor(V,z,j,K,X,ce,B,H,O,M,x){super(V,z,(0,p.joinPath)(j,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(K,l.MANIFEST_CACHE_FOLDER),X,ce,B,H,O,M,x),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const G=await this.fileService.readFile(u.URI.file(S.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=Y}),define(ne[254],re([0,1,49,6,37,3,2,22,10,28,8,20]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends T.Disposable{constructor(f,v){super(),this.userDataProfilesService=f,this.logService=v,this.processesLimiter=new t.Limiter(5)}async postUninstall(f){const v=this.parseScript(f,"uninstall");return v&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),E.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,v){const y=`vscode:${v}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const u=f.manifest.scripts[y].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(f,v,y,u,m){return new Promise((c,d)=>{const l=this.start(f,v,y,m);let n;const r=i=>{n&&(clearTimeout(n),n=null),i?d(i):c(void 0)};l.on("error",i=>{r((0,R.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,o)=>{r(i?`post-${v} process exited with code ${i}`:void 0)}),u&&(n=setTimeout(()=>{n=null,l.kill(),d("timed out")},5e3))})}start(f,v,y,u){const m={silent:!0,execArgv:void 0},c=(0,D.fork)(f,[`--type=extension-post-${v}`,...y],m);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(c.stdout,"data"),l=L.Event.fromNodeEventEmitter(c.stderr,"data");d(i=>this.logService.info(u.identifier.id,u.manifest.version,`post-${v}`,i)),l(i=>this.logService.error(u.identifier.id,u.manifest.version,`post-${v}`,i));const n=L.Event.any(L.Event.map(d,i=>({data:`%c${i}`,format:[""]})),L.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(n,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),c}getExtensionStoragePath(f){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};S=pe([J(0,b.IUserDataProfilesService),J(1,C.ILogService)],S),e.ExtensionsLifecycle=S}),define(ne[255],re([0,1,7,13,51,77,14,5,8,25,20]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends L.NativeExtensionsScannerService{constructor(p,f,v,y,u,m,c){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,D.URI.file(u.userDataPath),p,f,v,y,u,m,c)}};b=pe([J(0,C.IUserDataProfilesService),J(1,R.IExtensionsProfileScannerService),J(2,T.IFileService),J(3,I.ILogService),J(4,t.INativeEnvironmentService),J(5,E.IProductService),J(6,P.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ne[21],re([0,1,6,3,2,197,15,69,5,20]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function p(m){const c=m.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=p;class f extends R.Disposable{constructor(c={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,d){if(d===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:d,target:this.getKeyTargets(c)[d]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,d,l){return this.getStorage(d)?.get(c,l)}getBoolean(c,d,l){return this.getStorage(d)?.getBoolean(c,l)}getNumber(c,d,l){return this.getStorage(d)?.getNumber(c,l)}store(c,d,l,n){if((0,T.isUndefinedOrNull)(d)){this.remove(c,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,l,n),this.getStorage(l)?.set(c,d)})}remove(c,d){this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,void 0),this.getStorage(d)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,d){const l=[],n=this.getKeyTargets(c);for(const r of Object.keys(n))n[r]===d&&l.push(r);return l}updateKeyTarget(c,d,l){const n=this.getKeyTargets(d);typeof l=="number"?n[c]!==l&&(n[c]=l,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[c]=="number"&&(delete n[c],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const d=this.getStorage(c);return d?p(d):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=C.NONE){this._onWillSaveState.fire({reason:c});const d=this.getStorage(-1),l=this.getStorage(0),n=this.getStorage(1);switch(c){case C.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return u(c,d,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,d){return this.emitWillSaveState(C.NONE),(0,E.isUserDataProfile)(c)?this.switchToProfile(c,d):this.switchToWorkspace(c,d)}canSwitchProfile(c,d){return!(c.id===d.id||v(d)&&v(c))}switchData(c,d,l,n){this.withPausedEmitters(()=>{if(n)for(const[r,i]of c)d.set(r,i);else{const r=new Set;for(const[i,o]of c)r.add(i),d.get(i)!==o&&this.emitDidChangeValue(l,i);for(const[i]of d.items)r.has(i)||this.emitDidChangeValue(l,i)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function v(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class y extends f{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(c){return!1}}e.InMemoryStorageService=y;async function u(m,c,d,l,n,r){const i=_=>{try{return JSON.parse(_)}catch{return _}},o=new Map,s=new Map;m.forEach((_,N)=>{o.set(N,_),s.set(N,i(_))});const h=new Map,a=new Map;c.forEach((_,N)=>{h.set(N,_),a.set(N,i(_))});const g=new Map,w=new Map;d.forEach((_,N)=>{g.set(N,_),w.set(N,i(_))}),console.group(l!==n?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const A=[];if(o.forEach((_,N)=>{A.push({key:N,value:_})}),console.table(A),console.groupEnd(),console.log(s),l!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const _=[];h.forEach((N,W)=>{_.push({key:W,value:N})}),console.table(_),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const F=[];g.forEach((_,N)=>{F.push({key:N,value:_})}),console.table(F),console.groupEnd(),console.log(w)}e.logStorage=u}),define(ne[117],re([0,1,3,2,15,29,33,21]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends t.Disposable{constructor(b,S){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(b)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(S.onDidInstallExtensions(p=>p.forEach(({local:f,operation:v})=>{f&&v===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(b,S){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:S}),!0):!1}async disableExtension(b,S){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const S=this.getDisabledExtensions();return S.every(p=>!(0,T.areSameExtensions)(p,b))?(S.push(b),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(b){const S=this.getDisabledExtensions();for(let p=0;p<S.length;p++){const f=S[p];if((0,T.areSameExtensions)(f,b))return S.splice(p,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(b){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,S){this.storageManger.set(b,S,0)}};I=pe([J(0,P.IStorageService),J(1,L.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class E extends t.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(S=>this.onDidStorageChange(S)))}get(b,S){let p;return S===0?((0,R.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,S)),p=this.storage[b]):p=this._get(b,S),JSON.parse(p)}set(b,S,p){const f=JSON.stringify(S.map(({id:y,uuid:u})=>({id:y,uuid:u})));this._get(b,p)!==f&&(p===0&&(S.length?this.storage[b]=f:delete this.storage[b]),this._set(b,S.length?f:void 0,p))}onDidStorageChange(b){if(b.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const p=this.get(b.key,b.scope);delete this.storage[b.key];const f=this.get(b.key,b.scope),v=p.filter(u=>!f.some(m=>(0,T.areSameExtensions)(u,m))),y=f.filter(u=>!p.some(m=>(0,T.areSameExtensions)(m,u)));(v.length||y.length)&&this._onDidChange.fire([...v,...y])}}_get(b,S){return this.storageService.get(b,S,"[]")}_set(b,S,p){S?this.storageService.store(b,S,p,1):this.storageService.remove(b,p)}}e.StorageManager=E}),define(ne[256],re([0,1,18,24,9,4,36,15,7,16,13,29,33,70,14,8,25,45,226,21,23]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=L.isWeb?"web":(0,b.getTargetPlatform)(L.platform,T.arch);var n;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...O){return String(O.reduce((M,x)=>M|x,0))}var i;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class g{constructor(M=a){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,x=this.state.pageSize){return new g({...this.state,pageNumber:M,pageSize:x})}withFilter(M,...x){const G=[...this.state.criteria,...x.length?x.map(ee=>({filterType:M,value:ee})):[{filterType:M}]];return new g({...this.state,criteria:G})}withSortBy(M){return new g({...this.state,sortBy:M})}withSortOrder(M){return new g({...this.state,sortOrder:M})}withFlags(...M){return new g({...this.state,flags:M.reduce((x,G)=>x|G,0)})}withAssetTypes(...M){return new g({...this.state,assetTypes:M})}withSource(M){return new g({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:x,pageSize:G,sortBy:ee,sortOrder:oe,flags:Z,assetTypes:ie}=this.state;return{filters:[{criteria:M,pageNumber:x,pageSize:G,sortBy:ee,sortOrder:oe}],assetTypes:ie,flags:Z}}get searchText(){const M=this.state.criteria.filter(x=>x.filterType===i.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function w(O,M){const x=(O||[]).filter(G=>G.statisticName===M)[0];return x?x.value:0}function A(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(G=>G.assetType.indexOf(M)===0).reduce((G,ee)=>{const oe=N(O,ee.assetType);return oe&&G.push([ee.assetType.substring(M.length),oe]),G},[])}function F(O){if(O.properties){const M=O.properties.filter(ee=>ee.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=M.filter(ee=>x.test(ee.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return N(O,o.Repository)}function _(O){return{uri:`${O.fallbackAssetUri}/${o.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${o.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function N(O,M){return O.files.filter(G=>G.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function W(O,M){const x=O.properties?O.properties.filter(ee=>ee.key===M):[],G=x.length>0&&x[0].value;return G?G.split(",").map(ee=>(0,S.adoptToGalleryExtensionId)(ee)):[]}function k(O){const M=O.properties?O.properties.filter(x=>x.key===s.Engine):[];return M.length>0&&M[0].value||""}function U(O){const M=O.properties?O.properties.filter(x=>x.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function $(O){const M=O.properties?O.properties.filter(G=>G.key===s.LocalizedLanguages):[],x=M.length>0&&M[0].value||"";return x?x.split(","):[]}function Y(O){return O.properties?.find(M=>M.key===s.SponsorLink)?.value}function q(O){return O.indexOf("preview")!==-1}function V(O){return O.targetPlatform?(0,b.toTargetPlatform)(O.targetPlatform):"undefined"}function z(O){const M=(0,D.distinct)(O.versions.map(V)),x=!!O.tags?.includes(b.WEB_EXTENSION_TAG),G=M.indexOf("web");return x?G===-1&&M.push("web"):G!==-1&&M.splice(G,1),M}function j(O,M){const x=(0,b.getFallbackTargetPlarforms)(M);for(let G=0;G<O.length;G++){const ee=O[G];if(ee.version===O[G-1]?.version){let oe=G;const Z=V(ee);if(Z===M)for(;oe>0&&O[oe-1].version===ee.version;)oe--;else if(x.includes(Z))for(;oe>0&&O[oe-1].version===ee.version&&V(O[oe-1])!==M;)oe--;oe!==G&&(O.splice(G,1),O.splice(oe,0,ee))}}return O}e.sortExtensionVersions=j;function K(O,M,x){O.telemetryData={index:M,querySource:x}}function X(O,M,x){const G=O.versions[0],ee={manifest:N(M,o.Manifest),readme:N(M,o.Details),changelog:N(M,o.Changelog),license:N(M,o.License),repository:F(M),download:_(M),icon:N(M,o.Icon),signature:N(M,o.Signature),coreTranslations:A(M)};return{identifier:{id:(0,S.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:Y(G),description:O.shortDescription||"",installCount:w(O.statistics,"install"),rating:w(O.statistics,"averagerating"),ratingCount:w(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:x,assets:ee,properties:{dependencies:W(M,s.Dependency),extensionPack:W(M,s.ExtensionPack),engine:k(M),localizedLanguages:$(M),targetPlatform:V(M),isPreReleaseVersion:U(M)},hasPreReleaseVersion:U(G),hasReleaseVersion:!0,preview:q(O.flags),isSigned:!!ee.signature}}let ce=class{constructor(M,x,G,ee,oe,Z,ie,se){this.requestService=x,this.logService=G,this.environmentService=ee,this.telemetryService=oe,this.fileService=Z,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue?.serviceUrl,this.extensionsGallerySearchUrl=ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,x,G){const ee=t.CancellationToken.isCancellationToken(x)?{}:x,oe=t.CancellationToken.isCancellationToken(x)?x:G,Z=[],ie=[],se=[],ue=[];let de=!0;for(const Ee of M){Ee.uuid?ie.push(Ee.uuid):Z.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!Z.length)return[];let ve=new g().withPage(1,M.length);ie.length&&(ve=ve.withFilter(i.ExtensionId,...ie)),Z.length&&(ve=ve.withFilter(i.ExtensionName,...Z)),(ee.queryAllVersions||de)&&(ve=ve.withFlags(ve.flags,n.IncludeVersions)),ee.source&&(ve=ve.withSource(ee.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:ee.targetPlatform??l,includePreRelease:se,versions:ue,compatible:!!ee.compatible},oe);return ee.source&&we.forEach((Ee,Pe)=>K(Ee,Pe,ee.source)),we}async getCompatibleExtension(M,x,G){if((0,b.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(M,x,G))return M;const ee=new g().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(ee,{targetPlatform:G,compatible:!0,includePreRelease:x},t.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,x,G){if(!(0,b.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,G)||!x&&M.properties.isPreReleaseVersion)return!1;let ee=M.properties.engine;if(!ee){const oe=await this.getManifest(M,t.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ee=oe.engines.vscode}return(0,p.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(M,x,G,ee,oe){if(!(0,b.isTargetPlatformCompatible)(V(M),ee,oe)||x!=="any"&&U(M)!==(x==="prerelease"))return!1;if(G)try{const Z=await this.getEngine(M);if(!(0,p.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(Z)),!1}return!0}async query(M,x){let G=M.text||"";const ee=M.pageSize??50;let oe=new g().withPage(1,ee);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(i.Category,we||ve),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(i.Tag,we||ve),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(i.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),oe=oe.withFilter(i.SearchText,G)),oe=oe.withSortBy(0)):M.ids?oe=oe.withFilter(i.ExtensionId,...M.ids):M.names?oe=oe.withFilter(i.ExtensionName,...M.names):oe=oe.withSortBy(4),typeof M.sortBy=="number"&&(oe=oe.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(oe=oe.withSortOrder(M.sortOrder)),M.source&&(oe=oe.withSource(M.source));const Z=async(de,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(de,{targetPlatform:l,compatible:!1,includePreRelease:!!M.includePreRelease},ve);return we.forEach((Pe,Oe)=>K(Pe,(de.pageNumber-1)*de.pageSize+Oe,M.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await Z(oe,x),ue=async(de,ve)=>{if(ve.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await Z(oe.withPage(de+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(M,x,G){const ee=M.flags;!!(M.flags&n.IncludeLatestVersionOnly)&&!!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(M.flags&n.IncludeLatestVersionOnly)&&!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(M=M.withFlags(M.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),M=M.withFlags(M.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:oe,total:Z}=await this.queryRawGalleryExtensions(M,G);if(!(M.flags&n.IncludeLatestVersionOnly)){const de=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,x);we&&de.push(we)}return{extensions:de,total:Z}}const se=[],ue=new Map;for(let de=0;de<oe.length;de++){const ve=oe[de],we={id:(0,S.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Oe=>(0,S.areSameExtensions)(Oe,we))?.includePreRelease;if(x.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(z(ve),x.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,x);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==x.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,de):se.push([de,Pe])}if(ue.size){const de=new Date().getTime(),ve=new g().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ue.size).withFilter(i.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,x,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);se.push([Pe,Ee])}}return{extensions:se.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:Z}}async toGalleryExtensionWithCriteria(M,x){const G={id:(0,S.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ee=x.versions?.find(se=>(0,S.areSameExtensions)(se,G))?.version,oe=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(se=>(0,S.areSameExtensions)(se,G))?.includePreRelease,Z=z(M),ie=j(M.versions,x.targetPlatform);if(x.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(Z,x.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(ee&&ue.version!==ee)){if(await this.isValidVersion(ue,oe?"any":"release",x.compatible,Z,x.targetPlatform))return X(M,ue,Z);if(ee&&ue.version===ee)return null}}return ee||x.compatible?null:X(M,M.versions[0],Z)}async queryRawGalleryExtensions(M,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const G=await this.commonHeadersPromise,ee=JSON.stringify(M.raw),oe={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(ve=>ve.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:oe},x),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,u.asJson)(ie);if(de){const ve=de.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(de){throw se=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!ie&&(0,u.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,R.isCancellationError)(se)?"canceled":(0,R.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(M,x,G,ee){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${M}.${x}/version/${G}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${x}/${G}/stats?statType=${ee}`),Z=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:oe,headers:se},t.CancellationToken.None)}catch{}}async download(M,x,G){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const ee=(0,S.getGalleryExtensionTelemetryData)(M),oe=new Date().getTime(),Z=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=G===2?"install":G===3?"update":"",se=ie?{uri:`${M.assets.download.uri}${I.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${I.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(x,ue.stream),Z(new Date().getTime()-oe)}async downloadSignatureArchive(M,x){if(!M.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const G=await this.getAsset(M.assets.signature);await this.fileService.writeFile(x,G.stream)}async getReadme(M,x){if(M.assets.readme){const G=await this.getAsset(M.assets.readme,{},x);return await(0,u.asTextOrError)(G)||""}return""}async getManifest(M,x){if(M.assets.manifest){const G=await this.getAsset(M.assets.manifest,{},x),ee=await(0,u.asTextOrError)(G);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(M,x){const G=N(M,o.Manifest);if(!G)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},oe=await this.getAsset(G,{headers:ee});return await(0,u.asJson)(oe)}async getCoreTranslation(M,x){const G=M.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(G){const ee=await this.getAsset(G[1]),oe=await(0,u.asTextOrError)(ee);return oe?JSON.parse(oe):null}return null}async getChangelog(M,x){if(M.assets.changelog){const G=await this.getAsset(M.assets.changelog,{},x);return await(0,u.asTextOrError)(G)||""}return""}async getAllCompatibleVersions(M,x,G){let ee=new g().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ee=ee.withFilter(i.ExtensionId,M.identifier.uuid):ee=ee.withFilter(i.ExtensionName,M.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(ee,t.CancellationToken.None);if(!oe.length)return[];const Z=z(oe[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(Z,G))return[];const ie=[];await Promise.all(oe[0].versions.map(async de=>{try{await this.isValidVersion(de,x?"any":"release",!0,Z,G)&&ie.push(de)}catch{}}));const se=[],ue=new Set;for(const de of j(ie,G))ue.has(de.version)||(ue.add(de.version),se.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:U(de)}));return se}async getAsset(M,x={},G=t.CancellationToken.None){const ee=await this.commonHeadersPromise,oe={type:"GET"},Z={...ee,...x.headers||{}};x={...x,...oe,headers:Z};const ie=M.uri,se=M.fallbackUri,ue={...x,url:ie};try{const de=await this.requestService.request(ue,G);if(de.res.statusCode===200)return de;const ve=await(0,u.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ve}`)}catch(de){if((0,R.isCancellationError)(de))throw de;const ve=(0,R.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...x,url:se};return this.requestService.request(we,G)}}async getEngine(M){let x=k(M);if(!x){const G=await this.getManifestFromRawExtensionVersion(M,t.CancellationToken.None);if(!G)throw new Error("Manifest was not found");x=G.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,u.asJson)(M),G=[],ee={};if(x){for(const oe of x.malicious)G.push({id:oe});if(x.migrateToPreRelease)for(const[oe,Z]of Object.entries(x.migrateToPreRelease))(!Z.engine||(0,p.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(ee[oe.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[oe,Z]of Object.entries(x.deprecated))Z&&(ee[oe.toLowerCase()]=(0,P.isBoolean)(Z)?{}:Z)}return{malicious:G,deprecated:ee}}};ce=pe([J(1,u.IRequestService),J(2,v.ILogService),J(3,C.IEnvironmentService),J(4,d.ITelemetryService),J(5,f.IFileService),J(6,y.IProductService),J(7,E.IConfigurationService)],ce);let B=class extends ce{constructor(M,x,G,ee,oe,Z,ie,se){super(M,x,G,ee,oe,Z,ie,se)}};B=pe([J(0,c.IStorageService),J(1,u.IRequestService),J(2,v.ILogService),J(3,C.IEnvironmentService),J(4,d.ITelemetryService),J(5,f.IFileService),J(6,y.IProductService),J(7,E.IConfigurationService)],B),e.ExtensionGalleryService=B;let H=class extends ce{constructor(M,x,G,ee,oe,Z,ie){super(void 0,M,x,G,ee,oe,Z,ie)}};H=pe([J(0,u.IRequestService),J(1,v.ILogService),J(2,C.IEnvironmentService),J(3,d.ITelemetryService),J(4,f.IFileService),J(5,y.IProductService),J(6,E.IConfigurationService)],H),e.ExtensionGalleryServiceWithNoStorageService=H}),define(ne[78],re([0,1,5,3,2,21,33,25,18,8,15]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let S=class Xe extends R.Disposable{static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const v=b.exec(f);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(f,v){const y=await f.getInstalled(),u=[];for(const[m,c]of Xe.readAllExtensionsWithKeysForSync(v)){const d=y.find(l=>(0,T.areSameExtensions)(l.identifier,{id:m}))?.manifest.version;for(const l of c)d!==l&&u.push(Xe.toKey({id:m,version:l}))}for(const m of u)v.remove(m,0)}static readAllExtensionsWithKeysForSync(f){const v=new Map,y=f.keys(0,1);for(const u of y){const m=Xe.fromKey(u);if(m){let c=v.get(m.id.toLowerCase());c||v.set(m.id.toLowerCase(),c=[]),c.push(m.version)}}return v}constructor(f,v,y){super(),this.storageService=f,this.productService=v,this.logService=y,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Xe.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=Xe.fromKey(f.key);if(v){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let y=this.extensionsWithKeysForSync.get(v.id.toLowerCase());y||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),y=[]),y.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,C.isString)(f))return f;const v=f.manifest?f.manifest.publisher:f.publisher,y=f.manifest?f.manifest.name:f.name;return(0,T.getExtensionId)(v,y)}getExtensionState(f,v){const y=this.getExtensionId(f),u=this.storageService.get(y,v?0:1);if(u)try{return JSON.parse(u)}catch(m){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${v}): ${m}`)}}setExtensionState(f,v,y){const u=this.getExtensionId(f);v===void 0?this.storageService.remove(u,y?0:1):this.storageService.store(u,JSON.stringify(v),y?0:1,1)}setKeysForSync(f,v){this.storageService.store(Xe.toKey(f),JSON.stringify(v),0,1)}getKeysForSync(f){const v=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],y=this.storageService.get(Xe.toKey(f),0),u=y?JSON.parse(y):void 0;return u&&v?(0,I.distinct)([...u,...v]):u||v}addToMigrationList(f,v){if(f!==v){const y=this.migrationList.filter(u=>!u.includes(f)&&!u.includes(v));y.push([f,v]),this.migrationList=y}}getSourceExtensionToMigrate(f){const v=this.migrationList.find(([,y])=>f===y);return v?v[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(f);if(Array.isArray(v))return v}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};S=pe([J(0,L.IStorageService),J(1,P.IProductService),J(2,E.ILogService)],S),e.ExtensionStorageService=S}),define(ne[257],re([0,1,18,6,3,10,4,36,7,152,13,29,33,216,98,14,8,60,25,45,21,23]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends p.ExtensionTipsService{constructor(s,h,a,g,w,A,F,_,N,W){super(F,_,N,W),this.environmentService=s,this.telemetryService=h,this.extensionManagementService=a,this.storageService=g,this.nativeHostService=w,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&Object.entries(_.exeBasedExtensionTips).forEach(([k,U])=>{const $=[],Y=[],q=[];Object.entries(U.recommendations).forEach(([V,z])=>{z.important?U.important?$.push({extensionId:V,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):Y.push({extensionId:V,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):q.push({extensionId:V,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),$.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:$}),Y.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:Y}),q.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:q})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),h=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...h]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),h=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(h,a)}groupImportantTipsByExe(s,h){const a=new Map;s.forEach(_=>a.set(_.extensionId.toLowerCase(),_));const{installed:g,uninstalled:w}=this.groupByInstalled([...a.keys()],h);for(const _ of g){const N=a.get(_);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:N.exeName})}for(const _ of w){const N=a.get(_);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:N.exeName})}const A=this.getPromptedExecutableTips(),F=new Map;for(const _ of w){const N=a.get(_);if(N&&(!A[N.exeName]||!A[N.exeName].includes(N.extensionId))){let W=F.get(N.exeName);W||(W=[],F.set(N.exeName,W)),W.push(N)}}return F}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,h]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(h).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(h[0].exeName,h);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,t.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),h=Date.now()-s,a=7*24*60*60*1e3;if(h<a){const A=this._register((0,t.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},a-h));return}const[g,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(w[0].exeName,w);const F=this._register((0,t.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const F=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const F=this._register((0,t.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const h=await this.extensionManagementService.getInstalled(1),a=s.filter(w=>!w.whenNotInstalled||w.whenNotInstalled.every(A=>h.every(F=>!(0,S.areSameExtensions)(F.identifier,{id:A})))).map(({extensionId:w})=>w.toLowerCase()),g=(0,E.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,g,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(r,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(r,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(s,h){const a=this.getPromptedExecutableTips();a[s]=h.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(n,JSON.stringify(a),-1,0)}groupByInstalled(s,h){const a=[],g=[],w=h.reduce((A,F)=>(A.add(F.identifier.id.toLowerCase()),A),new Set);return s.forEach(A=>{w.has(A.toLowerCase())?a.push(A):g.push(A)}),{installed:a,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const h=[],a=new Map;for(const g of s.keys()){const w=s.get(g);if(!w||!(0,D.isNonEmptyArray)(w.recommendations))continue;const A=[];T.isWindows?w.windowsPath&&A.push(w.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(A.push((0,L.join)("/usr/local/bin",g)),A.push((0,L.join)("/usr/bin",g)),A.push((0,L.join)(this.environmentService.userHome.fsPath,g)));for(const F of A){let _=a.get(F);if(_===void 0&&(_=await this.fileService.exists(I.URI.file(F)),a.set(F,_)),_)for(const{extensionId:N,extensionName:W,isExtensionPack:k,whenNotInstalled:U}of w.recommendations)h.push({extensionId:N,extensionName:W,isExtensionPack:k,exeName:g,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath,whenNotInstalled:U})}}return h}};i=pe([J(0,C.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,b.IExtensionManagementService),J(3,d.IStorageService),J(4,u.INativeHostService),J(5,f.IExtensionRecommendationNotificationService),J(6,v.IFileService),J(7,m.IProductService),J(8,c.IRequestService),J(9,y.ILogService)],i),e.ExtensionTipsService=i}),define(ne[258],re([0,1,6,2,19,69,21,74,20]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends T.AbstractStorageService{constructor(b,S,p,f){super(),this.initialWorkspace=b,this.initialProfiles=S,this.mainProcessService=p,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new t.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new t.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const b=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),S=this._register(new L.Storage(b));return this._register(S.onDidChangeStorage(p=>this.emitDidChangeValue(-1,p))),S}createProfileStorage(b){this.profileStorageDisposables.clear(),this.profileStorageProfile=b;let S;if((0,T.isProfileUsingDefaultStorage)(b))S=this.applicationStorage;else{const p=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));S=this.profileStorageDisposables.add(new L.Storage(p))}return this.profileStorageDisposables.add(S.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),S}createWorkspaceStorage(b){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=b?.id;let S;if(b){const p=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));S=this.workspaceStorageDisposables.add(new L.Storage(p)),this.workspaceStorageDisposables.add(S.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return S}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(b,S){if(!this.canSwitchProfile(this.profileStorageProfile,b))return;const p=this.profileStorage,f=p.items;p!==this.applicationStorage&&await p.close(),this.profileStorage=this.createProfileStorage(b),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,S)}async switchToWorkspace(b,S){const p=this.workspaceStorage,f=p?.items??new Map;await p?.close(),this.workspaceStorage=this.createWorkspaceStorage(b),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,S)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.profileStorageProfile.id===b.id:this.workspaceStorageId===b.id}}e.NativeStorageService=E}),define(ne[259],re([0,1,3,2,19,13,59,20]),function(Q,e,D,t,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends t.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(C,b,S){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=b.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(S.userRoamingDataHome,"profiles"),this._profiles=C.map(p=>(0,P.reviveProfile)(p,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(p=>{const f=p.added.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),v=p.removed.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),y=p.updated.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme));this._profiles=p.all.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:v,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(C){this.enabled=C}isEnabled(){return this.enabled}async createNamedProfile(C,b,S){const p=await this.channel.call("createNamedProfile",[C,b,S]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(C,b,S,p){const f=await this.channel.call("createProfile",[C,b,S,p]);return(0,P.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(C){const b=await this.channel.call("createTransientProfile",[C]);return(0,P.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(C,b){await this.channel.call("setProfileForWorkspace",[C,b])}removeProfile(C){return this.channel.call("removeProfile",[C])}async updateProfile(C,b){const S=await this.channel.call("updateProfile",[C,b]);return(0,P.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};I=pe([J(1,T.IMainProcessService),J(2,L.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(ne[41],re([0,1,18,6,17,24,3,35,2,27,15,7,167,16,13,14,8,50,21,23,31,26,20]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=r;let i=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(g,w,A,F,_,N,W,k,U,$,Y,q){super(),this.syncResource=g,this.collection=w,this.fileService=A,this.environmentService=F,this.userDataSyncStoreService=N,this.userDataSyncBackupStoreService=W,this.userDataSyncEnablementService=k,this.telemetryService=U,this.logService=$,this.configurationService=Y,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=`${(0,E.uppercaseFirstLetter)(this.resource)}${g.profile.isDefault?"":` (${g.profile.name})`}`,this.extUri=q.extUri,this.syncFolder=this.extUri.joinPath(F.userDataSyncHome,...(0,l.getPathSegments)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,F,this.extUri),this.currentMachineIdPromise=(0,u.getServiceMachineId)(F,A,_)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const g=await this.syncPreviewPromise;this.syncPreviewPromise=null;const w=await this.performSync(g.remoteUserData,g.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(w)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.hasRemoteChanged(g):!0)&&this._onDidChangeLocal.fire()}}setStatus(g){this._status!==g&&(this._status=g,this._onDidChangStatus.fire(g))}async sync(g,w={}){await this._sync(g,!0,this.getUserDataSyncConfiguration(),w)}async preview(g,w,A={}){return this._sync(g,!1,w,A)}async apply(g,w={}){try{this.syncHeaders={...w};const A=await this.doApply(g);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(g,w,A,F){try{if(this.syncHeaders={...F},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const N=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(g,N);return _=await this.performSync(W,N,w,A),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(g){const w=await this.resolveContent(g);if(!w)return!1;const A=this.parseSyncData(w);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const F=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,F),N=await this.isRemoteDataFromCurrentMachine(_),W=await this.generateSyncPreview({ref:_.ref,syncData:A},F,N,this.getUserDataSyncConfiguration(),L.CancellationToken.None),k=[];for(const U of W){const $=await this.getAcceptResult(U,U.remoteResource,void 0,L.CancellationToken.None),{remoteChange:Y}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,L.CancellationToken.None);k.push([U,{...$,remoteChange:Y!==0?Y:2}])}await this.applyResult(_,F,k,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(g){const w=await this.currentMachineIdPromise;return!!g.syncData?.machineId&&g.syncData.machineId===w}async getLatestRemoteUserData(g,w){if(w){const A=g?g[this.resource]:void 0;if(w.ref===A||A===void 0&&w.syncData===null)return w}return this.getRemoteUserData(w)}async performSync(g,w,A,F){if(g.syncData&&g.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,S.localize)(0,null,this.resource,this.version,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(g,w,A,F)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(g,w,A,F);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),w=await this.getLastSyncUserData(),this.performSync(g,w,A,F)}throw _}}async doSync(g,w,A,F){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(N=>this.doGenerateSyncResourcePreview(g,w,A,F,N)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:N})=>N==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(g){return await this.updateSyncResourcePreview(g,async w=>{const A=await this.getMergeResult(w,L.CancellationToken.None);await this.fileService.writeFile(w.previewResource,R.VSBuffer.fromString(A?.content||""));const F=A&&!A.hasConflicts?await this.getAcceptResult(w,w.previewResource,void 0,L.CancellationToken.None):void 0;return w.acceptResult=F,w.mergeState=A.hasConflicts?"conflict":F?"accepted":"preview",w.localChange=F?F.localChange:A.localChange,w.remoteChange=F?F.remoteChange:A.remoteChange,w}),this.syncPreviewPromise}async accept(g,w){return await this.updateSyncResourcePreview(g,async A=>{const F=await this.getAcceptResult(A,g,w,L.CancellationToken.None);return A.acceptResult=F,A.mergeState="accepted",A.localChange=F.localChange,A.remoteChange=F.remoteChange,A}),this.syncPreviewPromise}async discard(g){return await this.updateSyncResourcePreview(g,async w=>{const A=await this.getMergeResult(w,L.CancellationToken.None);return await this.fileService.writeFile(w.previewResource,R.VSBuffer.fromString(A.content||"")),w.acceptResult=void 0,w.mergeState="preview",w.localChange=A.localChange,w.remoteChange=A.remoteChange,w}),this.syncPreviewPromise}async updateSyncResourcePreview(g,w){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const F=A.resourcePreviews.findIndex(({localResource:_,remoteResource:N,previewResource:W})=>this.extUri.isEqual(_,g)||this.extUri.isEqual(N,g)||this.extUri.isEqual(W,g));F!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const N=[...A.resourcePreviews];return N[F]=await w(N[F]),{...A,resourcePreviews:N}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(g){if(!this.syncPreviewPromise)return"idle";const w=await this.syncPreviewPromise;return w.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":w.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(w.remoteUserData,w.lastSyncUserData,w.resourcePreviews.map(A=>[A,A.acceptResult]),g),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(g){const w=g.filter(({mergeState:A})=>A==="conflict");(0,D.equals)(this._conflicts,w,(A,F)=>this.extUri.isEqual(A.previewResource,F.previewResource))||(this._conflicts=w,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:w,ref:A})=>({created:w,uri:this.toRemoteBackupResource(A)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:w,ref:A})=>({created:w,uri:this.toLocalBackupResource(A)}))}toRemoteBackupResource(g){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${g}`})}toLocalBackupResource(g){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${g}`})}async getMachineId({uri:g}){const w=this.extUri.basename(g);if(this.extUri.isEqual(g,this.toRemoteBackupResource(w))){const{content:A}=await this.getUserData(w);if(A)return this.parseSyncData(A)?.machineId}}async resolveContent(g){const w=this.extUri.basename(g);if(this.extUri.isEqual(g,this.toRemoteBackupResource(w))){const{content:A}=await this.getUserData(w);return A}return this.extUri.isEqual(g,this.toLocalBackupResource(w))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,w):null}async resolvePreviewContent(g){const w=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(w)for(const A of w.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,g))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,g))return A.remoteContent;if(this.extUri.isEqual(A.localResource,g))return A.localContent;if(this.extUri.isEqual(A.baseResource,g))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(g,w,A,F,_){const N=await this.isRemoteDataFromCurrentMachine(g),W=await this.generateSyncPreview(g,w,N,F,_),k=[];for(const U of W){const $=U.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)k.push({...U,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=A?await this.getMergeResult(U,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(Y?.content||""));const q=Y&&!Y.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,_):void 0;k.push({...U,acceptResult:q,mergeState:Y?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:Y?Y.localChange:U.localChange,remoteChange:q?q.remoteChange:Y?Y.remoteChange:U.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:w,resourcePreviews:k,isLastSyncFromCurrentMachine:N}}async getLastSyncUserData(){try{const g=await this.fileService.readFile(this.lastSyncResource),w=JSON.parse(g.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=w.version&&A&&w.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${w.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const F=w;if(F.content===null)return{ref:w.ref,syncData:null};const _=JSON.parse(F.content);if(r(_))return{...w,syncData:_,content:void 0}}catch(g){g instanceof v.FileOperationError&&g.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(g)}return null}async updateLastSyncUserData(g,w={}){if(w.ref||w.content||w.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),F={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,version:A,...w};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(F)))}async getRemoteUserData(g){const{ref:w,content:A}=await this.getUserData(g);let F=null;return A!==null&&(F=this.parseSyncData(A)),{ref:w,syncData:F}}parseSyncData(g){try{const w=JSON.parse(g);if(r(w))return w}catch(w){this.logService.error(w)}throw new l.UserDataSyncError((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(g){if((0,C.isString)(g)){const w=await this.userDataSyncStoreService.resolveResourceContent(this.resource,g,this.collection);return{ref:g,content:w}}else{const w=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,w,this.collection,this.syncHeaders)}}async updateRemoteUserData(g,w){const A=await this.currentMachineIdPromise,F={version:this.version,machineId:A,content:g};try{return w=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(F),w,this.collection,this.syncHeaders),{ref:w,syncData:F}}catch(_){throw _ instanceof l.UserDataSyncError&&_.code==="TooLarge"&&(_=new l.UserDataSyncError(_.message,_.code,this.resource)),_}}async backupLocal(g){const w={version:this.version,content:g};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(w))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=pe([J(2,v.IFileService),J(3,f.IEnvironmentService),J(4,m.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,c.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,d.IUriIdentityService)],i),e.AbstractSynchroniser=i;let o=class extends i{constructor(g,w,A,F,_,N,W,k,U,$,Y,q,V){super(w,A,F,_,N,W,k,U,$,Y,q,V),this.file=g,this._register(this.fileService.watch(this.extUri.dirname(g))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(g,w,A){try{w?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(g),A?void 0:w):await this.fileService.createFile(this.file,R.VSBuffer.fromString(g),{overwrite:A})}catch(F){throw F instanceof v.FileOperationError&&F.fileOperationResult===1||F instanceof v.FileOperationError&&F.fileOperationResult===3?new l.UserDataSyncError(F.message,"LocalPreconditionFailed"):F}}onFileChanges(g){!g.contains(this.file)||this.triggerLocalChange()}};o=pe([J(3,v.IFileService),J(4,f.IEnvironmentService),J(5,m.IStorageService),J(6,l.IUserDataSyncStoreService),J(7,l.IUserDataSyncBackupStoreService),J(8,l.IUserDataSyncEnablementService),J(9,c.ITelemetryService),J(10,l.IUserDataSyncLogService),J(11,p.IConfigurationService),J(12,d.IUriIdentityService)],o),e.AbstractFileSynchroniser=o;let s=class extends o{constructor(g,w,A,F,_,N,W,k,U,$,Y,q,V,z){super(g,w,A,F,_,N,W,k,U,$,Y,V,z),this.userDataSyncUtilService=q,this._formattingOptions=void 0}hasErrors(g,w){const A=[],F=(0,P.parse)(g,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,C.isUndefined)(F)&&w!==Array.isArray(F)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=pe([J(3,v.IFileService),J(4,f.IEnvironmentService),J(5,m.IStorageService),J(6,l.IUserDataSyncStoreService),J(7,l.IUserDataSyncBackupStoreService),J(8,l.IUserDataSyncEnablementService),J(9,c.ITelemetryService),J(10,l.IUserDataSyncLogService),J(11,l.IUserDataSyncUtilService),J(12,p.IConfigurationService),J(13,d.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let h=class{constructor(g,w,A,F,_,N){this.resource=g,this.userDataProfilesService=w,this.environmentService=A,this.logService=F,this.fileService=_,this.extUri=N.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:g,content:w}){if(!w){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(w);if(!!A)try{await this.doInitialize({ref:g,syncData:A})}catch(F){this.logService.error(F)}}parseSyncData(g){try{const w=JSON.parse(g);if(r(w))return w}catch(w){this.logService.error(w)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(g,w={}){const A={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,...w};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(A)))}};h=pe([J(1,n.IUserDataProfilesService),J(2,f.IEnvironmentService),J(3,y.ILogService),J(4,v.IFileService),J(5,d.IUriIdentityService)],h),e.AbstractInitializer=h}),define(ne[260],re([0,1,18,17,3,35,4,15,168,16,13,14,21,23,31,20,41,244,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(n,r,i){try{const o=JSON.parse(n);if(!r)return(0,P.isUndefined)(o.all)?null:o.all;switch(T.OS){case 2:return(0,P.isUndefined)(o.mac)?null:o.mac;case 3:return(0,P.isUndefined)(o.linux)?null:o.linux;case 1:return(0,P.isUndefined)(o.windows)?null:o.windows}}catch(o){return i.error(o),null}}e.getKeybindingsContentFromSyncContent=c;let d=class extends y.AbstractJsonFileSynchroniser{constructor(r,i,o,s,h,a,g,w,A,F,_,N,W){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},i,w,A,F,o,s,g,N,h,_,a,W),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(a.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,i,o,s){const h=r.syncData?c(r.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;i=i===null&&o?r:i;const a=i?this.getKeybindingsContentFromLastSyncUserData(i):null,g=await this.getLocalFileContent(),w=await this.getFormattingOptions();let A=null,F=!1,_=!1,N=!1;if(h){let U=g?g.value.toString():"[]";if(U=U||"[]",this.hasErrors(U,!0))throw new m.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==h){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await(0,u.merge)(U,h,a,w,this.userDataSyncUtilService);$.hasChanges&&(A=$.mergeContent,N=$.hasConflicts,F=N||$.mergeContent!==U,_=N||$.mergeContent!==h)}}else g&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=g.value.toString(),_=!0);const W={content:N?a:A,localChange:F?g?2:1:0,remoteChange:_?2:0,hasConflicts:N},k=g?g.value.toString():null;return[{fileContent:g,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:k,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:h,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const i=this.getKeybindingsContentFromLastSyncUserData(r);if(i===null)return!0;const o=await this.getLocalFileContent(),s=o?o.value.toString():"",h=await this.getFormattingOptions(),a=await(0,u.merge)(s||"[]",i,i,h,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==i}async getMergeResult(r,i){return r.previewResult}async getAcceptResult(r,i,o,s){if(this.extUri.isEqual(i,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(r,i,o,s){const{fileContent:h}=o[0][0];let{content:a,localChange:g,remoteChange:w}=o[0][1];if(g===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new m.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),h&&await this.backupLocal(this.toSyncContent(h.value.toString())),await this.updateLocalFileContent(a||"[]",h,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),w!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(A,s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const i=(0,L.parse)(r.value.toString());if((0,D.isNonEmptyArray)(i))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:i}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let i=await super.resolveContent(r);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(r)),i){const o=this.parseSyncData(i);if(o)switch(this.extUri.basename(r)){case"keybindings.json":return c(o.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,i){let o={};try{o=JSON.parse(i||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete o.all:o.all=r,T.OS){case 2:o.mac=r;break;case 3:o.linux=r;break;case 1:o.windows=r;break}return JSON.stringify(o)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=pe([J(2,m.IUserDataSyncStoreService),J(3,m.IUserDataSyncBackupStoreService),J(4,m.IUserDataSyncLogService),J(5,E.IConfigurationService),J(6,m.IUserDataSyncEnablementService),J(7,b.IFileService),J(8,C.IEnvironmentService),J(9,S.IStorageService),J(10,m.IUserDataSyncUtilService),J(11,p.ITelemetryService),J(12,f.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let l=class extends y.AbstractInitializer{constructor(r,i,o,s,h){super("keybindings",i,o,s,r,h)}async doInitialize(r){const i=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!i){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,t.VSBuffer.fromString(i)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),i=(0,L.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(i)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return c(r,!0,this.logService)}catch(i){return this.logService.error(i),null}}};l=pe([J(0,b.IFileService),J(1,v.IUserDataProfilesService),J(2,C.IEnvironmentService),J(3,m.IUserDataSyncLogService),J(4,f.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[261],re([0,1,17,3,169,16,73,13,29,14,21,23,31,20,41,62,248,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const r=JSON.parse(n);return m(r)?r:{settings:n}}e.parseSettingsSyncContent=c;let d=class extends f.AbstractJsonFileSynchroniser{constructor(r,i,o,s,h,a,g,w,A,F,_,N,W,k){super(r.settingsResource,{syncResource:"settings",profile:r},i,o,s,h,a,g,_,N,w,A,F,k),this.extensionManagementService=W,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const i=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(r,i),s=this.getSettingsSyncContent(o),h=new T.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&h.parse(s.settings),h.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,i,o){const s=await this.getLocalFileContent(),h=await this.getFormattingOptions(),a=this.getSettingsSyncContent(r);i=i===null&&o?r:i;const g=i?this.getSettingsSyncContent(i):null,w=await this.getIgnoredSettings();let A=null,F=!1,_=!1,N=!1;if(a){let $=s?s.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Y=(0,y.merge)($,a.settings,g?g.settings:null,w,[],h);A=Y.localContent||Y.remoteContent,F=Y.localContent!==null,_=Y.remoteContent!==null,N=Y.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=s.value.toString().trim()||"{}",this.validateContent(A),_=!0);const W=s?s.value.toString():null,k=g?.settings??null,U={content:N?k:A,localChange:F?2:0,remoteChange:_?2:0,hasConflicts:N};return[{fileContent:s,baseResource:this.baseResource,baseContent:k,localResource:this.localResource,localContent:W,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const i=this.getSettingsSyncContent(r);if(i===null)return!0;const o=await this.getLocalFileContent(),s=o?o.value.toString().trim():"",h=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,y.merge)(s||"{}",i.settings,i.settings,h,[],a).remoteContent!==null}async getMergeResult(r,i){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,y.updateIgnoredSettings)(r.previewResult.content,"{}",s,o):null}}async getAcceptResult(r,i,o,s){const h=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:r.fileContent?(0,y.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,h):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:r.remoteContent!==null?(0,y.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,h):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o!==null?(0,y.updateIgnoredSettings)(o,r.fileContent?r.fileContent.value.toString():"{}",a,h):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(r,i,o,s){const{fileContent:h}=o[0][0];let{content:a,localChange:g,remoteChange:w}=o[0][1];if(g===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),h&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(h.value.toString()))),await this.updateLocalFileContent(a,h,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const A=await this.getFormattingOptions(),F=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(a);a=(0,y.updateIgnoredSettings)(a,F?F.settings:"{}",_,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),s?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}i?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const i=await this.getFormattingOptions(),o=(0,v.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,y.isEmpty)(o)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:i}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r))return this.resolvePreviewContent(r);let i=await super.resolveContent(r);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(r)),i){const o=this.parseSyncData(i);if(o){const s=this.parseSettingsSyncContent(o.content);if(s)switch(this.extUri.basename(r)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(r){let i=await super.resolvePreviewContent(r);if(i){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();i=(0,y.updateIgnoredSettings)(i,"{}",s,o)}return i}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return c(r)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:h})=>!!h)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(i,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new u.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};d=pe([J(2,E.IFileService),J(3,P.IEnvironmentService),J(4,C.IStorageService),J(5,u.IUserDataSyncStoreService),J(6,u.IUserDataSyncBackupStoreService),J(7,u.IUserDataSyncLogService),J(8,u.IUserDataSyncUtilService),J(9,L.IConfigurationService),J(10,u.IUserDataSyncEnablementService),J(11,b.ITelemetryService),J(12,I.IExtensionManagementService),J(13,S.IUriIdentityService)],d),e.SettingsSynchroniser=d;let l=class extends f.AbstractInitializer{constructor(r,i,o,s,h){super("settings",i,o,s,r,h)}async doInitialize(r){const i=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return c(r)}catch(i){this.logService.error(i)}return null}};l=pe([J(0,E.IFileService),J(1,p.IUserDataProfilesService),J(2,P.IEnvironmentService),J(3,u.IUserDataSyncLogService),J(4,S.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[262],re([0,1,17,3,32,16,13,14,21,23,31,20,41,245,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let v=class extends S.AbstractSynchroniser{constructor(m,c,d,l,n,r,i,o,s,h,a,g){super({syncResource:"snippets",profile:m},c,l,d,n,r,i,h,a,o,s,g),this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,w=>w.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,c,d){const l=await this.getSnippetsFileContents(),n=this.toSnippetsContents(l),r=m.syncData?this.parseSnippets(m.syncData):null;c=c===null&&d?m:c;const i=c&&c.syncData?this.parseSnippets(c.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const o=(0,p.merge)(n,r,i);return this.getResourcePreviews(o,l,r||{},i||{})}async hasRemoteChanged(m){const c=m.syncData?this.parseSnippets(m.syncData):null;if(c===null)return!0;const d=await this.getSnippetsFileContents(),l=this.toSnippetsContents(d),n=(0,p.merge)(l,c,c);return Object.keys(n.remote.added).length>0||Object.keys(n.remote.updated).length>0||n.remote.removed.length>0||n.conflicts.length>0}async getMergeResult(m,c){return m.previewResult}async getAcceptResult(m,c,d,l){if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder))return d===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:d,localChange:d===null?m.fileContent!==null?3:0:2,remoteChange:d===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(m,c,d,l){const n=d.map(([r,i])=>({...r,acceptResult:i}));n.every(({localChange:r,remoteChange:i})=>r===0&&i===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),n.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(n),await this.updateLocalSnippets(n,l)),n.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(n,m,l)),c?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of n)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,c,d,l){const n=new Map;for(const r of Object.keys(m.local.added)){const i={content:m.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(m.local.updated)){const i={content:m.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0},o=c[r]?c[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},o=c[r]?c[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(m.remote.added)){const i={content:m.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1},o=c[r]?c[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(m.remote.updated)){const i={content:m.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2},o=c[r]?c[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of m.conflicts){const i={content:l[r]??null,hasConflicts:!0,localChange:c[r]?2:1,remoteChange:d[r]?2:1},o=c[r]?c[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r]||null,localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(c))if(!n.has(r)){const i={content:c[r]?c[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},o=c[r]?c[r].value.toString():null;n.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r]||null,localContent:o,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...n.values()]}async getAssociatedResources({uri:m}){const c=await super.resolveContent(m);if(c){const d=this.parseSyncData(c);if(d){const l=this.parseSnippets(d),n=[];for(const r of Object.keys(l)){const i=this.extUri.joinPath(m,r),o=this.extUri.joinPath(this.snippetsFolder,r),s=await this.fileService.exists(o);n.push({resource:i,comparableResource:s?o:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return n}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let c=await super.resolveContent(m);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(m)),c){const d=this.parseSyncData(c);if(d)return this.parseSnippets(d)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const c={};for(const d of m)d.fileContent&&(c[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(c)))}async updateLocalSnippets(m,c){for(const{fileContent:d,acceptResult:l,localResource:n,remoteResource:r,localChange:i}of m)if(i!==0){const o=r?this.extUri.basename(r):this.extUri.basename(n),s=this.extUri.joinPath(this.snippetsFolder,o);i===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):i===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,D.VSBuffer.fromString(l.content),{overwrite:c}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,D.VSBuffer.fromString(l.content),c?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(m,c,d){const l=c.syncData?this.parseSnippets(c.syncData):{},n=(0,R.deepClone)(l);for(const{acceptResult:r,localResource:i,remoteResource:o,remoteChange:s}of m)if(s!==0){const h=i?this.extUri.basename(i):this.extUri.basename(o);s===3?delete n[h]:n[h]=r.content}return(0,p.areSame)(l,n)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),c=await this.updateRemoteUserData(JSON.stringify(n),d?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),c}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const c={};for(const d of Object.keys(m))c[d]=m[d].value.toString();return c}async getSnippetsFileContents(){const m={};let c;try{c=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof P.FileOperationError&&d.fileOperationResult===1)return m;throw d}for(const d of c.children||[]){const l=d.resource,n=this.extUri.extname(l);if(n===".json"||n===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,l),i=await this.fileService.readFile(l);m[r]=i}}return m}};v=pe([J(2,T.IEnvironmentService),J(3,P.IFileService),J(4,I.IStorageService),J(5,f.IUserDataSyncStoreService),J(6,f.IUserDataSyncBackupStoreService),J(7,f.IUserDataSyncLogService),J(8,L.IConfigurationService),J(9,f.IUserDataSyncEnablementService),J(10,E.ITelemetryService),J(11,C.IUriIdentityService)],v),e.SnippetsSynchroniser=v;let y=class extends S.AbstractInitializer{constructor(m,c,d,l,n){super("snippets",c,d,l,m,n)}async doInitialize(m){const c=m.syncData?JSON.parse(m.syncData.content):null;if(!c){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(c)){const n=c[l];if(n){const r=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,l);await this.fileService.createFile(r,D.VSBuffer.fromString(n)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};y=pe([J(0,P.IFileService),J(1,b.IUserDataProfilesService),J(2,T.IEnvironmentService),J(3,f.IUserDataSyncLogService),J(4,C.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(ne[263],re([0,1,17,16,13,14,21,23,31,20,41,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(y,u){try{return JSON.parse(y).tasks}catch(m){return u.error(m),null}}e.getTasksContentFromSyncContent=S;let p=class extends C.AbstractFileSynchroniser{constructor(u,m,c,d,l,n,r,i,o,s,h,a){super(u.tasksResource,{syncResource:"tasks",profile:u},m,i,o,s,c,d,r,h,l,n,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,m,c,d){const l=u.syncData?S(u.syncData.content,this.logService):null;m=m===null&&c?u:m;const n=m?.syncData?S(m.syncData.content,this.logService):null,r=await this.getLocalFileContent();let i=null,o=!1,s=!1,h=!1;if(l){const w=r?r.value.toString():null;if(!n||n!==w||n!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=v(w,l,n);i=A.content,h=A.hasConflicts,o=A.hasLocalChanged,s=A.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),i=r.value.toString(),s=!0);const a={content:h?n:i,localChange:o?r?2:1:0,remoteChange:s?2:0,hasConflicts:h},g=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:g,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const m=u?.syncData?S(u.syncData.content,this.logService):null;if(m===null)return!0;const c=await this.getLocalFileContent(),d=c?c.value.toString():null,l=v(d,m,m);return l.hasLocalChanged||l.hasRemoteChanged}async getMergeResult(u,m){return u.previewResult}async getAcceptResult(u,m,c,d){if(this.extUri.isEqual(m,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(m,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(m,this.previewResource))return c===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async applyResult(u,m,c,d){const{fileContent:l}=c[0][0],{content:n,localChange:r,remoteChange:i}=c[0][1];if(r===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),l&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(l.value.toString()))),await this.updateLocalFileContent(n||"{}",l,d),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),i!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const o=JSON.stringify(this.toTasksSyncContent(n||"{}"));u=await this.updateRemoteUserData(o,d?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}m?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:u}){const m=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(u,"tasks.json"),comparableResource:m}]}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let m=await super.resolveContent(u);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(u)),m){const c=this.parseSyncData(m);if(c)switch(this.extUri.basename(u)){case"tasks.json":return S(c.content,this.logService)}}return null}toTasksSyncContent(u){return{tasks:u}}};p=pe([J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncBackupStoreService),J(4,b.IUserDataSyncLogService),J(5,t.IConfigurationService),J(6,b.IUserDataSyncEnablementService),J(7,L.IFileService),J(8,R.IEnvironmentService),J(9,T.IStorageService),J(10,P.ITelemetryService),J(11,I.IUriIdentityService)],p),e.TasksSynchroniser=p;let f=class extends C.AbstractInitializer{constructor(u,m,c,d,l){super("tasks",m,c,d,u,l),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const m=u.syncData?S(u.syncData.content,this.logService):null;if(!m){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(m)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=pe([J(0,L.IFileService),J(1,E.IUserDataProfilesService),J(2,R.IEnvironmentService),J(3,b.IUserDataSyncLogService),J(4,I.IUriIdentityService)],f),e.TasksInitializer=f;function v(y,u,m){if(y===null&&u===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=m!==y,d=m!==u;return!c&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!d?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!c?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[264],re([0,1,46,7,16,13,14,21,23,31,20,41,246,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let f=class vt extends b.AbstractSynchroniser{constructor(u,m,c,d,l,n,r,i,o,s,h,a,g){super({syncResource:"profiles",profile:u},m,d,l,n,r,i,h,a,o,s,g),this.userDataProfilesService=c,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?v(u.syncData):null}async getRemoteSyncedProfiles(u){const m=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(u,m);return c?.syncData?v(c.syncData):null}async generateSyncPreview(u,m,c){const d=u.syncData?v(u.syncData):null,l=m?.syncData?v(m.syncData):null,n=this.getLocalUserDataProfiles(),{local:r,remote:i}=(0,S.merge)(n,d,l,[]),o={local:r,remote:i,content:l?this.stringifyRemoteProfiles(l):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:i!==null?2:0},s=this.stringifyLocalProfiles(n,!1);return[{baseResource:this.baseResource,baseContent:l?this.stringifyRemoteProfiles(l):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:d?this.stringifyRemoteProfiles(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const m=u?.syncData?v(u.syncData):null,c=this.getLocalUserDataProfiles(),{remote:d}=(0,S.merge)(c,m,m,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async getMergeResult(u,m){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,m,c,d){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(m,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(u){const m=this.getLocalUserDataProfiles(),c=(0,S.merge)(m,null,null,[]),{local:d,remote:l}=c;return{content:u.localContent,local:d,remote:l,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:l!==null?2:0}}async acceptRemote(u){const m=u.remoteContent?JSON.parse(u.remoteContent):null,c=[],d=[];for(const l of this.getLocalUserDataProfiles()){const n=m?.find(r=>r.id===l.id);n&&(c.push({id:l.id,name:l.name,collection:n.collection}),d.push(l))}if(m!==null){const l=(0,S.merge)(d,m,c,[]),{local:n,remote:r}=l;return{content:u.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,m,c,d){const{local:l,remote:n,localChange:r,remoteChange:i}=c[0][1];if(r===0&&i===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),r!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const o=[];for(const s of l.added)o.push(this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}));for(const s of l.removed)o.push(this.userDataProfilesService.removeProfile(s));for(const s of l.updated){const h=this.userDataProfilesService.profiles.find(a=>a.id===s.id);h?o.push(this.userDataProfilesService.updateProfile(h,{name:s.name,shortName:s.shortName})):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(o)}if(i!==0){const o=c[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of n?.added||[]){const h=await this.userDataSyncStoreService.createCollection(this.syncHeaders);o.push({id:s.id,name:s.name,collection:h,shortName:s.shortName})}for(const s of n?.removed||[])o.splice(o.findIndex(({id:h})=>s.id===h),1);for(const s of n?.updated||[]){const h=o.find(({id:a})=>s.id===a);h&&o.splice(o.indexOf(h),1,{id:s.id,name:s.name,collection:h.collection,shortName:s.shortName})}u=await this.updateRemoteUserData(this.stringifyRemoteProfiles(o),d?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`);for(const s of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}m?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"profiles.json"),comparableResource:vt.PROFILES_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,vt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const c=await this.resolvePreviewContent(u);return c&&(0,D.toFormattedString)(JSON.parse(c),{})}let m=await super.resolveContent(u);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(u)),m){const c=this.parseSyncData(m);if(c)switch(this.extUri.basename(u)){case"profiles.json":return(0,D.toFormattedString)(v(c),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((m,c)=>m.name.localeCompare(c.name)))}stringifyLocalProfiles(u,m){const c=[...u].sort((d,l)=>d.name.localeCompare(l.name)).map(d=>({id:d.id,name:d.name}));return m?(0,D.toFormattedString)(c,{}):JSON.stringify(c)}};f.PROFILES_DATA_URI=t.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),f=pe([J(2,C.IUserDataProfilesService),J(3,T.IFileService),J(4,L.IEnvironmentService),J(5,P.IStorageService),J(6,p.IUserDataSyncStoreService),J(7,p.IUserDataSyncBackupStoreService),J(8,p.IUserDataSyncLogService),J(9,R.IConfigurationService),J(10,p.IUserDataSyncEnablementService),J(11,I.ITelemetryService),J(12,E.IUriIdentityService)],f),e.UserDataProfilesManifestSynchroniser=f;function v(y){return JSON.parse(y.content)}}),define(ne[265],re([0,1,6,17,65,2,19,16,13,14,20,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let S=class extends L.Disposable{constructor(f,v,y,u,m){super(),this.environmentService=f,this.fileService=v,this.configurationService=y,this.logService=u,this.userDataProfilesService=m;for(const c of this.userDataProfilesService.profiles)for(const d of b.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(c,d))}async getAllRefs(f,v){const y=this.getResourceBackupHome(f,v),u=await this.fileService.resolve(y);return u.children?u.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)})):[]}async resolveContent(f,v,y){if(!y){const u=await this.getAllRefs(f,v);u.length&&(y=u[u.length-1].ref)}if(y){const u=(0,T.joinPath)(this.environmentService.userDataSyncHome,v,y);return(await this.fileService.readFile(u)).value.toString()}return null}async backup(f,v,y){const u=this.getResourceBackupHome(f,v),m=(0,T.joinPath)(u,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(m,t.VSBuffer.fromString(y))}catch(c){this.logService.error(c)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(f,v){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[v]:[f.id,v])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const v=await this.fileService.resolve(f);if(v.children){const y=v.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let m=y.filter(d=>Date.now()-this.getCreationTime(d)>u);const c=y.length-m.length;c<10&&(m=m.slice(10-c)),await D.Promises.settled(m.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};S=pe([J(0,I.IEnvironmentService),J(1,E.IFileService),J(2,P.IConfigurationService),J(3,b.IUserDataSyncLogService),J(4,C.IUserDataProfilesService)],S),e.UserDataSyncBackupStoreService=S}),define(ne[266],re([0,1,3,2,4,13,21,23,26]),function(Q,e,D,t,R,L,T,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let C=class extends t.Disposable{constructor(S,p,f,v){super(),this.storageService=S,this.telemetryService=p,this.environmentService=f,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:S}),this.storageService.store(E,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,I.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,p){if(this.isResourceEnabled(S)!==p){const f=(0,I.getEnablementKey)(S);this.storeResourceEnablement(f,p)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,p){this.storageService.store(S,p,-1,R.isWeb?0:1)}onDidStorageChange(S){if(S.scope!==-1)return;if(E===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===S.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};C=pe([J(0,T.IStorageService),J(1,P.ITelemetryService),J(2,L.IEnvironmentService),J(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(ne[79],re([0,1,3,2,4,27,172,13,14,5,25,50,21,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",v="Safari",y="Chrome",u="Edge",m="Firefox",c="Android";function d(r){switch(r){case v:case y:case u:case m:case c:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function l(){return R.isSafari?v:R.isChrome?y:R.isEdge?u:R.isFirefox?m:R.isAndroid?c:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let n=class st extends t.Disposable{constructor(i,o,s,h,a,g){super(),this.storageService=s,this.userDataSyncStoreService=h,this.logService=a,this.productService=g,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(i,o,s)}async getMachines(i){const o=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(h=>({...h,isCurrent:h.id===o}))}async addCurrentMachine(i){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(i);s.machines.some(({id:h})=>h===o)||(s.machines.push({id:o,name:this.computeCurrentMachineName(s.machines),platform:l()}),await this.writeMachinesData(s))}async removeCurrentMachine(i){const o=await this.currentMachineIdPromise,s=await this.readMachinesData(i),h=s.machines.filter(({id:a})=>a!==o);h.length!==s.machines.length&&(s.machines=h,await this.writeMachinesData(s))}async renameMachine(i,o,s){const h=await this.readMachinesData(s),a=h.machines.find(({id:g})=>g===i);if(a){a.name=o,await this.writeMachinesData(h);const g=await this.currentMachineIdPromise;i===g&&this.storageService.store(f,o,-1,1)}}async setEnablements(i){const o=await this.readMachinesData();for(const[s,h]of i){const a=o.machines.find(g=>g.id===s);a&&(a.disabled=h?void 0:!0)}await this.writeMachinesData(o)}computeCurrentMachineName(i){const o=this.storageService.get(f,-1);if(o)return o;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,h=new RegExp(`${(0,L.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const g of i){const w=h.exec(g.name),A=w?parseInt(w[1]):0;a=A>a?A:a}return`${s} #${a+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const o=this.parse(this.userData);if(o.version!==st.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return o}async writeMachinesData(i){const o=JSON.stringify(i),s=await this.userDataSyncStoreService.writeResource(st.RESOURCE,o,this.userData?.ref||null);this.userData={ref:s,content:o},this._onDidChange.fire()}async readUserData(i){if(this.userData){const o=i&&i.latest?i.latest[st.RESOURCE]:void 0;if(this.userData.ref===o)return this.userData;if(o===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(st.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(o){this.logService.error(o)}return{version:st.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=pe([J(0,P.IEnvironmentService),J(1,I.IFileService),J(2,S.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,C.IProductService)],n),e.UserDataSyncMachinesService=n}),define(ne[267],re([0,1,6,65,37,9,3,2,4,19,7,170,25,21,23,26,76,79]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",c="sync.sessionId",d="sync.storeUrl",l="sync.productQuality";let n=class extends P.Disposable{get syncUrl(){const o=this.storageService.get(d,-1);return o?C.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(d,o.toString(),-1,1):this.storageService.remove(d,-1)}get productQuality(){return this.storageService.get(l,-1)}set productQuality(o){o?this.storageService.store(l,o,-1,1):this.storageService.remove(l,-1)}constructor(o,s,h,a,g,w,A,F,_,N){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=h,this.userDataSyncEnablementService=a,this.userDataSyncService=g,this.logService=w,this.userDataSyncAccountService=A,this.telemetryService=F,this.userDataSyncMachinesService=_,this.storageService=N,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(h.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(g.onDidChangeLocal(W=>this.triggerSync([W],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,W])=>W)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:o,message:s}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(h=>this.onDidFinishSync(h))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,s,h){try{this.userDataSyncAccountService.account&&!h&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),s)this.updateEnablement(!1);else throw a}}updateEnablement(o){this.userDataSyncEnablementService.isEnabled()!==o&&(this.userDataSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const s=v.UserDataSyncError.toUserDataSyncError(o);s instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(m,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(m,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(m,-1)}async triggerSync(o,s,h){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",h)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=pe([J(0,S.IProductService),J(1,v.IUserDataSyncStoreManagementService),J(2,v.IUserDataSyncStoreService),J(3,v.IUserDataSyncEnablementService),J(4,v.IUserDataSyncService),J(5,v.IUserDataSyncLogService),J(6,y.IUserDataSyncAccountService),J(7,f.ITelemetryService),J(8,u.IUserDataSyncMachinesService),J(9,p.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends P.Disposable{constructor(o,s,h,a,g,w,A,F){super(),this.lastSyncUrl=o,this.interval=s,this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=a,this.userDataSyncService=g,this.userDataSyncMachinesService=w,this.logService=A,this.storageService=F,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(o,s){const h=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(g){if((0,L.isCancellationError)(g))return}return this.doSync(o,s,a)});return this.syncPromise=h,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!o&&(!(0,E.isEqual)(s.defaultUrl,o.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,o.insidersUrl)||!(0,E.isEqual)(s.stableUrl,o.stableUrl))}async doSync(o,s,h){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),h.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const g=this.storageService.get(c,-1);if(g&&this.manifest&&g!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(h.isCancellationRequested)return;const A=w.find(F=>F.isCurrent);if(A?.disabled)throw new v.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(F){throw new v.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof v.UserDataSyncError?F.code:"Unknown")}if(this.manifest&&this.manifest.session!==g&&this.storageService.store(c,this.manifest.session,-1,1),h.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(g){this.logService.error(g),a=g}this._onDidFinishSync.fire(a)}register(o){return super._register(o)}}r.INTERVAL_SYNCING="Interval"}),define(ne[63],re([0,1,2,69,5,21]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(E){super(),this.storageService=E}async readStorageData(E){return this.withProfileScopedStorageService(E,async C=>this.getItems(C))}async updateStorageData(E,C,b){return this.withProfileScopedStorageService(E,async S=>this.writeItems(S,C,b))}async withProfileScopedStorageService(E,C){if(this.storageService.hasScope(E))return C(this.storageService);const b=await this.createStorageDatabase(E),S=new P(b);try{await S.initialize();const p=await C(S);return await S.flush(),p}finally{S.dispose(),await this.closeAndDispose(b)}}getItems(E){const C=new Map,b=S=>{for(const p of E.keys(0,S))C.set(p,{value:E.get(p,0),target:S})};return b(0),b(1),C}writeItems(E,C,b){for(const[S,p]of C)E.store(S,p,0,b)}async closeAndDispose(E){try{await E.close()}finally{(0,D.isDisposable)(E)&&E.dispose()}}};T=pe([J(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class P extends L.AbstractStorageService{constructor(E){super({flushInterval:100}),this.profileStorage=this._register(new t.Storage(E))}doInitialize(){return this.profileStorage.init()}getStorage(E){return E===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[268],re([0,1,6,24,9,3,46,2,27,7,16,13,117,29,33,78,14,5,71,8,21,23,31,20,41,243,115,26,63]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n,r,i,o,s,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function g(F,_){const N=JSON.parse(F.content);if(F.version===1||F.version===2){const W=(await _.getInstalled(0)).filter(k=>k.isBuiltin);for(const k of N)F.version===1&&(k.enabled===!1&&(k.disabled=!0),delete k.enabled),F.version===2&&W.every(U=>!(0,f.areSameExtensions)(U.identifier,k.identifier))&&(k.installed=!0)}return N}let w=class St extends i.AbstractSynchroniser{constructor(_,N,W,k,U,$,Y,q,V,z,j,K,X,ce,B,H,O,M){super({syncResource:"extensions",profile:_},N,k,W,U,$,Y,X,ce,z,K,H),this.extensionManagementService=q,this.ignoredExtensionsManagementService=V,this.extensionGalleryService=j,this.userDataSyncProfilesStorageService=O,this.instantiationService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.profileLocation=_.extensionsResource,this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:G})=>!!G)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),L.Event.filter(O.onDidChange,x=>x.valueChanges.some(({profile:G,changes:ee})=>this.syncResource.profile.id===G.id&&ee.some(oe=>oe.key===p.DISABLED_EXTENSIONS_STORAGE_PATH))),B.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(_,N){const W=_.syncData?await g(_.syncData,this.extensionManagementService):null,k=N?.skippedExtensions||[],U=N?.builtinExtensions||[],$=N?.syncData?await g(N.syncData,this.extensionManagementService):null,Y=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),q=await this.getLocalExtensions(Y),V=this.ignoredExtensionsManagementService.getIgnoredExtensions(Y);W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:j}=(0,o.merge)(q,W,$,k,V,U),K={local:z,remote:j,content:this.getPreviewContent(q,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:j!==null?2:0},X=this.stringify(q,!1);return[{skippedExtensions:k,builtinExtensions:U,baseResource:this.baseResource,baseContent:$?this.stringify($,!1):X,localResource:this.localResource,localContent:X,localExtensions:q,remoteResource:this.remoteResource,remoteExtensions:W,remoteContent:W?this.stringify(W,!1):null,previewResource:this.previewResource,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(_){const N=_.syncData?await g(_.syncData,this.extensionManagementService):null,W=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),k=await this.getLocalExtensions(W),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(W),{remote:$}=(0,o.merge)(k,N,N,_.skippedExtensions||[],U,_.builtinExtensions||[]);return $!==null}getPreviewContent(_,N,W,k){const U=[...N,...W],$=new Set,Y=q=>{$.add(q.id.toLowerCase()),q.uuid&&$.add(q.uuid)};U.forEach(({identifier:q})=>Y(q)),k.forEach(Y);for(const q of _)$.has(q.identifier.id.toLowerCase())||q.identifier.uuid&&$.has(q.identifier.uuid)||U.push(q);return this.stringify(U,!1)}async getMergeResult(_,N){return{..._.previewResult,hasConflicts:!1}}async getAcceptResult(_,N,W,k){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(_);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(_);if(this.extUri.isEqual(N,this.previewResource))return _.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(_){const N=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),W=this.ignoredExtensionsManagementService.getIgnoredExtensions(N),k=(0,o.merge)(_.localExtensions,null,null,_.skippedExtensions,W,_.builtinExtensions),{local:U,remote:$}=k;return{content:_.localContent,local:U,remote:$,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:$!==null?2:0}}async acceptRemote(_){const N=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),W=this.ignoredExtensionsManagementService.getIgnoredExtensions(N),k=_.remoteContent?JSON.parse(_.remoteContent):null;if(k!==null){const U=(0,o.merge)(_.localExtensions,k,_.localExtensions,[],W,_.builtinExtensions),{local:$,remote:Y}=U;return{content:_.remoteContent,local:$,remote:Y,localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:_.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(_,N,W,k){let{skippedExtensions:U,localExtensions:$}=W[0][0];const{local:Y,remote:q,localChange:V,remoteChange:z}=W[0][1];if(V===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),V!==0&&(await this.backupLocal(JSON.stringify($)),U=await this.updateLocalExtensions(Y.added,Y.removed,Y.updated,U)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const j=JSON.stringify(q.all);_=await this.updateRemoteUserData(j,k?null:_.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(K=>K.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(K=>K.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(K=>K.identifier.id))}.`:""}`)}if(N?.ref!==_.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const j=$.filter(K=>!K.installed).map(K=>K.identifier);await this.updateLastSyncUserData(_,{skippedExtensions:U,builtinExtensions:j}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${U.length?` Skipped: ${JSON.stringify(U.map(K=>K.identifier.id))}.`:""}`)}}async getAssociatedResources({uri:_}){return[{resource:this.extUri.joinPath(_,"extensions.json"),comparableResource:St.EXTENSIONS_DATA_URI}]}async resolveContent(_){if(this.extUri.isEqual(_,St.EXTENSIONS_DATA_URI)){const W=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(W),U=(await this.getLocalExtensions(W)).filter($=>!k.some(Y=>(0,f.areSameExtensions)({id:Y},$.identifier)));return this.stringify(U,!0)}if(this.extUri.isEqual(this.remoteResource,_)||this.extUri.isEqual(this.baseResource,_)||this.extUri.isEqual(this.localResource,_)||this.extUri.isEqual(this.acceptedResource,_)){const W=await this.resolvePreviewContent(_);return W&&this.stringify(JSON.parse(W),!0)}let N=await super.resolveContent(_);if(N)return N;if(N=await super.resolveContent(this.extUri.dirname(_)),N){const W=this.parseSyncData(N);if(W)switch(this.extUri.basename(_)){case"extensions.json":return this.stringify(this.parseExtensions(W),!0)}}return null}stringify(_,N){return _.sort((W,k)=>!W.identifier.uuid&&k.identifier.uuid?-1:W.identifier.uuid&&!k.identifier.uuid?1:(0,I.compare)(W.identifier.id,k.identifier.id)),N?(0,T.toFormattedString)(_,{}):JSON.stringify(_)}async hasLocalData(){try{const _=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if((await this.getLocalExtensions(_)).some(W=>W.installed||W.disabled))return!0}catch{}return!1}async updateLocalExtensions(_,N,W,k){return this.withProfileScopedServices(async(U,$)=>{const Y=[],q=[],V=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(N.length){const j=V.filter(({identifier:K,isBuiltin:X})=>!X&&N.some(ce=>(0,f.areSameExtensions)(K,ce)));await D.Promises.settled(j.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),Y.push(K.identifier)}))}(_.length||W.length)&&await D.Promises.settled([..._,...W].map(async j=>{const K=V.find(ce=>(0,f.areSameExtensions)(ce.identifier,j.identifier));if(K&&K.isBuiltin){j.state&&K.manifest.version===j.version&&this.updateExtensionState(j.state,K,K.manifest.version,$),U.getDisabledExtensions().some(B=>(0,f.areSameExtensions)(B,j.identifier))!==!!j.disabled&&(j.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,j.identifier.id),await U.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,j.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,j.identifier.id),await U.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,j.identifier.id))),Y.push(j.identifier);return}const X=(await this.extensionGalleryService.getExtensions([{...j.identifier,preRelease:j.preRelease}],t.CancellationToken.None))[0];if(j.state&&(K?K.manifest.version===j.version:!!X)&&this.updateExtensionState(j.state,K||X,K?.manifest.version,$),X)try{U.getDisabledExtensions().some(B=>(0,f.areSameExtensions)(B,j.identifier))!==!!j.disabled&&(j.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,j.identifier.id,X.version),await U.disableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,j.identifier.id,X.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,j.identifier.id,X.version),await U.enableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,j.identifier.id,X.version))),(!K||K.preRelease!==j.preRelease)&&(await this.extensionManagementService.canInstall(X)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,j.identifier.id,X.version),await this.extensionManagementService.installFromGallery(X,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:j.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,j.identifier.id,X.version),Y.push(X.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,X.displayName||X.identifier.id),q.push(j)))}catch(ce){q.push(j),ce instanceof p.ExtensionManagementError&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatiblePreRelease,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ce.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,X.displayName||X.identifier.id):(this.logService.error(ce),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,X.displayName||X.identifier.id))}else q.push(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}));const z=[];for(const j of k)Y.some(K=>(0,f.areSameExtensions)(K,j.identifier))||z.push(j);for(const j of q)z.some(K=>(0,f.areSameExtensions)(K.identifier,j.identifier))||z.push(j);return z})}updateExtensionState(_,N,W,k){const U=k.getExtensionState(N,!0)||{},$=W?k.getKeysForSync({id:N.identifier.id,version:W}):void 0;$?$.forEach(Y=>{U[Y]=_[Y]}):Object.keys(_).forEach(Y=>U[Y]=_[Y]),k.setExtensionState(N,U,!0)}parseExtensions(_){return JSON.parse(_.content)}getLocalExtensions(_){return this.withProfileScopedServices(async(N,W)=>{const k=N.getDisabledExtensions();return _.map(U=>{const{identifier:$,isBuiltin:Y,manifest:q,preRelease:V}=U,z={identifier:$,preRelease:V,version:q.version};k.some(j=>(0,f.areSameExtensions)(j,$))&&(z.disabled=!0),Y||(z.installed=!0);try{const j=W.getKeysForSync({id:$.id,version:q.version});if(j){const K=W.getExtensionState(U,!0)||{};z.state=Object.keys(K).reduce((X,ce)=>(j.includes(ce)&&(X[ce]=K[ce]),X),{})}}catch(j){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(j))}return z})})}async withProfileScopedServices(_){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(this.syncResource.profile,async N=>{const W=new P.DisposableStore,k=this.instantiationService.createChild(new m.ServiceCollection([d.IStorageService,N])),U=W.add(k.createInstance(S.GlobalExtensionEnablementService)),$=W.add(k.createInstance(v.ExtensionStorageService));try{return await _(U,$)}finally{W.dispose()}})}};w.EXTENSIONS_DATA_URI=E.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),w=pe([J(2,b.IEnvironmentService),J(3,y.IFileService),J(4,d.IStorageService),J(5,h.IUserDataSyncStoreService),J(6,h.IUserDataSyncBackupStoreService),J(7,p.IExtensionManagementService),J(8,s.IIgnoredExtensionsManagementService),J(9,h.IUserDataSyncLogService),J(10,p.IExtensionGalleryService),J(11,C.IConfigurationService),J(12,h.IUserDataSyncEnablementService),J(13,l.ITelemetryService),J(14,v.IExtensionStorageService),J(15,n.IUriIdentityService),J(16,a.IUserDataSyncProfilesStorageService),J(17,u.IInstantiationService)],w),e.ExtensionsSynchroniser=w;let A=class extends i.AbstractInitializer{constructor(_,N,W,k,U,$,Y){super("extensions",k,U,$,W,Y),this.extensionManagementService=_,this.ignoredExtensionsManagementService=N}async parseExtensions(_){return _.syncData?await g(_.syncData,this.extensionManagementService):null}generatePreview(_,N){const W=[],k=[],U=[];for(const $ of _){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension($.identifier.id))continue;const Y=N.find(q=>(0,f.areSameExtensions)(q.identifier,$.identifier));Y?(W.push(Y),$.disabled&&U.push($.identifier)):$.installed&&(k.push({...$.identifier,preRelease:!!$.preRelease}),$.disabled&&U.push($.identifier))}return{installedExtensions:W,newExtensions:k,disabledExtensions:U,remoteExtensions:_}}};A=pe([J(0,p.IExtensionManagementService),J(1,s.IIgnoredExtensionsManagementService),J(2,y.IFileService),J(3,r.IUserDataProfilesService),J(4,b.IEnvironmentService),J(5,c.ILogService),J(6,n.IUriIdentityService)],A),e.AbstractExtensionsInitializer=A}),define(ne[269],re([0,1,17,9,3,35,46,4,7,30,16,13,14,8,50,21,23,31,41,62,247,26,20,63]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",o=["locale"];function s(A,F){const _=A.storage?Object.keys(A.storage).sort():[],N={};return _.forEach(W=>N[W]=A.storage[W]),A.storage=N,F?(0,T.toFormattedString)(A,{}):JSON.stringify(A)}const h=1;let a=class yt extends m.AbstractSynchroniser{constructor(F,_,N,W,k,U,$,Y,q,V,z,j,K){super({syncResource:"globalState",profile:F},_,W,Y,j,k,U,q,V,$,z,K),this.userDataSyncProfilesStorageService=N,this.version=h,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(W.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(W.onDidFilesChange,X=>X.contains(this.environmentService.argvResource)),R.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,X=>!!(X.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||X.valueChanges.some(({profile:ce,changes:B})=>this.syncResource.profile.id===ce.id&&B.some(H=>H.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(F,_,N){const W=F.syncData?JSON.parse(F.syncData.content):null;_=_===null&&N?F:_;const k=_&&_.syncData?JSON.parse(_.syncData.content):null,U=await this.getLocalGlobalState();W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=await this.getStorageKeys(k),{local:Y,remote:q}=(0,d.merge)(U.storage,W?W.storage:null,k?k.storage:null,$,this.logService),V={content:null,local:Y,remote:q,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:q.all!==null?2:0},z=s(U,!1);return[{baseResource:this.baseResource,baseContent:k?s(k,!1):z,localResource:this.localResource,localContent:z,localUserData:U,remoteResource:this.remoteResource,remoteContent:W?s(W,!1):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async hasRemoteChanged(F){const _=F.syncData?JSON.parse(F.syncData.content):null;if(_===null)return!0;const N=await this.getLocalGlobalState(),W=await this.getStorageKeys(_),{remote:k}=(0,d.merge)(N.storage,_.storage,_.storage,W,this.logService);return k.all!==null}async getMergeResult(F,_){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,_,N,W){if(this.extUri.isEqual(_,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(_,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(_,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${_.toString()}`)}async acceptLocal(F){return{content:F.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(F.localUserData.storage),removed:[],updated:[],all:F.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(F){if(F.remoteContent!==null){const _=JSON.parse(F.remoteContent),{local:N,remote:W}=(0,d.merge)(F.localUserData.storage,_.storage,null,F.storageKeys,this.logService);return{content:F.remoteContent,local:N,remote:W,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:F.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(F,_,N,W){const{localUserData:k}=N[0][0],{local:U,remote:$,localChange:Y,remoteChange:q}=N[0][1];if(Y===0&&q===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Y!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(k)),await this.writeLocalGlobalState(U),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),q!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const V=JSON.stringify({storage:$.all});F=await this.updateRemoteUserData(V,W?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${$.added.length?` Added: ${$.added}.`:""}${$.updated.length?` Updated: ${$.updated}.`:""}${$.removed.length?` Removed: ${$.removed}.`:""}`)}_?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(F),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:F}){return[{resource:this.extUri.joinPath(F,"globalState.json"),comparableResource:yt.GLOBAL_STATE_DATA_URI}]}async resolveContent(F){if(this.extUri.isEqual(F,yt.GLOBAL_STATE_DATA_URI)){const N=await this.getLocalGlobalState();return s(N,!0)}if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const N=await this.resolvePreviewContent(F);return N&&s(JSON.parse(N),!0)}let _=await super.resolveContent(F);if(_)return _;if(_=await super.resolveContent(this.extUri.dirname(F)),_){const N=this.parseSyncData(_);if(N)switch(this.extUri.basename(F)){case"globalState.json":return s(JSON.parse(N.content),!0)}}return null}async hasLocalData(){try{const{storage:F}=await this.getLocalGlobalState();if(Object.keys(F).length>1||F[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const F={};if(this.syncResource.profile.isDefault){const N=await this.getLocalArgvContent(),W=(0,L.parse)(N);for(const k of o)W[k]!==void 0&&(F[`${i}${k}`]={version:1,value:W[k]})}const _=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile);for(const[N,W]of _)W.value&&W.target===0&&(F[N]={version:1,value:W.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const F=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),F.value.toString()}catch(F){this.logService.debug((0,t.getErrorMessage)(F))}return"{}"}async writeLocalGlobalState({added:F,removed:_,updated:N}){const W={},k=new Map,U=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),$=(Y,q)=>{for(const V of Y){if(V.startsWith(i)){W[V.substring(i.length)]=q?q[V].value:void 0;continue}if(q){const z=q[V];z.value!==U.get(V)?.value&&k.set(V,z.value)}else U.get(V)!==void 0&&k.set(V,void 0)}};$(Object.keys(F),F),$(Object.keys(N),N),$(_),Object.keys(W).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(W),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),k.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.syncResource.profile,k,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...k.keys()]))}async updateArgv(F){const _=await this.getLocalArgvContent();let N=_;for(const W of Object.keys(F))N=(0,c.edit)(N,[W],F[W],{});_!==N&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys(F){const _=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),N=[],W=[];for(const[$,Y]of _)Y.target===0?N.push($):Y.target===1&&W.push($);const k=[...N,...W],U=F?.storage?Object.keys(F.storage).filter($=>!$.startsWith(i)&&!k.includes($)&&_.get($)!==void 0):[];if(!P.isWeb){const $=[...l.ALL_SYNC_RESOURCES.map(Y=>(0,l.getEnablementKey)(Y)),l.SYNC_SERVICE_URL_TYPE];U.push(...$),W.push(...$)}return{user:N,machine:W,unregistered:U}}};a.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=pe([J(2,r.IUserDataSyncProfilesStorageService),J(3,S.IFileService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncLogService),J(7,b.IEnvironmentService),J(8,l.IUserDataSyncEnablementService),J(9,y.ITelemetryService),J(10,C.IConfigurationService),J(11,v.IStorageService),J(12,u.IUriIdentityService)],a),e.GlobalStateSynchroniser=a;let g=class extends m.AbstractInitializer{constructor(F,_,N,W,k,U){super("globalState",N,W,k,_,U),this.storageService=F}async doInitialize(F){const _=F.syncData?JSON.parse(F.syncData.content):null;if(!_){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},W={};for(const k of Object.keys(_.storage))k.startsWith(i)?N[k.substring(i.length)]=_.storage[k].value:this.storageService.get(k,0)===void 0&&(W[k]=_.storage[k].value);if(Object.keys(N).length){let k="{}";try{k=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const U of Object.keys(N))k=(0,c.edit)(k,[U],N[U],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(k))}if(Object.keys(W).length)for(const k of Object.keys(W))this.storageService.store(k,W[k],0,0)}};g=pe([J(0,v.IStorageService),J(1,S.IFileService),J(2,n.IUserDataProfilesService),J(3,b.IEnvironmentService),J(4,l.IUserDataSyncLogService),J(5,u.IUriIdentityService)],g),e.GlobalStateInitializer=g;let w=class{constructor(F,_,N,W,k){this.userDataSyncStoreClient=F,this.storageService=_,this.environmentService=N,this.fileService=W,this.logService=k}getSyncStoreType(F){return this.parseGlobalState(F)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(F){const _=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(F,_)}catch(N){if(N instanceof l.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(F,_)}throw N}}async doSync(F,_){const N=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,_),W=this.parseGlobalState(N)||{storage:{}};W.storage[l.SYNC_SERVICE_URL_TYPE]={value:F,version:h};const k=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),U={version:h,machineId:k,content:s(W,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(U),N.ref,void 0,_)}parseGlobalState({content:F}){if(!F)return null;const _=JSON.parse(F);if((0,m.isSyncData)(_))return _?JSON.parse(_.content):null;throw new Error("Invalid remote data")}};w=pe([J(1,v.IStorageService),J(2,b.IEnvironmentService),J(3,S.IFileService),J(4,p.ILogService)],w),e.UserDataSyncStoreTypeSynchronizer=w}),define(ne[270],re([0,1,18,6,24,37,3,2,19,15,30,16,13,29,5,25,21,23,20,268,269,260,261,262,263,264,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n,r,i,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const h="sync.lastSyncTime";let a=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(_,N,W,k,U,$,Y,q,V,z){super(),this.userDataSyncStoreService=_,this.userDataSyncStoreManagementService=N,this.instantiationService=W,this.logService=k,this.telemetryService=U,this.storageService=$,this.userDataSyncEnablementService=Y,this.userDataProfilesService=q,this.productService=V,this.environmentService=z,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=N.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(h,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(_,N){this.checkEnablement(),this.logService.info("Sync started.");const W=new Date().getTime(),k=(0,C.generateUuid)();try{const q=(0,s.createSyncHeaders)(k);N&&(q["Cache-Control"]="no-cache"),_=await this.userDataSyncStoreService.manifest(_,q)}catch(q){const V=s.UserDataSyncError.toUserDataSyncError(q);throw A(V,k,this.userDataSyncStoreManagementService,this.telemetryService),V}const U=!1,$=this;let Y;return{manifest:_,async run(){if(U)throw new Error("Can run a task only once");Y=(0,t.createCancelablePromise)(q=>$.sync(_,!1,k,q)),await Y.finally(()=>Y=void 0),$.logService.info(`Sync done. Took ${new Date().getTime()-W}ms`),$.updateLastSyncTime()},stop(){return Y?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const _=new Date().getTime(),N=(0,C.generateUuid)(),W=(0,s.createSyncHeaders)(N);let k;try{k=await this.userDataSyncStoreService.manifest(null,W)}catch(Y){const q=s.UserDataSyncError.toUserDataSyncError(Y);throw A(q,N,this.userDataSyncStoreManagementService,this.telemetryService),q}await this.resetLocal();const U=this,$=new R.CancellationTokenSource;return{id:N,async merge(){return U.sync(k,!0,N,$.token)},async apply(){await U.applyManualSync(k,N,$.token),U.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),U.updateLastSyncTime()},stop(){return $.cancel(),U.stop()},dispose(){$.cancel(),U.stop()}}}async sync(_,N,W,k){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(U,_,N,W,k));const $=U.enabled.find(Y=>Y.resource==="profiles");if($){const Y=await $.getLastSyncedProfiles()||[];if(k.isCancellationRequested)return;await this.syncRemoteProfiles(Y,_,N,W,k)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(_,N,W,k,U){for(const $ of _){if(U.isCancellationRequested)return;const Y=this.userDataProfilesService.profiles.find(V=>V.id===$.id);if(!Y){this.logService.error(`Settings Profile with id:${$.id} and name: ${$.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",$.name);const q=this.getOrCreateActiveProfileSynchronizer(Y,$);this._syncErrors.push(...await this.syncProfile(q,N,W,k,U))}}async applyManualSync(_,N,W){const k=this.getActiveProfileSynchronizers();for(const V of k){if(W.isCancellationRequested)return;await V.apply(N,W)}const U=k.find(V=>V.profile.isDefault);if(!U)return;const $=U.enabled.find(V=>V.resource==="profiles");if(!$)return;const q=(await $.getRemoteSyncedProfiles(_?.latest??null)||[]).filter(V=>k.every(z=>z.profile.id!==V.id));q.length&&await this.syncRemoteProfiles(q,_,!1,N,W)}async syncProfile(_,N,W,k,U){return(await _.sync(N,W,k,U)).map(([Y,q])=>({profile:_.profile,syncResource:Y,error:q}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(_=>_.stop()))}async resolveContent(_){for(const N of this.userDataProfilesService.profiles){const W=await this.performAction(N,async k=>{const U=await k.resolveContent(_);if(U)return U});if(!(0,E.isUndefinedOrNull)(W))return W}return null}async replace(_,N){this.checkEnablement(),await this.performAction(_.profile,async W=>{if(_.syncResource===W.resource)return await W.replace(N),!0})}async accept(_,N,W,k){this.checkEnablement(),await this.performAction(_.profile,async U=>{if(_.syncResource===U.resource)return await U.accept(N,W),k&&await U.apply((0,E.isBoolean)(k)?!1:k.force,(0,s.createSyncHeaders)((0,C.generateUuid)())),!0})}async getRemoteSyncResourceHandles(_){return await this.performAction(_.profile,async W=>{if(W.resource===_.syncResource)return W.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(_){return await this.performAction(_.profile,async W=>{if(W.resource===_.syncResource)return W.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(_,N){return await this.performAction(_.profile,async k=>{if(k.resource===_.syncResource)return k.getAssociatedResources(N)})||[]}async getMachineId(_,N){return await this.performAction(_.profile,async k=>{if(k.resource===_.syncResource)return await k.getMachineId(N)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async N=>{if(N.resource!=="globalState"&&await N.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async N=>{if(await N.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(_){this.logService.error(_)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(h,-1);for(const[_]of this.activeProfileSynchronizers.values())try{await _.resetLocal()}catch(N){this.logService.error(N)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(_,N){const W=new P.DisposableStore;try{const k=this.activeProfileSynchronizers.get(_.id);if(k){const V=await this.performActionWithProfileSynchronizer(k[0],N,W);return(0,E.isUndefined)(V)?null:V}if(_.isDefault){const V=W.add(this.instantiationService.createInstance(g,_,void 0)),z=await this.performActionWithProfileSynchronizer(V,N,W);return(0,E.isUndefined)(z)?null:z}if(this.userDataProfilesService.isEnabled()||this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const U=W.add(this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,_,void 0)),$=await this.userDataSyncStoreService.manifest(null),q=(await U.getRemoteSyncedProfiles($?.latest??null)||[]).find(V=>V.id===_.id);if(q){const V=W.add(this.instantiationService.createInstance(g,_,q.collection)),z=await this.performActionWithProfileSynchronizer(V,N,W);return(0,E.isUndefined)(z)?null:z}return null}finally{W.dispose()}}async performActionWithProfileSynchronizer(_,N,W){const k=[..._.enabled,..._.disabled.map(U=>W.add(_.createSynchronizer(U)))];for(const U of k){const $=await N(U);if(!(0,E.isUndefined)($))return $}}setStatus(_){const N=this._status;this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_),N==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const _=this.getActiveProfileSynchronizers().map(N=>N.conflicts).flat();(0,D.equals)(this._conflicts,_,(N,W)=>N.profile.id===W.profile.id&&N.syncResource===W.syncResource&&(0,D.equals)(N.conflicts,W.conflicts,(k,U)=>(0,I.isEqual)(k.previewResource,U.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(h,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(_,N){let W=this.activeProfileSynchronizers.get(_.id);if(!W){const k=new P.DisposableStore,U=k.add(this.instantiationService.createInstance(g,_,N?.collection));k.add(U.onDidChangeStatus($=>this.setStatus($))),k.add(U.onDidChangeConflicts($=>this.updateConflicts())),k.add(U.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),this.activeProfileSynchronizers.set(_.id,W=[U,k])}return W[0]}getActiveProfileSynchronizers(){const _=[];for(const[N]of this.activeProfileSynchronizers.values())_.push(N);return _}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,_])=>_.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=pe([J(0,s.IUserDataSyncStoreService),J(1,s.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,s.IUserDataSyncLogService),J(4,u.ITelemetryService),J(5,y.IStorageService),J(6,s.IUserDataSyncEnablementService),J(7,m.IUserDataProfilesService),J(8,v.IProductService),J(9,S.IEnvironmentService)],a),e.UserDataSyncService=a;let g=class extends P.Disposable{get enabled(){return this._enabled.sort((_,N)=>_[1]-N[1]).map(([_])=>_)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(_=>!this.userDataSyncEnablementService.isResourceEnabled(_))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(_,N,W,k,U,$,Y,q,V,z,j,K){super(),this._profile=_,this.collection=N,this.userDataSyncEnablementService=W,this.instantiationService=k,this.extensionGalleryService=U,this.userDataSyncStoreManagementService=$,this.telemetryService=Y,this.logService=q,this.productService=V,this.userDataProfilesService=z,this.configurationService=j,this.environmentService=K,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(z.onDidChangeProfiles(()=>{if(z.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!z.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=z.defaultProfile;for(const[X]of this._enabled)X instanceof c.ExtensionsSynchroniser&&(X.profileLocation=this._profile.extensionsResource)}})),this._register(W.onDidChangeResourceEnablement(([X,ce])=>this.onDidChangeResourceEnablement(X,ce))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,X])=>X.dispose())));for(const X of s.ALL_SYNC_RESOURCES)W.isResourceEnabled(X)&&this.registerSynchronizer(X)}onDidChangeResourceEnablement(_,N){N?this.registerSynchronizer(_):this.deRegisterSynchronizer(_)}registerSynchronizer(_){if(this._enabled.some(([U])=>U.resource===_))return;if(_==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(_==="profiles"){if(!this._profile.isDefault||!this.userDataProfilesService.isEnabled())return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const N=new P.DisposableStore,W=N.add(this.createSynchronizer(_));N.add(W.onDidChangeStatus(()=>this.updateStatus())),N.add(W.onDidChangeConflicts(()=>this.updateConflicts())),N.add(W.onDidChangeLocal(()=>this._onDidChangeLocal.fire(_)));const k=this.getOrder(_);this._enabled.push([W,k,N])}deRegisterSynchronizer(_){const N=this._enabled.findIndex(([W])=>W.resource===_);if(N!==-1){const W=this._enabled.splice(N,1);for(const[k,,U]of W){if(k.status!=="idle"){const $=k.conflicts.conflicts.length>0;k.stop(),$&&this.updateConflicts(),this.updateStatus()}U.dispose()}}}createSynchronizer(_){switch(_){case"settings":return this.instantiationService.createInstance(n.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(l.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(r.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(i.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(c.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(o.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(_,N,W,k){if(k.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const $=[],Y=(0,s.createSyncHeaders)(W),q=(this.collection?_?.collections?.[this.collection]?.latest:_?.latest)??null,V=N?await this.getUserDataSyncConfiguration(q):{};for(const z of U){if(k.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(z.resource))return[];try{if(N){const j=await z.preview(q,V,Y);if(j)for(const K of j.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await z.merge(K.previewResource)}else await z.sync(q,Y)}catch(j){const K=s.UserDataSyncError.toUserDataSyncError(j);if(A(K,W,this.userDataSyncStoreManagementService,this.telemetryService),w(j))throw K;this.logService.error(j),this.logService.error(`${z.resource}: ${(0,L.toErrorMessage)(j)}`),$.push([z.resource,K])}}return $}finally{this.updateStatus()}}async apply(_,N){const W=(0,s.createSyncHeaders)(_);for(const k of this.enabled){if(N.isCancellationRequested)return;try{await k.apply(!1,W)}catch(U){const $=s.UserDataSyncError.toUserDataSyncError(U);if(A($,_,this.userDataSyncStoreManagementService,this.telemetryService),w(U))throw $;this.logService.error(U),this.logService.error(`${k.resource}: ${(0,L.toErrorMessage)(U)}`)}}}async stop(){for(const _ of this.enabled)try{_.status!=="idle"&&await _.stop()}catch(N){this.logService.error(N)}}async resetLocal(){for(const _ of this.enabled)try{await _.resetLocal()}catch(N){this.logService.error(`${_.resource}: ${(0,L.toErrorMessage)(N)}`),this.logService.error(N)}}async getUserDataSyncConfiguration(_){if(!this.profile.isDefault)return{};const N=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),W=this.enabled.find(k=>k instanceof n.SettingsSynchroniser);if(W){const k=await W.getRemoteUserDataSyncConfiguration(_);return{...N,...k}}return N}setStatus(_){this._status!==_&&(this._status=_,this._onDidChangeStatus.fire(_))}updateStatus(){return this.updateConflicts(),this.enabled.some(_=>_.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(_=>_.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const _=this.enabled.filter(N=>N.status==="hasConflicts").filter(N=>N.conflicts.conflicts.length>0).map(N=>N.conflicts);(0,D.equals)(this._conflicts,_,(N,W)=>N.syncResource===W.syncResource&&(0,D.equals)(N.conflicts,W.conflicts,(k,U)=>(0,I.isEqual)(k.previewResource,U.previewResource)))||(this._conflicts=_,this._onDidChangeConflicts.fire(_))}getOrder(_){switch(_){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};g=pe([J(2,s.IUserDataSyncEnablementService),J(3,f.IInstantiationService),J(4,p.IExtensionGalleryService),J(5,s.IUserDataSyncStoreManagementService),J(6,u.ITelemetryService),J(7,s.IUserDataSyncLogService),J(8,v.IProductService),J(9,m.IUserDataProfilesService),J(10,b.IConfigurationService),J(11,S.IEnvironmentService)],g);function w(F){if(F instanceof s.UserDataSyncError)switch(F.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function A(F,_,N,W){W.publicLog2("sync/error",{code:F.code,serverCode:F instanceof s.UserDataSyncStoreError?String(F.serverCode):void 0,url:F instanceof s.UserDataSyncStoreError?F.url:void 0,resource:F.resource,executionId:_,service:N.userDataSyncStore.url.toString()})}}),define(ne[271],re([0,1,3,2,7,20,26]),function(Q,e,D,t,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(b,S){return{...b,profile:(0,L.reviveProfile)(b.profile,S.profilesHome.scheme)}}class I{constructor(S,p,f){this.service=S,this.userDataProfilesService=p,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(S,p){switch(p){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${p}`)}async call(S,p,f){try{return await this._call(S,p,f)}catch(v){throw this.logService.error(v),v}}async _call(S,p,f){switch(p){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(f[0]));case"accept":return this.service.accept(P(f[0],this.userDataProfilesService),R.URI.revive(f[1]),f[2],f[3]);case"replace":return this.service.replace(P(f[0],this.userDataProfilesService),R.URI.revive(f[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(f[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(f[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(f[0],this.userDataProfilesService),{created:f[1].created,uri:R.URI.revive(f[1].uri)});case"getMachineId":return this.service.getMachineId(P(f[0],this.userDataProfilesService),{created:f[1].created,uri:R.URI.revive(f[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(p.startsWith("manualSync/")){const v=p.substring(11),y=f[0],u=this.getManualSyncTask(y);switch(f=f.slice(1),v){case"merge":return u.merge();case"apply":return u.apply();case"stop":return u.stop();case"dispose":return this.disposeManualSyncTask(u)}}throw new Error("Invalid call")}getManualSyncTask(S){const p=this.manualSyncTasks.get(this.createKey(S));if(!p)throw new Error(`Manual sync taks not found: ${S}`);return p.manualSyncTask}async createManualSyncTask(){const S=new t.DisposableStore,p=S.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(p.id),{manualSyncTask:p,disposables:S}),p.id}disposeManualSyncTask(S){S.dispose();const p=this.createKey(S.id);this.manualSyncTasks.get(p)?.disposables.dispose(),this.manualSyncTasks.delete(p)}createKey(S){return`manualSyncTask-${S}`}}e.UserDataSyncChannel=I;let E=class extends t.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(S,p){super(),this.userDataProfilesService=p,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,v,y){return S.call(f,v,y).then(null,u=>{throw T.UserDataSyncError.toUserDataSyncError(u)})},listen(f,v){return S.listen(f,v)}},this.channel.call("_getInitialData").then(([f,v,y])=>{this.updateStatus(f),this.updateConflicts(v),y&&this.updateLastSyncTime(y),this._register(this.channel.listen("onDidChangeStatus")(u=>this.updateStatus(u))),this._register(this.channel.listen("onDidChangeLastSyncTime")(u=>this.updateLastSyncTime(u)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(v=>({...v,error:T.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const S=await this.channel.call("createManualSyncTask"),p=this;return new C(S,{async call(v,y,u){return p.channel.call(`manualSync/${v}`,[S,...Array.isArray(y)?y:[y]],u)},listen(){throw new Error("not supported")}})}replace(S,p){return this.channel.call("replace",[S,p])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(S,p,f,v){return this.channel.call("accept",[S,p,f,v])}resolveContent(S){return this.channel.call("resolveContent",[S])}async getLocalSyncResourceHandles(S){return(await this.channel.call("getLocalSyncResourceHandles",[S])).map(({created:f,uri:v})=>({created:f,uri:R.URI.revive(v)}))}async getRemoteSyncResourceHandles(S){return(await this.channel.call("getRemoteSyncResourceHandles",[S])).map(({created:f,uri:v})=>({created:f,uri:R.URI.revive(v)}))}async getAssociatedResources(S,p){return(await this.channel.call("getAssociatedResources",[S,p])).map(({resource:v,comparableResource:y})=>({resource:R.URI.revive(v),comparableResource:R.URI.revive(y)}))}async getMachineId(S,p){return this.channel.call("getMachineId",[S,p])}async updateStatus(S){this._status=S,this._onDidChangeStatus.fire(S)}async updateConflicts(S){this._conflicts=S.map(p=>({syncResource:p.syncResource,profile:(0,L.reviveProfile)(p.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:p.conflicts.map(f=>({...f,baseResource:R.URI.revive(f.baseResource),localResource:R.URI.revive(f.localResource),remoteResource:R.URI.revive(f.remoteResource),previewResource:R.URI.revive(f.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(S){this._lastSyncTime!==S&&(this._lastSyncTime=S,this._onDidChangeLastSyncTime.fire(S))}};E=pe([J(1,L.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class C extends t.Disposable{constructor(S,p){super(),this.id=S,this.channel=p}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ne[272],re([0,1,6,24,9,3,2,132,4,19,15,7,30,16,13,14,25,45,50,21,26]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",o=100,s=1e3*60*5;let h=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,_,-1,I.isWeb?0:1)}constructor(_,N,W){super(),this.productService=_,this.configurationService=N,this.storageService=W,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(W.onDidChangeValue,k=>k.key===d.SYNC_SERVICE_URL_TYPE&&k.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[d.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,N){_=I.isWeb&&_?.web?{..._,..._.web}:_;const W={..._||{},...N||{}};if(W&&(0,C.isString)(W.url)&&(0,C.isObject)(W.authenticationProviders)&&Object.keys(W.authenticationProviders).every(k=>Array.isArray(W.authenticationProviders[k].scopes))){const k=W,U=!!k.canSwitch&&!N?.url,$=k.url===k.insidersUrl?"insiders":"stable",Y=(U?this.userDataSyncStoreType:void 0)||$,q=N?.url||(Y==="insiders"?k.insidersUrl:Y==="stable"?k.stableUrl:k.url);return{url:b.URI.parse(q),type:Y,defaultType:$,defaultUrl:b.URI.parse(k.url),stableUrl:b.URI.parse(k.stableUrl),insidersUrl:b.URI.parse(k.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(k.authenticationProviders).reduce((V,z)=>(V.push({id:z,scopes:k.authenticationProviders[z].scopes}),V),[])}}}};h=pe([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,c.IStorageService)],h),e.AbstractUserDataSyncStoreManagementService=h;let a=class extends h{constructor(_,N,W){super(_,N,W);const k=this.storageService.get(l,-1);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const U=this.productService[d.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(l,JSON.stringify(U),-1,1):this.storageService.remove(l,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=pe([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let g=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(_,N,W,k,U,$,Y){super(),this.requestService=W,this.logService=k,this.storageService=Y,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,m.getServiceMachineId)(U,$,Y).then(q=>{const V={"X-Client-Name":`${N.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(V["X-Client-Commit"]=N.commit),V}),this.session=new A(o,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(_,N){this.authToken={token:_,type:N}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,E.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(n,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]="application/json";const W=await this.request(N,{type:"GET",headers:_},[],t.CancellationToken.None);return await(0,u.asJson)(W)||[]}async createCollection(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]=P.Mimes.text;const W=await this.request(N,{type:"POST",headers:_},[],t.CancellationToken.None),k=await(0,u.asTextOrError)(W);if(!k)throw new d.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",W.res.statusCode,W.res.headers[d.HEADER_OPERATION_ID]);return k}async deleteCollection(_,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=_?(0,E.joinPath)(this.userDataSyncStoreUrl,"collection",_).toString():(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(W,{type:"DELETE",headers:N},[],t.CancellationToken.None)}async getAllResourceRefs(_,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=this.getResourceUrl(this.userDataSyncStoreUrl,N,_),k={},U=await this.request(W.toString(),{type:"GET",headers:k},[],t.CancellationToken.None);return(await(0,u.asJson)(U)||[]).map(({url:Y,created:q})=>({ref:(0,E.relativePath)(W,W.with({path:Y})),created:q*1e3}))}async resolveResourceContent(_,N,W,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,_),N).toString();k={...k},k["Cache-Control"]="no-cache";const $=await this.request(U,{type:"GET",headers:k},[],t.CancellationToken.None);return await(0,u.asTextOrError)($)}async deleteResource(_,N,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=N!==null?(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,_),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,W,_).toString(),U={};await this.request(k,{type:"DELETE",headers:U},[],t.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":P.Mimes.text};await this.request(_,{type:"DELETE",headers:N},[],t.CancellationToken.None)}async readResource(_,N,W,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,W,_),"latest").toString();k={...k},k["Cache-Control"]="no-cache",N&&(k["If-None-Match"]=N.ref);const $=await this.request(U,{type:"GET",headers:k},[304],t.CancellationToken.None);let Y=null;if($.res.statusCode===304&&(Y=N),Y===null){const q=$.res.headers.etag;if(!q)throw new d.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",$.res.statusCode,$.res.headers[d.HEADER_OPERATION_ID]);const V=await(0,u.asTextOrError)($);if(!V&&$.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",U,"EmptyResponse",$.res.statusCode,$.res.headers[d.HEADER_OPERATION_ID]);Y={ref:q,content:V}}return Y}async writeResource(_,N,W,k,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,k,_).toString();U={...U},U["Content-Type"]=P.Mimes.text,W&&(U["If-Match"]=W);const Y=await this.request($,{type:"POST",data:N,headers:U},[],t.CancellationToken.None),q=Y.res.headers.etag;if(!q)throw new d.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",Y.res.statusCode,Y.res.headers[d.HEADER_OPERATION_ID]);return q}async manifest(_,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",_&&(N["If-None-Match"]=_.ref);const k=await this.request(W,{type:"GET",headers:N},[304],t.CancellationToken.None);let U=null;if(k.res.statusCode===304&&(U=_),!U){const Y=k.res.headers.etag;if(!Y)throw new d.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);const q=await(0,u.asTextOrError)(k);if(!q&&k.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",W,"EmptyResponse",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);q&&(U={...JSON.parse(q),ref:Y})}const $=this.storageService.get(r,-1);return $&&U&&$!==U.session&&this.clearSession(),U===null&&$&&this.clearSession(),U&&this.storageService.store(r,U.session,-1,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(_,N,W){return N?(0,E.joinPath)(_,"collection",N,"resource",W):(0,E.joinPath)(_,"resource",W)}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(i,-1)}async request(_,N,W,k){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;N.headers={...N.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:_,type:N.type,headers:{...N.headers,authorization:void 0}});let $;try{$=await this.session.request(_,N,k)}catch(z){if(!(z instanceof d.UserDataSyncStoreError)){let j="RequestFailed";const K=(0,R.getErrorMessage)(z).toLowerCase();K.includes("xhr timeout")?j="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?j="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":K.includes("headers must be an object")?j="RequestHeadersNotObject":(0,R.isCancellationError)(z)&&(j="RequestCanceled"),z=new d.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,j,void 0,void 0)}throw this.logService.info("Request failed",_),z}const Y=$.res.headers[d.HEADER_OPERATION_ID],q={url:_,status:$.res.statusCode,"execution-id":N.headers[d.HEADER_EXECUTION_ID],"operation-id":Y},V=(0,u.isSuccess)($)||$.res.statusCode&&W.indexOf($.res.statusCode)!==-1;if(V?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new d.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",$.res.statusCode,Y);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",$.res.statusCode,Y);if($.res.statusCode===410)throw new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",$.res.statusCode,Y);if($.res.statusCode===412)throw new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",$.res.statusCode,Y);if($.res.statusCode===413)throw new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",$.res.statusCode,Y);if($.res.statusCode===426)throw new d.UserDataSyncStoreError(`${N.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",$.res.statusCode,Y);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",$.res.statusCode,Y)):new d.UserDataSyncStoreError(`${N.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",$.res.statusCode,Y)}if(!V)throw new d.UserDataSyncStoreError("Server returned "+$.res.statusCode,_,"Unknown",$.res.statusCode,Y);return $}addSessionHeaders(_){let N=this.storageService.get(i,-1);N===void 0&&(N=(0,S.generateUuid)(),this.storageService.store(i,N,-1,1)),_["X-Machine-Session-Id"]=N;const W=this.storageService.get(r,-1);W!==void 0&&(_["X-User-Session-Id"]=W)}};g=pe([J(1,y.IProductService),J(2,u.IRequestService),J(3,d.IUserDataSyncLogService),J(4,f.IEnvironmentService),J(5,v.IFileService),J(6,c.IStorageService)],g),e.UserDataSyncStoreClient=g;let w=class extends g{constructor(_,N,W,k,U,$,Y){super(_.userDataSyncStore?.url,N,W,k,U,$,Y),this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};w=pe([J(0,d.IUserDataSyncStoreManagementService),J(1,y.IProductService),J(2,u.IRequestService),J(3,d.IUserDataSyncLogService),J(4,f.IEnvironmentService),J(5,v.IFileService),J(6,c.IStorageService)],w),e.UserDataSyncStoreService=w;class A{constructor(_,N,W,k){this.limit=_,this.interval=N,this.requestService=W,this.logService=k,this.requests=[],this.startTime=void 0}request(_,N,W){if(this.isExpired()&&this.reset(),N.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(N,W)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(ne[273],re([0,1,3,60,25,21,23,267,26,76,79]),function(Q,e,D,t,R,L,T,P,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(p,f,v,y,u,m,c,d,l,n,r){super(p,f,v,y,u,c,d,l,n,r),this._register(D.Event.debounce(D.Event.any(D.Event.map(m.onDidFocusWindow,()=>"windowFocus"),D.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(i,o)=>i?[...i,o]:[o],1e3)(i=>this.triggerSync(i,!0,!1)))}};b=pe([J(0,R.IProductService),J(1,I.IUserDataSyncStoreManagementService),J(2,I.IUserDataSyncStoreService),J(3,I.IUserDataSyncEnablementService),J(4,I.IUserDataSyncService),J(5,t.INativeHostService),J(6,I.IUserDataSyncLogService),J(7,E.IUserDataSyncAccountService),J(8,T.ITelemetryService),J(9,C.IUserDataSyncMachinesService),J(10,L.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ne[274],re([0,1,3,2,59,8,63,21,74,20]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let C=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(S,p,f,v){super(f),this.mainProcessService=S;const y=S.getChannel("profileStorageListener"),u=this._register(new t.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{u.value=y.listen("onDidChange")(m=>{v.trace("profile storage changes",m),this._onDidChange.fire({targetChanges:m.targetChanges.map(c=>(0,E.reviveProfile)(c,p.profilesHome.scheme)),valueChanges:m.valueChanges.map(c=>({...c,profile:(0,E.reviveProfile)(c.profile,p.profilesHome.scheme)}))})})},onLastListenerRemove:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(S){const p=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(S)?new I.ApplicationStorageDatabaseClient(p):new I.ProfileStorageDatabaseClient(p,S)}};C=pe([J(0,R.IMainProcessService),J(1,E.IUserDataProfilesService),J(2,P.IStorageService),J(3,L.ILogService)],C),e.UserDataSyncProfilesStorageService=C}),define(ne[275],re([0,1,99,22,4,19]),function(Q,e,D,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(E){function C(){let b=E.scheme===t.Schemas.file?(0,L.originalFSPath)(E):E.toString();return R.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:C(),configPath:E}}e.getWorkspaceIdentifier=T;function P(E,C){function b(){if(E.scheme!==t.Schemas.file)return(0,D.createHash)("md5").update(E.toString()).digest("hex");if(!C)return;let p;return R.isLinux?p=C.ino:R.isMacintosh?p=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?p=Math.floor(C.birthtimeMs):p=C.birthtime.getTime()),(0,D.createHash)("md5").update(E.fsPath).update(p?String(p):"").digest("hex")}const S=b();if(typeof S=="string")return{id:S,uri:E}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(ne[276],re([0,1,6,9,2,10,28,13,59,8,60,74,116,275]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends R.Disposable{constructor(y,u,m,c){super(),this.environmentService=y,this.logService=u,this.nativeHostService=m,this.mainProcessService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const y=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new b.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(y.map(async m=>{const c=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,m);m.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||m===S.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===m)||await u.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(y){(0,t.onUnexpectedError)(y)}}};f=pe([J(0,P.INativeEnvironmentService),J(1,E.ILogService),J(2,C.INativeHostService),J(3,I.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(ne[118],re([0,1,55,6,10,15,28,144,285,286]),function(Q,e,D,t,R,L,T,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=r}}e.ExtractError=C;function b(l){const n=l.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function S(l){if(l instanceof C)return l;let n;return/end of central directory record signature not found/.test(l.message)&&(n="CorruptZip"),new C(n,l)}function p(l,n,r,i,o,s){const h=R.dirname(n),a=R.join(i,h);if(!a.startsWith(i))return Promise.reject(new Error(P.localize(0,null,n)));const g=R.join(i,n);let w;return s.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,F)=>{if(!s.isCancellationRequested)try{w=(0,D.createWriteStream)(g,{mode:r}),w.once("close",()=>A()),w.once("error",F),l.once("error",F),l.pipe(w)}catch(_){F(_)}}))}function f(l,n,r,i){let o=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{o.cancel(),l.close()}),new Promise((h,a)=>{const g=new t.Sequencer,w=A=>{A.isCancellationRequested||(s++,l.readEntry())};l.once("error",a),l.once("close",()=>o.then(()=>{i.isCancellationRequested||l.entryCount===s?h():a(new C("Incomplete",new Error(P.localize(1,null,s,l.entryCount))))},a)),l.readEntry(),l.on("entry",A=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){w(i);return}const F=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(F)){const W=R.join(n,F);o=(0,t.createCancelablePromise)(k=>T.Promises.mkdir(W,{recursive:!0}).then(()=>w(k)).then(void 0,a));return}const _=y(l,A),N=b(A);o=(0,t.createCancelablePromise)(W=>g.queue(()=>_.then(k=>p(k,F,N,n,r,W).then(()=>w(W)))).then(null,a))})})}function v(l,n=!1){return new Promise((r,i)=>{(0,I.open)(l,n?{lazyEntries:!0}:void 0,(o,s)=>{o?i(S(o)):r((0,L.assertIsDefined)(s))})})}function y(l,n){return new Promise((r,i)=>{l.openReadStream(n,(o,s)=>{o?i(S(o)):r((0,L.assertIsDefined)(s))})})}function u(l,n){return new Promise((r,i)=>{const o=new E.ZipFile;n.forEach(h=>{h.contents?o.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&o.addFile(h.localPath,h.path)}),o.end();const s=(0,D.createWriteStream)(l);o.outputStream.pipe(s),o.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>r(l))})}e.zip=u;function m(l,n,r={},i){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=v(l,!0);return r.overwrite&&(s=s.then(h=>T.Promises.rm(n).then(()=>h))),s.then(h=>f(h,n,{sourcePathRegex:o},i))}e.extract=m;function c(l,n){return v(l).then(r=>new Promise((i,o)=>{r.on("entry",s=>{s.fileName===n&&y(r,s).then(h=>i(h),h=>o(h))}),r.once("close",()=>o(new Error(P.localize(2,null,n))))}))}function d(l,n){return c(l,n).then(r=>new Promise((i,o)=>{const s=[];r.once("error",o),r.on("data",h=>s.push(h)),r.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=d}),define(ne[277],re([0,1,118,154]),function(Q,e,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(L){return(0,D.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=R}),define(ne[119],re([0,1,6,37,9,2,22,10,4,19,56,15,7,30,28,118,153,96,13,253,29,33,51,77,208,254,277,209,240,44,70,14,5,8,25,23,31,20]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n,r,i,o,s,h,a,g,w,A,F,_,N,W,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(d.IExtensionManagementService);let $=class extends c.AbstractExtensionManagementService{constructor(B,H,O,M,x,G,ee,oe,Z,ie,se,ue){super(B,H,O,ie,ue),this.extensionsScannerService=x,this.extensionsProfileScannerService=G,this.downloadService=ee,this.fileService=Z,this.installGalleryExtensionsTasks=new Map;const de=this._register(oe.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(Y,we=>de.postUninstall(we))),this.manifestCache=this._register(new h.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(oe.createInstance(i.ExtensionsDownloader));const ve=this._register(new a.ExtensionsWatcher(this,Z,M,O,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const H=await this.collectFiles(B),O=await(0,v.zip)((0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,p.generateUuid)()).fsPath,H);return S.URI.file(O)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:H,cleanup:O}=await this.downloadVsix(B),M=P.resolve(H.fsPath);try{return await(0,s.getManifest)(M)}finally{await O()}}getInstalled(B,H){return this.extensionsScanner.scanExtensions(B??null,H)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(B,H={}){this.logService.trace("ExtensionManagementService#install",B.toString());const{location:O,cleanup:M}=await this.downloadVsix(B);try{const x=await(0,s.getManifest)(P.resolve(O.fsPath));if(x.engines&&x.engines.vscode&&!(0,w.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,l.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return await this.installExtension(x,O,H)}finally{await M()}}getMetadata(B){return this.extensionsScannerService.scanMetadata(B.location)}async updateMetadata(B,H){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const O={...H};return H.isPreReleaseVersion&&(O.preRelease=!0),B=await this.extensionsScanner.updateMetadata(B,O),this.manifestCache.invalidate(),B}async updateExtensionScope(B,H){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.updateMetadata(B,{isMachineScoped:H}),this.manifestCache.invalidate(),B}removeUninstalledExtensions(B){return this.extensionsScanner.cleanUp(B)}async download(B,H){const{location:O}=await this.extensionsDownloader.download(B,H);return O}async downloadVsix(B){if(B.scheme===T.Schemas.file)return{location:B,async cleanup(){}};this.logService.trace("Downloading extension from",B.toString());const H=(0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,p.generateUuid)());return await this.downloadService.download(B,H),this.logService.info("Downloaded extension to",H.toString()),{location:H,cleanup:async()=>{try{await this.fileService.del(H)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(B,H,O){let M;if(S.URI.isUri(H))M=new z(B,H,O,this.galleryService,this.extensionsScanner,this.logService);else{const x=l.ExtensionKey.create(H).toString();M=this.installGalleryExtensionsTasks.get(x),M||(this.installGalleryExtensionsTasks.set(x,M=new V(B,H,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return O.profileLocation?new j(M,O.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(B,H){return H.profileLocation?new X(B,H.profileLocation,this.extensionsProfileScannerService):new K(B,H,this.extensionsScanner)}async collectFiles(B){const H=async M=>{let x=await f.Promises.readdir(M);x=x.map(oe=>P.join(M,oe));const G=await Promise.all(x.map(oe=>f.Promises.stat(oe)));let ee=Promise.resolve([]);return G.forEach((oe,Z)=>{const ie=x[Z];oe.isFile()&&(ee=ee.then(se=>[...se,ie])),oe.isDirectory()&&(ee=ee.then(se=>H(ie).then(ue=>[...se,...ue])))}),ee};return(await H(B.location.fsPath)).map(M=>({path:`extension/${P.relative(B.location.fsPath,M)}`,localPath:M}))}};$=pe([J(0,d.IExtensionGalleryService),J(1,W.ITelemetryService),J(2,_.ILogService),J(3,m.INativeEnvironmentService),J(4,r.IExtensionsScannerService),J(5,n.IExtensionsProfileScannerService),J(6,u.IDownloadService),J(7,F.IInstantiationService),J(8,A.IFileService),J(9,N.IProductService),J(10,k.IUriIdentityService),J(11,U.IUserDataProfilesService)],$),e.ExtensionManagementService=$;let Y=class extends L.Disposable{constructor(B,H,O,M){super(),this.beforeRemovingExtension=B,this.fileService=H,this.extensionsScannerService=O,this.logService=M,this.uninstalledPath=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(B){await this.removeUninstalledExtensions(),B&&await this.removeOutdatedExtensions()}async scanExtensions(B,H){const O={includeInvalid:!0,profileLocation:H};let M=[];return B===null||B===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):B===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(O)),M=B!==null?M.filter(x=>x.type===B):M,Promise.all(M.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(B){const H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(H.map(O=>this.toLocalExtension(O)))}async extractUserExtension(B,H,O,M){const x=B.toString(),G=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,p.generateUuid)()}`),ee=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await f.Promises.rm(ee)}catch{throw new d.ExtensionManagementError(y.localize(1,null,ee,B.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(B,H,G,M),await this.extensionsScannerService.updateMetadata(S.URI.file(G),O);try{await this.rename(B,G,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(oe){try{await f.Promises.rm(G)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(oe)}. Deleted from extracted location`,G),oe}return this.scanLocalExtension(S.URI.file(ee),1)}async updateMetadata(B,H){return await this.extensionsScannerService.updateMetadata(B.location,H),this.scanLocalExtension(B.location,B.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...B){const H=B.map(O=>l.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{H.forEach(M=>O[M.toString()]=!0)})}async setInstalled(B){await this.withUninstalledExtensions(M=>delete M[B.toString()]);const O=(await this.scanUserExtensions(!0)).find(M=>l.ExtensionKey.create(M).equals(B))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(B,H){this.logService.trace(`Deleting ${H} extension from disk`,B.identifier.id,B.location.fsPath),await f.Promises.rm(B.location.fsPath),this.logService.info("Deleted from disk",B.identifier.id,B.location.fsPath)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.withUninstalledExtensions(H=>delete H[l.ExtensionKey.create(B).toString()])}async withUninstalledExtensions(B){return this.uninstalledFileLimiter.queue(async()=>{let H;try{H=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let O={};if(H)try{O=JSON.parse(H)}catch{}return B&&(B(O),Object.keys(O).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await f.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(B,H,O,M){this.logService.trace(`Started extracting the extension from ${H} to ${O}`);try{await f.Promises.rm(O)}catch(x){throw new d.ExtensionManagementError(this.joinErrors(x).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(H,O,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${O}:`,B.id)}catch(x){try{await f.Promises.rm(O)}catch{}let G=d.ExtensionManagementErrorCode.Extract;throw x instanceof v.ExtractError&&(x.type==="CorruptZip"?G=d.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(G=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(x.message,G)}}async rename(B,H,O,M){try{await f.Promises.rename(H,O)}catch(x){if(I.isWindows&&x&&x.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${H} to ${O} with 'EPERM' error. Trying again...`,B.id),this.rename(B,H,O,M);throw new d.ExtensionManagementError(x.message||y.localize(2,null,H,O),x.code||d.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(B,H){const O=await this.extensionsScannerService.scanExistingExtension(B,H,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(y.localize(3,null,B.path))}async toLocalExtension(B){const H=await this.fileService.resolve(B.location);let O,M;return H.children&&(O=H.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,M=H.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:O,changelogUrl:M,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated}}async removeUninstalledExtensions(){const B=await this.getUninstalledExtensions(),H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const G of H)B[l.ExtensionKey.create(G).toString()]||O.add(G.identifier.id.toLowerCase());const M=(0,l.groupByExtension)(H,G=>G.identifier);await D.Promises.settled(M.map(async G=>{const ee=G.sort((oe,Z)=>C.rcompare(oe.manifest.version,Z.manifest.version))[0];O.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}));const x=H.filter(G=>B[l.ExtensionKey.create(G).toString()]);await D.Promises.settled(x.map(G=>this.removeUninstalledExtension(G)))}async removeOutdatedExtensions(){const B=await this.extensionsScannerService.scanSystemExtensions({}),H=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],M=await this.extensionsScannerService.getTargetPlatform(),x=(0,l.groupByExtension)(H,G=>G.identifier);for(const G of x)if(G.length>1&&O.push(...G.sort((ee,oe)=>{const Z=C.rcompare(ee.manifest.version,oe.manifest.version);return Z!==0?Z:ee.targetPlatform===M?-1:1}).slice(1)),G[0].type===0){const ee=B.find(oe=>(0,l.areSameExtensions)(oe.identifier,G[0].identifier));(!ee||C.gte(ee.manifest.version,G[0].manifest.version))&&O.push(G[0])}await D.Promises.settled(O.map(G=>this.removeExtension(G,"outdated")))}joinErrors(B){const H=Array.isArray(B)?B:[B];return H.length===1?H[0]instanceof Error?H[0]:new Error(H[0]):H.reduce((O,M)=>new Error(`${O.message}${O.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};Y=pe([J(1,A.IFileService),J(2,r.IExtensionsScannerService),J(3,_.ILogService)],Y),e.ExtensionsScanner=Y;class q extends c.AbstractExtensionTask{get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(B,H,O,M,x){super(),this.identifier=B,this.source=H,this.options=O,this.extensionsScanner=M,this.logService=x,this.wasVerified=!1,this._operation=2}async installExtension(B,H){try{const O=await this.unsetUninstalledAndGetLocal(B.key);if(O)return this.extensionsScanner.updateMetadata(O,B.metadata)}catch{throw I.isMacintosh?new d.ExtensionManagementError(y.localize(4,null),d.ExtensionManagementErrorCode.Internal):new d.ExtensionManagementError(y.localize(5,null),d.ExtensionManagementErrorCode.Internal)}return this.extract(B,H)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const O=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),O}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}async extract({zipPath:B,key:H,metadata:O},M){const x=await this.extensionsScanner.extractUserExtension(H,B,O,M);return this.logService.info("Extracting completed.",H.id),x}}class V extends q{constructor(B,H,O,M,x,G){super(H.identifier,H,O,x,G),this.manifest=B,this.gallery=H,this.extensionsDownloader=M}async doRun(B){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(ee=>(0,l.areSameExtensions)(ee.identifier,this.gallery.identifier));O&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,g.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,M),metadata:M};const{location:x,verified:G}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!G,this.validateManifest(x.fsPath);const ee=await this.installExtension({zipPath:x.fsPath,key:l.ExtensionKey.create(this.gallery),metadata:M},B);return O&&!this.options.profileLocation&&(O.targetPlatform!==ee.targetPlatform||C.neq(O.manifest.version,ee.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:ee,metadata:M}}catch(ee){try{await this.extensionsDownloader.delete(x)}catch(oe){this.logService.warn("Error while deleting the downloaded file",x.toString(),(0,R.getErrorMessage)(oe))}throw ee}}async validateManifest(B){try{await(0,s.getManifest)(B)}catch(H){throw new d.ExtensionManagementError((0,c.joinErrors)(H).message,d.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class z extends q{constructor(B,H,O,M,x,G){super({id:(0,l.getGalleryExtensionId)(B.publisher,B.name)},H,O,x,G),this.manifest=B,this.location=H,this.galleryService=M}async doRun(B){const H=new l.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ee=>(0,l.areSameExtensions)(this.identifier,ee.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(x.isApplicationScoped=(0,g.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||M?.isBuiltin,x.installedTimestamp=Date.now(),M)if(this._operation=3,H.equals(new l.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const ee=await this.unsetUninstalledAndGetLocal(H);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:H,metadata:x},B),metadata:x}}async getMetadata(B,H,O){try{let[M]=await this.galleryService.getExtensions([{id:B,version:H}],O);if(M||([M]=await this.galleryService.getExtensions([{id:B}],O)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class j{constructor(B,H,O){this.task=B,this.profileLocation=H,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const B=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[B.local,B.metadata]],this.profileLocation),B}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class K extends c.AbstractExtensionTask{constructor(B,H,O){super(),this.extension=B,this.options=H,this.extensionsScanner=O}async doRun(B){const H=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=l.ExtensionKey.create(this.extension);H.push(...O.filter(x=>M.equals(l.ExtensionKey.create(x))))}else H.push(...O.filter(M=>(0,l.areSameExtensions)(M.identifier,this.extension.identifier)));if(!H.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...H),this.options.remove)for(const M of H)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(x){throw new Error(y.localize(9,null,(0,t.toErrorMessage)(x)))}}}class X extends c.AbstractExtensionTask{constructor(B,H,O){super(),this.extension=B,this.profileLocation=H,this.extensionsProfileScannerService=O}async doRun(B){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[278],re([0,1,2,29,33,51,78,207,119,44,5,8,21,31,20]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const v={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let y=class extends D.Disposable{constructor(c,d,l,n,r,i,o,s){super(),this.userDataProfilesService=d,c.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(c,l,n,r,s),T.ExtensionStorageService.removeOutdatedExtensionVersions(c,o),this._register(i.createInstance(u))}};y=pe([J(0,I.INativeServerExtensionManagementService),J(1,f.IUserDataProfilesService),J(2,t.IExtensionGalleryService),J(3,T.IExtensionStorageService),J(4,t.IGlobalExtensionEnablementService),J(5,C.IInstantiationService),J(6,S.IStorageService),J(7,b.ILogService)],y),e.ExtensionsCleaner=y;let u=class extends D.Disposable{constructor(c,d,l,n,r){super(),this.extensionManagementService=c,this.userDataProfilesService=d,this.extensionsProfileScannerService=l,this.uriIdentityService=n,this.logService=r,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:c,removed:d,all:l}){try{await Promise.all(d.map(n=>n.extensionsResource?this.removeExtensionsFromProfile(n.extensionsResource):Promise.resolve()))}catch(n){this.logService.error(n)}if(l.length===1){this.profileModeDisposables.clear();const n=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{n.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{c.length&&(await Promise.all(c.map(n=>n.extensionsResource?this.populateExtensionsFromProfile(n.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(n=>this.onDidChangeProfiles(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(n=>this.onDidUninstallExtension(n))),await this.uninstallExtensionsNotInProfiles()))}catch(n){this.logService.error(n)}}async uninstallExtensionsNotInProfiles(){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(l=>l.installedTimestamp&&!this.profileExtensionsLocations.has(this.getKey(l.identifier,l.manifest.version)));d.length&&await Promise.all(d.map(l=>this.extensionManagementService.uninstall(l,v)))}async onDidInstallExtensions(c){for(const{local:d,profileLocation:l}of c)!d||!l||this.addExtensionWithKey(this.getKey(d.identifier,d.manifest.version),l)}async onDidUninstallExtension(c){!c.profileLocation||!c.version||this.removeExtensionWithKey(this.getKey(c.identifier,c.version),c.profileLocation)&&await this.uninstallExtensions([{identifier:c.identifier,version:c.version}])}async populateExtensionsFromProfile(c){const d=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const l of d)this.addExtensionWithKey(this.getKey(l.identifier,l.version),c)}async removeExtensionsFromProfile(c){const d=[];for(const l of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(l,c))continue;const n=this.fromKey(l);n&&d.push(n)}d.length&&await this.uninstallExtensions(d)}addExtensionWithKey(c,d){let l=this.profileExtensionsLocations.get(c);l||(l=[],this.profileExtensionsLocations.set(c,l)),l.push(d)}removeExtensionWithKey(c,d){const l=this.profileExtensionsLocations.get(c);if(l){const n=l.findIndex(r=>this.uriIdentityService.extUri.isEqual(r,d));n>-1&&l.splice(n,1)}return l?.length?!1:(this.profileExtensionsLocations.delete(c),!0)}async uninstallExtensions(c){const l=(await this.extensionManagementService.getAllUserInstalled()).filter(n=>n.installedTimestamp&&c.some(r=>this.getKey(n.identifier,n.manifest.version)===this.getKey(r.identifier,r.version)));l.length&&await Promise.all(l.map(n=>this.extensionManagementService.uninstall(n,v)))}getKey(c,d){return`${E.ExtensionIdentifier.toKey(c.id)}@${d}`}fromKey(c){const[d,l]=(0,R.getIdAndVersion)(c);return l?{identifier:{id:d},version:l}:void 0}};u=pe([J(0,I.INativeServerExtensionManagementService),J(1,f.IUserDataProfilesService),J(2,L.IExtensionsProfileScannerService),J(3,p.IUriIdentityService),J(4,b.ILogService)],u)}),define(ne[287],re([0,1,92,34,37,9,2,22,19,7,38,142,200,278,201,193,194,276,182,185,16,205,95,224,96,215,13,221,117,256,29,97,184,257,119,98,180,14,196,198,57,5,191,71,192,59,72,210,8,102,60,103,25,45,21,258,109,23,110,111,112,52,229,113,231,237,78,115,26,76,265,249,250,79,266,270,271,272,273,274,63,251,108,223,75,239,212,238,107,220,31,241,4,242,186,203,202,77,255,20,51,199,61,259,218,228,252,225,106,101]),function(Q,e,D,t,R,L,T,P,I,E,C,b,S,p,f,v,y,u,m,c,d,l,n,r,i,o,s,h,a,g,w,A,F,_,N,W,k,U,$,Y,q,V,z,j,K,X,ce,B,H,O,M,x,G,ee,oe,Z,ie,se,ue,de,ve,we,Ee,Pe,Oe,$e,Ve,Je,ae,fe,ge,be,Ie,Le,Re,Ne,_e,Me,We,ke,Ae,te,le,he,me,Se,Ce,De,ze,Fe,Te,qe,Be,Ze,et,At,wt,_t,Ot,Et,bt,Ut,Ct,Mt,Nt,Ft,$t,Wt,Pt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const ye=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Ue="vscode:electron-main->shared-process=disposeWorker",je=(He,tt)=>{this.onDisposeWorker(tt)};D.ipcRenderer.on(Ue,je),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,ae.registerConfiguration)(),ye.invokeFunction(Ue=>{const je=Ue.get(H.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(S.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(f.LanguagePackCachedDataCleaner),ye.createInstance(u.UnusedWorkspaceStorageDataCleaner),ye.createInstance(y.LogsDataCleaner),ye.createInstance(v.LocalizationsUpdater),ye.createInstance(p.ExtensionsCleaner),ye.createInstance($t.UserDataProfilesCleaner)))}async initServices(){const ye=new j.ServiceCollection,Ue={_serviceBrand:void 0,...x.default};ye.set(G.IProductService,Ue);const je=new C.StaticRouter(Ye=>Ye==="main"),He=new K.MessagePortMainProcessService(this.server,je);ye.set(X.IMainProcessService,He);const tt=this.configuration.policiesData?new Ut.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new Ct.NullPolicyService;ye.set(Ct.IPolicyService,tt);const xe=new h.SharedProcessEnvironmentService(this.configuration.args,Ue);ye.set(s.INativeEnvironmentService,xe);const ct=new O.LogLevelChannelClient(this.server.getChannel("logLevel",je)),it=new O.LoggerChannelClient(this.configuration.logLevel,ct.onDidChangeLogLevel,He.getChannel("logger"));ye.set(H.ILoggerService,it);const ut=this._register(new H.MultiplexLogService([this._register(new H.ConsoleLogger(this.configuration.logLevel)),this._register(it.createLogger((0,I.joinPath)(E.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new O.FollowerLogService(ct,ut));ye.set(H.ILogService,Ge),this.lifecycleService=new It.SharedProcessLifecycleService(Ge),ye.set(It.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new Fe.SharedProcessWorkerService(Ge),ye.set(ze.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new $.FileService(Ge));ye.set(U.IFileService,Qe);const ht=this._register(new Y.DiskFileSystemProvider(Ge));Qe.registerProvider(P.Schemas.file,ht);const dt=this._register(new Ze.FileUserDataProvider(P.Schemas.file,this._register(new et.DiskFileSystemProviderClient(He.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Be.isLinux})),P.Schemas.vscodeUserData,Ge));Qe.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this._register(new Mt.UserDataProfilesNativeService(this.configuration.profiles,He,xe));ye.set(Et.IUserDataProfilesService,nt);const Ke=this._register(new l.ConfigurationService(nt.defaultProfile.settingsResource,Qe,tt,Ge));ye.set(d.IConfigurationService,Ke);const ot=new Z.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},He,xe);ye.set(oe.IStorageService,ot),this._register((0,T.toDisposable)(()=>ot.flush())),await Promise.all([Ke.initialize(),ot.initialize()]),ye.set(Te.IUriIdentityService,new qe.UriIdentityService(Qe)),ye.set(ee.IRequestService,new Nt.SharedProcessRequestService(He,Ke,Ge)),ye.set(m.IChecksumService,new q.SyncDescriptor(c.ChecksumService,void 0,!1)),ye.set(wt.IV8InspectProfilingService,new q.SyncDescriptor(At.InspectProfilingService,void 0,!1));const lt=C.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(M.INativeHostService,lt),ye.set(i.IDownloadService,new q.SyncDescriptor(o.DownloadService,void 0,!0));const ft=this._register(new te.ActiveWindowManager(lt)),gt=new C.StaticRouter(Ye=>ft.getActiveClientId().then(mt=>Ye===mt));ye.set(W.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",gt)));let rt;const at=[],Rt=(0,we.isInternalTelemetry)(Ue,Ke);if((0,we.supportsTelemetry)(Ue,xe)){const Ye=new de.TelemetryLogAppender(it,xe);at.push(Ye);const{installSourcePath:mt}=xe;if(Ue.aiConfig?.ariaKey){const Lt=new Ft.OneDataSystemAppender(Rt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>Lt.flush())),at.push(Lt)}rt=new ve.TelemetryService({appenders:at,commonProperties:(0,ie.resolveCommonProperties)(Qe,(0,t.release)(),(0,t.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Rt,mt),sendErrorTelemetry:!0,piiPaths:(0,we.getPiiPathsFromEnvironment)(xe)},Ke,Ue)}else{rt=we.NullTelemetryService;const Ye=we.NullAppender;at.push(Ye)}this.server.registerChannel("telemetryAppender",new ue.TelemetryAppenderChannel(at)),ye.set(se.ITelemetryService,rt);const jt=new Ee.CustomEndpointTelemetryService(Ke,rt,it,xe,Ue);ye.set(se.ICustomEndpointTelemetryService,jt),ye.set(bt.IExtensionsProfileScannerService,new q.SyncDescriptor(bt.ExtensionsProfileScannerService,void 0,!0)),ye.set(_t.IExtensionsScannerService,new q.SyncDescriptor(Ot.ExtensionsScannerService,void 0,!0)),ye.set(A.IExtensionSignatureVerificationService,new q.SyncDescriptor(A.ExtensionSignatureVerificationService,void 0,!0)),ye.set(N.INativeServerExtensionManagementService,new q.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ye.set(w.IExtensionGalleryService,new q.SyncDescriptor(g.ExtensionGalleryService,void 0,!0)),ye.set(w.IExtensionTipsService,new q.SyncDescriptor(_.ExtensionTipsService,void 0,!1)),ye.set(ce.ILanguagePackService,new q.SyncDescriptor(B.NativeLanguagePackService,void 0,!1)),ye.set(n.IDiagnosticsService,new q.SyncDescriptor(r.DiagnosticsService,void 0,!1)),ye.set(fe.IUserDataSyncAccountService,new q.SyncDescriptor(fe.UserDataSyncAccountService,void 0,!0)),ye.set(ae.IUserDataSyncLogService,new q.SyncDescriptor(Ie.UserDataSyncLogService,void 0,!0)),ye.set(ae.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(w.IGlobalExtensionEnablementService,new q.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),ye.set(Je.IIgnoredExtensionsManagementService,new q.SyncDescriptor(Je.IgnoredExtensionsManagementService,void 0,!0)),ye.set(Ve.IExtensionStorageService,new q.SyncDescriptor(Ve.ExtensionStorageService)),ye.set(ae.IUserDataSyncStoreManagementService,new q.SyncDescriptor(Me.UserDataSyncStoreManagementService,void 0,!0)),ye.set(ae.IUserDataSyncStoreService,new q.SyncDescriptor(Me.UserDataSyncStoreService,void 0,!0)),ye.set(Le.IUserDataSyncMachinesService,new q.SyncDescriptor(Le.UserDataSyncMachinesService,void 0,!0)),ye.set(ae.IUserDataSyncBackupStoreService,new q.SyncDescriptor(ge.UserDataSyncBackupStoreService,void 0,!1)),ye.set(ae.IUserDataSyncEnablementService,new q.SyncDescriptor(Re.UserDataSyncEnablementService,void 0,!0)),ye.set(ae.IUserDataSyncService,new q.SyncDescriptor(Ne.UserDataSyncService,void 0,!1)),ye.set(Ae.IUserDataSyncProfilesStorageService,new q.SyncDescriptor(ke.UserDataSyncProfilesStorageService,void 0,!0));const kt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,xe,Ge);return kt.initialize(),ye.set(Oe.ILocalPtyService,this._register(kt)),ye.set(le.ISignService,new q.SyncDescriptor(he.SignService,void 0,!1)),ye.set(me.ISharedTunnelsService,new q.SyncDescriptor(Se.SharedTunnelsService)),ye.set(Ce.ISharedProcessTunnelService,new q.SyncDescriptor(De.SharedProcessTunnelService)),ye.set(Pt.IRemoteTunnelService,new q.SyncDescriptor(Wt.RemoteTunnelService)),new z.InstantiationService(ye)}initChannels(ye){const Ue=new O.LogLevelChannel(ye.get(H.ILogService),ye.get(H.ILoggerService));this.server.registerChannel("logLevel",Ue);const je=new F.ExtensionManagementChannel(ye.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",je);const He=C.ProxyChannel.fromService(ye.get(ce.ILanguagePackService));this.server.registerChannel("languagePacks",He);const tt=C.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",tt);const xe=new F.ExtensionTipsChannel(ye.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",xe);const ct=C.ProxyChannel.fromService(ye.get(m.IChecksumService));this.server.registerChannel("checksum",ct);const it=C.ProxyChannel.fromService(ye.get(wt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",it);const ut=new be.UserDataSyncMachinesServiceChannel(ye.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ut);const Ge=C.ProxyChannel.fromService(ye.get(se.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ge);const Qe=new be.UserDataSyncAccountServiceChannel(ye.get(fe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Qe);const ht=new be.UserDataSyncStoreManagementServiceChannel(ye.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ht);const dt=new _e.UserDataSyncChannel(ye.get(ae.IUserDataSyncService),ye.get(Et.IUserDataProfilesService),ye.get(H.ILogService));this.server.registerChannel("userDataSync",dt);const nt=this._register(ye.get(V.IInstantiationService).createInstance(We.UserDataAutoSyncService)),Ke=new be.UserDataAutoSyncChannel(nt);this.server.registerChannel("userDataAutoSync",Ke);const ot=ye.get(Oe.ILocalPtyService),lt=C.ProxyChannel.fromService(ot);this.server.registerChannel(Pe.TerminalIpcChannels.LocalPty,lt);const ft=C.ProxyChannel.fromService(ye.get(Ce.ISharedProcessTunnelService));this.server.registerChannel(Ce.ipcSharedProcessTunnelChannelName,ft);const gt=C.ProxyChannel.fromService(ye.get(ze.ISharedProcessWorkerService));this.server.registerChannel(ze.ipcSharedProcessWorkerChannelName,gt);const rt=C.ProxyChannel.fromService(ye.get(Pt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",rt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,L.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Ue=>{const je=(0,R.toErrorMessage)(Ue,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function qt(Dt){const ye=new zt(Dt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=qt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/504c5a768a001b2099dd2b44e9dc39e10ccdfb56/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
