/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/common/profiling","vs/platform/profiling/common/profilingModel","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ee=function(z){for(var e=[],I=0,t=z.length;I<t;I++)e[I]=Z[z[I]];return e};define(Z[119],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function I(D){return D?D.replace(/\$\((.*?)\)/g,(P,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(P,w,S){this.id=P,this.definition=w,this.description=S,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,P){const w=["codicon","codicon-"+D];return P&&w.push("codicon-modifier-"+P),w}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function w(C){if(C instanceof t)return["codicon","codicon-"+C.id];const b=P.exec(C.id);if(!b)return w(t.error);const[,u,g]=b,h=["codicon","codicon-"+u];return g&&h.push("codicon-modifier-"+g.substr(1)),h}D.asClassNameArray=w;function S(C){return w(C).join(" ")}D.asClassName=S;function E(C){return"."+w(C).join(".")}D.asCSSSelector=E})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Z[120],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(P,w){const S=Math.pow(10,w);return Math.round(P*S)/S}class t{constructor(w,S,E,C=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,w))|0,this.g=Math.min(255,Math.max(0,S))|0,this.b=Math.min(255,Math.max(0,E))|0,this.a=I(Math.max(Math.min(1,C),0),3)}static equals(w,S){return w.r===S.r&&w.g===S.g&&w.b===S.b&&w.a===S.a}}e.RGBA=t;class k{constructor(w,S,E,C){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=I(Math.max(Math.min(1,S),0),3),this.l=I(Math.max(Math.min(1,E),0),3),this.a=I(Math.max(Math.min(1,C),0),3)}static equals(w,S){return w.h===S.h&&w.s===S.s&&w.l===S.l&&w.a===S.a}static fromRGBA(w){const S=w.r/255,E=w.g/255,C=w.b/255,b=w.a,u=Math.max(S,E,C),g=Math.min(S,E,C);let h=0,p=0;const d=(g+u)/2,v=u-g;if(v>0){switch(p=Math.min(d<=.5?v/(2*d):v/(2-2*d),1),u){case S:h=(E-C)/v+(E<C?6:0);break;case E:h=(C-S)/v+2;break;case C:h=(S-E)/v+4;break}h*=60,h=Math.round(h)}return new k(h,p,d,b)}static _hue2rgb(w,S,E){return E<0&&(E+=1),E>1&&(E-=1),E<1/6?w+(S-w)*6*E:E<1/2?S:E<2/3?w+(S-w)*(2/3-E)*6:w}static toRGBA(w){const S=w.h/360,{s:E,l:C,a:b}=w;let u,g,h;if(E===0)u=g=h=C;else{const p=C<.5?C*(1+E):C+E-C*E,d=2*C-p;u=k._hue2rgb(d,p,S+1/3),g=k._hue2rgb(d,p,S),h=k._hue2rgb(d,p,S-1/3)}return new t(Math.round(u*255),Math.round(g*255),Math.round(h*255),b)}}e.HSLA=k;class R{constructor(w,S,E,C){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=I(Math.max(Math.min(1,S),0),3),this.v=I(Math.max(Math.min(1,E),0),3),this.a=I(Math.max(Math.min(1,C),0),3)}static equals(w,S){return w.h===S.h&&w.s===S.s&&w.v===S.v&&w.a===S.a}static fromRGBA(w){const S=w.r/255,E=w.g/255,C=w.b/255,b=Math.max(S,E,C),u=Math.min(S,E,C),g=b-u,h=b===0?0:g/b;let p;return g===0?p=0:b===S?p=((E-C)/g%6+6)%6:b===E?p=(C-S)/g+2:p=(S-E)/g+4,new R(Math.round(p*60),h,b,w.a)}static toRGBA(w){const{h:S,s:E,v:C,a:b}=w,u=C*E,g=u*(1-Math.abs(S/60%2-1)),h=C-u;let[p,d,v]=[0,0,0];return S<60?(p=u,d=g):S<120?(p=g,d=u):S<180?(d=u,v=g):S<240?(d=g,v=u):S<300?(p=g,v=u):S<=360&&(p=u,v=g),p=Math.round((p+h)*255),d=Math.round((d+h)*255),v=Math.round((v+h)*255),new t(p,d,v,b)}}e.HSVA=R;class D{static fromHex(w){return D.Format.CSS.parseHex(w)||D.red}static equals(w,S){return!w&&!S?!0:!w||!S?!1:w.equals(S)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(w){if(w)if(w instanceof t)this.rgba=w;else if(w instanceof k)this._hsla=w,this.rgba=k.toRGBA(w);else if(w instanceof R)this._hsva=w,this.rgba=R.toRGBA(w);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(w){return!!w&&t.equals(this.rgba,w.rgba)&&k.equals(this.hsla,w.hsla)&&R.equals(this.hsva,w.hsva)}getRelativeLuminance(){const w=D._relativeLuminanceForComponent(this.rgba.r),S=D._relativeLuminanceForComponent(this.rgba.g),E=D._relativeLuminanceForComponent(this.rgba.b),C=.2126*w+.7152*S+.0722*E;return I(C,4)}static _relativeLuminanceForComponent(w){const S=w/255;return S<=.03928?S/12.92:Math.pow((S+.055)/1.055,2.4)}getContrastRatio(w){const S=this.getRelativeLuminance(),E=w.getRelativeLuminance();return S>E?(S+.05)/(E+.05):(E+.05)/(S+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(w){const S=this.getRelativeLuminance(),E=w.getRelativeLuminance();return S>E}isDarkerThan(w){const S=this.getRelativeLuminance(),E=w.getRelativeLuminance();return S<E}lighten(w){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*w,this.hsla.a))}darken(w){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*w,this.hsla.a))}transparent(w){const{r:S,g:E,b:C,a:b}=this.rgba;return new D(new t(S,E,C,b*w))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(w){const S=w.rgba,E=this.rgba.a,C=S.a,b=E+C*(1-E);if(b<1e-6)return D.transparent;const u=this.rgba.r*E/b+S.r*C*(1-E)/b,g=this.rgba.g*E/b+S.g*C*(1-E)/b,h=this.rgba.b*E/b+S.b*C*(1-E)/b;return new D(new t(u,g,h,b))}makeOpaque(w){if(this.isOpaque()||w.rgba.a!==1)return this;const{r:S,g:E,b:C,a:b}=this.rgba;return new D(new t(w.rgba.r-b*(w.rgba.r-S),w.rgba.g-b*(w.rgba.g-E),w.rgba.b-b*(w.rgba.b-C),1))}flatten(...w){const S=w.reduceRight((E,C)=>D._flatten(C,E));return D._flatten(this,S)}static _flatten(w,S){const E=1-w.rgba.a;return new D(new t(E*S.rgba.r+w.rgba.a*w.rgba.r,E*S.rgba.g+w.rgba.a*w.rgba.g,E*S.rgba.b+w.rgba.a*w.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(w,S,E){if(w.isLighterThan(S))return w;E=E||.5;const C=w.getRelativeLuminance(),b=S.getRelativeLuminance();return E=E*(b-C)/b,w.lighten(E)}static getDarkerColor(w,S,E){if(w.isDarkerThan(S))return w;E=E||.5;const C=w.getRelativeLuminance(),b=S.getRelativeLuminance();return E=E*(C-b)/C,w.darken(E)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(P){let w;(function(S){let E;(function(C){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:P.Format.CSS.formatRGBA(n)}C.formatRGB=b;function u(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}C.formatRGBA=u;function g(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(n)}C.formatHSL=g;function h(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}C.formatHSLA=h;function p(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function d(n){return`#${p(n.rgba.r)}${p(n.rgba.g)}${p(n.rgba.b)}`}C.formatHex=d;function v(n,s=!1){return s&&n.rgba.a===1?P.Format.CSS.formatHex(n):`#${p(n.rgba.r)}${p(n.rgba.g)}${p(n.rgba.b)}${p(Math.round(n.rgba.a*255))}`}C.formatHexA=v;function m(n){return n.isOpaque()?P.Format.CSS.formatHex(n):P.Format.CSS.formatRGBA(n)}C.format=m;function f(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),o=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),r=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new P(new t(i,o,r,1))}if(s===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),o=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),r=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),l=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new P(new t(i,o,r,l/255))}if(s===4){const i=c(n.charCodeAt(1)),o=c(n.charCodeAt(2)),r=c(n.charCodeAt(3));return new P(new t(16*i+i,16*o+o,16*r+r))}if(s===5){const i=c(n.charCodeAt(1)),o=c(n.charCodeAt(2)),r=c(n.charCodeAt(3)),l=c(n.charCodeAt(4));return new P(new t(16*i+i,16*o+o,16*r+r,(16*l+l)/255))}return null}C.parseHex=f;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(E=S.CSS||(S.CSS={}))})(w=P.Format||(P.Format={}))}(D=e.Color||(e.Color={}))}),define(Z[53],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function I(D){return(P,w,S)=>{let E=null,C=null;if(typeof S.value=="function"?(E="value",C=S.value):typeof S.get=="function"&&(E="get",C=S.get),!C)throw new Error("not supported");S[E]=D(C,w)}}e.createDecorator=I;function t(D,P,w){let S=null,E=null;if(typeof w.value=="function"?(S="value",E=w.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(S="get",E=w.get),!E)throw new Error("not supported");const C=`$memoize$${P}`;w[S]=function(...b){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,b)}),this[C]}}e.memoize=t;function k(D,P,w){return I((S,E)=>{const C=`$debounce$${E}`,b=`$debounce$result$${E}`;return function(...u){this[b]||(this[b]=w?w():void 0),clearTimeout(this[C]),P&&(this[b]=P(this[b],...u),u=[this[b]]),this[C]=setTimeout(()=>{S.apply(this,u),this[b]=w?w():void 0},D)}})}e.debounce=k;function R(D,P,w){return I((S,E)=>{const C=`$throttle$timer$${E}`,b=`$throttle$result$${E}`,u=`$throttle$lastRun$${E}`,g=`$throttle$pending$${E}`;return function(...h){if(this[b]||(this[b]=w?w():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...h)),this[g])return;const p=this[u]+D;p<=Date.now()?(this[u]=Date.now(),S.apply(this,[this[b]]),this[b]=w?w():void 0):(this[g]=!0,this[C]=setTimeout(()=>{this[g]=!1,this[u]=Date.now(),S.apply(this,[this[b]]),this[b]=w?w():void 0},p-Date.now()))}})}e.throttle=R}),define(Z[16],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=I,e.errorHandler=new I;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:n,message:s}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:s,stack:i,noTelemetry:m.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const P="Canceled";function w(c){return c instanceof S?!0:c instanceof Error&&c.name===P&&c.message===P}e.isCancellationError=w;class S extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=S;function E(){const c=new Error(P);return c.name=c.message,c}e.canceled=E;function C(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=C;function b(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=b;function u(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function g(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=g;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=p;class d extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=d;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const s=new m;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class f extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(Z[24],ee([0,1,16]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,re=0){return j[j.length-(1+re)]}e.tail=t;function k(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=k;function R(j,re,ne=(ce,ge)=>ce===ge){if(j===re)return!0;if(!j||!re||j.length!==re.length)return!1;for(let ce=0,ge=j.length;ce<ge;ce++)if(!ne(j[ce],re[ce]))return!1;return!0}e.equals=R;function D(j,re){const ne=j.length-1;re<ne&&(j[re]=j[ne]),j.pop()}e.removeFastWithoutKeepingOrder=D;function P(j,re,ne){return w(j.length,ce=>ne(j[ce],re))}e.binarySearch=P;function w(j,re){let ne=0,ce=j-1;for(;ne<=ce;){const ge=(ne+ce)/2|0,Re=re(ge);if(Re<0)ne=ge+1;else if(Re>0)ce=ge-1;else return ge}return-(ne+1)}e.binarySearch2=w;function S(j,re){let ne=0,ce=j.length;if(ce===0)return 0;for(;ne<ce;){const ge=Math.floor((ne+ce)/2);re(j[ge])?ce=ge:ne=ge+1}return ne}e.findFirstInSorted=S;function E(j,re,ne){if(j=j|0,j>=re.length)throw new TypeError("invalid index");const ce=re[Math.floor(re.length*Math.random())],ge=[],Re=[],Te=[];for(const Me of re){const Ae=ne(Me,ce);Ae<0?ge.push(Me):Ae>0?Re.push(Me):Te.push(Me)}return j<ge.length?E(j,ge,ne):j<ge.length+Te.length?Te[0]:E(j-(ge.length+Te.length),Re,ne)}e.quickSelect=E;function C(j,re){const ne=[];let ce;for(const ge of j.slice(0).sort(re))!ce||re(ce[0],ge)!==0?(ce=[ge],ne.push(ce)):ce.push(ge);return ne}e.groupBy=C;function b(j,re,ne){const ce=[];function ge(Me,Ae,ve){if(Ae===0&&ve.length===0)return;const pe=ce[ce.length-1];pe&&pe.start+pe.deleteCount===Me?(pe.deleteCount+=Ae,pe.toInsert.push(...ve)):ce.push({start:Me,deleteCount:Ae,toInsert:ve})}let Re=0,Te=0;for(;;){if(Re===j.length){ge(Re,0,re.slice(Te));break}if(Te===re.length){ge(Re,j.length-Re,[]);break}const Me=j[Re],Ae=re[Te],ve=ne(Me,Ae);ve===0?(Re+=1,Te+=1):ve<0?(ge(Re,1,[]),Re+=1):ve>0&&(ge(Re,0,[Ae]),Te+=1)}return ce}e.sortedDiff=b;function u(j,re,ne){const ce=b(j,re,ne),ge=[],Re=[];for(const Te of ce)ge.push(...j.slice(Te.start,Te.start+Te.deleteCount)),Re.push(...Te.toInsert);return{removed:ge,added:Re}}e.delta=u;function g(j,re,ne){if(ne===0)return[];const ce=j.slice(0,ne).sort(re);return p(j,re,ce,ne,j.length),ce}e.top=g;function h(j,re,ne,ce,ge){return ne===0?Promise.resolve([]):new Promise((Re,Te)=>{(async()=>{const Me=j.length,Ae=j.slice(0,ne).sort(re);for(let ve=ne,pe=Math.min(ne+ce,Me);ve<Me;ve=pe,pe=Math.min(pe+ce,Me)){if(ve>ne&&await new Promise(Se=>setTimeout(Se)),ge&&ge.isCancellationRequested)throw new I.CancellationError;p(j,re,Ae,ve,pe)}return Ae})().then(Re,Te)})}e.topAsync=h;function p(j,re,ne,ce,ge){for(const Re=ne.length;ce<ge;ce++){const Te=j[ce];if(re(Te,ne[Re-1])<0){ne.pop();const Me=S(ne,Ae=>re(Te,Ae)<0);ne.splice(Me,0,Te)}}}function d(j){return j.filter(re=>!!re)}e.coalesce=d;function v(j){let re=0;for(let ne=0;ne<j.length;ne++)j[ne]&&(j[re]=j[ne],re+=1);j.length=re}e.coalesceInPlace=v;function m(j,re,ne){j.splice(ne,0,j.splice(re,1)[0])}e.move=m;function f(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=f;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function n(j,re=ne=>ne){const ne=new Set;return j.filter(ce=>{const ge=re(ce);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=n;function s(j){const re=new Set;return ne=>{const ce=j(ne);return re.has(ce)?!1:(re.add(ce),!0)}}e.uniqueFilter=s;function i(j,re){const ne=o(j,re);if(ne!==-1)return j[ne]}e.findLast=i;function o(j,re){for(let ne=j.length-1;ne>=0;ne--){const ce=j[ne];if(re(ce))return ne}return-1}e.lastIndex=o;function r(j,re){return j.length>0?j[0]:re}e.firstOrDefault=r;function l(j,re){return j.length>0?j[j.length-1]:re}e.lastOrDefault=l;function a(j,re,ne=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,Re=Math.min(j.length,re.length);ge<Re&&ne(j[ge],re[ge]);ge++)ce++;return ce}e.commonPrefixLength=a;function y(j){return[].concat(...j)}e.flatten=y;function M(j,re){let ne=typeof re=="number"?j:0;typeof re=="number"?ne=j:(ne=0,re=j);const ce=[];if(ne<=re)for(let ge=ne;ge<re;ge++)ce.push(ge);else for(let ge=ne;ge>re;ge--)ce.push(ge);return ce}e.range=M;function T(j,re,ne){return j.reduce((ce,ge)=>(ce[re(ge)]=ne?ne(ge):ge,ce),Object.create(null))}e.index=T;function N(j,re){return j.push(re),()=>G(j,re)}e.insert=N;function G(j,re){const ne=j.indexOf(re);if(ne>-1)return j.splice(ne,1),re}e.remove=G;function ae(j,re,ne){const ce=j.slice(0,re),ge=j.slice(re);return ce.concat(ne,ge)}e.arrayInsert=ae;function X(j,re){let ne;if(typeof re=="number"){let ce=re;ne=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ce=j.length-1;ce>0;ce-=1){const ge=Math.floor(ne()*(ce+1)),Re=j[ce];j[ce]=j[ge],j[ge]=Re}}e.shuffle=X;function Q(j,re){const ne=j.indexOf(re);ne>-1&&(j.splice(ne,1),j.unshift(re))}e.pushToStart=Q;function ie(j,re){const ne=j.indexOf(re);ne>-1&&(j.splice(ne,1),j.push(re))}e.pushToEnd=ie;function oe(j,re){for(const ne of re)j.push(ne)}e.pushMany=oe;function he(j,re){return Array.isArray(j)?j.map(re):re(j)}e.mapArrayOrNot=he;function V(j){return Array.isArray(j)?j:[j]}e.asArray=V;function q(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=q;function F(j,re){for(const ne of j){const ce=re(ne);if(ce!==void 0)return ce}}e.mapFind=F;function A(j,re,ne){const ce=U(j,re),ge=j.length,Re=ne.length;j.length=ge+Re;for(let Te=ge-1;Te>=ce;Te--)j[Te+Re]=j[Te];for(let Te=0;Te<Re;Te++)j[Te+ce]=ne[Te]}e.insertInto=A;function W(j,re,ne,ce){const ge=U(j,re),Re=j.splice(ge,ne);return A(j,ge,ce),Re}e.splice=W;function U(j,re){return re<0?Math.max(re+j.length,0):Math.min(re,j.length)}var J;(function(j){function re(ge){return ge<0}j.isLessThan=re;function ne(ge){return ge>0}j.isGreaterThan=ne;function ce(ge){return ge===0}j.isNeitherLessOrGreaterThan=ce,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function B(j,re){return(ne,ce)=>re(j(ne),j(ce))}e.compareBy=B;function $(...j){return(re,ne)=>{for(const ce of j){const ge=ce(re,ne);if(!J.isNeitherLessOrGreaterThan(ge))return ge}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(j,re)=>j-re;e.numberComparator=L;function O(j,re){if(j.length===0)return;let ne=j[0];for(let ce=1;ce<j.length;ce++){const ge=j[ce];re(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function _(j,re){if(j.length===0)return;let ne=j[0];for(let ce=1;ce<j.length;ce++){const ge=j[ce];re(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=_;function H(j,re){return O(j,(ne,ce)=>-re(ne,ce))}e.findMinBy=H;class Y{constructor(re){this.items=re,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(re){let ne=this.firstIdx;for(;ne<this.items.length&&re(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(re){let ne=this.lastIdx;for(;ne>=0&&re(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const re=this.items[this.firstIdx];return this.firstIdx++,re}removeLast(){const re=this.items[this.lastIdx];return this.lastIdx--,re}takeCount(re){const ne=this.items.slice(this.firstIdx,this.firstIdx+re);return this.firstIdx+=re,ne}}e.ArrayQueue=Y;class se{constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new se(ne=>this.iterate(ce=>re(ce)?ne(ce):!0))}map(re){return new se(ne=>this.iterate(ce=>ne(re(ce))))}some(re){let ne=!1;return this.iterate(ce=>(ne=re(ce),!ne)),ne}findFirst(re){let ne;return this.iterate(ce=>re(ce)?(ne=ce,!1):!0),ne}findLast(re){let ne;return this.iterate(ce=>(re(ce)&&(ne=ce),!0)),ne}findLastMaxBy(re){let ne,ce=!0;return this.iterate(ge=>((ce||J.isGreaterThan(re(ge,ne)))&&(ce=!1,ne=ge),!0)),ne}}e.CallbackIterable=se,se.empty=new se(j=>{})}),define(Z[121],ee([0,1,16]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,S){if(!w)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=t;function k(w,S="Unreachable"){throw new Error(S)}e.assertNever=k;function R(w){if(!w)throw new I.BugIndicatingError("Assertion Failed")}e.assert=R;function D(w){if(!w()){debugger;w(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(w,S){let E=0;for(;E<w.length-1;){const C=w[E],b=w[E+1];if(!S(C,b))return!1;E++}return!0}e.checkAdjacentItems=P}),define(Z[49],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=I}),define(Z[57],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*P(f){yield f}t.single=P;function w(f){return k(f)?f:P(f)}t.wrap=w;function S(f){return f||R}t.from=S;function E(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=E;function C(f){return f[Symbol.iterator]().next().value}t.first=C;function b(f,c){for(const n of f)if(c(n))return!0;return!1}t.some=b;function u(f,c){for(const n of f)if(c(n))return n}t.find=u;function*g(f,c){for(const n of f)c(n)&&(yield n)}t.filter=g;function*h(f,c){let n=0;for(const s of f)yield c(s,n++)}t.map=h;function*p(...f){for(const c of f)for(const n of c)yield n}t.concat=p;function d(f,c,n){let s=n;for(const i of f)s=c(s,i);return s}t.reduce=d;function*v(f,c,n=f.length){for(c<0&&(c+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);c<n;c++)yield f[c]}t.slice=v;function m(f,c=Number.POSITIVE_INFINITY){const n=[];if(c===0)return[n,f];const s=f[Symbol.iterator]();for(let i=0;i<c;i++){const o=s.next();if(o.done)return[n,t.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}t.consume=m})(I=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(n,s=!1){let i=0;const o=n.length;let r="",l=0,a=16,y=0;function M(ie){let oe=0,he=0;for(;oe<ie;){const V=n.charCodeAt(i);if(V>=48&&V<=57)he=he*16+V-48;else if(V>=65&&V<=70)he=he*16+V-65+10;else if(V>=97&&V<=102)he=he*16+V-97+10;else break;i++,oe++}return oe<ie&&(he=-1),he}function T(ie){i=ie,r="",l=0,a=16,y=0}function N(){const ie=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&S(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&S(n.charCodeAt(i)))for(i++;i<n.length&&S(n.charCodeAt(i));)i++;else return y=3,n.substring(ie,i);let oe=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&S(n.charCodeAt(i))){for(i++;i<n.length&&S(n.charCodeAt(i));)i++;oe=i}else y=3;return n.substring(ie,oe)}function G(){let ie="",oe=i;for(;;){if(i>=o){ie+=n.substring(oe,i),y=2;break}const he=n.charCodeAt(i);if(he===34){ie+=n.substring(oe,i),i++;break}if(he===92){if(ie+=n.substring(oe,i),i++,i>=o){y=2;break}switch(n.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const q=M(4);q>=0?ie+=String.fromCharCode(q):y=4;break}default:y=5}oe=i;continue}if(he>=0&&he<=31)if(w(he)){ie+=n.substring(oe,i),y=2;break}else y=6;i++}return ie}function ae(){if(r="",y=0,l=i,i>=o)return l=o,a=17;let ie=n.charCodeAt(i);if(P(ie)){do i++,r+=String.fromCharCode(ie),ie=n.charCodeAt(i);while(P(ie));return a=15}if(w(ie))return i++,r+=String.fromCharCode(ie),ie===13&&n.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(ie){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=G(),a=10;case 47:{const oe=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!w(n.charCodeAt(i));)i++;return r=n.substring(oe,i),a=12}if(n.charCodeAt(i+1)===42){i+=2;const he=o-1;let V=!1;for(;i<he;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,y=1),r=n.substring(oe,i),a=13}return r+=String.fromCharCode(ie),i++,a=16}case 45:if(r+=String.fromCharCode(ie),i++,i===o||!S(n.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),a=11;default:for(;i<o&&X(ie);)i++,ie=n.charCodeAt(i);if(l!==i){switch(r=n.substring(l,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(ie),i++,a=16}}function X(ie){if(P(ie)||w(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let ie;do ie=ae();while(ie>=12&&ie<=15);return ie}return{setPosition:T,getPosition:()=>i,scan:s?Q:ae,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>y}}e.createScanner=D;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var E;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(E||(E={}));function C(n,s){const i=[],o=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(M,T,N,G){l.value=M,l.offset=T,l.length=N,l.type=G,l.colonOffset=void 0,r=l}try{m(n,{onObjectBegin:(M,T)=>{if(s<=M)throw o;r=void 0,a=s>M,i.push("")},onObjectProperty:(M,T,N)=>{if(s<T||(y(M,T,N,"property"),i[i.length-1]=M,s<=T+N))throw o},onObjectEnd:(M,T)=>{if(s<=M)throw o;r=void 0,i.pop()},onArrayBegin:(M,T)=>{if(s<=M)throw o;r=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(s<=M)throw o;r=void 0,i.pop()},onLiteralValue:(M,T,N)=>{if(s<T||(y(M,T,N,c(M)),s<=T+N))throw o},onSeparator:(M,T,N)=>{if(s<=T)throw o;if(M===":"&&r&&r.type==="property")r.colonOffset=T,a=!1,r=void 0;else if(M===","){const G=i[i.length-1];typeof G=="number"?i[i.length-1]=G+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(M){if(M!==o)throw M}return{path:i,previousNode:r,isAtPropertyKey:a,matches:M=>{let T=0;for(let N=0;T<M.length&&N<i.length;N++)if(M[T]===i[N]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=C;function b(n,s=[],i=R.DEFAULT){let o=null,r=[];const l=[];function a(M){Array.isArray(r)?r.push(M):o!==null&&(r[o]=M)}return m(n,{onObjectBegin:()=>{const M={};a(M),l.push(r),r=M,o=null},onObjectProperty:M=>{o=M},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const M=[];a(M),l.push(r),r=M,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:a,onError:(M,T,N)=>{s.push({error:M,offset:T,length:N})}},i),r[0]}e.parse=b;function u(n,s=[],i=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(M){o.type==="property"&&(o.length=M-o.offset,o=o.parent)}function l(M){return o.children.push(M),M}m(n,{onObjectBegin:M=>{o=l({type:"object",offset:M,length:-1,parent:o,children:[]})},onObjectProperty:(M,T,N)=>{o=l({type:"property",offset:T,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:M,offset:T,length:N,parent:o})},onObjectEnd:(M,T)=>{o.length=M+T-o.offset,o=o.parent,r(M+T)},onArrayBegin:(M,T)=>{o=l({type:"array",offset:M,length:-1,parent:o,children:[]})},onArrayEnd:(M,T)=>{o.length=M+T-o.offset,o=o.parent,r(M+T)},onLiteralValue:(M,T,N)=>{l({type:c(M),offset:T,length:N,parent:o,value:M}),r(T+N)},onSeparator:(M,T,N)=>{o.type==="property"&&(M===":"?o.colonOffset=T:M===","&&r(T))},onError:(M,T,N)=>{s.push({error:M,offset:T,length:N})}},i);const y=o.children[0];return y&&delete y.parent,y}e.parseTree=u;function g(n,s){if(!n)return;let i=n;for(const o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===o){i=l.children[1],r=!0;break}if(!r)return}else{const r=o;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=g;function h(n){if(!n.parent||!n.parent.children)return[];const s=h(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;s.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&s.push(i)}return s}e.getNodePath=h;function p(n){switch(n.type){case"array":return n.children.map(p);case"object":{const s=Object.create(null);for(const i of n.children){const o=i.children[1];o&&(s[i.children[0].value]=p(o))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=p;function d(n,s,i=!1){return s>=n.offset&&s<n.offset+n.length||i&&s===n.offset+n.length}e.contains=d;function v(n,s,i=!1){if(d(n,s,i)){const o=n.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=s;r++){const l=v(o[r],s,i);if(l)return l}return n}}e.findNodeAtOffset=v;function m(n,s,i=R.DEFAULT){const o=D(n,!1);function r(B){return B?()=>B(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(B){return B?$=>B($,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),y=l(s.onObjectProperty),M=r(s.onObjectEnd),T=r(s.onArrayBegin),N=r(s.onArrayEnd),G=l(s.onLiteralValue),ae=l(s.onSeparator),X=r(s.onComment),Q=l(s.onError),ie=i&&i.disallowComments,oe=i&&i.allowTrailingComma;function he(){for(;;){const B=o.scan();switch(o.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:ie||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(B){case 12:case 13:ie?V(10):X();break;case 16:V(1);break;case 15:case 14:break;default:return B}}}function V(B,$=[],L=[]){if(Q(B),$.length+L.length>0){let O=o.getToken();for(;O!==17;){if($.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function q(B){const $=o.getTokenValue();return B?G($):y($),he(),!0}function F(){switch(o.getToken()){case 11:{let B=0;try{B=JSON.parse(o.getTokenValue()),typeof B!="number"&&(V(2),B=0)}catch{V(2)}G(B);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return he(),!0}function A(){return o.getToken()!==10?(V(3,[],[2,5]),!1):(q(!1),o.getToken()===6?(ae(":"),he(),J()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function W(){a(),he();let B=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(B||V(4,[],[]),ae(","),he(),o.getToken()===2&&oe)break}else B&&V(6,[],[]);A()||V(4,[],[2,5]),B=!0}return M(),o.getToken()!==2?V(7,[2],[]):he(),!0}function U(){T(),he();let B=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(B||V(4,[],[]),ae(","),he(),o.getToken()===4&&oe)break}else B&&V(6,[],[]);J()||V(4,[],[4,5]),B=!0}return N(),o.getToken()!==4?V(8,[4],[]):he(),!0}function J(){switch(o.getToken()){case 3:return U();case 1:return W();case 10:return q(!0);default:return F()}}return he(),o.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):J()?(o.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=m;function f(n,s){const i=D(n),o=[];let r,l=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:l!==a&&o.push(n.substring(l,a)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),l=i.getPosition();break}while(r!==17);return o.join("")}e.stripComments=f;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[122],ee([0,1,43]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(S,E,C){let b,u,g,h,p;if(E){for(h=E.offset,p=h+E.length,g=h;g>0&&!w(S,g-1);)g--;let a=p;for(;a<S.length&&!w(S,a);)a++;u=S.substring(g,a),b=D(u,C)}else u=S,b=0,g=0,h=0,p=S.length;const d=P(C,S);let v=!1,m=0,f;C.insertSpaces?f=R(" ",C.tabSize||4):f="	";const c=(0,I.createScanner)(u,!1);let n=!1;function s(){return d+R(f,b+m)}function i(){let a=c.scan();for(v=!1;a===15||a===14;)v=v||a===14,a=c.scan();return n=a===16||c.getTokenError()!==0,a}const o=[];function r(a,y,M){!n&&y<p&&M>h&&S.substring(y,M)!==a&&o.push({offset:y,length:M-y,content:a})}let l=i();if(l!==17){const a=c.getTokenOffset()+g,y=R(f,b);r(y,g,a)}for(;l!==17;){let a=c.getTokenOffset()+c.getTokenLength()+g,y=i(),M="";for(;!v&&(y===12||y===13);){const N=c.getTokenOffset()+g;r(" ",a,N),a=c.getTokenOffset()+c.getTokenLength()+g,M=y===12?s():"",y=i()}if(y===2)l!==1&&(m--,M=s());else if(y===4)l!==3&&(m--,M=s());else{switch(l){case 3:case 1:m++,M=s();break;case 5:case 12:M=s();break;case 13:v?M=s():M=" ";break;case 6:M=" ";break;case 10:if(y===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?M=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}v&&(y===12||y===13)&&(M=s())}const T=c.getTokenOffset()+g;r(M,a,T),l=y}return o}e.format=t;function k(S,E){const C=JSON.stringify(S,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?C.replace(/\r\n|\r|\n/g,E.eol):C}e.toFormattedString=k;function R(S,E){let C="";for(let b=0;b<E;b++)C+=S;return C}function D(S,E){let C=0,b=0;const u=E.tabSize||4;for(;C<S.length;){const g=S.charAt(C);if(g===" ")b++;else if(g==="	")b+=u;else break;C++}return Math.floor(b/u)}function P(S,E){for(let C=0;C<E.length;C++){const b=E.charAt(C);if(b==="\r")return C+1<E.length&&E.charAt(C+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function w(S,E){return`\r
`.indexOf(S.charAt(E))!==-1}e.isEOL=w}),define(Z[123],ee([0,1,43,122]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(S,E,C){return R(S,E,void 0,C)}e.removeProperty=k;function R(S,E,C,b,u){const g=E.slice(),h=[],p=(0,I.parseTree)(S,h);let d,v;for(;g.length>0&&(v=g.pop(),d=(0,I.findNodeAtLocation)(p,g),d===void 0&&C!==void 0);)typeof v=="string"?C={[v]:C}:C=[C];if(d)if(d.type==="object"&&typeof v=="string"&&Array.isArray(d.children)){const m=(0,I.findNodeAtLocation)(d,[v]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const f=d.children.indexOf(m.parent);let c,n=m.parent.offset+m.parent.length;if(f>0){const s=d.children[f-1];c=s.offset+s.length}else c=d.offset+1,d.children.length>1&&(n=d.children[1].offset);return D(S,{offset:c,length:n-c,content:""},b)}else return D(S,{offset:m.offset,length:m.length,content:JSON.stringify(C)},b);else{if(C===void 0)return[];const f=`${JSON.stringify(v)}: ${JSON.stringify(C)}`,c=u?u(d.children.map(s=>s.children[0].value)):d.children.length;let n;if(c>0){const s=d.children[c-1];n={offset:s.offset+s.length,length:0,content:","+f}}else d.children.length===0?n={offset:d.offset+1,length:0,content:f}:n={offset:d.offset+1,length:0,content:f+","};return D(S,n,b)}}else if(d.type==="array"&&typeof v=="number"&&Array.isArray(d.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let f;if(d.children.length===0||v===0)f={offset:d.offset+1,length:0,content:d.children.length===0?m:m+","};else{const c=v===-1||v>d.children.length?d.children.length:v,n=d.children[c-1];f={offset:n.offset+n.length,length:0,content:","+m}}return D(S,f,b)}else{const m=v,f=d.children[m];let c;if(d.children.length===1)c={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===m){const n=d.children[m-1],s=n.offset+n.length,i=d.offset+d.length;c={offset:s,length:i-2-s,content:""}}else c={offset:f.offset,length:d.children[m+1].offset-f.offset,content:""};return D(S,c,b)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${d.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(S,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(C)},b)}}e.setProperty=R;function D(S,E,C){let b=P(S,E),u=E.offset,g=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;u>0&&!(0,t.isEOL)(b,u-1);)u--;for(;g<b.length&&!(0,t.isEOL)(b,g);)g++}const h=(0,t.format)(b,{offset:u,length:g-u},C);for(let d=h.length-1;d>=0;d--){const v=h[d];b=P(b,v),u=Math.min(u,v.offset),g=Math.max(g,v.offset+v.length),g+=v.content.length-v.length}const p=S.length-(b.length-g)-u;return[{offset:u,length:p,content:b.substring(u,g)}]}e.withFormatting=D;function P(S,E){return S.substring(0,E.offset)+E.content+S.substring(E.offset+E.length)}e.applyEdit=P;function w(S,E){const C=E.slice(0).sort((u,g)=>{const h=u.offset-g.offset;return h===0?u.length-g.length:h});let b=S.length;for(let u=C.length-1;u>=0;u--){const g=C[u];if(g.offset+g.length<=b)S=P(S,g);else throw new Error("Overlapping edit");b=g.offset}return S}e.applyEdits=w}),define(Z[124],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new I(()=>k(this.getValue()))}}e.Lazy=I}),define(Z[2],ee([0,1,49,57]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(l){R=l}if(e.setDisposableTracker=D,k){const l="__is_disposable_tracked__";D(new class{trackDisposable(a){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(y)},3e3)}setParent(a,y){if(a&&a!==v.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function P(l){return R?.trackDisposable(l),l}function w(l){R?.markAsDisposed(l)}function S(l,a){R?.setParent(l,a)}function E(l,a){if(!!R)for(const y of l)R.setParent(y,a)}function C(l){return R?.markAsSingleton(l),l}e.markAsSingleton=C;function b(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=b;function u(l){if(t.Iterable.is(l)){const a=[];for(const y of l)if(y)try{y.dispose()}catch(M){a.push(M)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=u;function g(l){for(const a of l)b(a)&&a.dispose();return[]}e.disposeIfDisposable=g;function h(...l){const a=p(()=>u(l));return E(l,a),a}e.combinedDisposable=h;function p(l){const a=P({dispose:(0,I.once)(()=>{w(a),l()})});return a}e.toDisposable=p;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new d,P(this),S(this._store,this)}dispose(){w(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&S(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&S(a,null),a}}e.MutableDisposable=m;class f{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let y=a;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,w(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(a,...y){let M=this.references.get(a);M||(M={counter:0,object:this.createReferencedObject(a,...y)},this.references.set(a,M));const{object:T}=M,N=(0,I.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(a,M.object),this.references.delete(a))});return M.counter++,{object:T,dispose:N}}}e.ReferenceCollection=n;class s{constructor(a){this.referenceCollection=a}async acquire(a,...y){const M=this.referenceCollection.acquire(a,...y);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=s;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(l){const a=new d;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=o;class r{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){w(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,y,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(a)?.dispose(),this._store.set(a,y)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(Z[95],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let R=this._first;for(;R!==I.Undefined;){const D=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=D}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const P=new I(R);if(this._first===I.Undefined)this._first=P,this._last=P;else if(D){const S=this._last;this._last=P,P.prev=S,S.next=P}else{const S=this._first;this._first=P,P.next=S,S.prev=P}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(P))}}shift(){if(this._first!==I.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==I.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===I.Undefined&&R.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):R.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):R.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(Z[39],ee([0,1]),function(z,e){"use strict";var I,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(g,h,p){let d=g.get(h);return d===void 0&&(d=p,g.set(h,d)),d}e.getOrSet=R;function D(g){const h=[];return g.forEach((p,d)=>{h.push(`${d} => ${p}`)}),`Map(${g.size}) {${h.join(", ")}}`}e.mapToString=D;function P(g){const h=[];return g.forEach(p=>{h.push(p)}),`Set(${g.size}) {${h.join(", ")}}`}e.setToString=P;class w{constructor(h,p){this.uri=h,this.value=p}}class S{constructor(h,p){this[I]="ResourceMap",h instanceof S?(this.map=new Map(h.map),this.toKey=p??S.defaultToKey):(this.map=new Map,this.toKey=h??S.defaultToKey)}set(h,p){return this.map.set(this.toKey(h),new w(h,p)),this}get(h){return this.map.get(this.toKey(h))?.value}has(h){return this.map.has(this.toKey(h))}get size(){return this.map.size}clear(){this.map.clear()}delete(h){return this.map.delete(this.toKey(h))}forEach(h,p){typeof p<"u"&&(h=h.bind(p));for(const[d,v]of this.map)h(v.value,v.uri,this)}*values(){for(const h of this.map.values())yield h.value}*keys(){for(const h of this.map.values())yield h.uri}*entries(){for(const h of this.map.values())yield[h.uri,h.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.map)yield[h.uri,h.value]}}e.ResourceMap=S,S.defaultToKey=g=>g.toString();class E{constructor(h,p){this[t]="ResourceSet",!h||typeof h=="function"?this._map=new S(h):(this._map=new S(p),h.forEach(this.add,this))}get size(){return this._map.size}add(h){return this._map.set(h,h),this}clear(){this._map.clear()}delete(h){return this._map.delete(h)}forEach(h,p){this._map.forEach((d,v)=>h.call(p,v,v,this))}has(h){return this._map.has(h)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=E;var C;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class b{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(h){return this._map.has(h)}get(h,p=0){const d=this._map.get(h);if(!!d)return p!==0&&this.touch(d,p),d.value}set(h,p,d=0){let v=this._map.get(h);if(v)v.value=p,d!==0&&this.touch(v,d);else{switch(v={key:h,value:p,next:void 0,previous:void 0},d){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(h,v),this._size++}return this}delete(h){return!!this.remove(h)}remove(h){const p=this._map.get(h);if(!!p)return this._map.delete(h),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const h=this._head;return this._map.delete(h.key),this.removeItem(h),this._size--,h.value}forEach(h,p){const d=this._state;let v=this._head;for(;v;){if(p?h.bind(p)(v.value,v.key,this):h(v.value,v.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const h=this,p=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:d.key,done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return v}values(){const h=this,p=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:d.value,done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return v}entries(){const h=this,p=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(h._state!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:[d.key,d.value],done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return v}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(h){if(h>=this.size)return;if(h===0){this.clear();return}let p=this._head,d=this.size;for(;p&&d>h;)this._map.delete(p.key),p=p.next,d--;this._head=p,this._size=d,p&&(p.previous=void 0),this._state++}addItemFirst(h){if(!this._head&&!this._tail)this._tail=h;else if(this._head)h.next=this._head,this._head.previous=h;else throw new Error("Invalid list");this._head=h,this._state++}addItemLast(h){if(!this._head&&!this._tail)this._head=h;else if(this._tail)h.previous=this._tail,this._tail.next=h;else throw new Error("Invalid list");this._tail=h,this._state++}removeItem(h){if(h===this._head&&h===this._tail)this._head=void 0,this._tail=void 0;else if(h===this._head){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this._head=h.next}else if(h===this._tail){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this._tail=h.previous}else{const p=h.next,d=h.previous;if(!p||!d)throw new Error("Invalid list");p.previous=d,d.next=p}h.next=void 0,h.previous=void 0,this._state++}touch(h,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(h===this._head)return;const d=h.next,v=h.previous;h===this._tail?(v.next=void 0,this._tail=v):(d.previous=v,v.next=d),h.previous=void 0,h.next=this._head,this._head.previous=h,this._head=h,this._state++}else if(p===2){if(h===this._tail)return;const d=h.next,v=h.previous;h===this._head?(d.previous=void 0,this._head=d):(d.previous=v,v.next=d),h.next=void 0,h.previous=this._tail,this._tail.next=h,this._tail=h,this._state++}}}toJSON(){const h=[];return this.forEach((p,d)=>{h.push([d,p])}),h}fromJSON(h){this.clear();for(const[p,d]of h)this.set(p,d)}}e.LinkedMap=b;class u extends b{constructor(h,p=1){super(),this._limit=h,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(h){this._limit=h,this.checkTrim()}get ratio(){return this._ratio}set ratio(h){this._ratio=Math.min(Math.max(0,h),1),this.checkTrim()}get(h,p=2){return super.get(h,p)}peek(h){return super.get(h,0)}set(h,p){return super.set(h,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Z[77],ee([0,1,39]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function k(S){return w(S,"NFC",t)}e.normalizeNFC=k;const R=new I.LRUCache(1e4);function D(S){return w(S,"NFD",R)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function w(S,E,C){if(!S)return S;const b=C.get(S);if(b)return b;let u;return P.test(S)?u=S.normalize(E):u=S,C.set(S,u),u}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(E){return D(E).replace(S,"")}}()}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(w){R.push(w,Date.now())}function P(){const w=[];for(let S=0;S<R.length;S+=2)w.push({name:R[S],startTime:R[S+1]});return w}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function I(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:z)[t]=I[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function I(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,I),k.l=!0,k.exports}return I.m=z,I.c=e,I.d=function(t,k,R){I.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},I.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,k){if(1&k&&(t=I(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)I.d(R,D,function(P){return t[P]}.bind(null,D));return R},I.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(k,"a",k),k},I.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},I.p="",I(I.s=0)}([function(z,e,I){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],S=0,E=S++;w[E]="0|[1-9]\\d*";var C=S++;w[C]="[0-9]+";var b=S++;w[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=S++;w[u]="("+w[E]+")\\.("+w[E]+")\\.("+w[E]+")";var g=S++;w[g]="("+w[C]+")\\.("+w[C]+")\\.("+w[C]+")";var h=S++;w[h]="(?:"+w[E]+"|"+w[b]+")";var p=S++;w[p]="(?:"+w[C]+"|"+w[b]+")";var d=S++;w[d]="(?:-("+w[h]+"(?:\\."+w[h]+")*))";var v=S++;w[v]="(?:-?("+w[p]+"(?:\\."+w[p]+")*))";var m=S++;w[m]="[0-9A-Za-z-]+";var f=S++;w[f]="(?:\\+("+w[m]+"(?:\\."+w[m]+")*))";var c=S++,n="v?"+w[u]+w[d]+"?"+w[f]+"?";w[c]="^"+n+"$";var s="[v=\\s]*"+w[g]+w[v]+"?"+w[f]+"?",i=S++;w[i]="^"+s+"$";var o=S++;w[o]="((?:<|>)?=?)";var r=S++;w[r]=w[C]+"|x|X|\\*";var l=S++;w[l]=w[E]+"|x|X|\\*";var a=S++;w[a]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[d]+")?"+w[f]+"?)?)?";var y=S++;w[y]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[v]+")?"+w[f]+"?)?)?";var M=S++;w[M]="^"+w[o]+"\\s*"+w[a]+"$";var T=S++;w[T]="^"+w[o]+"\\s*"+w[y]+"$";var N=S++;w[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=S++;w[G]="(?:~>?)";var ae=S++;w[ae]="(\\s*)"+w[G]+"\\s+",P[ae]=new RegExp(w[ae],"g");var X=S++;w[X]="^"+w[G]+w[a]+"$";var Q=S++;w[Q]="^"+w[G]+w[y]+"$";var ie=S++;w[ie]="(?:\\^)";var oe=S++;w[oe]="(\\s*)"+w[ie]+"\\s+",P[oe]=new RegExp(w[oe],"g");var he=S++;w[he]="^"+w[ie]+w[a]+"$";var V=S++;w[V]="^"+w[ie]+w[y]+"$";var q=S++;w[q]="^"+w[o]+"\\s*("+s+")$|^$";var F=S++;w[F]="^"+w[o]+"\\s*("+n+")$|^$";var A=S++;w[A]="(\\s*)"+w[o]+"\\s*("+s+"|"+w[a]+")",P[A]=new RegExp(w[A],"g");var W=S++;w[W]="^\\s*("+w[a]+")\\s+-\\s+("+w[a]+")\\s*$";var U=S++;w[U]="^\\s*("+w[y]+")\\s+-\\s+("+w[y]+")\\s*$";var J=S++;w[J]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,w[B]),P[B]||(P[B]=new RegExp(w[B]));function $(x,ue){if(x instanceof L)return x;if(typeof x!="string"||x.length>R||!(ue?P[i]:P[c]).test(x))return null;try{return new L(x,ue)}catch{return null}}function L(x,ue){if(x instanceof L){if(x.loose===ue)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(x,ue);k("SemVer",x,ue),this.loose=ue;var de=x.trim().match(ue?P[i]:P[c]);if(!de)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=$,e.valid=function(x,ue){var de=$(x,ue);return de?de.version:null},e.clean=function(x,ue){var de=$(x.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof L||(x=new L(x,this.loose)),this.compareMain(x)||this.comparePre(x)},L.prototype.compareMain=function(x){return x instanceof L||(x=new L(x,this.loose)),_(this.major,x.major)||_(this.minor,x.minor)||_(this.patch,x.patch)},L.prototype.comparePre=function(x){if(x instanceof L||(x=new L(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],ye=x.prerelease[ue];if(k("prerelease compare",ue,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return _(de,ye)}while(++ue)},L.prototype.inc=function(x,ue){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,ue,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(x,de).inc(ue,ye).version}catch{return null}},e.diff=function(x,ue){if(j(x,ue))return null;var de=$(x),ye=$(ue);if(de.prerelease.length||ye.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(x,ue){var de=O.test(x),ye=O.test(ue);return de&&ye&&(x=+x,ue=+ue),de&&!ye?-1:ye&&!de?1:x<ue?-1:x>ue?1:0}function H(x,ue,de){return new L(x,de).compare(new L(ue,de))}function Y(x,ue,de){return H(x,ue,de)>0}function se(x,ue,de){return H(x,ue,de)<0}function j(x,ue,de){return H(x,ue,de)===0}function re(x,ue,de){return H(x,ue,de)!==0}function ne(x,ue,de){return H(x,ue,de)>=0}function ce(x,ue,de){return H(x,ue,de)<=0}function ge(x,ue,de,ye){var Ce;switch(ue){case"===":typeof x=="object"&&(x=x.version),typeof de=="object"&&(de=de.version),Ce=x===de;break;case"!==":typeof x=="object"&&(x=x.version),typeof de=="object"&&(de=de.version),Ce=x!==de;break;case"":case"=":case"==":Ce=j(x,de,ye);break;case"!=":Ce=re(x,de,ye);break;case">":Ce=Y(x,de,ye);break;case">=":Ce=ne(x,de,ye);break;case"<":Ce=se(x,de,ye);break;case"<=":Ce=ce(x,de,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function Re(x,ue){if(x instanceof Re){if(x.loose===ue)return x;x=x.value}if(!(this instanceof Re))return new Re(x,ue);k("comparator",x,ue),this.loose=ue,this.parse(x),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,ue){return _(ue,x)},e.major=function(x,ue){return new L(x,ue).major},e.minor=function(x,ue){return new L(x,ue).minor},e.patch=function(x,ue){return new L(x,ue).patch},e.compare=H,e.compareLoose=function(x,ue){return H(x,ue,!0)},e.rcompare=function(x,ue,de){return H(ue,x,de)},e.sort=function(x,ue){return x.sort(function(de,ye){return e.compare(de,ye,ue)})},e.rsort=function(x,ue){return x.sort(function(de,ye){return e.rcompare(de,ye,ue)})},e.gt=Y,e.lt=se,e.eq=j,e.neq=re,e.gte=ne,e.lte=ce,e.cmp=ge,e.Comparator=Re;var Te={};function Me(x,ue){if(x instanceof Me)return x.loose===ue?x:new Me(x.raw,ue);if(x instanceof Re)return new Me(x.value,ue);if(!(this instanceof Me))return new Me(x,ue);if(this.loose=ue,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ae(x){return!x||x.toLowerCase()==="x"||x==="*"}function ve(x,ue,de,ye,Ce,Fe,Oe,$e,Ne,je,Qe,Be,Ge){return((ue=Ae(de)?"":Ae(ye)?">="+de+".0.0":Ae(Ce)?">="+de+"."+ye+".0":">="+ue)+" "+($e=Ae(Ne)?"":Ae(je)?"<"+(+Ne+1)+".0.0":Ae(Qe)?"<"+Ne+"."+(+je+1)+".0":Be?"<="+Ne+"."+je+"."+Qe+"-"+Be:"<="+$e)).trim()}function pe(x,ue){for(var de=0;de<x.length;de++)if(!x[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<x.length;de++)if(k(x[de].semver),x[de].semver!==Te&&x[de].semver.prerelease.length>0){var ye=x[de].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function Se(x,ue,de){try{ue=new Me(ue,de)}catch{return!1}return ue.test(x)}function ke(x,ue,de,ye){var Ce,Fe,Oe,$e,Ne;switch(x=new L(x,ye),ue=new Me(ue,ye),de){case">":Ce=Y,Fe=ce,Oe=se,$e=">",Ne=">=";break;case"<":Ce=se,Fe=ne,Oe=Y,$e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(x,ue,ye))return!1;for(var je=0;je<ue.set.length;++je){var Qe=ue.set[je],Be=null,Ge=null;if(Qe.forEach(function(K){K.semver===Te&&(K=new Re(">=0.0.0")),Be=Be||K,Ge=Ge||K,Ce(K.semver,Be.semver,ye)?Be=K:Oe(K.semver,Ge.semver,ye)&&(Ge=K)}),Be.operator===$e||Be.operator===Ne||(!Ge.operator||Ge.operator===$e)&&Fe(x,Ge.semver)||Ge.operator===Ne&&Oe(x,Ge.semver))return!1}return!0}Re.prototype.parse=function(x){var ue=this.loose?P[q]:P[F],de=x.match(ue);if(!de)throw new TypeError("Invalid comparator: "+x);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Te},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===Te||(typeof x=="string"&&(x=new L(x,this.loose)),ge(x,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(x,ue){if(!(x instanceof Re))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(x.value,ue),Se(this.value,de,ue);if(x.operator==="")return de=new Me(this.value,ue),Se(x.semver,de,ue);var ye=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Fe=this.semver.version===x.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),$e=ge(this.semver,"<",x.semver,ue)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ne=ge(this.semver,">",x.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ye||Ce||Fe&&Oe||$e||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(x){var ue=this.loose;x=x.trim(),k("range",x,ue);var de=ue?P[U]:P[W];x=x.replace(de,ve),k("hyphen replace",x),x=x.replace(P[A],"$1$2$3"),k("comparator trim",x,P[A]),x=(x=(x=x.replace(P[ae],"$1~")).replace(P[oe],"$1^")).split(/\s+/).join(" ");var ye=ue?P[q]:P[F],Ce=x.split(" ").map(function(Fe){return function(Oe,$e){return k("comp",Oe),Oe=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){k("caret",Be,Ge);var K=Ge?P[V]:P[he];return Be.replace(K,function(le,fe,me,Ee,Le){var Ue;return k("caret",Be,le,fe,me,Ee,Le),Ae(fe)?Ue="":Ae(me)?Ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(Ee)?Ue=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Le?(k("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ue=fe==="0"?me==="0"?">="+fe+"."+me+"."+Ee+Le+" <"+fe+"."+me+"."+(+Ee+1):">="+fe+"."+me+"."+Ee+Le+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Ee+Le+" <"+(+fe+1)+".0.0"):(k("no pr"),Ue=fe==="0"?me==="0"?">="+fe+"."+me+"."+Ee+" <"+fe+"."+me+"."+(+Ee+1):">="+fe+"."+me+"."+Ee+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+Ee+" <"+(+fe+1)+".0.0"),k("caret return",Ue),Ue})}(Qe,je)}).join(" ")}(Oe,$e),k("caret",Oe),Oe=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){var K=Ge?P[Q]:P[X];return Be.replace(K,function(le,fe,me,Ee,Le){var Ue;return k("tilde",Be,le,fe,me,Ee,Le),Ae(fe)?Ue="":Ae(me)?Ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(Ee)?Ue=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Le?(k("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Ue=">="+fe+"."+me+"."+Ee+Le+" <"+fe+"."+(+me+1)+".0"):Ue=">="+fe+"."+me+"."+Ee+" <"+fe+"."+(+me+1)+".0",k("tilde return",Ue),Ue})}(Qe,je)}).join(" ")}(Oe,$e),k("tildes",Oe),Oe=function(Ne,je){return k("replaceXRanges",Ne,je),Ne.split(/\s+/).map(function(Qe){return function(Be,Ge){Be=Be.trim();var K=Ge?P[T]:P[M];return Be.replace(K,function(le,fe,me,Ee,Le,Ue){k("xRange",Be,le,fe,me,Ee,Le,Ue);var it=Ae(me),Je=it||Ae(Ee),He=Je||Ae(Le);return fe==="="&&He&&(fe=""),it?le=fe===">"||fe==="<"?"<0.0.0":"*":fe&&He?(Je&&(Ee=0),He&&(Le=0),fe===">"?(fe=">=",Je?(me=+me+1,Ee=0,Le=0):He&&(Ee=+Ee+1,Le=0)):fe==="<="&&(fe="<",Je?me=+me+1:Ee=+Ee+1),le=fe+me+"."+Ee+"."+Le):Je?le=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(le=">="+me+"."+Ee+".0 <"+me+"."+(+Ee+1)+".0"),k("xRange return",le),le})}(Qe,je)}).join(" ")}(Oe,$e),k("xrange",Oe),Oe=function(Ne,je){return k("replaceStars",Ne,je),Ne.trim().replace(P[J],"")}(Oe,$e),k("stars",Oe),Oe}(Fe,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(ye)})),Ce=Ce.map(function(Fe){return new Re(Fe,ue)})},Me.prototype.intersects=function(x,ue){if(!(x instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return x.set.some(function(Ce){return Ce.every(function(Fe){return ye.intersects(Fe,ue)})})})})},e.toComparators=function(x,ue){return new Me(x,ue).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new L(x,this.loose));for(var ue=0;ue<this.set.length;ue++)if(pe(this.set[ue],x))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(x,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return x.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,de)))}),ye},e.minSatisfying=function(x,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return x.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,de)))}),ye},e.validRange=function(x,ue){try{return new Me(x,ue).range||"*"}catch{return null}},e.ltr=function(x,ue,de){return ke(x,ue,"<",de)},e.gtr=function(x,ue,de){return ke(x,ue,">",de)},e.outside=ke,e.prerelease=function(x,ue){var de=$(x,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(x,ue,de){return x=new Me(x,de),ue=new Me(ue,de),x.intersects(ue)},e.coerce=function(x){if(x instanceof L)return x;if(typeof x!="string")return null;var ue=x.match(P[N]);return ue==null?null:$((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,I(1))},function(z,e){var I,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(p){if(I===setTimeout)return setTimeout(p,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(p,0);try{return I(p,0)}catch{try{return I.call(null,p,0)}catch{return I.call(this,p,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var w,S=[],E=!1,C=-1;function b(){E&&w&&(E=!1,w.length?S=w.concat(S):C=-1,S.length&&u())}function u(){if(!E){var p=P(b);E=!0;for(var d=S.length;d;){for(w=S,S=[];++C<d;)w&&w[C].run();C=-1,d=S.length}w=null,E=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(p)}}function g(p,d){this.fun=p,this.array=d}function h(){}k.nextTick=function(p){var d=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)d[v-1]=arguments[v];S.push(new g(p,d)),S.length!==1||E||P(u)},g.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=h,k.addListener=h,k.once=h,k.off=h,k.removeListener=h,k.removeAllListeners=h,k.emit=h,k.prependListener=h,k.prependOnceListener=h,k.listeners=function(p){return[]},k.binding=function(p){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(p){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[125],ee([0,1]),function(z,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,w,S){this.level=P,this.key=w,this.value=S,this.forward=[]}}const k=void 0;class R{constructor(P,w=2**16){this.comparator=P,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(w)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(P){return Boolean(R._search(this,P,this.comparator))}get(P){return R._search(this,P,this.comparator)?.value}set(P,w){return R._insert(this,P,w,this.comparator)&&(this._size+=1),this}delete(P){const w=R._delete(this,P,this.comparator);return w&&(this._size-=1),w}forEach(P,w){let S=this._header.forward[0];for(;S;)P.call(w,S.value,S.key,this),S=S.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this._header.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static _search(P,w,S){let E=P._header;for(let C=P._level-1;C>=0;C--)for(;E.forward[C]&&S(E.forward[C].key,w)<0;)E=E.forward[C];if(E=E.forward[0],E&&S(E.key,w)===0)return E}static _insert(P,w,S,E){const C=[];let b=P._header;for(let u=P._level-1;u>=0;u--){for(;b.forward[u]&&E(b.forward[u].key,w)<0;)b=b.forward[u];C[u]=b}if(b=b.forward[0],b&&E(b.key,w)===0)return b.value=S,!1;{const u=R._randomLevel(P);if(u>P._level){for(let g=P._level;g<u;g++)C[g]=P._header;P._level=u}b=new t(u,w,S);for(let g=0;g<u;g++)b.forward[g]=C[g].forward[g],C[g].forward[g]=b;return!0}}static _randomLevel(P,w=.5){let S=1;for(;Math.random()<w&&S<P._maxLevel;)S+=1;return S}static _delete(P,w,S){const E=[];let C=P._header;for(let b=P._level-1;b>=0;b--){for(;C.forward[b]&&S(C.forward[b].key,w)<0;)C=C.forward[b];E[b]=C}if(C=C.forward[0],!C||S(C.key,w)!==0)return!1;for(let b=0;b<P._level&&E[b].forward[b]===C;b++)E[b].forward[b]=C.forward[b];for(;P._level>0&&P._header.forward[P._level-1]===k;)P._level-=1;return!0}}e.SkipList=R}),define(Z[58],ee([0,1,16,2]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const c=f;return c?typeof c.read=="function":!1}e.isReadable=k;function R(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function D(f){const c=f;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(f,c){return new w(f,c)}e.newWriteableStream=P;class w{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,I.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(n);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,c){const n=[];let s;for(;(s=f.read())!==null;)n.push(s);return c(n)}e.consumeReadable=S;function E(f,c,n){const s=[];let i;for(;(i=f.read())!==null&&s.length<n;)s.push(i);return i===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return f.read()}}}e.peekReadable=E;function C(f,c){return new Promise((n,s)=>{const i=[];b(f,{onData:o=>{c&&i.push(o)},onError:o=>{c?s(o):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=C;function b(f,c){let n=!1;return f.on("error",s=>{n||c.onError(s)}),f.on("end",()=>{n||c.onEnd()}),f.on("data",s=>{n||c.onData(s)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=b;function u(f,c){return new Promise((n,s)=>{const i=new t.DisposableStore,o=[],r=y=>{if(o.push(y),o.length>c)return i.dispose(),f.pause(),n({stream:f,buffer:o,ended:!1})},l=y=>s(y),a=()=>n({stream:f,buffer:o,ended:!0});i.add((0,t.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),i.add((0,t.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),i.add((0,t.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}e.peekStream=u;function g(f,c){const n=P(c);return n.end(f),n}e.toStream=g;function h(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function p(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=p;function d(f,c,n){const s=P(n);return b(f,{onData:i=>s.write(c.data(i)),onError:i=>s.error(c.error?c.error(i):i),onEnd:()=>s.end()}),s}e.transform=d;function v(f,c,n){let s=!1;return{read:()=>{const i=c.read();return s?i:(s=!0,i!==null?n([f,i]):f)}}}e.prefixedReadable=v;function m(f,c,n){let s=!1;const i=P(n);return b(c,{onData:o=>s?i.write(o):(s=!0,i.write(n([f,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(f)),i.end()}}),i}e.prefixedStream=m}),define(Z[17],ee([0,1,58]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(y){return t?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return t&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(y)):(k||(k=new TextEncoder),new D(k.encode(y)))}static fromByteArray(y){const M=D.alloc(y.length);for(let T=0,N=y.length;T<N;T++)M.buffer[T]=y[T];return M}static concat(y,M){if(typeof M>"u"){M=0;for(let G=0,ae=y.length;G<ae;G++)M+=y[G].byteLength}const T=D.alloc(M);let N=0;for(let G=0,ae=y.length;G<ae;G++){const X=y[G];T.set(X,N),N+=X.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(y,M){return new D(this.buffer.subarray(y,M))}set(y,M){if(y instanceof D)this.buffer.set(y.buffer,M);else if(y instanceof Uint8Array)this.buffer.set(y,M);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),M);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,M){E(this.buffer,y,M)}readUInt32LE(y){return C(this.buffer,y)}writeUInt32LE(y,M){b(this.buffer,y,M)}readUInt8(y){return u(this.buffer,y)}writeUInt8(y,M){g(this.buffer,y,M)}}e.VSBuffer=D;function P(a,y){return a[y+0]<<0>>>0|a[y+1]<<8>>>0}e.readUInt16LE=P;function w(a,y,M){a[M+0]=y&255,y=y>>>8,a[M+1]=y&255}e.writeUInt16LE=w;function S(a,y){return a[y]*2**24+a[y+1]*2**16+a[y+2]*2**8+a[y+3]}e.readUInt32BE=S;function E(a,y,M){a[M+3]=y,y=y>>>8,a[M+2]=y,y=y>>>8,a[M+1]=y,y=y>>>8,a[M]=y}e.writeUInt32BE=E;function C(a,y){return a[y+0]<<0>>>0|a[y+1]<<8>>>0|a[y+2]<<16>>>0|a[y+3]<<24>>>0}e.readUInt32LE=C;function b(a,y,M){a[M+0]=y&255,y=y>>>8,a[M+1]=y&255,y=y>>>8,a[M+2]=y&255,y=y>>>8,a[M+3]=y&255}e.writeUInt32LE=b;function u(a,y){return a[y]}e.readUInt8=u;function g(a,y,M){a[M]=y}e.writeUInt8=g;function h(a){return I.consumeReadable(a,y=>D.concat(y))}e.readableToBuffer=h;function p(a){return I.toReadable(a)}e.bufferToReadable=p;function d(a){return I.consumeStream(a,y=>D.concat(y))}e.streamToBuffer=d;async function v(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=v;function m(a){return I.toStream(a,y=>D.concat(y))}e.bufferToStream=m;function f(a){return I.transform(a,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.streamToBufferReadableStream=f;function c(a){return I.newWriteableStream(y=>D.concat(y),a)}e.newWriteableBufferStream=c;function n(a,y){return I.prefixedReadable(a,y,M=>D.concat(M))}e.prefixedBufferReadable=n;function s(a,y){return I.prefixedStream(a,y,M=>D.concat(M))}e.prefixedBufferStream=s;function i(a){let y=0,M=0,T=0;const N=new Uint8Array(Math.floor(a.length/4*3)),G=X=>{switch(M){case 3:N[T++]=y|X,M=0;break;case 2:N[T++]=y|X>>>2,y=X<<6,M=3;break;case 1:N[T++]=y|X>>>4,y=X<<4,M=2;break;default:y=X<<2,M=1}};for(let X=0;X<a.length;X++){const Q=a.charCodeAt(X);if(Q>=65&&Q<=90)G(Q-65);else if(Q>=97&&Q<=122)G(Q-97+26);else if(Q>=48&&Q<=57)G(Q-48+52);else if(Q===43||Q===45)G(62);else if(Q===47||Q===95)G(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${a[X]}`)}}const ae=T;for(;M>0;)G(0);return D.wrap(N).slice(0,ae)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},y=!0,M=!1){const T=M?r:o;let N="";const G=a.byteLength%3;let ae=0;for(;ae<a.byteLength-G;ae+=3){const X=a[ae+0],Q=a[ae+1],ie=a[ae+2];N+=T[X>>>2],N+=T[(X<<4|Q>>>4)&63],N+=T[(Q<<2|ie>>>6)&63],N+=T[ie&63]}if(G===1){const X=a[ae+0];N+=T[X>>>2],N+=T[X<<4&63],y&&(N+="==")}else if(G===2){const X=a[ae+0],Q=a[ae+1];N+=T[X>>>2],N+=T[(X<<4|Q>>>4)&63],N+=T[Q<<2&63],y&&(N+="=")}return N}e.encodeBase64=l}),define(Z[12],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(s){return typeof s=="string"}e.isString=I;function t(s){return Array.isArray(s)&&s.every(i=>I(i))}e.isStringArray=t;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function R(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}e.isTypedArray=R;function D(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=D;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function w(s){return s===!0||s===!1}e.isBoolean=w;function S(s){return typeof s>"u"}e.isUndefined=S;function E(s){return!C(s)}e.isDefined=E;function C(s){return S(s)||s===null}e.isUndefinedOrNull=C;function b(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function u(s){if(C(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=u;function g(...s){const i=[];for(let o=0;o<s.length;o++){const r=s[o];if(C(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.assertAllDefined=g;const h=Object.prototype.hasOwnProperty;function p(s){if(!k(s))return!1;for(const i in s)if(h.call(s,i))return!1;return!0}e.isEmptyObject=p;function d(s){return typeof s=="function"}e.isFunction=d;function v(...s){return s.length>0&&s.every(d)}e.areFunctions=v;function m(s,i){const o=Math.min(s.length,i.length);for(let r=0;r<o;r++)f(s[r],i[r])}e.validateConstraints=m;function f(s,i){if(I(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(s instanceof i)return}catch{}if(!C(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(s){return s===null?void 0:s}e.withNullAsUndefined=c;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(Z[50],ee([0,1,12]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const v=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([m,f])=>{v[m]=f&&typeof f=="object"?t(f):f}),v}e.deepClone=t;function k(d){if(!d||typeof d!="object")return d;const v=[d];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const f in m)if(R.call(m,f)){const c=m[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,I.isTypedArray)(c)&&v.push(c)}}return d}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(d,v){return P(d,v,new Set)}e.cloneAndChange=D;function P(d,v,m){if((0,I.isUndefinedOrNull)(d))return d;const f=v(d);if(typeof f<"u")return f;if(Array.isArray(d)){const c=[];for(const n of d)c.push(P(n,v,m));return c}if((0,I.isObject)(d)){if(m.has(d))throw new Error("Cannot clone recursive data-structure");m.add(d);const c={};for(const n in d)R.call(d,n)&&(c[n]=P(d[n],v,m));return m.delete(d),c}return d}function w(d,v,m=!0){return(0,I.isObject)(d)?((0,I.isObject)(v)&&Object.keys(v).forEach(f=>{f in d?m&&((0,I.isObject)(d[f])&&(0,I.isObject)(v[f])?w(d[f],v[f],m):d[f]=v[f]):d[f]=v[f]}),d):v}e.mixin=w;function S(d,v){if(d===v)return!0;if(d==null||v===null||v===void 0||typeof d!=typeof v||typeof d!="object"||Array.isArray(d)!==Array.isArray(v))return!1;let m,f;if(Array.isArray(d)){if(d.length!==v.length)return!1;for(m=0;m<d.length;m++)if(!S(d[m],v[m]))return!1}else{const c=[];for(f in d)c.push(f);c.sort();const n=[];for(f in v)n.push(f);if(n.sort(),!S(c,n))return!1;for(m=0;m<c.length;m++)if(!S(d[c[m]],v[c[m]]))return!1}return!0}e.equals=S;function E(d){const v=new Set;return JSON.stringify(d,(m,f)=>{if((0,I.isObject)(f)||Array.isArray(f)){if(v.has(f))return"[Circular]";v.add(f)}return f})}e.safeStringify=E;function C(d,v){const m=Object.create(null);return!d||!v||Object.keys(v).forEach(c=>{const n=d[c],s=v[c];S(n,s)||(m[c]=s)}),m}e.distinct=C;function b(d,v){const m=v.toLowerCase(),f=Object.keys(d).find(c=>c.toLowerCase()===m);return f?d[f]:d[v]}e.getCaseInsensitive=b;function u(d,v){const m=Object.create(null);for(const[f,c]of Object.entries(d))v(f,c)&&(m[f]=c);return m}e.filter=u;function g(d){let v=[],m=Object.getPrototypeOf(d);for(;Object.prototype!==m;)v=v.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return v}e.getAllPropertyNames=g;function h(d){const v=[];for(const m of g(d))typeof d[m]=="function"&&v.push(m);return v}e.getAllMethodNames=h;function p(d,v){const m=c=>function(){const n=Array.prototype.slice.call(arguments,0);return v(c,n)},f={};for(const c of d)f[c]=m(c);return f}e.createProxyObject=p}),define(Z[29],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return I.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,S="";return S+=D[R[w++]],S+=D[R[w++]],S+=D[R[w++]],S+=D[R[w++]],S+="-",S+=D[R[w++]],S+=D[R[w++]],S+="-",S+=D[R[w++]],S+=D[R[w++]],S+="-",S+=D[R[w++]],S+=D[R[w++]],S+="-",S+=D[R[w++]],S+=D[R[w++]],S+=D[R[w++]],S+=D[R[w++]],S+=D[R[w++]],S+=D[R[w++]],S}}()}),define(Z[126],ee([0,1,78,40,49]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,P){if(await new Promise((E,C)=>{const b=t.createReadStream(D),u=I.createHash("sha1");b.pipe(u);const g=(0,k.once)((h,p)=>{b.removeAllListeners(),u.removeAllListeners(),h?C(h):E(p)});b.once("error",g),b.once("end",g),u.once("error",g),u.once("data",h=>g(void 0,h.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[127],ee([0,1,25]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const P=D.replace(/\-/g,":").toLowerCase();return!t.has(P)}function R(){const D=(0,I.networkInterfaces)();for(const P in D){const w=D[P];if(w){for(const{mac:S}of w)if(k(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[96],ee([0,1,79]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,w,S,E=1){let C=!1;return new Promise(b=>{const u=setTimeout(()=>{if(!C)return C=!0,b(0)},S);k(P,w,E,g=>{if(!C)return C=!0,clearTimeout(u),b(g)})})}e.findFreePort=t;function k(P,w,S,E){if(w===0)return E(0);const C=new I.Socket;C.once("connect",()=>(D(C),k(P+S,w-1,S,E))),C.once("data",()=>{}),C.once("error",b=>(D(C),b.code!=="ECONNREFUSED"?k(P+S,w-1,S,E):E(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,w,S){let E=!1,C,b=1;const u=I.createServer({pauseOnConnect:!0});function g(h,p){E||(E=!0,u.removeAllListeners(),u.close(),C&&clearTimeout(C),p(h))}return new Promise(h=>{C=setTimeout(()=>{g(0,h)},S),u.on("listening",()=>{g(P,h)}),u.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&b<w?(P++,b++,u.listen(P,"127.0.0.1")):g(0,h)}),u.on("close",()=>{g(0,h)}),u.listen(P,"127.0.0.1")})}e.findFreePortFaster=R;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(Z[128],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[129],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=I}),define(Z[41],ee([0,1,13,16]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,P){const w=(S,...E)=>{this.validateEvent(D,S)&&P(S,...E)};return this.mapListenerToWrapper.set(P,w),I.ipcMain.on(D,w),this}once(D,P){return I.ipcMain.once(D,(w,...S)=>{this.validateEvent(D,w)&&P(w,...S)}),this}handle(D,P){return I.ipcMain.handle(D,(w,...S)=>this.validateEvent(D,w)?P(w,...S):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return I.ipcMain.removeHandler(D),this}removeListener(D,P){const w=this.mapListenerToWrapper.get(P);return w&&(I.ipcMain.removeListener(D,w),this.mapListenerToWrapper.delete(P)),this}validateEvent(D,P){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const w=P.senderFrame,S=w.url;if(!S)return!0;let E="unknown";try{E=new URL(S).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${S}'.`),!1}return E!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${E}'.`),!1):w.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${E}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(Z[130],ee([0,1,13,41,12,128]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(w,S,E,C,b)=>{const u=P(w,C,E);u.popup({window:(0,k.withNullAsUndefined)(I.BrowserWindow.fromWebContents(w.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{u&&w.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}e.registerContextMenuListener=D;function P(w,S,E){const C=new I.Menu;return E.forEach(b=>{let u;b.type==="separator"?u=new I.MenuItem({type:b.type}):Array.isArray(b.submenu)?u=new I.MenuItem({submenu:P(w,S,b.submenu),label:b.label}):u=new I.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(g,h,p)=>w.sender.send(S,b.id,p)}),C.append(u)}),C}}),define(Z[131],ee([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(Z[132],ee([0,1,131]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,P=R*30,w=R*365;function S(C,b,u){typeof C!="number"&&(C=C.getTime());const g=Math.round((new Date().getTime()-C)/1e3);if(g<-30)return(0,I.localize)(0,null,S(new Date().getTime()+g*1e3,!1));if(g<30)return(0,I.localize)(1,null);let h;return g<t?(h=g,b?h===1?u?(0,I.localize)(2,null,h):(0,I.localize)(3,null,h):u?(0,I.localize)(4,null,h):(0,I.localize)(5,null,h):h===1?u?(0,I.localize)(6,null,h):(0,I.localize)(7,null,h):u?(0,I.localize)(8,null,h):(0,I.localize)(9,null,h)):g<k?(h=Math.floor(g/t),b?h===1?u?(0,I.localize)(10,null,h):(0,I.localize)(11,null,h):u?(0,I.localize)(12,null,h):(0,I.localize)(13,null,h):h===1?u?(0,I.localize)(14,null,h):(0,I.localize)(15,null,h):u?(0,I.localize)(16,null,h):(0,I.localize)(17,null,h)):g<R?(h=Math.floor(g/k),b?h===1?u?(0,I.localize)(18,null,h):(0,I.localize)(19,null,h):u?(0,I.localize)(20,null,h):(0,I.localize)(21,null,h):h===1?u?(0,I.localize)(22,null,h):(0,I.localize)(23,null,h):u?(0,I.localize)(24,null,h):(0,I.localize)(25,null,h)):g<D?(h=Math.floor(g/R),b?h===1?(0,I.localize)(26,null,h):(0,I.localize)(27,null,h):h===1?(0,I.localize)(28,null,h):(0,I.localize)(29,null,h)):g<P?(h=Math.floor(g/D),b?h===1?u?(0,I.localize)(30,null,h):(0,I.localize)(31,null,h):u?(0,I.localize)(32,null,h):(0,I.localize)(33,null,h):h===1?u?(0,I.localize)(34,null,h):(0,I.localize)(35,null,h):u?(0,I.localize)(36,null,h):(0,I.localize)(37,null,h)):g<w?(h=Math.floor(g/P),b?h===1?u?(0,I.localize)(38,null,h):(0,I.localize)(39,null,h):u?(0,I.localize)(40,null,h):(0,I.localize)(41,null,h):h===1?u?(0,I.localize)(42,null,h):(0,I.localize)(43,null,h):u?(0,I.localize)(44,null,h):(0,I.localize)(45,null,h)):(h=Math.floor(g/w),b?h===1?u?(0,I.localize)(46,null,h):(0,I.localize)(47,null,h):u?(0,I.localize)(48,null,h):(0,I.localize)(49,null,h):h===1?u?(0,I.localize)(50,null,h):(0,I.localize)(51,null,h):u?(0,I.localize)(52,null,h):(0,I.localize)(53,null,h))}e.fromNow=S;function E(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(Z[133],ee([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,24,12,133]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(C,b){return b&&(C.stack||C.stacktrace)?k.localize(0,null,P(C),D(C.stack)||D(C.stacktrace)):P(C)}function D(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function w(C=null,b=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const u=I.coalesce(C),g=w(u[0],b);return u.length>1?k.localize(4,null,g,u.length):g}if(t.isString(C))return C;if(C.detail){const u=C.detail;if(u.error)return R(u.error,b);if(u.exception)return R(u.exception,b)}return C.stack?R(C,b):C.message?C.message:k.localize(5,null)}e.toErrorMessage=w;function S(C){const b=C;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=S;function E(C,b){let u;return typeof C=="string"?u=new Error(C):u=C,u.actions=b,u}e.createErrorWithActions=E}),define(Z[134],ee([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(Z[135],ee([0,1,134]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(Z[136],ee([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,136]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,P=!1,w=!1,S=!1,E=!1,C=!1,b=!1,u,g=e.LANGUAGE_DEFAULT,h,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const v=typeof d?.versions?.electron=="string",m=v&&d?.type==="renderer";if(typeof navigator=="object"&&!m)p=navigator.userAgent,t=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,E=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=p.indexOf("Linux")>=0,b=p?.indexOf("Mobi")>=0,w=!0,u=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,g=u;else if(typeof d=="object"){t=d.platform==="win32",k=d.platform==="darwin",R=d.platform==="linux",D=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,S=v,C=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const a=d.env.VSCODE_NLS_CONFIG;if(a)try{const y=JSON.parse(a),M=y.availableLanguages["*"];u=y.locale,g=M||e.LANGUAGE_DEFAULT,h=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var f;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;k?n=1:t?n=3:R&&(n=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=P,e.isElectron=S,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isMobile=b,e.isCI=C,e.platform=n,e.userAgent=p,e.language=g;var s;(function(a){function y(){return e.language}a.value=y;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=M;function T(){return e.language==="en"}a.isDefault=T})(s=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,N=a.length;T<N;T++){const G=a[T];if(G.id===M.data.vscodeScheduleAsyncWork){a.splice(T,1),G.callback();return}}});let y=0;return M=>{const T=++y;a.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||E?2:t?1:3;let o=!0,r=!1;function l(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[33],ee([0,1,4]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const k=I.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],ee([0,1,33]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,P=46,w=47,S=92,E=58,C=63;class b extends Error{constructor(f,c,n){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const i=f.indexOf(".")!==-1?"property":"argument";let o=`The "${f}" ${i} ${s} of type ${c}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function u(m,f){if(typeof m!="string")throw new b(f,"string",m)}function g(m){return m===w||m===S}function h(m){return m===w}function p(m){return m>=t&&m<=R||m>=k&&m<=D}function d(m,f,c,n){let s="",i=0,o=-1,r=0,l=0;for(let a=0;a<=m.length;++a){if(a<m.length)l=m.charCodeAt(a);else{if(n(l))break;l=w}if(n(l)){if(!(o===a-1||r===1))if(r===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const y=s.lastIndexOf(c);y===-1?(s="",i=0):(s=s.slice(0,y),i=s.length-1-s.lastIndexOf(c)),o=a,r=0;continue}else if(s.length!==0){s="",i=0,o=a,r=0;continue}}f&&(s+=s.length>0?`${c}..`:"..",i=2)}else s.length>0?s+=`${c}${m.slice(o+1,a)}`:s=m.slice(o+1,a),i=a-o-1;o=a,r=0}else l===P&&r!==-1?++r:r=-1}return s}function v(m,f){if(f===null||typeof f!="object")throw new b("pathObject","Object",f);const c=f.dir||f.root,n=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${n}`:`${c}${m}${n}`:n}e.win32={resolve(...m){let f="",c="",n=!1;for(let s=m.length-1;s>=-1;s--){let i;if(s>=0){if(i=m[s],u(i,"path"),i.length===0)continue}else f.length===0?i=I.cwd():(i=I.env[`=${f}`]||I.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===S)&&(i=`${f}\\`));const o=i.length;let r=0,l="",a=!1;const y=i.charCodeAt(0);if(o===1)g(y)&&(r=1,a=!0);else if(g(y))if(a=!0,g(i.charCodeAt(1))){let M=2,T=M;for(;M<o&&!g(i.charCodeAt(M));)M++;if(M<o&&M!==T){const N=i.slice(T,M);for(T=M;M<o&&g(i.charCodeAt(M));)M++;if(M<o&&M!==T){for(T=M;M<o&&!g(i.charCodeAt(M));)M++;(M===o||M!==T)&&(l=`\\\\${N}\\${i.slice(T,M)}`,r=M)}}}else r=1;else p(y)&&i.charCodeAt(1)===E&&(l=i.slice(0,2),r=2,o>2&&g(i.charCodeAt(2))&&(a=!0,r=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(n){if(f.length>0)break}else if(c=`${i.slice(r)}\\${c}`,n=a,a&&f.length>0)break}return c=d(c,!n,"\\",g),n?`${f}\\${c}`:`${f}${c}`||"."},normalize(m){u(m,"path");const f=m.length;if(f===0)return".";let c=0,n,s=!1;const i=m.charCodeAt(0);if(f===1)return h(i)?"\\":m;if(g(i))if(s=!0,g(m.charCodeAt(1))){let r=2,l=r;for(;r<f&&!g(m.charCodeAt(r));)r++;if(r<f&&r!==l){const a=m.slice(l,r);for(l=r;r<f&&g(m.charCodeAt(r));)r++;if(r<f&&r!==l){for(l=r;r<f&&!g(m.charCodeAt(r));)r++;if(r===f)return`\\\\${a}\\${m.slice(l)}\\`;r!==l&&(n=`\\\\${a}\\${m.slice(l,r)}`,c=r)}}}else c=1;else p(i)&&m.charCodeAt(1)===E&&(n=m.slice(0,2),c=2,f>2&&g(m.charCodeAt(2))&&(s=!0,c=3));let o=c<f?d(m.slice(c),!s,"\\",g):"";return o.length===0&&!s&&(o="."),o.length>0&&g(m.charCodeAt(f-1))&&(o+="\\"),n===void 0?s?`\\${o}`:o:s?`${n}\\${o}`:`${n}${o}`},isAbsolute(m){u(m,"path");const f=m.length;if(f===0)return!1;const c=m.charCodeAt(0);return g(c)||f>2&&p(c)&&m.charCodeAt(1)===E&&g(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let f,c;for(let i=0;i<m.length;++i){const o=m[i];u(o,"path"),o.length>0&&(f===void 0?f=c=o:f+=`\\${o}`)}if(f===void 0)return".";let n=!0,s=0;if(typeof c=="string"&&g(c.charCodeAt(0))){++s;const i=c.length;i>1&&g(c.charCodeAt(1))&&(++s,i>2&&(g(c.charCodeAt(2))?++s:n=!1))}if(n){for(;s<f.length&&g(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(m,f){if(u(m,"from"),u(f,"to"),m===f)return"";const c=e.win32.resolve(m),n=e.win32.resolve(f);if(c===n||(m=c.toLowerCase(),f=n.toLowerCase(),m===f))return"";let s=0;for(;s<m.length&&m.charCodeAt(s)===S;)s++;let i=m.length;for(;i-1>s&&m.charCodeAt(i-1)===S;)i--;const o=i-s;let r=0;for(;r<f.length&&f.charCodeAt(r)===S;)r++;let l=f.length;for(;l-1>r&&f.charCodeAt(l-1)===S;)l--;const a=l-r,y=o<a?o:a;let M=-1,T=0;for(;T<y;T++){const G=m.charCodeAt(s+T);if(G!==f.charCodeAt(r+T))break;G===S&&(M=T)}if(T!==y){if(M===-1)return n}else{if(a>y){if(f.charCodeAt(r+T)===S)return n.slice(r+T+1);if(T===2)return n.slice(r+T)}o>y&&(m.charCodeAt(s+T)===S?M=T:T===2&&(M=3)),M===-1&&(M=0)}let N="";for(T=s+M+1;T<=i;++T)(T===i||m.charCodeAt(T)===S)&&(N+=N.length===0?"..":"\\..");return r+=M,N.length>0?`${N}${n.slice(r,l)}`:(n.charCodeAt(r)===S&&++r,n.slice(r,l))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const f=e.win32.resolve(m);if(f.length<=2)return m;if(f.charCodeAt(0)===S){if(f.charCodeAt(1)===S){const c=f.charCodeAt(2);if(c!==C&&c!==P)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(p(f.charCodeAt(0))&&f.charCodeAt(1)===E&&f.charCodeAt(2)===S)return`\\\\?\\${f}`;return m},dirname(m){u(m,"path");const f=m.length;if(f===0)return".";let c=-1,n=0;const s=m.charCodeAt(0);if(f===1)return g(s)?m:".";if(g(s)){if(c=n=1,g(m.charCodeAt(1))){let r=2,l=r;for(;r<f&&!g(m.charCodeAt(r));)r++;if(r<f&&r!==l){for(l=r;r<f&&g(m.charCodeAt(r));)r++;if(r<f&&r!==l){for(l=r;r<f&&!g(m.charCodeAt(r));)r++;if(r===f)return m;r!==l&&(c=n=r+1)}}}}else p(s)&&m.charCodeAt(1)===E&&(c=f>2&&g(m.charCodeAt(2))?3:2,n=c);let i=-1,o=!0;for(let r=f-1;r>=n;--r)if(g(m.charCodeAt(r))){if(!o){i=r;break}}else o=!1;if(i===-1){if(c===-1)return".";i=c}return m.slice(0,i)},basename(m,f){f!==void 0&&u(f,"ext"),u(m,"path");let c=0,n=-1,s=!0,i;if(m.length>=2&&p(m.charCodeAt(0))&&m.charCodeAt(1)===E&&(c=2),f!==void 0&&f.length>0&&f.length<=m.length){if(f===m)return"";let o=f.length-1,r=-1;for(i=m.length-1;i>=c;--i){const l=m.charCodeAt(i);if(g(l)){if(!s){c=i+1;break}}else r===-1&&(s=!1,r=i+1),o>=0&&(l===f.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=r))}return c===n?n=r:n===-1&&(n=m.length),m.slice(c,n)}for(i=m.length-1;i>=c;--i)if(g(m.charCodeAt(i))){if(!s){c=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":m.slice(c,n)},extname(m){u(m,"path");let f=0,c=-1,n=0,s=-1,i=!0,o=0;m.length>=2&&m.charCodeAt(1)===E&&p(m.charCodeAt(0))&&(f=n=2);for(let r=m.length-1;r>=f;--r){const l=m.charCodeAt(r);if(g(l)){if(!i){n=r+1;break}continue}s===-1&&(i=!1,s=r+1),l===P?c===-1?c=r:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||s===-1||o===0||o===1&&c===s-1&&c===n+1?"":m.slice(c,s)},format:v.bind(null,"\\"),parse(m){u(m,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return f;const c=m.length;let n=0,s=m.charCodeAt(0);if(c===1)return g(s)?(f.root=f.dir=m,f):(f.base=f.name=m,f);if(g(s)){if(n=1,g(m.charCodeAt(1))){let M=2,T=M;for(;M<c&&!g(m.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&g(m.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!g(m.charCodeAt(M));)M++;M===c?n=M:M!==T&&(n=M+1)}}}}else if(p(s)&&m.charCodeAt(1)===E){if(c<=2)return f.root=f.dir=m,f;if(n=2,g(m.charCodeAt(2))){if(c===3)return f.root=f.dir=m,f;n=3}}n>0&&(f.root=m.slice(0,n));let i=-1,o=n,r=-1,l=!0,a=m.length-1,y=0;for(;a>=n;--a){if(s=m.charCodeAt(a),g(s)){if(!l){o=a+1;break}continue}r===-1&&(l=!1,r=a+1),s===P?i===-1?i=a:y!==1&&(y=1):i!==-1&&(y=-1)}return r!==-1&&(i===-1||y===0||y===1&&i===r-1&&i===o+1?f.base=f.name=m.slice(o,r):(f.name=m.slice(o,i),f.base=m.slice(o,r),f.ext=m.slice(i,r))),o>0&&o!==n?f.dir=m.slice(0,o-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let f="",c=!1;for(let n=m.length-1;n>=-1&&!c;n--){const s=n>=0?m[n]:I.cwd();u(s,"path"),s.length!==0&&(f=`${s}/${f}`,c=s.charCodeAt(0)===w)}return f=d(f,!c,"/",h),c?`/${f}`:f.length>0?f:"."},normalize(m){if(u(m,"path"),m.length===0)return".";const f=m.charCodeAt(0)===w,c=m.charCodeAt(m.length-1)===w;return m=d(m,!f,"/",h),m.length===0?f?"/":c?"./":".":(c&&(m+="/"),f?`/${m}`:m)},isAbsolute(m){return u(m,"path"),m.length>0&&m.charCodeAt(0)===w},join(...m){if(m.length===0)return".";let f;for(let c=0;c<m.length;++c){const n=m[c];u(n,"path"),n.length>0&&(f===void 0?f=n:f+=`/${n}`)}return f===void 0?".":e.posix.normalize(f)},relative(m,f){if(u(m,"from"),u(f,"to"),m===f||(m=e.posix.resolve(m),f=e.posix.resolve(f),m===f))return"";const c=1,n=m.length,s=n-c,i=1,o=f.length-i,r=s<o?s:o;let l=-1,a=0;for(;a<r;a++){const M=m.charCodeAt(c+a);if(M!==f.charCodeAt(i+a))break;M===w&&(l=a)}if(a===r)if(o>r){if(f.charCodeAt(i+a)===w)return f.slice(i+a+1);if(a===0)return f.slice(i+a)}else s>r&&(m.charCodeAt(c+a)===w?l=a:a===0&&(l=0));let y="";for(a=c+l+1;a<=n;++a)(a===n||m.charCodeAt(a)===w)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(i+l)}`},toNamespacedPath(m){return m},dirname(m){if(u(m,"path"),m.length===0)return".";const f=m.charCodeAt(0)===w;let c=-1,n=!0;for(let s=m.length-1;s>=1;--s)if(m.charCodeAt(s)===w){if(!n){c=s;break}}else n=!1;return c===-1?f?"/":".":f&&c===1?"//":m.slice(0,c)},basename(m,f){f!==void 0&&u(f,"ext"),u(m,"path");let c=0,n=-1,s=!0,i;if(f!==void 0&&f.length>0&&f.length<=m.length){if(f===m)return"";let o=f.length-1,r=-1;for(i=m.length-1;i>=0;--i){const l=m.charCodeAt(i);if(l===w){if(!s){c=i+1;break}}else r===-1&&(s=!1,r=i+1),o>=0&&(l===f.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=r))}return c===n?n=r:n===-1&&(n=m.length),m.slice(c,n)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===w){if(!s){c=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":m.slice(c,n)},extname(m){u(m,"path");let f=-1,c=0,n=-1,s=!0,i=0;for(let o=m.length-1;o>=0;--o){const r=m.charCodeAt(o);if(r===w){if(!s){c=o+1;break}continue}n===-1&&(s=!1,n=o+1),r===P?f===-1?f=o:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||n===-1||i===0||i===1&&f===n-1&&f===c+1?"":m.slice(f,n)},format:v.bind(null,"/"),parse(m){u(m,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return f;const c=m.charCodeAt(0)===w;let n;c?(f.root="/",n=1):n=0;let s=-1,i=0,o=-1,r=!0,l=m.length-1,a=0;for(;l>=n;--l){const y=m.charCodeAt(l);if(y===w){if(!r){i=l+1;break}continue}o===-1&&(r=!1,o=l+1),y===P?s===-1?s=l:a!==1&&(a=1):s!==-1&&(a=-1)}if(o!==-1){const y=i===0&&c?1:i;s===-1||a===0||a===1&&s===o-1&&s===i+1?f.base=f.name=m.slice(y,o):(f.name=m.slice(y,s),f.base=m.slice(y,o),f.ext=m.slice(s,o))}return i>0?f.dir=m.slice(0,i-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[80],ee([0,1,4]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...w){const S=w.reduce((b,u)=>(b[u]=!0,b),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!S[b]).forEach(b=>{for(let u=0;u<E.length;u++)if(b.search(E[u])!==-1){delete P[b];break}})}e.sanitizeProcessEnvironment=R;function D(P){!P||(delete P.DEBUG,I.isMacintosh&&delete P.DYLD_LIBRARY_PATH,I.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Z[81],ee([0,1,4]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?I.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[3],ee([0,1,16,49,2,95,81]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,w=!1;var S;(function(l){l.None=()=>k.Disposable.None;function a(O){if(w){const{onListenerDidAdd:_}=O,H=g.create();let Y=0;O.onListenerDidAdd=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),_?.()}}}function y(O){return(_,H=null,Y)=>{let se=!1,j;return j=O(re=>{if(!se)return j?j.dispose():se=!0,_.call(H,re)},null,Y),se&&j.dispose(),j}}l.once=y;function M(O,_,H){return Q((Y,se=null,j)=>O(re=>Y.call(se,_(re)),null,j),H)}l.map=M;function T(O,_,H){return Q((Y,se=null,j)=>O(re=>{_(re),Y.call(se,re)},null,j),H)}l.forEach=T;function N(O,_,H){return Q((Y,se=null,j)=>O(re=>_(re)&&Y.call(se,re),null,j),H)}l.filter=N;function G(O){return O}l.signal=G;function ae(...O){return(_,H=null,Y)=>(0,k.combinedDisposable)(...O.map(se=>se(j=>_.call(H,j),null,Y)))}l.any=ae;function X(O,_,H,Y){let se=H;return M(O,j=>(se=_(se,j),se),Y)}l.reduce=X;function Q(O,_){let H;const Y={onFirstListenerAdd(){H=O(se.fire,se)},onLastListenerRemove(){H?.dispose()}};_||a(Y);const se=new p(Y);return _?.add(se),se.event}function ie(O,_,H=100,Y=!1,se,j){let re,ne,ce,ge=0;const Re={leakWarningThreshold:se,onFirstListenerAdd(){re=O(Me=>{ge++,ne=_(ne,Me),Y&&!ce&&(Te.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Ae=ne;ne=void 0,ce=void 0,(!Y||ge>1)&&Te.fire(Ae),ge=0},H)})},onLastListenerRemove(){re.dispose()}};j||a(Re);const Te=new p(Re);return j?.add(Te),Te.event}l.debounce=ie;function oe(O,_=(Y,se)=>Y===se,H){let Y=!0,se;return N(O,j=>{const re=Y||!_(j,se);return Y=!1,se=j,re},H)}l.latch=oe;function he(O,_,H){return[l.filter(O,_,H),l.filter(O,Y=>!_(Y),H)]}l.split=he;function V(O,_=!1,H=[]){let Y=H.slice(),se=O(ne=>{Y?Y.push(ne):re.fire(ne)});const j=()=>{Y?.forEach(ne=>re.fire(ne)),Y=null},re=new p({onFirstListenerAdd(){se||(se=O(ne=>re.fire(ne)))},onFirstListenerDidAdd(){Y&&(_?setTimeout(j):j())},onLastListenerRemove(){se&&se.dispose(),se=null}});return re.event}l.buffer=V;class q{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new q(M(this.event,_,this.disposables))}forEach(_){return new q(T(this.event,_,this.disposables))}filter(_){return new q(N(this.event,_,this.disposables))}reduce(_,H){return new q(X(this.event,_,H,this.disposables))}latch(){return new q(oe(this.event,void 0,this.disposables))}debounce(_,H=100,Y=!1,se){return new q(ie(this.event,_,H,Y,se,this.disposables))}on(_,H,Y){return this.event(_,H,Y)}once(_,H,Y){return y(this.event)(_,H,Y)}dispose(){this.disposables.dispose()}}function F(O){return new q(O)}l.chain=F;function A(O,_,H=Y=>Y){const Y=(...ne)=>re.fire(H(...ne)),se=()=>O.on(_,Y),j=()=>O.removeListener(_,Y),re=new p({onFirstListenerAdd:se,onLastListenerRemove:j});return re.event}l.fromNodeEventEmitter=A;function W(O,_,H=Y=>Y){const Y=(...ne)=>re.fire(H(...ne)),se=()=>O.addEventListener(_,Y),j=()=>O.removeEventListener(_,Y),re=new p({onFirstListenerAdd:se,onLastListenerRemove:j});return re.event}l.fromDOMEventEmitter=W;function U(O){return new Promise(_=>y(O)(_))}l.toPromise=U;function J(O,_){return _(void 0),O(H=>_(H))}l.runAndSubscribe=J;function B(O,_){let H=null;function Y(j){H?.dispose(),H=new k.DisposableStore,_(j,H)}Y(void 0);const se=O(j=>Y(j));return(0,k.toDisposable)(()=>{se.dispose(),H?.dispose()})}l.runAndSubscribeWithStore=B;class ${constructor(_,H){this.obs=_,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};H||a(Y),this.emitter=new p(Y),H&&H.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,H){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new $(O,_).emitter.event}l.fromObservable=L})(S=e.Event||(e.Event={}));class E{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${E._idPool++}`,E.all.add(this)}start(a){this._stopWatch=new D.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=E,E.all=new Set,E._idPool=0;let C=-1;function b(l){const a=C;return C=l,{dispose(){C=a}}}e.setGlobalLeakWarningThreshold=b;class u{constructor(a,y=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=y,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,y){let M=C;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||y<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let N,G=0;for(const[ae,X]of this._stacks)(!N||G<X)&&(N=ae,G=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${G}):`),console.warn(N)}return()=>{const N=this._stacks.get(a.value)||0;this._stacks.set(a.value,N-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(a,y,M){this.callback=a,this.callbackThis=y,this.stack=M,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class p{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=C>0?new u(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const y of a)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,y,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,G;this._leakageMon&&this._listeners.size>=30&&(G=g.create(),N=this._leakageMon.check(G,this._listeners.size+1)),P&&(G=G??g.create());const ae=new h(a,y,G),X=this._listeners.push(ae);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,y);const Q=ae.subscription.set(()=>{N?.(),this._disposed||(X(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(Q):Array.isArray(M)&&M.push(Q),Q}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const y of this._listeners)this._deliveryQueue.push(this,y,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class d{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(a,y,M){this._queue.push(new m(a,y,M))}clear(a){const y=new R.LinkedList;for(const M of this._queue)M.emitter!==a&&y.push(M);this._queue=y}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(y){(0,I.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=d;class v extends d{clear(a){this._queue.clear()}}class m{constructor(a,y,M){this.emitter=a,this.listener=y,this.event=M}}class f extends p{async fireAsync(a,y,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,a]);for(;this._asyncDeliveryQueue.size>0&&!y.isCancellationRequested;){const[T,N]=this._asyncDeliveryQueue.shift(),G=[],ae={...N,token:y,waitUntil:X=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");M&&(X=M(X,T.callback)),G.push(X)}};try{T.invoke(ae)}catch(X){(0,I.onUnexpectedError)(X);continue}Object.freeze(G),await Promise.allSettled(G).then(X=>{for(const Q of X)Q.status==="rejected"&&(0,I.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=f;class c extends p{constructor(a){super(a),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class n extends c{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class s extends p{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(y=>super.fire(y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const y={event:a,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const M=()=>{this.hasListeners&&this.unhook(y);const T=this.events.indexOf(y);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(y=>this.emitter.fire(y))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(a){return(y,M,T)=>a(N=>{const G=this.buffers[this.buffers.length-1];G?G.push(()=>y.call(M,N)):y.call(M,N)},void 0,T)}bufferEvents(a){const y=[];this.buffers.push(y);const M=a();return this.buffers.pop(),y.forEach(T=>T()),M}}e.EventBufferer=o;class r{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=k.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(Z[23],ee([0,1,3]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,w){const S=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(S)}}});var k;(function(P){function w(S){return S===P.None||S===P.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(Z[137],ee([0,1,23]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new I.CancellationTokenSource,w=this.task(P.token);return this.result={promise:w,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class k{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const w=JSON.stringify(P);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const w=this.fn(P);return this._map.set(P,w),w}}e.CachedFunction=R}),define(Z[97],ee([0,1,3,2]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:I.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new I.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(Z[26],ee([0,1,137,124]),function(z,e,I,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function P(K,...le){return le.length===0?K:K.replace(D,function(fe,me){const Ee=parseInt(me,10);return isNaN(Ee)||Ee<0||Ee>=le.length?fe:le[Ee]})}e.format=P;const w=/{([^}]+)}/g;function S(K,le){return K.replace(w,(fe,me)=>le[me]??fe)}e.format2=S;function E(K){return K.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=E;function C(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function b(K,le){let fe=0;const me=le.charCodeAt(0);for(let Ee=K.length-1;Ee>=0;Ee--)K.charCodeAt(Ee)===me&&fe++;return fe}e.count=b;function u(K,le,fe="\u2026"){return K.length<=le?K:`${K.substr(0,le)}${fe}`}e.truncate=u;function g(K,le=" "){const fe=h(K,le);return p(fe,le)}e.trim=g;function h(K,le){if(!K||!le)return K;const fe=le.length;if(fe===0||K.length===0)return K;let me=0;for(;K.indexOf(le,me)===me;)me=me+fe;return K.substring(me)}e.ltrim=h;function p(K,le){if(!K||!le)return K;const fe=le.length,me=K.length;if(fe===0||me===0)return K;let Ee=me,Le=-1;for(;Le=K.lastIndexOf(le,Ee-1),!(Le===-1||Le+fe!==Ee);){if(Le===0)return"";Ee=Le}return K.substring(0,Ee)}e.rtrim=p;function d(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function m(K,le,fe={}){if(!K)throw new Error("Cannot create regex from empty string");le||(K=C(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=m;function f(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=n;function s(K){return K.split(/\r\n|\r|\n/)}e.splitLines=s;function i(K){for(let le=0,fe=K.length;le<fe;le++){const me=K.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function o(K,le=0,fe=K.length){for(let me=le;me<fe;me++){const Ee=K.charCodeAt(me);if(Ee!==32&&Ee!==9)return K.substring(le,me)}return K.substring(le,fe)}e.getLeadingWhitespace=o;function r(K,le=K.length-1){for(let fe=le;fe>=0;fe--){const me=K.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=r;function l(K,le,fe){const me=[];let Ee=0;for(const Le of K.matchAll(le)){if(me.push(K.slice(Ee,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Ee=Le.index+Le[0].length,me.push(fe(Le[0],...Le.slice(1),Le.index,K,Le.groups))}return me.push(K.slice(Ee)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=l;function a(K,le){return K<le?-1:K>le?1:0}e.compare=a;function y(K,le,fe=0,me=K.length,Ee=0,Le=le.length){for(;fe<me&&Ee<Le;fe++,Ee++){const Je=K.charCodeAt(fe),He=le.charCodeAt(Ee);if(Je<He)return-1;if(Je>He)return 1}const Ue=me-fe,it=Le-Ee;return Ue<it?-1:Ue>it?1:0}e.compareSubstring=y;function M(K,le){return T(K,le,0,K.length,0,le.length)}e.compareIgnoreCase=M;function T(K,le,fe=0,me=K.length,Ee=0,Le=le.length){for(;fe<me&&Ee<Le;fe++,Ee++){let Je=K.charCodeAt(fe),He=le.charCodeAt(Ee);if(Je===He)continue;if(Je>=128||He>=128)return y(K.toLowerCase(),le.toLowerCase(),fe,me,Ee,Le);G(Je)&&(Je-=32),G(He)&&(He-=32);const et=Je-He;if(et!==0)return et}const Ue=me-fe,it=Le-Ee;return Ue<it?-1:Ue>it?1:0}e.compareSubstringIgnoreCase=T;function N(K){return K>=48&&K<=57}e.isAsciiDigit=N;function G(K){return K>=97&&K<=122}e.isLowerAsciiLetter=G;function ae(K){return K>=65&&K<=90}e.isUpperAsciiLetter=ae;function X(K,le){return K.length===le.length&&T(K,le)===0}e.equalsIgnoreCase=X;function Q(K,le){const fe=le.length;return le.length>K.length?!1:T(K,le,0,fe)===0}e.startsWithIgnoreCase=Q;function ie(K,le){const fe=Math.min(K.length,le.length);let me;for(me=0;me<fe;me++)if(K.charCodeAt(me)!==le.charCodeAt(me))return me;return fe}e.commonPrefixLength=ie;function oe(K,le){const fe=Math.min(K.length,le.length);let me;const Ee=K.length-1,Le=le.length-1;for(me=0;me<fe;me++)if(K.charCodeAt(Ee-me)!==le.charCodeAt(Le-me))return me;return fe}e.commonSuffixLength=oe;function he(K){return 55296<=K&&K<=56319}e.isHighSurrogate=he;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function q(K,le){return(K-55296<<10)+(le-56320)+65536}e.computeCodePoint=q;function F(K,le,fe){const me=K.charCodeAt(fe);if(he(me)&&fe+1<le){const Ee=K.charCodeAt(fe+1);if(V(Ee))return q(me,Ee)}return me}e.getNextCodePoint=F;function A(K,le){const fe=K.charCodeAt(le-1);if(V(fe)&&le>1){const me=K.charCodeAt(le-2);if(he(me))return q(me,fe)}return fe}class W{get offset(){return this._offset}constructor(le,fe=0){this._str=le,this._len=le.length,this._offset=fe}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class U{get offset(){return this._iterator.offset}constructor(le,fe=0){this._iterator=new W(le,fe)}nextGraphemeLength(){const le=Fe.getInstance(),fe=this._iterator,me=fe.offset;let Ee=le.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Le=fe.offset,Ue=le.getGraphemeBreakType(fe.nextCodePoint());if(ye(Ee,Ue)){fe.setOffset(Le);break}Ee=Ue}return fe.offset-me}prevGraphemeLength(){const le=Fe.getInstance(),fe=this._iterator,me=fe.offset;let Ee=le.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Le=fe.offset,Ue=le.getGraphemeBreakType(fe.prevCodePoint());if(ye(Ue,Ee)){fe.setOffset(Le);break}Ee=Ue}return me-fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=U;function J(K,le){return new U(K,le).nextGraphemeLength()}e.nextCharLength=J;function B(K,le){return new U(K,le).prevGraphemeLength()}e.prevCharLength=B;function $(K,le){le>0&&V(K.charCodeAt(le))&&le--;const fe=le+J(K,le);return[fe-B(K,fe),fe]}e.getCharContainingOffset=$;function L(K){const le=new U(K);let fe=0;for(;!le.eol();)fe++,le.nextGraphemeLength();return fe}e.charCount=L;let O;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function H(K){return O||(O=_()),O.test(K)}e.containsRTL=H;const Y=/^[\t\n\r\x20-\x7E]*$/;function se(K){return Y.test(K)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=j;function re(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function ce(K,le){if(K.length<le)return K;const fe=/\b/g;let me=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<le);)me=fe.lastIndex,fe.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,Re=/\x1b\[\d+m/g,Te=/\x1b\[0?m/g;function Me(K){return K&&(K=K.replace(ge,""),K=K.replace(Re,""),K=K.replace(Te,"")),K}e.removeAnsiEscapeCodes=Me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function pe(K,le){if(!K||!le||K.length<le.length)return!1;const fe=le.length,me=K.toLowerCase();let Ee=0,Le=-1;for(;Ee<fe;){const Ue=me.indexOf(le[Ee],Le+1);if(Ue<0)return!1;Le=Ue,Ee++}return!0}e.fuzzyContains=pe;function Se(K,le=!1){return K?(le&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=ke;function x(K,le=1){if(le===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),le--;while(le>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=x;function ue(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=ue;function de(K){return Fe.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=de;function ye(K,le){return K===0?le!==5&&le!==7:K===2&&le===3?!1:K===4||K===2||K===3||le===4||le===2||le===3?!0:!(K===8&&(le===8||le===9||le===11||le===12)||(K===11||K===9)&&(le===9||le===10)||(K===12||K===10)&&le===10||le===5||le===13||le===7||K===1||K===13&&le===14||K===6&&le===6)}var Ce;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const fe=this._data,me=fe.length/3;let Ee=1;for(;Ee<=me;)if(le<fe[3*Ee])Ee=2*Ee;else if(le>fe[3*Ee+1])Ee=2*Ee+1;else return fe[3*Ee+2];return 0}}Fe._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(K,le){if(K===0)return 0;const fe=Ne(K,le);if(fe!==void 0)return fe;const me=new W(le,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=$e;function Ne(K,le){const fe=new W(le,K);let me=fe.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!ne(me))return;let Ee=fe.offset;return Ee>0&&fe.prevCodePoint()===8205&&(Ee=fe.offset),Ee}function je(K){return 127995<=K&&K<=127999}var Qe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(le){return Be.cache.get(Array.from(le))}static getLocales(){return Be._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new I.LRUCachedFunction(K=>{function le(He){const et=new Map;for(let nt=0;nt<He.length;nt+=2)et.set(He[nt],He[nt+1]);return et}function fe(He,et){const nt=new Map(He);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function me(He,et){if(!He)return et;const nt=new Map;for(const[lt,gt]of He)et.has(lt)&&nt.set(lt,gt);return nt}const Ee=k.ambiguousCharacterData.getValue();let Le=K.filter(He=>!He.startsWith("_")&&He in Ee);Le.length===0&&(Le=["_default"]);let Ue;for(const He of Le){const et=le(Ee[He]);Ue=me(Ue,et)}const it=le(Ee._common),Je=fe(it,Ue);return new Be(Je)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(le){return Ge.getData().has(le)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(Z[30],ee([0,1,9,4,26,12]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function P(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=P;function w(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function S(r,l=I.posix.sep){if(!r)return"";const a=r.length,y=r.charCodeAt(0);if(D(y)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let T=3;const N=T;for(;T<a&&!D(r.charCodeAt(T));T++);if(N!==T&&!D(r.charCodeAt(T+1))){for(T+=1;T<a;T++)if(D(r.charCodeAt(T)))return r.slice(0,T+1).replace(/[\\/]/g,l)}}return l}else if(d(y)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let M=r.indexOf("://");if(M!==-1){for(M+=3;M<a;M++)if(D(r.charCodeAt(M)))return r.slice(0,M+1)}return""}e.getRoot=S;function E(r){if(!t.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let a=2;const y=a;for(;a<r.length&&(l=r.charCodeAt(a),l!==92);a++);return!(y===a||(l=r.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=E;const C=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,l=t.isWindows){const a=l?C:b;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||l&&u.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function h(r,l,a){const y=r===l;return!a||y?y:!r||!l?!1:(0,k.equalsIgnoreCase)(r,l)}e.isEqual=h;function p(r,l,a,y=I.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let T=l.length;return l.charAt(l.length-1)===y&&T--,r.charAt(T)===y}return l.charAt(l.length-1)!==y&&(l+=y),r.indexOf(l)===0}e.isEqualOrParent=p;function d(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=d;function v(r,l){return t.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(l,r)),r=(0,I.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,k.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=v;function m(r){const l=(0,I.normalize)(r);return t.isWindows?r.length>3?!1:f(l)&&(r.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=m;function f(r,l=t.isWindows){return l?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(r){return f(r)?r[0]:void 0}e.getDriveLetter=c;function n(r,l,a){return l.length>r.length?-1:r===l?0:(a&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=n;function s(r){const l=r.split(":");let a,y,M;for(const T of l){const N=Number(T);(0,R.isNumber)(N)?y===void 0?y=N:M===void 0&&(M=N):a=a?[a,T].join(":"):T}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:y!==void 0?y:void 0,column:M!==void 0?M:y!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(r,l,a=8){let y="";for(let T=0;T<a;T++)y+=i.charAt(Math.floor(Math.random()*i.length));let M;return l?M=`${l}-${y}`:M=y,r?(0,I.join)(r,M):M}e.randomPath=o}),define(Z[67],ee([0,1,26]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return k(d,0)}e.hash=t;function k(d,v){switch(typeof d){case"object":return d===null?R(349,v):Array.isArray(d)?w(d,v):S(d,v);case"string":return P(d,v);case"boolean":return D(d,v);case"number":return R(d,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(d,v){return(v<<5)-v+d|0}e.numberHash=R;function D(d,v){return R(d?433:863,v)}function P(d,v){v=R(149417,v);for(let m=0,f=d.length;m<f;m++)v=R(d.charCodeAt(m),v);return v}e.stringHash=P;function w(d,v){return v=R(104579,v),d.reduce((m,f)=>k(f,m),v)}function S(d,v){return v=R(181387,v),Object.keys(d).sort().reduce((m,f)=>(m=P(f,m),k(d[f],m)),v)}class E{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=E;var C;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function b(d,v,m=32){const f=m-v,c=~((1<<f)-1);return(d<<v|(c&d)>>>f)>>>0}function u(d,v=0,m=d.byteLength,f=0){for(let c=0;c<m;c++)d[v+c]=f}function g(d,v,m="0"){for(;d.length<v;)d=m+d;return d}function h(d,v=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(m=>m.toString(16).padStart(2,"0")).join(""):g((d>>>0).toString(16),v/4)}e.toHexString=h;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const m=v.length;if(m===0)return;const f=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,s,i;for(n!==0?(s=n,i=-1,n=0):(s=v.charCodeAt(0),i=0);;){let o=s;if(I.isHighSurrogate(s))if(i+1<m){const r=v.charCodeAt(i+1);I.isLowSurrogate(r)?(i++,o=I.computeCodePoint(s,r)):o=65533}else{n=s;break}else I.isLowSurrogate(s)&&(o=65533);if(c=this._push(f,c,o),i++,i<m)s=v.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(v,m,f){return f<128?v[m++]=f:f<2048?(v[m++]=192|(f&1984)>>>6,v[m++]=128|(f&63)>>>0):f<65536?(v[m++]=224|(f&61440)>>>12,v[m++]=128|(f&4032)>>>6,v[m++]=128|(f&63)>>>0):(v[m++]=240|(f&1835008)>>>18,v[m++]=128|(f&258048)>>>12,v[m++]=128|(f&4032)>>>6,v[m++]=128|(f&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=p._bigBlock32,m=this._buffDV;for(let a=0;a<64;a+=4)v.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)v.setUint32(a,b(v.getUint32(a-12,!1)^v.getUint32(a-32,!1)^v.getUint32(a-56,!1)^v.getUint32(a-64,!1),1),!1);let f=this._h0,c=this._h1,n=this._h2,s=this._h3,i=this._h4,o,r,l;for(let a=0;a<80;a++)a<20?(o=c&n|~c&s,r=1518500249):a<40?(o=c^n^s,r=1859775393):a<60?(o=c&n|c&s|n&s,r=2400959708):(o=c^n^s,r=3395469782),l=b(f,5)+o+i+r+v.getUint32(a*4,!1)&4294967295,i=s,s=n,n=b(c,30),c=f,f=l;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[98],ee([0,1,26]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",P="warn",w="info",S="ignore";function E(b){return b?I.equalsIgnoreCase(R,b)?k.Error:I.equalsIgnoreCase(D,b)||I.equalsIgnoreCase(P,b)?k.Warning:I.equalsIgnoreCase(w,b)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function C(b){switch(b){case k.Error:return R;case k.Warning:return D;case k.Info:return w;default:return S}}k.toString=C}(t||(t={})),e.default=t}),define(Z[59],ee([0,1,24,26]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const g=u.charCodeAt(0),h=this._value.charCodeAt(this._pos);return g-h}value(){return this._value[this._pos]}}e.StringIterator=k;class R{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,t.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class D{constructor(u=!0,g=!0){this._splitOnBackslash=u,this._caseSensitive=g}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let g=u.length-1;g>=0;g--,this._valueLen--){const h=this._value.charCodeAt(g);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,t.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class w{constructor(u,g){this._ignorePathCasing=u,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,t.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(E||(E={}));class C{static forUris(u=()=>!1,g=()=>!1){return new C(new w(u,g))}static forPaths(u=!1){return new C(new D(void 0,!u))}static forStrings(){return new C(new k)}static forConfigKeys(){return new C(new R)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,g){if(g){const h=g.slice(0);(0,I.shuffle)(h);for(const p of h)this.set(p,u)}else{const h=u.slice(0);(0,I.shuffle)(h);for(const p of h)this.set(p[0],p[1])}}set(u,g){const h=this._iter.reset(u);let p;this._root||(this._root=new S,this._root.segment=h.value());const d=[];for(p=this._root;;){const m=h.cmp(p.segment);if(m>0)p.left||(p.left=new S,p.left.segment=h.value()),d.push([-1,p]),p=p.left;else if(m<0)p.right||(p.right=new S,p.right.segment=h.value()),d.push([1,p]),p=p.right;else if(h.hasNext())h.next(),p.mid||(p.mid=new S,p.mid.segment=h.value()),d.push([0,p]),p=p.mid;else break}const v=p.value;p.value=g,p.key=u;for(let m=d.length-1;m>=0;m--){const f=d[m][1];f.updateHeight();const c=f.balanceFactor();if(c<-1||c>1){const n=d[m][0],s=d[m+1][0];if(n===1&&s===1)d[m][1]=f.rotateLeft();else if(n===-1&&s===-1)d[m][1]=f.rotateRight();else if(n===1&&s===-1)f.right=d[m+1][1]=d[m+1][1].rotateRight(),d[m][1]=f.rotateLeft();else if(n===-1&&s===1)f.left=d[m+1][1]=d[m+1][1].rotateLeft(),d[m][1]=f.rotateRight();else throw new Error;if(m>0)switch(d[m-1][0]){case-1:d[m-1][1].left=d[m][1];break;case 1:d[m-1][1].right=d[m][1];break;case 0:d[m-1][1].mid=d[m][1];break}else this._root=d[0][1]}}return v}get(u){return this._getNode(u)?.value}_getNode(u){const g=this._iter.reset(u);let h=this._root;for(;h;){const p=g.cmp(h.segment);if(p>0)h=h.left;else if(p<0)h=h.right;else if(g.hasNext())g.next(),h=h.mid;else break}return h}has(u){const g=this._getNode(u);return!(g?.value===void 0&&g?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,g){const h=this._iter.reset(u),p=[];let d=this._root;for(;d;){const v=h.cmp(d.segment);if(v>0)p.push([-1,d]),d=d.left;else if(v<0)p.push([1,d]),d=d.right;else if(h.hasNext())h.next(),p.push([0,d]),d=d.mid;else break}if(!!d){if(g?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const v=this._min(d.right);if(v.key){const{key:m,value:f,segment:c}=v;this._delete(v.key,!1),d.key=m,d.value=f,d.segment=c}}else{const v=d.left??d.right;if(p.length>0){const[m,f]=p[p.length-1];switch(m){case-1:f.left=v;break;case 0:f.mid=v;break;case 1:f.right=v;break}}else this._root=v}for(let v=p.length-1;v>=0;v--){const m=p[v][1];m.updateHeight();const f=m.balanceFactor();if(f>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),p[v][1]=m.rotateLeft()):f<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),p[v][1]=m.rotateRight()),v>0)switch(p[v-1][0]){case-1:p[v-1][1].left=p[v][1];break;case 1:p[v-1][1].right=p[v][1];break;case 0:p[v-1][1].mid=p[v][1];break}else this._root=p[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const g=this._iter.reset(u);let h=this._root,p;for(;h;){const d=g.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(g.hasNext())g.next(),p=h.value||p,h=h.mid;else break}return h&&h.value||p}findSuperstr(u){const g=this._iter.reset(u);let h=this._root;for(;h;){const p=g.cmp(h.segment);if(p>0)h=h.left;else if(p<0)h=h.right;else if(g.hasNext())g.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(u){for(const[g,h]of this)u(h,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const g=[];return this._dfsEntries(u,g),g[Symbol.iterator]()}_dfsEntries(u,g){!u||(u.left&&this._dfsEntries(u.left,g),u.value&&g.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,g),u.right&&this._dfsEntries(u.right,g))}_isBalanced(){const u=g=>{if(!g)return!0;const h=g.balanceFactor();return h<-1||h>1?!1:u(g.left)&&u(g.right)};return u(this._root)}}e.TernarySearchTree=C}),define(Z[7],ee([0,1,9,4]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,o){return!i&&!o?"file":i}function S(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==C&&(o=C+o):o=C;break}return o}const E="",C="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(o){return o instanceof u?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,r,l,a,y,M=!1){typeof o=="object"?(this.scheme=o.scheme||E,this.authority=o.authority||E,this.path=o.path||E,this.query=o.query||E,this.fragment=o.fragment||E):(this.scheme=w(o,M),this.authority=r||E,this.path=S(this.scheme,l||E),this.query=a||E,this.fragment=y||E,P(this,M))}get fsPath(){return m(this,!1)}with(o){if(!o)return this;let{scheme:r,authority:l,path:a,query:y,fragment:M}=o;return r===void 0?r=this.scheme:r===null&&(r=E),l===void 0?l=this.authority:l===null&&(l=E),a===void 0?a=this.path:a===null&&(a=E),y===void 0?y=this.query:y===null&&(y=E),M===void 0?M=this.fragment:M===null&&(M=E),r===this.scheme&&l===this.authority&&a===this.path&&y===this.query&&M===this.fragment?this:new h(r,l,a,y,M)}static parse(o,r=!1){const l=b.exec(o);return l?new h(l[2]||E,s(l[4]||E),s(l[5]||E),s(l[7]||E),s(l[9]||E),r):new h(E,E,E,E,E)}static file(o){let r=E;if(t.isWindows&&(o=o.replace(/\\/g,C)),o[0]===C&&o[1]===C){const l=o.indexOf(C,2);l===-1?(r=o.substring(2),o=C):(r=o.substring(2,l),o=o.substring(l)||C)}return new h("file",r,o,E,E)}static from(o){const r=new h(o.scheme,o.authority,o.path,o.query,o.fragment);return P(r,!0),r}static joinPath(o,...r){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&o.scheme==="file"?l=u.file(I.win32.join(m(o,!0),...r)).path:l=I.posix.join(o.path,...r),o.with({path:l})}toString(o=!1){return f(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof u)return o;{const r=new h(o);return r._formatted=o.external,r._fsPath=o._sep===g?o.fsPath:null,r}}else return o}}e.URI=u;const g=t.isWindows?1:void 0;class h extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(o=!1){return o?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=g),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,o){let r,l=-1;for(let a=0;a<i.length;a++){const y=i.charCodeAt(a);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||o&&y===47)l!==-1&&(r+=encodeURIComponent(i.substring(l,a)),l=-1),r!==void 0&&(r+=i.charAt(a));else{r===void 0&&(r=i.substr(0,a));const M=p[y];M!==void 0?(l!==-1&&(r+=encodeURIComponent(i.substring(l,a)),l=-1),r+=M):l===-1&&(l=a)}}return l!==-1&&(r+=encodeURIComponent(i.substring(l))),r!==void 0?r:i}function v(i){let o;for(let r=0;r<i.length;r++){const l=i.charCodeAt(r);l===35||l===63?(o===void 0&&(o=i.substr(0,r)),o+=p[l]):o!==void 0&&(o+=i[r])}return o!==void 0?o:i}function m(i,o){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function f(i,o){const r=o?v:d;let l="",{scheme:a,authority:y,path:M,query:T,fragment:N}=i;if(a&&(l+=a,l+=":"),(y||a==="file")&&(l+=C,l+=C),y){let G=y.indexOf("@");if(G!==-1){const ae=y.substr(0,G);y=y.substr(G+1),G=ae.indexOf(":"),G===-1?l+=r(ae,!1):(l+=r(ae.substr(0,G),!1),l+=":",l+=r(ae.substr(G+1),!1)),l+="@"}y=y.toLowerCase(),G=y.indexOf(":"),G===-1?l+=r(y,!1):(l+=r(y.substr(0,G),!1),l+=y.substr(G))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const G=M.charCodeAt(1);G>=65&&G<=90&&(M=`/${String.fromCharCode(G+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const G=M.charCodeAt(0);G>=65&&G<=90&&(M=`${String.fromCharCode(G+32)}:${M.substr(2)}`)}l+=r(M,!0)}return T&&(l+="?",l+=r(T,!1)),N&&(l+="#",l+=o?N:d(N,!1)),l}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,o=>c(o)):i}}),define(Z[138],ee([0,1,7]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(S){const E=S;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=t;function k(S){const E=[];let C;try{const b=JSON.parse(S.arguments),u=b[b.length-1];u&&u.__$stack&&(b.pop(),C=u.__$stack),E.push(...b)}catch{E.push("Unable to log remote console arguments",S.arguments)}return{args:E,stack:C}}e.parse=k;function R(S){if(typeof S!="string")return R(k(S).stack);const E=S;if(E){const C=D(E),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function D(S){if(!S)return S;const E=S.indexOf(`
`);return E===-1?S:S.substring(0,E)}function P(S,E){const{args:C,stack:b}=k(S),u=typeof C[0]=="string"&&C.length===1;let g=D(b);g&&(g=`(${g.trim()})`);let h=[];if(typeof C[0]=="string"?g&&u?h=[`%c[${E}] %c${C[0]} %c${g}`,w("blue"),w(""),w("grey")]:h=[`%c[${E}] %c${C[0]}`,w("blue"),w(""),...C.slice(1)]:h=[`%c[${E}]%`,w("blue"),...C],g&&!u&&h.push(g),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,h)}e.log=P;function w(S){return`color: ${S}`}}),define(Z[68],ee([0,1,17,26,7]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(S){return JSON.stringify(S,P)}e.stringify=R;function D(S){let E=JSON.parse(S);return E=w(E),E}e.parse=D;function P(S,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,t.regExpFlags)(E)}:E}function w(S,E=0){if(!S||E>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return k.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 15:return new Date(S.source)}if(S instanceof I.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=w(S[C],E+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=w(S[C],E+1))}return S}e.revive=w}),define(Z[14],ee([0,1,4,7]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}setServerRootPath(S){this._remoteResourcesPath=`${S}/${k.vscodeRemoteResource}`}set(S,E,C){this._hosts[S]=E,this._ports[S]=C}setConnectionToken(S,E){this._connectionTokens[S]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const E=S.authority;let C=this._hosts[E];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const b=this._ports[E],u=this._connectionTokens[E];let g=`path=${encodeURIComponent(S.path)}`;return typeof u=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),t.URI.from({scheme:I.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${b}`,path:this._remoteResourcesPath,query:g})}}e.RemoteAuthorities=new R;class D{asBrowserUri(S,E){const C=this.toUri(S,E);return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(S,E){const C=this.toUri(S,E);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==D.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(S,E){return t.URI.isUri(S)?S:t.URI.parse(E.toUrl(S))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var P;(function(w){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(S.get("3"));const E="vscode-coi";function C(u){let g;typeof u=="string"?g=new URL(u).searchParams:u instanceof URL?g=u.searchParams:t.URI.isUri(u)&&(g=new URL(u.toString(!0)).searchParams);const h=g?.get(E);if(!!h)return S.get(h)}w.getHeadersFromQuery=C;function b(u,g,h){if(!globalThis.crossOriginIsolated)return;const p=g&&h?"3":h?"2":"1";u instanceof URLSearchParams?u.set(E,p):u[E]=p}w.addSearchParam=b})(P=e.COI||(e.COI={}))}),define(Z[18],ee([0,1,30,14,9,4,26,7]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=w;class S{constructor(g){this._ignorePathCasing=g}compare(g,h,p=!1){return g===h?0:(0,D.compare)(this.getComparisonKey(g,p),this.getComparisonKey(h,p))}isEqual(g,h,p=!1){return g===h?!0:!g||!h?!1:this.getComparisonKey(g,p)===this.getComparisonKey(h,p)}getComparisonKey(g,h=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,h,p=!1){if(g.scheme===h.scheme){if(g.scheme===t.Schemas.file)return I.isEqualOrParent(w(g),w(h),this._ignorePathCasing(g))&&g.query===h.query&&(p||g.fragment===h.fragment);if((0,e.isEqualAuthority)(g.authority,h.authority))return I.isEqualOrParent(g.path,h.path,this._ignorePathCasing(g),"/")&&g.query===h.query&&(p||g.fragment===h.fragment)}return!1}joinPath(g,...h){return P.URI.joinPath(g,...h)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return k.posix.basename(g.path)}extname(g){return k.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let h;return g.scheme===t.Schemas.file?h=P.URI.file(k.dirname(w(g))).path:(h=k.posix.dirname(g.path),g.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),h="/")),g.with({path:h})}normalizePath(g){if(!g.path.length)return g;let h;return g.scheme===t.Schemas.file?h=P.URI.file(k.normalize(w(g))).path:h=k.posix.normalize(g.path),g.with({path:h})}relativePath(g,h){if(g.scheme!==h.scheme||!(0,e.isEqualAuthority)(g.authority,h.authority))return;if(g.scheme===t.Schemas.file){const v=k.relative(w(g),w(h));return R.isWindows?I.toSlashes(v):v}let p=g.path||"/";const d=h.path||"/";if(this._ignorePathCasing(g)){let v=0;for(const m=Math.min(p.length,d.length);v<m&&!(p.charCodeAt(v)!==d.charCodeAt(v)&&p.charAt(v).toLowerCase()!==d.charAt(v).toLowerCase());v++);p=d.substr(0,v)+p.substr(v)}return k.posix.relative(p,d)}resolvePath(g,h){if(g.scheme===t.Schemas.file){const p=P.URI.file(k.resolve(w(g),h));return g.with({authority:p.authority,path:p.path})}return h=I.toPosixPath(h),g.with({path:k.posix.resolve(g.path,h)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,h){return g===h||g!==void 0&&h!==void 0&&(0,D.equalsIgnoreCase)(g,h)}hasTrailingPathSeparator(g,h=k.sep){if(g.scheme===t.Schemas.file){const p=w(g);return p.length>I.getRoot(p).length&&p[p.length-1]===h}else{const p=g.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,h=k.sep){return(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,h=k.sep){let p=!1;if(g.scheme===t.Schemas.file){const d=w(g);p=d!==void 0&&d.length===I.getRoot(d).length&&d[d.length-1]===h}else{h="/";const d=g.path;p=d.length===1&&d.charCodeAt(d.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(g,h)?g.with({path:g.path+"/"}):g}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(u=>u.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new S(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(u,g){const h=[];for(let p=0;p<u.length;p++){const d=g(u[p]);u.some((v,m)=>m===p?!1:(0,e.isEqualOrParent)(d,g(v)))||h.push(u[p])}return h}e.distinctParents=E;var C;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function g(h){const p=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(m=>{const[f,c]=m.split(":");f&&c&&p.set(f,c)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&p.set(u.META_DATA_MIME,v),p}u.parseMetaData=g})(C=e.DataUri||(e.DataUri={}));function b(u,g,h){if(g){let p=u.path;return p&&p[0]!==k.posix.sep&&(p=k.posix.sep+p),u.with({scheme:h,authority:g,path:p})}return u.with({scheme:h})}e.toLocalResource=b}),define(Z[8],ee([0,1,23,16,3,2,18,4]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w($){return!!$&&typeof $.then=="function"}e.isThenable=w;function S($){const L=new I.CancellationTokenSource,O=$(L.token),_=new Promise((H,Y)=>{const se=L.token.onCancellationRequested(()=>{se.dispose(),L.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(j=>{se.dispose(),L.dispose(),H(j)},j=>{se.dispose(),L.dispose(),Y(j)})});return new class{cancel(){L.cancel()}then(H,Y){return _.then(H,Y)}catch(H){return this.then(void 0,H)}finally(H){return _.finally(H)}}}e.createCancelablePromise=S;function E($,L,O){return new Promise((_,H)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),_(O)});$.then(_,H).finally(()=>Y.dispose())})}e.raceCancellation=E;function C($,L){return new Promise((O,_)=>{const H=L.onCancellationRequested(()=>{H.dispose(),_(new t.CancellationError)});$.then(O,_).finally(()=>H.dispose())})}e.raceCancellationError=C;async function b($){let L=-1;const O=$.map((H,Y)=>H.then(se=>(L=Y,se))),_=await Promise.race(O);return $.forEach((H,Y)=>{Y!==L&&H.cancel()}),_}e.raceCancellablePromises=b;function u($,L,O){let _;const H=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([$.finally(()=>clearTimeout(H)),new Promise(Y=>_=Y)])}e.raceTimeout=u;function g($){return new Promise((L,O)=>{const _=$();w(_)?_.then(L,O):L(_)})}e.asPromise=g;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(H=>{this.activePromise=null,O(H)},H=>{this.activePromise=null,_(H)})})}}e.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=p;class d{constructor(){this.promiseMap=new Map}queue(L,O){const H=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===H&&this.promiseMap.delete(L)});return this.promiseMap.set(L,H),H}}e.SequencerByKey=d;const v=($,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},m=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,Y)=>{this.doResolve=H,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?m(_):v(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(L){this.delayer=new f(L),this.throttler=new h}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i($,L){return L?new Promise((O,_)=>{const H=setTimeout(()=>{Y.dispose(),O()},$),Y=L.onCancellationRequested(()=>{clearTimeout(H),Y.dispose(),_(new t.CancellationError)})}):S(O=>i($,O))}e.timeout=i;function o($,L=0){const O=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=o;function r($){const L=[];let O=0;const _=$.length;function H(){return O<_?$[O++]():null}function Y(se){se!=null&&L.push(se);const j=H();return j?j.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.sequence=r;function l($,L=_=>!!_,O=null){let _=0;const H=$.length,Y=()=>{if(_>=H)return Promise.resolve(O);const se=$[_++];return Promise.resolve(se()).then(re=>L(re)?Promise.resolve(re):Y())};return Y()}e.first=l;function a($,L=_=>!!_,O=null){if($.length===0)return Promise.resolve(O);let _=$.length;const H=()=>{_=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,se)=>{for(const j of $)j.then(re=>{--_>=0&&L(re)?(H(),Y(re)):_===0&&Y(O)}).catch(re=>{--_>=0&&(H(),se(re))})})}e.firstParallel=a;class y{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class M extends y{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const _=O.getComparisonKey(L);let H=this.queues.get(_);return H||(H=new M,k.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,H)),H}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=N;class G{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=G;class ae{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class X{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=X;class Q extends ae{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q;class ie extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ie,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,P.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const O=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class oe{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=oe;async function he($,L,O){let _;for(let H=0;H<O;H++)try{return await $()}catch(Y){_=Y,await i(L)}throw _}e.retry=he;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const H=new Promise((Y,se)=>{O=Y,_=se});this._next={run:L,promise:H,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class q{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class F{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function($){async function L(_){let H;const Y=await Promise.all(_.map(se=>se.then(j=>j,j=>{H||(H=j)})));if(typeof H<"u")throw H;return Y}$.settled=L;function O(_){return new Promise(async(H,Y)=>{try{await _(H,Y)}catch(se){Y(se)}})}$.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(W||(W={}));class U{static fromArray(L){return new U(O=>{O.emitMany(L)})}static fromPromise(L){return new U(async O=>{O.emitMany(await L)})}static fromPromises(L){return new U(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new U(async O=>{await Promise.all(L.map(async _=>{for await(const H of _)O.emitOne(H)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new U(async _=>{for await(const H of L)_.emitOne(O(H))})}map(L){return U.map(this,L)}static filter(L,O){return new U(async _=>{for await(const H of L)O(H)&&_.emitOne(H)})}filter(L){return U.filter(this,L)}static coalesce(L){return U.filter(L,O=>!!O)}coalesce(){return U.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return U.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=U,U.EMPTY=U.fromArray([]);class J extends U{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function B($){const L=new I.CancellationTokenSource,O=$(L.token);return new J(L,async _=>{const H=L.token.onCancellationRequested(()=>{H.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const Y of O){if(L.token.isCancellationRequested)return;_.emitOne(Y)}H.dispose(),L.dispose()}catch(Y){H.dispose(),L.dispose(),_.reject(Y)}})}e.createCancelableAsyncIterable=B}),define(Z[99],ee([0,1,24,8,30,39,9,4,26]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",C="[^/\\\\]",b=/\//g;function u(F,A){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${E}|${C}+${E}${A?`|${E}${C}+`:""})*?`}}function g(F,A){if(!F)return[];const W=[];let U=!1,J=!1,B="";for(const $ of F){switch($){case A:if(!U&&!J){W.push(B),B="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":J=!0;break;case"]":J=!1;break}B+=$}return B&&W.push(B),W}e.splitGlobAware=g;function h(F){if(!F)return"";let A="";const W=g(F,e.GLOB_SPLIT);if(W.every(U=>U===e.GLOBSTAR))A=".*";else{let U=!1;W.forEach((J,B)=>{if(J===e.GLOBSTAR){if(U)return;A+=u(2,B===W.length-1)}else{let $=!1,L="",O=!1,_="";for(const H of J){if(H!=="}"&&$){L+=H;continue}if(O&&(H!=="]"||!_)){let Y;H==="-"?Y=H:(H==="^"||H==="!")&&!_?Y="^":H===e.GLOB_SPLIT?Y="":Y=(0,w.escapeRegExpCharacters)(H),_+=Y;continue}switch(H){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${g(L,",").map(j=>h(j)).join("|")})`,$=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=C;continue;case"*":A+=u(1);continue;default:A+=(0,w.escapeRegExpCharacters)(H)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=E)}U=J===e.GLOBSTAR})}return A}const p=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),s=function(){return!1},i=function(){return null};function o(F,A){if(!F)return i;let W;typeof F!="string"?W=F.pattern:W=F,W=W.trim();const U=`${W}_${!!A.trimForExclusions}`;let J=n.get(U);if(J)return r(J,F);let B;return p.test(W)?J=a(W.substr(4),W):(B=d.exec(l(W,A)))?J=y(B[1],W):(A.trimForExclusions?m:v).test(W)?J=M(W,A):(B=f.exec(l(W,A)))?J=T(B[1].substr(1),W,!0):(B=c.exec(l(W,A)))?J=T(B[1],W,!1):J=N(W),n.set(U,J),r(J,F)}function r(F,A){if(typeof A=="string")return F;const W=function(U,J){return(0,k.isEqualOrParent)(U,A.base,!P.isLinux)?F(U.substr(A.base.length+1),J):null};return W.allBasenames=F.allBasenames,W.allPaths=F.allPaths,W.basenames=F.basenames,W.patterns=F.patterns,W}function l(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function a(F,A){return function(W,U){return typeof W=="string"&&W.endsWith(F)?A:null}}function y(F,A){const W=`/${F}`,U=`\\${F}`,J=function($,L){return typeof $!="string"?null:L?L===F?A:null:$===F||$.endsWith(W)||$.endsWith(U)?A:null},B=[F];return J.basenames=B,J.patterns=[A],J.allBasenames=B,J}function M(F,A){const W=V(F.slice(1,-1).split(",").map(L=>o(L,A)).filter(L=>L!==i),F),U=W.length;if(!U)return i;if(U===1)return W[0];const J=function(L,O){for(let _=0,H=W.length;_<H;_++)if(W[_](L,O))return F;return null},B=W.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function T(F,A,W){const U=D.sep===D.posix.sep,J=U?F:F.replace(b,D.sep),B=D.sep+J,$=D.posix.sep+F;let L;return W?L=function(O,_){return typeof O=="string"&&(O===J||O.endsWith(B)||!U&&(O===F||O.endsWith($)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===J||!U&&O===F)?A:null},L.allPaths=[(W?"*/":"./")+F],L}function N(F){try{const A=new RegExp(`^${h(F)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?F:null}}catch{return i}}function G(F,A,W){return!F||typeof A!="string"?!1:ae(F)(A,void 0,W)}e.match=G;function ae(F,A={}){if(!F)return s;if(typeof F=="string"||X(F)){const W=o(F,A);if(W===i)return s;const U=function(J,B){return!!W(J,B)};return W.allBasenames&&(U.allBasenames=W.allBasenames),W.allPaths&&(U.allPaths=W.allPaths),U}return oe(F,A)}e.parse=ae;function X(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=X;function Q(F){return F.allBasenames||[]}e.getBasenameTerms=Q;function ie(F){return F.allPaths||[]}e.getPathTerms=ie;function oe(F,A){const W=V(Object.getOwnPropertyNames(F).map(L=>he(L,F[L],A)).filter(L=>L!==i)),U=W.length;if(!U)return i;if(!W.some(L=>!!L.requiresSiblings)){if(U===1)return W[0];const L=function(H,Y){let se;for(let j=0,re=W.length;j<re;j++){const ne=W[j](H,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(se||(se=[]),se.push(ne))}return se?(async()=>{for(const j of se){const re=await j;if(typeof re=="string")return re}return null})():null},O=W.find(H=>!!H.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=W.reduce((H,Y)=>Y.allPaths?H.concat(Y.allPaths):H,[]);return _.length&&(L.allPaths=_),L}const J=function(L,O,_){let H,Y;for(let se=0,j=W.length;se<j;se++){const re=W[se];re.requiresSiblings&&_&&(O||(O=(0,D.basename)(L)),H||(H=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=re(L,O,H,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const se of Y){const j=await se;if(typeof j=="string")return j}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function he(F,A,W){if(A===!1)return i;const U=o(F,W);if(U===i)return i;if(typeof A=="boolean")return U;if(A){const J=A.when;if(typeof J=="string"){const B=($,L,O,_)=>{if(!_||!U($,L))return null;const H=J.replace("$(basename)",O),Y=_(H);return(0,t.isThenable)(Y)?Y.then(se=>se?F:null):Y?F:null};return B.requiresSiblings=!0,B}}return U}function V(F,A){const W=F.filter(L=>!!L.basenames);if(W.length<2)return F;const U=W.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let J;if(A){J=[];for(let L=0,O=U.length;L<O;L++)J.push(A)}else J=W.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let H;for(H=L.length;H>0;H--){const Y=L.charCodeAt(H-1);if(Y===47||Y===92)break}O=L.substr(H)}const _=U.indexOf(O);return _!==-1?J[_]:null};B.basenames=U,B.patterns=J,B.allBasenames=U;const $=F.filter(L=>!L.basenames);return $.push(B),$}function q(F,A){return(0,I.equals)(F,A,(W,U)=>typeof W=="string"&&typeof U=="string"?W===U:typeof W!="string"&&typeof U!="string"?W.base===U.base&&W.pattern===U.pattern:!1)}e.patternsEquals=q}),define(Z[34],ee([0,1,24,30,9,4,18,26]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(i,o){const{os:r,tildify:l,relative:a}=o;if(a){const T=S(i,a,r);if(typeof T=="string")return T}let y=i.fsPath;if(r===1&&!R.isWindows?y=y.replace(/\//g,"\\"):r!==1&&R.isWindows&&(y=y.replace(/\\/g,"/")),r!==1&&l?.userHome){const T=l.userHome.fsPath;let N;i.scheme!==l.userHome.scheme&&i.path.startsWith(k.posix.sep)?N=l.userHome.with({path:i.path}).fsPath:N=i.fsPath,y=b(N,T,r)}return(r===1?k.win32:k.posix).normalize(E(y,r===1))}e.getPathLabel=w;function S(i,o,r){const l=r===1?k.win32:k.posix,a=r===3?D.extUri:D.extUriIgnorePathCase,y=o.getWorkspace(),M=(0,I.firstOrDefault)(y.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=o.getWorkspaceFolder(i);if(!T)return;let N;if(a.isEqual(T.uri,i)?N="":N=a.relativePath(T.uri,i)??"",N&&(N=l.normalize(N)),y.folders.length>1&&!o.noPrefix){const G=T.name?T.name:a.basenameOrAuthority(T.uri);N=N?`${G} \u2022 ${N}`:G}return N}function E(i,o=R.isWindows){return(0,t.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let C=Object.create(null);function b(i,o,r=R.OS){if(r===1||!i||!o)return i;let l=C.original===o?C.normalized:void 0;l||(l=o,R.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,P.rtrim)(l,k.posix.sep)}${k.posix.sep}`,C={original:o,normalized:l});let a=i;return R.isWindows&&(a=(0,t.toSlashes)(a)),(r===3?a.startsWith(l):(0,P.startsWithIgnoreCase)(a,l))?`~/${a.substr(l.length)}`:i}e.tildify=b;function u(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=u;const g="\u2026",h="\\\\",p="~";function d(i,o=k.sep){const r=new Array(i.length);let l=!1;for(let a=0;a<i.length;a++){const y=i[a];if(y===""){r[a]=`.${o}`;continue}if(!y){r[a]=y;continue}l=!0;let M="",T=y;T.indexOf(h)===0?(M=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(o)===0?(M=T.substr(0,T.indexOf(o)+o.length),T=T.substr(T.indexOf(o)+o.length)):T.indexOf(p)===0&&(M=T.substr(0,T.indexOf(p)+p.length),T=T.substr(T.indexOf(p)+p.length));const N=T.split(o);for(let G=1;l&&G<=N.length;G++)for(let ae=N.length-G;l&&ae>=0;ae--){l=!1;let X=N.slice(ae,ae+G).join(o);for(let Q=0;!l&&Q<i.length;Q++)if(Q!==a&&i[Q]&&i[Q].indexOf(X)>-1){const ie=ae+G===N.length,oe=ae>0&&i[Q].indexOf(o)>-1?o+X:X,he=i[Q].endsWith(oe);l=!ie||he}if(!l){let Q="";(N[0].endsWith(":")||M!=="")&&(ae===1&&(ae=0,G++,X=N[0]+o+X),ae>0&&(Q=N[0]+o),Q=M+Q),ae>0&&(Q=Q+g+o),Q=Q+X,ae+G<N.length&&(Q=Q+o+g),r[a]=Q}}l&&(r[a]=y)}return r}e.shorten=d;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function m(i,o=Object.create(null)){const r=[];let l=!1,a="";for(const y of i)if(y==="$"||l&&y==="{")a&&r.push({value:a,type:v.TEXT}),a="",l=!0;else if(y==="}"&&l){const M=o[a];if(typeof M=="string")M.length&&r.push({value:M,type:v.VARIABLE});else if(M){const T=r[r.length-1];(!T||T.type!==v.SEPARATOR)&&r.push({value:M.label,type:v.SEPARATOR})}a="",l=!1}else a+=y;return a&&!l&&r.push({value:a,type:v.TEXT}),r.filter((y,M)=>{if(y.type===v.SEPARATOR){const T=r[M-1],N=r[M+1];return[T,N].every(G=>G&&(G.type===v.VARIABLE||G.type===v.TEXT)&&G.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=m;function f(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function c(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,r=>r==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(i){const o=i.indexOf("/")!==-1?k.posix:k.win32,r=o.basename(i),l=o.dirname(i);return r.length?{name:r,parentPath:l}:{name:l,parentPath:""}}e.splitName=s}),define(Z[139],ee([0,1,7]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(E){return E.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const b=this._uriTransformer.transformIncoming(C);return b===C?C:t(I.URI.from(b))}transformOutgoing(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:t(I.URI.from(b))}transformOutgoingURI(C){const b=this._uriTransformer.transformOutgoing(C);return b===C?C:I.URI.from(b)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function R(E,C,b){if(!E||b>200)return null;if(typeof E=="object"){if(E instanceof I.URI)return C.transformOutgoing(E);for(const u in E)if(Object.hasOwnProperty.call(E,u)){const g=R(E[u],C,b+1);g!==null&&(E[u]=g)}}return null}function D(E,C){const b=R(E,C,0);return b===null?E:b}e.transformOutgoingURIs=D;function P(E,C,b,u){if(!E||u>200)return null;if(typeof E=="object"){if(E.$mid===1)return b?I.URI.revive(C.transformIncoming(E)):C.transformIncoming(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const h=P(E[g],C,b,u+1);h!==null&&(E[g]=h)}}return null}function w(E,C){const b=P(E,C,!1,0);return b===null?E:b}e.transformIncomingURIs=w;function S(E,C){const b=P(E,C,!0,0);return b===null?E:b}e.transformAndReviveIncomingURIs=S}),define(Z[82],ee([0,1,25,16,59,29,127]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,C=0;const b=(0,I.networkInterfaces)();for(const u in b){const g=b[u];if(g)for(const{mac:h,internal:p}of g)p||(C+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(E+=1))}this._value=C>0?E/C:0}return this._value}};let P;async function w(){return P||(P=(async()=>await S()||R.generateUuid())()),P}e.getMachineId=w;async function S(){try{const E=await new Promise((b,u)=>{z(["crypto"],b,u)}),C=(0,D.getMac)();return E.createHash("sha256").update(C,"utf8").digest("hex")}catch(E){t.onUnexpectedError(E);return}}}),define(Z[21],ee([0,1,40,25,140,8,30,77,9,4,18,7]),function(z,e,I,t,k,R,D,P,w,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function u(oe,he=b.UNLINK){if((0,D.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");return he===b.UNLINK?h(oe):g(oe)}async function g(oe){try{const he=(0,D.randomPath)((0,t.tmpdir)());try{await I.promises.rename(oe,he)}catch(V){return V.code==="ENOENT"?void 0:h(oe)}h(he).catch(V=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function h(oe){return(0,k.promisify)(I.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function p(oe){if((0,D.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function d(oe,he){return f(await(he?v(oe):(0,k.promisify)(I.readdir)(oe)))}async function v(oe){try{return await(0,k.promisify)(I.readdir)(oe,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const he=[],V=await d(oe);for(const q of V){let F=!1,A=!1,W=!1;try{const U=await e.Promises.lstat((0,w.join)(oe,q));F=U.isFile(),A=U.isDirectory(),W=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}he.push({name:q,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>W})}return he}function m(oe){return f(I.readdirSync(oe))}e.readdirSync=m;function f(oe){return oe.map(he=>typeof he=="string"?S.isMacintosh?(0,P.normalizeNFC)(he):he:(he.name=S.isMacintosh?(0,P.normalizeNFC)(he.name):he.name,he))}async function c(oe){const he=await d(oe),V=[];for(const q of he)await s.existsDirectory((0,w.join)(oe,q))&&V.push(q);return V}function n(oe,he=1e3){return new Promise(V=>{let q=!1;const F=setInterval(()=>{q||(q=!0,I.access(oe,A=>{q=!1,A&&(clearInterval(F),V(void 0))}))},he)})}e.whenDeleted=n;var s;(function(oe){async function he(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(S.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw U}throw W}}oe.stat=he;async function V(F){try{const{stat:A,symbolicLink:W}=await oe.stat(F);return A.isFile()&&W?.dangling!==!0}catch{}return!1}oe.existsFile=V;async function q(F){try{const{stat:A,symbolicLink:W}=await oe.stat(F);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}oe.existsDirectory=q})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function o(oe,he,V){return i.queueFor(C.URI.file(oe),E.extUriBiasedIgnorePathCase).queue(()=>{const q=M(V);return new Promise((F,A)=>a(oe,he,q,W=>W?A(W):F()))})}let r=!0;function l(oe){r=oe}e.configureFlushOnWrite=l;function a(oe,he,V,q){if(!r)return I.writeFile(oe,he,{mode:V.mode,flag:V.flag},q);I.open(oe,V.flag,V.mode,(F,A)=>{if(F)return q(F);I.writeFile(A,he,W=>{if(W)return I.close(A,()=>q(W));I.fdatasync(A,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),l(!1)),I.close(A,J=>q(J))))})})}function y(oe,he,V){const q=M(V);if(!r)return I.writeFileSync(oe,he,{mode:q.mode,flag:q.flag});const F=I.openSync(oe,q.flag,q.mode);try{I.writeFileSync(F,he);try{I.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),l(!1)}}finally{I.closeSync(F)}}e.writeFileSync=y;function M(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function T(oe,he){if(oe!==he)try{await e.Promises.rename(oe,he)}catch(V){if(oe.toLowerCase()!==he.toLowerCase()&&V.code==="EXDEV"||oe.endsWith("."))await N(oe,he,{preserveSymlinks:!1}),await u(oe,b.MOVE);else throw V}}async function N(oe,he,V){return ae(oe,he,{root:{source:oe,target:he},options:V,handledSourcePaths:new Set})}const G=511;async function ae(oe,he,V){if(V.handledSourcePaths.has(oe))return;V.handledSourcePaths.add(oe);const{stat:q,symbolicLink:F}=await s.stat(oe);if(F){if(V.options.preserveSymlinks)try{return await ie(oe,he,V)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return q.isDirectory()?X(oe,he,q.mode&G,V):Q(oe,he,q.mode&G)}async function X(oe,he,V,q){await e.Promises.mkdir(he,{recursive:!0,mode:V});const F=await d(oe);for(const A of F)await ae((0,w.join)(oe,A),(0,w.join)(he,A),q)}async function Q(oe,he,V){await e.Promises.copyFile(oe,he),await e.Promises.chmod(he,V)}async function ie(oe,he,V){let q=await e.Promises.readlink(oe);(0,D.isEqualOrParent)(q,V.root.source,!S.isLinux)&&(q=(0,w.join)(V.root.target,q.substr(V.root.source.length+1))),await e.Promises.symlink(q,he)}e.Promises=new class{get access(){return(0,k.promisify)(I.access)}get stat(){return(0,k.promisify)(I.stat)}get lstat(){return(0,k.promisify)(I.lstat)}get utimes(){return(0,k.promisify)(I.utimes)}get read(){return(oe,he,V,q,F)=>new Promise((A,W)=>{I.read(oe,he,V,q,F,(U,J,B)=>U?W(U):A({bytesRead:J,buffer:B}))})}get readFile(){return(0,k.promisify)(I.readFile)}get write(){return(oe,he,V,q,F)=>new Promise((A,W)=>{I.write(oe,he,V,q,F,(U,J,B)=>U?W(U):A({bytesWritten:J,buffer:B}))})}get appendFile(){return(0,k.promisify)(I.appendFile)}get fdatasync(){return(0,k.promisify)(I.fdatasync)}get truncate(){return(0,k.promisify)(I.truncate)}get rename(){return(0,k.promisify)(I.rename)}get copyFile(){return(0,k.promisify)(I.copyFile)}get open(){return(0,k.promisify)(I.open)}get close(){return(0,k.promisify)(I.close)}get symlink(){return(0,k.promisify)(I.symlink)}get readlink(){return(0,k.promisify)(I.readlink)}get chmod(){return(0,k.promisify)(I.chmod)}get mkdir(){return(0,k.promisify)(I.mkdir)}get unlink(){return(0,k.promisify)(I.unlink)}get rmdir(){return(0,k.promisify)(I.rmdir)}get realpath(){return(0,k.promisify)(I.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return c}get writeFile(){return o}get rm(){return u}get move(){return T}get copy(){return N}}}),define(Z[100],ee([0,1,40,9,4,26,21]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(b){if(k.isLinux)return b;const u=(0,t.dirname)(b);if(b===u)return b;const g=((0,t.basename)(b)||b).toLowerCase();try{const p=(0,D.readdirSync)(u).filter(d=>d.toLowerCase()===g);if(p.length===1){const d=P(u);if(d)return(0,t.join)(d,p[0])}else if(p.length>1){const d=p.indexOf(g);if(d>=0){const v=P(u);if(v)return(0,t.join)(v,p[d])}}}catch{}return null}e.realcaseSync=P;async function w(b){if(k.isLinux)return b;const u=(0,t.dirname)(b);if(b===u)return b;const g=((0,t.basename)(b)||b).toLowerCase();try{const p=(await D.Promises.readdir(u)).filter(d=>d.toLowerCase()===g);if(p.length===1){const d=await w(u);if(d)return(0,t.join)(d,p[0])}else if(p.length>1){const d=p.indexOf(g);if(d>=0){const v=await w(u);if(v)return(0,t.join)(v,p[d])}}}catch{}return null}e.realcase=w;async function S(b){try{return await D.Promises.realpath(b)}catch{const g=C(b);return await D.Promises.access(g,I.constants.R_OK),g}}e.realpath=S;function E(b){try{return I.realpathSync(b)}catch{const g=C(b);return I.accessSync(g,I.constants.R_OK),g}}e.realpathSync=E;function C(b){return(0,R.rtrim)((0,t.normalize)(b),t.sep)}}),define(Z[141],ee([0,1,25,9,21]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(w||(w={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class C{constructor(c,n,s){this.exePath=c,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:f=!1}={}){return f?S===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:f=!1,findPreview:c=!1}={}){const n=b({useAlternateBitness:f});if(!n)return null;const s=t.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let i=-1,o=null;for(const a of await k.Promises.readdir(s)){let y=-1;if(c){const T=a.indexOf("-");if(T<0)continue;const N=a.substring(0,T);if(!R.test(N)||a.substring(T+1)!=="preview")continue;y=parseInt(N,10)}else{if(!R.test(a))continue;y=parseInt(a,10)}if(y<=i)continue;const M=t.join(s,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(o=M,i=y)}if(!o)return null;const r=n.includes("x86")?" (x86)":"",l=c?" Preview":"";return new C(o,`PowerShell${l}${r}`,!0)}async function g({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(n.test(i)){const o=t.join(c,i,"pwsh.exe");return new C(o,s)}return null}function h(){const f=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(f,".NET Core PowerShell Global Tool")}function p(){const f=t.join(process.env.windir,S===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(f,"Windows PowerShell",!0)}async function*d(){let f=await u();f&&(yield f),f=await u({useAlternateBitness:!0}),f&&(yield f),f=await g(),f&&(yield f),f=h(),f&&(yield f),f=await u({findPreview:!0}),f&&(yield f),f=await g({findPreview:!0}),f&&(yield f),f=await u({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=p(),f&&(yield f)}async function*v(){for await(const f of d())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=v;async function m(){for await(const f of v())return f;return null}e.getFirstAvailablePowerShellInstallation=m}),define(Z[83],ee([0,1,9,4,33,80,12,21]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function w(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=w;function S(C){let b=[],u=!1;const g=function(h){if(u){b.push(h);return}(!C.send(h,d=>{if(d&&console.error(d),u=!1,b.length>0){const v=b.slice(0);b=[],v.forEach(m=>g(m))}})||t.isWindows)&&(u=!0)};return{send:g}}e.createQueuedSender=S;var E;(function(C){async function b(u,g,h){if(I.isAbsolute(u))return u;if(g===void 0&&(g=k.cwd()),I.dirname(u)!=="."||(h===void 0&&D.isString(k.env.PATH)&&(h=k.env.PATH.split(I.delimiter)),h===void 0||h.length===0))return I.join(g,u);async function d(v){if(await P.Promises.exists(v)){let m;try{m=await P.Promises.stat(v)}catch(f){f.message.startsWith("EACCES")&&(m=await P.Promises.lstat(v))}return m?!m.isDirectory():!1}return!1}for(const v of h){let m;if(I.isAbsolute(v)?m=I.join(v,u):m=I.join(g,v,u),await d(m))return m;let f=m+".com";if(await d(f)||(f=m+".exe",await d(f)))return f}return I.join(g,u)}C.findExecutable=b})(E=e.win32||(e.win32={}))}),define(Z[101],ee([0,1,45,14]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((P,w)=>{let S;const E=new Map;function C(u,g,h,p,d){const v=E.get(g);if(u===D||v){const m={name:b(h),cmd:h,pid:u,ppid:g,load:p,mem:d};E.set(u,m),u===D&&(S=m),v&&(v.children||(v.children=[]),v.children.push(m),v.children.length>1&&(v.children=v.children.sort((f,c)=>f.pid-c.pid)))}}function b(u){const g=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,m=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(m.exec(u))return"electron-crash-reporter";if(f.exec(u))return"winpty-process";if(c.exec(u))return"console-window-host (Windows internal process)";let s=n.exec(u);if(s&&s.length===2){if(s[1]==="renderer")return g.exec(u)?"shared-process":h.exec(u)?"issue-reporter":p.exec(u)?"process-explorer":"window";if(s[1]==="utility"){if(d.exec(u))return"utility-network-service";if(v.exec(u))return"extension-host"}return s[1]}const i=/[a-zA-Z-]+\.js/g;let o="";do s=i.exec(u),s&&(o+=s+" ");while(s);return o&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${o}`:u}if(process.platform==="win32"){const u=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,h)=>{z(["windows-process-tree"],g,h)}).then(g=>{g.getProcessList(D,h=>{if(!h){w(new Error(`Root process ${D} not found`));return}g.getProcessCpuUsage(h,p=>{const d=new Map;p.forEach(v=>{const m=u(v.commandLine||"");d.set(v.pid,{name:b(m),cmd:m,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),S=d.get(D),S?(d.forEach(v=>{const m=d.get(v.ppid);m&&(m.children||(m.children=[]),m.children.push(v))}),d.forEach(v=>{v.children&&(v.children=v.children.sort((m,f)=>m.pid-f.pid))}),P(S)):w(new Error(`Root process ${D} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let u=function(){let g=[S];const h=[];for(;g.length;){const d=g.shift();d&&(h.push(d.pid),d.children&&(g=g.concat(d.children)))}let p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);p+=" "+h.join(" "),(0,I.exec)(p,{},(d,v,m)=>{if(d||m)w(d||new Error(m.toString()));else{const f=v.toString().split(`
`);for(let c=0;c<h.length;c++){const n=E.get(h[c]);n.load=parseFloat(f[c])}if(!S){w(new Error(`Root process ${D} not found`));return}P(S)}})};(0,I.exec)("which ps",{},(g,h,p)=>{if(g||p)if(process.platform!=="linux")w(g||new Error(p.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,I.exec)(d,{},(v,m,f)=>{v||f?w(v||new Error(f.toString())):(R(m,C),u())})}else{const d=h.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${d} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,f,c)=>{m||c&&!c.includes("screen size is bogus")?w(m||new Error(c.toString())):(R(f,C),process.platform==="linux"?u():S?P(S):w(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=D.toString().split(`
`);for(const E of S){const C=w.exec(E.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(Z[142],ee([0,1,25,4,141,83]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(u,g){return u===1?t.isWindows?C():R.getWindowsShell(g):S(u,g)}e.getSystemShell=D;function P(u,g){return u===1?t.isWindows?b(g):R.getWindowsShell(g):S(u,g)}e.getSystemShellSync=P;let w=null;function S(u,g){if(t.isLinux&&u===2||t.isMacintosh&&u===3)return"/bin/bash";if(!w){let h;if(t.isWindows)h="/bin/bash";else{if(h=g.SHELL,!h)try{h=(0,I.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}w=h}return w}let E=null;async function C(){return E||(E=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),E}function b(u){if(E)return E;const g=t.isWindows&&parseFloat((0,I.release)())>=10,h=u.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${u.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?p:R.getWindowsShell(u)}});var we=this&&this.__decorate||function(z,e,I,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,I,t);else for(var P=z.length-1;P>=0;P--)(D=z[P])&&(R=(k<3?D(R):k>3?D(e,I,R):D(e,I))||R);return k>3&&R&&Object.defineProperty(e,I,R),R};define(Z[46],ee([0,1,24,8,17,23,53,16,3,2,68,26,12]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var u;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(u=e.RequestType||(e.RequestType={}));function g(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function p(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(d||(d={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function c(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function n(F){return F.read(4).readUInt32BE(0)}function s(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const i={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},o=typeof Buffer<"u";function r(F,A){if(typeof A>"u")F.write(i.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);F.write(i.String),F.write(c(W.byteLength)),F.write(W)}else if(o&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);F.write(i.Buffer),F.write(c(W.byteLength)),F.write(W)}else if(A instanceof k.VSBuffer)F.write(i.VSBuffer),F.write(c(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(i.Array),F.write(c(A.length));for(const W of A)r(F,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));F.write(i.Object),F.write(c(W.byteLength)),F.write(W)}}function l(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(n(F)).toString();case f.Buffer:return F.read(n(F)).buffer;case f.VSBuffer:return F.read(n(F));case f.Array:{const W=n(F),U=[];for(let J=0;J<W;J++)U.push(l(F));return U}case f.Object:return JSON.parse(F.read(n(F)).toString())}}class a{constructor(A,W,U=null,J=1e3){this.protocol=A,this.ctx=W,this.logger=U,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,p(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,p(A.type),A.data);return}}}send(A,W=void 0){const U=new m;return r(U,A),r(U,W),this.sendBuffer(U.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new v(A),U=l(W),J=l(W),B=U[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,U[1],1,`${g(B)}: ${U[2]}.${U[3]}`,J),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:J});case 102:return this.logger?.logIncoming(A.byteLength,U[1],1,`${g(B)}: ${U[2]}.${U[3]}`,J),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:J});case 101:return this.logger?.logIncoming(A.byteLength,U[1],1,`${g(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger?.logIncoming(A.byteLength,U[1],1,`${g(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const U=new R.CancellationTokenSource;let J;try{J=W.call(this.ctx,A.name,A.arg,U.token)}catch(L){J=Promise.reject(L)}const B=A.id;J.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const $=(0,S.toDisposable)(()=>U.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const U=A.id,B=W.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:U,data:$,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const U=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:U})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const U of W)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=W}getChannel(A){const W=this;return{call(U,J,B){return W.isDisposed?Promise.reject(new P.CancellationError):W.requestPromise(A,U,J,B)},listen(U,J){return W.isDisposed?w.Event.None:W.requestEvent(A,U,J)}}}requestPromise(A,W,U,J=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:U};if(J.isCancellationRequested)return Promise.reject(new P.CancellationError);let O;return new Promise((H,Y)=>{if(J.isCancellationRequested)return Y(new P.CancellationError);const se=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(B),H(ge.data);break;case 202:{this.handlers.delete(B);const Re=new Error(ge.data.message);Re.stack=ge.data.stack,Re.name=ge.data.name,Y(Re);break}case 203:this.handlers.delete(B),Y(ge.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let j=null;this.state===d.Idle?se():(j=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),j.then(()=>{j=null,se()}));const re=()=>{j?(j.cancel(),j=null):this.sendRequest({id:B,type:101}),Y(new P.CancellationError)},ne=J.onCancellationRequested(re);O=(0,S.combinedDisposable)((0,S.toDisposable)(re),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,U){const J=this.lastRequestId++,$={id:J,type:102,channelName:A,name:W,arg:U};let L=null;const O=new w.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(H=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest($)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:J,type:103}))}}),_=H=>O.fire(H.data);return this.handlers.set(J,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${g(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,g(A.type));return}}}send(A,W=void 0){const U=new m;return r(U,A),r(U,W),this.sendBuffer(U.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new v(A),U=l(W),J=l(W),B=U[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,p(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,U[1],0,p(B),J),this.onResponse({type:U[0],id:U[1],data:J})}}onResponse(A){if(A.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}we([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:U})=>{w.Event.once(W.onMessage)(B=>{const $=new v(B),L=l($),O=new a(W,L),_=new M(W);this.channels.forEach((Y,se)=>O.registerChannel(se,Y));const H={channelServer:O,channelClient:_,ctx:L};this._connections.add(H),this._onDidAddConnection.fire(H),U(()=>{O.dispose(),_.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}getChannel(A,W){const U=this;return{call(J,B,$){let L;if((0,b.isFunction)(W)){const _=(0,I.getRandomElement)(U.connections.filter(W));L=_?Promise.resolve(_):w.Event.toPromise(w.Event.filter(U.onDidAddConnection,W))}else L=W.routeCall(U,J,B);const O=L.then(_=>_.channelClient.getChannel(A));return G(O).call(J,B,$)},listen(J,B){if((0,b.isFunction)(W))return U.getMulticastEvent(A,W,J,B);const $=W.routeEvent(U,J,B).then(L=>L.channelClient.getChannel(A));return G($).listen(J,B)}}}getMulticastEvent(A,W,U,J){const B=this;let $=new S.DisposableStore;const L=new w.Emitter({onFirstListenerAdd:()=>{$=new S.DisposableStore;const O=new w.EventMultiplexer,_=new Map,H=se=>{const re=se.channelClient.getChannel(A).listen(U,J),ne=O.add(re);_.set(se,ne)},Y=se=>{const j=_.get(se);!j||(j.dispose(),_.delete(se))};B.connections.filter(W).forEach(H),w.Event.filter(B.onDidAddConnection,W)(H,void 0,$),B.onDidRemoveConnection(Y,void 0,$),O.event(L.fire,L,$),$.add(O)},onLastListenerRemove:()=>{$.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(U=>{U.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(A,W,U=null){const J=new m;r(J,W),A.send(J.buffer),this.channelClient=new M(A,U),this.channelServer=new a(A,W,U)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function G(F){return{call(A,W,U){return F.then(J=>J.call(A,W,U))},listen(A,W){const U=new w.Relay;return F.then(J=>U.input=J.listen(A,W)),U.event}}}e.getDelayedChannel=G;function ae(F){let A=!1;return{call(W,U,J){return A?F.call(W,U,J):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(W,U,J))},listen(W,U){if(A)return F.listen(W,U);const J=new w.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>J.input=F.listen(W,U)),J.event}}}e.getNextTickChannel=ae;class X{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await w.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=X;var Q;(function(F){function A(B,$){const L=B,O=$&&$.disableMarshalling,_=new Map;for(const H in L)U(H)&&_.set(H,w.Event.buffer(L[H],!0));return new class{listen(H,Y,se){const j=_.get(Y);if(j)return j;if(J(Y)){const re=L[Y];if(typeof re=="function")return re.call(L,se)}throw new Error(`Event not found: ${Y}`)}call(H,Y,se){const j=L[Y];if(typeof j=="function"){if(!O&&Array.isArray(se))for(let re=0;re<se.length;re++)se[re]=(0,E.revive)(se[re]);return j.apply(L,se)}throw new Error(`Method not found: ${Y}`)}}}F.fromService=A;function W(B,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return $?.properties?.has(_)?$.properties.get(_):J(_)?function(H){return B.listen(_,H)}:U(_)?B.listen(_):async function(...H){let Y;$&&!(0,b.isUndefinedOrNull)($.context)?Y=[$.context,...H]:Y=H;const se=await B.call(_,Y);return L?se:(0,E.revive)(se)};throw new Error(`Property not found: ${String(_)}`)}})}F.toService=W;function U(B){return B[0]==="o"&&B[1]==="n"&&C.isUpperAsciiLetter(B.charCodeAt(2))}function J(B){return/^onDynamic/.test(B)&&C.isUpperAsciiLetter(B.charCodeAt(9))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function he(F){return Array.isArray(F)?F.map(oe):oe(F)}function V(F,A,W,U,J,B,$){$=he($);const L=ie[J],O=L[U%L.length];let _=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat($),_.push(")")):_.push($),console.log.apply(console,_)}e.logWithColors=V;class q{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,U,J,B){this._totalOutgoing+=A,V(this._outgoingPrefix,this._totalOutgoing,A,W,U,J,B)}logIncoming(A,W,U,J,B){this._totalIncoming+=A,V(this._incomingPrefix,this._totalIncoming,A,W,U,J,B)}}e.IPCLogger=q}),define(Z[143],ee([0,1,17,3,46]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(w){this.port=w,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",S=>I.VSBuffer.wrap(S.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(w,S){const E=new R(w);super(E,S),this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=D}),define(Z[102],ee([0,1,17,3,2,46]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(o){o.enableDiagnostics=!1,o.records=[];const r=new WeakMap;let l=0;function a(M,T){if(!r.has(M)){const N=String(++l);r.set(M,N)}return r.get(M)}function y(M,T,N,G){if(!o.enableDiagnostics)return;const ae=a(M,T);if(G instanceof I.VSBuffer||G instanceof Uint8Array||G instanceof ArrayBuffer||ArrayBuffer.isView(G)){const X=I.VSBuffer.alloc(G.byteLength);X.set(G),o.records.push({timestamp:Date.now(),id:ae,label:T,type:N,buff:X})}else o.records.push({timestamp:Date.now(),id:ae,label:T,type:N,data:G})}o.traceSocketEvent=y})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function E(){return S||(S=I.VSBuffer.alloc(0)),S}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return E();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const T=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),T}if(this._chunks[0].byteLength>r){const T=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),T}const a=I.VSBuffer.alloc(r);let y=0,M=0;for(;r>0;){const T=this._chunks[M];if(T.byteLength>r){const N=T.slice(0,r);a.set(N,y),y+=r,l&&(this._chunks[M]=T.slice(r),this._totalLength-=r),r-=r}else a.set(T,y),y+=T.byteLength,l?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,r-=T.byteLength}return a}}e.ChunkStream=C;var b;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(b||(b={}));function u(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,l,a,y){this.type=r,this.id=l,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends k.Disposable{constructor(r){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:u(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,y=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new h(a,y,M,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=I.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:u(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(l,r.data)}_bufferAdd(r,l){const a=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,a}_bufferTake(){const r=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class v extends k.Disposable{constructor(r){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=v;class m extends R.IPCClient{static fromSocket(r,l){return new m(new v(r),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,l,a=null){super(r,l,a),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=m;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let r=0,l=this._first;for(;l;)l=l.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let l=0,a=this._first;for(;a;)r[l++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new c(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class s{static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<s._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=s._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),l=(1+s._HISTORY_LENGTH)*1e3;let a=0;for(let y=0;y<s._HISTORY_LENGTH;y++)r-this.lastRuns[y]<=l&&a++;return 1-a/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class i{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r,l=null,a=s.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,E());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new h(7,0,0,E());this._socketWriter.write(r)}sendResume(){const r=new h(8,0,0,E());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,E());this._socketWriter.write(r);const l=this._outgoingUnackMsg.toArray();for(let a=0,y=l.length;a<y;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new h(6,0,0,E())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,y=l.length;a<y;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const l=new h(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const M=Math.max(2e4-l,2e4-a,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,E());this._socketWriter.write(r)}_sendKeepAlive(){const r=new h(9,0,0,E());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(Z[144],ee([0,1,41,17,3,2,46,129]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(E,C){const b=k.Event.fromNodeEventEmitter(I.validatedIpcMain,C,(g,h)=>({event:g,message:h})),u=k.Event.filter(b,({event:g})=>g.sender.id===E);return k.Event.map(u,({message:g})=>g&&t.VSBuffer.wrap(g))}class S extends D.IPCServer{static getOnDidClientConnect(){const C=k.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(C,b=>{const u=b.id;S.Clients.get(u)?.dispose();const h=new k.Emitter;S.Clients.set(u,(0,R.toDisposable)(()=>h.fire()));const p=w(u,"vscode:message"),d=k.Event.any(k.Event.signal(w(u,"vscode:disconnect")),h.event);return{protocol:new P.Protocol(b,p),onDidClientDisconnect:d}})}constructor(){super(S.getOnDidClientConnect())}}e.Server=S,S.Clients=new Map}),define(Z[103],ee([0,1,41,3,29,143]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(S,E){super({addEventListener:(C,b)=>S.addListener(C,b),removeEventListener:(C,b)=>S.removeListener(C,b),postMessage:C=>S.postMessage(C),start:()=>S.start(),close:()=>S.close()},E)}}e.Client=D;async function P(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const S=(0,k.generateUuid)();w.webContents.send("vscode:createMessageChannel",S);const E=t.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(b,u)=>({nonce:u,port:b.ports[0]})),{port:C}=await t.Event.toPromise(t.Event.once(t.Event.filter(E,b=>b.nonce===S)));return C}e.connect=P}),define(Z[145],ee([0,1,45,8,17,23,138,16,3,2,50,83,80,46]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends u.ChannelServer{constructor(d){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=g;class h{constructor(d,v){this.modulePath=d,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(d){const v=this;return{call(m,f,c){return v.requestPromise(d,m,f,c)},listen(m,f){return v.requestEvent(d,m,f)}}}requestPromise(d,v,m,f=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(d),n=(0,t.createCancelablePromise)(o=>c.call(v,m,o)),s=f.onCancellationRequested(()=>n.cancel()),i=(0,S.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(d,v,m){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let f;const c=new w.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(d).listen(v,m)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,b.removeDangerousEnvVariables)(v.env),this.child=(0,I.fork)(this.modulePath,d,v);const m=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.options.serverName}`);return}m.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&c.send(r.buffer.toString("base64")),s=m.event,i={send:n,onMessage:s};this._client=new u.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",o),this.activeRequests.forEach(a=>(0,S.dispose)(a)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(d){let v=this.channels.get(d);return v||(v=this.client.getChannel(d),this.channels.set(d,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(Z[84],ee([0,1,17,16,3,2,9,4,29,46,102]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class b{traceSocketEvent(a,y){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,y)}constructor(a,y=""){this._canWrite=!0,this.debugLabel=y,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const y=M=>{this.traceSocketEvent("read",M),a(I.VSBuffer.wrap(M))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(a){const y=M=>{a({type:0,hadError:M,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(a){const y=()=>{a()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=b;var u;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(u||(u={}));var g;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(g||(g={}));class h extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,y){this.socket.traceSocketEvent(a,y)}constructor(a,y,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new p(this,y,M,T,this._onData,(N,G)=>this._write(N,G))),this._register(this._flowManager.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,y){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let M=2;a.byteLength<126?M+=0:a.byteLength<2**16?M+=2:M+=8;const T=I.VSBuffer.alloc(M);if(y?T.writeUInt8(194,0):T.writeUInt8(130,0),a.byteLength<126)T.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(a.byteLength>>>8&255,++N),T.writeUInt8(a.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(a.byteLength>>>24&255,++N),T.writeUInt8(a.byteLength>>>16&255,++N),T.writeUInt8(a.byteLength>>>8&255,++N),T.writeUInt8(a.byteLength>>>0&255,++N)}this.socket.write(I.VSBuffer.concat([T,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),M=y.readUInt8(0),T=(M&128)>>>7,N=(M&64)>>>6,G=y.readUInt8(1),ae=(G&128)>>>7,X=G&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(X===126?2:0)+(X===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),M=y.readUInt8(1),T=(M&128)>>>7;let N=M&127,G=1;N===126?N=y.readUInt8(++G)*2**8+y.readUInt8(++G):N===127&&(N=y.readUInt8(++G)*0+y.readUInt8(++G)*0+y.readUInt8(++G)*0+y.readUInt8(++G)*0+y.readUInt8(++G)*2**24+y.readUInt8(++G)*2**16+y.readUInt8(++G)*2**8+y.readUInt8(++G));let ae=0;T&&(ae=y.readUInt8(++G)*2**24+y.readUInt8(++G)*2**16+y.readUInt8(++G)*2**8+y.readUInt8(++G)),this._state.state=3,this._state.readLen=N,this._state.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),m(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class p extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(a,y,M,T,N,G){super(),this._tracer=a,this._onData=N,this._writeFn=G,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new d(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ae=>this._onError.fire(ae))),this._register(this._zlibDeflateStream.onError(ae=>this._onError.fire(ae)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const y=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(y,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,y){return new Promise((M,T)=>{a.write(y),a.flush(N=>M(N))})}acceptFrame(a,y,M){this._readQueue.push({data:a,isCompressed:y,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,y,M){return new Promise((T,N)=>{a.write(y),M&&a.write(I.VSBuffer.fromByteArray([0,0,255,255])),a.flush(G=>T(G))})}}class d extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.concat(this._recordedInflateBytes):I.VSBuffer.alloc(0)}constructor(a,y,M,T){super(),this._tracer=a,this._recordInflateBytes=y,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(T),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(I.VSBuffer.wrap(N))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=I.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(y)})}}class v extends R.Disposable{constructor(a,y){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(I.VSBuffer.wrap(M))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=I.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),a(y)})}}function m(l,a){if(a===0)return;const y=l.byteLength>>>2;for(let X=0;X<y;X++){const Q=l.readUInt32BE(X*4);l.writeUInt32BE(Q^a,X*4)}const M=y*4,T=l.byteLength-M,N=a>>>24&255,G=a>>>16&255,ae=a>>>8&255;T>=1&&l.writeUInt8(l.readUInt8(M)^N,M),T>=2&&l.writeUInt8(l.readUInt8(M+1)^G,M+1),T>=3&&l.writeUInt8(l.readUInt8(M+2)^ae,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function c(){const l=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,D.join)(C().os.tmpdir(),`vscode-ipc-${l}.sock`),s(a),a}e.createRandomIPCHandle=c;function n(l,a,y){const M=C().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${y}-${a}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${y}-${a}.sock`):T=(0,D.join)(l,`${y}-${a}.sock`),s(T),T}e.createStaticIPCHandle=n;function s(l){const a=f[P.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends S.IPCServer{static toClientConnectionEvent(a){const y=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(y,M=>({protocol:new E.Protocol(new b(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(a){super(i.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function o(l){return new Promise((a,y)=>{const M=C().net.createServer();M.on("error",y),M.listen(l,()=>{M.removeListener("error",y),a(new i(M))})})}e.serve=o;function r(l,a){return new Promise((y,M)=>{const T=C().net.createConnection(l,()=>{T.removeListener("error",M),y(E.Client.fromSocket(new b(T,`ipc-client${a}`),a))});T.once("error",M)})}e.connect=r}),define(Z[104],ee([0,1,8,3,2,12]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function P(C){const b=C;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class S extends k.Disposable{constructor(b,u=Object.create(null)){super(),this.database=b,this.options=u,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((u,g)=>this.accept(g,u)),b.deleted?.forEach(u=>this.accept(u,void 0))}accept(b,u){if(this.state===w.Closed)return;let g=!1;(0,R.isUndefinedOrNull)(u)?g=this.cache.delete(b):this.cache.get(b)!==u&&(this.cache.set(b,u),g=!0),g&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,u){const g=this.cache.get(b);return(0,R.isUndefinedOrNull)(g)?u:g}getBoolean(b,u){const g=this.get(b);return(0,R.isUndefinedOrNull)(g)?u:g==="true"}getNumber(b,u){const g=this.get(b);return(0,R.isUndefinedOrNull)(g)?u:parseInt(g,10)}async set(b,u){if(this.state===w.Closed)return;if((0,R.isUndefinedOrNull)(u))return this.delete(b);const g=String(u);if(this.cache.get(b)!==g)return this.cache.set(b,g),this.pendingInserts.set(b,g),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async delete(b){if(!(this.state===w.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(b){if(!!this.hasPending)return this.doFlush(b)}async doFlush(b){return this.flushDelayer.trigger(()=>this.flushPending(),b)}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert?.forEach((u,g)=>this.items.set(g,u)),b.delete?.forEach(u=>this.items.delete(u))}async close(){}}e.InMemoryStorageDatabase=E}),define(Z[146],ee([0,1,8,3,39,9,21]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(E,C=Object.create(null)){this.path=E,this.options=C,this.name=(0,R.basename)(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const E=await this.whenConnected,C=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(u=>C.set(u.key,u.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${C.size} rows`),C}async updateItems(E){const C=await this.whenConnected;return this.doUpdateItems(C,E)}doUpdateItems(E,C){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${C.insert?(0,k.mapToString)(C.insert):"0"}), delete(${C.delete?(0,k.setToString)(C.delete):"0"})`),this.transaction(E,()=>{const b=C.insert,u=C.delete;if(b&&b.size>0){const g=[];g.push([]);let h=0;b.forEach((p,d)=>{let v=g[h];v.length>P.MAX_HOST_PARAMETERS&&(h++,v=[],g.push(v)),v.push(d,p)}),g.forEach(p=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,d=>d.run(p),()=>{const d=[];let v=0;return b.forEach((m,f)=>{d.push(f),v+=m.length}),`Keys: ${d.join(", ")} Length: ${v}`})})}if(u&&u.size){const g=[];g.push([]);let h=0;u.forEach(p=>{let d=g[h];d.length>P.MAX_HOST_PARAMETERS&&(h++,d=[],g.push(d)),d.push(p)}),g.forEach(p=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,d=>d.run(p),()=>{const d=[];return u.forEach(v=>{d.push(v)}),`Keys: ${d.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const C=await this.whenConnected;return this.doClose(C,E)}doClose(E,C){return new Promise((b,u)=>{E.db.close(g=>(g&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${g}`),this.path===P.IN_MEMORY_PATH?b():!E.isErroneous&&!E.isInMemory?this.backup().then(b,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),b())):typeof C=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const p=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:C()}).then(()=>p(),d=>(p(),Promise.reject(d)))})).then(b,u):u(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return D.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const C=await this.whenConnected,b=await this.get(C,E?"PRAGMA integrity_check":"PRAGMA quick_check"),u=E?b.integrity_check:b.quick_check;return C.isErroneous?`${u} (last error: ${C.lastError})`:C.isInMemory?`${u} (in-memory!)`:u}async connect(E,C=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${C})`);try{return await this.doConnect(E)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&C)return await(0,I.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await D.Promises.unlink(E);try{await D.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(u){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${u}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(E,C){E.isErroneous=!0,E.lastError=C,this.logger.error(C)}doConnect(E){return new Promise((C,b)=>{new Promise((u,g)=>{z(["@vscode/sqlite3"],u,g)}).then(u=>{const g={db:new(this.logger.isTracing?u.verbose().Database:u.Database)(E,h=>h?g.db&&h.code!=="SQLITE_CANTOPEN"?g.db.close(()=>b(h)):b(h):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>C(g),p=>g.db.close(()=>b(p)))),isInMemory:E===P.IN_MEMORY_PATH};g.db.on("error",h=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&g.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},b)})}exec(E,C){return new Promise((b,u)=>{E.db.exec(C,g=>g?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${g}`),u(g)):b())})}get(E,C){return new Promise((b,u)=>{E.db.get(C,(g,h)=>g?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${g}`),u(g)):b(h))})}all(E,C){return new Promise((b,u)=>{E.db.all(C,(g,h)=>g?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${g}`),u(g)):b(h))})}transaction(E,C){return new Promise((b,u)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),C(),E.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${g}`),u(g)):b())})})}prepare(E,C,b,u){const g=E.db.prepare(C),h=p=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${p} (${C}). Details: ${u()}`)};g.on("error",h),b(g),g.finalize(p=>{p&&h(p),g.removeListener("error",h)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256;class w{constructor(E){E&&typeof E.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace?.(E)}error(E){this.logError?.(E)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[147],ee([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(Z[148],ee([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[149],ee([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[150],ee([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(Z[151],ee([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(Z[152],ee([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[153],ee([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[154],ee([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[155],ee([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[156],ee([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[157],ee([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(Z[158],ee([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(Z[159],ee([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(Z[160],ee([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[161],ee([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[162],ee([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[163],ee([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[164],ee([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[165],ee([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(Z[166],ee([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(Z[167],ee([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[168],ee([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[169],ee([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[170],ee([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[171],ee([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[172],ee([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(Z[173],ee([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[174],ee([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[175],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[176],ee([0,1,7]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(w=>({workspace:{id:w.id,configPath:I.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=k;function R(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(w=>({folderUri:I.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=R}),define(Z[177],ee([0,1,3,2]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}call(P,w,S){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:S[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:S[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:S[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:S[0],port:S[1],subId:S[2]}))}throw new Error("Method not implemented.")}listen(P,w,S){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,w,S){this.channel.call("attach",[P,w,S])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,w){this.channel.call("terminate",[P,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,w){return this.channel.call("openExtensionDevelopmentHostWindow",[P,w])}}e.ExtensionHostDebugChannelClient=R}),define(Z[178],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class I{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>z(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=I}),define(Z[179],ee([0,1,132,53,14,9,33,18,7]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=D.env.VSCODE_PORTABLE;return h?w.URI.file((0,R.join)(h,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,R.resolve)(h):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?w.URI.file((0,R.resolve)(h)):w.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,R.resolve)(h);const p=D.env.VSCODE_EXTENSIONS;if(p)return p;const d=D.env.VSCODE_PORTABLE;return d?(0,R.join)(d,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,R.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?w.URI.parse(h):w.URI.file((0,R.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const p of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);d&&d[1]&&d[2]&&h.push([d[1],d[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=D.env.VSCODE_PORTABLE;return h?w.URI.file((0,R.join)(h,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,p,d){this._args=h,this.paths=p,this.productService=d,this.editSessionId=this.args.editSessionId}}we([t.memoize],S.prototype,"appRoot",null),we([t.memoize],S.prototype,"userHome",null),we([t.memoize],S.prototype,"userDataPath",null),we([t.memoize],S.prototype,"appSettingsHome",null),we([t.memoize],S.prototype,"tmpDir",null),we([t.memoize],S.prototype,"cacheHome",null),we([t.memoize],S.prototype,"stateResource",null),we([t.memoize],S.prototype,"userRoamingDataHome",null),we([t.memoize],S.prototype,"userDataSyncHome",null),we([t.memoize],S.prototype,"userDataSyncLogResource",null),we([t.memoize],S.prototype,"editSessionsLogResource",null),we([t.memoize],S.prototype,"sync",null),we([t.memoize],S.prototype,"machineSettingsResource",null),we([t.memoize],S.prototype,"workspaceStorageHome",null),we([t.memoize],S.prototype,"localHistoryHome",null),we([t.memoize],S.prototype,"keyboardLayoutResource",null),we([t.memoize],S.prototype,"argvResource",null),we([t.memoize],S.prototype,"isExtensionDevelopment",null),we([t.memoize],S.prototype,"untitledWorkspacesHome",null),we([t.memoize],S.prototype,"installSourcePath",null),we([t.memoize],S.prototype,"builtinExtensionsPath",null),we([t.memoize],S.prototype,"extensionsPath",null),we([t.memoize],S.prototype,"extensionDevelopmentLocationURI",null),we([t.memoize],S.prototype,"extensionDevelopmentKind",null),we([t.memoize],S.prototype,"extensionTestsLocationURI",null),we([t.memoize],S.prototype,"debugExtensionHost",null),we([t.memoize],S.prototype,"logLevel",null),we([t.memoize],S.prototype,"extensionLogLevel",null),we([t.memoize],S.prototype,"serviceMachineIdResource",null),we([t.memoize],S.prototype,"telemetryLogResource",null),we([t.memoize],S.prototype,"disableWorkspaceTrust",null),we([t.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function E(g,h){return u(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=E;function C(g,h){return u(g["inspect-search"],g["inspect-brk-search"],5876,h,g.extensionEnvironment)}e.parseSearchPort=C;function b(g,h){return u(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,h,g.extensionEnvironment)}e.parsePtyHostPort=b;function u(g,h,p,d,v,m){const c=Number(h||g)||(d?null:p),n=c?Boolean(!!h):!1;let s;if(m)try{s=JSON.parse(m)}catch{}return{port:c,break:n,debugId:v,env:s}}}),define(Z[105],ee([0,1,278,4,150]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,p,d=D){const v=h.find(l=>l.length>0&&l[0]!=="-"),m={},f=["_"],c=[],n={};let s;for(const l in p){const a=p[l];a.type==="subcommand"?l===v&&(s=a):(a.alias&&(m[l]=a.alias),a.type==="string"||a.type==="string[]"?(f.push(l),a.deprecates&&f.push(...a.deprecates)):a.type==="boolean"&&(c.push(l),a.deprecates&&c.push(...a.deprecates)),a.global&&(n[l]=a))}if(s&&v){const l=n;for(const T in s.options)l[T]=s.options[T];const a=h.filter(T=>T!==v),y=d.getSubcommandReporter?d.getSubcommandReporter(v):void 0,M=P(a,l,y);return{[v]:M,_:[]}}const i=I(h,{string:f,boolean:c,alias:m}),o={},r=i;o._=i._.map(l=>String(l)).filter(l=>l.length>0),delete r._;for(const l in p){const a=p[l];if(a.type==="subcommand")continue;a.alias&&delete r[a.alias];let y=r[l];if(a.deprecates)for(const M of a.deprecates)r.hasOwnProperty(M)&&(y||(y=r[M],y&&d.onDeprecatedOption(M,a.deprecationMessage||(0,k.localize)(36,null,l))),delete r[M]);if(typeof y<"u"){if(a.type==="string[]"){if(Array.isArray(y)||(y=[y]),!a.allowEmptyValue){const M=y.filter(T=>T.length>0);M.length!==y.length&&(d.onEmptyValue(l),y=M.length>0?M:void 0)}}else a.type==="string"&&(Array.isArray(y)?(y=y.pop(),d.onMultipleValues(l,y)):!y&&!a.allowEmptyValue&&(d.onEmptyValue(l),y=void 0));o[l]=y,a.deprecationMessage&&d.onDeprecatedOption(l,a.deprecationMessage)}delete r[l]}for(const l in r)d.onUnknownOption(l);return o}e.parseArgs=P;function w(h,p){let d="";return p.args&&(Array.isArray(p.args)?d=` <${p.args.join("> <")}>`:d=` <${p.args}>`),p.alias?`-${p.alias} --${h}${d}`:`--${h}${d}`}function S(h,p){const d=[];for(const v in h){const m=h[v],f=w(v,m);d.push([f,m.description])}return E(d,p)}e.formatOptions=S;function E(h,p){const v=h.reduce((c,n)=>Math.max(c,n[0].length),12)+2+1;if(p-v<25)return h.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const m=p-v-1,f=[];for(const c of h){const n=c[0],s=b(c[1],m),i=C(v-n.length-2);f.push("  "+n+i+s[0]);for(let o=1;o<s.length;o++)f.push(C(v)+s[o])}return f}function C(h){return" ".repeat(h)}function b(h,p){const d=[];for(;h.length;){const v=h.length<p?h.length:h.lastIndexOf(" ",p),m=h.slice(0,v).trim();h=h.slice(v),d.push(m)}return d}function u(h,p,d,v,m){const f=process.stdout.isTTY&&process.stdout.columns||80,c=m?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",n=[`${h} ${d}`];n.push(""),n.push(`${(0,k.localize)(38,null)}: ${p} [${(0,k.localize)(39,null)}]${c}`),n.push(""),m?.noPipe!==!0&&(t.isWindows?n.push((0,k.localize)(40,null,p)):n.push((0,k.localize)(41,null,p)),n.push(""));const s={},i=[];for(const o in v){const r=v[o];if(r.type==="subcommand")r.description&&i.push({command:o,description:r.description});else if(r.description&&r.cat){let l=s[r.cat];l||(s[r.cat]=l={}),l[o]=r}}for(const o in s){const r=o,l=s[r];l&&(n.push(R[r]),n.push(...S(l,f)),n.push(""))}return i.length&&(n.push((0,k.localize)(42,null)),n.push(...E(i.map(o=>[o.command,o.description]),f)),n.push("")),n.join(`
`)}e.buildHelpMessage=u;function g(h,p){return`${h||(0,k.localize)(43,null)}
${p||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=g}),define(Z[180],ee([0,1,79,177,105]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(P,w){super(),this.windowsMainService=P,this.userDataProfilesMainService=w}call(P,w,S){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(S[0],S[1]):super.call(P,w,S)}async openExtensionDevelopmentHostWindow(P,w){const S=(0,k.parseArgs)(P,k.OPTIONS);S.debugRenderer=w;const E=S.extensionDevelopmentPath;if(!E)return{success:!1};const[C]=await this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:S,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(S)});if(!w)return{success:!0};const b=C.win;if(!b)return{success:!0};const u=b.webContents.debugger;let g=u.isAttached()?1/0:0;const h=(0,I.createServer)(p=>{g++===0&&u.attach();let d=!1;const v=c=>{d||p.write(JSON.stringify(c)+"\0")},m=(c,n,s,i)=>v({method:n,params:s,sessionId:i});b.on("close",()=>{u.removeListener("message",m),p.end(),d=!0}),u.addListener("message",m);let f=Buffer.alloc(0);p.on("data",c=>{f=Buffer.concat([f,c]);for(let n=f.indexOf(0);n!==-1;n=f.indexOf(0)){let s;try{const i=f.slice(0,n).toString("utf8");f=f.slice(n+1),s=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}u.sendCommand(s.method,s.params,s.sessionId).then(i=>v({id:s.id,sessionId:s.sessionId,result:i})).catch(i=>v({id:s.id,sessionId:s.sessionId,error:{code:0,message:i.message}}))}}),p.on("error",c=>{console.error("error on cdp pipe:",c)}),p.on("close",()=>{d=!0,--g===0&&u.detach()})});return await new Promise(p=>h.listen(0,p)),b.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[60],ee([0,1,279,151,105]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(b,u){const g=(f,c)=>{console.warn((0,t.localize)(0,null,f,c))},h=f=>{console.warn((0,t.localize)(1,null,f))},p=(f,c)=>{console.warn((0,t.localize)(2,null,f,c))},d=f=>({onUnknownOption:c=>{f!=="tunnel"&&console.warn((0,t.localize)(3,null,c,f))},onMultipleValues:g,onEmptyValue:h,onDeprecatedOption:p,getSubcommandReporter:f!=="tunnel"?d:void 0}),v={onUnknownOption:f=>{console.warn((0,t.localize)(4,null,f))},onMultipleValues:g,onEmptyValue:h,onDeprecatedOption:p,getSubcommandReporter:d},m=(0,k.parseArgs)(b,k.OPTIONS,u?v:void 0);return m.goto&&m._.forEach(f=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(5,null))),m["max-memory"]&&I(parseInt(m["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),m}function P(b){const u=b.findIndex(g=>!/^-/.test(g));if(u>-1)return[...b.slice(0,u),...b.slice(u+1)]}function w(b){let[,...u]=b;process.env.VSCODE_DEV&&(u=P(u)||[]);const g=!C(process.env);return D(u,g)}e.parseMainProcessArgv=w;function S(b){let[,,...u]=b;return process.env.VSCODE_DEV&&(u=P(u)||[]),D(u,!0)}e.parseCLIProcessArgv=S;function E(b,...u){const g=b.indexOf("--");return g===-1?b.push(...u):b.splice(g,0,...u),b}e.addArg=E;function C(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function z(e,I,t){function k(D,P){const w=R(D,P),S=[w];return e.isAbsolute(w)||S.unshift(t),e.resolve(...S)}function R(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,P);const E=D["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(C,"AppData","Roaming")}break;case"darwin":S=e.join(I.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,P)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[181],ee([182,25,33]),function(e,I,t){return z(e,I,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=z(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[183],ee([0,1,25,179,181]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,w.nameShort)},w)}}e.NativeEnvironmentService=R}),define(Z[184],ee([0,1,40,25,30]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const P=(0,k.randomPath)((0,t.tmpdir)());try{return(0,I.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(w){D&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFileSync=R}),define(Z[185],ee([0,1,12,153]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,P,w){try{R(D,P,w)}catch{}return D}e.localizeManifest=k;function R(D,P,w){const S=(E,C,b)=>{const u=E[C];if((0,I.isString)(u)){const g=u,h=g.length;if(h>1&&g[0]==="%"&&g[h-1]==="%"){const p=g.substr(1,h-2);let d=P[p];d===void 0&&w&&(d=w[p]);const v=typeof d=="string"?d:d.message;if(v!==void 0){const m=w?.[p],f=typeof m=="string"?m:m?.message;if(b&&(C==="title"||C==="category")&&f&&f!==v){const c={value:v,original:f};E[C]=c}else E[C]=v}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,p)}`)}}else if((0,I.isObject)(u))for(const g in u)u.hasOwnProperty(g)&&(g==="commands"?S(u,g,!0):S(u,g,b));else if(Array.isArray(u))for(let g=0;g<u.length;g++)S(u,g,b)};for(const E in D)D.hasOwnProperty(E)&&S(D,E)}}),define(Z[186],ee([0,1,18,98,155,187]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(d){return d=d.trim(),d==="*"||D.test(d)}e.isValidVersionStr=w;function S(d){if(!w(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=d.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=S;function E(d){if(!d)return null;const v=d.majorBase,m=d.majorMustEqual,f=d.minorBase;let c=d.minorMustEqual;const n=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(v===0||(c=!1),s=!1);let i=0;if(d.preRelease){const o=P.exec(d.preRelease);if(o){const[,r,l,a]=o;i=Date.UTC(Number(r),Number(l)-1,Number(a))}}return{majorBase:v,majorMustEqual:m,minorBase:f,minorMustEqual:c,patchBase:n,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=E;function C(d,v,m){let f;typeof d=="string"?f=E(S(d)):f=d;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let n;if(typeof m=="string"?n=E(S(m)):n=m,!f||!n)return!1;const s=f.majorBase,i=f.minorBase,o=f.patchBase;let r=n.majorBase,l=n.minorBase,a=n.patchBase;const y=n.notBefore;let M=n.majorMustEqual,T=n.minorMustEqual,N=n.patchMustEqual;return n.isMinimum?s>r?!0:s<r?!1:i>l?!0:i<l||c&&c<y?!1:o>=a:(s===1&&r===0&&(!M||!T||!N)&&(r=1,l=0,a=0,M=!0,T=!1,N=!1),s<r?!1:s>r?!M:i<l?!1:i>l?!T:o<a?!1:o>a?!N:!(c&&c<y))}e.isValidVersion=C;function b(d,v,m,f,c){const n=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return n.push([t.default.Error,k.localize(0,null)]),n;if(typeof f.name!="string")return n.push([t.default.Error,k.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([t.default.Error,k.localize(2,null,"version")]),n;if(!f.engines)return n.push([t.default.Error,k.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([t.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies<"u"&&!p(f.extensionDependencies))return n.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents<"u"){if(!p(f.activationEvents))return n.push([t.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof f.main>"u"&&typeof f.browser>"u")return n.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&n.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return n.push([t.default.Error,k.localize(9,null,"main")]),n;{const o=(0,I.joinPath)(m,f.main);(0,I.isEqualOrParent)(o,m)||n.push([t.default.Warning,k.localize(10,null,o.path,m.path)])}if(typeof f.activationEvents>"u")return n.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof f.browser<"u"){if(typeof f.browser!="string")return n.push([t.default.Error,k.localize(12,null,"browser")]),n;{const o=(0,I.joinPath)(m,f.browser);(0,I.isEqualOrParent)(o,m)||n.push([t.default.Warning,k.localize(13,null,o.path,m.path)])}if(typeof f.activationEvents>"u")return n.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(f.version))return n.push([t.default.Error,k.localize(15,null)]),n;const s=[];if(!u(d,v,f,c,s))for(const o of s)n.push([t.default.Error,o]);return n}e.validateExtensionManifest=b;function u(d,v,m,f,c){return f||typeof m.main>"u"&&typeof m.browser>"u"?!0:h(d,v,m.engines.vscode,c)}e.isValidExtensionVersion=u;function g(d,v,m){return d==="*"||h(v,m,d)}e.isEngineValid=g;function h(d,v,m,f=[]){const c=E(S(m));if(!c)return f.push(k.localize(16,null,m)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return f.push(k.localize(17,null,m)),!1}else if(!c.majorMustEqual)return f.push(k.localize(18,null,m)),!1;return C(d,v,c)?!0:(f.push(k.localize(19,null,d,m)),!1)}function p(d){if(!Array.isArray(d))return!1;for(let v=0,m=d.length;v<m;v++)if(typeof d[v]!="string")return!1;return!0}}),define(Z[188],ee([0,1,17,29]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const E=(await D.readFile(R.serviceMachineIdResource)).value.toString();w=(0,t.isUUID)(E)?E:null}catch{w=null}if(!w){w=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,I.VSBuffer.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=k}),define(Z[69],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=I}),define(Z[189],ee([0,1,69]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(P,w,S){w instanceof I.SyncDescriptor||(w=new I.SyncDescriptor(w,[],Boolean(S))),t.push([P,w])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(Z[190],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const P=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(D);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let P=this._nodes.get(D);return P||(P=new I(D,R),this._nodes.set(D,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,P]of this._nodes)R.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const P=new Set([R]),w=this._findCycle(D,P);if(w)return w}}_findCycle(R,D){for(const[P,w]of R.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const S=this._findCycle(w,D);if(S)return S;D.delete(P)}}}e.Graph=t}),define(Z[5],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(I=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,P,w){P[I.DI_TARGET]===P?P[I.DI_DEPENDENCIES].push({id:D,index:w}):(P[I.DI_DEPENDENCIES]=[{id:D,index:w}],P[I.DI_TARGET]=P)}function k(D){if(I.serviceIds.has(D))return I.serviceIds.get(D);const P=function(w,S,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,w,E)};return P.toString=()=>D,I.serviceIds.set(D,P),P}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(Z[61],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(Z[19],ee([0,1,12,7,5]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function S(d,v){const m=Object.create(null);for(const f in d)E(m,f,d[f],v);return m}e.toValuesTree=S;function E(d,v,m,f){const c=v.split("."),n=c.pop();let s=d;for(let i=0;i<c.length;i++){const o=c[i];let r=s[o];switch(typeof r){case"undefined":r=s[o]=Object.create(null);break;case"object":break;default:f(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[n]=m}catch{f(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=E;function C(d,v){const m=v.split(".");b(d,m)}e.removeFromValueTree=C;function b(d,v){const m=v.shift();if(v.length===0){delete d[m];return}if(Object.keys(d).indexOf(m)!==-1){const f=d[m];typeof f=="object"&&!Array.isArray(f)&&(b(f,v),Object.keys(f).length===0&&delete d[m])}}function u(d,v,m){function f(s,i){let o=s;for(const r of i){if(typeof o!="object"||o===null)return;o=o[r]}return o}const c=v.split("."),n=f(d,c);return typeof n>"u"?m:n}e.getConfigurationValue=u;function g(d,v,m){Object.keys(v).forEach(f=>{f!=="__proto__"&&(f in d?I.isObject(d[f])&&I.isObject(v[f])?g(d[f],v[f],m):m&&(d[f]=v[f]):d[f]=v[f])})}e.merge=g;function h(d,v,m){const f=d.inspect(v),c=d.inspect(m);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:f.defaultValue}e.getMigratedSettingValue=h;function p(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(Z[70],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,P){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=P}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const P of Object.keys(this.secretVault[R]||{}))D.push({account:P,password:this.secretVault[R][P]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[85],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(Z[106],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(Z[35],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,53,9,84,35,183,5]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(R.IEnvironmentService);class w extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}we([I.memoize],w.prototype,"cachedLanguagesPath",null),we([I.memoize],w.prototype,"backupHome",null),we([I.memoize],w.prototype,"mainIPCHandle",null),we([I.memoize],w.prototype,"mainLockfile",null),we([I.memoize],w.prototype,"disableUpdates",null),we([I.memoize],w.prototype,"disableKeytar",null),we([I.memoize],w.prototype,"crossOriginIsolated",null),we([I.memoize],w.prototype,"codeCachePath",null),we([I.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(Z[191],ee([0,1,152,5]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(d,v){switch(d){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(d,v){return v==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(d,v,m){return P(v,m)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===m?!0:S(m).includes(d)}e.isTargetPlatformCompatible=w;function S(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function E(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=E;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var b;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var u;(function(d){d.Install="install",d.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var h;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(v,m){super(v),this.code=m,this.name=m}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[192],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(Z[193],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[107],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(Z[194],ee([0,1,45,14,9,4,80,21,83,156,107]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=S.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends b{openTerminal(f,c){return this.spawnTerminal(I,f,w.getWindowsShell(),c)}spawnTerminal(f,c,n,s){const i=c.windowsExec||u.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=k.basename(i).toLowerCase();if(o==="cmder"||o==="cmder.exe")return f.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return i.indexOf(" ")>=0&&r.push('""'),r.push(i),(o==="wt"||o==="wt.exe")&&r.push("-d ."),new Promise((l,a)=>{const y=p(process),M=f.spawn(n,r,{cwd:s,env:y});M.on("error",a),M.on("exit",()=>l())})}runInTerminal(f,c,n,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:u.getDefaultTerminalWindows();return new Promise((r,l)=>{const a=`"${c} - ${C}"`,y=`""${n.join('" "')}" & pause"`,M=["/c","start",a,"/wait",o,"/c",y],T=Object.assign({},p(process),s);Object.keys(T).filter(ae=>T[ae]===null).forEach(ae=>delete T[ae]);const N={cwd:c,env:T,windowsVerbatimArguments:!0};I.spawn(u.CMD,M,N).on("error",ae=>{l(d(ae))}),r(void 0)})}static getDefaultTerminalWindows(){if(!u._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return u._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=u,u.CMD="cmd.exe";class g extends b{openTerminal(f,c){return this.spawnTerminal(I,f,c)}runInTerminal(f,c,n,s,i){const o=i.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(o===E.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const a=o===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,z).fsPath,"-t",f||C,"-w",c];for(const G of n)M.push("-a"),M.push(G);if(s){const G=Object.assign({},p(process),s);for(const ae in G){const X=G[ae];X===null?(M.push("-u"),M.push(ae)):(M.push("-e"),M.push(`${ae}=${X}`))}}let T="";const N=I.spawn(g.OSASCRIPT,M);N.on("error",G=>{l(d(G))}),N.stderr.on("data",G=>{T+=G.toString()}),N.on("exit",G=>{if(G===0)r(void 0);else if(T){const ae=T.split(`
`,1);l(new Error(ae[0]))}else l(new Error(S.localize(1,null,a,G)))})}else l(new Error(S.localize(2,null,o)))})}spawnTerminal(f,c,n){const s=c.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const r=["-a",s];n&&r.push(n);const l=p(process),a=f.spawn("/usr/bin/open",r,{cwd:n,env:l});a.on("error",o),a.on("exit",()=>i())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class h extends b{openTerminal(f,c){return this.spawnTerminal(I,f,c)}runInTerminal(f,c,n,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{const a=[];o.then(y=>{y.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const M=`${v(n)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;a.push(`''${M}''`);const T=Object.assign({},p(process),s);Object.keys(T).filter(X=>T[X]===null).forEach(X=>delete T[X]);const N={cwd:c,env:T};let G="";const ae=I.spawn(y,a,N);ae.on("error",X=>{l(d(X))}),ae.stderr.on("data",X=>{G+=X.toString()}),ae.on("exit",X=>{if(X===0)r(void 0);else if(G){const Q=G.split(`
`,1);l(new Error(Q[0]))}else l(new Error(S.localize(4,null,y,X)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const f=await P.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{f?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,c,n){const s=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(r=>{const l=p(process),a=f.spawn(r,[],{cwd:n,env:l});a.on("error",o),a.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=S.localize(3,null);function p(m){const f={...m.env};return(0,D.sanitizeProcessEnvironment)(f),f}function d(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(S.localize(5,null,m.path)):m}function v(m){let f="";for(const c of m)c.indexOf(" ")>=0?f+='"'+c+'"':f+=c,f+=" ";return f}}),define(Z[15],ee([0,1,59,9,26,12,7,158,5]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function S(V){return V.create===!0}e.isFileOpenForWriteOptions=S;var E;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var C;(function(V){V[V.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var b;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=u;function g(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=g;function h(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=h;function p(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function d(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=d;function v(V){return u(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var m;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(q,F){super(q),this.code=F}}e.FileSystemProviderError=f;function c(V,q){const F=new f(V.toString(),q);return s(F,q),F}e.createFileSystemProviderError=c;function n(V){return V||c((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=n;function s(V,q){return V.name=q?`${q} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=s;function i(V){if(!V)return m.Unknown;if(V instanceof f)return V.code;const q=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!q)return m.Unknown;switch(q[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=i;function o(V){if(V instanceof T)return V.fileOperationResult;switch(i(V)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class l{constructor(q,F,A){this.resource=q,this.operation=F,this.target=A}isOperation(q){return this.operation===q}}e.FileOperationEvent=l;var a;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class y{constructor(q,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=q;const A=new Map;for(const W of q){const U=A.get(W.type);switch(U?U.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,U]of A)switch(W){case 1:this.added=I.TernarySearchTree.forUris(()=>F),this.added.fill(U);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>F),this.updated.fill(U);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>F),this.deleted.fill(U);break}}contains(q,...F){return this.doContains(q,{includeChildren:!1},...F)}affects(q,...F){return this.doContains(q,{includeChildren:!0},...F)}doContains(q,F,...A){if(!q)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get(q)||F.includeChildren&&this.added?.findSuperstr(q))||(!W||A.includes(0))&&(this.updated?.get(q)||F.includeChildren&&this.updated?.findSuperstr(q))||(!W||A.includes(2))&&(this.deleted?.findSubstr(q)||F.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=y;function M(V,q,F){return!V||!q||V===q||q.length>V.length?!1:(q.charAt(q.length-1)!==t.sep&&(q+=t.sep),F?(0,k.startsWithIgnoreCase)(V,q):V.indexOf(q)===0)}e.isParent=M;class T extends Error{constructor(q,F,A){super(q),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class N extends T{constructor(q,F,A){super(q,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=N;var G;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(G=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=X;async function Q(V,q){if(!q.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(F=>{const A=q.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===V.scheme&&W.added&&(A.dispose(),F())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(q){return(0,R.isNumber)(q)||(q=0),q<ie.KB?(0,P.localize)(1,null,q.toFixed(0)):q<ie.MB?(0,P.localize)(2,null,(q/ie.KB).toFixed(2)):q<ie.GB?(0,P.localize)(3,null,(q/ie.MB).toFixed(2)):q<ie.TB?(0,P.localize)(4,null,(q/ie.GB).toFixed(2)):(0,P.localize)(5,null,(q/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var oe;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*ie.MB:16*ie.GB,maxHeapSize:V===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=he}),define(Z[195],ee([0,1,17,44,16,3,2,58,7,29,15]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends D.Disposable{constructor(u,g){super(),this.channel=u,this.extraCapabilities=g,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,g){const{buffer:h}=await this.channel.call("readFile",[u,g]);return h}readFileStream(u,g,h){const p=(0,P.newWriteableStream)(v=>I.VSBuffer.concat(v.map(m=>I.VSBuffer.wrap(m))).buffer),d=this.channel.listen("readFileStream",[u,g])(v=>{if(v instanceof I.VSBuffer)p.write(v.buffer);else{if(v==="end")p.end();else{let m=v;m instanceof Error||(m=(0,E.createFileSystemProviderError)((0,t.toErrorMessage)(m),E.FileSystemProviderErrorCode.Unknown)),p.error(m),p.end()}d.dispose()}});return h.onCancellationRequested(()=>{p.error((0,k.canceled)()),p.end(),d.dispose()}),p}writeFile(u,g,h){return this.channel.call("writeFile",[u,I.VSBuffer.wrap(g),h])}open(u,g){return this.channel.call("open",[u,g])}close(u){return this.channel.call("close",[u])}async read(u,g,h,p,d){const[v,m]=await this.channel.call("read",[u,g,d]);return h.set(v.buffer.slice(0,m),p),m}write(u,g,h,p,d){return this.channel.call("write",[u,g,I.VSBuffer.wrap(h),p,d])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,g){return this.channel.call("delete",[u,g])}rename(u,g,h){return this.channel.call("rename",[u,g,h])}copy(u,g,h){return this.channel.call("copy",[u,g,h])}cloneFile(u,g){return this.channel.call("cloneFile",[u,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const g=u;this._onDidChange.fire(g.map(h=>({resource:w.URI.revive(h.resource),type:h.type})))}else{const g=u;this._onDidWatchError.fire(g)}}))}watch(u,g){const h=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,h,u,g]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=C}),define(Z[108],ee([0,1,17,16,159,15]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(E,C,b,u,g,h){let p;try{await P(E,C,b,u,g,h)}catch(d){p=d}finally{p&&g.errorTransformer&&(p=g.errorTransformer(p)),typeof p<"u"&&b.error(p),b.end()}}e.readFileIntoStream=D;async function P(E,C,b,u,g,h){w(h);const p=await E.open(C,{create:!1});try{w(h);let d=0,v=0,m=g&&typeof g.length=="number"?g.length:void 0,f=I.VSBuffer.alloc(Math.min(g.bufferSize,typeof m=="number"?m:g.bufferSize)),c=g&&typeof g.position=="number"?g.position:0,n=0;do v=await E.read(p,c,f.buffer,n,f.byteLength-n),c+=v,n+=v,d+=v,typeof m=="number"&&(m-=v),n===f.byteLength&&(await b.write(u(f)),f=I.VSBuffer.alloc(Math.min(g.bufferSize,typeof m=="number"?m:g.bufferSize)),n=0);while(v>0&&(typeof m!="number"||m>0)&&w(h)&&S(d,g));if(n>0){let s=n;typeof m=="number"&&(s=Math.min(n,m)),b.write(u(f.slice(0,s)))}}catch(d){throw(0,R.ensureFileSystemProviderError)(d)}finally{await E.close(p)}}function w(E){if(E.isCancellationRequested)throw(0,t.canceled)();return!0}function S(E,C){if(C?.limits){if(typeof C.limits.memory=="number"&&E>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&E>C.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[71],ee([0,1,99,2,9,4,7,15]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(d){return d.recursive===!0}e.isRecursiveWatchRequest=w;class S extends t.Disposable{constructor(v,m,f,c){super(),this.onFileChanges=v,this.onLogMessage=m,this.verboseLogging=f,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),v.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),v.add(this.watcher.onDidError(m=>this.onError(m)))}onError(v){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class E extends S{constructor(v,m,f){super(v,m,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class C extends S{constructor(v,m,f){super(v,m,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function b(d){return d.map(v=>({type:v.type,resource:D.URI.file(v.path)}))}e.toFileChanges=b;function u(d){const v=new p;for(const m of d)v.processEvent(m);return v.coalesce()}e.coalesceEvents=u;function g(d,v){return typeof v=="string"&&!v.startsWith(I.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:d,pattern:v}:v}e.normalizeWatcherPattern=g;function h(d,v){const m=[];for(const f of v)m.push((0,I.parse)(g(d,f)));return m}e.parseWatcherPatterns=h;class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const m=this.mapPathToChange.get(this.toKey(v));let f=!1;if(m){const c=m.type,n=v.type;m.path!==v.path&&(v.type===2||v.type===1)?f=!0:c===1&&n===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(m)):c===2&&n===1?m.type=0:c===1&&n===0||(m.type=n)}else f=!0;f&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],m=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,c)=>f.path.length-c.path.length).filter(f=>m.some(c=>(0,P.isParent)(f.path,c,!R.isLinux))?!1:(m.push(f.path),!0)).concat(v)}}}),define(Z[196],ee([0,1,40,8,23,30,2,77,9,4,100,21,71]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends D.Disposable{constructor(p,d,v,m){super(),this.request=p,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,b.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,b.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const p=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await C.Promises.stat(p);this._register(await this.doWatch(p,d.isDirectory()))}catch(p){p.code!=="ENOENT"?this.error(p):this.trace(p)}}async normalizePath(p){let d=p.path;try{d=await C.Promises.realpath(p.path),p.path===d&&(d=await(0,E.realcase)(p.path)??p.path),p.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${d})`)}catch{}return d}async doWatch(p,d){if(S.isMacintosh&&(0,R.isEqualOrParent)(p,"/Volumes/",!0))return this.error(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const v=new k.CancellationTokenSource(this.cts.token),m=new D.DisposableStore;try{const f=(0,w.basename)(p),c=(0,I.watch)(p);m.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${p}'`);const n=new Set;if(d)try{for(const i of await C.Promises.readdir(p))n.add(i)}catch(i){this.error(i)}const s=new Map;m.add((0,D.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),c.on("error",(i,o)=>{this.error(`Failed to watch ${p} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),c.on("change",(i,o)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let r="";if(o&&(r=o.toString(),S.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){s.get(r)?.dispose();const l=setTimeout(async()=>{if(s.delete(r),r===f&&!await C.Promises.exists(p)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,w.join)(p,r));if(v.token.isCancellationRequested)return;let y;a?n.has(r)?y=0:(y=1,n.add(r)):(n.delete(r),y=2),this.onFileChange({path:(0,w.join)(this.request.path,r),type:y})},u.FILE_DELETE_HANDLER_DELAY);s.set(r,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(r)?l=0:(l=1,n.add(r)),this.onFileChange({path:(0,w.join)(this.request.path,r),type:l})}else if(i==="rename"||r!==f){const l=setTimeout(async()=>{const a=await C.Promises.exists(p);v.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(p,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await C.Promises.exists(p)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${p} for changes using fs.watch() (${f.toString()})`)}return(0,D.toDisposable)(()=>{v.dispose(!0),m.dispose()})}async onFileChange(p,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),!d&&this.excludes.some(v=>v(p.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${p.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(p.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${p.path}`):this.fileChangesBuffer.push(p);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,b.coalesceEvents)(v);if(m.length>0){if(this.verboseLogging)for(const c of m)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(p){if(S.isLinux)return C.Promises.exists(p);try{const d=(0,w.basename)(p);return(await C.Promises.readdir((0,w.dirname)(p))).some(m=>m===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(p){this.verboseLogging=p}error(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}warn(p){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}trace(p){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function g(h,p,d,v,m=512){const f=await C.Promises.open(h,"r"),c=Buffer.allocUnsafe(m),n=new k.CancellationTokenSource(v);let s,i=!1;const o={path:h,excludes:[],recursive:!1},r=new u(o,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await C.Promises.read(f,c,0,m,null);if(!y||n.token.isCancellationRequested)break;p(c.slice(0,y))}}catch(y){s=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await r.ready,d(),new Promise((l,a)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await C.Promises.close(f)}catch(y){s=new Error(y)}s?a(s):l()})})}e.watchFileContents=g}),define(Z[197],ee([0,1,3,99,2,4,196]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const E=this.normalizeRequests(S),C=E.filter(u=>{const g=this.watchers.get(u.path);return g?!(0,t.patternsEquals)(g.request.excludes,u.excludes)||!(0,t.patternsEquals)(g.request.includes,u.includes):!0}),b=Array.from(this.watchers.values()).filter(({request:u})=>!E.find(g=>g.path===u.path&&(0,t.patternsEquals)(g.excludes,u.excludes)&&(0,t.patternsEquals)(g.includes,u.includes))).map(({request:u})=>u.path);C.length&&this.trace(`Request to start watching: ${C.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),b.length&&this.trace(`Request to stop watching: ${b.join(",")}`);for(const u of b)this.stopWatching(u);for(const u of C)this.startWatching(u)}startWatching(S){const E=new D.NodeJSFileWatcherLibrary(S,b=>this._onDidChangeFile.fire(b),b=>this._onDidLogMessage.fire(b),this.verboseLogging),C={request:S,instance:E};this.watchers.set(S.path,C)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const E=this.watchers.get(S);E&&(this.watchers.delete(S),E.instance.dispose())}normalizeRequests(S){const E=new Map;for(const C of S){const b=R.isLinux?C.path:C.path.toLowerCase();E.set(b,C)}return Array.from(E.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,E]of this.watchers)E.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,E){return E?`[File Watcher (node.js)] ${S} (path: ${E.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=P}),define(Z[198],ee([0,1,71,197]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends I.AbstractNonRecursiveWatcherClient{constructor(D,P,w){super(D,P,w),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[199],ee([0,1,14,46,145,71]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(w,S,E){super(w,S,E),this.init()}createWatcher(w){const S=w.add(new k.Client(I.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(S.onDidProcessExit(({code:E,signal:C})=>this.onError(`terminated by itself with code ${E}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Z[86],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=I}),define(Z[200],ee([0,1,8,16,2,69,190,5,86,95]),function(z,e,I,t,k,R,D,P,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class C extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class b{constructor(p=new w.ServiceCollection,d=!1,v,m=E){this._services=p,this._strict=d,this._parent=v,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=m?v?._globalGraph??new D.Graph(f=>f):void 0}createChild(p){return new b(p,this._strict,this,this._enableTracing)}invokeFunction(p,...d){const v=g.traceInvocation(this._enableTracing,p);let m=!1;try{return p({get:c=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(c,v);if(!n)throw new Error(`[invokeFunction] unknown service '${c}'`);return n}},...d)}finally{m=!0,v.stop()}}createInstance(p,...d){let v,m;return p instanceof R.SyncDescriptor?(v=g.traceCreation(this._enableTracing,p.ctor),m=this._createInstance(p.ctor,p.staticArguments.concat(d),v)):(v=g.traceCreation(this._enableTracing,p),m=this._createInstance(p,d,v)),v.stop(),m}_createInstance(p,d=[],v){const m=P._util.getServiceDependencies(p).sort((n,s)=>n.index-s.index),f=[];for(const n of m){const s=this._getOrCreateServiceInstance(n.id,v);s||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${n.id}.`,!1),f.push(s)}const c=m.length>0?m[0].index:d.length;if(d.length!==c){console.trace(`[createInstance] First service dependency of ${p.name} at position ${c+1} conflicts with ${d.length} static arguments`);const n=c-d.length;n>0?d=d.concat(new Array(n)):d=d.slice(0,c)}return Reflect.construct(p,d.concat(f))}_setServiceInstance(p,d){if(this._services.get(p)instanceof R.SyncDescriptor)this._services.set(p,d);else if(this._parent)this._parent._setServiceInstance(p,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const d=this._services.get(p);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):d}_getOrCreateServiceInstance(p,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const v=this._getServiceInstanceOrDescriptor(p);return v instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,v,d.branch(p,!0)):(d.branch(p,!1),v)}_safeCreateAndCacheServiceInstance(p,d,v){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,d,v)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,d,v){const m=new D.Graph(n=>n.id.toString());let f=0;const c=[{id:p,desc:d,_trace:v}];for(;c.length;){const n=c.pop();if(m.lookupOrInsertNode(n),f++>1e3)throw new C(m);for(const s of P._util.getServiceDependencies(n.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${p} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),i instanceof R.SyncDescriptor){const o={id:s.id,desc:i,_trace:n._trace.branch(s.id,!0)};m.insertEdge(n,o),c.push(o)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:s}of n){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const o=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,o)}m.removeNode(s)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,d,v=[],m,f){if(this._services.get(p)instanceof R.SyncDescriptor)return this._createServiceInstance(p,d,v,m,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,d,v,m,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(p,d,v=[],m,f){if(m){const c=new b(void 0,this._strict,this,this._enableTracing);c._globalGraphImplicitDependency=String(p);const n=new Map,s=new I.IdleValue(()=>{const i=c._createInstance(d,v,f);for(const[o,r]of n){const l=i[o];if(typeof l=="function")for(const a of r)l.apply(i,a)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=n.get(o);return a||(a=new S.LinkedList,n.set(o,a)),(M,T,N)=>{const G=a.push([M,T,N]);return(0,k.toDisposable)(G)}}if(o in i)return i[o];const r=s.value;let l=r[o];return typeof l!="function"||(l=l.bind(r),i[o]=l),l},set(i,o,r){return s.value[o]=r,!0}})}else return this._createInstance(d,v,f)}_throwIfStrict(p,d){if(d&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=b;var u;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(u||(u={}));class g{static traceInvocation(p,d){return p?new g(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(p,d){return p?new g(0,d.name):g._None}constructor(p,d){this.type=p,this.name=d,this._start=Date.now(),this._dep=[]}branch(p,d){const v=new g(2,p.toString());return this._dep.push([p,d,v]),v}stop(){const p=Date.now()-this._start;g._totals+=p;let d=!1;function v(f,c){const n=[],s=new Array(f+1).join("	");for(const[i,o,r]of c._dep)if(o&&r){d=!0,n.push(`${s}CREATES -> ${i}`);const l=v(f+1,r);l&&n.push(l)}else n.push(`${s}uses -> ${i}`);return n.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(p>2||d)&&g.all.add(m.join(`
`))}}e.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Z[6],ee([0,1,44,3,2,39,4,7,5]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function S(){return new Date().toISOString()}var E;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function C(l,a,y){switch(a){case E.Trace:l.trace(y);break;case E.Debug:l.debug(y);break;case E.Info:l.info(y);break;case E.Warning:l.warn(y);break;case E.Error:l.error(y);break;case E.Critical:l.critical(y);break;default:throw new Error("Invalid log level")}}e.log=C;function b(l){let a="";for(let y=0;y<l.length;y++){let M=l[y];if(typeof M=="object")try{M=JSON.stringify(M)}catch{}a+=(y>0?" ":"")+M}return a}e.format=b;class u extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=u;class g extends u{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...y){this.checkLogLevel(E.Trace)&&this.log(E.Trace,b([a,...y]))}debug(a,...y){this.checkLogLevel(E.Debug)&&this.log(E.Debug,b([a,...y]))}info(a,...y){this.checkLogLevel(E.Info)&&this.log(E.Info,b([a,...y]))}warn(a,...y){this.checkLogLevel(E.Warning)&&this.log(E.Warning,b([a,...y]))}error(a,...y){if(this.checkLogLevel(E.Error))if(a instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=a.stack,this.log(E.Error,b(M))}else this.log(E.Error,b([a,...y]))}critical(a,...y){this.checkLogLevel(E.Critical)&&this.log(E.Critical,b([a,...y]))}flush(){}}e.AbstractMessageLogger=g;class h extends u{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!D.isWindows}trace(a,...y){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.log(`[main ${S()}]`,a,...y))}debug(a,...y){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.log(`[main ${S()}]`,a,...y))}info(a,...y){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.log(`[main ${S()}]`,a,...y))}warn(a,...y){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,a,...y):console.warn(`[main ${S()}]`,a,...y))}error(a,...y){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,a,...y):console.error(`[main ${S()}]`,a,...y))}critical(a,...y){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${S()}]\x1B[0m`,a,...y):console.error(`[main ${S()}]`,a,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class p extends u{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...y){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",a,...y)}debug(a,...y){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...y)}info(a,...y){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",a,...y)}warn(a,...y){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",a,...y)}error(a,...y){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",a,...y)}critical(a,...y){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...y)}dispose(){}flush(){}}e.ConsoleLogger=p;class d extends u{constructor(a,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(y)}trace(a,...y){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(a),...y])}debug(a,...y){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(a),...y])}info(a,...y){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(a),...y])}warn(a,...y){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(a),...y])}error(a,...y){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(a),...y])}critical(a,...y){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(a),...y])}extractMessage(a){return typeof a=="string"?a:(0,I.toErrorMessage)(a,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class v extends u{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const y of this.logServices)y.setLevel(a);super.setLevel(a)}trace(a,...y){for(const M of this.logServices)M.trace(a,...y)}debug(a,...y){for(const M of this.logServices)M.debug(a,...y)}info(a,...y){for(const M of this.logServices)M.info(a,...y)}warn(a,...y){for(const M of this.logServices)M.warn(a,...y)}error(a,...y){for(const M of this.logServices)M.error(a,...y)}critical(a,...y){for(const M of this.logServices)M.critical(a,...y)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=v;class m extends k.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...y){this.logger.trace(a,...y)}debug(a,...y){this.logger.debug(a,...y)}info(a,...y){this.logger.info(a,...y)}warn(a,...y){this.logger.warn(a,...y)}error(a,...y){this.logger.error(a,...y)}critical(a,...y){this.logger.critical(a,...y)}flush(){this.logger.flush()}}e.LogService=m;class f extends k.Disposable{constructor(a,y){super(),this.logLevel=a,this.loggerItems=new R.ResourceMap,this._register(y(M=>this.setLevel(M)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,y,M){let T=this.loggerItems.get(a)?.logger;return T||(M=y?.always?E.Trace:M,T=this.doCreateLogger(a,M??this.logLevel,y),this.loggerItems.set(a,{logger:T,logLevel:M})),T}setLevel(a,y){const M=P.URI.isUri(a)?a:void 0,T=M?y:a;if(M){const N=this.loggerItems.get(M);N&&N.logLevel!==T&&(N.logLevel=T,N.logger.setLevel(T))}else this.logLevel=T,this.loggerItems.forEach(({logLevel:N,logger:G})=>{N===void 0&&G.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=f;class c{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return E.Info}trace(a,...y){}debug(a,...y){}info(a,...y){}warn(a,...y){}error(a,...y){}critical(a,...y){}dispose(){}flush(){}}e.NullLogger=c;class n extends c{}e.NullLogService=n;class s extends f{constructor(){super(E.Info,t.Event.None)}doCreateLogger(a,y,M){return new c}}e.NullLoggerService=s;function i(l){if(l.verbose)return E.Trace;if(typeof l.logLevel=="string"){const a=o(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function o(l){switch(l){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=o;function r(l){switch(l){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=r});var te=this&&this.__param||function(z,e){return function(I,t){e(I,t,z)}};define(Z[201],ee([0,1,70,3,2,6,4,8]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class Et extends k.Disposable{constructor(E){super(),this.logService=E,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(E,C){this.logService.trace("Getting password from keytar:",E,C);let b;try{b=await this.withKeytar()}catch{return null}const u=await(0,P.retry)(()=>b.getPassword(E,C),50,3);if(!u)return this.logService.trace("Did not get a password from keytar for account:",C),u;let g,h;try{const p=JSON.parse(u);g=p.content,h=p.hasNextChunk}catch{}if(!g||!h)return this.logService.trace("Got password from keytar for account:",C),u;try{let p=1;for(;h;){const d=await(0,P.retry)(()=>b.getPassword(E,`${C}-${p}`),50,3),v=JSON.parse(d);g+=v.content,h=v.hasNextChunk,p++}return this.logService.trace(`Got ${p}-chunked password from keytar for account:`,C),g}catch(p){return this.logService.error(p),u}}async setPassword(E,C,b){this.logService.trace("Setting password using keytar:",E,C);let u;try{u=await this.withKeytar()}catch(g){throw this.surfaceKeytarLoadError?.(g),g}if(D.isWindows&&b.length>Et.MAX_PASSWORD_LENGTH){let g=0,h=0,p=!0;for(;p;){const d=b.substring(g,g+Et.PASSWORD_CHUNK_SIZE);g+=Et.PASSWORD_CHUNK_SIZE,p=b.length-g>0;const v={content:d,hasNextChunk:p};await(0,P.retry)(()=>u.setPassword(E,h?`${C}-${h}`:C,JSON.stringify(v)),50,3),h++}this.logService.trace(`Got${h?` ${h}-chunked`:""} password from keytar for account:`,C)}else await(0,P.retry)(()=>u.setPassword(E,C,b),50,3),this.logService.trace("Got password from keytar for account:",C);this._onDidChangePassword.fire({service:E,account:C})}async deletePassword(E,C){this.logService.trace("Deleting password using keytar:",E,C);let b;try{b=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const u=await b.getPassword(E,C);if(!u)return this.logService.trace("Did not get a password to delete from keytar for account:",C),!1;let g,h;try{const d=JSON.parse(u);g=d.content,h=d.hasNextChunk}catch{}let p=0;if(g&&h)try{for(p++;h;){const d=`${C}-${p}`,v=await b.getPassword(E,d);await b.deletePassword(E,d),h=JSON.parse(v).hasNextChunk,p++}}catch(d){this.logService.error(d)}return await b.deletePassword(E,C)?(this._onDidChangePassword.fire({service:E,account:C}),this.logService.trace(`Deleted${p?` ${p}-chunked`:""} password from keytar for account:`,C),!0):(this.logService.trace(`Keytar failed to delete${p?` ${p}-chunked`:""} password for account:`,C),!1)}async findPassword(E){let C;try{C=await this.withKeytar()}catch{return null}return await C.findPassword(E)}async findCredentials(E){let C;try{C=await this.withKeytar()}catch{return[]}return await C.findCredentials(E)}clear(){return this._keytarCache instanceof I.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};w.MAX_PASSWORD_LENGTH=2500,w.PASSWORD_CHUNK_SIZE=w.MAX_PASSWORD_LENGTH-100,w=we([te(0,R.ILogService)],w),e.BaseCredentialsMainService=w}),define(Z[202],ee([0,1,24,8,16,3,2,9,71,6]),function(z,e,I,t,k,R,D,P,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends D.Disposable{constructor(b,u){super(),this.logService=b,this.options=u,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(b,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(b,u):this.watchNonRecursive(b,u)}watchUniversal(b,u){const g={path:this.toFilePath(b),excludes:u.excludes,includes:u.includes,recursive:u.recursive},h=(0,I.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(b=>(0,k.onUnexpectedError)(b))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,w.toFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const b=this.options?.watcher?.recursive?.usePolling;if(b===!0)for(const u of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const u of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(u)&&b.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(b,u){const g={path:this.toFilePath(b),excludes:u.excludes,includes:u.includes,recursive:!1},h=(0,I.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(b=>(0,k.onUnexpectedError)(b))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(b=>this._onDidChangeFile.fire((0,w.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(b){b.type==="error"&&this._onDidWatchError.fire(b.message),this.logService[b.type](b.message)}toFilePath(b){return(0,P.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(Z[203],ee([0,1,24,8,17,23,3,67,57,2,59,14,72,18,58,157,15,108,6]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends S.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${c}`);const s=new S.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),s.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new p.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,S.dispose)(s)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(s){n.push(s)}}),!this.provider.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const s=this.provider.get(c.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return w.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,u.isAbsolutePath)(c))throw new p.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,h.localize)(1,null,c.toString()),s}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n)||(0,p.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(n)||(0,p.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(s){throw(0,p.toFileSystemProviderErrorCode)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,p.ensureFileSystemProviderError)(s)}}async doResolveFile(c,n){const s=await this.withProvider(c),i=this.isPathCaseSensitive(s),o=n?.resolveTo,r=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,a=await s.stat(c);let y;return this.toFileStat(s,c,a,void 0,!!l,(M,T)=>(y||(y=E.TernarySearchTree.forUris(()=>!i),y.set(c,!0),o&&y.fill(!0,o)),y.get(M.resource)||y.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&r?T===1:!1))}async toFileStat(c,n,s,i,o,r){const{providerExtUri:l}=this.getExtUri(c),a={resource:n,name:l.basename(n),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&p.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,p.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(a.isDirectory&&r(a,i)){try{const y=await c.readdir(n),M=await t.Promises.settled(y.map(async([T,N])=>{try{const G=l.joinPath(n,T),ae=o?await c.stat(G):{type:N};return await this.toFileStat(c,G,ae,y.length,o,r)}catch(G){return this.logService.trace(G),null}}));a.children=(0,I.coalesce)(M)}catch(y){this.logService.trace(y),a.children=[]}return a}return a}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),s=await n.stat(c);return this.toFileStat(n,c,s,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(s){return s}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new p.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=k.VSBuffer.fromString(""),s){await this.doValidateCreateFile(c,s);const i=await this.writeFile(c,n);return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,i)),i}async writeFile(c,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,c,s)||await this.mkdirp(i,o.dirname(c));let l;if((0,p.hasReadWriteCapability)(i)&&!(n instanceof k.VSBuffer))if((0,g.isReadableStream)(n)){const a=await(0,g.peekStream)(n,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,g.peekReadable)(n,a=>k.VSBuffer.concat(a),3);else l=n;!(0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,s,l):await this.doWriteBuffered(i,c,s,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this._onDidRunOperation.fire(new p.FileOperationEvent(c,4))}catch(r){throw new p.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,s){if(!!s?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(n)));let o;try{o=await c.stat(n)}catch{return}if((o.type&p.FileType.Directory)!==0)throw new p.FileOperationError((0,h.localize)(6,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,o),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&s.mtime<o.mtime&&s.etag!==(0,p.etag)({mtime:s.mtime,size:o.size}))throw new p.FileOperationError((0,h.localize)(7,null),3,s);return o}async readFile(c,n,s){const i=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(i,c,n,s):this.doReadFile(i,c,n,s)}async doReadFileAtomic(c,n,s,i){return new Promise((o,r)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(c,n,s,i);o(l)}catch(l){r(l)}})})}async doReadFile(c,n,s,i){const o=await this.doReadFileStream(c,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(c,n,s){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,n,s)}async doReadFileStream(c,n,s,i){const o=new R.CancellationTokenSource(i),r=this.validateReadFile(n,s).then(a=>a,a=>{throw o.cancel(),a});let l;try{return typeof s?.etag=="string"&&s.etag!==p.ETAG_DISABLED&&await r,s?.atomic&&(0,p.hasFileAtomicReadCapability)(c)||!((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasFileReadStreamCapability)(c))||(0,p.hasReadWriteCapability)(c)&&s?.preferUnbuffered?l=this.readFileUnbuffered(c,n,s):(0,p.hasFileReadStreamCapability)(c)?l=this.readFileStreamed(c,n,o.token,s):l=this.readFileBuffered(c,n,o.token,s),{...await r,value:l}}catch(a){l&&await(0,g.consumeStream)(l);const y=(0,h.localize)(8,null,this.resourceForError(n),(0,p.ensureFileSystemProviderError)(a).toString());throw a instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(y,a.stat,s):new p.FileOperationError(y,(0,p.toFileOperationResult)(a),s)}}readFileStreamed(c,n,s,i=Object.create(null)){const o=c.readFileStream(n,i,s);return(0,g.transform)(o,{data:r=>r instanceof k.VSBuffer?r:k.VSBuffer.wrap(r),error:r=>new p.FileOperationError((0,h.localize)(9,null,this.resourceForError(n),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),i)},r=>k.VSBuffer.concat(r))}readFileBuffered(c,n,s,i=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,d.readFileIntoStream)(c,n,o,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new p.FileOperationError((0,h.localize)(10,null,this.resourceForError(n),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),i)},s),o}readFileUnbuffered(c,n,s){const i=(0,g.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;s?.atomic&&(0,p.hasFileAtomicReadCapability)(c)?o=await c.readFile(n,{atomic:!0}):o=await c.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.validateReadFileLimits(n,o.byteLength,s),i.end(k.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(c,n){const s=await this.resolve(c,{resolveMetadata:!0});if(s.isDirectory)throw new p.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==p.ETAG_DISABLED&&n.etag===s.etag)throw new p.NotModifiedSinceFileOperationError((0,h.localize)(12,null),s,n);return this.validateReadFileLimits(c,s.size,n),s}validateReadFileLimits(c,n,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&n>s.limits.size&&(i=7),typeof i=="number")throw new p.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,n,s){return this.doCanMoveCopy(c,n,"move",s)}async canCopy(c,n,s){return this.doCanMoveCopy(c,n,"copy",s)}async doCanMoveCopy(c,n,s,i){if(c.toString()!==n.toString())try{const o=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,c,r,n,s,i)}catch(o){return o}return!0}async move(c,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,c,o,n,"move",!!s),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="move"?2:3,l)),l}async copy(c,n,s){const i=await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(i,c,o,n,"copy",!!s),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="copy"?3:2,l)),l}async doMoveCopy(c,n,s,i,o,r){if(n.toString()===i.toString())return o;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,n,s,i,o,r);if(l&&!a&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),o==="copy"){if(c===s&&(0,p.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:r});else{const y=await this.resolve(n);y.isDirectory?await this.doCopyFolder(c,y,s,i):await this.doCopyFile(c,n,s,i)}return o}else return c===s?(await c.rename(n,i,{overwrite:r}),o):(await this.doMoveCopy(c,n,s,i,"copy",r),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,s,i){if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(c,n,s,i);if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(c,n,s,i);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(c,n,s,i);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasReadWriteCapability)(s))return this.doPipeUnbuffered(c,n,s,i)}async doCopyFolder(c,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async o=>{const r=this.getExtUri(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(c,await this.resolve(o.resource),s,r):this.doCopyFile(c,o.resource,s,r)}))}async doValidateMoveCopy(c,n,s,i,o,r){let l=!1;if(c===s){const{providerExtUri:y,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(l=y.isEqual(n,i)),l&&o==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!l&&y.isEqualOrParent(i,n))throw new Error((0,h.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!l){if(!r)throw new p.FileOperationError((0,h.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(c===s){const{providerExtUri:y}=this.getExtUri(c);if(y.isEqualOrParent(n,i))throw new Error((0,h.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,s)),s}async mkdirp(c,n){const s=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&p.FileType.Directory)===0)throw new Error((0,h.localize)(18,null,this.resourceForError(n)));break}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await c.mkdir(n)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(s){return s}return!0}async doValidateDelete(c,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let o;try{o=await s.stat(c)}catch{}if(o)this.throwIfFileIsReadonly(c,o);else throw new p.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return s}async del(c,n){const s=await this.doValidateDelete(c,n),i=!!n?.useTrash,o=!!n?.recursive;await s.delete(c,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new p.FileOperationEvent(c,1))}async cloneFile(c,n){const s=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(c,n))return;if(s===i&&(0,p.hasFileCloneCapability)(s))return s.cloneFile(c,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const o=this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri);return s===i&&(0,p.hasFileFolderCopyCapability)(s)?o.queue(()=>s.copy(c,n,{overwrite:!0})):o.queue(()=>this.doCopyFile(s,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const s=new S.DisposableStore;let i=!1,o=()=>{i=!0};return s.add((0,S.toDisposable)(()=>o())),(async()=>{try{const r=await this.doWatch(c,n);i?(0,S.dispose)(r):o=()=>(0,S.dispose)(r)}catch(r){this.logService.error(r)}})(),s}async doWatch(c,n){const s=await this.withProvider(c),i=(0,P.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(c),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:s.watch(c,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,S.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,S.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,s,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const o=await c.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,g.isReadableStream)(i)||(0,g.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,o,i):await this.doWriteReadableBufferedQueued(c,o,i)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await c.close(o)}})}async doWriteStreamBufferedQueued(c,n,s){let i=0,o;if((0,g.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=k.VSBuffer.concat(s.buffer);await this.doWriteBuffer(c,n,r,r.byteLength,i,0),i+=r.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((r,l)=>{(0,g.listenStream)(o,{onData:async a=>{o.pause();try{await this.doWriteBuffer(c,n,a,a.byteLength,i,0)}catch(y){return l(y)}i+=a.byteLength,setTimeout(()=>o.resume())},onError:a=>l(a),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.doWriteBuffer(c,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(c,n,s,i,o,r){let l=0;for(;l<i;)l+=await c.write(n,o+l,s.buffer,r+l,i-l)}async doWriteUnbuffered(c,n,s,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,s,i))}async doWriteUnbufferedQueued(c,n,s,i){let o;i instanceof k.VSBuffer?o=i:(0,g.isReadableStream)(i)?o=await(0,k.streamToBuffer)(i):(0,g.isReadableBufferedStream)(i)?o=await(0,k.bufferedStreamToBuffer)(i):o=(0,k.readableToBuffer)(i),await c.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(c,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,s,i))}async doPipeBufferedQueued(c,n,s,i){let o,r;try{o=await c.open(n,{create:!1}),r=await s.open(i,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,y=0,M=0;do M=await c.read(o,a,l.buffer,y,l.byteLength-y),await this.doWriteBuffer(s,r,l,M,a,y),a+=M,y+=M,y===l.byteLength&&(y=0);while(M>0)}catch(l){throw(0,p.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof o=="number"?c.close(o):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,s,i))}async doPipeUnbufferedQueued(c,n,s,i){return s.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,s,i))}async doPipeUnbufferedToBufferedQueued(c,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const r=await c.readFile(n);await this.doWriteBuffer(s,o,k.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await s.close(o)}}async doPipeBufferedToUnbuffered(c,n,s,i){const o=await(0,k.streamToBuffer)(this.readFileBuffered(c,n,R.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,o)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new p.FileOperationError((0,h.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===C.Schemas.file?c.fsPath:c.toString(!0)}};m=we([te(0,v.ILogService)],m),e.FileService=m}),define(Z[87],ee([0,1,40,280,8,39,17,3,30,2,9,4,18,58,21,161,15,108,202,44,199,198]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(s){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(s)}`)}})();class n extends v.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new R.ResourceMap(r=>b.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:r}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,r),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(o.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,b.joinPath)(i,l.name))).type:a=this.toType(l),r.push([l.name,a])}catch(a){this.logService.trace(a)}})),r}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let r;return o?.dangling?r=p.FileType.Unknown:i.isFile()?r=p.FileType.File:i.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,o&&(r|=p.FileType.SymbolicLink),r}async createResourceLock(i){const o=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let r;for(;r=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await r.wait();const l=new k.Barrier;return this.resourceLocks.set(i,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,S.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),l.open()})}async readFile(i,o){let r;try{o?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const l=this.toFilePath(i);return await g.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{r?.dispose()}}traceLock(i){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,o,r){const l=(0,u.newWriteableStream)(a=>D.VSBuffer.concat(a.map(y=>D.VSBuffer.wrap(y))).buffer);return(0,d.readFileIntoStream)(this,i,l,a=>a.buffer,{...o,bufferSize:256*1024},r),l}async writeFile(i,o,r){let l;try{const a=this.toFilePath(i);if(!r.create||!r.overwrite){if(await g.Promises.exists(a)){if(!r.overwrite)throw(0,p.createFileSystemProviderError)((0,h.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.createFileSystemProviderError)((0,h.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(l,0,o,0,o.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,o){const r=this.toFilePath(i);let l;(0,p.isFileOpenForWriteOptions)(o)&&(l=await this.createResourceLock(i));let a;try{if((0,p.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:M}=await g.SymlinkSupport.stat(r);M.mode&128||await g.Promises.chmod(r,M.mode|128)}catch(M){this.logService.trace(M)}let y;if((0,p.isFileOpenForWriteOptions)(o)){if(C.isWindows)try{await g.Promises.truncate(r,0),y="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}y||(y="w")}else y="r";a=await g.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,p.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(a,0),(0,p.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(a,i),l){const y=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,l),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),y.dispose())}return a}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await g.Promises.fdatasync(i)}catch(r){n.configureFlushOnWrite(!1),this.logService.error(r)}return await g.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,r,l,a){const y=this.normalizePos(i,o);let M=null;try{M=(await g.Promises.read(i,r,l,a,y)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,y,M)}return M}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,r){const l=this.mapHandleToPos.get(i);typeof l=="number"&&(typeof o=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,l+r):this.mapHandleToPos.delete(i)))}async write(i,o,r,l,a){return(0,k.retry)(()=>this.doWrite(i,o,r,l,a),100,3)}async doWrite(i,o,r,l,a){const y=this.normalizePos(i,o);let M=null;try{M=(await g.Promises.write(i,r,l,a,y)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,y,M)}return M}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const r=this.toFilePath(i);o.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,o,r){const l=this.toFilePath(i),a=this.toFilePath(o);if(l!==a)try{await this.validateTargetDeleted(i,o,"move",r.overwrite),await g.Promises.move(l,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(2,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,o,r){const l=this.toFilePath(i),a=this.toFilePath(o);if(l!==a)try{await this.validateTargetDeleted(i,o,"copy",r.overwrite),await g.Promises.copy(l,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,h.localize)(3,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(i,o,r,l){const a=this.toFilePath(i),y=this.toFilePath(o);let M=!1;if(!!(this.capabilities&1024)||(M=(0,w.isEqual)(a,y,!0)),M&&r==="copy")throw(0,p.createFileSystemProviderError)((0,h.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!M&&await g.Promises.exists(y)){if(!l)throw(0,p.createFileSystemProviderError)((0,h.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,r){const l=this.toFilePath(i),a=this.toFilePath(o),y=!!(this.capabilities&1024);if((0,w.isEqual)(l,a,!y))return;const M=new S.DisposableStore;try{const[T,N]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);M.add(T),M.add(N),r&&await g.Promises.mkdir((0,E.dirname)(a),{recursive:!0}),await g.Promises.copyFile(l,a)}catch(T){if(T.code==="ENOENT"&&!r)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,o,r){return new f.UniversalWatcherClient(l=>i(l),l=>o(l),r)}createNonRecursiveWatcher(i,o,r){return new c.NodeJSWatcherClient(l=>i(l),l=>o(l),r)}toFileSystemProviderError(i){if(i instanceof p.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=p.FileSystemProviderErrorCode.NoPermissions;break;default:o=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let r=this.toFileSystemProviderError(o);if(i&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await g.SymlinkSupport.stat(this.toFilePath(i));l.mode&128||(r=(0,p.createFileSystemProviderError)(o,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(Z[204],ee([0,1,3,87,2,17,58,23]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends k.Disposable{constructor(C,b){super(),this.provider=C,this.logService=b,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(C,b,u){const g=this.getUriTransformer(C);switch(b){case"stat":return this.stat(g,u[0]);case"readdir":return this.readdir(g,u[0]);case"open":return this.open(g,u[0],u[1]);case"close":return this.close(u[0]);case"read":return this.read(u[0],u[1],u[2]);case"readFile":return this.readFile(g,u[0],u[1]);case"write":return this.write(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.writeFile(g,u[0],u[1],u[2]);case"rename":return this.rename(g,u[0],u[1],u[2]);case"copy":return this.copy(g,u[0],u[1],u[2]);case"cloneFile":return this.cloneFile(g,u[0],u[1]);case"mkdir":return this.mkdir(g,u[0]);case"delete":return this.delete(g,u[0],u[1]);case"watch":return this.watch(g,u[0],u[1],u[2],u[3]);case"unwatch":return this.unwatch(u[0],u[1])}throw new Error(`IPC Command ${b} not found`)}listen(C,b,u){const g=this.getUriTransformer(C);switch(b){case"fileChange":return this.onFileChange(g,u[0]);case"readFileStream":return this.onReadFileStream(g,u[0],u[1])}throw new Error(`Unknown event ${b}`)}stat(C,b){const u=this.transformIncoming(C,b,!0);return this.provider.stat(u)}readdir(C,b){const u=this.transformIncoming(C,b);return this.provider.readdir(u)}async readFile(C,b,u){const g=this.transformIncoming(C,b,!0),h=await this.provider.readFile(g,u);return R.VSBuffer.wrap(h)}onReadFileStream(C,b,u){const g=this.transformIncoming(C,b,!0),h=new P.CancellationTokenSource,p=new I.Emitter({onLastListenerRemove:()=>{h.cancel()}}),d=this.provider.readFileStream(g,u,h.token);return(0,D.listenStream)(d,{onData:v=>p.fire(R.VSBuffer.wrap(v)),onError:v=>p.fire(v),onEnd:()=>{p.fire("end"),p.dispose(),h.dispose()}}),p.event}writeFile(C,b,u,g){const h=this.transformIncoming(C,b);return this.provider.writeFile(h,u.buffer,g)}open(C,b,u){const g=this.transformIncoming(C,b,!0);return this.provider.open(g,u)}close(C){return this.provider.close(C)}async read(C,b,u){const g=R.VSBuffer.alloc(u),h=0,p=await this.provider.read(C,b,g.buffer,h,u);return[g,p]}write(C,b,u,g,h){return this.provider.write(C,b,u.buffer,g,h)}mkdir(C,b){const u=this.transformIncoming(C,b);return this.provider.mkdir(u)}delete(C,b,u){const g=this.transformIncoming(C,b);return this.provider.delete(g,u)}rename(C,b,u,g){const h=this.transformIncoming(C,b),p=this.transformIncoming(C,u);return this.provider.rename(h,p,g)}copy(C,b,u,g){const h=this.transformIncoming(C,b),p=this.transformIncoming(C,u);return this.provider.copy(h,p,g)}cloneFile(C,b,u){const g=this.transformIncoming(C,b),h=this.transformIncoming(C,u);return this.provider.cloneFile(g,h)}onFileChange(C,b){const u=new I.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(b,this.createSessionFileWatcher(C,u))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(b)),this.sessionToWatcher.delete(b)}});return u.event}async watch(C,b,u,g,h){const p=this.sessionToWatcher.get(b);if(p){const d=this.transformIncoming(C,g),v=p.watch(u,d,h);this.watchRequests.set(b+u,v)}}async unwatch(C,b){const u=C+b,g=this.watchRequests.get(u);g&&((0,k.dispose)(g),this.watchRequests.delete(u))}dispose(){super.dispose();for(const[,C]of this.watchRequests)C.dispose();this.watchRequests.clear();for(const[,C]of this.sessionToWatcher)C.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class S extends k.Disposable{constructor(C,b,u,g){super(),this.uriTransformer=C,this.logService=u,this.environmentService=g,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(b)}registerListeners(C){const b=this._register(new I.Emitter);this._register(b.event(u=>{C.fire(u.map(g=>({resource:this.uriTransformer.transformOutgoingURI(g.resource),type:g.type})))})),this._register(this.fileWatcher.onDidChangeFile(u=>b.fire(u))),this._register(this.fileWatcher.onDidWatchError(u=>C.fire(u)))}getRecursiveWatcherOptions(C){}getExtraExcludes(C){}watch(C,b,u){const g=this.getExtraExcludes(this.environmentService);return Array.isArray(g)&&(u.excludes=[...u.excludes,...g]),this.watcherRequests.set(C,this.fileWatcher.watch(b,u)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(C)),this.watcherRequests.delete(C)})}dispose(){super.dispose();for(const[,C]of this.watcherRequests)C.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=S}),define(Z[205],ee([0,1,13,160,4,7,15,9,204,139]),function(z,e,I,t,k,R,D,P,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class E extends w.AbstractDiskFileSystemProviderChannel{constructor(u,g,h){super(u,g),this.environmentService=h}getUriTransformer(u){return S.DefaultURITransformer}transformIncoming(u,g){return R.URI.revive(g)}async delete(u,g,h){if(!h.useTrash)return super.delete(u,g,h);const p=this.transformIncoming(u,g),d=(0,P.normalize)(p.fsPath);try{await I.shell.trashItem(d)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,P.basename)(d)):(0,t.localize)(1,null,(0,P.basename)(d)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(u,g){return new C(u,g,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=E;class C extends w.AbstractSessionFileWatcher{watch(u,g,h){if(h.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,g,h)}}}),define(Z[206],ee([0,1,6]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case I.LogLevel.Trace:return R.trace;case I.LogLevel.Debug:return R.debug;case I.LogLevel.Info:return R.info;case I.LogLevel.Warning:return R.warn;case I.LogLevel.Error:return R.error;case I.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends I.AbstractLogger{constructor(D=I.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(P=>{this._logger?.setLevel(P)}))}set logger(D){this._logger=D;for(const{level:P,args:w}of this.buffer)t(D,P).apply(D,w);this.buffer=[]}_log(D,...P){this._logger?t(this._logger,D).apply(this._logger,P):this.getLevel()<=D&&this.buffer.push({level:D,args:P})}trace(D,...P){this._log(I.LogLevel.Trace,D,...P)}debug(D,...P){this._log(I.LogLevel.Debug,D,...P)}info(D,...P){this._log(I.LogLevel.Info,D,...P)}warn(D,...P){this._log(I.LogLevel.Warning,D,...P)}error(D,...P){this._log(I.LogLevel.Error,D,...P)}critical(D,...P){this._log(I.LogLevel.Critical,D,...P)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(Z[207],ee([0,1,3,7,6]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(b,u){this.logService=b,this.loggerService=u,this.onDidChangeLogLevel=I.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}async call(b,u,g){switch(u){case"setLevel":return g[1]?this.loggerService.setLevel(t.URI.revive(g[1]),g[0]):this.logService.setLevel(g[0])}throw new Error(`Call not found: ${u}`)}}e.LogLevelChannel=R;class D{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b,u){D.setLevel(this.channel,b,u)}static setLevel(b,u,g){return b.call("setLevel",[u,g])}}e.LogLevelChannelClient=D;class P{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,u){throw new Error(`Event not found: ${u}`)}async call(b,u,g){switch(u){case"createLogger":this.createLogger(t.URI.revive(g[0]),g[1]);return;case"log":return this.log(t.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${u}`)}createLogger(b,u){this.loggers.set(b.toString(),this.loggerService.createLogger(b,u))}consoleLog(b,u){let g=console.log;switch(b){case k.LogLevel.Error:g=console.error;break;case k.LogLevel.Warning:g=console.warn;break;case k.LogLevel.Info:g=console.info;break}g.call(console,...u)}log(b,u){const g=this.loggers.get(b.toString());if(!g)throw new Error("Create the logger before logging");for(const[h,p]of u)(0,k.log)(g,h,p)}}e.LoggerChannel=P;class w extends k.AbstractLoggerService{constructor(b,u,g){super(b,u),this.channel=g}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,u)=>{this.channel.call("consoleLog",[b,u])}})}doCreateLogger(b,u,g){return new S(this.channel,b,u,g)}}e.LoggerChannelClient=w;class S extends k.AbstractMessageLogger{constructor(b,u,g,h){super(h?.always),this.channel=b,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[u,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,u){const g=[[b,u]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(b){this.channel.call("log",[this.file,b])}}class E extends k.LogService{constructor(b,u){super(u),this.parent=b,this._register(b.onDidChangeLogLevel(g=>u.setLevel(g)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=E}),define(Z[208],ee([0,1,15,6]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(P,w,S,E,C){try{const b=await new Promise((g,h)=>{z(["spdlog"],g,h)});b.setFlushOn(t.LogLevel.Trace);const u=await b.createAsyncRotatingLogger(P,w,S,E);return C?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(b){console.error(b)}return null}function R(P,w,S){switch(w){case t.LogLevel.Trace:P.trace(S);break;case t.LogLevel.Debug:P.debug(S);break;case t.LogLevel.Info:P.info(S);break;case t.LogLevel.Warning:P.warn(S);break;case t.LogLevel.Error:P.error(S);break;case t.LogLevel.Critical:P.critical(S);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(w,S,E,C,b){super(),this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(w,S,E,C),this._register(this.onDidChangeLogLevel(u=>{this._logger?.setLevel(u)}))}async _createSpdLogLogger(w,S,E,C){const b=E?6:1,u=30/b*I.ByteSize.MB,g=await k(w,S,u,b,C);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:h,message:p}of this.buffer)R(this._logger,h,p);this.buffer=[]}}log(w,S){this._logger?R(this._logger,w,S):this.getLevel()<=w&&this.buffer.push({level:w,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(Z[209],ee([0,1,29,6,208]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}doCreateLogger(P,w,S){return new k.SpdLogLogger(S?.name||(0,I.generateUuid)(),P.fsPath,!S?.donotRotate,!!S?.donotUseFormatters,w)}};R=we([te(0,t.ILogService)],R),e.LoggerService=R}),define(Z[210],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!I(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(Z[36],ee([0,1,3,57,2,5]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(S){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...S,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(S),t.Iterable.reduce(this.policies.entries(),(C,[b,u])=>({...C,[b]:u}),{})}getPolicyValue(S){return this.policies.get(S)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(S,[E,C])=>({...S,[E]:{definition:C,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=I.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(Z[211],ee([0,1,8,3,57,12,15,6,36]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function S(C,b){const u=[];for(const g of k.Iterable.concat(C.keys(),b.keys()))C.get(g)!==b.get(g)&&u.push(g);return u}let E=class extends w.AbstractPolicyService{constructor(b,u,g){super(),this.file=b,this.fileService=u,this.logService=g,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const h=t.Event.filter(u.onDidFilesChange,p=>p.affects(b));this._register(u.watch(b)),this._register(h(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(b){await this.refresh()}async read(){const b=new Map;try{const u=await this.fileService.readFile(this.file),g=JSON.parse(u.value.toString());if(!(0,R.isObject)(g))throw new Error("Policy file isn't a JSON object");for(const h of Object.keys(g))this.policyDefinitions[h]&&b.set(h,g[h])}catch(u){u.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",u)}return b}async refresh(){const b=await this.read(),u=S(this.policies,b);this.policies=b,u.length>0&&this._onDidChange.fire(u)}};E=we([te(1,D.IFileService),te(2,P.ILogService)],E),e.FilePolicyService=E}),define(Z[212],ee([0,1,3,2,36]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(w){this.service=w,this.disposables=new t.DisposableStore}listen(w,S){switch(S){case"onDidChange":return I.Event.map(this.service.onDidChange,E=>E.reduce((C,b)=>({...C,[b]:this.service.getPolicyValue(b)??null}),{}),this.disposables)}throw new Error(`Event not found: ${S}`)}call(w,S,E){switch(S){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${S}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(w,S){super(),this.channel=S;for(const E in w){const{definition:C,value:b}=w[E];this.policyDefinitions[E]=C,b!==void 0&&this.policies.set(E,b)}this.channel.listen("onDidChange")(E=>{for(const C in E){const b=E[C];b===null?this.policies.delete(C):this.policies.set(C,b)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(w){const S=await this.channel.call("registerPolicyDefinitions",w);for(const E in S)this.policies.set(E,S[E])}}e.PolicyChannelClient=D}),define(Z[54],ee([0,1,14,4,33,18]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)D=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const P=(0,R.dirname)(I.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(P,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const w=z.__$__nodeRequire((0,R.joinPath)(P,"package.json").fsPath);Object.assign(D,{version:w.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(Z[20],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[213],ee([0,1,78,6,20]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(P,w){this.productService=P,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const S=/^(.*)#([^#]+)$/.exec(w);if(!S)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,E,C]=S;let b=this.trustedExtensionUrlPublicKeys.get(P);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[P],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...b])}const u=Buffer.from(decodeURIComponent(C),"base64");if(u.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const g=u.slice(0,6),h=u.readUIntBE(0,6),p=Date.now()-h;if(p<0||p>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const d=u.slice(6),v=I.createVerify("SHA256");v.write(g),v.write(Buffer.from(E)),v.end();for(let m=0;m<b.length;m++){let f=b[m];if(f!==null){if(typeof f=="string")try{f=I.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),b[m]=f}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${P}:`,c),b[m]=null;continue}if(v.verify(f,d))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};R=we([te(0,k.IProductService),te(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[214],ee([0,1,9,5]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var k;(function(R){function D(w){return Boolean(w.samples&&w.timeDeltas)}R.isValidProfile=D;function P(w,S="noAbsolutePaths"){for(const E of w.nodes)E.callFrame&&E.callFrame.url&&((0,I.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,I.join)(S,(0,I.basename)(E.callFrame.url)));return w}R.rewriteAbsolutePaths=P})(k=e.Utils||(e.Utils={}))}),define(Z[215],ee([0,1,9]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.bottomUp=e.buildModel=void 0;const t=(C,b)=>{const u=b[C];if(u.aggregateTime)return u.aggregateTime;let g=u.selfTime;for(const h of u.children)g+=t(h,b);return u.aggregateTime=g},k=C=>{let b=0;const u=new Map,g=h=>{const p=[h.functionName,h.url,h.scriptId,h.lineNumber,h.columnNumber].join(":"),d=u.get(p);if(d)return d.id;const v=b++;return u.set(p,{id:v,callFrame:h,location:{lineNumber:h.lineNumber+1,columnNumber:h.columnNumber+1}}),v};for(const h of C.nodes)h.locationId=g(h.callFrame),h.positionTicks=h.positionTicks?.map(p=>({...p,startLocationId:g({...h.callFrame,lineNumber:p.line-1,columnNumber:0}),endLocationId:g({...h.callFrame,lineNumber:p.line,columnNumber:0})}));return[...u.values()].sort((h,p)=>h.id-p.id).map(h=>({locations:[h.location],callFrame:h.callFrame}))},R=C=>{if(!C.timeDeltas||!C.samples)return{nodes:[],locations:[],samples:C.samples||[],timeDeltas:C.timeDeltas||[],duration:C.endTime-C.startTime};const{samples:b,timeDeltas:u}=C,h=k(C).map((c,n)=>{const s=c.locations[0];return{id:n,selfTime:0,aggregateTime:0,ticks:0,callFrame:c.callFrame,src:s}}),p=new Map,d=c=>{let n=p.get(c);return n===void 0&&(n=p.size,p.set(c,n)),n},v=new Array(C.nodes.length);for(let c=0;c<C.nodes.length;c++){const n=C.nodes[c],s=d(n.id);v[s]={id:s,selfTime:0,aggregateTime:0,locationId:n.locationId,children:n.children?.map(d)||[]};for(const i of n.positionTicks||[])i.startLocationId&&(h[i.startLocationId].ticks+=i.ticks)}for(const c of v)for(const n of c.children)v[n].parent=c.id;const m=C.endTime-C.startTime;let f=m-u[0];for(let c=0;c<u.length-1;c++){const n=u[c+1];v[d(b[c])].selfTime+=n,f-=n}v.length&&(v[d(b[u.length-1])].selfTime+=f,u.push(f));for(let c=0;c<v.length;c++){const n=v[c],s=h[n.locationId];s.aggregateTime+=t(c,v),s.selfTime+=n.selfTime}return{nodes:v,locations:h,samples:b.map(d),timeDeltas:u,duration:m}};e.buildModel=R;class D{static root(){return new D({id:-1,selfTime:0,aggregateTime:0,ticks:0,callFrame:{functionName:"(root)",lineNumber:-1,columnNumber:-1,scriptId:"0",url:""}})}get id(){return this.location.id}get callFrame(){return this.location.callFrame}get src(){return this.location.src}constructor(b,u){this.location=b,this.parent=u,this.children={},this.aggregateTime=0,this.selfTime=0,this.ticks=0,this.childrenSize=0}addNode(b){this.selfTime+=b.selfTime,this.aggregateTime+=b.aggregateTime}}const P=(C,b,u,g=b)=>{let h=C.children[b.locationId];h||(h=new D(u.locations[b.locationId],C),C.childrenSize++,C.children[b.locationId]=h),h.addNode(g),b.parent&&P(h,u.nodes[b.parent],u,g)};function w(C){return C.functionName.startsWith("(")&&C.functionName.endsWith(")")}function S(C){return Array.isArray(C.locations)&&Array.isArray(C.samples)&&Array.isArray(C.timeDeltas)}function E(C,b,u=!1){const g=S(C)?C:(0,e.buildModel)(C),h=D.root();for(const m of g.nodes)P(h,m,g),h.addNode(m);const p=Object.values(h.children).sort((m,f)=>f.selfTime-m.selfTime).slice(0,b),d=[];function v(m){let f=m.functionName||"(anonymous)";return m.url&&(f+="#",f+=u?m.url:(0,I.basename)(m.url),m.lineNumber>=0&&(f+=":",f+=m.lineNumber+1)),f}for(const m of p){const f={selfTime:Math.round(m.selfTime/1e3),totalTime:Math.round(m.aggregateTime/1e3),location:v(m.callFrame),url:m.callFrame.url,caller:[],percentage:Math.round(m.selfTime/(g.duration/100)),isSpecial:w(m.callFrame)},c=[m];for(;c.length;){const n=c.pop();let s;for(const i of Object.values(n.children))(!s||s.selfTime<i.selfTime)&&(s=i);if(s){const i=Math.round(s.selfTime/(n.selfTime/100));f.caller.push({percentage:i,location:v(s.callFrame)}),c.push(s)}}d.push(f)}return d}e.bottomUp=E}),define(Z[62],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(Z[47],ee([0,1,121,12]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,P){I.ok(t.isString(D)),I.ok(t.isObject(P)),I.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(Z[216],ee([0,1,3,47]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,S){this.schemasById[k(w)]=S,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Z[63],ee([0,1,24,3,12,148,19,216,47]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=w.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const i=this.doRegisterConfigurations(n,s);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const s=this.doDeregisterConfigurations(n);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const i=[];i.push(...this.doDeregisterConfigurations(s)),i.push(...this.doRegisterConfigurations(n,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,I.distinct)(i)})}registerDefaultConfigurations(n){const s=[],i=[];for(const{overrides:o,source:r}of n)for(const l in o)if(s.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),y=a?.valuesSources??new Map;if(r)for(const G of Object.keys(o[l]))y.set(G,r);const M={...a?.value||{},...o[l]};this.configurationDefaultsOverrides.set(l,{source:r,value:M,valuesSources:y});const T=(0,D.getLanguageTagSettingPlainKey)(l),N={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(r)?void 0:r,defaultValueSource:r};i.push(...h(l)),this.configurationProperties[l]=N,this.defaultLanguageConfigurationOverridesNode.properties[l]=N}else{this.configurationDefaultsOverrides.set(l,{value:o[l],source:r});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:i,source:o}of n)for(const r in i){const l=this.configurationDefaultsOverrides.get(r),a=k.isString(o)?o:o?.id,y=k.isString(l?.source)?l?.source:l?.source?.id;if(a===y)if(s.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const M=this.configurationProperties[r];M&&(this.updatePropertyDefaultValue(r,M),this.updateSchema(r,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const s=[],i=o=>{if(o.properties)for(const r in o.properties){s.push(r);const l=this.configurationProperties[r];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r])}o.allOf?.forEach(r=>i(r))};for(const o of n){i(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(n,s=!0,i,o,r=3){r=k.isUndefinedOrNull(n.scope)?r:n.scope;const l=[],a=n.properties;if(a)for(const M in a){const T=a[M];if(s&&m(M,T)){delete a[M];continue}if(T.source=i,T.defaultDefaultValue=a[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?r:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!o?.includes(M):T.restricted),a[M].hasOwnProperty("included")&&!a[M].included){this.excludedConfigurationProperties[M]=a[M],delete a[M];continue}else this.configurationProperties[M]=a[M],a[M].policy?.name&&this.policyConfigurations.set(a[M].policy.name,M);!a[M].deprecationMessage&&a[M].markdownDeprecationMessage&&(a[M].deprecationMessage=a[M].markdownDeprecationMessage),l.push(M)}const y=n.allOf;if(y)for(const M of y)l.push(...this.validateAndRegisterProperties(M,s,i,o,r));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=i=>{const o=i.properties;if(o)for(const l in o)this.updateSchema(l,o[l]);i.allOf?.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,r=i?.source;k.isUndefined(o)&&(o=s.defaultDefaultValue,r=void 0),k.isUndefined(o)&&(o=d(s.type)),s.default=o,s.defaultValueSource=r}}const u="\\[([^\\]]+)\\]",g=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=g.exec(c);for(;s?.length;){const i=s[1].trim();i&&n.push(i),s=g.exec(c)}}return(0,I.distinct)(n)}e.overrideIdentifiersFromKey=h;function p(c){return c.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=p;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const v=new b;w.Registry.add(e.Extensions.Configuration,v);function m(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,c,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=m;function f(){const c=[],n=v.getConfigurationProperties();for(const s of Object.keys(n))c.push([s,n[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(Z[109],ee([0,1,24,3,43,2,39,50,12,7,19,63,47]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class u{constructor(s={},i=[],o=[],r){this._contents=s,this._keys=i,this._overrides=o,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof u)return i;const o=new g("");return o.parseRaw(i),o.configurationModel});this._rawConfiguration=s.reduce((i,o)=>o===i?o:i.merge(o),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,E.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const o=this.rawConfiguration.getValue(s),r=i?this.rawConfiguration.getOverrideValue(s,i):void 0,l=i?this.rawConfiguration.override(i).getValue(s):o;return{value:o,override:r,merged:l}}getOverrideValue(s,i){const o=this.getContentsForOverrideIdentifer(i);return o?s?(0,E.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return I.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of s)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(i,a.contents);for(const y of a.overrides){const[M]=o.filter(T=>I.equals(T.identifiers,y.identifiers));M?(this.mergeContents(M.contents,y.contents),M.keys.push(...y.keys),M.keys=I.distinct(M.keys)):o.push(P.deepClone(y))}for(const y of a.keys)r.indexOf(y)===-1&&r.push(y)}return new u(i,r,o,l.every(a=>a instanceof u)?void 0:l)}freeze(){return this.frozen=!0,this}clone(){return new u(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const a=i[r];a&&(typeof l=="object"&&typeof a=="object"?(l=P.deepClone(l),this.mergeContents(l,a)):l=a),o[r]=l}return new u(o,this.keys,this.overrides)}mergeContents(s,i){for(const o of Object.keys(i)){if(o in s&&w.isObject(s[o])&&w.isObject(i[o])){this.mergeContents(s[o],i[o]);continue}s[o]=P.deepClone(i[o])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?P.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,o=null;const r=l=>{l&&(o?this.mergeContents(o,l):o=P.deepClone(l))};for(const l of this.overrides)I.equals(l.identifiers,[s])?i=l.contents:l.identifiers.includes(s)&&r(l.contents);return r(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,E.addToValueTree)(this.contents,s,i,o=>{throw new Error(o)})}removeValue(s){this.removeKey(s)&&(0,E.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let o=0;o<i;o++)s.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,s)}removeKey(s){const i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=u;class g{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!w.isUndefinedOrNull(s)){const o=this.doParseContent(s);this.parseRaw(o,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:o,keys:r,overrides:l,restricted:a,hasExcludedProperties:y}=this.doParseRaw(s,i);this._configurationModel=new u(o,r,l,y?[s]:void 0),this._restrictedConfigurations=a||[]}doParseContent(s){let i={},o=null,r=[];const l=[],a=[];function y(T){Array.isArray(r)?r.push(T):o!==null&&(r[o]=T)}const M={onObjectBegin:()=>{const T={};y(T),l.push(r),r=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const T=[];y(T),l.push(r),r=T,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(T,N,G)=>{a.push({error:T,offset:N,length:G})}};if(s)try{k.visit(s,M),i=r[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(s,i){const o=b.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(s,o,!0,i);s=r.raw;const l=(0,E.toValuesTree)(s,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),a=Object.keys(s),y=this.toOverrides(s,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:l,keys:a,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(s,i,o,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:l};const a={},y=[];for(const M in s)if(C.OVERRIDE_PROPERTY_REGEX.test(M)&&o){const T=this.filter(s[M],i,!1,r);a[M]=T.raw,l=l||T.hasExcludedProperties,y.push(...T.restricted)}else{const T=i[M],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&y.push(M),(N===void 0||r.scopes===void 0||r.scopes.includes(N))&&!(r.skipRestricted&&T?.restricted)?a[M]=s[M]:l=!0}return{raw:a,restricted:y,hasExcludedProperties:l}}toOverrides(s,i){const o=[];for(const r of Object.keys(s))if(C.OVERRIDE_PROPERTY_REGEX.test(r)){const l={};for(const a in s[r])l[a]=s[r][a];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(r),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,i)})}return o}}e.ConfigurationModelParser=g;class h extends R.Disposable{constructor(s,i,o,r){super(),this.userSettingsResource=s,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&o.isEqual(l.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class p{constructor(s,i,o,r,l,a,y,M,T,N,G,ae,X){this.key=s,this.overrides=i,this.value=o,this.overrideIdentifiers=r,this.defaultConfiguration=l,this.policyConfiguration=a,this.applicationConfiguration=y,this.userConfiguration=M,this.localUserConfiguration=T,this.remoteUserConfiguration=N,this.workspaceConfiguration=G,this.folderConfigurationModel=ae,this.memoryInspectValue=X}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(s,i,o,r,l=new u,a=new u,y=new D.ResourceMap,M=new u,T=new D.ResourceMap,N=!0){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=r,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=y,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._freeze=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(s,i,o){return this.getConsolidatedConfigurationModel(s,i,o).getValue(s)}updateValue(s,i,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new u,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(s):r.setValue(s,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,o){const r=this.getConsolidatedConfigurationModel(s,i,o),l=I.distinct(r.overrides.map(M=>M.identifiers).flat()).filter(M=>r.getOverrideValue(s,M)!==void 0),a=this.getFolderConfigurationModelForResource(i.resource,o),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration;return new p(s,i,r.getValue(s),l.length?l:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,y.inspect(s,i.overrideIdentifier))}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:r,updated:l,removed:a}=f(this._defaultConfiguration,s);i=[...r,...l,...a]}for(const r of i)for(const l of(0,C.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),y=s.getKeysForOverrideIdentifier(l),M=[...y.filter(T=>a.indexOf(T)===-1),...a.filter(T=>y.indexOf(T)===-1),...a.filter(T=>!P.equals(this._defaultConfiguration.override(l).getValue(T),s.override(l).getValue(T)))];o.push([l,M])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:r}=f(this._policyConfiguration,s),l=[...i,...o,...r];return l.length&&this.updatePolicyConfiguration(s),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:o,removed:r,overrides:l}=f(this.applicationConfiguration,s),a=[...i,...o,...r];return a.length&&this.updateApplicationConfiguration(s),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:r,overrides:l}=f(this.localUserConfiguration,s),a=[...i,...o,...r];return a.length&&this.updateLocalUserConfiguration(s),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:r,overrides:l}=f(this.remoteUserConfiguration,s),a=[...i,...o,...r];return a.length&&this.updateRemoteUserConfiguration(s),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:r,overrides:l}=f(this.workspaceConfiguration,s),a=[...i,...o,...r];return a.length&&this.updateWorkspaceConfiguration(s),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:r,updated:l,removed:a,overrides:y}=f(o,i),M=[...r,...l,...a];return(M.length||!o)&&this.updateFolderConfiguration(s,i),{keys:M,overrides:y}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:r,removed:l,overrides:a}=f(i,void 0);return{keys:[...o,...r,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,o){let r=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:s},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const r=i.getFolder(s);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const l=this._memoryConfigurationByResource.get(s);l&&(o=o.merge(l))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(s);r?(i=o.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=o}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:o,overrides:r,keys:l}=this._folderConfigurations.get(i);return s.push([i,{contents:o,overrides:r,keys:l}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>s.add(o))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),o=this.parseConfigurationModel(s.policy),r=this.parseConfigurationModel(s.application),l=this.parseConfigurationModel(s.user),a=this.parseConfigurationModel(s.workspace),y=s.folders.reduce((M,T)=>(M.set(S.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new d(i,o,r,l,new u,a,y,new u,new D.ResourceMap,!1)}static parseConfigurationModel(s){return new u(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=d;function v(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const r of n)r.keys.forEach(l=>s.add(l)),r.overrides.forEach(([l,a])=>{const y=(0,D.getOrSet)(i,l,new Set);a.forEach(M=>y.add(M))});const o=[];return i.forEach((r,l)=>o.push([l,[...r.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=v;class m{constructor(s,i,o,r){this.change=s,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;s.keys.forEach(y=>l.add(y)),s.overrides.forEach(([,y])=>y.forEach(M=>l.add(M))),this.affectedKeys=[...l.values()];const a=new u;this.affectedKeys.forEach(y=>a.setValue(y,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!P.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let o=(0,E.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(s=s[r],!s)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=m;function f(n,s){const{added:i,removed:o,updated:r}=c(s?.rawConfiguration,n?.rawConfiguration),l=[],a=n?.getAllOverrideIdentifiers()||[],y=s?.getAllOverrideIdentifiers()||[];if(s){const M=y.filter(T=>!a.includes(T));for(const T of M)l.push([T,s.getKeysForOverrideIdentifier(T)])}if(n){const M=a.filter(T=>!y.includes(T));for(const T of M)l.push([T,n.getKeysForOverrideIdentifier(T)])}if(s&&n){for(const M of a)if(y.includes(M)){const T=c({contents:n.getOverrideValue(void 0,M)||{},keys:n.getKeysForOverrideIdentifier(M)},{contents:s.getOverrideValue(void 0,M)||{},keys:s.getKeysForOverrideIdentifier(M)});l.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:o,updated:r,overrides:l}}function c(n,s){const i=n?s?n.keys.filter(l=>s.keys.indexOf(l)===-1):[...n.keys]:[],o=s?n?s.keys.filter(l=>n.keys.indexOf(l)===-1):[...s.keys]:[],r=[];if(n&&s){for(const l of s.keys)if(n.keys.indexOf(l)!==-1){const a=(0,E.getConfigurationValue)(s.contents,l),y=(0,E.getConfigurationValue)(n.contents,l);P.equals(a,y)||r.push(l)}}return{added:i,removed:o,updated:r}}}),define(Z[217],ee([0,1,24,3,2,50,12,19,109,63,6,36,47]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class u extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new g(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(b.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:m})=>this.onDidUpdateConfiguration(v,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=u;class g extends w.ConfigurationModel{constructor(v={}){const m=b.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(m),c=Object.create(null),n=[];for(const s in m){const i=v[s],o=i!==void 0?i:m[s].default;(0,P.addToValueTree)(c,s,o,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(c))S.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(s),keys:Object.keys(c[s]),contents:(0,P.toValuesTree)(c[s],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,f,n)}}e.DefaultConfigurationModel=g;class h{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let p=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(v,m,f){super(),this.defaultConfiguration=v,this.policyService=m,this.logService=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const m={},f=[],c=b.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of v){const s=c[n];if(!s){f.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(n),m[s.policy.name]={type:s.type}}}return(0,D.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),f}onDidChangePolicies(v){const m=b.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),f=(0,I.coalesce)(v.map(c=>m.get(c)));this.update(f,!0)}update(v,m){const f=b.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const s of v){const i=f[s]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(n?o!==void 0:!(0,R.equals)(this._configurationModel.getValue(s),o))&&c.push([s,o])}else this._configurationModel.getValue(s)!==void 0&&c.push([s,void 0])}if(c.length){const s=this._configurationModel;this._configurationModel=new w.ConfigurationModel;for(const i of s.keys)this._configurationModel.setValue(i,s.getValue(i));for(const[i,o]of c)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};p=we([te(1,C.IPolicyService),te(2,E.ILogService)],p),e.PolicyConfiguration=p}),define(Z[218],ee([0,1,8,3,2,18,19,109,217,36]),function(z,e,I,t,k,R,D,P,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends k.Disposable{constructor(b,u,g,h){super(),this.settingsResource=b,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new w.DefaultConfiguration),this.policyConfiguration=g instanceof S.NullPolicyService?new w.NullPolicyConfiguration:this._register(new w.PolicyConfiguration(this.defaultConfiguration,g,h)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,u)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:p,properties:d})=>this.onDidDefaultConfigurationChange(p,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(p=>this.onDidPolicyConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[b,u,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(b,u,new P.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(b,u){const g=typeof b=="string"?b:void 0,h=(0,D.isConfigurationOverrides)(b)?b:(0,D.isConfigurationOverrides)(u)?u:{};return this.configuration.getValue(g,h,void 0)}updateValue(b,u,g,h){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const u=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(g,u,2)}onDidDefaultConfigurationChange(b,u){const g=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(b,u);this.trigger(h,g,7)}onDidPolicyConfigurationChange(b){const u=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(b);this.trigger(g,u,7)}trigger(b,u,g){const h=new P.ConfigurationChangeEvent(b,{data:u},this.configuration);h.source=g,h.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(b){switch(b){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(Z[219],ee([0,1,16,5]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends I.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}constructor(P,w=k.Unknown,S){super(P),this._message=P,this._code=w,this._detail=S,this.isHandled=w===k.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(Z[64],ee([0,1,14]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(S){return S.scheme===I.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=t;function k(S){if(!S)return;const E=S.indexOf("+");return E<0?S:S.substr(0,E)}e.getRemoteName=k;function R(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(S){const{host:E,port:C}=w(S);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:C}}e.parseAuthorityWithPort=D;function P(S,E){let{host:C,port:b}=w(S);return typeof b>"u"&&(b=E),{host:C,port:b}}e.parseAuthorityWithOptionalPort=P;function w(S){const E=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const C=S.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const b=S.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:S,port:void 0}}}),define(Z[110],ee([0,1,26,5,64]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=R;function D(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,p){if(typeof h>"u"||h===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof h=="string"||typeof p=="string"){const d=typeof h=="string"?h:h.value,v=typeof p=="string"?p:p.value;return I.equalsIgnoreCase(d,v)}return h._lower===p._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=S;function E(g){return C(g)}e.isApplicationScopedExtension=E;function C(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function u(g,h){if(h){const p=`onResolveRemoteAuthority:${(0,k.getRemoteName)(h)}`;return g.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=u,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[111],ee([0,1,26,191,110,4,7,16,33]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,I.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=S;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(i){const o=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new C(i.identifier,o,r)}static parse(i){const o=E.exec(i);return o&&o[1]&&o[2]?new C({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,r="undefined"){this.version=o,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof C?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=C;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(s){const i=b.exec(s);return i&&i[1]?[h(i[1]),i[2]]:[h(s),void 0]}e.getIdAndVersion=u;function g(s,i){return`${s}.${i}`}e.getExtensionId=g;function h(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function p(s,i){return h(g(s,i))}e.getGalleryExtensionId=p;function d(s,i){const o=[],r=l=>{for(const a of o)if(a.some(y=>S(i(y),i(l))))return a;return null};for(const l of s){const a=r(l);a?a.push(l):o.push([l])}return o}e.groupByExtension=d;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function m(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(s,i){const o=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&o.every(a=>!S(a.identifier,{id:l}))){const a=s.filter(y=>S(y.identifier,{id:l}));a.length===1&&(o.push(a[0]),r.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=f;async function c(s,i){if(!R.isLinux)return!1;let o;try{o=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(s,i){const o=await c(s,i),r=(0,t.getTargetPlatform)(o?"alpine":R.platform,w.arch);return i.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=n}),define(Z[73],ee([0,1,8,17,2,39,7,111,15,5,6]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(u,g){super(),this.fileService=u,this.logService=g,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(u){return this.withProfileExtensions(u)}addExtensionsToProfile(u,g){return this.withProfileExtensions(g,h=>(h=h.filter(p=>u.some(([d])=>!(0,P.areSameExtensions)(p.identifier,d.identifier))),h.push(...u.map(([p,d])=>({identifier:p.identifier,version:p.manifest.version,location:p.location,metadata:d}))),h))}removeExtensionFromProfile(u,g){return this.withProfileExtensions(g,h=>h.filter(p=>!(0,P.areSameExtensions)(p.identifier,u)))}async withProfileExtensions(u,g){return this.getResourceAccessQueue(u).queue(async()=>{let h=[];try{const p=await this.fileService.readFile(u),d=JSON.parse(p.value.toString());for(const v of d){if(!v.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",v);continue}if(!v.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",v);continue}if(!v.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",v);continue}h.push({identifier:v.identifier,location:D.URI.revive(v.location),version:v.version,metadata:v.metadata})}}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}if(g){h=g(h);const p=h.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),metadata:d.metadata}));await this.fileService.writeFile(u,t.VSBuffer.fromString(JSON.stringify(p)))}return h})}getResourceAccessQueue(u){let g=this.resourcesAccessQueueMap.get(u);return g||(g=new I.Queue,this.resourcesAccessQueueMap.set(u,g)),g}};C=we([te(0,w.IFileService),te(1,E.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(Z[220],ee([0,1,8,17,23,16,3,2,29,102,219,64]),function(z,e,I,t,k,R,D,P,w,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var u;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(u=e.ConnectionType||(e.ConnectionType={}));function g(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(B){const $=new k.CancellationTokenSource;return setTimeout(()=>$.cancel(),B),$.token}function p(B,$){if(B.isCancellationRequested||$.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class d{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function v(B,$){const L=new d($);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),H=F(_);H?L.reject(H):L.resolve(_)})),L.promise}function m(B,$,L,O,_,H,Y,se){const j=new d(se);return $.connect(L,O,_,H,Y,(re,ne)=>{j.didTimeout?(re&&B.error(re),ne?.dispose()):re||!ne?j.reject(re):j.resolve(ne)}),j.promise}function f(B,$){const L=new d($);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(B,$,L,O){const _=U(B,$);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let H;try{H=await m(B.logService,B.socketFactory,B.host,B.port,(0,C.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${g($)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let Y,se;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(H,null),Y=B.reconnectionProtocol,se=!1):(Y=new S.PersistentProtocol(H,null),se=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const j=await f(B.signService.createNewMessage((0,w.generateUuid)()),O),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:j.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(re)));try{const ne=await v(Y,p(O,h(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Te=new Error("Unexpected handshake message");throw Te.code="VSCODE_CONNECTION_ERROR",Te}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await f(B.signService.validate(j,ne.signedData),O)){const Te=new Error("Refused to connect to unsupported server");throw Te.code="VSCODE_CONNECTION_ERROR",Te}const ge=await f(B.signService.sign(ne.data),O),Re={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:$};return L&&(Re.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Re))),{protocol:Y,ownsProtocol:se}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),se&&q(Y),ne}}async function n(B,$,L,O){const _=Date.now(),H=U(B,$),{protocol:Y,ownsProtocol:se}=await c(B,$,L,O),j=new d(O);return j.registerDisposable(Y.onControlMessage(re=>{const ne=JSON.parse(re.toString()),ce=F(ne);ce?(B.logService.error(`${H} received error control message when negotiating connection. Error:`),B.logService.error(ce),se&&q(Y),j.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${J(_)}!`),j.resolve({protocol:Y,firstMessage:ne}))})),j.promise}async function s(B,$){const{protocol:L}=await n(B,1,void 0,$);return{protocol:L}}async function i(B,$,L){const{protocol:O,firstMessage:_}=await n(B,2,$,L),H=_&&_.debugPort;return{protocol:O,debugPort:H}}async function o(B,$,L){const O=Date.now(),_=U(B,3),{protocol:H}=await c(B,3,$,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${J(O)}!`),H}async function r(B,$,L){const{host:O,port:_,connectionToken:H}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:H,reconnectionToken:$,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function l(B,$,L){return y(B,async O=>{const{protocol:_}=await s(O,k.CancellationToken.None);return new he(B,$,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=l;async function a(B,$){return y(B,async L=>{const{protocol:O,debugPort:_}=await i(L,$,k.CancellationToken.None);return new V(B,$,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=a;async function y(B,$){for(let O=1;;O++)try{const _=(0,w.generateUuid)(),H=await r(B,_,null);return await $(H)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),oe.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(_)),_}}async function M(B,$,L){const O=await r(B,(0,w.generateUuid)(),null);return await o(O,{host:$,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,I.createCancelablePromise)($=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);$.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class G{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=G;class ae{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ae;class X{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=X;class Q{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=Q;class ie{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=ie;class oe extends P.Disposable{static triggerPermanentFailure($,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||oe._permanentFailure}constructor($,L,O,_,H){super(),this._connectionType=$,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(_.onSocketClose(Y=>{const se=W(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(Y=>{const se=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),oe._instances.push(this),this._register((0,P.toDisposable)(()=>{const Y=oe._instances.indexOf(this);Y>=0&&oe._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const Y=T(_);this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,Y)),this._options.logService.info(`${$} waiting for ${_} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${$} resolving connection...`);const H=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,h(b)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,R.isCancellationError)(H)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,E.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,O){this._reconnectionFailureIsFatal?oe.triggerPermanentFailure($,L,O):this._gotoPermanentFailure($,L,O)}_gotoPermanentFailure($,L,O){this._onDidStateChange.fire(new ie(this.reconnectionToken,$,L,O)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=oe,oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class he extends oe{constructor($,L,O,_,H){super(1,$,_,H,!0),this.client=this._register(new S.Client(H,{remoteAuthority:L,clientId:O},$.ipcLogger))}async _reconnect($,L){await s($,L)}}e.ManagementPersistentConnection=he;class V extends oe{constructor($,L,O,_,H){super(2,$,O,_,!1),this._startArguments=L,this.debugPort=H}async _reconnect($,L){await i($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=V;function q(B){try{B.acceptDisconnect();const $=B.getSocket();B.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function F(B){if(B&&B.type==="error"){const $=new Error(`Connection error: ${B.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function A(B,$){for(;B.length<$;)B+=" ";return B}function W(B,$,L){return`[remote-connection][${A(g(B),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function U(B,$){return`${W($,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function J(B){return`${Date.now()-B} ms`}}),define(Z[221],ee([0,1,79,84]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,P,w,S){const E=b=>S(b,void 0),C=I.createConnection({host:k,port:R},()=>{C.removeListener("error",E);const b=Buffer.alloc(16);for(let p=0;p<16;p++)b[p]=Math.round(Math.random()*256);const u=b.toString("base64"),g=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];C.write(g.join(`\r
`)+`\r
\r
`);const h=p=>{p.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",h),S(void 0,new t.NodeSocket(C,w)))};C.on("data",h)});C.setNoDelay(!0),C.once("error",E)}}}),define(Z[222],ee([0,1,25,45,40,182]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(u=!1){return(D===void 0||u)&&(D=w()),D}e.hasWSLFeatureInstalled=P;async function w(){const u=S();if(u===void 0)return!1;if(u>=22e3){const g=C();if(g)return new Promise(h=>{t.execFile(g,["--status"],p=>h(!p))})}else{const g=b();if(g)try{if((await k.promises.stat(g)).isFile())return!0}catch{}}return!1}function S(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(u)return parseInt(u[3])}function E(u){const g=process.env.SystemRoot;if(g){const h=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(g,h?"Sysnative":"System32",u)}}function C(){return E("wsl.exe")}function b(){return E("lxss\\LxssManager.dll")}}),define(Z[55],ee([0,1,17,165,63,5,47]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function w(h){return h.res.statusCode===204}async function S(h){return w(h)?null:(await(0,I.streamToBuffer)(h.stream)).toString()}e.asText=S;async function E(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)}e.asTextOrError=E;async function C(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const d=(await(0,I.streamToBuffer)(h.stream)).toString();try{return JSON.parse(d)}catch(v){throw v.message+=`:
`+d,v}}e.asJson=C;function b(h){g(h)}e.updateProxyConfigurationsScope=b;let u;function g(h){const p=D.Registry.as(k.Extensions.Configuration),d=u;u={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[u],remove:d?[d]:[]})}g(2)}),define(Z[223],ee([0,1,17,23]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.service=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,S,E=t.CancellationToken.None){switch(w){case"request":return this.service.request(S[0],E).then(async({res:C,stream:b})=>{const u=await(0,I.streamToBuffer)(b);return[{statusCode:C.statusCode,headers:C.headers},u]});case"resolveProxy":return this.service.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(P){this.channel=P}async request(P,w){const[S,E]=await this.channel.call("request",[P],w);return{res:S,stream:(0,I.bufferToStream)(E)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=R}),define(Z[224],ee([0,1,225,12]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(D,P,w={}){const S=(0,I.parse)(D),E=w.proxyUrl||k(S,P);if(!E)return null;const C=(0,I.parse)(E);if(!/^https?:$/.test(C.protocol||""))return null;const b={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,t.isBoolean)(w.strictSSL)?w.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((u,g)=>{z(["http-proxy-agent"],u,g)}))(b):new(await new Promise((u,g)=>{z(["https-proxy-agent"],u,g)}))(b)}e.getProxyAgent=R}),define(Z[112],ee([0,1,45,9,166,23,44,16,4,29,142,60,8]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const u=1e4;let g;async function h(d,v,m){return v["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(m)&&!v["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(m)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=b.Promises.withAsyncBody(async(f,c)=>{const n=new R.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),c(new Error((0,k.localize)(0,null)))},u);try{f(await p(d,n.token))}catch(i){!(0,P.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):f({})}finally{clearTimeout(s),n.dispose()}})),g)}e.getResolvedShellEnv=h;async function p(d,v){const m=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",m);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",f);const c=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",s);const i=await(0,E.getSystemShell)(w.OS,s);return d.trace("getUnixShellEnvironment#shell",i),new Promise((o,r)=>{if(v.isCancellationRequested)return r((0,P.canceled)());const l=(0,t.basename)(i);let a,y;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,y=["-Login","-Command"]):(a=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?y=["-ic"]:y=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),a);const T=(0,I.spawn)(i,[...y,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(T.kill(),r((0,P.canceled)()))),T.on("error",ae=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ae)),r(ae)});const N=[];T.stdout.on("data",ae=>N.push(ae));const G=[];T.stderr.on("data",ae=>G.push(ae)),T.on("close",(ae,X)=>{const Q=Buffer.concat(N).toString("utf8");d.trace("getUnixShellEnvironment#raw",Q);const ie=Buffer.concat(G).toString("utf8");if(ie.trim()&&d.trace("getUnixShellEnvironment#stderr",ie),ae||X)return r(new Error((0,k.localize)(2,null,ae,X)));const oe=n.exec(Q),he=oe?oe[1]:"{}";try{const V=JSON.parse(he);m?V.ELECTRON_RUN_AS_NODE=m:delete V.ELECTRON_RUN_AS_NODE,f?V.ELECTRON_NO_ATTACH_CONSOLE=f:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",V),o(V)}catch(V){d.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),r(V)}})})}}),define(Z[88],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[226],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const P=String(I._nextId++);return this.validators.set(P,D),{id:P,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=I,I._nextId=1}),define(Z[37],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(Z[22],ee([0,1,13,41,8,3,2,4,33,12,5,6,37,27]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var g;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(g=e.ShutdownReason||(e.ShutdownReason={}));var h;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(h=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let p=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(v,m,f){super(),this.logService=v,this.stateMainService=m,this.environmentMainService=f,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};I.app.addListener("before-quit",v);const m=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",m),I.app.once("will-quit",f=>{this.trace("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),I.app.removeListener("before-quit",v),I.app.removeListener("window-all-closed",m),I.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({reason:v,join(f){m.push(f)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(m)}catch(f){this.logService.error(f)}try{await this.stateMainService.close()}catch(f){this.logService.error(f)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const m=this.phaseWhen.get(this._phase);m&&(m.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let m=this.phaseWhen.get(v);m||(m=new k.Barrier,this.phaseWhen.set(v,m)),await m.wait()}registerWindow(v){const m=new D.DisposableStore;this.windowCounter++,m.add(v.onWillLoad(c=>this._onWillLoadWindow.fire({window:v,workspace:c.workspace,reason:c.reason})));const f=(0,S.assertIsDefined)(v.win);f.on("close",c=>{const n=v.id;if(this.windowToCloseRequest.has(n)){this.windowToCloseRequest.delete(n);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(s=>{if(s){this.windowToCloseRequest.delete(n);return}this.windowToCloseRequest.add(n),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this._onBeforeCloseWindow.fire(v),v.close()})}),f.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,m.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,m){await this.unload(v,3)||v.reload(m)}unload(v,m){const f=this.mapWindowIdToPendingUnload.get(v.id);if(f)return f;const c=this.doUnload(v,m).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,c),c}async doUnload(v,m){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const f=this._quitRequested?2:m,c=await this.onBeforeUnloadWindowInRenderer(v,f);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(v,f),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,m){return new Promise(f=>{const c=this.oneTimeListenerTokenGenerator++,n=`vscode:ok${c}`,s=`vscode:cancel${c}`;t.validatedIpcMain.once(n,()=>{f(!1)}),t.validatedIpcMain.once(s,()=>{f(!0)}),v.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:s,reason:m})})}onWillUnloadWindowInRenderer(v,m){return new Promise(f=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(n,()=>f()),v.send("vscode:onWillUnload",{replyChannel:n,reason:m})})}quit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(m=>{this.pendingQuitPromiseResolve=m,this.trace("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}async relaunch(v){this.trace("Lifecycle#relaunch()");const m=process.argv.slice(1);if(v?.addArgs&&m.push(...v.addArgs),v?.removeArgs)for(const n of v.removeArgs){const s=m.indexOf(n);s>=0&&m.splice(s,1)}const f=()=>{try{if(P.isWindows){const n=(0,w.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.logService.error(n)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:m})};I.app.once("quit",f),await this.quit(!0)&&I.app.removeListener("quit",f)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const m of I.BrowserWindow.getAllWindows())if(m&&!m.isDestroyed()){let f;m.webContents&&!m.webContents.isDestroyed()?f=new Promise(c=>m.once("closed",c)):f=Promise.resolve(),m.destroy(),await f}})()]),I.app.exit(v)}};p.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",p=we([te(0,C.ILogService),te(1,b.IStateMainService),te(2,u.IEnvironmentMainService)],p),e.LifecycleMainService=p}),define(Z[227],ee([0,1,4,3,2,5,22]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(E){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,E.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const E=await new Promise((C,b)=>{z(["native-keymap"],C,b)});this._keyboardLayoutData=w(E),I.isCI||E.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=w(E),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=we([te(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function w(S){const E=S.getKeyMap(),C=S.getCurrentKeyboardLayout();return{keyboardMapping:E,keyboardLayoutInfo:C}}}),define(Z[228],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(Z[229],ee([0,1,8,17,12,35,15,6]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class w{constructor(C,b,u){this.storagePath=C,this.logService=b,this.fileService=u,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new I.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}}getItem(C,b){const u=this.storage[C];return(0,k.isUndefinedOrNull)(u)?b:u}setItem(C,b){this.setItems([{key:C,data:b}])}setItems(C){let b=!1;for(const{key:u,data:g}of C)this.storage[u]!==g&&((0,k.isUndefinedOrNull)(g)?(0,k.isUndefined)(this.storage[u])||(this.storage[u]=void 0,b=!0):(this.storage[u]=g,b=!0));b&&this.save()}removeItem(C){(0,k.isUndefined)(this.storage[C])||(this.storage[C]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const C=JSON.stringify(this.storage,null,4);if(C!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(C)),this.lastSavedStorageContents=C}catch(b){this.logService.error(b)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=w;let S=class{constructor(C,b,u){this.fileStorage=new w(C.stateResource,b,u)}async init(){await this.fileStorage.init()}getItem(C,b){return this.fileStorage.getItem(C,b)}};S=we([te(0,R.IEnvironmentService),te(1,P.ILogService),te(2,D.IFileService)],S),e.StateService=S}),define(Z[230],ee([0,1,229]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends I.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Z[113],ee([0,1,4,33,7,29]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(S){if(I.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,E,C,b,u,g,h,p,d,v){const m=Object.create(null);m["common.machineId"]=h,m.sessionID=(0,R.generateUuid)()+Date.now(),m.commitHash=u,m.version=g,m["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,I.PlatformToString)(I.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=b,m["common.product"]=v||"desktop",p&&(m["common.msftInternal"]=p);let f=0;const c=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),I.isLinuxSnap&&(m["common.snap"]="true");const n=D(C);n&&(m["common.platformDetail"]=n);try{const s=await S.readFile(k.URI.file(d));m["common.source"]=s.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=P;function w(S){const E=t.env.USERDNSDOMAIN;if(!E)return!1;const C=E.toLowerCase();return S.some(b=>C===b)}e.verifyMicrosoftInternalDomain=w}),define(Z[31],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[231],ee([0,1,25,57,8,43,14,9,4,7,82,21,101,85,15,20,31]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function v(s,i){const o=`${s}::${i.join(":")}`,r=d.get(o);if(r)return r;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,y=new Map,M=2e4;function T(G,ae,X,Q){const ie=ae.substring(G.length+1);return k.Promises.withAsyncBody(async oe=>{let he;try{he=await C.Promises.readdir(ae,{withFileTypes:!0})}catch{oe();return}if(Q.count>=M){Q.count+=he.length,Q.maxReached=!0,oe();return}let V=he.length;if(V===0){oe();return}let q=he;Q.count+he.length>M&&(Q.maxReached=!0,V=M-Q.count,q=he.slice(0,V)),Q.count+=he.length;for(const F of q)if(F.isDirectory()){if(X.includes(F.name)||await T(G,(0,P.join)(ae,F.name),X,Q),--V===0){oe();return}}else{const A=F.name.lastIndexOf(".");if(A>=0){const W=F.name.substring(A+1);W&&a.set(W,(a.get(W)??0)+1)}for(const W of l)W.relativePathPattern?.test(ie)!==!1&&W.filePattern.test(F.name)&&y.set(W.tag,(y.get(W.tag)??0)+1);if(--V===0){oe();return}}})}const N=k.Promises.withAsyncBody(async G=>{const ae={count:0,maxReached:!1};await T(s,s,i,ae);const X=await c(s);G({configFiles:m(y),fileTypes:m(a),fileCount:ae.count,maxFilesReached:ae.maxReached,launchConfigFiles:X})});return d.set(o,N),N}e.collectWorkspaceStats=v;function m(s){return[...t.Iterable.map(s.entries(),([i,o])=>({name:i,count:o}))].sort((i,o)=>o.count-i.count)}function f(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},i=I.cpus();return i&&i.length>0&&(s.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),s}e.getMachineInfo=f;async function c(s){try{const i=new Map,o=(0,P.join)(s,".vscode","launch.json"),r=await C.Promises.readFile(o),l=[],a=(0,R.parse)(r.toString(),l);if(l.length)return console.log(`Unable to parse ${o}`),[];if((0,R.getNodeType)(a)==="object"&&a.configurations)for(const y of a.configurations){const M=y.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return m(i)}catch{return[]}}e.collectLaunchConfigs=c;let n=class{constructor(i,o){this.telemetryService=i,this.productService=o}formatMachineInfo(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}formatEnvironment(i){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const r=I.cpus();return r&&r.length>0&&o.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),o.push(`Memory (System):  ${(I.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||o.push(`Load (avg):       ${I.loadavg().map(l=>Math.round(l)).join(", ")}`),o.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,b.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[l,a]=r,y=this.formatProcessList(i,l);return o.forEach(M=>{if((0,u.isRemoteDiagnosticError)(M))y+=`
${M.errorMessage}`,a+=`
${M.errorMessage}`;else if(y+=`

Remote: ${M.hostName}`,M.processes&&(y+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){a+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const N=M.workspaceMetadata[T];let G=`${N.fileCount} files`;N.maxFilesReached&&(G=`more than ${G}`),a+=`|    Folder (${T}): ${G}`,a+=this.formatWorkspaceStats(N)}}}),{processInfo:y,workspaceInfo:a}})}async getSystemInfo(i,o){const{memory:r,vmHint:l,os:a,cpus:y}=f(),M={os:a,memory:r,cpus:y,vmHint:l,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return w.isWindows||(M.load=`${I.loadavg().map(T=>Math.round(T)).join(", ")}`),w.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,o){const r=[];return(0,b.listProcesses)(i.mainPID).then(async l=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,l)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),o.forEach(a=>{if((0,u.isRemoteDiagnosticError)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.formatMachineInfo(a.machineInfo)),a.processes&&r.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const y of Object.keys(a.workspaceMetadata)){const M=a.workspaceMetadata[y];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),r.push(`Folder (${y}): ${T}`),r.push(this.formatWorkspaceStats(M))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const o=[];let l=0;const a=(N,G)=>{const ae=` ${N}(${G})`;l+ae.length>60?(o.push(y),y="|                 ",l=y.length):l+=ae.length,y+=ae};let y="|      File types:";const M=10,T=i.fileTypes.length>M?M:i.fileTypes.length;for(let N=0;N<T;N++){const G=i.fileTypes[N];a(G.name,G.count)}if(o.push(y),i.configFiles.length>=0&&(y="|      Conf files:",l=0,i.configFiles.forEach(N=>{a(N.name,N.count)}),o.push(y)),i.launchConfigFiles.length>0){let N="|      Launch Configs:";i.launchConfigFiles.forEach(G=>{N+=G.count>1?` ${G.name}(${G.count})`:` ${G.name}`}),o.push(N)}return o.join(`
`)}expandGPUFeatures(i){const o=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(o-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const o=[],r=[];return i.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(o.push(`|  Window (${l.title})`),l.folderURIs.forEach(a=>{const y=S.URI.revive(a);if(y.scheme===D.Schemas.file){const M=y.fsPath;r.push(v(M,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),o.push(`|    Folder (${(0,P.basename)(M)}): ${N}`),o.push(this.formatWorkspaceStats(T))}).catch(T=>{o.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else o.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(l=>o.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(i,o){const r=new Map;i.windows.forEach(a=>r.set(a.pid,a.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(i.mainPID,r,l,o,0),l.join(`
`)}formatProcessItem(i,o,r,l,a){const y=a===0;let M;y?M=l.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(a)} ${l.name}`,l.name==="window"&&(M=`${M} (${o.get(l.pid)})`));const T=process.platform==="win32"?l.mem:I.totalmem()*(l.mem/100);r.push(`${l.load.toFixed(0).padStart(5," ")}	${(T/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(l.children)&&l.children.forEach(N=>this.formatProcessItem(i,o,r,N,a+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:r}of i.folders){const l=S.URI.revive(r);if(l.scheme!==D.Schemas.file)continue;const a=l.fsPath;try{(await v(a,["node_modules",".git"])).fileTypes.forEach(M=>o.add(M.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const r=S.URI.revive(o);if(r.scheme!==D.Schemas.file)continue;const l=r.fsPath;try{const a=await v(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:y.name,count:y.count})}),a.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:y.name,count:y.count})}),a.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:y.name,count:y.count})})}catch{}}}};n=we([te(0,p.ITelemetryService),te(1,h.IProductService)],n),e.DiagnosticsService=n}),define(Z[232],ee([0,1,8,6,21,25,9,31,214,215,16]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=e.ProfilingOutput=void 0;var C;(function(u){u[u.Failure=0]="Failure",u[u.Irrelevant=1]="Irrelevant",u[u.Interesting=2]="Interesting"})(C=e.ProfilingOutput||(e.ProfilingOutput={}));let b=class{constructor(g,h,p,d){this._window=g,this._sessionId=h,this._logService=p,this._telemetryService=d}async inspect(g,h){if(!await this._connect())return 0;const d=this._window.webContents.debugger;await d.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,I.timeout)(g);const v=await d.sendCommand("Profiler.stop");this._logService.warn("[perf] profiling DONE",this._sessionId);const m=this._digest(v.profile,h);return await this._disconnect(),m}async _connect(){try{const g=this._window.webContents.debugger;return g.attach(),await g.sendCommand("Profiler.enable"),!0}catch(g){return this._logService.error(g,"[perf] FAILED to enable profiler",this._sessionId),!1}}async _disconnect(){try{const g=this._window.webContents.debugger;await g.sendCommand("Profiler.disable"),g.detach()}catch(g){this._logService.error(g,"[perf] FAILED to disable profiler",this._sessionId)}}_digest(g,h){if(!w.Utils.isValidProfile(g))return this._logService.warn("[perf] INVALID profile: no samples or timeDeltas",this._sessionId),1;const p=(0,S.buildModel)(g),d=(0,S.bottomUp)(p,5,!1).filter(v=>!v.isSpecial);if(d.length===0||d[1].percentage<10)return this._logService.warn("[perf] profiling did NOT reveal anything interesting",this._sessionId),1;for(const v of d){const m={sessionId:this._sessionId,perfBaseline:h,selfTime:v.selfTime,totalTime:v.totalTime,percentage:v.percentage,functionName:v.location,callstack:v.caller.map(c=>`${c.percentage}|${c.location}`).join("<"),extensionId:""};this._telemetryService.publicLog2("prof.freeze.sample",m);const f=new Error;f.name="PerfHeavyFunction",f.stack=`Spend ${v.selfTime}ms in ${v.location}
`+v.caller.map(c=>`	 at ${c.location} (${c.percentage}%)`).join(`
`),this._logService.error(f,"[perf] HEAVY function sample")}return this._store(g).catch(E.onUnexpectedError),2}async _store(g){const h=(0,D.join)((0,R.tmpdir)(),`renderer-profile-${Date.now()}.cpuprofile`);await k.Promises.writeFile(h,JSON.stringify(g)),this._logService.info(`[perf] stored profile to DISK '${h}'`,this._sessionId)}};b=we([te(2,t.ILogService),te(3,P.ITelemetryService)],b),e.WindowProfiler=b}),define(Z[233],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:P,data:w}){return this.appenders.forEach(S=>S.log(P,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[74],ee([0,1,50,97,12,19,113,31]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(o,r){return Promise.resolve(void 0)}publicLog2(o,r){return this.publicLog(o,r)}publicLogError(o,r){return Promise.resolve(void 0)}publicLogError2(o,r){return this.publicLogError(o,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class S{async publicLog(o,r,l){}async publicLogError(o,r,l){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(i,o){return o.onDidChangeConfiguration(r=>{r.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:d(r.sourceConfig)})})}e.configurationTelemetry=E;function C(i,o){return!(o.disableTelemetry||!i.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=C;function b(i){const o=i.getValue(P.TELEMETRY_SETTING_ID),r=i.getValue("telemetry.enableCrashReporter");if(i.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function u(i){const o={},r={},l={};p(i,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const y=l[a];typeof y=="number"?r[a]=y:typeof y=="boolean"?r[a]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${y.length}`),o[a]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(o[a]=y)}return{properties:o,measurements:r}}e.validateTelemetryData=u;const g=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function h(i){if(!i)return"none";for(const o of g)if(i.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=h;function p(i,o,r=0,l){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const y=i[a],M=l?l+a:a;Array.isArray(y)?o[M]=(0,I.safeStringify)(y):y instanceof Date?o[M]=y.toISOString():(0,k.isObject)(y)?r<2?p(y,o,r+1,M+"."):o[M]=(0,I.safeStringify)(y):o[M]=y}}function d(i){if(!i)return[];const o=[];return v(o,"",i),o}function v(i,o,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(l=>v(i,o?`${o}.${l}`:l,r[l])):i.push(o)}function m(i,o){const r=i.msftInternalDomains||[],l=o.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(r)||l}e.isInternalTelemetry=m;function f(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=f;function c(i,o){let r=i;const l=[];for(const T of o)for(;;){const N=T.exec(i);if(!N)break;l.push([N.index,T.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(r="";;){const T=y.exec(i);if(!T)break;!a.test(T[0])&&l.every(([N,G])=>T.index<N||T.index>=G)&&(r+=i.substring(M,T.index)+"<REDACTED: user-file-path>",M=y.lastIndex)}return M<i.length&&(r+=i.substr(M)),r}function n(i){if(!i)return i;const o=i.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of r)if(l.regex.test(o))return`<REDACTED: ${l.label}>`;return i}function s(i,o){return(0,I.cloneAndChange)(i,r=>{if(typeof r=="string"){let l=r;l=c(l,o);for(const a of o)l=l.replace(a,"");return l=n(l),l}})}e.cleanData=s}),define(Z[234],ee([0,1,188,74]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,P,w,S,E,C){const b={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,P)&&(0,t.getTelemetryLevel)(w)===3){const u=await(0,I.getServiceMachineId)(P,S,E),{sessionId:g}=await C.getTelemetryInfo();b["X-Market-User-Id"]=u,b["VSCode-SessionId"]=g}return b}e.resolveMarketplaceHeaders=k}),define(Z[235],ee([0,1,2,50,97,4,26,167,19,63,54,20,47,31,74]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(v,m,f){this._configurationService=m,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){let v=(0,g.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const f=m.usage?3:m.error?2:0;v=Math.min(v,f)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,m=v.sessionID,f=v["common.machineId"],c=v["common.firstSessionDate"],n=v["common.msftInternal"];return{sessionId:m,machineId:f,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(v,m,f,c){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(n=>{f=(0,t.mixin)(f,this._experimentProperties),f=(0,g.cleanData)(f,this._cleanupPatterns),f=(0,t.mixin)(f,n),this._appenders.forEach(s=>s.log(v,f))},n=>{console.error(n)})}publicLog(v,m,f){return this._log(v,3,m,f)}publicLog2(v,m,f){return this.publicLog(v,m,f)}publicLogError(v,m){return this._sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=we([te(1,w.IConfigurationService),te(2,C.IProductService)],h),e.TelemetryService=h;function p(){const d=(0,P.localize)(0,null,E.default.nameLong),v=E.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),c=(0,P.localize)(5,null),n=(0,P.localize)(6,null),s=(0,P.localize)(7,null),i=`
|       | ${f} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${d} ${v} ${m}

&nbsp;

${s}
${i}

&nbsp;

${o}
`}b.Registry.as(S.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[u.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(S.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[u.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,P.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,P.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${u.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[236],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===I.HIGH_CONTRAST_DARK||R===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===I.DARK||R===I.HIGH_CONTRAST_DARK}e.isDark=k}),define(Z[237],ee([0,1,119,3,2,5,47,236]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var w;(function(p){function d(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=d})(w=e.ThemeColor||(e.ThemeColor={}));function S(p){return{id:p}}e.themeColorFromId=S;var E;(function(p){function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||w.isThemeColor(o.color))}p.isThemeIcon=d;const v=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function m(o){const r=v.exec(o);if(!r)return;const[,l]=r;return{id:l}}p.fromString=m;function f(o){return{id:o}}p.fromId=f;function c(o,r){let l=o.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),r&&(l=`${l}~${r}`),{id:l}}p.modify=c;function n(o){const r=o.id.lastIndexOf("~");if(r!==-1)return o.id.substring(r+1)}p.getModifier=n;function s(o,r){return o.id===r.id&&o.color?.id===r.color?.id}p.isEqual=s;function i(o,r){return{id:o.id,color:r?S(r):void 0}}p.asThemeIcon=i,p.asClassNameArray=I.CSSIcon.asClassNameArray,p.asClassName=I.CSSIcon.asClassName,p.asCSSSelector=I.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function C(p){switch(p){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,k.toDisposable)(()=>{const v=this.themingParticipants.indexOf(d);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const u=new b;D.Registry.add(e.Extensions.ThemingContribution,u);function g(p){return u.onColorThemeChange(p)}e.registerThemingParticipant=g;class h extends k.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,v){let m=this.theme.getColor(d);return m&&v&&(m=v(m,this.theme)),m?m.toString():null}}e.Themable=h}),define(Z[65],ee([0,1,13,3,2,4,19,5,37]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const S="#FFFFFF",E="#1E1E1E",C="#000000",b="#FFFFFF",u="theme",g="themeBackground",h="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let p=class extends k.Disposable{constructor(v,m){super(),this.stateMainService=v,this.configurationService=m,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,I.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?C:b;let m=this.stateMainService.getItem(g,null);if(!m)switch(this.stateMainService.getItem(u,"vs-dark").split(" ")[0]){case"vs":m=S;break;case"hc-black":m=C;break;case"hc-light":m=b;break;default:m=E}return R.isMacintosh&&m.toUpperCase()===E&&(m="#171717"),m}saveWindowSplash(v,m){this.stateMainService.setItems([{key:u,data:m.baseTheme},{key:g,data:m.colorInfo.background},{key:h,data:m}]),typeof v=="number"&&this.updateBackgroundColor(v,m)}updateBackgroundColor(v,m){for(const f of I.BrowserWindow.getAllWindows())if(f.id===v){f.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(h)}};p=we([te(0,w.IStateMainService),te(1,D.IConfigurationService)],p),e.ThemeMainService=p}),define(Z[114],ee([0,1,3,4,5,6]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=C;function b(h,p){return p?p!==1&&h<1024:!t.isWindows&&h<1024}e.isPortPrivileged=b;class u{constructor(p,d,v){this.remoteAddress=p,this.localAddress=d,this._dispose=v,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=u;let g=class{constructor(p){this.logService=p,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],d=Array.from(this._tunnels.values());for(const v of d){const m=Array.from(v.values());for(const f of m){const c=await f.value;c&&p.push(c)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(v=>v?.dispose());p.clear()}this._tunnels.clear()}setEnvironmentTunnel(p,d,v,m,f){this.addTunnelToMap(p,d,Promise.resolve({tunnelRemoteHost:p,tunnelRemotePort:d,localAddress:v,privacy:m,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(p,d){(C(p)||E(p))&&(p=e.LOCALHOST_ADDRESSES[0]);const v=this.getTunnelFromMap(p,d);if(v)return++v.refcount,v.value}openTunnel(p,d,v,m,f=!1,c,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${v} on local port ${m}.`),!p)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(p,d,v,m,f,c,n);return s?s.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(i);return(i.tunnelRemoteHost!==d||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const v=d.get(p.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,v))}}}}async tryDisposeTunnel(p,d,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const m=v.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),m}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${d} `);const v=this._tunnels.get(p);if(v&&v.has(d)){const m=v.get(d);m.refcount=0,await this.tryDisposeTunnel(p,d,m)}}addTunnelToMap(p,d,v){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:v})}async removeEmptyTunnelFromMap(p,d){const v=this._tunnels.get(p);v&&(await v.get(d)||v.delete(d),v.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){const v=[p];E(p)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):C(p)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const m=v.map(f=>this._tunnels.get(f));for(const f of m){const c=f?.get(d);if(c)return c}}canTunnel(p){return!!S(p)}doIsPortPrivileged(p,d,v,m){if(d)return!1;if(v){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(f?.length===4){const c=parseInt(f[1]),n=parseInt(f[2]);if(c>10||c===10&&n>=14)return!1}}return p<1024}createWithProvider(p,d,v,m,f,c,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${v} on local port ${m}.`);const s=v;this._factoryInProgress.add(s);const i=m===void 0?v:m,o={elevationRequired:f?this.isPortPrivileged(i):!1},r={remoteAddress:{host:d,port:v},localAddressPort:m,privacy:c,public:c?c!==P.Private:void 0,protocol:n},l=p.forwardPort(r,o);return l?(this.addTunnelToMap(d,v,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),l}};g=we([te(0,R.ILogService)],g),e.AbstractTunnelService=g}),define(Z[238],ee([0,1,79,25,96,221,8,2,19,6,20,220,114,88,4]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function h(f,c,n,s,i){let o;for(let r=3;r&&(o?.dispose(),o=await new p(f,c,n,s,i).waitForReady(),!(i&&k.BROWSER_RESTRICTED_PORTS[i]||!k.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));r--);return o}class p extends P.Disposable{constructor(c,n,s,i,o){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=o,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=I.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){let c=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),n=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(c){c.pause();const n=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,C.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=s.getSocket().socket,o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&c.write(o.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),i.destroy()}),i.on("end",()=>c.end()),i.on("close",()=>c.end()),i.on("error",()=>{c.destroy()}),c.pipe(i),i.pipe(c),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),i.end()})}}let d=class extends b.AbstractTunnelService{constructor(c,n,s,i,o){super(n),this.socketFactory=c,this.signService=s,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(c){return this.doIsPortPrivileged(c,g.isWindows,g.isMacintosh,t.release())}retainOrCreateTunnel(c,n,s,i,o,r,l){const a=this.getTunnelFromMap(n,s);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,s,i,o,r,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${i}.`);const y={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},M=h(y,this.defaultTunnelHost,n,s,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,M),M}}};d=we([te(1,S.ILogService),te(2,u.ISignService),te(3,E.IProductService),te(4,w.IConfigurationService)],d),e.BaseTunnelService=d;let v=class extends d{constructor(c,n,s,i){super(R.nodeSocketFactory,c,n,s,i)}};v=we([te(0,S.ILogService),te(1,u.ISignService),te(2,E.IProductService),te(3,w.IConfigurationService)],v),e.TunnelService=v;let m=class extends P.Disposable{constructor(c,n,s,i){super(),this.logService=c,this.productService=n,this.signService=s,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(c,n,s,i,o,r,l,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${o}.`),!this._tunnelServices.has(c)){const y=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(y),this._tunnelServices.set(c,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(n,s,i,o,r,l,a)}};m=we([te(0,S.ILogService),te(1,E.IProductService),te(2,u.ISignService),te(3,w.IConfigurationService)],m),e.SharedTunnelsService=m}),define(Z[48],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(Z[239],ee([0,1,4,168,63,47]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[240],ee([0,1,3,48]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(P){this.service=P}listen(P,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(P,w,S){switch(w){case"checkForUpdates":return this.service.checkForUpdates(S);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(S)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=R}),define(Z[89],ee([0,1,8,23,3,19,27,22,6,20,55,48]),function(z,e,I,t,k,R,D,P,w,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(g,h,p){return`${p.updateUrl}/api/update/${g}/${h}/${p.commit}`}e.createUpdateURL=b;let u=class{get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}constructor(h,p,d,v,m,f){this.lifecycleMainService=h,this.configurationService=p,this.environmentMainService=d,this.requestService=v,this.logService=m,this.productService=f,this._state=C.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),p=this.getProductQuality(h);if(!p){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(p),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(C.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,I.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(h){}getUpdateType(){return 1}doQuitAndInstall(){}};u=we([te(0,P.ILifecycleMainService),te(1,R.IConfigurationService),te(2,D.IEnvironmentMainService),te(3,E.IRequestService),te(4,w.ILogService),te(5,S.IProductService)],u),e.AbstractUpdateService=u}),define(Z[241],ee([0,1,13,53,3,2,19,27,22,6,20,55,31,48,89]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends g.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"error",(d,v)=>v)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(d,v,m)=>({url:v,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(d,v,m,f)=>({releaseNotes:v,version:m,productVersion:m,date:f}))}constructor(d,v,m,f,c,n,s){super(d,v,f,c,n,s),this.telemetryService=m,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(d){this.logService.error("UpdateService error:",d);const m=(this.state.type==="checking for updates"?this.state.explicit:!0)?d:void 0;this.setState(u.State.Idle(1,m))}buildUpdateFeedUrl(d){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,g.createUpdateURL)(v,d,this.productService);try{I.autoUpdater.setFeedURL({url:m})}catch(f){this.logService.error("Failed to set update feed URL",f);return}return m}doCheckForUpdates(d){this.setState(u.State.CheckingForUpdates(d)),I.autoUpdater.checkForUpdates()}onUpdateAvailable(d){this.state.type==="checking for updates"&&this.setState(u.State.Downloading(d))}onUpdateDownloaded(d){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:d.version}),this.setState(u.State.Ready(d)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(u.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};we([t.memoize],h.prototype,"onRawError",null),we([t.memoize],h.prototype,"onRawUpdateNotAvailable",null),we([t.memoize],h.prototype,"onRawUpdateAvailable",null),we([t.memoize],h.prototype,"onRawUpdateDownloaded",null),h=we([te(0,w.ILifecycleMainService),te(1,D.IConfigurationService),te(2,b.ITelemetryService),te(3,P.IEnvironmentMainService),te(4,C.IRequestService),te(5,S.ILogService),te(6,E.IProductService)],h),e.DarwinUpdateService=h}),define(Z[242],ee([0,1,45,40,8,3,9,27,22,6,31,48]),function(z,e,I,t,k,R,D,P,w,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}constructor(h,p,d){if(this.lifecycleMainService=h,this.logService=d,this._state=C.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,p.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(C.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}scheduleCheckForUpdates(h=60*60*1e3){return(0,k.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(h){}};b=we([te(0,w.ILifecycleMainService),te(1,P.IEnvironmentMainService),te(2,S.ILogService)],b);let u=class extends b{constructor(h,p,d,v,m,f){super(d,v,m),this.snap=h,this.snapRevision=p,this.telemetryService=f;const c=(0,t.watch)(D.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(c,"change",(r,l)=>l),s=R.Event.filter(n,r=>r==="current"),o=R.Event.debounce(s,(r,l)=>l,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{o.dispose(),c.close()})}doCheckForUpdates(){this.setState(C.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(C.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((d,v)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(m,f)=>m?v(m):d(f))),p=D.basename(h);return this.snapRevision!==p}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=we([te(2,w.ILifecycleMainService),te(3,P.IEnvironmentMainService),te(4,S.ILogService),te(5,E.ITelemetryService)],u),e.SnapUpdateService=u}),define(Z[51],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(Z[243],ee([0,1,51,189,15,18,125,3,2]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(b){this.uri=b,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let E=class{constructor(b){this._fileService=b,this._dispooables=new w.DisposableStore,this._limit=2**16;const u=new Map,g=h=>{let p=u.get(h.scheme);return p===void 0&&(p=b.hasProvider(h)&&!this._fileService.hasCapability(h,1024),u.set(h.scheme,p)),p};this._dispooables.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(h=>{u.delete(h.scheme)})),this.extUri=new R.ExtUri(g),this._canonicalUris=new D.SkipList((h,p)=>this.extUri.compare(h,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(b){this._fileService.hasProvider(b)&&(b=(0,R.normalizePath)(b));const u=this._canonicalUris.get(b);return u?u.touch().uri.with({fragment:b.fragment}):(this._canonicalUris.set(b,new S(b)),this._checkTrim(),b)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const b=[...this._canonicalUris.entries()].sort((g,h)=>g[1].touch<h[1].touch?1:g[1].touch>h[1].touch?-1:0);S._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let g=0;g<u;g++)this._canonicalUris.set(b[g][0],b[g][1].touch())}};E=we([te(0,k.IFileService)],E),e.UriIdentityService=E,(0,t.registerSingleton)(I.IUriIdentityService,E,1)}),define(Z[115],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(Z[244],ee([0,1,7]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.handler=P}listen(P,w){throw new Error(`Event not found: ${w}`)}call(P,w,S){switch(w){case"handleURL":return this.handler.handleURL(I.URI.revive(S[0]),S[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=t;class k{constructor(P){this.channel=P}handleURL(P,w){return this.channel.call("handleURL",[P.toJSON(),w])}}e.URLHandlerChannelClient=k;class R{constructor(P){this.next=P}async routeCall(P,w,S,E){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(S){const C=I.URI.revive(S);if(C&&C.query){const b=/\bwindowId=(\d+)/.exec(C.query);if(b){const u=b[1],g=new RegExp(`window:${u}`),h=P.connections.find(p=>g.test(p.ctx));if(h)return h}}}return this.next.routeCall(P,w,S,E)}routeEvent(P,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=R}),define(Z[245],ee([0,1,8,2,7,20]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(S,E){const C=[...this.handlers.values()];return(0,I.first)(C.map(b=>()=>b.handleURL(S,E)),void 0,!1).then(b=>b||!1)}registerHandler(S){return this.handlers.add(S),(0,t.toDisposable)(()=>this.handlers.delete(S))}}e.AbstractURLService=D;let P=class extends D{constructor(S){super(),this.productService=S}create(S){let{authority:E,path:C,query:b,fragment:u}=S||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&C&&C.indexOf("/")!==0&&(C=`/${C}`),k.URI.from({scheme:this.productService.urlProtocol,authority:E,path:C,query:b,fragment:u})}};P=we([te(0,R.IProductService)],P),e.NativeURLService=P}),define(Z[246],ee([0,1,13,8,3,2,4,7]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(E){try{return P.URI.parse(E)}catch{return null}}class S{constructor(C,b,u,g,h){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=C,D.isWindows){const v=g.isBuilt?[]:[`"${g.appRoot}"`];v.push("--open-url","--"),I.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,v)}const p=k.Event.map(k.Event.fromNodeEventEmitter(I.app,"open-url",(v,m)=>({event:v,url:m})),({event:v,url:m})=>(v.preventDefault(),m));this.disposables.add(p(v=>{const m=w(v);!m||this.urlService.open(m,{originalUrl:v})})),u.getWindows().filter(v=>v.isReady).length>0?this.flush():k.Event.once(u.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const C=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||C.push(b);C.length!==0&&(this.uris=C,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=S}),define(Z[247],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(Z[248],ee([0,1,13,2,14,7]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const w=this.handleWebviewRequest.bind(this);I.protocol.registerFileProtocol(k.Schemas.vscodeWebview,w)}handleWebviewRequest(w,S){try{const E=R.URI.parse(w.url),C=D.validWebviewFilePaths.get(E.path);if(typeof C=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${C}`,u=k.FileAccess.asFileUri(b,z);return S({path:decodeURIComponent(u.fsPath),headers:{...k.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return S({error:-10})}catch{}return S({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[75],ee([0,1,4]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(E){return!!E.workspaceUri}e.isWorkspaceToOpen=t;function k(E){return!!E.folderUri}e.isFolderToOpen=k;function R(E){return!!E.fileUri}e.isFileToOpen=R;function D(E){const C=P(E),b=E.getValue("window.menuBarVisibility");return b==="default"||C==="native"&&b==="compact"||I.isMacintosh&&I.isNative?"classic":b}e.getMenuBarVisibility=D;function P(E){if(I.isWeb)return"custom";const C=E.getValue("window");if(C){if(I.isMacintosh&&C.nativeTabs===!0||I.isMacintosh&&C.nativeFullScreen===!1)return"native";const g=C.titleBarStyle;if(g==="native"||g==="custom")return g}return I.isLinux?"native":"custom"}e.getTitleBarStyle=P;function w(E){if(!I.isWindows||I.isWeb||P(E)==="native")return!1;const C=E.getValue("window.experimental.windowControlsOverlay.enabled");return typeof C=="boolean"?C:!1}e.useWindowControlsOverlay=w;function S(E=0){return Math.pow(1.2,E)}e.zoomLevelToZoomFactor=S}),define(Z[116],ee([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=k;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(Z[32],ee([0,1,5]),function(z,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[249],ee([0,1,13,23,3,67,2,29,70,106,6,20,32]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let g=class extends D.Disposable{constructor(p,d,v,m,f){super(),this.logService=p,this.windowsMainService=d,this.credentialsService=v,this.encryptionMainService=m,this.productService=f,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=u.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const p=k.Event.fromNodeEventEmitter(I.app,"login",(d,v,m,f,c)=>({event:d,webContents:v,req:m,authInfo:f,callback:c}));this._register(p(this.onLogin,this))}async onLogin({event:p,authInfo:d,req:v,callback:m}){if(!d.isProxy)return;if(!this.pendingProxyResolve&&this.state===u.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let f;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(d);try{f=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}m(f?.username,f?.password)}async resolveProxyCredentials(p){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.doResolveProxyCredentials(p);if(d)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(p){this.logService.trace("auth#doResolveProxyCredentials - enter",p);const d=String((0,R.hash)({scheme:p.scheme,host:p.host,port:p.port}));let v,m;try{const s=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d);if(s){const i=JSON.parse(await this.encryptionMainService.decrypt(s));v=i.username,m=i.password}}catch(s){this.logService.error(s)}if(this.state!==u.StoredCredentialsUsed&&typeof v=="string"&&typeof m=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=u.StoredCredentialsUsed,{username:v,password:m};const f=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!f){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const c={authInfo:p,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??m,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=u.LoginDialogShown;const n=await new Promise(s=>{const i=async(o,r,l)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",i),l){const a={username:l.username,password:l.password};try{if(l.remember){const y=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d,y)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d)}catch(y){this.logService.error(y)}s({username:a.username,password:a.password})}else s(void 0)};f.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};g=we([te(0,E.ILogService),te(1,b.IWindowsMainService),te(2,w.ICredentialsMainService),te(3,S.IEncryptionMainService),te(4,C.IProductService)],g),e.ProxyAuthHandler=g}),define(Z[250],ee([0,1,70,6,35,20,32,201]),function(z,e,I,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let w=class extends P.BaseCredentialsMainService{constructor(E,C,b,u){super(E),this.environmentMainService=C,this.productService=b,this.windowsMainService=u,this.surfaceKeytarLoadError=g=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",g.message??g)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new I.InMemoryCredentialsProvider,this._keytarCache;const E=await new Promise((C,b)=>{z(["keytar"],C,b)});return await E.findCredentials("test-keytar-loads"),this._keytarCache=E,this._keytarCache}};w=we([te(0,t.ILogService),te(1,k.INativeEnvironmentService),te(2,R.IProductService),te(3,D.IWindowsMainService)],w),e.CredentialsNativeMainService=w}),define(Z[251],ee([0,1,16,2,3,6,22,81,45,281,8,14,50,4,33,13,32]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const d=h.UtilityProcess,v=typeof d<"u";let m=class Ut{constructor(s,i,o){this._logService=s,this._windowsMainService=o,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(r=>{this._shutdown=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(s){const i=this._extHosts.get(s);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(s){return this._getExtHost(s).onStdout}onDynamicStderr(s){return this._getExtHost(s).onStderr}onDynamicMessage(s){return this._getExtHost(s).onMessage}onDynamicError(s){return this._getExtHost(s).onError}onDynamicExit(s){return this._getExtHost(s).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(s){if(this._shutdown)throw(0,I.canceled)();const i=String(++Ut._lastId);let o;if(s){if(!v)throw new Error("Cannot use UtilityProcess!");o=new c(i,this._logService,this._windowsMainService)}else o=new f(i,this._logService);return this._extHosts.set(i,o),o.onExit(({pid:r,code:l,signal:a})=>{this._logService.info(`Extension host with pid ${r} exited with code: ${l}, signal: ${a}.`),setTimeout(()=>{o.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(s,i){if(this._shutdown)throw(0,I.canceled)();return this._getExtHost(s).start(i)}async enableInspectPort(s){if(this._shutdown)throw(0,I.canceled)();const i=this._extHosts.get(s);return i?i.enableInspectPort():!1}async kill(s){if(this._shutdown)throw(0,I.canceled)();const i=this._extHosts.get(s);!i||i.kill()}async _killAllNow(){for(const[,s]of this._extHosts)s.kill()}async _waitForAllExit(s){const i=[];for(const[,o]of this._extHosts)i.push(o.waitForExit(s));return E.Promises.settled(i).then(()=>{})}};m._lastId=0,m=we([te(0,R.ILogService),te(1,D.ILifecycleMainService),te(2,p.IWindowsMainService)],m),e.ExtensionHostStarter=m;let f=class extends t.Disposable{constructor(s,i){super(),this.id=s,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(s){u.isCI&&this._logService.info("Calling fork to start extension host...");const i=P.StopWatch.create(!1);this._process=(0,w.fork)(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,g.cwd)()},s));const o=i.elapsed(),r=this._process.pid;this._logService.info(`Starting extension host with pid ${r} (fork() took ${o} ms).`);const l=new S.StringDecoder("utf-8");this._process.stdout?.on("data",y=>{const M=typeof y=="string"?y:l.write(y);this._onStdout.fire(M)});const a=new S.StringDecoder("utf-8");this._process.stderr?.on("data",y=>{const M=typeof y=="string"?y:a.write(y);this._onStderr.fire(M)}),this._process.on("message",y=>{this._onMessage.fire(y)}),this._process.on("error",y=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(y)})}),this._process.on("exit",(y,M)=>{this._hasExited=!0,this._onExit.fire({pid:r,code:y,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):u.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(s){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,E.timeout)(s)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${s}ms.`),this._process.kill())}};f=we([te(1,R.ILogService)],f);let c=class extends t.Disposable{constructor(s,i,o){super(),this.id=s,this._logService=i,this._windowsMainService=o,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(s){const i=this._windowsMainService.getWindowById(s.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=i.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=`extensionHost${this.id}`,l=C.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,a=["--type=extensionHost","--skipWorkspaceStorageLock"],y=s.execArgv||[],M={...s.env},T=!0;for(const ie of Object.keys(M))M[ie]=String(M[ie]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new d(l,a,{serviceName:r,env:M,execArgv:y,allowLoadingUnsignedLibraries:T});const N=new S.StringDecoder("utf-8");this._process.stdout?.on("data",ie=>{const oe=typeof ie=="string"?ie:N.write(ie);this._onStdout.fire(oe)});const G=new S.StringDecoder("utf-8");this._process.stderr?.on("data",ie=>{const oe=typeof ie=="string"?ie:G.write(ie);this._onStderr.fire(oe)}),this._process.on("message",ie=>{this._onMessage.fire(ie)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const ae=k.Event.fromNodeEventEmitter(this._process,"exit",(ie,oe)=>oe);this._register(ae(ie=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${ie}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:ie,signal:""})}));const{port1:X,port2:Q}=new h.MessageChannelMain;this._process.postMessage("null",[Q]),o.webContents.postMessage(s.responseChannel,s.responseNonce,[X])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(s){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,E.timeout)(s)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${s}ms, will kill it now.`),this._process.kill())}};c=we([te(1,R.ILogService),te(2,p.IWindowsMainService)],c)}),define(Z[252],ee([0,1,13,3,2,248,32]),function(z,e,I,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends k.Disposable{constructor(S){super(),this.windowsMainService=S,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(S,E){let C;if(typeof S.windowId=="number"){const{windowId:b}=S,u=this.windowsMainService.getWindowById(b);if(!u?.win)throw new Error(`Invalid windowId: ${b}`);C=u.win.webContents}else{const{webContentsId:b}=S;if(C=I.webContents.fromId(b),!C)throw new Error(`Invalid webContentsId: ${b}`)}C.isDestroyed()||C.setIgnoreMenuShortcuts(E)}async findInFrame(S,E,C,b){const g=this.getFrameByName(S,E);if(typeof g.findInFrame=="function"){g.findInFrame(C,{findNext:b.findNext,forward:b.forward});const h=(p,d)=>{d.finalUpdate&&(this._onFoundInFrame.fire(d),g.removeListener("found-in-frame",h))};g.on("found-in-frame",h)}}async stopFindInFrame(S,E,C){const u=this.getFrameByName(S,E);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(C.keepSelection?"keepSelection":"clearSelection")}getFrameByName(S,E){const C=this.windowsMainService.getWindowById(S.windowId);if(!C?.win)throw new Error(`Invalid windowId: ${S}`);const b=C.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===E);if(!b)throw new Error(`Unknown frame: ${E}`);return b}};P=we([te(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(Z[253],ee([0,1,8,3,2]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:w,getActiveWindowId:S}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(P,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,I.createCancelablePromise)(()=>S()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[28],ee([0,1,172,9,59,18,7,5,14]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function S(s){const i=s;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function E(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,t.basename)(s)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=s;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=E;function C(s){const i=s;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=C;function b(s){const i=s;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=b;var u;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(u=e.WorkbenchState||(e.WorkbenchState={}));function g(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=g;function h(s){const i=s;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class p{constructor(i,o,r,l,a){this._id=i,this._transient=r,this._configuration=l,this._ignorePathCasing=a,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class d{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function v(s){return new d({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(s,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function f(s){let i;return D.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=f;function c(s,i){return!m(s,i)&&!f(s)}e.isSavedWorkspace=c;function n(s){return(typeof s=="string"?(0,t.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(Z[56],ee([0,1,13,8,67,34,2,77,4,12,21,149,5,6,28]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let h=class{constructor(d){this.logService=d,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(d,v){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,C.localize)(0,null)},v)}pickFolder(d,v){return this.doPick({...d,pickFolders:!0,title:(0,C.localize)(1,null)},v)}pickFile(d,v){return this.doPick({...d,pickFiles:!0,title:(0,C.localize)(2,null)},v)}pickWorkspace(d,v){const m=(0,C.localize)(3,null),f=(0,R.mnemonicButtonLabel)((0,C.localize)(4,null)),c=g.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:m,filters:c,buttonLabel:f},v)}async doPick(d,v){const m={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(m.properties=void 0,d.pickFiles&&d.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&m.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(m,(0,S.withNullAsUndefined)(v||I.BrowserWindow.getFocusedWindow()));if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}getWindowDialogQueue(d){if(d){let v=this.windowDialogQueues.get(d.id);return v||(v=new t.Queue,this.windowDialogQueues.set(d.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(d,v){return this.getWindowDialogQueue(v).queue(async()=>v?I.dialog.showMessageBox(v,d):I.dialog.showMessageBox(d))}async showSaveDialog(d,v){const m=this.acquireFileDialogLock(d,v);if(!m)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let f;return v?f=await I.dialog.showSaveDialog(v,d):f=await I.dialog.showSaveDialog(d),f.filePath=this.normalizePath(f.filePath),f})}finally{(0,D.dispose)(m)}}normalizePath(d){return d&&w.isMacintosh&&(d=(0,P.normalizeNFC)(d)),d}normalizePaths(d){return d.map(v=>this.normalizePath(v))}async showOpenDialog(d,v){d.defaultPath&&(await E.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const m=this.acquireFileDialogLock(d,v);if(!m)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let f;return v?f=await I.dialog.showOpenDialog(v,d):f=await I.dialog.showOpenDialog(d),f.filePaths=this.normalizePaths(f.filePaths),f})}finally{(0,D.dispose)(m)}}acquireFileDialogLock(d,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let m=this.windowFileDialogLocks.get(v.id);m||(m=new Set,this.windowFileDialogLocks.set(v.id,m));const f=(0,k.hash)(d);if(!m.has(f))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),m.add(f),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),m?.delete(f),m?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};h=we([te(0,u.ILogService)],h),e.DialogMainService=h}),define(Z[254],ee([0,1,3,2,68,28]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(w,S){super(),this.logService=w,this.storageMainService=S,this.onDidChangeApplicationStorageEmitter=this._register(new I.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(S.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(w,S){this._register(I.Event.debounce(w.onDidChangeStorage,(E,C)=>(E?E.push(C):E=[C],E),D.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&S.fire(this.serializeStorageChangeEvents(E,w))}))}serializeStorageChangeEvents(w,S){const E=new Map,C=new Set;return w.forEach(b=>{const u=S.get(b.key);typeof u=="string"?E.set(b.key,u):C.add(b.key)}),{changed:Array.from(E.entries()),deleted:Array.from(C.values())}}listen(w,S,E){switch(S){case"onDidChangeStorage":{const C=E.profile?(0,k.revive)(E.profile):void 0;if(!C)return this.onDidChangeApplicationStorageEmitter.event;let b=this.mapProfileToOnDidChangeProfileStorageEmitter.get(C.id);return b||(b=this._register(new I.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(C),b),this.mapProfileToOnDidChangeProfileStorageEmitter.set(C.id,b)),b.event}}throw new Error(`Event not found: ${S}`)}async call(w,S,E){const C=E.profile?(0,k.revive)(E.profile):void 0,b=(0,R.reviveIdentifier)(E.workspace),u=await this.withStorageInitialized(C,b);switch(S){case"getItems":return Array.from(u.items.entries());case"updateItems":{const g=E;if(g.insert)for(const[h,p]of g.insert)u.set(h,p);g.delete?.forEach(h=>u.delete(h));break}case"isUsed":{const g=E.payload;if(typeof g=="string")return this.storageMainService.isUsed(g)}default:throw new Error(`Call not found: ${S}`)}}async withStorageInitialized(w,S){let E;S?E=this.storageMainService.workspaceStorage(S):w?E=this.storageMainService.profileStorage(w):E=this.storageMainService.applicationStorage;try{await E.init()}catch(C){this.logService.error(`StorageIPC#init: Unable to init ${S?"workspace":w?"profile":"application"} storage due to ${C}`)}return E}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[38],ee([0,1,67,3,2,18,12,7,169,35,15,5,6,28,39,51,8,29,26]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&P.URI.isUri(o.location)&&P.URI.isUri(o.globalStorageHome)&&P.URI.isUri(o.settingsResource)&&P.URI.isUri(o.keybindingsResource)&&P.URI.isUri(o.tasksResource)&&P.URI.isUri(o.snippetsHome)&&((0,D.isUndefined)(o.extensionsResource)||P.URI.isUri(o.extensionsResource)))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function f(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:P.URI.revive(i.location).with({scheme:o}),globalStorageHome:P.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:P.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:P.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:P.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:P.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:P.URI.revive(i.extensionsResource)?.with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(i,o,r,l){return{id:i,name:o,location:r,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=c;let n=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(o,r,l,a){super(),this.environmentService=o,this.fileService=r,this.uriIdentityService=l,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(o){this.enabled!==o&&(this._profilesObject=void 0,this.enabled=o)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const o=this.enabled?this.getStoredProfiles().map(y=>c((0,R.basename)(y.location),y.name,y.location,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags})):[];let r;const l=new g.ResourceMap,a=c((0,I.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,w.localize)(0,null),this.environmentService.userRoamingDataHome);if(o.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||o.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),o.length){const y=this.getStoredProfileAssociations();if(y.workspaces)for(const[M,T]of Object.entries(y.workspaces)){const N=P.URI.parse(M),G=P.URI.parse(T),ae=o.find(X=>this.uriIdentityService.extUri.isEqual(X.location,G));ae&&l.set(N,ae)}if(y.emptyWindow){const M=P.URI.parse(y.emptyWindow);r=o.find(T=>this.uriIdentityService.extUri.isEqual(T.location,M))}}this._profilesObject={profiles:o,workspaces:l,emptyWindow:r}}return this._profilesObject}async createTransientProfile(o){const r="Temp",l=new RegExp(`${(0,v.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const M of this.profiles){const T=l.exec(M.name),N=T?parseInt(T[1]):0;a=N>a?N:a}const y=`${r} ${a+1}`;return this.createProfile((0,I.hash)((0,d.generateUuid)()).toString(16),y,{transient:!0},o)}async createNamedProfile(o,r,l){return this.createProfile((0,I.hash)((0,d.generateUuid)()).toString(16),o,r,l)}async createProfile(o,r,l,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const y=await this.doCreateProfile(o,r,l);return a&&await this.setProfileForWorkspace(a,y),y}async doCreateProfile(o,r,l){let a=this.profileCreationPromises.get(r);return a||(a=(async()=>{try{const y=this.profiles.find(N=>N.name===r||N.id===o);if(y)return y;const M=c(o,r,(0,R.joinPath)(this.profilesHome,o),l);await this.fileService.createFolder(M.location);const T=[];return this._onWillCreateProfile.fire({profile:M,join(N){T.push(N)}}),await p.Promises.settled(T),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,a)),a}async updateProfile(o,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(a=>a.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);return l=c(l.id,r.name??l.name,l.location,{shortName:r.shortName??l.shortName,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags}),this.updateProfiles([],[],[l]),l}async removeProfile(o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===o.id);if(!r)throw new Error(`Profile '${o.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:r,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.logService.error(a)}r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(o,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let l=this.getProfileForWorkspace(o);return l||(l=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(o,l)),l}async setProfileForWorkspace(o,r){this.setProfileForWorkspaceSync(o,r)}setProfileForWorkspaceSync(o,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(a=>a.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(o,l)}unsetWorkspace(o,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(o,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const o=await this.fileService.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const o=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(o.map(r=>this.removeProfile(r)))}getProfileForWorkspace(o){const r=this.getWorkspace(o);return P.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(o){return(0,u.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,u.isWorkspaceIdentifier)(o)?o.configPath:"empty-window"}isProfileAssociatedToWorkspace(o){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,o.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,o.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,o.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,o.location)))}updateProfiles(o,r,l){const a=[...this.profiles,...o],y=[];this.transientProfilesObject.profiles=[];for(let M of a)M.isDefault||r.some(T=>M.id===T.id)||(M=l.find(T=>M.id===T.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):y.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(y),this._profilesObject=void 0,this.triggerProfilesChanges(o,r,l)}triggerProfilesChanges(o,r,l){this._onDidChangeProfiles.fire({added:o,removed:r,updated:l,all:this.profiles})}updateWorkspaceAssociation(o,r,l){l=r?.isTransient?!0:l,l||this.updateWorkspaceAssociation(o,void 0,!0);const a=this.getWorkspace(o),y=l?this.transientProfilesObject:this.profilesObject;P.URI.isUri(a)?(y.workspaces.delete(a),r&&y.workspaces.set(a,r)):y.emptyWindow=r,l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const o={};for(const[l,a]of this.profilesObject.workspaces.entries())o[l.toString()]=a.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:o,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(o){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(o){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=we([te(0,S.IEnvironmentService),te(1,E.IFileService),te(2,h.IUriIdentityService),te(3,b.ILogService)],n),e.UserDataProfilesService=n;class s extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(o){this.storedProfiles=o}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(o){this.storedProfileAssociations=o}}e.InMemoryUserDataProfilesService=s}),define(Z[90],ee([0,1,24,8,50,17,16,43,135,2,14,9,4,18,187,98,12,7,154,35,111,110,186,15,5,6,20,3,68,73,38,51,185]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s,i,o,r,l,a,y,M,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var G;(function(V){function q(F,A){if(F===A)return!0;const W=Object.keys(F),U=new Set;for(const J of Object.keys(A))U.add(J);if(W.length!==U.size)return!1;for(const J of W){if(F[J]!==A[J])return!1;U.delete(J)}return U.size===0}V.equals=q})(G=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ae=class extends S.Disposable{constructor(q,F,A,W,U,J,B,$,L,O,_){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=U,this.extensionsProfileScannerService=J,this.fileService=B,this.logService=$,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,(0,u.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,(0,u.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(Q,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(q,F,A){const[W,U]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(F)]),J=A?await this.scanExtensionsUnderDevelopment(q,[...W,...U]):[];return this.dedupExtensions(W,U,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const F=[];F.push(this.scanDefaultSystemExtensions(!!q.useCache,q.language)),F.push(this.scanDevSystemExtensions(q.language,!!q.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,q,!1)}async scanUserExtensions(q){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(q.profileLocation??this.userExtensionsLocation,!!q.profileLocation,1,!q.includeUninstalled,q.language);let W=await(q.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return W=await this.applyScanOptions(W,1,q,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment(q,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===E.Schemas.file).map(async W=>{const U=await this.createExtensionScannerInput(W,!1,1,!0,q.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(B=>(B.type=F.find($=>(0,f.areSameExtensions)($.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,U)))}))).flat();return this.applyScanOptions(A,"development",q,!0)}return[]}async scanExistingExtension(q,F,A){const W=await this.createExtensionScannerInput(q,!1,F,!0,A.language),U=await this.extensionsScanner.scanExtension(W);return!U||!A.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(q,F,A){const W=await this.createExtensionScannerInput(q,!1,F,!0,A.language),U=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(U,F,A,!0)}async scanMetadata(q){const F=(0,u.joinPath)(q,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(q,F){const A=(0,u.joinPath)(q,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),U=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,U.__metadata={...U.__metadata,...F},await this.fileService.writeFile((0,u.joinPath)(q,"package.json"),R.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async applyScanOptions(q,F,A,W){return A.includeAllVersions||(q=this.dedupExtensions(F===0?q:void 0,F===1?q:void 0,F==="development"?q:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||(q=q.filter(U=>U.isValid)),q.sort((U,J)=>{const B=C.basename(U.location.fsPath),$=C.basename(J.location.fsPath);return B<$?-1:B>$?1:0})}dedupExtensions(q,F,A,W,U){const J=($,L,O)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(U&&g.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(g.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},B=new Map;return q?.forEach($=>{const L=c.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!1))&&B.set(L,$)}),F?.forEach($=>{const L=c.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);if(!O&&q&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!O||J(O,$,!1))&&B.set(L,$)}),A?.forEach($=>{const L=c.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!0))&&B.set(L,$),B.set(L,$)}),[...B.values()]}async scanDefaultSystemExtensions(q,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),U=await(q&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(q,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},U=[],J=d.URI.file(C.normalize(C.join(E.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of A){const L=W[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":U.push((0,u.joinPath)(J,$.name));break;default:U.push(d.URI.file(L));break}}const B=await Promise.all(U.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,q))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,I.coalesce)(B)}async getBuiltInExtensionControl(){try{const q=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(q.value.toString())}catch{return{}}}async createExtensionScannerInput(q,F,A,W,U,J=!0){const B=await this.getTranslations(U??b.language),$=await this.getMtime(q),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new X(q,$,L,O,F,A,W,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,U,B)}async getMtime(q){try{const F=await this.fileService.stat(q);if(typeof F.mtime=="number")return F.mtime}catch{}}};ae=we([te(4,M.IUserDataProfilesService),te(5,y.IExtensionsProfileScannerService),te(6,s.IFileService),te(7,o.ILogService),te(8,m.IEnvironmentService),te(9,r.IProductService),te(10,i.IInstantiationService)],ae),e.AbstractExtensionsScannerService=ae;class X{constructor(q,F,A,W,U,J,B,$,L,O,_,H,Y,se){this.location=q,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=U,this.type=J,this.excludeObsolete=B,this.validate=$,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=H,this.language=Y,this.translations=se}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,F){return(0,u.isEqual)(q.location,F.location)&&q.mtime===F.mtime&&(0,u.isEqual)(q.applicationExtensionslocation,F.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&q.profile===F.profile&&q.type===F.type&&q.excludeObsolete===F.excludeObsolete&&q.validate===F.validate&&q.productVersion===F.productVersion&&q.productDate===F.productDate&&q.productCommit===F.productCommit&&q.devMode===F.devMode&&q.language===F.language&&G.equals(q.translations,F.translations)}}let Q=class extends S.Disposable{constructor(q,F,A,W,U){super(),this.obsoleteFile=q,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=U}async scanExtensions(q){const F=q.profile?await this.scanExtensionsFromProfile(q):await this.scanExtensionsFromLocation(q);let A={};if(q.excludeObsolete&&q.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,p.isEmptyObject)(A)?F:F.filter(W=>!A[f.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(q){const F=await this.fileService.resolve(q.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||q.type===1&&(0,u.basename)(W.resource).indexOf(".")===0)return null;const U=new X(W.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(U)}));return(0,I.coalesce)(A).sort((W,U)=>W.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(q){let F=await this.scanExtensionsFromProfileResource(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(q.location,q.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(q.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,q);F.push(...A)}return F}async scanExtensionsFromProfileResource(q,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions(q);if(!W.length)return[];const U=await Promise.all(W.map(async J=>{if(F(J)){const B=new X(J.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,J.metadata)}return null}));return(0,I.coalesce)(U)}async scanOneOrMultipleExtensions(q){try{if(await this.fileService.exists((0,u.joinPath)(q.location,"package.json"))){const F=await this.scanExtension(q);return F?[F]:[]}else return await this.scanExtensions(q)}catch(F){return this.logService.error(`Error scanning extensions at ${q.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(q,F){try{let A=await this.scanExtensionManifest(q.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,f.getGalleryExtensionId)(A.publisher,A.name),U=F?.id?{id:W,uuid:F.id}:{id:W},J=F?.isSystem?0:q.type,B=J===0||!!F?.isBuiltin;A=await this.translateManifest(q.location,A,X.createNlsConfiguration(q));const $={type:J,identifier:U,manifest:A,location:q.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return q.validate?this.validate($,q):$}}catch(A){q.type!==0&&this.logService.error(A)}return null}validate(q,F){let A=!0;const W=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,q.manifest,q.isBuiltin);for(const[U,J]of W)U===h.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,J)));return q.isValid=A,q.validations=W,q}async scanExtensionManifest(q){const F=(0,u.joinPath)(q,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(U){return(0,s.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(q,(0,v.localize)(0,null,F.path,U.message))),null}let W;try{W=JSON.parse(A)}catch{const J=[];(0,P.parse)(A,J);for(const B of J)this.logService.error(this.formatMessage(q,(0,v.localize)(1,null,F.path,B.offset,B.length,(0,w.getParseErrorMessage)(B.error))));return null}return(0,P.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(q,(0,v.localize)(2,null,F.path))),null):W}async translateManifest(q,F,A){const W=await this.getLocalizedMessages(q,F,A);if(W)try{const U=[],J=await this.resolveOriginalMessageBundle(W.default,U);if(U.length>0)return U.forEach($=>{this.logService.error(this.formatMessage(q,(0,v.localize)(3,null,W.default?.path,(0,w.getParseErrorMessage)($.error))))}),F;if((0,P.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(q,(0,v.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,N.localizeManifest)(F,B,J)}catch{}return F}async getLocalizedMessages(q,F,A){const W=(0,u.joinPath)(q,"package.nls.json"),U=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(q,(0,v.localize)(5,null,L?.path,(0,w.getParseErrorMessage)(_.error))))})},J=L=>{this.logService.error(this.formatMessage(q,(0,v.localize)(6,null,L?.path)))},B=`${F.publisher}.${F.name}`,$=A.translations[B];if($)try{const L=d.URI.file($),O=(await this.fileService.readFile(L)).value.toString(),_=[],H=(0,P.parse)(O,_);return _.length>0?(U(L,_),{values:void 0,default:W}):(0,P.getNodeType)(H)!=="object"?(J(L),{values:void 0,default:W}):{values:H.contents?H.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles(q,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),H=[],Y=(0,P.parse)(_,H);return H.length>0?(U(O.localized,H),{values:void 0,default:O.original}):(0,P.getNodeType)(Y)!=="object"?(J(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(q,F){if(q)try{const A=(await this.fileService.readFile(q)).value.toString();return(0,P.parse)(A,F)}catch{}}findMessageBundles(q,F){return new Promise((A,W)=>{const U=J=>{const B=(0,u.joinPath)(q,`package.nls.${J}.json`);this.fileService.exists(B).then($=>{$&&A({localized:B,original:(0,u.joinPath)(q,"package.nls.json")});const L=J.lastIndexOf("-");L===-1?A({localized:(0,u.joinPath)(q,"package.nls.json"),original:null}):(J=J.substring(0,L),U(J))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,u.joinPath)(q,"package.nls.json"),original:null});U(F.language)})}formatMessage(q,F){return`[${q.path}]: ${F}`}};Q=we([te(1,y.IExtensionsProfileScannerService),te(2,T.IUriIdentityService),te(3,s.IFileService),te(4,o.ILogService)],Q);let ie=class extends Q{constructor(q,F,A,W,U,J){super(F,A,W,U,J),this.cacheFile=q,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(q){const F=await this.readExtensionCache();if(this.input=q,F&&F.input&&X.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=d.URI.revive(W.location),W));const A=await super.scanExtensions(q);return await this.writeExtensionCache({input:q,result:A}),A}async readExtensionCache(){try{const q=await this.fileService.readFile(this.cacheFile),F=JSON.parse(q.value.toString());return{result:F.result,input:(0,a.revive)(F.input)}}catch(q){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(q))}return null}async writeExtensionCache(q){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(q)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const q=await this.readExtensionCache();if(!q)return;const F=q.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ie=we([te(2,y.IExtensionsProfileScannerService),te(3,T.IUriIdentityService),te(4,s.IFileService),te(5,o.ILogService)],ie);function oe(V,q){const F=(0,f.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:F,identifier:new c.ExtensionIdentifier(F),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:q,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=oe;class he extends ae{constructor(q,F,A,W,U,J,B,$,L,O,_){super(q,F,(0,u.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(W,c.MANIFEST_CACHE_FOLDER),U,J,B,$,L,O,_),this.translationsPromise=(async()=>{if(b.translationsConfigFile)try{const H=await this.fileService.readFile(d.URI.file(b.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}getTranslations(q){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(Z[255],ee([0,1,7,35,73,90,15,5,6,20,38]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends R.NativeExtensionsScannerService{constructor(u,g,h,p,d,v,m){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,I.URI.file(d.userDataPath),u,g,h,p,d,v,m)}};C=we([te(0,E.IUserDataProfilesService),te(1,k.IExtensionsProfileScannerService),te(2,D.IFileService),te(3,w.ILogService),te(4,t.INativeEnvironmentService),te(5,S.IProductService),te(6,P.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(Z[256],ee([0,1,13,2,14,9,4,59,7,29,41,35,6,38]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let g=class extends t.Disposable{constructor(p,d,v){super(),this.environmentService=p,this.logService=v,this.validRoots=P.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(p.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:p}=I.session;p.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(d,v)=>this.handleResourceRequest(d,v)),p.protocol.interceptFileProtocol(k.Schemas.file,(d,v)=>this.handleFileRequest(d,v)),this._register((0,t.toDisposable)(()=>{p.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(p){const d=(0,R.normalize)(p);return this.validRoots.get(d)?t.Disposable.None:(this.validRoots.set(d,!0),(0,t.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(p,d){const v=w.URI.parse(p.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${k.Schemas.file}: protocol (original URL: ${p.url})`),d({error:-3})}handleResourceRequest(p,d){const v=this.requestToNormalizedFilePath(p);let m;return this.environmentService.crossOriginIsolated&&((0,R.basename)(v)==="workbench.html"||(0,R.basename)(v)==="workbench-dev.html"?m=k.COI.CoopAndCoep:m=k.COI.getHeadersFromQuery(p.url)),this.validRoots.findSubstr(v)?d({path:v,headers:m}):this.validExtensions.has((0,R.extname)(v).toLowerCase())?d({path:v}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),d({error:-3}))}requestToNormalizedFilePath(p){const d=w.URI.parse(p.url),v=k.FileAccess.asFileUri(d);return(0,R.normalize)(v.fsPath)}createIPCObjectUrl(){let p;const d=w.URI.from({scheme:"vscode",path:(0,S.generateUuid)()}),v=d.toString(),m=async()=>p;return E.validatedIpcMain.handle(v,m),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:d,update:f=>p=f,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),E.validatedIpcMain.removeHandler(v)}}}};g=we([te(0,C.INativeEnvironmentService),te(1,u.IUserDataProfilesService),te(2,b.ILogService)],g),e.ProtocolMainService=g}),define(Z[257],ee([0,1,13,41,8,3,2,14,12,103,27,22,6,54,62,65,44,38,36]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(c,n,s,i,o,r,l,a,y){super(),this.machineId=c,this.userEnv=n,this.environmentMainService=s,this.userDataProfilesService=i,this.lifecycleMainService=o,this.logService=r,this.policyService=l,this.themeMainService=a,this.protocolMainService=y,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,n)=>this.onWindowConnection(c,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,n)=>this.onWorkerConnection(c,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const s=await this.connect();if(c.sender.isDestroyed())return s.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[s])}onWorkerConnection(c,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const s=new D.DisposableStore,i=r=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${r}')`,n),s.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},o=I.BrowserWindow.fromId(n.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}s.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,r=>r.window.win===o)(()=>i("load"))),s.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>i("closed"))),o.webContents.postMessage(n.reply.channel,n.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...n)}catch(s){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,p.toErrorMessage)(s)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new I.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:u.default,policiesData:this.policyService.serialize()}),this.window.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,n,s)=>this._onDidError.fire({type:3,details:{reason:s,exitCode:n}})))}async connect(){await this.whenIpcReady;const c=(0,w.assertIsDefined)(this.window);return(0,S.connect)(c)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};m=we([te(2,E.IEnvironmentMainService),te(3,d.IUserDataProfilesService),te(4,C.ILifecycleMainService),te(5,b.ILogService),te(6,v.IPolicyService),te(7,h.IThemeMainService),te(8,g.IProtocolMainService)],m),e.SharedProcess=m}),define(Z[91],ee([0,1,8,3,2,72,12,104,5,38]),function(z,e,I,t,k,R,D,P,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var E;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var b;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function u(v){const m=v.get(e.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.loadKeyTargets=u;class g extends k.Disposable{constructor(m={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,f){if(f===e.TARGET_KEY){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:f,target:this.getKeyTargets(m)[f]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,f,c){return this.getStorage(f)?.get(m,c)}getBoolean(m,f,c){return this.getStorage(f)?.getBoolean(m,c)}getNumber(m,f,c){return this.getStorage(f)?.getNumber(m,c)}store(m,f,c,n){if((0,D.isUndefinedOrNull)(f)){this.remove(m,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,c,n),this.getStorage(c)?.set(m,f)})}remove(m,f){this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,void 0),this.getStorage(f)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,f){const c=[],n=this.getKeyTargets(m);for(const s of Object.keys(n))n[s]===f&&c.push(s);return c}updateKeyTarget(m,f,c){const n=this.getKeyTargets(f);typeof c=="number"?n[m]!==c&&(n[m]=c,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[m]=="number"&&(delete n[m],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const f=this.getStorage(m);return f?u(f):Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=E.NONE){this._onWillSaveState.fire({reason:m});const f=this.getStorage(-1),c=this.getStorage(0),n=this.getStorage(1);switch(m){case E.NONE:await I.Promises.settled([f?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await I.Promises.settled([f?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return d(m,f,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(m,f){return this.emitWillSaveState(E.NONE),(0,S.isUserDataProfile)(m)?this.switchToProfile(m,f):this.switchToWorkspace(m,f)}canSwitchProfile(m,f){return!(m.id===f.id||h(f)&&h(m))}switchData(m,f,c,n){this.withPausedEmitters(()=>{if(n)for(const[s,i]of m)f.set(s,i);else{const s=new Set;for(const[i,o]of m)s.add(i),f.get(i)!==o&&this.emitDidChangeValue(c,i);for(const[i]of f.items)s.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;function h(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=h;class p extends g{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(m){return!1}}e.InMemoryStorageService=p;async function d(v,m,f,c,n,s){const i=G=>{try{return JSON.parse(G)}catch{return G}},o=new Map,r=new Map;v.forEach((G,ae)=>{o.set(ae,G),r.set(ae,i(G))});const l=new Map,a=new Map;m.forEach((G,ae)=>{l.set(ae,G),a.set(ae,i(G))});const y=new Map,M=new Map;f.forEach((G,ae)=>{y.set(ae,G),M.set(ae,i(G))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(o.forEach((G,ae)=>{T.push({key:ae,value:G})}),console.table(T),console.groupEnd(),console.log(r),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const G=[];l.forEach((ae,X)=>{G.push({key:X,value:ae})}),console.table(G),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const N=[];y.forEach((G,ae)=>{N.push({key:ae,value:G})}),console.table(N),console.groupEnd(),console.log(M)}e.logStorage=d}),define(Z[258],ee([0,1,24,8,3,2,9,81,7,21,104,146,6,91,31,28]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class p extends R.Disposable{get storage(){return this._storage}constructor(s,i){super(),this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=E.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===E.StorageState.None)try{const s=await this.doCreate();this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(o=>this._onDidChangeStorage.fire({key:o}))),await this.doInit(s);const i=s.getBoolean(u.IS_NEW_KEY);i===void 0?s.set(u.IS_NEW_KEY,!0):i&&s.set(u.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=E.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}async close(){const s=new P.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>p.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(!!this.path)try{const i=(0,I.top)(Array.from(this._storage.items.entries()).map(([r,l])=>({key:r,length:l.length})),(r,l)=>l.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),o=(await this.fileService.stat(w.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=E.StorageState.Closed,await this._storage.close()}}p.LOG_SLOW_CLOSE_THRESHOLD=2e3;class d extends p{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,d.STORAGE_NAME)}constructor(s,i,o,r){super(o,r),this.profile=s,this.options=i}async doCreate(){return new E.Storage(new C.SQLiteStorageDatabase(this.path??C.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}d.STORAGE_NAME="state.vscdb";class v extends d{constructor(s,i,o,r){super(s,i,o,r)}}e.ProfileStorageMain=v;class m extends d{constructor(s,i,o,r){super(i.defaultProfile,s,o,r)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(g.firstSessionDateStorageKey,void 0)===void 0&&s.set(g.firstSessionDateStorageKey,new Date().toUTCString());const o=s.get(g.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();s.set(g.lastSessionDateStorageKey,typeof o>"u"?null:o),s.set(g.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=m;class f extends p{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,f.WORKSPACE_STORAGE_NAME)}constructor(s,i,o,r,l){super(o,l),this.workspace=s,this.options=i,this.environmentService=r}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new C.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:i?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:C.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(s,f.WORKSPACE_STORAGE_NAME);return await S.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await S.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,h.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,h.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const o=(0,D.join)(s,f.WORKSPACE_META_NAME);await S.Promises.exists(o)||await S.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json";class c extends p{get path(){}async doCreate(){return new E.Storage(new E.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(Z[259],ee([0,1,68,35,15,6,228,51,38]),function(z,e,I,t,k,R,D,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let S=class At extends w.UserDataProfilesService{constructor(C,b,u,g,h){super(u,g,b,h),this.stateService=C}getStoredProfiles(){return(0,I.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,I.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};S=we([te(0,D.IStateService),te(1,P.IUriIdentityService),te(2,t.IEnvironmentService),te(3,k.IFileService),te(4,R.ILogService)],S),e.UserDataProfilesService=S}),define(Z[42],ee([0,1,7,35,15,5,6,37,51,38,259]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(S.IUserDataProfilesService);let C=class ht extends E.UserDataProfilesService{constructor(u,g,h,p,d){super(u,g,h,p,d),this.stateMainService=u}setEnablement(u){super.setEnablement(u),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}checkAndCreateProfileFromCli(u){if(!!this.isEnabled()){if(u.profile){const g=this.profiles.find(h=>h.name===u.profile);return g?Promise.resolve(g):this.createNamedProfile(u.profile)}if(u["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(u){u.length?this.stateMainService.setItem(ht.PROFILES_KEY,u):this.stateMainService.removeItem(ht.PROFILES_KEY)}saveStoredProfileAssociations(u){u.emptyWindow||u.workspaces?this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,u):this.stateMainService.removeItem(ht.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const u="workspaceAndProfileInfo",g=this.stateMainService.getItem(u,void 0);if(g){this.stateMainService.removeItem(u);const h=g.reduce((p,{workspace:d,profile:v})=>(p[I.URI.revive(d).toString()]=I.URI.revive(v).toString(),p),{});this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,{workspaces:h})}return super.getStoredProfileAssociations()}};C=we([te(0,P.IStateMainService),te(1,w.IUriIdentityService),te(2,t.IEnvironmentService),te(3,k.IFileService),te(4,D.ILogService)],C),e.UserDataProfilesMainService=C}),define(Z[260],ee([0,1,2,18,73,90,15,6,38,42]),function(z,e,I,t,k,R,D,P,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let E=class extends I.Disposable{constructor(b,u,g,h,p){super(),this.userDataProfilesService=b,this.fileService=u,this.extensionsScannerService=g,this.extensionsProfileScannerService=h,b.isEnabled()?(this._register(b.onWillCreateProfile(d=>{b.profiles.length===1&&d.join(this.initialize())})),this._register(b.onDidChangeProfiles(d=>{b.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,d=>p.error(d))}async initialize(){const b=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(b)}catch{}const u=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(u.map(g=>[g,g.metadata]),b)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,w.EXTENSIONS_RESOURCE_NAME)}};E=we([te(0,S.IUserDataProfilesMainService),te(1,D.IFileService),te(2,R.IExtensionsScannerService),te(3,k.IExtensionsProfileScannerService),te(4,P.ILogService)],E),e.DefaultExtensionsProfileInitHandler=E}),define(Z[261],ee([0,1,13,24,4,7,21,19,60,5,6,115,32,42]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let g=class{constructor(p,d,v,m,f){this.logService=p,this.windowsMainService=d,this.urlService=v,this.configurationService=m,this.userDataProfilesMainService=f}async start(p,d){this.logService.trace("Received data from other instance: ",p,d),k.isMacintosh&&I.app.focus({steal:!0});const v=this.parseOpenUrl(p);if(v.length){let m=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const f=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));f&&(m=f.ready())}m.then(()=>{for(const{uri:f,url:c}of v)this.urlService.open(f,{originalUrl:c})})}else return this.startOpenWindow(p,d)}parseOpenUrl(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,t.coalesce)(p._urls.map(d=>{try{return{uri:R.URI.parse(d),url:d}}catch{return null}})):[]}async startOpenWindow(p,d){const v=(0,w.isLaunchedFromCli)(d)?0:4;let m=[];const f=p.wait&&p.waitMarkerFilePath?R.URI.file(p.waitMarkerFilePath):void 0,c=p.remote||void 0,n=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(p),s={context:v,cli:p,userEnv:d,waitMarkerFileURI:f,remoteAuthority:c,profile:n};if(p.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,s);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let i=!1;if(p["new-window"]||p["unity-launch"]||n)i=!0;else if(p["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)m=await this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,s),m=[o]):m=await this.windowsMainService.open({...s,forceEmpty:!0})}}else m=await this.windowsMainService.open({...s,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(f&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,D.whenDeleted)(f.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};g=we([te(0,E.ILogService),te(1,b.IWindowsMainService),te(2,C.IURLService),te(3,P.IConfigurationService),te(4,u.IUserDataProfilesMainService)],g),e.LaunchMainService=g}),define(Z[92],ee([0,1,7,49,3,2,35,15,5,22,6,91,258,38,42,51]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,w.createDecorator)("storageMainService");let p=class extends R.Disposable{constructor(m,f,c,n,s,i){super(),this.logService=m,this.environmentService=f,this.userDataProfilesService=c,this.lifecycleMainService=n,this.fileService=s,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(m=>{m.window.profile&&this.profileStorage(m.window.profile).init(),m.workspace&&this.workspaceStorage(m.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(m=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=m.reason,m.join(this.applicationStorage.close());for(const[,f]of this.mapProfileToStorage)m.join(f.close());for(const[,f]of this.mapWorkspaceToStorage)m.join(f.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(m=>{m.join((async()=>{await this.fileService.exists(m.profile.globalStorageHome)||await this.fileService.createFolder(m.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(m=>{const f=this.mapProfileToStorage.get(m.profile.id);f&&m.join(f.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const m=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(m.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),m}profileStorage(m){if((0,C.isProfileUsingDefaultStorage)(m))return this.applicationStorage;let f=this.mapProfileToStorage.get(m.id);if(!f){this.logService.trace(`StorageMainService: creating profile storage (${m.name})`),f=this.createProfileStorage(m),this.mapProfileToStorage.set(m.id,f);const c=this._register(f.onDidChangeStorage(n=>this._onDidChangeProfileStorage.fire({...n,storage:f,profile:m})));(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${m.name})`),this.mapProfileToStorage.delete(m.id),c.dispose()})}return f}createProfileStorage(m){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(m,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(m){let f=this.mapWorkspaceToStorage.get(m.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${m.id})`),f=this.createWorkspaceStorage(m),this.mapWorkspaceToStorage.set(m.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${m.id})`),this.mapWorkspaceToStorage.delete(m.id)})),f}createWorkspaceStorage(m){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(m,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(m){const f=I.URI.file(m);for(const c of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!c.path&&this.uriIdentityService.extUri.isEqualOrParent(I.URI.file(c.path),f))return!0;return!1}};p=we([te(0,E.ILogService),te(1,D.IEnvironmentService),te(2,g.IUserDataProfilesMainService),te(3,S.ILifecycleMainService),te(4,P.IFileService),te(5,h.IUriIdentityService)],p),e.StorageMainService=p,e.IApplicationStorageMainService=(0,w.createDecorator)("applicationStorageMainService");let d=class extends C.AbstractStorageService{constructor(m,f){super(),this.userDataProfilesService=m,this.storageMainService=f,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(m){if(m===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(m){if(m===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};d=we([te(0,u.IUserDataProfilesService),te(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(Z[262],ee([0,1,2,22,42]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends I.Disposable{constructor(P,w){super(),this.userDataProfilesService=w,this._register(P.onWillLoadWindow(S=>{S.reason===2&&this.unsetTransientProfileForWorkspace(S.window.openedWorkspace??"empty-window")})),this._register(P.onBeforeCloseWindow(S=>this.unsetTransientProfileForWorkspace(S.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(P){this.userDataProfilesService.getOrSetProfileForWorkspace(P).isTransient&&(this.userDataProfilesService.unsetWorkspace(P,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=we([te(0,t.ILifecycleMainService),te(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(Z[263],ee([0,1,3,2,91]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(P,w,S){super(),this.storageMainService=P,this.userDataProfilesService=w,this.logService=S;const E=this._register(new t.MutableDisposable);this._onDidChange=this._register(new I.Emitter({onFirstListenerAdd:()=>E.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>E.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(I.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(w,S)=>(w?w.push(S.key):w=[S.key],w),100)(w=>this.onDidChangeApplicationStorage(w))),P.add(I.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(w,S)=>{w||(w=new Map);let E=w.get(S.profile.id);return E||w.set(S.profile.id,E={profile:S.profile,keys:[],storage:S.storage}),E.keys.push(S.key),w},100)(w=>this.onDidChangeProfileStorage(w))),P}onDidChangeApplicationStorage(P){const w=P.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],S=[];if(P=P.filter(E=>E!==k.TARGET_KEY),P.length){const E=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);S.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(C=>({key:C,scope:0,target:E[C]}))})}this.triggerEvents(w,S)}onDidChangeProfileStorage(P){const w=[],S=new Map;for(const[E,C]of P.entries()){C.keys.includes(k.TARGET_KEY)&&w.push(C.profile);const b=C.keys.filter(u=>u!==k.TARGET_KEY);if(b.length){const u=(0,k.loadKeyTargets)(C.storage.storage);S.set(E,{profile:C.profile,changes:b.map(g=>({key:g,scope:0,target:u[g]}))})}}this.triggerEvents(w,[...S.values()])}triggerEvents(P,w){(P.length||w.length)&&this._onDidChange.fire({valueChanges:w,targetChanges:P})}listen(P,w,S){switch(w){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${w}`)}async call(P,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=R}),define(Z[117],ee([0,1,18,7,28]),function(z,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(w,S,E){for(const b of w){const u=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(u)){const g=await E(u);if(g){if(g.folders.some(h=>I.extUriBiasedIgnorePathCase.isEqualOrParent(S,h.uri)))return b}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(S,u.configPath))return b}}const C=w.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(S,b.openedWorkspace.uri));if(C.length)return C.sort((b,u)=>-(b.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(w,S){for(const E of w)if((0,k.isWorkspaceIdentifier)(E.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,S)||(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,S))return E}e.findWindowOnWorkspaceOrFolder=D;function P(w,S){const E=C=>S.some(b=>I.extUriBiasedIgnorePathCase.isEqual(t.URI.file(b),t.URI.file(C)));for(const C of w)if(C.config?.extensionDevelopmentPath?.some(b=>E(b)))return C}e.findWindowOnExtensionDevelopmentPath=P}),define(Z[264],ee([0,1,13,2,4,18,7,19,22,6,37,32,116,28]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let g=class Tt extends t.Disposable{get state(){return this._state}constructor(f,c,n,s,i){super(),this.windowsMainService=f,this.stateMainService=c,this.lifecycleMainService=n,this.logService=s,this.configurationService=i,this._state=h(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){I.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(f=>this.onBeforeCloseWindow(f)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(f=>this.onBeforeCloseWindow(f))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const f=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&f.add(c.lastActiveWindow.uiState.display))}const n=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(n),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!n.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.toWindowState(i);return o.uiState.mode===3&&(f.has(o.uiState.display)?k.isMacintosh&&o.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):f.add(o.uiState.display)),o}));const s=d(c);this.stateMainService.setItem(Tt.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(f){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this._state.openedWindows.forEach(n=>{const s=(0,u.isWorkspaceIdentifier)(f.openedWorkspace)&&n.workspace?.id===f.openedWorkspace.id,i=(0,u.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,f.openedWorkspace.uri);(s||i)&&(n.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(f){return{windowId:f.id,workspace:(0,u.isWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const c=this.doGetNewWindowState(f),n=this.configurationService.getValue("window");if(c.mode===3){let s;c.hasDefaultState?s=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),s||(c.mode=1)}return c}doGetNewWindowState(f){const c=this.windowsMainService.getLastActiveWindow();if(!f.extensionTestsPath){if(!!f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=f.workspace;if((0,u.isWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===l.id).map(M=>M.uiState);if(y.length)return y[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,l.uri)).map(M=>M.uiState);if(y.length)return y[0]}else if(f.backupPath){const y=this.state.openedWindows.filter(M=>M.backupPath===f.backupPath).map(M=>M.uiState);if(y.length)return y[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!c&&a)return a.uiState}let n;const s=I.screen.getAllDisplays();if(s.length===1)n=s[0];else{if(k.isMacintosh){const l=I.screen.getCursorScreenPoint();n=I.screen.getDisplayNearestPoint(l)}!n&&c&&(n=I.screen.getDisplayMatching(c.getBounds())),n||(n=I.screen.getPrimaryDisplay()||s[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const o=this.configurationService.getValue("window");let r=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,r=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,r=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&c){const l=c.serializeWindowState();l.mode===3?i.mode=3:i=l,r=i.mode!==3&&o.newWindowDimensions==="offset"}}return r&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(f){if(this.windowsMainService.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const c=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===f.x||n.y===f.y);)f.x+=30,f.y+=30;return f}};g.windowsStateStorageKey="windowsState",g=we([te(0,C.IWindowsMainService),te(1,E.IStateMainService),te(2,w.ILifecycleMainService),te(3,S.ILogService),te(4,P.IConfigurationService)],g),e.WindowsStateHandler=g;function h(m){const f={openedWindows:[]},c=m||{openedWindows:[]};return c.lastActiveWindow&&(f.lastActiveWindow=p(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=p(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(f.openedWindows=c.openedWindows.map(n=>p(n))),f}e.restoreWindowsState=h;function p(m){const f={uiState:m.uiState};return m.backupPath&&(f.backupPath=m.backupPath),m.remoteAuthority&&(f.remoteAuthority=m.remoteAuthority),m.folder&&(f.folderUri=D.URI.parse(m.folder)),m.workspaceIdentifier&&(f.workspace={id:m.workspaceIdentifier.id,configPath:D.URI.parse(m.workspaceIdentifier.configURIPath)}),f}function d(m){return{lastActiveWindow:m.lastActiveWindow&&v(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&v(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(f=>v(f))}}e.getWindowsStateStoreData=d;function v(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(Z[93],ee([0,1,30,43,123,34,14,9,4,18,7,5,64,28]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,C.createDecorator)("workspacesService");function g(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function h(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=h;function p(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=p;function d(M){return v(M)||m(M)}e.isStoredWorkspaceFolder=d;function v(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function m(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function f(M,T,N,G,ae){if(M.scheme!==G.scheme)return{name:N,uri:M.toString(!0)};let X=T?void 0:ae.relativePath(G,M);if(X!==void 0)X.length===0?X=".":w.isWindows&&(X=c(X));else if(M.scheme===D.Schemas.file)X=M.fsPath,w.isWindows&&(X=c(X));else if(ae.isEqualAuthority(M.authority,G.authority))X=M.path;else return{name:N,uri:M.toString(!0)};return{name:N,path:X}}e.getStoredWorkspaceFolder=f;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,I.isUNC)(M)||(M=(0,I.toSlashes)(M)),M}function n(M,T,N){const G=[],ae=new Set,X=N.dirname(T);for(const Q of M){let ie;if(v(Q))Q.path&&(ie=N.resolvePath(X,Q.path));else if(m(Q))try{ie=E.URI.parse(Q.uri),ie.path[0]!==P.posix.sep&&(ie=ie.with({path:P.posix.sep+ie.path}))}catch(oe){console.warn(oe)}if(ie){const oe=N.getComparisonKey(ie);if(!ae.has(oe)){ae.add(oe);const he=Q.name||N.basenameOrAuthority(ie);G.push(new u.WorkspaceFolder({uri:ie,name:he,index:G.length},Q))}}}return G}e.toWorkspaceFolders=n;function s(M,T,N,G,ae){const X=i(T,M),Q=ae.dirname(T),ie=ae.dirname(G),oe=[];for(const F of X.folders){const A=v(F)?ae.resolvePath(Q,F.path):E.URI.parse(F.uri);let W;N?W=!1:W=!v(F)||(0,P.isAbsolute)(F.path),oe.push(f(A,W,F.name,ie,ae))}const he={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},V=k.setProperty(M,["folders"],oe,he);let q=k.applyEdits(M,V);return(0,S.isEqualAuthority)(X.remoteAuthority,(0,b.getRemoteAuthority)(G))&&(q=k.applyEdits(q,k.removeProperty(q,["remoteAuthority"],he))),q}e.rewriteWorkspaceFileForNewLocation=s;function i(M,T){const N=t.parse(T);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(G=>d(G));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function o(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function r(M){return typeof M.folderUri=="string"}function l(M){return typeof M.fileUri=="string"}function a(M,T){const N={workspaces:[],files:[]};if(M){const G=function(X,Q){for(let ie=0;ie<X.length;ie++)try{Q(X[ie],ie)}catch(oe){T.warn(`Error restoring recent entry ${JSON.stringify(X[ie])}: ${oe.toString()}. Skip entry.`)}},ae=M;Array.isArray(ae.entries)&&G(ae.entries,X=>{const Q=X.label,ie=X.remoteAuthority;o(X)?N.workspaces.push({label:Q,remoteAuthority:ie,workspace:{id:X.workspace.id,configPath:E.URI.parse(X.workspace.configPath)}}):r(X)?N.workspaces.push({label:Q,remoteAuthority:ie,folderUri:E.URI.parse(X.folderUri)}):l(X)&&N.files.push({label:Q,remoteAuthority:ie,fileUri:E.URI.parse(X.fileUri)})})}return N}e.restoreRecentlyOpened=a;function y(M){const T={entries:[]};for(const N of M.workspaces)h(N)?T.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):T.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)T.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return T}e.toStoreData=y}),define(Z[94],ee([0,1,78,14,4,18]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(S){function E(){let C=S.scheme===t.Schemas.file?(0,R.originalFSPath)(S):S.toString();return k.isLinux||(C=C.toLowerCase()),(0,I.createHash)("md5").update(C).digest("hex")}return{id:E(),configPath:S}}e.getWorkspaceIdentifier=D;function P(S,E){function C(){if(S.scheme!==t.Schemas.file)return(0,I.createHash)("md5").update(S.toString()).digest("hex");if(!E)return;let u;return k.isLinux?u=E.ino:k.isMacintosh?u=E.birthtime.getTime():k.isWindows&&(typeof E.birthtimeMs=="number"?u=Math.floor(E.birthtimeMs):u=E.birthtime.getTime()),(0,I.createHash)("md5").update(S.fsPath).update(u?String(u):"").digest("hex")}const b=C();if(typeof b=="string")return{id:b,uri:S}}e.getSingleFolderWorkspaceIdentifier=P;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(Z[265],ee([0,1,78,30,14,9,4,18,21,176,19,27,37,15,6,175,28,94]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Ot{constructor(f,c,n,s){this.environmentMainService=f,this.configurationService=c,this.logService=n,this.stateMainService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,o)=>(0,t.isEqual)(i,o,!D.isLinux)}}async initialize(){const f=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(f.emptyWindows),this.workspaces=await this.validateWorkspaces((0,S.deserializeWorkspaceInfos)(f)),this.folders=await this.validateFolders((0,S.deserializeFolderInfos)(f)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let f=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!f)try{const c=(0,R.join)(this.backupHome,"workspaces.json"),n=await w.Promises.readFile(c,"utf8");try{await w.Promises.unlink(c)}catch{}const s=JSON.parse(n);f={workspaces:Array.isArray(s.rootURIWorkspaces)?s.rootURIWorkspaces:[],folders:Array.isArray(s.folderWorkspaceInfos)?s.folderWorkspaceInfos:[],emptyWindows:Array.isArray(s.emptyWorkspaceInfos)?s.emptyWorkspaceInfos:[]}}catch(c){c.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${c.toString()}`)}return f??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(f,c){this.workspaces.some(s=>f.workspace.id===s.workspace.id)||(this.workspaces.push(f),this.storeWorkspacesMetadata());const n=(0,R.join)(this.backupHome,f.workspace.id);return c?this.moveBackupFolder(n,c).then(()=>n):n}async moveBackupFolder(f,c){if(await w.Promises.exists(f)&&await this.convertToEmptyWindowBackup(f),await w.Promises.exists(c))try{await w.Promises.rename(c,f)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(f){return this.folders.some(c=>this.backupUriComparer.isEqual(f.folderUri,c.folderUri))||(this.folders.push(f),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(f))}registerEmptyWindowBackup(f){return this.emptyWindows.some(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,f.backupFolder))||(this.emptyWindows.push(f),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,f.backupFolder)}async validateWorkspaces(f){if(!Array.isArray(f))return[];const c=new Set,n=[];for(const s of f){const i=s.workspace;if(!(0,p.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const o=(0,R.join)(this.backupHome,i.id);await this.doHasBackups(o)?i.configPath.scheme!==k.Schemas.file||await w.Promises.exists(i.configPath.fsPath)?n.push(s):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return n}async validateFolders(f){if(!Array.isArray(f))return[];const c=[],n=new Set;for(const s of f){const i=s.folderUri,o=this.backupUriComparer.getComparisonKey(i);if(!n.has(o)){n.add(o);const r=(0,R.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(r)?i.scheme!==k.Schemas.file||await w.Promises.exists(i.fsPath)?c.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateEmptyWorkspaces(f){if(!Array.isArray(f))return[];const c=[],n=new Set;for(const s of f){const i=s.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const o=(0,R.join)(this.backupHome,i);await this.doHasBackups(o)?c.push(s):await this.deleteStaleBackup(o)}}return c}async deleteStaleBackup(f){try{await w.Promises.rm(f,w.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}prepareNewEmptyWindowBackup(){let f=(0,d.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,f.id));)f=(0,d.createEmptyWorkspaceIdentifier)();return{backupFolder:f.id}}async convertToEmptyWindowBackup(f){const c=this.prepareNewEmptyWindowBackup(),n=(0,R.join)(this.backupHome,c.backupFolder);try{await w.Promises.rename(f,n)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(c),!0}async getDirtyWorkspaces(){const f=[];for(const c of this.workspaces)await this.hasBackups(c)&&f.push(c);for(const c of this.folders)await this.hasBackups(c)&&f.push(c);return f}hasBackups(f){let c;return(0,S.isEmptyWindowBackupInfo)(f)?c=(0,R.join)(this.backupHome,f.backupFolder):(0,h.isFolderBackupInfo)(f)?c=(0,R.join)(this.backupHome,this.getFolderHash(f)):c=(0,R.join)(this.backupHome,f.workspace.id),this.doHasBackups(c)}async doHasBackups(f){try{const c=await w.Promises.readdir(f);for(const n of c)try{if((await w.Promises.readdir((0,R.join)(f,n))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const f={workspaces:this.workspaces.map(({workspace:c,remoteAuthority:n})=>{const s={id:c.id,configURIPath:c.configPath.toString()};return n&&(s.remoteAuthority=n),s}),folders:this.folders.map(({folderUri:c,remoteAuthority:n})=>{const s={folderUri:c.toString()};return n&&(s.remoteAuthority=n),s}),emptyWindows:this.emptyWindows.map(({backupFolder:c,remoteAuthority:n})=>{const s={backupFolder:c};return n&&(s.remoteAuthority=n),s})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,f)}getFolderHash(f){const c=f.folderUri;let n;return c.scheme===k.Schemas.file?n=D.isLinux?c.fsPath:c.fsPath.toLowerCase():n=c.toString().toLowerCase(),(0,I.createHash)("md5").update(n).digest("hex")}};v.backupWorkspacesMetadataStorageKey="backupWorkspaces",v=we([te(0,C.IEnvironmentMainService),te(1,E.IConfigurationService),te(2,g.ILogService),te(3,b.IStateMainService)],v),e.BackupMainService=v}),define(Z[52],ee([0,1,13,3,43,34,2,14,9,18,12,21,174,61,56,27,5,6,20,42,117,28,93,94]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let i=class extends D.Disposable{constructor(r,l,a,y,M,T){super(),this.environmentMainService=r,this.logService=l,this.userDataProfilesMainService=a,this.backupMainService=y,this.dialogMainService=M,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const r=(await C.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(l=>(0,S.joinPath)(this.untitledWorkspacesHome,l,c.UNTITLED_WORKSPACE_NAME));for(const l of r){const a=(0,s.getWorkspaceIdentifier)(l),y=await this.resolveLocalWorkspace(l);y?this.untitledWorkspaces.push({workspace:a,remoteAuthority:y.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(r){r.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${r}).`)}}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,l=>C.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(r,l){if(!!this.isWorkspacePath(r)&&r.scheme===P.Schemas.file)try{const a=l(r.fsPath);return a instanceof Promise?a.then(y=>this.doResolveWorkspace(r,y),y=>{}):this.doResolveWorkspace(r,a)}catch{return}}isWorkspacePath(r){return(0,c.isUntitledWorkspace)(r,this.environmentMainService)||(0,c.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,l){try{const a=this.doParseStoredWorkspace(r,l),y=(0,s.getWorkspaceIdentifier)(r);return{id:y.id,configPath:y.configPath,folders:(0,n.toWorkspaceFolders)(a.folders,y.configPath,S.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(r,l){const a=(0,k.parse)(l);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(y=>(0,n.isStoredWorkspaceFolder)(y));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(r,l){const{workspace:a,storedWorkspace:y}=this.newUntitledWorkspace(r,l),M=a.configPath.fsPath;return await C.Promises.mkdir((0,w.dirname)(M),{recursive:!0}),await C.Promises.writeFile(M,JSON.stringify(y,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:l}),a}newUntitledWorkspace(r=[],l){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),y=(0,S.joinPath)(this.untitledWorkspacesHome,a),M=(0,S.joinPath)(y,c.UNTITLED_WORKSPACE_NAME),T=[];for(const N of r)T.push((0,n.getStoredWorkspaceFolder)(N.uri,!0,N.name,y,S.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(M),storedWorkspace:{folders:T,remoteAuthority:l}}}async getWorkspaceIdentifier(r){return(0,s.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,c.isUntitledWorkspace)(r.configPath,this.environmentMainService)}async deleteUntitledWorkspace(r){!this.isUntitledWorkspace(r)||(await this.doDeleteUntitledWorkspace(r),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(r),this._onDidDeleteUntitledWorkspace.fire(r))}async doDeleteUntitledWorkspace(r){const l=(0,S.originalFSPath)(r.configPath);try{await C.Promises.rm((0,w.dirname)(l));const a=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);await C.Promises.exists(a)&&await C.Promises.writeFile((0,w.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(y=>y.workspace.id!==r.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${l} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(r,l,a){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,l,a))return;const M=await this.doEnterWorkspace(r,(0,s.getWorkspaceIdentifier)(a));if(!!M)return this._onDidEnterWorkspace.fire({window:r,workspace:M.workspace}),M}async isValidTargetWorkspacePath(r,l,a){if(!a)return!0;if((0,c.isWorkspaceIdentifier)(r.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,a))return!1;if((0,f.findWindowOnWorkspaceOrFolder)(l,a)){const y={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(0,null))],message:(0,b.localize)(1,null,(0,S.basename)(a)),detail:(0,b.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(y,(0,E.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(r,l){if(!r.config)return;r.focus();let a;return r.config.extensionDevelopmentPath||(r.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:l,remoteAuthority:r.remoteAuthority},r.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:l,remoteAuthority:r.remoteAuthority})),(0,c.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=l,r.config.backupPath=a,{workspace:l,backupPath:a}}};i=we([te(0,h.IEnvironmentMainService),te(1,d.ILogService),te(2,m.IUserDataProfilesMainService),te(3,u.IBackupMainService),te(4,g.IDialogMainService),te(5,v.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Z[118],ee([0,1,13,41,23,5,32,28,52,12,6]),function(z,e,I,t,k,R,D,P,w,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let C=class{constructor(u,g,h){this.windowsMainService=u,this.workspacesManagementMainService=g,this.logService=h}async getRemoteDiagnostics(u){const g=this.windowsMainService.getWindows();return(await Promise.all(g.map(async p=>{const d=p.remoteAuthority;if(!d)return;const v=`vscode:getDiagnosticInfoResponse${p.id}`,m={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.getFolderURIs(p):void 0};return new Promise(f=>{p.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:v,args:m}),t.validatedIpcMain.once(v,(c,n)=>{n||f({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),f(n)}),setTimeout(()=>{f({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(p=>!!p)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const u=[];for(const g of I.BrowserWindow.getAllWindows()){const h=this.windowsMainService.getWindowById(g.id);h?u.push(await this.codeWindowToInfo(h)):u.push(this.browserWindowToInfo(g))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async codeWindowToInfo(u){const g=await this.getFolderURIs(u),h=(0,S.assertIsDefined)(u.win);return this.browserWindowToInfo(h,g,u.remoteAuthority)}browserWindowToInfo(u,g=[],h){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:g,remoteAuthority:h}}async getFolderURIs(u){const g=[],h=u.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(h))g.push(h.uri);else if((0,P.isWorkspaceIdentifier)(h)){const p=await this.workspacesManagementMainService.resolveLocalWorkspace(h.configPath);p&&p.folders.forEach(v=>{g.push(v.uri)})}return g}};C=we([te(0,D.IWindowsMainService),te(1,w.IWorkspacesManagementMainService),te(2,E.ILogService)],C),e.DiagnosticsMainService=C}),define(Z[66],ee([0,1,45,13,25,140,53,3,34,2,14,9,4,7,100,82,21,96,164,56,27,5,22,6,20,65,32,28,52,17,222,232,31]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s,i,o,r,l,a,y,M,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let G=class extends S.Disposable{constructor(X,Q,ie,oe,he,V,q,F,A,W){super(),this.sharedProcess=X,this.windowsMainService=Q,this.dialogMainService=ie,this.lifecycleMainService=oe,this.environmentMainService=he,this.logService=V,this.productService=q,this.themeMainService=F,this.workspacesManagementMainService=A,this.telemetryService=W,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,U=>U.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:U,x:J,y:B})=>({windowId:U.id,x:J,y:B})),({windowId:U})=>!!this.windowsMainService.getWindowById(U)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),U=>!!U),U=>U.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(U,J,B)=>B),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(Q=>({id:Q.id,workspace:Q.openedWorkspace??(0,l.toWorkspaceIdentifier)(Q.backupPath,Q.isExtensionDevelopmentHost),title:Q.win?.getTitle()??"",filename:Q.getRepresentedFilename(),dirty:Q.isDocumentEdited()}))}async getWindowCount(X){return this.windowsMainService.getWindowCount()}async getActiveWindowId(X){const Q=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(Q)return Q.id}openWindow(X,Q,ie){return Array.isArray(Q)?this.doOpenWindow(X,Q,ie):this.doOpenEmptyWindow(X,Q)}async doOpenWindow(X,Q,ie=Object.create(null)){Q.length>0&&await this.windowsMainService.open({context:5,contextWindowId:X,urisToOpen:Q,cli:this.environmentMainService.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0})}async doOpenEmptyWindow(X,Q){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:X},Q)}async toggleFullScreen(X){this.windowById(X)?.toggleFullScreen()}async handleTitleDoubleClick(X){this.windowById(X)?.handleTitleDoubleClick()}async isMaximized(X){const Q=this.windowById(X);return Q?.win?Q.win.isMaximized():!1}async maximizeWindow(X){const Q=this.windowById(X);Q?.win&&Q.win.maximize()}async unmaximizeWindow(X){const Q=this.windowById(X);Q?.win&&Q.win.unmaximize()}async minimizeWindow(X){const Q=this.windowById(X);Q?.win&&Q.win.minimize()}async updateWindowControls(X,Q){const ie=this.windowById(X);ie&&ie.updateWindowControls(Q)}async focusWindow(X,Q){Q&&typeof Q.windowId=="number"&&(X=Q.windowId),this.windowById(X)?.focus({force:Q?.force??!1})}async setMinimumSize(X,Q,ie){const oe=this.windowById(X);if(oe?.win){const[he,V]=oe.win.getSize(),[q,F]=oe.win.getMinimumSize(),[A,W]=[Q??q,ie??F],[U,J]=[Math.max(he,A),Math.max(V,W)];(q!==A||F!==W)&&oe.win.setMinimumSize(A,W),(he!==U||V!==J)&&oe.win.setSize(U,J)}}async saveWindowSplash(X,Q){this.themeMainService.saveWindowSplash(X,Q)}async installShellCommand(X){const{source:Q,target:ie}=await this.getShellCommandLink();try{const{symbolicLink:oe}=await p.SymlinkSupport.stat(Q);if(oe&&!oe.dangling){const he=await(0,g.realpath)(Q);if(ie===he)return}await p.Promises.unlink(Q)}catch(oe){if(oe.code!=="ENOENT")throw oe}try{await p.Promises.symlink(ie,Q)}catch(oe){if(oe.code!=="EACCES"&&oe.code!=="ENOENT")throw oe;const{response:he}=await this.showMessageBox(X,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(he===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${Q}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(V)}catch{throw new Error((0,v.localize)(3,null,Q))}}}async uninstallShellCommand(X){const{source:Q}=await this.getShellCommandLink();try{await p.Promises.unlink(Q)}catch(ie){switch(ie.code){case"EACCES":{const{response:oe}=await this.showMessageBox(X,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const he=`osascript -e "do shell script \\"rm '${Q}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(he)}catch{throw new Error((0,v.localize)(7,null,Q))}break}case"ENOENT":break;default:throw ie}}}async getShellCommandLink(){const X=(0,C.resolve)(this.environmentMainService.appRoot,"bin","code"),Q=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(X))throw new Error((0,v.localize)(8,null,X));return{source:Q,target:X}}async showMessageBox(X,Q){return this.dialogMainService.showMessageBox(Q,this.toBrowserWindow(X))}async showSaveDialog(X,Q){return this.dialogMainService.showSaveDialog(Q,this.toBrowserWindow(X))}async showOpenDialog(X,Q){return this.dialogMainService.showOpenDialog(Q,this.toBrowserWindow(X))}toBrowserWindow(X){const Q=this.windowById(X);if(Q?.win)return Q.win}async pickFileFolderAndOpen(X,Q){const ie=await this.dialogMainService.pickFileFolder(Q);ie&&await this.doOpenPicked(await Promise.all(ie.map(async oe=>await p.SymlinkSupport.existsDirectory(oe)?{folderUri:u.URI.file(oe)}:{fileUri:u.URI.file(oe)})),Q,X)}async pickFolderAndOpen(X,Q){const ie=await this.dialogMainService.pickFolder(Q);ie&&await this.doOpenPicked(ie.map(oe=>({folderUri:u.URI.file(oe)})),Q,X)}async pickFileAndOpen(X,Q){const ie=await this.dialogMainService.pickFile(Q);ie&&await this.doOpenPicked(ie.map(oe=>({fileUri:u.URI.file(oe)})),Q,X)}async pickWorkspaceAndOpen(X,Q){const ie=await this.dialogMainService.pickWorkspace(Q);ie&&await this.doOpenPicked(ie.map(oe=>({workspaceUri:u.URI.file(oe)})),Q,X)}async doOpenPicked(X,Q,ie){await this.windowsMainService.open({context:3,contextWindowId:ie,cli:this.environmentMainService.args,urisToOpen:X,forceNewWindow:Q.forceNewWindow})}async showItemInFolder(X,Q){t.shell.showItemInFolder(Q)}async setRepresentedFilename(X,Q){this.windowById(X)?.setRepresentedFilename(Q)}async setDocumentEdited(X,Q){this.windowById(X)?.setDocumentEdited(Q)}async openExternal(X,Q){return b.isLinuxSnap?this.safeSnapOpenExternal(Q):t.shell.openExternal(Q),!0}safeSnapOpenExternal(X){const Q=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(X),process.env.GDK_PIXBUF_MODULE_FILE=Q,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(X,Q){return t.shell.trashItem(Q)}async isAdmin(){let X;return b.isWindows?X=(await new Promise((Q,ie)=>{z(["native-is-elevated"],Q,ie)}))():X=process.getuid()===0,X}async writeElevated(X,Q,ie,oe){const he=await new Promise((V,q)=>{z(["@vscode/sudo-prompt"],V,q)});return new Promise((V,q)=>{const F=[`"${this.cliPath}"`];oe?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${Q.fsPath}"`,`"${ie.fsPath}"`);const A={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};he.exec(F.join(" "),A,(W,U,J)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),J&&this.logService.trace(`[sudo-prompt] received stderr: ${J}`),W?q(W):V(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,C.join)(this.environmentMainService.appRoot,"bin","code"):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(X,Q,ie){process.kill(Q,ie)}async readClipboardText(X,Q){return t.clipboard.readText(Q)}async writeClipboardText(X,Q,ie){return t.clipboard.writeText(Q,ie)}async readClipboardFindText(X){return t.clipboard.readFindText()}async writeClipboardFindText(X,Q){return t.clipboard.writeFindText(Q)}async writeClipboardBuffer(X,Q,ie,oe){return t.clipboard.writeBuffer(Q,Buffer.from(ie.buffer),oe)}async readClipboardBuffer(X,Q){return y.VSBuffer.wrap(t.clipboard.readBuffer(Q))}async hasClipboard(X,Q,ie){return t.clipboard.has(Q,ie)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(X,Q){this.windowById(X)?.updateTouchBar(Q)}async notifyReady(X){this.windowById(X)?.setReady()}async relaunch(X,Q){return this.lifecycleMainService.relaunch(Q)}async reload(X,Q){const ie=this.windowById(X);if(ie){if((0,l.isWorkspaceIdentifier)(ie.openedWorkspace)){const oe=ie.openedWorkspace.configPath;if(oe.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(oe))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(ie,Q?.disableExtensions!==void 0?{_:[],"disable-extensions":Q.disableExtensions}:void 0)}}async closeWindow(X){this.closeWindowById(X,X)}async closeWindowById(X,Q){const ie=this.windowById(Q);if(ie?.win)return ie.win.close()}async quit(X){const Q=this.windowsMainService.getLastActiveWindow();Q?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&Q.win?Q.win.close():this.lifecycleMainService.quit()}async exit(X,Q){await this.lifecycleMainService.kill(Q)}async resolveProxy(X,Q){const oe=this.windowById(X)?.win?.webContents?.session;if(oe)return oe.resolveProxy(Q)}findFreePort(X,Q,ie,oe,he=1){return(0,d.findFreePort)(Q,ie,oe,he)}async openDevTools(X,Q){const ie=this.windowById(X);ie?.win&&ie.win.webContents.openDevTools(Q)}async toggleDevTools(X){const Q=this.windowById(X);Q?.win&&Q.win.webContents.toggleDevTools()}async sendInputEvent(X,Q){const ie=this.windowById(X);ie?.win&&(Q.type==="mouseDown"||Q.type==="mouseUp")&&ie.win.webContents.sendInputEvent(Q)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async profileRenderer(X,Q,ie,oe){const he=this.windowById(X);return!he||!he.win?!1:await new T.WindowProfiler(he.win,Q,this.logService,this.telemetryService).inspect(ie,oe)===2}async windowsGetStringRegKey(X,Q,ie,oe){if(!b.isWindows)return;const he=await new Promise((V,q)=>{z(["@vscode/windows-registry"],V,q)});try{return he.GetStringRegKey(Q,ie,oe)}catch{return}}windowById(X){if(typeof X=="number")return this.windowsMainService.getWindowById(X)}};we([D.memoize],G.prototype,"cliPath",null),G=we([te(1,r.IWindowsMainService),te(2,m.IDialogMainService),te(3,n.ILifecycleMainService),te(4,f.IEnvironmentMainService),te(5,s.ILogService),te(6,i.IProductService),te(7,o.IThemeMainService),te(8,a.IWorkspacesManagementMainService),te(9,N.ITelemetryService)],G),e.NativeHostMainService=G}),define(Z[266],ee([0,1,13,41,25,34,2,14,4,101,162,85,118,56,27,5,6,66,54,20,62,75,30,12]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,h.createDecorator)("issueMainService");let i=class Nt{constructor(r,l,a,y,M,T,N,G,ae){this.userEnv=r,this.environmentMainService=l,this.logService=a,this.diagnosticsService=y,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=N,this.protocolMainService=G,this.productService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[l,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),y=await this.diagnosticsService.getSystemInfo(l,a);this.safeSend(r,"vscode:issueSystemInfoResponse",y)}),t.validatedIpcMain.on("vscode:listProcesses",async r=>{const l=[];try{l.push({name:(0,E.localize)(0,null),rootProcess:await(0,S.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(y=>{(0,C.isRemoteDiagnosticError)(y)?l.push({name:y.hostName,rootProcess:y}):y.processes&&l.push({name:y.hostName,rootProcess:y.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(r,"vscode:listProcessesResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{const l={title:this.productService.nameLong,message:(0,E.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(l,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const l=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:(0,E.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,E.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(r,l)=>{const{id:a,from:y,args:M}=l;let T;switch(y){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${y}`)}T?.webContents.send("vscode:runAction",{id:a,from:y,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(r,l)=>{this.nativeHostMainService.openExternal(void 0,l)}),t.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const l=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(r,"vscode:windowsInfoResponse",l.windows)})}safeSend(r,l,...a){r.sender.isDestroyed()||r.sender.send(l,...a)}async openReporter(r){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=I.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const l=new D.DisposableStore,a=l.add(this.protocolMainService.createIPCObjectUrl()),y=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(y,a,{backgroundColor:r.styles.backgroundColor,title:(0,E.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:v.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,l.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,l.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(r){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=I.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const l=new D.DisposableStore,a=l.add(this.protocolMainService.createIPCObjectUrl()),y=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(y,a,{backgroundColor:r.styles.backgroundColor,title:(0,E.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:v.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,l.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,l.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(r){r.isMinimized()&&r.restore(),r.focus()}createBrowserWindow(r,l,a,y){const M=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:a.title,backgroundColor:a.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,`--vscode-window-kind=${y}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[r,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,l)}getWindowPosition(r,l,a){let y;const M=I.screen.getAllDisplays();if(M.length===1)y=M[0];else{if(w.isMacintosh){const G=I.screen.getCursorScreenPoint();y=I.screen.getDisplayNearestPoint(G)}!y&&r&&(y=I.screen.getDisplayMatching(r.getBounds())),y||(y=I.screen.getPrimaryDisplay()||M[0])}const T={width:l,height:a},N=y.bounds;return T.x=N.x+N.width/2-T.width/2,T.y=N.y+N.height/2-T.height/2,N.width>0&&N.height>0&&(T.x<N.x&&(T.x=N.x),T.y<N.y&&(T.y=N.y),T.x>N.x+N.width&&(T.x=N.x),T.y>N.y+N.height&&(T.y=N.y),T.width>N.width&&(T.width=N.width),T.height>N.height&&(T.height=N.height)),T}async getPerformanceInfo(){try{const[r,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,l)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const r=await I.contentTracing.stopRecording(`${(0,n.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,E.localize)(9,null),detail:(0,E.localize)(10,null,r),buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(11,null))],defaultId:0,noLink:!0},(0,s.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,r)}};i.DEFAULT_BACKGROUND_COLOR="#1E1E1E",i=we([te(1,g.IEnvironmentMainService),te(2,p.ILogService),te(3,C.IDiagnosticsService),te(4,b.IDiagnosticsMainService),te(5,u.IDialogMainService),te(6,d.INativeHostMainService),te(7,f.IProtocolMainService),te(8,m.IProductService)],i),e.IssueMainService=i}),define(Z[267],ee([0,1,23,19,27,22,6,66,20,55,31,48,89]),function(z,e,I,t,k,R,D,P,w,S,E,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends b.AbstractUpdateService{constructor(h,p,d,v,m,f,c,n){super(h,p,v,m,f,n),this.telemetryService=d,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,b.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(C.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},I.CancellationToken.None).then(S.asJson).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(C.State.Idle(1))):this.setState(C.State.AvailableForDownload(p))}).then(void 0,p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const d=h?p.message||p:void 0;this.setState(C.State.Idle(1,d))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(C.State.Idle(1))}};u=we([te(0,R.ILifecycleMainService),te(1,t.IConfigurationService),te(2,E.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,S.IRequestService),te(5,D.ILogService),te(6,P.INativeHostMainService),te(7,w.IProductService)],u),e.LinuxUpdateService=u}),define(Z[268],ee([0,1,45,40,25,8,23,53,9,7,126,21,19,27,15,22,6,66,20,55,31,48,89]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(l,a=1e3){for(;!l();)await(0,R.timeout)(a)}let i;function o(){return typeof i>"u"&&(i=t.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),i}let r=class extends n.AbstractUpdateService{get cachePath(){const a=w.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return C.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,y,M,T,N,G,ae,X,Q){super(a,y,T,N,G,Q),this.telemetryService=M,this.fileService=ae,this.nativeHostMainService=X}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(a){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),o()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,n.createUpdateURL)(y,a,this.productService)}doCheckForUpdates(a){!this.url||(this.setState(c.State.CheckingForUpdates(a)),this.requestService.request({url:this.url},D.CancellationToken.None).then(m.asJson).then(y=>{const M=o();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(c.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(T=>C.Promises.exists(T).then(N=>{if(N)return Promise.resolve(T);const G=y.url,ae=y.hash,X=`${T}.tmp`;return this.requestService.request({url:G},D.CancellationToken.None).then(Q=>this.fileService.writeFile(S.URI.file(X),Q.stream)).then(ae?()=>(0,E.checksum)(X,y.hash):()=>{}).then(()=>C.Promises.rename(X,T)).then(()=>T)})).then(T=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},N&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(y)):this.setState(c.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a});const M=a?y.message||y:void 0;this.setState(c.State.Idle(o(),M))}))}async doDownloadUpdate(a){a.update.url&&this.nativeHostMainService.openExternal(void 0,a.update.url),this.setState(c.State.Idle(o()))}async getUpdatePackagePath(a){const y=await this.cachePath;return w.join(y,`CodeSetup-${this.productService.quality}-${a}.exe`)}async cleanup(a=null){const y=a?G=>!new RegExp(`${this.productService.quality}-${a}\\.exe$`).test(G):()=>!0,M=await this.cachePath,N=(await C.Promises.readdir(M)).filter(y).map(async G=>{try{await C.Promises.unlink(w.join(M,G))}catch{}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const a=this.state.update;this.setState(c.State.Updating(a));const y=await this.cachePath;this.availableUpdate.updateFilePath=w.join(y,`CodeSetup-${this.productService.quality}-${a.version}.flag`),await C.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(o()))});const T=`${this.productService.win32MutexName}-ready`,N=await new Promise((G,ae)=>{z(["windows-mutex"],G,ae)});s(()=>N.isActive(T)).then(()=>this.setState(c.State.Ready(a)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const y=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!y};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:a},y?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};we([P.memoize],r.prototype,"cachePath",null),r=we([te(0,h.ILifecycleMainService),te(1,b.IConfigurationService),te(2,f.ITelemetryService),te(3,u.IEnvironmentMainService),te(4,m.IRequestService),te(5,p.ILogService),te(6,g.IFileService),te(7,d.INativeHostMainService),te(8,v.IProductService)],r),e.Win32UpdateService=r}),define(Z[269],ee([0,1,13,8,23,44,3,34,2,14,9,72,4,7,170,61,19,56,27,60,15,22,6,20,62,234,92,31,237,65,75,32,28,52,116,120,36,37,54,42]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s,i,o,r,l,a,y,M,T,N,G,ae,X,Q,ie,oe,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(V||(V={}));let q=class Wt extends w.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,W,U,J,B,$,L,O,_,H,Y,se,j,re,ne,ce,ge,Re,Te){super(),this.logService=W,this.environmentMainService=U,this.policyService=J,this.userDataProfilesService=B,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=H,this.workspacesManagementMainService=Y,this.backupMainService=se,this.telemetryService=j,this.dialogMainService=re,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=Re,this.stateMainService=Te,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Ae]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const ve=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window");let Se=!1;typeof pe?.experimental?.useSandbox=="boolean"?Se=pe.experimental.useSandbox:Se=typeof oe.default.quality=="string"&&oe.default.quality!=="stable";const ke={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!ve,title:this.productService.nameLong,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(pe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...Se?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?ke.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(ke.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(ke.fullscreenable=!1),b.isMacintosh&&(ke.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(ke.acceptFirstMouse=!1));const x=b.isMacintosh&&pe?.nativeTabs===!0;x&&(ke.tabbingIdentifier=this.productService.nameShort);const ue=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ke.titleBarStyle="hidden",b.isMacintosh||(ke.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const de=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=X.Color.fromHex(de).isDarker()?"#FFFFFF":"#000000";ke.titleBarOverlay={height:29,color:de,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,C.mark)("code/willCreateCodeBrowserWindow"),this._win=new I.BrowserWindow(ke),(0,C.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,b.isMacintosh&&ue&&this._win.setSheetOffset(22),ue&&(b.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||b.isMacintosh)){const de=this.stateMainService.getItem(Wt.windowControlHeightStateStorageKey);de&&this.updateWindowControls({height:de})}b.isWindows&&ue&&this._win.hookWindowMessage(278,()=>{const[ye,Ce]=this._win.getPosition(),Fe=I.screen.getCursorScreenPoint(),Oe=Fe.x-ye,$e=Fe.y-Ce;return(()=>!(Oe>30&&$e>=0&&$e<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:$e})),0}),(b.isMacintosh||b.isWindows)&&Ae&&(!x||I.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ve&&((0,C.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,C.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){b.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){b.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){b.isMacintosh&&A?.force&&I.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){U.dispose(),J.dispose(),A()}const U=this.onDidClose(()=>W()),J=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,U)=>this.onWindowError(2,U)),this._win.webContents.on("did-fail-load",(W,U,J)=>this.onWindowError(3,{reason:J,exitCode:U})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),I.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),I.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,U)=>{const J=await this.getMarketplaceHeaders();U({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,J)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,g.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,g.localize)(2,null))],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,g.localize)(5,null):void 0},this._win);if(U.response!==1){const J=U.response===0;await this.destroyWindow(J,U.checkboxChecked)}}else if(A===2){let U;W?U=(0,g.localize)(7,null,W.reason,W.exitCode??"<unknown>"):U=(0,g.localize)(6,null);const J=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,g.localize)(8,null)),(0,P.mnemonicButtonLabel)((0,g.localize)(9,null))],message:U,detail:(0,g.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,g.localize)(11,null):void 0},this._win),B=J.response===0;await this.destroyWindow(B,J.checkboxChecked)}break}}async destroyWindow(A,W){const U=this._config?.workspace;if(W&&U)try{const J=this.storageMainService.workspaceStorage(U);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.logService.error(J)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let J,B;(0,N.isSingleFolderWorkspaceIdentifier)(U)?J={folderUri:U.uri}:(0,N.isWorkspaceIdentifier)(U)?J={workspaceUri:U.configPath}:B=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const J=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||J!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=J;const B=U||"",$=J?`${J},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(A){b.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(S.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:U?2:1})}updateConfiguration(A,W){const U=(this._config??this.pendingLoadConfig)?.userEnv;if(U){const J=(0,m.isLaunchedFromCli)(U)&&!(0,m.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(J||B)&&(A.userEnv={...U,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,C.mark)("code/willOpenNewWindow"),A.perfMarks=(0,C.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.continueOn=this.environmentMainService.continueOn,W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,N.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===S.Schemas.file&&!await this.fileService.exists(W))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===S.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,ae.defaultWindowState)();if(this.isFullScreen){let U;try{U=I.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,ae.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||J.width,height:this.windowState.height||J.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!b.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let U;W===1?U=this.getBounds():U=this._win.getNormalBounds(),A.x=U.x,A.y=U.y,A.width=U.width,A.height=U.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Wt.windowControlHeightStateStorageKey,A.height),b.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):b.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,C.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const U=I.screen.getAllDisplays();W=U.length>1,A=this.validateWindowState(A,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,C.mark)("code/didRestoreCodeWindowState"),[A||(0,ae.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let $=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),$()}return A}if(A.display&&A.mode===3){const B=W.find($=>$.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,ae.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let U,J;try{U=I.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),J=this.getWorkingArea(U)}catch{}if(U&&J&&A.x+A.width>J.x&&A.y+A.height>J.y&&A.x<J.x+J.width&&A.y<J.y+J.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",J),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[U,J]=this._win.getSize();return{x:A,y:W,width:U,height:J}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){b.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){b.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,g.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...U){this.isReady?this.send(A,...U):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...U)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(U){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(U)}`)}}}updateTouchBar(A){!b.isMacintosh||this.touchBarGroups.forEach((W,U)=>{const J=A[U];W.segments=this.createTouchBarGroupSegments(J)})}createTouchBar(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new I.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),U=new I.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:U.segments[J].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(A=[]){return A.map(U=>{let J;U.icon&&!a.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===S.Schemas.file&&(J=I.nativeImage.createFromPath(u.URI.revive(U.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let B;return typeof U.title=="string"?B=U.title:B=U.title.value,{id:U.id,label:J?void 0:B,icon:J}})}dispose(){super.dispose(),this._win=null}};q.windowControlHeightStateStorageKey="windowControlHeight",q=we([te(1,n.ILogService),te(2,v.IEnvironmentMainService),te(3,Q.IPolicyService),te(4,he.IUserDataProfilesMainService),te(5,f.IFileService),te(6,r.IApplicationStorageMainService),te(7,r.IStorageMainService),te(8,p.IConfigurationService),te(9,y.IThemeMainService),te(10,G.IWorkspacesManagementMainService),te(11,h.IBackupMainService),te(12,l.ITelemetryService),te(13,d.IDialogMainService),te(14,c.ILifecycleMainService),te(15,s.IProductService),te(16,i.IProtocolMainService),te(17,T.IWindowsMainService),te(18,ie.IStateMainService)],q),e.CodeWindow=q}),define(Z[76],ee([0,1,13,24,8,3,34,2,14,4,18,7,21,173,5,22,6,92,93,28,52,39]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,g.createDecorator)("workspacesHistoryMainService");let n=class rt extends P.Disposable{constructor(i,o,r,l){super(),this.logService=i,this.workspacesManagementMainService=o,this.lifecycleMainService=r,this.applicationStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let o=[],r=[];for(const a of i)if((0,v.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&!this.containsWorkspace(o,a.workspace)&&o.push(a);else if((0,v.isRecentFolder)(a))this.containsFolder(o,a.folderUri)||o.push(a);else{const y=this.containsFile(r,a.fileUri),M=a.fileUri.scheme===w.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,E.basename)(a.fileUri))>=0;!y&&!M&&(r.push(a),S.isWindows&&a.fileUri.scheme===w.Schemas.file&&I.app.addRecentDocument(a.fileUri.fsPath))}const l=await this.mergeEntriesFromStorage({workspaces:o,files:r});o=l.workspaces,r=l.files,o.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(o.length=rt.MAX_TOTAL_RECENT_ENTRIES),r.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:o,files:r}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const o=y=>{const M=this.location(y);for(const T of i)if(E.extUriBiasedIgnorePathCase.isEqual(T,M))return!1;return!0},r=await this.getRecentlyOpened(),l=r.workspaces.filter(o),a=r.files.filter(o);(l.length!==r.workspaces.length||a.length!==r.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:l}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const o=new c.ResourceMap(a=>E.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.workspaces)for(const a of i.workspaces)o.set(this.location(a),a);const r=new c.ResourceMap(a=>E.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.files)for(const a of i.files)r.set(this.location(a),a);const l=await this.getRecentlyOpenedFromStorage();for(const a of l.workspaces){const y=o.get(this.location(a));y?y.label=y.label??a.label:o.set(this.location(a),a)}for(const a of l.files){const y=r.get(this.location(a));y?y.label=y.label??a.label:r.set(this.location(a),a)}return{workspaces:[...o.values()],files:[...r.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const o=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof o=="string")try{i=JSON.parse(o)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,v.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(i)),-1,1)}location(i){return(0,v.isRecentFolder)(i)?i.folderUri:(0,v.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,o){return!!i.find(r=>(0,v.isRecentWorkspace)(r)&&r.workspace.id===o.id)}containsFolder(i,o){return!!i.find(r=>(0,v.isRecentFolder)(r)&&E.extUriBiasedIgnorePathCase.isEqual(r.folderUri,o))}containsFile(i,o){return!!i.find(r=>E.extUriBiasedIgnorePathCase.isEqual(r.fileUri,o))}async handleWindowsJumpList(){!S.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!S.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const a of I.app.getJumpListSettings().removedItems){const y=a.args;if(y){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);M&&o.push(C.URI.parse(M[2]))}}await this.removeRecentlyOpened(o);let r=!1;const l=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const y=(0,v.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:M,description:T}=this.getWindowsJumpListLabel(y,a.label);let N;return C.URI.isUri(y)?N=`--folder-uri "${y.toString()}"`:(r=!0,N=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:T.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:r?(0,u.localize)(2,null):(0,u.localize)(3,null),items:l})}i.push({type:"recent"});try{const o=I.app.setJumpList(i);o&&o!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.logService.warn("updateWindowsJumpList#setJumpList",o)}}getWindowsJumpListLabel(i,o){if(o)return{title:(0,D.splitName)(o).name,description:o};if(C.URI.isUri(i))return{title:(0,E.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,u.localize)(4,null),description:""};let r=(0,E.basename)(i.configPath);return r.endsWith(m.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-m.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,r),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!S.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),o=[];let r=0;for(let a=0;a<i.workspaces.length&&r<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const y=this.location(i.workspaces[a]);if(y.scheme===w.Schemas.file){const M=(0,E.originalFSPath)(y);await b.Promises.exists(M)&&(o.push(M),r++)}}const l=[];for(let a=0;a<i.files.length&&r<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const y=this.location(i.files[a]);if(y.scheme===w.Schemas.file){const M=(0,E.originalFSPath)(y);if(rt.COMMON_FILES_FILTER.includes((0,E.basename)(y))||o.includes(M))continue;await b.Promises.exists(M)&&(l.push(M),r++)}}l.reverse().forEach(a=>I.app.addRecentDocument(a)),o.reverse().forEach(a=>I.app.addRecentDocument(a))}};n.MAX_TOTAL_RECENT_ENTRIES=500,n.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",n.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,n.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,n.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,n.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],n=we([te(0,p.ILogService),te(1,f.IWorkspacesManagementMainService),te(2,h.ILifecycleMainService),te(3,d.IApplicationStorageMainService)],n),e.WorkspacesHistoryMainService=n}),define(Z[270],ee([0,1,13,8,23,34,4,7,163,19,27,22,6,210,66,20,37,31,48,75,32,76]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let s=class Ft{constructor(r,l,a,y,M,T,N,G,ae,X,Q){this.updateService=r,this.configurationService=l,this.windowsMainService=a,this.environmentMainService=y,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=N,this.lifecycleMainService=G,this.logService=ae,this.nativeHostMainService=X,this.productService=Q,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,m.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(Ft.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,N,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,N,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,N,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,N,G)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,N,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const l=this.productService.requestFeatureUrl;l&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(l,"openUserVoiceUrl"));const a=this.productService.reportIssueUrl;a&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(a,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,l){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(Ft.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!D.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!I.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=I.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){I.Menu.setApplicationMenu(D.isMacintosh?new I.Menu:null);return}const l=new I.Menu;let a;if(D.isMacintosh){const M=new I.Menu;a=new I.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),l.append(a)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new I.Menu;M.append(new I.MenuItem({label:this.mnemonicLabel(w.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),I.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(1,null)),submenu:M});this.setMenuById(M,"File"),l.append(T)}if(this.shouldDrawMenu("Edit")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),l.append(T)}if(this.shouldDrawMenu("Selection")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),l.append(T)}if(this.shouldDrawMenu("View")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(4,null)),submenu:M});this.setMenuById(M,"View"),l.append(T)}if(this.shouldDrawMenu("Go")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),l.append(T)}if(this.shouldDrawMenu("Run")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),l.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),l.append(T)}let y;if(this.shouldDrawMenu("Window")){const M=new I.Menu;y=new I.MenuItem({label:this.mnemonicLabel(w.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(y&&l.append(y),this.shouldDrawMenu("Help")){const M=new I.Menu,T=new I.MenuItem({label:this.mnemonicLabel(w.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),l.append(T)}l.items&&l.items.length>0?I.Menu.setApplicationMenu(l):I.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const l=this.createMenuItem(w.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),a=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const ie=new I.Menu;this.setMenuById(ie,"Preferences"),y=new I.MenuItem({label:this.mnemonicLabel(w.localize(11,null)),submenu:ie})}const M=new I.Menu,T=new I.MenuItem({label:w.localize(12,null),role:"services",submenu:M}),N=new I.MenuItem({label:w.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new I.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new I.MenuItem({label:w.localize(15,null),role:"unhide"}),X=new I.MenuItem(this.likeAction("workbench.action.quit",{label:w.localize(16,null,this.productService.nameLong),click:async(ie,oe,he)=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),Q=[l];Q.push(...a),y&&Q.push(i(),y),Q.push(i(),T,i(),N,G,ae,i(),X),Q.forEach(ie=>r.append(ie))}async confirmBeforeQuit(r){if(this.windowsMainService.getWindowCount()===0)return!0;const l=this.configurationService.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.isKeyboardEvent(r)){const a={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(w.localize(17,null)),(0,R.mnemonicButtonLabel)(w.localize(18,null))],message:w.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:y}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,a);return y===0}return!0}shouldDrawMenu(r){if(!D.isMacintosh&&(0,m.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,l){l.forEach(a=>{if((0,u.isMenubarMenuItemSeparator)(a))r.append(i());else if((0,u.isMenubarMenuItemSubmenu)(a)){const y=new I.Menu,M=new I.MenuItem({label:this.mnemonicLabel(a.label),submenu:y});this.setMenu(y,a.submenu.items),r.append(M)}else(0,u.isMenubarMenuItemRecentAction)(a)?r.append(this.createOpenRecentMenuItem(a)):(0,u.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[a.id]?r.append(new I.MenuItem(this.likeAction(a.id,{label:this.mnemonicLabel(a.label),click:this.fallbackMenuHandlers[a.id]}))):r.append(this.createMenuItem(a.label,a.id,!1,a.checked)):r.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)):r.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)))})}setMenuById(r,l){this.menubarMenus&&this.menubarMenus[l]&&this.setMenu(r,this.menubarMenus[l].items)}insertCheckForUpdatesItems(r){const l=this.getUpdateMenuItems();l.length&&(l.forEach(a=>r.append(a)),r.append(i()))}createOpenRecentMenuItem(r){const l=P.URI.revive(r.uri),a=r.id,y=a==="openRecentFile"?{fileUri:l}:a==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new I.MenuItem(this.likeAction(a,{label:r.label,click:async(M,T,N)=>{const G=this.isOptionClick(N);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([l])}},!1))}isOptionClick(r){return!!(r&&(!D.isMacintosh&&(r.ctrlKey||r.shiftKey)||D.isMacintosh&&(r.metaKey||r.altKey)))}isKeyboardEvent(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}createRoleMenuItem(r,l,a){const y={label:this.mnemonicLabel(r),role:a,enabled:!0};return new I.MenuItem(this.withKeybinding(l,y))}setMacWindowMenu(r){const l=new I.MenuItem({label:w.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),a=new I.MenuItem({label:w.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new I.MenuItem({label:w.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(w.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(w.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(w.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(w.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(w.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(w.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,a,i(),M,...T,i(),y].forEach(N=>r.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.mnemonicLabel(w.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:w.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.mnemonicLabel(w.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:w.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.mnemonicLabel(w.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new I.MenuItem({label:w.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.mnemonicLabel(w.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,l,a,y){const M=this.mnemonicLabel(r),T=typeof l=="function"?l:(Q,ie,oe)=>{const he=Q?Q.userSettingsLabel:null;let V=l;Array.isArray(l)&&(V=this.isOptionClick(oe)?l[1]:l[0]),he&&oe.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:V})},N=typeof a=="boolean"?a:this.windowsMainService.getWindowCount()>0,G=typeof y=="boolean"?y:!1,ae={label:M,click:T,enabled:N};G&&(ae.type="checkbox",ae.checked=G);let X;return typeof l=="string"?X=l:Array.isArray(l)&&(X=l[0]),D.isMacintosh&&(X==="editor.action.clipboardCutAction"?ae.role="cut":X==="editor.action.clipboardCopyAction"?ae.role="copy":X==="editor.action.clipboardPasteAction"&&(ae.role="paste"),X==="undo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:Q=>Q.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:Q=>Q.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(ae.click=this.makeContextAwareClickHandler(T,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.withKeybinding(X,ae))}makeContextAwareClickHandler(r,l){return(a,y,M)=>{const T=I.BrowserWindow.getFocusedWindow();if(!T)return l.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return l.inDevTools(T.webContents.devToolsWebContents);r(a,y||T,M)}}runActionInRenderer(r){let l=I.BrowserWindow.getFocusedWindow();if(!l){const y=this.windowsMainService.getLastActiveWindow();y?.isMinimized()&&(l=y.win)}const a=l?this.windowsMainService.getWindowById(l.id):void 0;if(a){if(this.logService.trace("menubar#runActionInRenderer",r),D.isMacintosh&&!this.environmentMainService.isBuilt&&!a.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const y={id:r.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",k.CancellationToken.None,y)}else{const y={userSettingsLabel:r.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,l){const a=typeof r=="string"?this.keybindings[r]:void 0;if(a?.label){if(a.isNative!==!1)l.accelerator=a.label,l.userSettingsLabel=a.userSettingsLabel;else if(typeof l.label=="string"){const y=l.label.indexOf("[");y>=0?l.label=`${l.label.substr(0,y)} [${a.label}]`:l.label=`${l.label} [${a.label}]`}}else l.accelerator=void 0;return l}likeAction(r,l,a=!l.accelerator){a&&(l=this.withKeybinding(r,l));const y=l.click;return l.click=(M,T,N)=>{this.reportMenuActionTelemetry(r),y?.(M,T,N)},l}openUrl(r,l){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(l)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:n})}mnemonicLabel(r){return(0,R.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=we([te(0,v.IUpdateService),te(1,S.IConfigurationService),te(2,f.IWindowsMainService),te(3,E.IEnvironmentMainService),te(4,d.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,p.IStateMainService),te(7,C.ILifecycleMainService),te(8,b.ILogService),te(9,g.INativeHostMainService),te(10,h.IProductService)],s),e.Menubar=s;function i(){return new I.MenuItem({type:"separator"})}}),define(Z[271],ee([0,1,5,22,6,270]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let D=class{constructor(w,S,E){this.instantiationService=w,this.lifecycleMainService=S,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(w,S){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(S,w)}};D=we([te(0,I.IInstantiationService),te(1,t.ILifecycleMainService),te(2,k.ILogService)],D),e.MenubarMainService=D}),define(Z[272],ee([0,1,13,21,25,24,23,3,30,49,34,2,14,9,72,4,33,18,12,7,171,61,19,56,27,15,5,22,6,54,20,62,64,37,75,269,117,264,28,94,76,52,65,36,42]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s,i,o,r,l,a,y,M,T,N,G,ae,X,Q,ie,oe,he,V,q,F,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U($){return(0,oe.isWorkspaceIdentifier)($?.workspace)}function J($){return(0,oe.isSingleFolderWorkspaceIdentifier)($?.workspace)}let B=class ft extends C.Disposable{constructor(L,O,_,H,Y,se,j,re,ne,ce,ge,Re,Te,Me,Ae,ve,pe,Se){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=H,this.policyService=Y,this.environmentMainService=se,this.userDataProfilesMainService=j,this.lifecycleMainService=re,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Re,this.instantiationService=Te,this.dialogMainService=Me,this.fileService=Ae,this.productService=ve,this.protocolMainService=pe,this.themeMainService=Se,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new P.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new C.DisposableStore;if(O.add(P.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,H=O?.remoteAuthority||void 0,Y=!0,se=O?.forceReuseWindow,j=!se;return this.open({...L,cli:_,forceEmpty:Y,forceNewWindow:j,forceReuseWindow:se,remoteAuthority:H})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],H=[],Y=[],se=[];let j,re=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const Me of ne)J(Me)?L.addMode?O.push(Me):_.push(Me):U(Me)?H.push(Me):Me.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),j.filesToOpenOrCreate.push(Me)):Me.backupPath?se.push({backupFolder:(0,u.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):re++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),H.push(...Y),se.push(...this.backupMainService.getEmptyWindowBackups())):se.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,H,_,se,re,j,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${_.length}, emptyToRestore: ${se.length}, emptyToOpen: ${re})`),ce.length>1)if(ge)ge.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,ve=!0;if(Me){const pe=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Ae=!1,ve=!1)}if(Ae)for(let pe=ce.length-1;pe>=0;pe--){const Se=ce[pe];if(!(Se.openedWorkspace&&Y.some(ke=>Se.openedWorkspace&&ke.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&se.some(ke=>Se.backupPath&&ke.backupFolder===(0,u.basename)(Se.backupPath)))){Se.focus(),ve=!1;break}}ve&&ce[ce.length-1].focus()}const Re=j&&j.filesToDiff.length>0,Te=j&&j.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!Re&&!Te&&!L.noRecentEntry){const Me=[];for(const Ae of ne)U(Ae)&&!Ae.transient?Me.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):J(Ae)?Me.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Me.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(L,O,_,H,Y,se,j){const re=[];let ne;function ce(pe,Se){re.push(pe),Se&&(ne=pe,se=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Re}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&j.length>0){const pe=j[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(pe);Se&&ce(this.doAddFoldersToExistingWindow(Se,j.map(ke=>ke.workspace.uri)))}const Te=_.length+O.length+H.length;if(se&&Te===0){const pe=se.filesToOpenOrCreate[0]||se.filesToDiff[0]||se.filesToMerge[3],Se=this.getWindows().filter(x=>se&&(0,d.isEqualAuthority)(x.remoteAuthority,se.remoteAuthority));let ke;pe?.fileUri&&!Re&&((L.context===4||L.context===0||L.context===1)&&(ke=await(0,Q.findWindowOnFile)(Se,pe.fileUri,async x=>x.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(x.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(Se))),ke?(0,oe.isWorkspaceIdentifier)(ke.openedWorkspace)?O.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?_.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,ke,se),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:se,forceNewWindow:!0,remoteAuthority:se.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const Me=(0,R.distinct)(O,pe=>pe.workspace.id);if(Me.length>0){const pe=(0,R.coalesce)(Me.map(Se=>(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(pe.length>0){const Se=pe[0],ke=(0,d.isEqualAuthority)(se?.remoteAuthority,Se.remoteAuthority)?se:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Me){if(pe.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===Se.workspace.id))continue;const ke=Se.remoteAuthority,x=(0,d.isEqualAuthority)(se?.remoteAuthority,ke)?se:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,x),!!x),ge=!0}}const Ae=(0,R.distinct)(_,pe=>d.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Ae.length>0){const pe=(0,R.coalesce)(Ae.map(Se=>(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(pe.length>0){const Se=pe[0],ke=(0,d.isEqualAuthority)(se?.remoteAuthority,Se.remoteAuthority)?se:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Ae){if(pe.some(ue=>(0,oe.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,Se.workspace.uri)))continue;const ke=Se.remoteAuthority,x=(0,d.isEqualAuthority)(se?.remoteAuthority,ke)?se:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,x),!!x),ge=!0}}const ve=(0,R.distinct)(H,pe=>pe.backupFolder);if(ve.length>0)for(const pe of ve){const Se=pe.remoteAuthority,ke=(0,d.isEqualAuthority)(se?.remoteAuthority,Se)?se:void 0;ce(this.doOpenEmpty(L,!0,Se,ke,pe),!!ke),ge=!0}if(re.length===0||se){se&&!Y&&Y++;const pe=se?se.remoteAuthority:L.remoteAuthority;for(let Se=0;Se<Y;Se++)ce(this.doOpenEmpty(L,ge,pe,se),!!se),ge=!0}return{windows:(0,R.distinct)(re),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const H={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,H),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,_),L}doOpenEmpty(L,O,_,H,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:H,forceNewWindow:O});let se;return!O&&typeof L.contextWindowId=="number"&&(se=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:se,emptyWindowBackupInfo:Y,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,H,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:H}),!_&&!Y&&typeof L.contextWindowId=="number"&&(Y=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:H,windowToUse:Y,profile:L.profile})}async getPathsToOpen(L){let O,_=!1,H=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),H=!0),!L.addMode&&_){const Y=O.filter(se=>J(se));if(Y.length>1){const se=Y[0].remoteAuthority;if(Y.every(j=>(0,d.isEqualAuthority)(j.remoteAuthority,se))){const j=await this.workspacesManagementMainService.createUntitledWorkspace(Y.map(re=>({uri:re.workspace.uri})));O.push({workspace:j,remoteAuthority:se}),O=O.filter(re=>!J(re))}}}if(L.initialStartup&&!H&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Y=await this.doGetPathsFromLastSession();O.unshift(...Y.filter(se=>U(se)||J(se)||se.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},_=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async H=>{const Y=await this.resolveOpenable(H,O);if(Y)return Y.label=H.label,Y;const se=this.resourceFromOpenable(H),j={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:se.scheme===b.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:se.scheme===b.Schemas.file?(0,f.localize)(3,null,(0,E.getPathLabel)(se,{os:h.OS,tildify:this.environmentMainService})):(0,f.localize)(4,null,se.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(j,(0,v.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},H=L["folder-uri"];if(H){const j=await Promise.all(H.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable({folderUri:ne},_)}));O.push(...(0,R.coalesce)(j))}const Y=L["file-uri"];if(Y){const j=await Promise.all(Y.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable((0,oe.hasWorkspaceFileExtension)(re)?{workspaceUri:ne}:{fileUri:ne},_)}));O.push(...(0,R.coalesce)(j))}const se=await Promise.all(L._.map(j=>_.remoteAuthority?this.doResolveRemotePath(j,_):this.doResolveFilePath(j,_)));return O.push(...(0,R.coalesce)(se)),O}cliArgToUri(L){try{const O=m.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(O.map(async H=>{if(H.workspace){const Y=await this.resolveOpenable({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(U(Y))return Y}else if(H.folderUri){const Y=await this.resolveOpenable({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(J(Y))return Y}else if(L!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===b.Schemas.file?((0,ae.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const H=(0,N.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,d.removeTrailingPathSeparator)((0,d.normalizePath)(_)),(0,ae.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Y,line:se,column:j}=(0,w.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Y}),options:{selection:se?{startLineNumber:se,startColumn:j||1}:void 0},remoteAuthority:H}}return{fileUri:_,remoteAuthority:H}}else if((0,ae.isWorkspaceToOpen)(L))return{workspace:(0,he.getWorkspaceIdentifier)(_),remoteAuthority:H};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:H}}resourceFromOpenable(L){return(0,ae.isWorkspaceToOpen)(L)?L.workspaceUri:(0,ae.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let _,H;O.gotoLineMode&&({path:L,line:_,column:H}=(0,w.parseLineAndColumnAware)(L)),L=(0,w.sanitizeFilePath)((0,u.normalize)(L),(0,p.cwd)());try{const Y=await t.Promises.stat(L);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const se=await this.workspacesManagementMainService.resolveLocalWorkspace(m.URI.file(L));if(se)return se.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:se.id,configPath:se.configPath},type:o.FileType.File,exists:!0,remoteAuthority:se.remoteAuthority,transient:se.transient}}return{fileUri:m.URI.file(L),type:o.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:H||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(m.URI.file(L),Y),type:o.FileType.Directory,exists:!0};if(!h.isWindows&&L==="/dev/null")return{fileUri:m.URI.file(L),type:o.FileType.File,exists:!0}}}catch{const se=m.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([se]),O.ignoreFileNotFound)return{fileUri:se,type:o.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const _=L.charCodeAt(0),H=O.remoteAuthority;let Y,se;O.gotoLineMode&&({path:L,line:Y,column:se}=(0,w.parseLineAndColumnAware)(L)),_!==47&&((0,w.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,w.toSlashes)(L)),L=`/${L}`);const j=m.URI.from({scheme:b.Schemas.vscodeRemote,authority:H,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,oe.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:Y?{startLineNumber:Y,startColumn:se||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)(j),remoteAuthority:H};if(O.gotoLineMode||u.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:Y?{startLineNumber:Y,startColumn:se||1}:void 0},remoteAuthority:H}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:H}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",H=O?.openFilesInNewWindow||"off";let Y=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let se=!1;return L.forceNewWindow||L.forceReuseWindow?se=!!L.forceNewWindow&&!L.forceReuseWindow:(h.isMacintosh?L.context===1&&(se=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(se=!0),!L.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&(se=H==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:se}}async openExtensionDevelopmentHostWindow(L,O){const _=(0,Q.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let H=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],se=O.cli._;if(!se.length&&!H.length&&!Y.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=ne?.workspace??ne?.folderUri;ce&&(m.URI.isUri(ce)?ce.scheme===b.Schemas.file?se=[ce.fsPath]:H=[ce.toString()]:ce.configPath.scheme===b.Schemas.file?se=[(0,d.originalFSPath)(ce.configPath)]:Y=[ce.configPath.toString()])}let j=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=m.URI.parse(ne),ge=(0,N.getRemoteAuthority)(ce);ge&&(j?(0,d.isEqualAuthority)(ge,j)||this.logService.error("more than one extension development path authority"):j=ge)}se=se.filter(ne=>{const ce=m.URI.file(ne);return(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,d.isEqualAuthority)((0,N.getRemoteAuthority)(ce),j)}),H=H.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,d.isEqualAuthority)((0,N.getRemoteAuthority)(ce),j):!1}),Y=Y.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,Q.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,d.isEqualAuthority)((0,N.getRemoteAuthority)(ce),j):!1}),O.cli._=se,O.cli["folder-uri"]=H,O.cli["file-uri"]=Y;const re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!se.length&&!H.length&&!Y.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:j,profile:O.profile};return this.open(re)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,u.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:y.default,isInitialStartup:L.initialStartup,perfMarks:(0,g.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let H;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(H=L.windowToUse||this.getLastActiveWindow(),H&&H.focus()),H){const Y=H.config;!_.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=Y.extensionDevelopmentPath,_.extensionDevelopmentKind=Y.extensionDevelopmentKind,_["enable-proposed-api"]=Y["enable-proposed-api"],_.verbose=Y.verbose,_["inspect-extensions"]=Y["inspect-extensions"],_["inspect-brk-extensions"]=Y["inspect-brk-extensions"],_.debugId=Y.debugId,_.extensionEnvironment=Y.extensionEnvironment,_["extensions-dir"]=Y["extensions-dir"],_["disable-extensions"]=Y["disable-extensions"])}else{const Y=this.windowsStateHandler.getNewWindowState(_);(0,g.mark)("code/willCreateCodeWindow");const se=H=this.instantiationService.createInstance(X.CodeWindow,{state:Y,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,g.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(se),ft.WINDOWS.push(se),this._onDidOpenWindow.fire(se),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,S.once)(se.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(se)),(0,S.once)(se.onDidClose)(()=>this.onWindowClosed(se)),(0,S.once)(se.onDidDestroy)(()=>this._onDidDestroyWindow.fire(se)),se.onDidTriggerSystemContextMenu(({x:re,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:se,x:re,y:ne}));const j=(0,v.assertIsDefined)(se.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(se)),this.lifecycleMainService.registerWindow(se)}return _.windowId=H.id,H.isReady?this.lifecycleMainService.unload(H,4).then(Y=>{Y||this.doOpenInBrowserWindow(H,_,L)}):this.doOpenInBrowserWindow(H,_,L),H}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,oe.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,oe.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=I.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,d.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,_){for(const H of this.getWindows())_&&_.indexOf(H.id)>=0||H.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=I.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=we([te(2,a.ILogService),te(3,G.IStateMainService),te(4,A.IPolicyService),te(5,i.IEnvironmentMainService),te(6,W.IUserDataProfilesMainService),te(7,l.ILifecycleMainService),te(8,c.IBackupMainService),te(9,n.IConfigurationService),te(10,V.IWorkspacesHistoryMainService),te(11,q.IWorkspacesManagementMainService),te(12,r.IInstantiationService),te(13,s.IDialogMainService),te(14,o.IFileService),te(15,M.IProductService),te(16,T.IProtocolMainService),te(17,F.IThemeMainService)],B),e.WindowsMainService=B}),define(Z[273],ee([0,1,61,32,76,52]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(w,S,E,C){this.workspacesManagementMainService=w,this.windowsMainService=S,this.workspacesHistoryMainService=E,this.backupMainService=C,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,S){const E=this.windowsMainService.getWindowById(w);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),S)}createUntitledWorkspace(w,S,E){return this.workspacesManagementMainService.createUntitledWorkspace(S,E)}deleteUntitledWorkspace(w,S){return this.workspacesManagementMainService.deleteUntitledWorkspace(S)}getWorkspaceIdentifier(w,S){return this.workspacesManagementMainService.getWorkspaceIdentifier(S)}getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(w,S){return this.workspacesHistoryMainService.addRecentlyOpened(S)}removeRecentlyOpened(w,S){return this.workspacesHistoryMainService.removeRecentlyOpened(S)}clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=we([te(0,R.IWorkspacesManagementMainService),te(1,t.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,I.IBackupMainService)],D),e.WorkspacesMainService=D}),define(Z[274],ee([0,1,13,41,25,17,44,16,30,49,43,34,2,14,9,4,12,7,29,82,130,46,144,103,249,147,61,265,19,70,180,85,118,56,106,178,27,60,112,192,213,193,251,107,194,195,15,205,87,69,5,86,266,227,261,22,6,207,271,66,20,64,257,88,37,254,92,113,31,233,235,74,48,240,241,267,242,268,115,244,245,246,247,252,32,272,253,28,93,76,273,52,250,36,212,42,260,223,55,73,90,255,262,263,8]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s,i,o,r,l,a,y,M,T,N,G,ae,X,Q,ie,oe,he,V,q,F,A,W,U,J,B,$,L,O,_,H,Y,se,j,re,ne,ce,ge,Re,Te,Me,Ae,ve,pe,Se,ke,x,ue,de,ye,Ce,Fe,Oe,$e,Ne,je,Qe,Be,Ge,K,le,fe,me,Ee,Le,Ue,it,Je,He,et,nt,lt,gt,St,Bt,zt,$t,_t,jt,qt,Ht,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends b.Disposable{constructor(be,Pe,De,Ie,We,ze,Ze,tt,_e,Ve,Ke){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=De,this.logService=Ie,this.environmentMainService=We,this.lifecycleMainService=ze,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const be=_e=>_e?.startsWith(`${u.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((_e,Ve,Ke,xe)=>be(xe.requestingUrl)?Ke(Pe.has(Ve)):Ke(!1)),I.session.defaultSession.setPermissionCheckHandler((_e,Ve,Ke,xe)=>be(xe.requestingUrl)?Pe.has(Ve):!1);const De=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ve=_e;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},We=_e=>_e.resourceType==="xhr"||Ie(_e.frame),ze=_e=>{const Ve=_e.frame;if(!Ve||!this.windowsMainService)return!1;const Ke=I.BrowserWindow.getAllWindows();for(const xe of Ke)if(Ve.processId===xe.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ve)=>{if(_e.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.windowsMainService)return!1;for(const xe of this.windowsMainService.getWindows())if(xe.win&&Ke.processId===xe.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((_e,Ve)=>{const Ke=d.URI.parse(_e.url);return Ke.scheme===u.Schemas.vscodeWebview&&!Ze(Ke,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ve({cancel:!0})):Ke.scheme===u.Schemas.vscodeFileResource&&!ze(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!De.has(Ke.scheme)?Ve({cancel:!We(_e)}):Ve({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((_e,Ve)=>{const Ke=_e.responseHeaders,xe=Ke["content-type"]||Ke["Content-Type"];if(xe&&Array.isArray(xe)){const ot=d.URI.parse(_e.url);if(ot.path.endsWith(".svg")&&De.has(ot.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!ot.path.endsWith(u.Schemas.vscodeRemoteResource)&&xe.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!We(_e)})}return Ve({cancel:!1})});const tt=I.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,g.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(De=>this.onUnexpectedError(De)),process.on("uncaughtException",De=>(0,P.onUnexpectedError)(De)),process.on("unhandledRejection",De=>(0,P.onUnexpectedError)(De)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(De,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),I.app.on("activate",async(De,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(De,Ie)=>{Ie.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Ie.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let be=[],Pe;I.app.on("open-file",(De,Ie)=>{this.logService.trace("app#open-file: ",Ie),De.preventDefault(),be.push((0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:d.URI.file(Ie)}:{fileUri:d.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",De=>{const Ie=this.windowsMainService?.getWindowByWebContents(De.sender);let We,ze;return Ie?.config?(We=Ie.config,ze={...process.env,...Ie.config.userEnv}):(We=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(We,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(De,Ie,We)=>{const ze=this.validateNlsPath([Ie]);if(!ze||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,R.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(De,...Ie)=>{const We=this.validateNlsPath(Ie);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",De=>De.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",De=>De.sender.reload())}validateNlsPath(be){let Pe;for(const De of be)typeof De=="string"&&(typeof Pe!="string"?Pe=De:Pe=(0,g.join)(Pe,De));if(!(typeof Pe!="string"||!(0,g.isAbsolute)(Pe)||!(0,w.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return d.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;h.isWindows&&be&&I.app.setAppUserModelId(be);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new n.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const De=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${De}`);const{sharedProcess:Ie,sharedProcessReady:We,sharedProcessClient:ze}=this.setupSharedProcess(De),Ze=await this.initServices(De,Ie,We);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,ze)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(i.ProxyAuthHandler)),this._register(be.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(Ht.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(x.machineIdKey);return(!be||h.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,m.getMachineId)(),this.stateMainService.setItem(x.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,be,this.userEnv)),De=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(We,"main")})(),Ie=(async()=>(await Pe.whenReady(),De))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:De}}async initServices(be,Pe,De){const Ie=new _.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(je.Win32UpdateService));break;case"linux":h.isLinuxSnap?Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ce.IUpdateService,new L.SyncDescriptor($e.LinuxUpdateService));break;case"darwin":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ie.set(me.IWindowsMainService,new L.SyncDescriptor(Ee.WindowsMainService,[be,this.userEnv],!1));const We=new G.DialogMainService(this.logService);Ie.set(G.IDialogMainService,We),Ie.set(se.ILaunchMainService,new L.SyncDescriptor(se.LaunchMainService,void 0,!1)),Ie.set(N.IDiagnosticsMainService,new L.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),Ie.set(T.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(De.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(H.IIssueMainService,new L.SyncDescriptor(H.IssueMainService,[this.userEnv])),Ie.set(ae.IEncryptionMainService,new L.SyncDescriptor(X.EncryptionMainService,[be])),Ie.set(Y.IKeyboardLayoutMainService,new L.SyncDescriptor(Y.KeyboardLayoutMainService)),Ie.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ie.set(y.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ie.set(le.IWebviewManagerService,new L.SyncDescriptor(fe.WebviewMainService)),Ie.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ie.set(he.IExtensionUrlTrustService,new L.SyncDescriptor(V.ExtensionUrlTrustService)),Ie.set(q.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(Se.IStorageMainService,new L.SyncDescriptor(Se.StorageMainService)),Ie.set(Se.IApplicationStorageMainService,new L.SyncDescriptor(Se.ApplicationStorageMainService)),h.isWindows?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.WindowsExternalTerminalService)):h.isMacintosh?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.MacExternalTerminalService)):h.isLinux&&Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(W.LinuxExternalTerminalService));const ze=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(r.IBackupMainService,ze);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,ze,We,this.productService);if(Ie.set(et.IWorkspacesManagementMainService,Ze),Ie.set(it.IWorkspacesService,new L.SyncDescriptor(He.WorkspacesMainService,void 0,!1)),Ie.set(Je.IWorkspacesHistoryMainService,new L.SyncDescriptor(Je.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Qe.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,c.getDelayedChannel)(De.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new ue.TelemetryAppenderClient(_e),Ke=(0,ke.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),xe=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Ke,piiPaths:xe,sendErrorTelemetry:!0};Ie.set(x.ITelemetryService,new L.SyncDescriptor(de.TelemetryService,[ot],!1))}else Ie.set(x.ITelemetryService,ye.NullTelemetryService);return Ie.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ie.set(jt.IExtensionsScannerService,new L.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([ze.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(be,Pe,De){const Ie=c.ProxyChannel.fromService(be.get(se.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const We=c.ProxyChannel.fromService(be.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const ze=new gt.PolicyChannel(be.get(lt.IPolicyService));Pe.registerChannel("policy",ze),De.then(Ye=>Ye.registerChannel("policy",ze));const Ze=this.fileService.getProvider(u.Schemas.file);(0,p.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),De.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=c.ProxyChannel.fromService(be.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),De.then(Ye=>Ye.registerChannel("userDataProfiles",_e));const Ve=new zt.RequestChannel(be.get($t.IRequestService));De.then(Ye=>Ye.registerChannel("request",Ve));const Ke=new Fe.UpdateChannel(be.get(Ce.IUpdateService));Pe.registerChannel("update",Ke);const xe=c.ProxyChannel.fromService(be.get(H.IIssueMainService));Pe.registerChannel("issue",xe);const ot=c.ProxyChannel.fromService(be.get(ae.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=c.ProxyChannel.fromService(be.get(y.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=c.ProxyChannel.fromService(be.get(Ae.ISignService));Pe.registerChannel("sign",kt);const Xe=c.ProxyChannel.fromService(be.get(Y.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(ge.INativeHostMainService);const mt=c.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),De.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=c.ProxyChannel.fromService(be.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=c.ProxyChannel.fromService(be.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=c.ProxyChannel.fromService(be.get(Qe.IURLService));Pe.registerChannel("url",Mt);const Dt=c.ProxyChannel.fromService(be.get(he.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=c.ProxyChannel.fromService(be.get(le.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new pe.StorageDatabaseChannel(this.logService,be.get(Se.IStorageMainService)));Pe.registerChannel("storage",ut),De.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Vt.ProfileStorageChangesListenerChannel(be.get(Se.IStorageMainService),be.get(St.IUserDataProfilesMainService),this.logService));De.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=c.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const qe=new ne.LogLevelChannel(be.get(re.ILogService),be.get(re.ILoggerService));Pe.registerChannel("logLevel",qe),De.then(Ye=>Ye.registerChannel("logLevel",qe));const st=new ne.LoggerChannel(be.get(re.ILoggerService));Pe.registerChannel("logger",st),De.then(Ye=>Ye.registerChannel("logger",st));const dt=new M.ElectronExtensionHostDebugBroadcastChannel(be.get(me.IWindowsMainService),be.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",dt);const at=c.ProxyChannel.fromService(be.get(q.IExtensionHostStarter));Pe.registerChannel(q.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(be,Pe){const De=this.windowsMainService=be.get(me.IWindowsMainService),Ie=be.get(Qe.IURLService),We=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const ze=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(qe=>{try{return{uri:d.URI.parse(qe),url:qe}}catch{return}}).filter(qe=>{if(!qe||this.shouldBlockURI(qe.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(qe.uri);return st?(ze.push(st),!1):!0}),tt=this,_e=this.environmentMainService,Ve=this.productService,Ke=this.logService;Ie.registerHandler({async handleURL(qe,st){if(Ke.trace("app#handleURL: ",qe.toString(!0),st),qe.scheme===Ve.urlProtocol&&qe.path==="workspace"&&(qe=qe.with({authority:"file",path:d.URI.parse(qe.query).path,query:""})),tt.shouldBlockURI(qe))return!0;let dt=!1;const at=new URLSearchParams(qe.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),qe=qe.with({query:at.toString()}),dt=!0),dt||=h.isMacintosh&&De.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(_e.continueOn=Ye??void 0,at.delete("continueOn"),qe=qe.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(qe);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await De.open({context:5,cli:{..._e.args},urisToOpen:[Rt],forceNewWindow:dt,gotoLineMode:!0});return Lt.focus(),!0}if(dt){const[Lt]=await De.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Te.getRemoteAuthority)(qe)});return await Lt.ready(),Ie.open(qe,st)}return!1}});const xe=this._register(new Le.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),ot=new c.StaticRouter(qe=>xe.getActiveClientId().then(st=>qe===st)),ct=new Be.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ie.registerHandler(new Be.URLHandlerChannelClient(kt)),this._register(new K.ElectronURLListener(Ze,Ie,De,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,ie.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?d.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if(ze.length>0)return De.open({context:pt,cli:Xe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return De.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return De.open({context:1,cli:Xe,urisToOpen:mt.map(qe=>(0,Ue.hasWorkspaceFileExtension)(qe)?{workspaceUri:d.URI.file(qe)}:{fileUri:d.URI.file(qe)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return De.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(be){return!!(be.authority===u.Schemas.file&&h.isWindows&&I.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,C.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,C.getPathLabel)(be,{os:h.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===u.Schemas.file){const Pe=d.URI.file(be.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===u.Schemas.vscodeRemote){const Pe=be.path.indexOf(g.posix.sep,1);if(Pe!==-1){const De=be.path.substring(1,Pe),Ie=be.path.substring(Pe),We=d.URI.from({scheme:u.Schemas.vscodeRemote,authority:De,path:Ie,query:be.query,fragment:be.fragment});return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:We}:/:[\d]+$/.test(Ie)?{fileUri:We}:{folderUri:We}}}}}afterWindowOpen(be,Pe){const De=be.get(x.ITelemetryService),Ie=be.get(Ce.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(De,Pe),this.installMutex(),I.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(We,ze)=>{ze({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})}),(Ie instanceof je.Win32UpdateService||Ie instanceof $e.LinuxUpdateService||Ie instanceof Oe.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(h.isWindows&&be)try{const Pe=await new Promise((Ie,We)=>{z(["windows-mutex"],Ie,We)}),De=new Pe.Mutex(be);(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let De=!1;(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>De=!0),this._register(Pe.onDidError(({type:Ie,details:We})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(ze)),be.publicLog2("sharedprocesserror",{type:Ie,reason:We?.reason,code:We?.exitCode,visible:Pe.isVisible(),shuttingdown:De})}))}async resolveShellEnvironment(be,Pe,De){try{return await(0,oe.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ie){const We=(0,D.toErrorMessage)(Ie);De?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),De=JSON.parse((0,E.stripComments)(Pe)),We=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(De["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const ze=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${We},`);ze!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(ze))}}catch(be){this.logService.error(be)}}};Pt=we([te(2,O.IInstantiationService),te(3,re.ILogService),te(4,Q.IEnvironmentMainService),te(5,j.ILifecycleMainService),te(6,a.IConfigurationService),te(7,ve.IStateMainService),te(8,J.IFileService),te(9,Re.IProductService),te(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(Z[275],ee([0,1,36,8,282,2]),function(z,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends I.AbstractPolicyService{constructor(w){super(),this.productName=w,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(w){await this.throttler.queue(()=>new Promise((S,E)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,w,C=>{for(const b in C){const u=C[b];u===void 0?this.policies.delete(b):this.policies.set(b,u)}this._onDidChange.fire(Object.keys(C)),S()})}catch(C){E(C)}}))}}e.NativePolicyService=D}),define(Z[276],ee([0,1,225,8,17,16,2,12,19,35,112,6,224,283]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let g=class extends D.Disposable{constructor(p,d,v){super(),this.environmentService=d,this.logService=v,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,d){this.logService.trace("RequestService#request (node) - begin",p.url);const{proxyUrl:v,strictSSL:m}=this;let f;try{f=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",s))}const c={...process.env,...f},n=p.agent?p.agent:await(0,b.getProxyAgent)(p.url||"",c,{proxyUrl:v,strictSSL:m});p.agent=n,p.strictSSL=m,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization});try{const s=await this._request(p,d);return this.logService.trace("RequestService#request (node) - success",p.url),s}catch(s){throw this.logService.trace("RequestService#request (node) - error",p.url,s),s}}async getNodeRequest(p){return((0,I.parse)(p.url).protocol==="https:"?await new Promise((m,f)=>{z(["https"],m,f)}):await new Promise((m,f)=>{z(["http"],m,f)})).request}_request(p,d){return t.Promises.withAsyncBody(async(v,m)=>{const f=(0,I.parse)(p.url),c=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),n={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,P.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(n.auth=p.user+":"+p.password);const s=c(n,i=>{const o=(0,P.isNumber)(p.followRedirects)?p.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this._request({...p,url:i.headers.location,followRedirects:o-1},d).then(v,m);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,u.createGunzip)())),v({res:i,stream:(0,k.streamToBufferReadableStream)(r)})}});s.on("error",m),p.timeout&&s.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&s.write(p.data),s.end(),d.onCancellationRequested(()=>{s.abort(),m(new R.CancellationError)})})}async resolveProxy(p){}};g=we([te(0,w.IConfigurationService),te(1,S.INativeEnvironmentService),te(2,C.ILogService)],g),e.RequestService=g}),define(Z[277],ee([0,1,13,276]),function(z,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return I.net.request}class R extends t.RequestService{request(P,w){return super.request({...P||{},getRawRequest:k},w)}}e.RequestMainService=R}),define(Z[284],ee([0,1,13,40,7,24,8,44,16,30,49,34,14,9,72,4,33,26,21,46,84,274,10,19,218,231,27,60,184,15,203,87,69,200,86,22,206,6,209,54,20,62,256,114,238,55,277,88,226,37,230,74,65,42,36,275,211,2,51,243,38,239]),function(z,e,I,t,k,R,D,P,w,S,E,C,b,u,g,h,p,d,v,m,f,c,n,s,i,o,r,l,a,y,M,T,N,G,ae,X,Q,ie,oe,he,V,q,F,A,W,U,J,B,$,L,O,_,H,Y,se,j,re,ne,ce,ge,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Te{main(){try{this.startup()}catch(ve){console.error(ve.message),I.app.exit(1)}}async startup(){(0,w.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,pe,Se,ke,x,ue,de,ye]=this.createServices();try{try{await this.initServices(Se,ye,ke,x,de)}catch(Ce){throw this.handleStartupDataDirError(Se,de.nameLong,Ce),Ce}await ve.invokeFunction(async Ce=>{const Fe=Ce.get(ie.ILogService),Oe=Ce.get(X.ILifecycleMainService),$e=Ce.get(y.IFileService),Ne=Ce.get(ie.ILoggerService),je=await this.claimInstance(Fe,Se,Oe,ve,de,!0);return v.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(Qe=>{Fe.warn(`Error writing main lockfile: ${Qe.stack}`)}),ue.logger=Ne.createLogger(k.URI.file((0,u.join)(Se.logsPath,"main.log")),{name:"main"}),(0,E.once)(Oe.onWillShutdown)(Qe=>{$e.dispose(),ke.dispose(),Qe.join(v.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),ve.createInstance(c.CodeApplication,je,pe).startup()})}catch(Ce){ve.invokeFunction(this.quit,Ce)}}createServices(){const ve=new ae.ServiceCollection,pe=new ne.DisposableStore;process.once("exit",()=>pe.dispose());const Se={_serviceBrand:void 0,...he.default};ve.set(V.IProductService,Se);const ke=new r.EnvironmentMainService(this.resolveArgs(),Se),x=this.patchEnvironment(ke);ve.set(r.IEnvironmentMainService,ke);const ue=new Q.BufferLogService,de=pe.add(new ie.MultiplexLogService([new ie.ConsoleMainLogger((0,ie.getLogLevel)(ke)),ue]));ve.set(ie.ILogService,de);const ye=new M.FileService(de);ve.set(y.IFileService,ye);const Ce=new T.DiskFileSystemProvider(de);ye.registerProvider(b.Schemas.file,Ce);const Fe=new ge.UriIdentityService(ye);ve.set(ce.IUriIdentityService,Fe),ve.set(ie.ILoggerService,new oe.LoggerService(de));const Oe=new O.StateMainService(ke,de,ye);ve.set(L.IStateMainService,Oe);const $e=new Y.UserDataProfilesMainService(Oe,Fe,ke,ye,de);ve.set(Y.IUserDataProfilesMainService,$e);const Ne=h.isWindows&&Se.win32RegValueName?pe.add(new j.NativePolicyService(Se.win32RegValueName)):ke.policyFile?pe.add(new re.FilePolicyService(ke.policyFile,ye,de)):new se.NullPolicyService;ve.set(se.IPolicyService,Ne);const je=new i.ConfigurationService($e.defaultProfile.settingsResource,ye,Ne,de);return ve.set(s.IConfigurationService,je),ve.set(X.ILifecycleMainService,new N.SyncDescriptor(X.LifecycleMainService,void 0,!1)),ve.set(U.IRequestService,new N.SyncDescriptor(J.RequestMainService,void 0,!0)),ve.set(H.IThemeMainService,new N.SyncDescriptor(H.ThemeMainService)),ve.set(B.ISignService,new N.SyncDescriptor($.SignService,void 0,!1)),ve.set(A.ITunnelService,new N.SyncDescriptor(W.TunnelService)),ve.set(q.IProtocolMainService,new F.ProtocolMainService(ke,$e,de)),[new G.InstantiationService(ve,!0),x,ke,je,Oe,ue,Se,$e]}patchEnvironment(ve){const pe={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const ke=process.env[Se];typeof ke=="string"&&(pe[Se]=ke)}),Object.assign(process.env,pe),pe}async initServices(ve,pe,Se,ke,x){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,pe.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?v.Promises.mkdir(ue,{recursive:!0}):void 0)),ke.init(),Se.initialize()]),pe.setEnablement(x.quality!=="stable"||Se.getValue(Re.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ve,pe,Se,ke,x,ue){let de;try{(0,g.mark)("code/willStartMainServer"),de=await(0,f.serve)(pe.mainIPCHandle),(0,g.mark)("code/didStartMainServer"),(0,E.once)(Se.onWillShutdown)(()=>de.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,x.nameLong,ye),ye;let Ce;try{Ce=await(0,f.connect)(pe.mainIPCHandle,"main")}catch(Ne){if(!ue||h.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,x.nameShort),(0,n.localize)(1,null),x.nameLong),Ne;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(ve,pe,Se,ke,x,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ve.error(Ne),Ce.dispose(),new Error(Ne)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,x.nameShort),(0,n.localize)(3,null),x.nameLong)},1e4));const Oe=m.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),$e=m.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ke.invokeFunction(async()=>{const Ne=new o.DiagnosticsService(_.NullTelemetryService,x),je=await $e.getMainDiagnostics(),Qe=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(je,Qe);throw console.log(Be),new w.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,ve),ve.trace("Sending env to running instance..."),await Oe.start(pe.args,process.env),Ce.dispose(),Fe&&clearTimeout(Fe),new w.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ve.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(ve,pe,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const ke=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,f.XDG_RUNTIME_DIR]).map(x=>(0,C.getPathLabel)(k.URI.file(x),{os:h.OS,tildify:ve}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,P.toErrorMessage)(Se),ke.join(`
`)),pe)}}showStartupWarningDialog(ve,pe,Se){I.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,n.localize)(6,null))],message:ve,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ve,pe){if(h.isWindows){const Se=await ve.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Se);try{(await new Promise((ke,x)=>{z(["windows-foreground-love"],ke,x)})).allowSetForegroundWindow(Se)}catch(ke){pe.error(ke)}}}quit(ve,pe){const Se=ve.get(ie.ILogService),ke=ve.get(X.ILifecycleMainService);let x=0;pe&&(pe.isExpected?pe.message&&Se.trace(pe.message):(x=1,pe.stack?Se.error(pe.stack):Se.error(`Startup error: ${pe.toString()}`))),ke.kill(x)}resolveArgs(){const ve=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const pe=(0,a.createWaitMarkerFileSync)(ve.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),ve.waitMarkerFilePath=pe)}return ve}validatePaths(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const pe=this.doValidatePaths(ve._,ve.goto);ve._=pe}return ve}doValidatePaths(ve,pe){const Se=(0,p.cwd)(),ke=ve.map(de=>{let ye=String(de),Ce;pe&&(Ce=(0,S.parseLineAndColumnAware)(ye),ye=Ce.path),ye&&(ye=this.preparePath(Se,ye));const Fe=(0,S.sanitizeFilePath)(ye,Se),Oe=(0,u.basename)(Fe);return Oe&&!(0,S.isValidBasename)(Oe)?null:pe&&Ce?(Ce.path=Fe,this.toPath(Ce)):Fe}),x=h.isWindows||h.isMacintosh,ue=(0,R.distinct)(ke,de=>de&&x?de.toLowerCase():de||"");return(0,R.coalesce)(ue)}preparePath(ve,pe){return h.isWindows&&(pe=(0,d.rtrim)(pe,'"')),pe=(0,d.trim)((0,d.trim)(pe," "),"	"),h.isWindows&&(pe=(0,u.resolve)(ve,pe),pe=(0,d.rtrim)(pe,".")),pe}toPath(ve){const pe=[ve.path];return typeof ve.line=="number"&&pe.push(String(ve.line)),typeof ve.column=="number"&&pe.push(String(ve.column)),pe.join(":")}}new Te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/504c5a768a001b2099dd2b44e9dc39e10ccdfb56/core/vs/code/electron-main/main.js.map
